IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtBoolean' ) 
    CREATE TYPE udtBoolean FROM BIT
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtByte' ) 
    CREATE TYPE udtByte FROM TINYINT
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtDateTime' ) 
    CREATE TYPE udtDateTime FROM DATETIME
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtFloat' ) 
    CREATE TYPE udtFloat FROM FLOAT
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtId' ) 
    CREATE TYPE udtId FROM BIGINT NOT NULL
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtInteger' ) 
    CREATE TYPE udtInteger FROM INT
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtLong' ) 
    CREATE TYPE udtLong FROM BIGINT
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtName' ) 
    CREATE TYPE udtName FROM VARCHAR(50)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtNameId' ) 
    CREATE TYPE udtNameId FROM VARCHAR(50) NOT NULL
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize1024' ) 
    CREATE TYPE udtStringSize1024 FROM VARCHAR(1024)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize128' ) 
    CREATE TYPE udtStringSize128 FROM VARCHAR(128)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize2048' ) 
    CREATE TYPE udtStringSize2048 FROM VARCHAR(2048)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize255' ) 
    CREATE TYPE udtStringSize255 FROM VARCHAR(255)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize4096' ) 
    CREATE TYPE udtStringSize4096 FROM VARCHAR(4096)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize512' ) 
    CREATE TYPE udtStringSize512 FROM VARCHAR(512)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize8000' ) 
    CREATE TYPE udtStringSize8000 FROM VARCHAR(8000)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtDecimal10_4' ) 
    CREATE TYPE udtDecimal10_4 FROM DECIMAL(10,4)
go

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtNumeric10_2' ) 
    CREATE TYPE udtNumeric10_2 FROM NUMERIC(10,2)
go


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_catalogo_pres')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_catalogo_pres
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              nombre VARCHAR(50) NULL ,
              fecha DATETIME NULL ,
              realizo VARCHAR(60) NULL ,
              autorizado CHAR(1) NULL ,
              referencia VARCHAR(20) NULL ,
              estatus CHAR(1) NULL ,
              CONSTRAINT PK6661 PRIMARY KEY NONCLUSTERED ( id_presup )
            )

    END
GO

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_parametro')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE dbo.P_parametro
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              ini_ejercicio INT NULL ,
              fin_ejercicio INT NULL ,
              mes_inicio INT NULL ,
              mes_final INT NULL ,
              prima_rt NUMERIC(8, 5)
                NULL CONSTRAINT PK6664 PRIMARY KEY NONCLUSTERED ( id_presup )
            )
        ALTER TABLE dbo.P_parametro ADD CONSTRAINT RefP_catalogo_pres21 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)

    END
go

IF EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'Tmp_p_Sueldos')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
		drop table Tmp_p_Sueldos
	end 


If OBJECT_ID('dbo.Tmp_p_Domingos') Is NOT NULL
Drop Table dbo.Tmp_p_Domingos

GO

If OBJECT_ID('dbo.Tmp_p_Fondo') Is NOT NULL
Drop Table dbo.Tmp_p_Fondo
GO

If OBJECT_ID('dbo.Tmp_p_FdoTotal') Is NOT NULL
Drop Table dbo.Tmp_p_FdoTotal
GO
  
If OBJECT_ID('dbo.Tmp_p_Imss') Is NOT NULL
Drop Table dbo.Tmp_p_Imss
GO

If OBJECT_ID('dbo.Tmp_p_Kardex') Is NOT NULL
Drop Table dbo.Tmp_p_Kardex
GO

If OBJECT_ID('dbo.Tmp_p_Vacaciones') IS NOT NULL
Drop Table dbo.Tmp_p_Vacaciones
GO

If OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL
Drop Table dbo.Tmp_p_Kardex
GO

If OBJECT_ID('dbo.Tmp_p_Despensa') Is NOT NULL
    Drop Table dbo.Tmp_p_Despensa
GO

If OBJECT_ID('dbo.Tmp_p_Aus') Is NOT NULL
    Drop Table dbo.Tmp_p_Aus
GO

If OBJECT_ID('dbo.Tmp_p_Comision') Is NOT NULL
    Drop Table dbo.Tmp_p_Comision
GO

If OBJECT_ID('dbo.Tmp_p_Provisiona') Is NOT NULL
Drop Table dbo.Tmp_p_Provisiona
GO

If OBJECT_ID('dbo.Tmp_p_Provisiones') Is NOT NULL
Drop Table dbo.Tmp_p_Provisiones
GO

If OBJECT_ID('dbo.Tmp_p_Kardex') Is NOT NULL
Drop Table dbo.Tmp_p_Kardex
GO

If OBJECT_ID('dbo.Tmp_p_Infonavit') Is NOT NULL
  Drop Table dbo.Tmp_p_Infonavit
GO

If OBJECT_ID('dbo.Tmp_p_Retenciones') Is NOT NULL
  Drop Table dbo.Tmp_p_Retenciones
GO

If OBJECT_ID('dbo.Tmp_p_Kardex') Is NOT NULL
  Drop Table dbo.Tmp_p_Kardex
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.P_parametro')
                        AND name = 'NaturalesImss' ) 
    ALTER TABLE dbo.P_parametro ADD NaturalesImss VARCHAR(1)
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_salmin')
                        AND name = 'UMA' ) 
    ALTER TABLE dbo.p_salmin ADD UMA numeric(10,2)
GO

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_empresas')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_empresas
            (
              empresa INT NOT NULL ,
              id_presup NUMERIC(8, 0) NOT NULL ,
              CONSTRAINT PK6662 PRIMARY KEY NONCLUSTERED
                ( empresa, id_presup )
            )
        ALTER TABLE dbo.P_empresas ADD CONSTRAINT RefP_catalogo_pres11 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)
    END
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.P_empresas')
                        AND name = 'encabezados' ) 
    ALTER TABLE dbo.P_empresas ADD encabezados VARCHAR(2) NULL
GO

ALTER TABLE dbo.p_kardex_resumen_detalle ALTER COLUMN departamento varchar(500) NULL
	ALTER TABLE dbo.p_kardex_resumen_detalle ALTER COLUMN actividad varchar(500) NULL
	IF not EXISTS(select syscolumns.name  from syscolumns 
	left join sysobjects on syscolumns.id=sysobjects.id
	where syscolumns.name = 'ManoObra' and sysobjects.name='p_kardex_resumen_detalle')
	begin
		Alter table dbo.p_kardex_resumen_detalle add ManoObra varchar(5)            
	end

ALTER TABLE dbo.p_kardex_empleados ALTER COLUMN departamento varchar(500) NULL	
ALTER TABLE dbo.p_kardex_empleados ALTER COLUMN actividad varchar(500) NULL
IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'ManoObra' and sysobjects.name='p_kardex_empleados')
begin
	Alter table dbo.p_kardex_empleados add ManoObra varchar(5)            
end

ALTER TABLE dbo.p_kardex_resumen_emps ALTER COLUMN departamento varchar(500) NULL	
ALTER TABLE dbo.p_kardex_resumen_emps ALTER COLUMN actividad varchar(500) NULL
IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'ManoObra' and sysobjects.name='p_kardex_resumen_emps')
begin
	Alter table dbo.p_kardex_resumen_emps add ManoObra varchar(5)            
end

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'Presup_EliminaTablasTemporales'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Presup_EliminaTablasTemporales
GO

CREATE PROCEDURE dbo.Presup_EliminaTablasTemporales

    ----WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

		declare @Tmps_Tables as table(name varchar(50), idTable bigint)

		insert into @Tmps_Tables
		SELECT information_schema.columns.TABLE_NAME,DENSE_RANK() OVER (PARTITION BY 1 ORDER BY information_schema.columns.TABLE_NAME ASC) as serial
		FROM information_schema.columns
		INNER JOIN information_schema.tables ON (information_schema.columns.TABLE_NAME = information_schema.tables.TABLE_NAME)
		INNER JOIN sysobjects ON (information_schema.tables.TABLE_NAME = sysobjects.name)
		WHERE sysobjects.xtype = 'u' AND information_schema.columns.TABLE_NAME  like'%tmp_p_%'
		group by information_schema.columns.TABLE_NAME


		declare @max bigint
		declare @met bigint

		set @met = 1
		set @max = isnull((select max(idTable) from @Tmps_Tables),0)
		declare @sqlExec varchar(max)

		while @met<=@max
		begin 
			set @sqlExec = 'drop table ' + (isnull((select name from @Tmps_Tables where idTable=@met),'tmp_p_tmp'))
			exec(@sqlExec)
			set @met = @met + 1
		end

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PadL]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
begin
	DROP FUNCTION [dbo].[PadL]
end

GO


CREATE FUNCTION [dbo].[PadL](@nvalor INTEGER, @cvalor VARCHAR(100), @nlen INTEGER, @cchar CHAR(1))

RETURNS VARCHAR(500)

AS

BEGIN

  DECLARE @creturn VARCHAR(500)

  IF @nvalor IS NOT NULL
    SET @creturn = LTRIM(RTRIM(CONVERT(VARCHAR(500),@nvalor)))
  ELSE
    SET @creturn = LTRIM(RTRIM(@cvalor))


  IF LEN(@creturn) < @nlen
    SET @creturn = REPLICATE(@cchar,@nlen - LEN(@creturn)) + @creturn
  ELSE
    SET @creturn = LEFT(@creturn,@nlen)

  RETURN (@creturn)

END


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Update_Salarys')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Update_Salarys
GO

CREATE PROCEDURE dbo.Update_Salarys ( @id_presup INT )
AS 
    DECLARE @movs AS TABLE
        (
          id_presup INT ,
          empresa INT ,
          codigo INT ,
          fch_mov DATETIME ,
          mov VARCHAR(2) ,
          sueldo NUMERIC(10, 2) ,
          saldiaint NUMERIC(10, 2)
        )

    INSERT  INTO @movs
            ( id_presup ,
              empresa ,
              codigo ,
              fch_mov ,
              mov ,
              sueldo ,
              saldiaint
            )
            SELECT  a.id_presup ,
                    a.empresa ,
                    a.codigo ,
                    a.fch_mov ,
                    a.mov ,
                    ISNULL(( SELECT MAX(b.sueldo)
                             FROM   p_avisos_imss AS b
                             WHERE  b.id_presup = a.id_presup
                                    AND b.empresa = a.empresa
                                    AND b.codigo = a.codigo
                                    AND b.fch_mov <= a.fch_mov
                                    AND mov = 'MS'
                           ), a.sueldo) AS sueldo ,
                    ISNULL(( SELECT MAX(b.saldiaint)
                             FROM   p_avisos_imss AS b
                             WHERE  b.id_presup = a.id_presup
                                    AND b.empresa = a.empresa
                                    AND b.codigo = a.codigo
                                    AND b.fch_mov <= a.fch_mov
                                    AND mov = 'MS'
                           ), a.saldiaint) AS sueldo
            FROM    p_avisos_imss AS a
            WHERE   a.id_presup = @id_presup
		--AND a.codigo=1493
ORDER BY            a.codigo ,
                    a.mes_operacion ,
                    a.serial

    UPDATE  a
    SET     saldiaint = b.saldiaint ,
            sueldo = b.sueldo
    FROM    p_avisos_imss AS a
            INNER JOIN @movs AS b ON b.id_presup = a.id_presup
                                     AND b.empresa = a.empresa
                                     AND b.codigo = a.codigo
                                     AND b.fch_mov = a.fch_mov
                                     AND a.mov = b.mov
    WHERE   a.id_presup = @id_presup


    DECLARE @movs2 AS TABLE
        (
          id_presup INT ,
          empresa INT ,
          codigo INT ,
          fch_mov DATETIME ,
          mov VARCHAR(2) ,
          sueldo NUMERIC(10, 2) ,
          saldiaint NUMERIC(10, 2)
        )

    INSERT  INTO @movs2
            ( id_presup ,
              empresa ,
              codigo ,
              fch_mov ,
              mov ,
              sueldo ,
              saldiaint
            )
            SELECT  a.id_presup ,
                    a.empresa ,
                    a.codigo ,
                    a.fch_mov ,
                    a.mov ,
                    ISNULL(( SELECT MAX(b.sueldo)
                             FROM   p_avisos_imss AS b
                             WHERE  b.id_presup = a.id_presup
                                    AND b.empresa = a.empresa
                                    AND b.codigo = a.codigo
                           ), a.sueldo) AS sueldo ,
                    ISNULL(( SELECT MAX(b.saldiaint)
                             FROM   p_avisos_imss AS b
                             WHERE  b.id_presup = a.id_presup
                                    AND b.empresa = a.empresa
                                    AND b.codigo = a.codigo
                           ), a.saldiaint) AS sueldo
            FROM    p_avisos_imss AS a
            WHERE   a.id_presup = @id_presup
		--AND a.codigo=1493
ORDER BY            a.codigo ,
                    a.mes_operacion ,
                    a.serial

    UPDATE  a
    SET     saldiaint = b.saldiaint ,
            sueldo = b.sueldo
    FROM    p_empleados_pres AS a
            INNER JOIN @movs2 AS b ON b.id_presup = a.id_presup
                                      AND b.empresa = a.empresa
                                      AND b.codigo = a.codigo
    WHERE   a.id_presup = @id_presup

GO

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_conc_pres')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_conc_pres
            (
              concepto NUMERIC(8, 0) NOT NULL ,
              id_presup NUMERIC(8, 0) NOT NULL ,
              nombre VARCHAR(50) NULL ,
              tipo CHAR(3) NULL ,
              CONSTRAINT PK6666 PRIMARY KEY NONCLUSTERED
                ( concepto, id_presup )
            )

        ALTER TABLE dbo.P_conc_pres ADD CONSTRAINT RefP_parametro651 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_parametro(id_presup)
    END
go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_conc_pres_nomina')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_conc_pres_nomina
            (
              num_conc INT NOT NULL ,
              concepto NUMERIC(8, 0) NOT NULL ,
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa NUMERIC(8, 0) NULL ,
              nombre VARCHAR(30) NULL ,
              clase CHAR(2) NOT NULL ,
              centro CHAR(15)
                NOT NULL
                CONSTRAINT PK6667
                PRIMARY KEY NONCLUSTERED
                ( num_conc, concepto, id_presup, clase, centro )
            )

        ALTER TABLE dbo.P_conc_pres_nomina ADD CONSTRAINT RefP_conc_pres61 
        FOREIGN KEY (concepto, id_presup)
        REFERENCES dbo.P_conc_pres(concepto, id_presup)
    END
go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_dias')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_dias
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              tiponom INT NOT NULL ,
              mes INT NOT NULL ,
              dias DECIMAL(8, 2) NULL ,
              ejercicio INT NOT NULL ,
              inicio DATETIME NULL ,
              cierre DATETIME NULL ,
              pago DATETIME NULL ,
              estatus CHAR(1)
                NULL
                CONSTRAINT PK6665
                PRIMARY KEY NONCLUSTERED
                ( id_presup, tiponom, mes, ejercicio )
            )
        ALTER TABLE dbo.P_dias ADD CONSTRAINT RefP_parametro31 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_parametro(id_presup)
    END
go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_SalMin')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_SalMin
            (
              Regional NUMERIC(8, 2) NULL ,
              DF NUMERIC(8, 2) NULL ,
              id_presup NUMERIC(8, 0) NOT NULL ,
              fecha DATETIME NULL
            )
        ALTER TABLE dbo.P_SalMin ADD CONSTRAINT RefP_parametro10 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_parametro(id_presup)
    END
go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_tablas_int')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE dbo.p_tablas_int
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              clase CHAR(2) NOT NULL ,
              ayos CHAR(2) NOT NULL ,
              Mes_Operacion INT NOT NULL ,
              Ayo_Operacion INT NOT NULL ,
              factor DECIMAL(9, 6) NULL ,
              aguinaldo DECIMAL(8, 4) NULL ,
              dias_vac DECIMAL(8, 4) NULL ,
              prima_vac DECIMAL(8, 4) NULL ,
              pmavacdias DECIMAL(6, 2) NULL ,
              pmavacimpo DECIMAL(7, 2) NULL ,
              despensa DECIMAL(8, 4) NULL ,
              despensaim DECIMAL(10, 2) NULL ,
              dias_ayo DECIMAL(8, 4) NULL ,
              porc_ayo DECIMAL(8, 4) NULL ,
              imp_ayo DECIMAL(10, 2) NULL ,
              dias_mes DECIMAL(8, 4) NULL ,
              porc_mes DECIMAL(8, 4) NULL ,
              imp_mes DECIMAL(10, 2) NULL ,
              porc_dia DECIMAL(8, 4) NULL ,
              imp_dia DECIMAL(10, 2) NULL ,
              fdoahopatp DECIMAL(8, 4) NULL ,
              fdoahopati DECIMAL(7, 3) NULL ,
              fdoahotrap DECIMAL(8, 4) NULL ,
              fdoahotrai DECIMAL(7, 3) NULL ,
              pmo1ayopor DECIMAL(8, 4) NULL ,
              pmo1ayoimp DECIMAL(6, 2) NULL ,
              pmo2ayopor DECIMAL(8, 4) NULL ,
              pmo2ayoimp DECIMAL(6, 2) NULL ,
              CONSTRAINT PK6699 PRIMARY KEY NONCLUSTERED
                ( clase, ayos, Mes_Operacion, Ayo_Operacion, empresa, id_presup )
            )
        ALTER TABLE dbo.p_tablas_int ADD CONSTRAINT RefP_empresas11 
        FOREIGN KEY (empresa, id_presup)
        REFERENCES dbo.P_empresas(empresa, id_presup)
    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_Empleados_Pres')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_Empleados_Pres
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo NUMERIC(8, 0) NOT NULL ,
              Nombre VARCHAR(50) NULL ,
              Centro CHAR(15) NULL ,
              Clase CHAR(2) NOT NULL ,
              ocupacion INT NOT NULL ,
              tiponom INT NOT NULL ,
              horario INT NOT NULL ,
              tiposal INT NOT NULL ,
              FchAlta DATETIME NOT NULL ,
              FchAntigua DATETIME NOT NULL ,
              FchNac DATETIME NULL ,
              Sindicato CHAR(1) NOT NULL ,
              Sueldo DECIMAL(10, 2) NULL ,
              Saldiaint DECIMAL(10, 2) NULL ,
              Sueldo_i DECIMAL(10, 2) NULL ,
              Saldiaint_i DECIMAL(10, 2) NULL ,
              origen CHAR(1) NULL ,
              activo CHAR(1) NULL ,
              varia_imss DECIMAL(8, 2) NULL ,
              tempbaja CHAR(1)
                NULL
                CONSTRAINT PK6688_2
                PRIMARY KEY NONCLUSTERED ( Codigo, empresa, id_presup )
            )
        ALTER TABLE dbo.p_Empleados_Pres ADD CONSTRAINT RefP_empresas6614 
        FOREIGN KEY (empresa, id_presup)
        REFERENCES dbo.P_empresas(empresa, id_presup)
    END
go



IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.P_Avisos_IMSS')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.P_Avisos_IMSS
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              serial DECIMAL(10, 0) NOT NULL ,
              Codigo DECIMAL(8, 0) NOT NULL ,
              Mov CHAR(2) NOT NULL ,
              mes_operacion NUMERIC(2) NOT NULL ,
              ayo_operacion NUMERIC(4) NOT NULL ,
              fch_mov DATETIME NOT NULL ,
              Sueldo DECIMAL(10, 2) NULL ,
              SalDiaInt DECIMAL(10, 2) NULL ,
              DiasTr NUMERIC(8, 2) NULL ,
              SalDiaIV DECIMAL(10, 2) NULL ,
              Incap NUMERIC(8, 2) NULL ,
              Ausen NUMERIC(8, 2) NULL ,
              Fch_Real DATETIME NULL ,
              CONSTRAINT PK669 PRIMARY KEY NONCLUSTERED
                ( serial, id_presup, empresa, Codigo, mes_operacion, ayo_operacion )
            )

        ALTER TABLE dbo.P_Avisos_IMSS ADD CONSTRAINT RefP_Empleados_Pres66615 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)
    END
go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_tmp_modsal_pres')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_tmp_modsal_pres
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo DECIMAL(8, 0) NOT NULL ,
              nvosal NUMERIC(10, 2) NULL ,
              nvosdi NUMERIC(10, 2) NULL ,
              CONSTRAINT Entity6662PK PRIMARY KEY NONCLUSTERED
                ( id_presup, empresa, Codigo )
            )

        ALTER TABLE dbo.p_tmp_modsal_pres ADD CONSTRAINT RefP_Empleados_Pres66616 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)
    END
go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_pagos_variables')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_pagos_variables
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              num_conc INT NOT NULL ,
              concepto NUMERIC(8, 0) NOT NULL ,
              centro VARCHAR(15) NOT NULL ,
              clase CHAR(2) NOT NULL ,
              ene1 NUMERIC(10, 2) NULL ,
              feb1 NUMERIC(10, 2) NULL ,
              mar1 NUMERIC(10, 2) NULL ,
              abr1 NUMERIC(10, 2) NULL ,
              may1 NUMERIC(10, 2) NULL ,
              jun1 NUMERIC(10, 2) NULL ,
              jul1 NUMERIC(10, 2) NULL ,
              ago1 NUMERIC(10, 2) NULL ,
              sep1 NUMERIC(10, 2) NULL ,
              oct1 NUMERIC(10, 2) NULL ,
              nov1 NUMERIC(10, 2) NULL ,
              dic1 NUMERIC(10, 2) NULL ,
              ene2 NUMERIC(10, 2) NULL ,
              feb2 NUMERIC(10, 2) NULL ,
              mar2 NUMERIC(10, 2) NULL ,
              abr2 NUMERIC(10, 2) NULL ,
              may2 NUMERIC(10, 2) NULL ,
              jun2 NUMERIC(10, 2) NULL ,
              jul2 NUMERIC(10, 2) NULL ,
              ago2 NUMERIC(10, 2) NULL ,
              sep2 NUMERIC(10, 2) NULL ,
              oct2 NUMERIC(10, 2) NULL ,
              nov2 NUMERIC(10, 2) NULL ,
              dic2 NUMERIC(10, 2) NULL ,
              CONSTRAINT Entity663PK PRIMARY KEY NONCLUSTERED
                ( num_conc, concepto, id_presup, centro, clase )
            )

        ALTER TABLE dbo.p_pagos_variables ADD CONSTRAINT RefP_conc_pres_nomina66171 
        FOREIGN KEY (num_conc, concepto, id_presup,centro,clase)
        REFERENCES dbo.P_conc_pres_nomina(num_conc, concepto, id_presup,centro,clase)
    END 

go

IF NOT EXISTS ( SELECT  *
                FROM    sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_pagos_variables_tiponom')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_pagos_variables_tiponom
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              num_conc INT NOT NULL ,
              concepto NUMERIC(8, 0) NOT NULL ,
              centro VARCHAR(15) NOT NULL ,
              clase CHAR(2) NOT NULL ,
              tiponom INT NOT NULL, 
              ene1 NUMERIC(10, 2) NULL ,
              feb1 NUMERIC(10, 2) NULL ,
              mar1 NUMERIC(10, 2) NULL ,
              abr1 NUMERIC(10, 2) NULL ,
              may1 NUMERIC(10, 2) NULL ,
              jun1 NUMERIC(10, 2) NULL ,
              jul1 NUMERIC(10, 2) NULL ,
              ago1 NUMERIC(10, 2) NULL ,
              sep1 NUMERIC(10, 2) NULL ,
              oct1 NUMERIC(10, 2) NULL ,
              nov1 NUMERIC(10, 2) NULL ,
              dic1 NUMERIC(10, 2) NULL ,
              ene2 NUMERIC(10, 2) NULL ,
              feb2 NUMERIC(10, 2) NULL ,
              mar2 NUMERIC(10, 2) NULL ,
              abr2 NUMERIC(10, 2) NULL ,
              may2 NUMERIC(10, 2) NULL ,
              jun2 NUMERIC(10, 2) NULL ,
              jul2 NUMERIC(10, 2) NULL ,
              ago2 NUMERIC(10, 2) NULL ,
              sep2 NUMERIC(10, 2) NULL ,
              oct2 NUMERIC(10, 2) NULL ,
              nov2 NUMERIC(10, 2) NULL ,
              dic2 NUMERIC(10, 2) NULL ,
              CONSTRAINT Entity667PK PRIMARY KEY NONCLUSTERED
                ( num_conc, concepto, id_presup, centro, clase, tiponom )
            )
    END 

go
IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_despensas')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_despensas
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo DECIMAL(8, 0) NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              sueldo DECIMAL(12, 2) NULL ,
              importe DECIMAL(12, 2) NULL ,
              porciento DECIMAL(6, 2) NULL ,
              fchinicio DATETIME NULL ,
              fchcierre DATETIME NULL ,
              fchpago DATETIME NULL ,
              dias DECIMAL(6, 2) NULL ,
              aus DECIMAL(6, 2) NULL ,
              inc DECIMAL(6, 2) NULL ,
              comision DECIMAL(12, 2) NULL ,
              total DECIMAL(12, 2) NULL ,
              gravable DECIMAL(12, 2) NULL ,
              exento DECIMAL(12, 2) NULL ,
              ispt DECIMAL(12, 2) NULL ,
              redondeo DECIMAL(12, 2) NULL ,
              neto DECIMAL(12, 2) NULL ,
              excedente DECIMAL(12, 2) NULL ,
              excede DECIMAL(12, 2) NULL ,
              inicio_ant DATETIME NULL ,
              cierre_ant DATETIME NULL ,
              pago_ant DATETIME NULL ,
              dias_ant DECIMAL(12, 2) NULL ,
              aus_ant DECIMAL(12, 2) NULL ,
              inc_ant DECIMAL(12, 2) NULL ,
              comision_a DECIMAL(12, 2) NULL ,
              total_ant DECIMAL(12, 2) NULL ,
              grava_ant DECIMAL(12, 2) NULL ,
              exento_ant DECIMAL(12, 2) NULL ,
              nomina CHAR(1) NULL ,
              marca CHAR(1) NULL ,
              pagada CHAR(1) NOT NULL ,
              pagarla CHAR(1) NOT NULL ,
              redondeo_a DECIMAL(6, 2) NOT NULL ,
              CONSTRAINT despensasPK PRIMARY KEY NONCLUSTERED
                ( id_presup, empresa, Codigo, mes_operacion, ayo_operacion )
            )

        ALTER TABLE dbo.p_despensas ADD CONSTRAINT RefP_Empleados_Pres23 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)

    END
go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo NUMERIC(8, 0) NOT NULL ,
              nomina CHAR(3) NOT NULL ,
              centro CHAR(15) NOT NULL ,
              num_conc INT NOT NULL ,
              clase CHAR(2) NOT NULL ,
              folio INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              renglon INT NULL ,
              fch_inicio DATETIME NULL ,
              fch_cierre DATETIME NULL ,
              fch_pago DATETIME NULL ,
              dias DECIMAL(6, 2) NULL ,
              inc DECIMAL(6, 2) NULL ,
              aus DECIMAL(6, 2) NULL ,
              diastr DECIMAL(6, 2) NULL ,
              dias_imss DECIMAL(6, 2) NULL ,
              tpago_desc CHAR(1) NULL ,
              concepto VARCHAR(30) NOT NULL ,
              variaimss DECIMAL(12, 2) NULL ,
              variable DECIMAL(12, 2) NOT NULL ,
              imss CHAR(1) NULL ,
              ispt CHAR(1) NULL ,
              ptu CHAR(1) NULL ,
              despensa CHAR(1) NOT NULL ,
              mca_agui CHAR(1) NULL ,
              fdoahorro CHAR(1) NOT NULL ,
              calculo CHAR(1) NULL ,
              impor_base DECIMAL(12, 2) NULL ,
              saldiaint DECIMAL(12, 2) NOT NULL ,
              tabulador INT NULL ,
              unidades DECIMAL(6, 2) NULL ,
              horas DECIMAL(6, 2) NULL ,
              tipo_mov VARCHAR(3) NULL ,
              secuencia INT NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              igravable DECIMAL(12, 2) NULL ,
              iexento DECIMAL(12, 2) NULL ,
              credito DECIMAL(12, 2) NULL ,
              descuento DECIMAL(12, 2) NULL ,
              saldo DECIMAL(12, 2) NULL ,
              referencia CHAR(12) NULL ,
              siempre CHAR(1) NULL ,
              justificar CHAR(1) NULL ,
              septimo CHAR(1) NULL ,
              prevsocial CHAR(1) NULL ,
              varia1 DECIMAL(12, 2) NULL ,
              varia2 DECIMAL(12, 2) NULL ,
              varia3 DECIMAL(12, 2) NULL ,
              varia4 DECIMAL(12, 2) NULL ,
              variable1 VARCHAR(20) NULL ,
              variable2 VARCHAR(20) NULL ,
              variable3 VARCHAR(20) NULL ,
              variable4 VARCHAR(20) NULL ,
              masivo CHAR(1) NOT NULL ,
              formula VARCHAR(100) NOT NULL ,
              ispt_ng VARCHAR(100) NOT NULL ,
              imss_ni VARCHAR(100) NOT NULL ,
              marca CHAR(1) NOT NULL ,
              serial INT NOT NULL ,
              informativo CHAR(1) NULL ,
              detalle_prn VARCHAR(50) NULL ,
              [id_serial] [int]
                IDENTITY(1, 1)
                NOT NULL
                CONSTRAINT PK66655
                PRIMARY KEY NONCLUSTERED
                ( nomina, centro, num_conc, clase, folio, id_presup, empresa, Codigo, mes_operacion, ayo_operacion, id_serial )
            )

        ALTER TABLE dbo.p_kardex ADD CONSTRAINT RefP_Empleados_Pres20 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)

    END
go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_empleados')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_empleados
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo NUMERIC(8, 0) NOT NULL ,
              centro VARCHAR(15) NOT NULL ,
              departamento VARCHAR(50) NULL ,
              num_conc INT NOT NULL ,
              grupo_concepto BIGINT NOT NULL ,
              concepto VARCHAR(30) NOT NULL ,
              tiponom INT NOT NULL ,
              ocupacion BIGINT ,
              actividad VARCHAR(50) ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              dias DECIMAL(6, 2) NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              [id_serial] [BIGint]
                IDENTITY(1, 1)
                CONSTRAINT PK_p_kardex_empleados_66655
                PRIMARY KEY NONCLUSTERED
                ( id_presup, empresa,  Codigo, mes_operacion, ayo_operacion, num_conc, id_serial )
            )

        ALTER TABLE dbo.p_kardex_empleados ADD CONSTRAINT RefP_Empleados_Pres26 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)

    END
go
--DROP TABLE p_kardex_resumen_detalle
IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_resumen_detalle')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_resumen_detalle
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              centro VARCHAR(15) NOT NULL ,
              departamento VARCHAR(50) NULL ,
              num_conc INT NOT NULL ,
              grupo_concepto BIGINT NOT NULL ,
              concepto VARCHAR(30) NOT NULL ,
              tiponom INT NOT NULL ,
              ocupacion BIGINT ,
              actividad VARCHAR(50) ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              dias DECIMAL(6, 2) NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              [id_serial] [BIGint]
                IDENTITY(1, 1)
                NOT NULL
                CONSTRAINT PK66657
                PRIMARY KEY NONCLUSTERED
                ( id_presup, tiponom, centro, ocupacion, num_conc, mes_operacion, ayo_operacion, id_serial )
            )

        ALTER TABLE dbo.p_kardex_resumen_detalle ADD CONSTRAINT RefP_Empleados_Pres31 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)

    END
go

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'clase'
                        AND sysobjects.name = 'p_kardex_resumen_detalle' ) 
    ALTER TABLE p_kardex_resumen_detalle ADD clase VARCHAR(4) NULL 
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Nombreclase'
                        AND sysobjects.name = 'p_kardex_resumen_detalle' ) 
    ALTER TABLE p_kardex_resumen_detalle ADD Nombreclase VARCHAR(250) NULL 
GO


--DROP TABLE p_kardex_resumen_emps
IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_resumen_emps')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_resumen_emps
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              centro VARCHAR(15) NOT NULL ,
              departamento VARCHAR(50) NULL ,
              ocupacion BIGINT ,
              actividad VARCHAR(50) ,
              tiponom INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              empleados BIGINT ,
              [id_serial] [BIGint]
                IDENTITY(1, 1)
                NOT NULL
                CONSTRAINT PK66659
                PRIMARY KEY NONCLUSTERED
                ( id_presup, tiponom, centro, ocupacion, mes_operacion, ayo_operacion, id_serial )
            )

        ALTER TABLE dbo.p_kardex_resumen_emps ADD CONSTRAINT RefP_Empleados_Pres32 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)

    END
go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_historico')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_historico
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo NUMERIC(8, 0) NOT NULL ,
              nomina CHAR(3) NOT NULL ,
              centro CHAR(15) NOT NULL ,
              num_conc INT NOT NULL ,
              clase CHAR(2) NOT NULL ,
              folio INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              renglon INT NULL ,
              fch_inicio DATETIME NULL ,
              fch_cierre DATETIME NULL ,
              fch_pago DATETIME NULL ,
              dias DECIMAL(6, 2) NULL ,
              inc DECIMAL(6, 2) NULL ,
              aus DECIMAL(6, 2) NULL ,
              diastr DECIMAL(6, 2) NULL ,
              dias_imss DECIMAL(6, 2) NULL ,
              tpago_desc CHAR(1) NULL ,
              concepto VARCHAR(30) NOT NULL ,
              variaimss DECIMAL(12, 2) NULL ,
              variable DECIMAL(12, 2) NOT NULL ,
              imss CHAR(1) NULL ,
              ispt CHAR(1) NULL ,
              ptu CHAR(1) NULL ,
              despensa CHAR(1) NOT NULL ,
              mca_agui CHAR(1) NULL ,
              fdoahorro CHAR(1) NOT NULL ,
              calculo CHAR(1) NULL ,
              impor_base DECIMAL(12, 2) NULL ,
              saldiaint DECIMAL(12, 2) NOT NULL ,
              tabulador INT NULL ,
              unidades DECIMAL(6, 2) NULL ,
              horas DECIMAL(6, 2) NULL ,
              tipo_mov VARCHAR(3) NULL ,
              secuencia INT NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              igravable DECIMAL(12, 2) NULL ,
              iexento DECIMAL(12, 2) NULL ,
              credito DECIMAL(12, 2) NULL ,
              descuento DECIMAL(12, 2) NULL ,
              saldo DECIMAL(12, 2) NULL ,
              referencia CHAR(12) NULL ,
              siempre CHAR(1) NULL ,
              justificar CHAR(1) NULL ,
              septimo CHAR(1) NULL ,
              prevsocial CHAR(1) NULL ,
              varia1 DECIMAL(12, 2) NULL ,
              varia2 DECIMAL(12, 2) NULL ,
              varia3 DECIMAL(12, 2) NULL ,
              varia4 DECIMAL(12, 2) NULL ,
              variable1 VARCHAR(20) NULL ,
              variable2 VARCHAR(20) NULL ,
              variable3 VARCHAR(20) NULL ,
              variable4 VARCHAR(20) NULL ,
              masivo CHAR(1) NOT NULL ,
              formula VARCHAR(100) NOT NULL ,
              ispt_ng VARCHAR(100) NOT NULL ,
              imss_ni VARCHAR(100) NOT NULL ,
              marca CHAR(1) NOT NULL ,
              serial INT NOT NULL ,
              informativo CHAR(1) NULL ,
              detalle_prn VARCHAR(50) NULL ,
              [id_serial] [int]
                NOT NULL
                CONSTRAINT PK66656
                PRIMARY KEY NONCLUSTERED
                ( nomina, centro, num_conc, clase, folio, id_presup, empresa, Codigo, mes_operacion, ayo_operacion, id_serial )
            )

        ALTER TABLE dbo.p_kardex_historico ADD CONSTRAINT RefP_Empleados_Pres21 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)
    END

go


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_nomina_tot')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_nomina_tot
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo DECIMAL(8, 0) NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              tiponom INT NULL ,
              movimss CHAR(2) NULL ,
              fchinicio DATETIME NULL ,
              fchcierre DATETIME NULL ,
              diastr_nom DECIMAL(6, 2) NULL ,
              dias_pagar DECIMAL(6, 2) NULL ,
              aus DECIMAL(6, 2) NULL ,
              incap DECIMAL(6, 2) NULL ,
              incap_eg DECIMAL(6, 2) NULL ,
              incap_mat DECIMAL(6, 2) NULL ,
              incap_rt DECIMAL(6, 2) NULL ,
              retardos INT NULL ,
              tot_sueldo DECIMAL(12, 2) NULL ,
              perc_grava DECIMAL(12, 2) NULL ,
              perc_exento DECIMAL(12, 2) NULL ,
              tot_percep DECIMAL(12, 2) NULL ,
              dedu_grava DECIMAL(12, 2) NULL ,
              dedu_exent DECIMAL(12, 2) NULL ,
              tot_deducc DECIMAL(12, 2) NULL ,
              tot_ispt DECIMAL(12, 2) NULL ,
              tot_imss DECIMAL(12, 2) NULL ,
              neto DECIMAL(12, 2) NULL ,
              ptu DECIMAL(12, 2) NULL ,
              mca_baja CHAR(1) NULL ,
              credcontra DECIMAL(12, 2) NULL ,
              isptcontra DECIMAL(12, 2) NULL ,
              horaslab DECIMAL(6, 2) NULL ,
              horasdes DECIMAL(6, 2) NULL ,
              diaslab DECIMAL(6, 2) NULL ,
              sdolab DECIMAL(12, 2) NULL ,
              diasdes DECIMAL(6, 2) NULL ,
              sdodes DECIMAL(12, 2) NULL ,
              prevsocial DECIMAL(12, 2) NOT NULL ,
              prevgrava DECIMAL(12, 2) NOT NULL ,
              prevexenta DECIMAL(12, 2) NOT NULL ,
              credreal DECIMAL(12, 2) NOT NULL ,
              isptreal DECIMAL(12, 2) NOT NULL ,
              base_i_est DECIMAL(12, 2) NULL ,
              base_i_fed DECIMAL(12, 2) NULL ,
              subsidio DECIMAL(12, 2) NULL ,
              subsidion DECIMAL(12, 2) NULL ,
              CONSTRAINT nomina_totPK PRIMARY KEY NONCLUSTERED
                ( id_presup, empresa, Codigo, mes_operacion, ayo_operacion )
            )
        ALTER TABLE dbo.p_nomina_tot ADD CONSTRAINT RefP_Empleados_Pres21 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)

    END
go


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_poldisk')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN 
        CREATE TABLE [dbo].[p_poldisk]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [ayo_operacion] [int] NOT NULL ,
              [mes_operacion] [int] NOT NULL ,
              [concepto] [int] NOT NULL ,
              [centro] [char](15) NOT NULL ,
              [cuenta] [char](20) NOT NULL ,
              [tiponom] [int] NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL ,
              [nomconcep] [varchar](20) NOT NULL ,
              [nomcuenta] [varchar](20) NOT NULL ,
              [importe] [decimal](12, 2) NOT NULL ,
              [debe] [decimal](12, 2) NOT NULL ,
              [haber] [decimal](12, 2) NOT NULL ,
              [fch_inicio] [datetime] NOT NULL ,
              [fch_cierre] [datetime] NOT NULL ,
              [fch_pago] [datetime] NOT NULL ,
              [numero] [int] NOT NULL ,
              [clasifica] [char](1) NOT NULL ,
              [depto] [char](30) NULL ,
              [sri] [int] IDENTITY(1, 1)
                          NOT NULL ,
              CONSTRAINT PK_p_poldisk PRIMARY KEY CLUSTERED
                ( [id_presup] ASC, [ayo_operacion] ASC, [mes_operacion] ASC, [concepto] ASC, [centro] ASC, [cuenta] ASC, [tiponom] ASC, [empresa] ASC, [sri] ASC )
                ON [PRIMARY]
            )
        ON  [PRIMARY]

    END
go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_polizas')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN 
        CREATE TABLE dbo.p_polizas
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              ayo_operacion INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              num_conc INT NOT NULL ,
              concepto CHAR(30) NOT NULL ,
              centro CHAR(14) NOT NULL ,
              tiponom INT NOT NULL ,
              empresa NUMERIC(3, 0) NOT NULL ,
              renglon INT NOT NULL ,
              tpago_desc CHAR(1) NOT NULL ,
              fch_pago DATETIME NOT NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              gravable DECIMAL(12, 2) NOT NULL ,
              exento DECIMAL(12, 2) NOT NULL ,
              empleados INT NOT NULL ,
              dias DECIMAL(8, 2) NOT NULL ,
              horas DECIMAL(8, 2) NOT NULL ,
              tipo CHAR(1) NOT NULL ,
              varia1 DECIMAL(12, 2) NOT NULL ,
              CONSTRAINT PK66668 PRIMARY KEY NONCLUSTERED
                ( id_presup, mes_operacion, ayo_operacion, num_conc, concepto, centro, tiponom, empresa )
            )
    END
go


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_percepciones')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_percepciones
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              empresa INT NOT NULL ,
              Codigo DECIMAL(8, 0) NOT NULL ,
              num_conc INT NOT NULL ,
              nomina DECIMAL(12, 2) NULL ,
              varia_imss DECIMAL(12, 2) NULL ,
              fch_real DATETIME NOT NULL ,
              tiponom INT NOT NULL ,
              horas_ex DECIMAL(8, 2) NULL ,
              mes INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              siempre CHAR(1) NULL ,
              clase CHAR(2) NULL ,
              centro CHAR(15) NULL ,
              folio INT NULL ,
              variable DECIMAL(12, 4) NULL ,
              varia1 DECIMAL(12, 4) NULL ,
              varia2 DECIMAL(12, 4) NULL ,
              varia3 DECIMAL(12, 4) NULL ,
              varia4 DECIMAL(12, 4)
                NULL
                CONSTRAINT Entity444444PK
                PRIMARY KEY NONCLUSTERED
                ( id_presup, empresa, Codigo, num_conc, fch_real, tiponom, mes, ayo_operacion )
            )

        ALTER TABLE dbo.p_percepciones ADD CONSTRAINT RefP_Empleados_Pres18 
        FOREIGN KEY (Codigo, empresa, id_presup)
        REFERENCES dbo.P_Empleados_Pres(Codigo, empresa, id_presup)
    END

go

IF NOT EXISTS ( SELECT  *
                FROM    sys.objects
                WHERE   object_id = OBJECT_ID(N'[dbo].[p_primas_rt]')
                        AND type IN ( N'U' ) ) 
    CREATE TABLE [dbo].[p_primas_rt]
        (
          id_presup NUMERIC(8, 0) NOT NULL ,
          [empresa] [numeric](3, 0) NOT NULL ,
          [prima_rt] [decimal](8, 5) NOT NULL ,
          [prima_modificada] [decimal](8, 5) NULL ,
          [mes] INT NULL ,
          [ayo] INT NULL ,
          CONSTRAINT [PK9999970] PRIMARY KEY CLUSTERED
            ( id_presup DESC, [empresa] ASC )
            WITH ( PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF,
                   IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON,
                   ALLOW_PAGE_LOCKS = ON ) ON [PRIMARY]
        )
    ON  [PRIMARY]

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_InsertaMes')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_InsertaMes
GO

CREATE PROCEDURE dbo.p_InsertaMes
    @id_presup NUMERIC(3, 0) ,
    @Dias NUMERIC(4, 2)
AS 
    DECLARE @MesIni udtInteger ,
        @MesFin udtInteger ,
        @AyoIni udtInteger ,
        @AyoFin udtInteger
            
            
    SELECT  @MesIni = mes_inicio ,
            @MesFin = mes_final ,
            @AyoIni = ini_ejercicio ,
            @AyoFin = fin_ejercicio
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup

	
    DECLARE @Fechaperi DATETIME ,
        @Fechaperi2 DATETIME ,
        @Mes CHAR(2) ,
        @ayo CHAR(4) ,
        @Fecha2 DATETIME ,
        @FechaFin DATETIME ,
        @DiasFin INT 
    DECLARE @Mes1 NUMERIC(3)
    IF @Ayoini = @Ayofin 
        BEGIN
            SET @Mes1 = @MesIni
            WHILE @Mes1 <= @MesFin 
                BEGIN
      
                    SET @Fechaperi = CAST(@AyoIni AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 ELSE CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    SET @FechaFin = @FechaPeri + 29   
                    --PRINT @FechaPeri
                    --PRINT @FechaFin
                    PRINT 'Fin'

                    INSERT  INTO dbo.p_Dias
                            ( id_presup ,
                              tiponom ,
                              Mes ,
                              dias ,
                              ejercicio ,
                              inicio ,
                              cierre ,
                              pago ,
                              estatus
                                            
                            )
                            SELECT  a.id_presup ,
                                    l.tiponom ,
                                    @Mes1 ,
                                    @Dias ,
                                    @AyoIni ,
                                    @FechaPeri ,
                                    @FechaFin ,
                                    @FechaFin ,
                                    ''
                            FROM    dbo.p_catalogo_pres AS a
                                    INNER JOIN dbo.p_empresas AS b ON b.id_presup = a.id_presup
                                    INNER JOIN dbo.nominas AS l ON l.empresa = b.empresa
                                                              AND l.tiponom > 0
                                    LEFT JOIN dbo.p_dias AS d ON d.tiponom = l.tiponom
                                                              AND d.id_presup = @id_presup AND d.mes = @Mes1 AND d.ejercicio=@AyoIni
                            WHERE   d.tiponom IS NULL
                                    AND a.id_presup = @id_presup
                            GROUP BY a.id_presup ,
                                    l.tiponom ,
                                    d.tiponom
                            
                    SET @Mes1 = @Mes1 + 1
        
                    --CONTINUE
                END
        END

    IF @Ayoini < @Ayofin 
        BEGIN
            SET @Mes1 = @MesIni
            WHILE @Mes1 <= 12 
                BEGIN

                    SET @Fechaperi = CAST(@AyoIni AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 ELSE CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    SET @FechaFin = @FechaPeri + 29   
--                    PRINT @FechaPeri
--                    PRINT @FechaFin
                    PRINT 'Fin'

                    INSERT  INTO dbo.p_Dias
                            ( id_presup ,
                              tiponom ,
                              Mes ,
                              dias ,
                              ejercicio ,
                              inicio ,
                              cierre ,
                              pago ,
                              estatus
                                            
                            )
                            SELECT  a.id_presup ,
                                    l.tiponom ,
                                    @Mes1 ,
                                    @Dias ,
                                    @AyoIni ,
                                    @FechaPeri ,
                                    @FechaFin ,
                                    @FechaFin ,
                                    ''
                            FROM    dbo.p_catalogo_pres AS a
                                    INNER JOIN dbo.p_empresas AS b ON b.id_presup = a.id_presup
                                    INNER JOIN dbo.nominas AS l ON l.empresa = b.empresa
                                                              AND l.tiponom > 0
                                    LEFT JOIN dbo.p_dias AS d ON d.tiponom = l.tiponom
                                                              AND d.id_presup = @id_presup AND d.mes = @Mes1 AND d.ejercicio=@AyoIni
                            WHERE   d.tiponom IS NULL
                                    AND a.id_presup = @id_presup
                            GROUP BY a.id_presup ,
                                    l.tiponom ,
                                    d.tiponom

                    SET @Mes1 = @Mes1 + 1
      
                    CONTINUE
                END
   
            SET @Mes1 = 1
            WHILE @Mes1 <= @MesFin 
                BEGIN

                    SET @Fechaperi = CAST(@AyoFin AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 ELSE CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    SET @FechaFin = @FechaPeri + 29   
                    --PRINT @FechaPeri
                    --PRINT @FechaFin
                    PRINT 'Fin'

                    INSERT  INTO dbo.p_Dias
                            ( id_presup ,
                              tiponom ,
                              Mes ,
                              dias ,
                              ejercicio ,
                              inicio ,
                              cierre ,
                              pago ,
                              estatus
                                            
                            )
                            SELECT  a.id_presup ,
                                    l.tiponom ,
                                    @Mes1 ,
                                    @Dias ,
                                    @AyoFin ,
                                    @FechaPeri ,
                                    @FechaFin ,
                                    @FechaFin ,
                                    ''
                            FROM    dbo.p_catalogo_pres AS a
                                    INNER JOIN dbo.p_empresas AS b ON b.id_presup = a.id_presup
                                    INNER JOIN dbo.nominas AS l ON l.empresa = b.empresa
                                                              AND l.tiponom > 0
                                    LEFT JOIN dbo.p_dias AS d ON d.tiponom = l.tiponom
                                                              AND d.id_presup = @id_presup AND d.mes = @Mes1 AND d.ejercicio=@AyoFin
                            WHERE   d.tiponom IS NULL
                                    AND a.id_presup = @id_presup
                            GROUP BY a.id_presup ,
                                    l.tiponom ,
                                    d.tiponom

                    SET @Mes1 = @Mes1 + 1
      
                                    --CONTINUE
                END
        END

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_InsertaIMAltas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_InsertaIMAltas
GO
CREATE PROCEDURE dbo.p_InsertaIMAltas
    @id_presup INT ,
    @empresa INT ,
    @Codigo NUMERIC(12) ,
    @FchA DATETIME
AS 
    DECLARE @Fecha DATETIME
    DECLARE @ayo1 NUMERIC(4) ,
        @ayo2 NUMERIC(4) ,
        @mes1 INT ,
        @mes2 INT

    SELECT  @ayo1 = YEAR(@FchA) ,
            @ayo2 = fin_ejercicio ,
            @mes1 = MONTH(@FchA) + 1 ,
            @mes2 = mes_final
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup

    IF @ayo2 = @ayo1 
        BEGIN

            WHILE @mes1 <= @mes2 
                BEGIN
                    SET @fecha = CAST(@ayo1 AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 WHEN @mes1 >= 10 THEN CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes1 AS mes ,
                                    @ayo1 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND codigo = @Codigo
                                    AND activo = 'S'
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

        END

    IF @ayo2 > @ayo1 
        BEGIN

            WHILE @mes1 <= 12 
                BEGIN
                    SET @fecha = CAST(@ayo1 AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 WHEN @mes1 >= 10 THEN CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes1 AS mes ,
                                    @ayo1 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND codigo = @Codigo
                                    AND activo = 'S'
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

            SET @Mes1 = 1
   
            WHILE @mes1 <= @Mes2 
                BEGIN
                    SET @fecha = CAST(@ayo2 AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 WHEN @mes1 >= 10 THEN CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes1 AS mes ,
                                    @ayo2 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND codigo = @Codigo
                                    AND activo = 'S'
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_saca_prestaciones_presup')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_saca_prestaciones_presup
GO

CREATE  PROCEDURE dbo.p_saca_prestaciones_presup
    @nempresa INTEGER ,
    @cclase CHAR(2) ,
    @nayo CHAR(02) ,
    @nmes_operacion INT ,
    @nayo_operacion INT,
	@idPresup bigint
AS 
    SELECT  p_tablas_int.clase ,
            clases.nombre ,
            p_tablas_int.ayos ,
            p_tablas_int.factor ,
            p_tablas_int.aguinaldo ,
            p_tablas_int.dias_vac ,
            p_tablas_int.prima_vac ,
            p_tablas_int.despensa ,
            p_tablas_int.despensaim ,
            p_tablas_int.dias_ayo ,
            p_tablas_int.porc_ayo ,
            p_tablas_int.imp_ayo ,
            p_tablas_int.dias_mes ,
            p_tablas_int.porc_mes ,
            p_tablas_int.imp_mes ,
            p_tablas_int.porc_dia ,
            p_tablas_int.imp_dia ,
            p_tablas_int.fdoahopatp ,
            p_tablas_int.fdoahopati ,
            p_tablas_int.fdoahotrap ,
            p_tablas_int.fdoahotrai ,
            p_tablas_int.pmo1ayopor ,
            p_tablas_int.pmo1ayoimp ,
            p_tablas_int.pmo2ayopor ,
            p_tablas_int.pmo2ayoimp ,
            clases.Empresa ,
            p_tablas_int.pmavacdias
    FROM    dbo.p_tablas_int
            INNER JOIN dbo.clases ON ( p_tablas_int.clase = clases.clase
                                       AND p_tablas_int.empresa = clases.empresa
                                     )
    WHERE   p_tablas_int.empresa = @nempresa
            AND p_tablas_int.clase = @cclase
            AND p_tablas_int.Ayos = @nayo
            AND mes_operacion = @nmes_operacion
            AND ayo_operacion = @nayo_operacion
			and id_presup=@idPresup

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_IndicaConc')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_IndicaConc
GO

CREATE PROCEDURE dbo.p_IndicaConc
    @id_presup INT ,
    @ayo INT ,
    @num_conc INT ,
    @mes CHAR(3),
    @tiponom INT
AS 
    SELECT  k.centro ,
            ISNULL(( SELECT SUM(a.importe)
                     FROM   dbo.kardex_anual AS a
                            LEFT JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                         AND b.codigo = a.codigo
                     WHERE  a.num_conc = k.num_conc
                            AND b.centro = K.centro
                            AND SUBSTRING(a.mes, 1, 3) = @mes
                            AND ayo_operacion = @ayo
                            AND a.tiponom = @tiponom
                   ), 0) AS impo ,
            ( SELECT    COUNT_BIG(DISTINCT a.codigo)
              FROM      dbo.kardex_anual AS a
                        LEFT JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                     AND b.codigo = a.codigo
              WHERE     a.num_conc = k.num_conc
                        AND b.centro = K.centro
                        AND SUBSTRING(a.mes, 1, 3) = @mes
                        AND ayo_operacion = @ayo
                        AND a.tiponom = @tiponom
            ) AS trab
    FROM    dbo.p_pagos_variables_tiponom AS k
    WHERE   k.num_conc = @num_conc
            AND k.id_presup = @id_presup
            AND k.tiponom = @tiponom

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_empleados_pres')
                        AND name = 'cambia' ) 
    ALTER TABLE dbo.p_empleados_pres ADD cambia CHAR(1)
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_empleados_pres')
                        AND name = 'baja' ) 
    ALTER TABLE dbo.p_empleados_pres ADD baja CHAR(1)
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_empleados_pres')
                        AND name = 'campo01' ) 
    ALTER TABLE dbo.p_empleados_pres ADD campo01 VARCHAR(50) NULL
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_empleados_pres')
                        AND name = 'campo02' ) 
    ALTER TABLE dbo.p_empleados_pres ADD campo02 VARCHAR(50) NULL
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_empleados_pres')
                        AND name = 'campo03' ) 
    ALTER TABLE dbo.p_empleados_pres ADD campo03 BIGINT NULL
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.p_empleados_pres')
                        AND name = 'ManoObra' ) 
    ALTER TABLE dbo.p_empleados_pres ADD ManoObra varchar(15) NULL
GO

update a set manoobra=b.manoobra
from dbo.p_empleados_pres as a
inner join dbo.empleados as b on b.empresa=a.empresa and b.codigo=b.codigo
where a.manoobra is null

GO


IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.empresas')
                        AND name = 'consolidapres' ) 
    ALTER TABLE dbo.empresas ADD consolidapres VARCHAR(1)
GO


UPDATE  a
SET     baja = CASE WHEN ( SELECT   MAX(mov)
                           FROM     dbo.p_avisos_imss
                           WHERE    id_presup = a.id_presup
                                    AND empresa = a.empresa
                                    AND codigo = a.codigo
                                    AND mov = 'B'
                         ) = 'B' THEN 'S'
                    ELSE 'N'
               END
FROM    dbo.p_empleados_pres AS a
WHERE   baja IS NULL

GO

	
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_guardahistorico')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_guardahistorico
GO

CREATE  PROCEDURE dbo.asp_pres_guardahistorico
AS 
    BEGIN
        INSERT  INTO dbo.p_kardex_historico
                SELECT  *
                FROM    dbo.p_kardex
                WHERE   id_presup IN ( SELECT   id_presup
                                       FROM     dbo.p_catalogo_pres
                                       WHERE    estatus = 'C' )

        DELETE  dbo.p_kardex
        WHERE   id_presup IN ( SELECT   id_presup
                               FROM     dbo.p_catalogo_pres
                               WHERE    estatus = 'C' )
    END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_Pres_ActualizaImpEstatal')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_Pres_ActualizaImpEstatal
GO


CREATE PROCEDURE dbo.asp_Pres_ActualizaImpEstatal
    @id_presup INT ,
    @Tiponom INT ,
    @mes INT ,
    @ayo INT
AS 
    DECLARE @empresa NUMERIC(4)


    DECLARE empresas_imp CURSOR
    FOR
    SELECT empresa FROM dbo.p_empresas WHERE id_presup=@id_presup

    OPEN empresas_imp

    FETCH NEXT FROM empresas_imp INTO @empresa

    WHILE ( @@FETCH_STATUS <> -1 ) 
        BEGIN
		
--            PRINT @Empresa
		
            EXEC dbo.asp_Pres_ImpEstatal @id_presup, @Tiponom, @mes, @ayo,
                @empresa

            UPDATE  k
            SET     importe = b.importe
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.tmp_pres_imp_est AS b ON b.id_presup = k.id_presup
                                                            AND b.empresa = k.empresa
                                                            AND b.codigo = k.codigo
                    INNER JOIN dbo.p_empleados_pres AS e ON e.id_presup = b.id_presup
                                                            AND e.empresa = b.empresa
                                                            AND e.codigo = b.codigo
            WHERE   k.num_conc = 216
                    AND k.id_presup = @id_presup
                    AND k.empresa = @empresa
                    AND k.mes_operacion = @mes
                    AND k.ayo_operacion = @ayo
                    AND e.tiponom = @tiponom

            IF OBJECT_ID('dbo.tmp_pres_imp_est') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.tmp_pres_imp_est
                END
            FETCH NEXT FROM empresas_imp INTO @empresa

        END

    DEALLOCATE empresas_imp

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_Pres_ImpEstatal')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_Pres_ImpEstatal
GO


CREATE PROCEDURE dbo.asp_Pres_ImpEstatal
    @id_presup INT ,
    @Tiponom INT ,
    @mes INT ,
    @ayo INT ,
    @empresa NUMERIC(4)
AS 
    BEGIN
	
        DECLARE @cConcs CHAR(500) ,
            @cTiponom CHAR(1) ,
            @Res NUMERIC(10, 2) ,
            @cMes CHAR(2) ,
            @cAyo CHAR(4) ,
            @cEmpresa CHAR(4) ,
            @cCodigo CHAR(8) ,
            @cId_presup CHAR(5) ,
            @cPorc CHAR(10)

        SET @cId_presup = CAST(@id_presup AS CHAR(5))
        SET @cMes = CAST(@Mes AS CHAR(2))
        SET @cAyo = CAST(@Ayo AS CHAR(4))
        SET @cTiponom = CAST(@Tiponom AS CHAR(1))
        SET @cEmpresa = CAST(@empresa AS VARCHAR(4))
	
		Print 'Impuesto Estatal'

        SELECT  
				@cPorc = case when len(formula)>5 then SUBSTRING(formula,CHARINDEX('"',formula)+1,CHARINDEX('"',SUBSTRING(formula,CHARINDEX('"',formula)+1,LEN(formula)))-1    )ELSE '0' END ,
                @cConcs = CASE WHEN LEN(totales) <= 0 THEN '0'
                               ELSE SUBSTRING(totales, 2,
                                              CHARINDEX('}', totales) - 2)
                                    + ',213,215'
                          END
        FROM    dbo.conceptos
        WHERE   num_conc = 216
                AND empresa = @empresa
	
        PRINT @cPorc
	
        PRINT 'Aqui'
        IF OBJECT_ID('dbo.tmp_pres_imp_est1') IS NOT NULL 
            BEGIN
                DROP TABLE dbo.tmp_pres_imp_est1
            END

        IF OBJECT_ID('dbo.tmp_pres_imp_est') IS NOT NULL 
            BEGIN
                DROP TABLE dbo.tmp_pres_imp_est
            END

        CREATE TABLE dbo.tmp_pres_imp_est1
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [Empresa] [int] NOT NULL ,
              [Codigo] [numeric](8, 0) NOT NULL ,
              [Importe] [numeric](10, 2) NULL ,
              [tipo] INT not NULL
                CONSTRAINT PK6988_2
                PRIMARY KEY NONCLUSTERED ( Codigo, empresa, id_presup, tipo )
            ) 

        CREATE TABLE dbo.tmp_pres_imp_est
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [Empresa] [int] NOT NULL ,
              [Codigo] [numeric](8, 0) NOT NULL ,
              [Importe] [numeric](10, 2)
                NULL
                CONSTRAINT PK6788_2
                PRIMARY KEY NONCLUSTERED ( Codigo, empresa, id_presup )
            ) 

        DECLARE @SQL CHAR(8000)
        SET @SQL = 'insert into dbo.tmp_pres_imp_est1 '
            + 'Select k.id_presup,k.empresa,k.codigo,' + 'sum(k.importe) * '
            + @cPorc + ', '
            + 'case when k.num_conc>=1 and k.num_conc<=99 then 1 when k.num_conc>=100 and k.num_conc<=199 then 2 when k.num_conc>=200 and k.num_conc<=299 then 1 end '
            + 'From dbo.p_kardex as k '
            + 'Inner join dbo.p_empleados_pres as a on a.empresa=k.empresa and a.codigo=k.codigo and a.id_presup=k.id_presup '
            + 'Where k.id_presup=' + RTRIM(LTRIM(@cId_presup)) + ' and '
            + 'k.num_conc in(' + RTRIM(LTRIM(@cConcs)) + ') and '
            + 'k.empresa = ' + RTRIM(LTRIM(@cEmpresa)) + ' and '
            + 'k.mes_operacion = ' + RTRIM(LTRIM(@cMes)) + ' and '
            + 'k.Ayo_operacion = ' + RTRIM(LTRIM(@cAyo)) + ' and '
            + 'a.tiponom=' + RTRIM(LTRIM(@cTiponom)) + ' '
            + 'group by k.id_presup,k.empresa,k.codigo,case when k.num_conc>=1 and k.num_conc<=99 then 1 when k.num_conc>=100 and k.num_conc<=199 then 2 when k.num_conc>=200 and k.num_conc<=299 then 1 end '
			+ ' order by k.codigo'
        EXEC(@SQL)

        INSERT  INTO dbo.tmp_pres_imp_est
                SELECT  a.id_presup ,
                        a.empresa ,
                        a.codigo ,
                        ( SELECT    SUM(importe)
                          FROM      dbo.tmp_pres_imp_est1
                          WHERE     id_presup = a.id_presup
                                    AND empresa = a.empresa
                                    AND codigo = a.codigo
                                    AND tipo = 1
                        ) - ISNULL(( SELECT SUM(importe)
                                     FROM   dbo.tmp_pres_imp_est1
                                     WHERE  id_presup = a.id_presup
                                            AND empresa = a.empresa
                                            AND codigo = a.codigo
                                            AND tipo = 2
                                   ), 0)
                FROM    dbo.tmp_pres_imp_est1 AS a
                GROUP BY a.id_presup ,
                        a.empresa ,
                        a.codigo
	
		IF OBJECT_ID('dbo.tmp_pres_imp_est1') IS NOT NULL 
            BEGIN
                DROP TABLE dbo.tmp_pres_imp_est1
            END

    END 



GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_ImportarCaptura')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_ImportarCaptura
GO

CREATE PROCEDURE dbo.asp_pres_ImportarCaptura
    @id_presup INT ,
    @num_conc INT ,
    @cEjer CHAR(1) ,
    @cMeses CHAR(1) ,
    @mes INT ,
    @AyoImp INT ,
    @cPorc CHAR(5),
    @tiponom INT
AS /*
Set @id_presup = 1
Set @num_conc  = 9
Set @cEjer     = 'T'
Set @cMeses    = 'F'
Set @mes       = 2
Set @AyoImp    = 2008
Set @Ayo       = 2009
*/
--    PRINT @cPorc

    DECLARE @ayo1 INT ,
        @ayo2 INT ,
        @nPorc DECIMAL(8, 2)

    SET @nPorc = CAST(@cPorc AS DECIMAL(8, 2))
--    PRINT @nPorc


    SELECT  @ayo1 = ini_ejercicio ,
            @ayo2 = fin_ejercicio
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup
 
    DECLARE @SQL NVARCHAR(800) ,
        @cImporte CHAR(15)
    DECLARE @cMes CHAR(4) ,
        @importe NUMERIC(12, 2) ,
        @Centro NVARCHAR(15)

    IF OBJECT_ID('dbo.p_pagos_conc_tmp') IS NOT NULL 
        DROP TABLE dbo.p_pagos_conc_tmp

    SELECT  id_presup ,
            num_conc ,
            concepto ,
            centro ,
            clase ,
            tiponom	
    INTO    dbo.p_pagos_conc_tmp
    FROM    dbo.p_pagos_variables_tiponom
    WHERE   id_presup = @id_presup
            AND num_conc = @num_conc
            AND tiponom = @tiponom

    DELETE  dbo.p_pagos_variables_tiponom
    WHERE   id_presup = @id_presup
            AND num_conc = @num_conc
            AND tiponom = @tiponom

    INSERT  INTO dbo.p_pagos_variables_tiponom
            ( id_presup ,
              num_conc ,
              concepto ,
              centro ,
              clase ,
              tiponom
            )
            SELECT  id_presup ,
                    num_conc ,
                    concepto ,
                    centro ,
                    clase ,
                    tiponom
            FROM    dbo.p_pagos_conc_tmp

    IF OBJECT_ID('dbo.p_pagos_conc_tmp') IS NOT NULL 
        DROP TABLE dbo.p_pagos_conc_tmp


    IF @cMeses = 'T' 
        BEGIN
            DECLARE Parte_Variable CURSOR
            FOR
	
            SELECT SUBSTRING(a.mes,1,3)+'1',CASE WHEN @nPorc > 0 THEN ISNULL(SUM(a.importe),0) + (ISNULL(SUM(a.importe),0) * @nPorc)
            ELSE ISNULL(SUM(a.importe),0) END,l.centro
            FROM dbo.Kardex_anual AS a
            INNER JOIN dbo.llaves AS l ON a.empresa=l.empresa AND a.codigo=l.codigo
            INNER JOIN dbo.p_pagos_variables_tiponom AS v ON v.centro=l.centro AND v.num_conc=@num_conc AND v.id_presup=@id_presup AND v.tiponom = @tiponom
            WHERE a.num_conc=@num_conc AND a.ayo_operacion=@AyoImp AND a.tiponom = @tiponom
            GROUP BY  (CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
            WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
            WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
            WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
            WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
            WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
            WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
            WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
            WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
            WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
            WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
            WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
            END),a.mes,l.centro
            ORDER BY  l.centro,(CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
            WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
            WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
            WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
            WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
            WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
            WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
            WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
            WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
            WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
            WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
            WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
            END)
            OPEN Parte_Variable
            FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro

            WHILE ( @@FETCH_STATUS <> -1 ) 
                BEGIN
                    SET @cImporte = CAST(@importe AS CHAR(15))
                    SET @SQL = 'Update dbo.p_pagos_variables_tiponom set ' + @cMes
                        + ' =' + @cImporte + ' where id_presup='
                        + CAST(@id_presup AS CHAR(5)) + ' and num_conc='
                        + CAST(@NUM_CONC AS CHAR(5)) + ' and centro='
                        + @centro + ' and tiponom=' + LTRIM(RTRIM(STR(@tiponom)))
--                    PRINT @SQL
                    EXEC(@SQL)
                    FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro
                END
            DEALLOCATE Parte_Variable
        END
    ELSE 
        BEGIN
            DECLARE Parte_Variable CURSOR
            FOR
	
            SELECT SUBSTRING(a.mes,1,3)+'1',CASE WHEN @nPorc > 0 THEN ISNULL(SUM(a.importe),0) + (ISNULL(SUM(a.importe),0) * @nPorc)
            ELSE ISNULL(SUM(a.importe),0) END,l.centro
            FROM dbo.Kardex_anual AS a
            INNER JOIN dbo.llaves AS l ON a.empresa=l.empresa AND a.codigo=l.codigo
            INNER JOIN dbo.p_pagos_variables_tiponom AS v ON v.centro=l.centro AND v.num_conc=@num_conc AND v.id_presup=@id_presup AND v.tiponom = @tiponom
            WHERE a.num_conc=@num_conc AND a.ayo_operacion=@AyoImp AND SUBSTRING(mes,1,3)= CASE WHEN @mes = 01 THEN 'ENE' 
            WHEN @mes = 02 THEN 'FEB'
            WHEN @mes = 03 THEN 'MAR'
            WHEN @mes = 04 THEN 'ABR'
            WHEN @mes = 05 THEN 'MAY'
            WHEN @mes = 06 THEN 'JUN'
            WHEN @mes = 07 THEN 'JUL'
            WHEN @mes = 08 THEN 'AGO'
            WHEN @mes = 09 THEN 'SEP'
            WHEN @mes = 10 THEN 'OCT'
            WHEN @mes = 11 THEN 'NOV'
            WHEN @mes = 12 THEN 'DIC'
            END AND a.tiponom = @tiponom
            GROUP BY  (CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
            WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
            WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
            WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
            WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
            WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
            WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
            WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
            WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
            WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
            WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
            WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
            END),a.mes,l.centro
            ORDER BY  l.centro,(CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
            WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
            WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
            WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
            WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
            WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
            WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
            WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
            WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
            WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
            WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
            WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
            END)
            OPEN Parte_Variable
            FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro

            WHILE ( @@FETCH_STATUS <> -1 ) 
                BEGIN
                    SET @cImporte = CAST(@importe AS CHAR(15))
                    SET @SQL = 'Update dbo.p_pagos_variables_tiponom set ' + @cMes
                        + ' =' + @cImporte + ' where id_presup='
                        + CAST(@id_presup AS CHAR(5)) + ' and num_conc='
                        + CAST(@NUM_CONC AS CHAR(5)) + ' and centro='
                        + @centro + ' and tiponom=' + LTRIM(RTRIM(STR(@tiponom))) 
--                    PRINT @SQL
                    EXEC(@SQL)
                    FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro
                END
            DEALLOCATE Parte_Variable
        END

    IF @cEjer = 'T'
        AND @ayo2 > @ayo1 
        IF @cMeses = 'T' 
            BEGIN
                DECLARE Parte_Variable CURSOR
                FOR
		
                SELECT SUBSTRING(a.mes,1,3)+'2',CASE WHEN @nPorc > 0 THEN ISNULL(SUM(a.importe),0) + (ISNULL(SUM(a.importe),0) * @nPorc)
                ELSE ISNULL(SUM(a.importe),0) END,l.centro
                FROM dbo.Kardex_anual AS a
                INNER JOIN dbo.llaves AS l ON a.empresa=l.empresa AND a.codigo=l.codigo
                INNER JOIN dbo.p_pagos_variables_tiponom AS v ON v.centro=l.centro AND v.num_conc=@num_conc AND v.id_presup=@id_presup AND v.tiponom = @tiponom
                WHERE a.num_conc=@num_conc AND a.ayo_operacion=@AyoImp AND a.tiponom = @tiponom
                GROUP BY  (CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
                WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
                WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
                WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
                WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
                WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
                WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
                WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
                WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
                WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
                WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
                WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
                END),a.mes,l.centro
                ORDER BY  l.centro,(CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
                WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
                WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
                WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
                WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
                WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
                WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
                WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
                WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
                WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
                WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
                WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
                END)
                OPEN Parte_Variable
                FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro

                WHILE ( @@FETCH_STATUS <> -1 ) 
                    BEGIN
                        SET @cImporte = CAST(@importe AS CHAR(15))
                        SET @SQL = 'Update dbo.p_pagos_variables_tiponom set ' + @cMes
                            + ' =' + @cImporte + ' where id_presup='
                            + CAST(@id_presup AS CHAR(5)) + ' and num_conc='
                            + CAST(@NUM_CONC AS CHAR(5)) + ' and centro='
                            + @centro + ' and tiponom=' + LTRIM(RTRIM(STR(@tiponom))) 
--                        PRINT @SQL
                        EXEC(@SQL)
                        FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro
                    END
                DEALLOCATE Parte_Variable
            END
        ELSE 
            BEGIN
                DECLARE Parte_Variable CURSOR
                FOR
		
                SELECT SUBSTRING(a.mes,1,3)+'2',CASE WHEN @nPorc > 0 THEN ISNULL(SUM(a.importe),0) + (ISNULL(SUM(a.importe),0) * @nPorc)
                ELSE ISNULL(SUM(a.importe),0) END,l.centro
                FROM dbo.Kardex_anual AS a
                INNER JOIN dbo.llaves AS l ON a.empresa=l.empresa AND a.codigo=l.codigo
                INNER JOIN dbo.p_pagos_variables_tiponom AS v ON v.centro=l.centro AND v.num_conc=@num_conc AND v.id_presup=@id_presup AND v.tiponom = @tiponom
                WHERE a.num_conc=@num_conc AND a.ayo_operacion=@AyoImp AND SUBSTRING(mes,1,3)= CASE WHEN @mes = 01 THEN 'ENE' 
                WHEN @mes = 02 THEN 'FEB'
                WHEN @mes = 03 THEN 'MAR'
                WHEN @mes = 04 THEN 'ABR'
                WHEN @mes = 05 THEN 'MAY'
                WHEN @mes = 06 THEN 'JUN'
                WHEN @mes = 07 THEN 'JUL'
                WHEN @mes = 08 THEN 'AGO'
                WHEN @mes = 09 THEN 'SEP'
                WHEN @mes = 10 THEN 'OCT'
                WHEN @mes = 11 THEN 'NOV'
                WHEN @mes = 12 THEN 'DIC'
                END AND a.tiponom = @tiponom
                GROUP BY  (CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
                WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
                WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
                WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
                WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
                WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
                WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
                WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
                WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
                WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
                WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
                WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
                END),a.mes,l.centro
                ORDER BY  l.centro,(CASE WHEN SUBSTRING(a.mes,1,3) = 'ENE' THEN 01 
                WHEN SUBSTRING(a.mes,1,3) = 'FEB' THEN 02 
                WHEN SUBSTRING(a.mes,1,3) = 'MAR' THEN 03 
                WHEN SUBSTRING(a.mes,1,3) = 'ABR' THEN 04 
                WHEN SUBSTRING(a.mes,1,3) = 'MAY' THEN 05 
                WHEN SUBSTRING(a.mes,1,3) = 'JUN' THEN 06 
                WHEN SUBSTRING(a.mes,1,3) = 'JUL' THEN 07 
                WHEN SUBSTRING(a.mes,1,3) = 'AGO' THEN 08 
                WHEN SUBSTRING(a.mes,1,3) = 'SEP' THEN 09 
                WHEN SUBSTRING(a.mes,1,3) = 'OCT' THEN 10 
                WHEN SUBSTRING(a.mes,1,3) = 'NOV' THEN 11 
                WHEN SUBSTRING(a.mes,1,3) = 'DIC' THEN 12 
                END)
                OPEN Parte_Variable
                FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro

                WHILE ( @@FETCH_STATUS <> -1 ) 
                    BEGIN
                        SET @cImporte = CAST(@importe AS CHAR(15))
                        SET @SQL = 'Update dbo.p_pagos_variables_tiponom set ' + @cMes
                            + ' =' + @cImporte + ' where id_presup='
                            + CAST(@id_presup AS CHAR(5)) + ' and num_conc='
                            + CAST(@NUM_CONC AS CHAR(5)) + ' and centro='
                            + @centro + ' and tiponom=' + LTRIM(RTRIM(STR(@tiponom))) 
--                        PRINT @SQL
                        EXEC(@SQL)
                        FETCH FROM Parte_Variable INTO @cMes,@importe,@Centro
                    END
                DEALLOCATE Parte_Variable
            END

GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_InsertaEmpsNomina')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_InsertaEmpsNomina
GO

CREATE PROCEDURE dbo.p_InsertaEmpsNomina
    (
      @empresa INT ,
      @id_presup INT
    )
AS 
    SET NOCOUNT ON

    INSERT  INTO dbo.p_empleados_pres
            ( id_presup ,
              empresa ,
              codigo ,
              nombre ,
              centro ,
              clase ,
              ocupacion ,
              tiponom ,
              horario ,
              fchalta ,
              sindicato ,
              sueldo ,
              saldiaint ,
              sueldo_i ,
              saldiaint_i ,
              origen ,
              activo ,
              tiposal ,
              fchantigua ,
              varia_imss ,
              fchnac,
              campo01,
              campo03,
			  ManoObra
            )
            SELECT  @id_presup AS id_presup ,
                    @empresa AS empresa ,
                    a.codigo ,
                    SUBSTRING(RTRIM(a.nombre) + ' ' + RTRIM(a.ap_paterno)
                    + ' ' +  RTRIM(a.ap_materno), 1, 50) AS nombre ,
                    l.centro ,
                    l.clase ,
                    l.ocupacion ,
                    l.tiponom ,
                    l.horario ,
                    isnull(a.fchalta,a.fchantigua) as Alta ,
                    a.sindicato ,
                    a.sueldo ,
                    a.saldiaint ,
                    a.sueldo ,
                    a.saldiaint ,
                    'N' AS origen ,
                    'S' AS activo ,
                    a.tiposal ,
                    isnull(a.fchantigua,a.fchalta) as Antiguedad ,
                    a.varia_imss ,
                    a.fchnac,
                    c.campo_02,
                    c.campo_07,
					a.manoobra
            FROM    dbo.empleados AS a
                    INNER JOIN dbo.llaves AS l ON l.empresa = a.empresa
                                                  AND l.codigo = a.codigo
                    LEFT JOIN dbo.clasificacion_empleados AS c ON a.empresa = c.empresa AND a.codigo = c.codigo
            WHERE   a.empresa = @empresa
                    AND a.ultmov <> 'B'
                    AND a.activo = 'S'

    DECLARE @ayo1 INT ,
        @ayo2 INT ,
        @mes1 INT ,
        @mes2 INT ,
        @mes INT ,
        @Fecha DATETIME

    SELECT  @ayo1 = ini_ejercicio ,
            @ayo2 = fin_ejercicio ,
            @mes1 = mes_inicio ,
            @mes2 = mes_final
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup
	
    IF @ayo2 = @ayo1 
        BEGIN

            SET @mes = @mes1
	
            WHILE @mes <= @mes2 
                BEGIN
		
                    SET @fecha = CAST(@ayo1 AS CHAR(4)) + REPLICATE('0',
                                                              2
                                                              - LEN(LTRIM(RTRIM(STR(@mes)))))
                        + LTRIM(RTRIM(STR(@mes))) + '01'
--                    PRINT @mes
--                    PRINT @fecha
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes AS mes ,
                                    @ayo1 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND activo = 'S'
	
                    SET @Mes = @Mes + 1
	
                END

        END

    IF @ayo2 > @ayo1 
        BEGIN
            SET @mes = 1
            WHILE @mes <= 12 
                BEGIN
                    SET @fecha = CAST(@ayo1 AS CHAR(4)) + REPLICATE('0',
                                                              2
                                                              - LEN(LTRIM(RTRIM(STR(@mes)))))
                        + LTRIM(RTRIM(STR(@mes))) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes AS mes ,
                                    @ayo1 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND activo = 'S'
	
                    SET @Mes = @Mes + 1
	
                END

    
            SET @Mes = 1
   
            WHILE @mes <= @Mes2 
                BEGIN
                    SET @fecha = CAST(@ayo2 AS CHAR(4)) + REPLICATE('0',
                                                              2
                                                              - LEN(LTRIM(RTRIM(STR(@mes)))))
                        + LTRIM(RTRIM(STR(@mes))) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes AS mes ,
                                    @ayo2 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND activo = 'S'

                    SET @Mes = @Mes + 1

                END

        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_InsertaTablas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_InsertaTablas
GO

CREATE PROCEDURE dbo.p_InsertaTablas
    @id_presup NUMERIC(3, 0) ,
    @Empresa INT ,
    @clase CHAR(2)
AS 
    DECLARE @ayo_op INT ,
        @mes_op INT

    DECLARE @ayo1 NUMERIC(4) ,
        @ayo2 NUMERIC(4) ,
        @mes1 INT ,
        @mes2 INT

    SELECT  @ayo1 = ini_ejercicio ,
            @ayo2 = fin_ejercicio ,
            @mes1 = mes_inicio ,
            @mes2 = mes_final
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup

    SELECT  @ayo_op = MAX(ayo_operacion)
    FROM    dbo.tablas_int
    WHERE   empresa = @empresa
            AND clase = @clase

--    PRINT @ayo_op

    SELECT  @mes_op = MAX(mes_operacion)
    FROM    dbo.tablas_int
    WHERE   empresa = @empresa
            AND clase = @clase
            AND ayo_operacion = @ayo_op

--    PRINT @mes_op
	
    IF @ayo2 = @ayo1 
        BEGIN
            WHILE @mes1 <= @mes2 
                BEGIN
--                    PRINT @Mes1
                    INSERT  INTO dbo.p_tablas_int
                            ( id_presup ,
                              empresa ,
                              clase ,
                              ayos ,
                              mes_operacion ,
                              ayo_operacion ,
                              factor ,
                              aguinaldo ,
                              dias_vac ,
                              prima_vac ,
                              pmavacdias ,
                              pmavacimpo ,
                              despensa ,
                              despensaim ,
                              dias_ayo ,
                              porc_ayo ,
                              imp_ayo ,
                              dias_mes ,
                              porc_mes ,
                              imp_mes ,
                              porc_dia ,
                              imp_dia ,
                              fdoahopatp ,
                              fdoahopati ,
                              fdoahotrap ,
                              fdoahotrai ,
                              pmo1ayopor ,
                              pmo1ayoimp ,
                              pmo2ayopor ,
                              pmo2ayoimp
                            )
                            SELECT  @id_presup ,
                                    @empresa ,
                                    a.clase ,
                                    a.ayos ,
                                    @Mes1 ,
                                    @Ayo1 ,
                                    a.factor ,
                                    a.aguinaldo ,
                                    a.dias_vac ,
                                    a.prima_vac ,
                                    a.pmavacdias ,
                                    a.pmavacimpo ,
                                    a.despensa ,
                                    a.despensaim ,
                                    a.dias_ayo ,
                                    a.porc_ayo ,
                                    a.imp_ayo ,
                                    a.dias_mes ,
                                    a.porc_mes ,
                                    a.imp_mes ,
                                    a.porc_dia ,
                                    a.imp_dia ,
                                    a.fdoahopatp ,
                                    a.fdoahopati ,
                                    a.fdoahotrap ,
                                    a.fdoahotrai ,
                                    a.pmo1ayopor ,
                                    a.pmo1ayoimp ,
                                    a.pmo2ayopor ,
                                    a.pmo2ayoimp
                            FROM    dbo.tablas_int AS a
                            WHERE   a.mes_operacion = @mes_op
                                    AND a.ayo_operacion = @ayo_op
                                    AND a.empresa = @empresa
                                    AND a.clase = @clase
                            ORDER BY a.clase ,
                                    CAST(a.ayos AS NUMERIC(2))
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

        END

    IF @ayo2 > @ayo1 
        BEGIN
            DECLARE @MesInc NUMERIC(2)
            SET @MesInc = @Mes1
	
            WHILE @MesInc <= 12 
                BEGIN
                    INSERT  INTO dbo.p_tablas_int
                            ( id_presup ,
                              empresa ,
                              clase ,
                              ayos ,
                              mes_operacion ,
                              ayo_operacion ,
                              factor ,
                              aguinaldo ,
                              dias_vac ,
                              prima_vac ,
                              pmavacdias ,
                              pmavacimpo ,
                              despensa ,
                              despensaim ,
                              dias_ayo ,
                              porc_ayo ,
                              imp_ayo ,
                              dias_mes ,
                              porc_mes ,
                              imp_mes ,
                              porc_dia ,
                              imp_dia ,
                              fdoahopatp ,
                              fdoahopati ,
                              fdoahotrap ,
                              fdoahotrai ,
                              pmo1ayopor ,
                              pmo1ayoimp ,
                              pmo2ayopor ,
                              pmo2ayoimp
                            )
                            SELECT  @id_presup ,
                                    @empresa ,
                                    a.clase ,
                                    a.ayos ,
                                    @MesInc ,
                                    @Ayo1 ,
                                    a.factor ,
                                    a.aguinaldo ,
                                    a.dias_vac ,
                                    a.prima_vac ,
                                    a.pmavacdias ,
                                    a.pmavacimpo ,
                                    a.despensa ,
                                    a.despensaim ,
                                    a.dias_ayo ,
                                    a.porc_ayo ,
                                    a.imp_ayo ,
                                    a.dias_mes ,
                                    a.porc_mes ,
                                    a.imp_mes ,
                                    a.porc_dia ,
                                    a.imp_dia ,
                                    a.fdoahopatp ,
                                    a.fdoahopati ,
                                    a.fdoahotrap ,
                                    a.fdoahotrai ,
                                    a.pmo1ayopor ,
                                    a.pmo1ayoimp ,
                                    a.pmo2ayopor ,
                                    a.pmo2ayoimp
                            FROM    dbo.tablas_int AS a
                            WHERE   mes_operacion = @mes_op
                                    AND ayo_operacion = @ayo_op
                                    AND a.empresa = @empresa
                                    AND a.clase = @clase
                            ORDER BY a.clase ,
                                    CAST(a.ayos AS NUMERIC(2))
                    SET @MesInc = @MesInc + 1
                    CONTINUE
                END

            SET @MesInc = 1
            WHILE @MesInc <= @Mes2 
                BEGIN
                    INSERT  INTO dbo.p_tablas_int
                            ( id_presup ,
                              empresa ,
                              clase ,
                              ayos ,
                              mes_operacion ,
                              ayo_operacion ,
                              factor ,
                              aguinaldo ,
                              dias_vac ,
                              prima_vac ,
                              pmavacdias ,
                              pmavacimpo ,
                              despensa ,
                              despensaim ,
                              dias_ayo ,
                              porc_ayo ,
                              imp_ayo ,
                              dias_mes ,
                              porc_mes ,
                              imp_mes ,
                              porc_dia ,
                              imp_dia ,
                              fdoahopatp ,
                              fdoahopati ,
                              fdoahotrap ,
                              fdoahotrai ,
                              pmo1ayopor ,
                              pmo1ayoimp ,
                              pmo2ayopor ,
                              pmo2ayoimp
                            )
                            SELECT  @id_presup ,
                                    @empresa ,
                                    a.clase ,
                                    a.ayos ,
                                    @MesInc ,
                                    @Ayo2 ,
                                    a.factor ,
                                    a.aguinaldo ,
                                    a.dias_vac ,
                                    a.prima_vac ,
                                    a.pmavacdias ,
                                    a.pmavacimpo ,
                                    a.despensa ,
                                    a.despensaim ,
                                    a.dias_ayo ,
                                    a.porc_ayo ,
                                    a.imp_ayo ,
                                    a.dias_mes ,
                                    a.porc_mes ,
                                    a.imp_mes ,
                                    a.porc_dia ,
                                    a.imp_dia ,
                                    a.fdoahopatp ,
                                    a.fdoahopati ,
                                    a.fdoahotrap ,
                                    a.fdoahotrai ,
                                    a.pmo1ayopor ,
                                    a.pmo1ayoimp ,
                                    a.pmo2ayopor ,
                                    a.pmo2ayoimp
                            FROM    dbo.tablas_int AS a
                            WHERE   mes_operacion = @mes_op
                                    AND ayo_operacion = @ayo_op
                                    AND a.empresa = @empresa
                                    AND a.clase = @clase
                            ORDER BY a.clase ,
                                    CAST(a.ayos AS NUMERIC(2))
                    SET @MesInc = @MesInc + 1 
                    CONTINUE
                END

        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_ActualizaParteVariable')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_ActualizaParteVariable
GO

CREATE PROCEDURE dbo.asp_pres_ActualizaParteVariable
    @id_presup INT ,
    @mes INT ,
    @ayo INT
AS 
    DECLARE @nVar NUMERIC(12, 2)

    DECLARE @nEmpresa INT ,
        @nCodigo INT ,
        @nNum_Conc INT ,
        @nSueldo NUMERIC(12, 2) ,
        @nSaldiaInt NUMERIC(12, 2) ,
        @nDiasPag NUMERIC(4, 2) ,
        @nImpo_For NUMERIC(12, 2)

    DECLARE Parte_Variable CURSOR
    FOR
    SELECT  a.empresa,
    a.codigo,
    a.num_conc,
    b.sueldo,
    b.saldiaint,
    (SELECT dias 
    FROM dbo.p_dias 
    WHERE id_presup=@id_presup AND mes=@mes AND ejercicio=@ayo AND tiponom=b.tiponom),
    a.nomina 
    FROM dbo.p_percepciones AS a 
    INNER JOIN dbo.p_empleados_pres AS b ON a.empresa=b.empresa AND a.codigo=b.codigo AND a.id_presup=b.id_presup
    WHERE a.id_presup=@id_presup AND a.mes=@mes AND a.ayo_operacion=@ayo 
	
    OPEN Parte_Variable
    FETCH FROM Parte_Variable INTO @nEmpresa,
								   @nCodigo,
								   @nNum_Conc,
								   @nSueldo,
								   @nSaldiaInt,
								   @nDiasPag,
								   @nImpo_For

    WHILE ( @@FETCH_STATUS <> -1 ) 
        BEGIN
            SELECT  @nVar = vari
            FROM    dbo.tmp_ParteVariable
            UPDATE  dbo.p_percepciones
            SET     varia_imss = @nVar
            WHERE   id_presup = @id_presup
                    AND mes = @Mes
                    AND ayo_operacion = @ayo
                    AND codigo = @nCodigo
                    AND empresa = @nEmpresa
                    AND num_conc = @nNum_Conc
            FETCH NEXT FROM Parte_Variable INTO @nEmpresa,
											@nCodigo,
											@nNum_Conc,
											@nSueldo,
											@nSaldiaInt,
											@nDiasPag,
											@nImpo_For
        END
    DEALLOCATE Parte_Variable


GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_AnalizaTE')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_AnalizaTE
GO


CREATE  PROCEDURE dbo.asp_p_AnalizaTE
    @id_presup INT ,
    @pSMin DECIMAL(10, 2) ,
    @nTiponom INT
AS 
    DECLARE @pEmpresa INT

    DECLARE @nAyo INT
    DECLARE @nMes INT

    DECLARE @cTipoNom CHAR(3)
    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END

    SELECT  @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio)
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup

    IF OBJECT_ID('dbo.Tmp_p_HrEx') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_HrEx

    IF OBJECT_ID('dbo.Tmp_p_Proporcion') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Proporcion

    IF OBJECT_ID('dbo.Tmp_p_HrEx_gra') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_HrEx_gra

    SET DATEFIRST 7
    SELECT  a.codigo ,
            a.Empresa AS Empresa ,
            a.num_conc ,
            MAX(a.folio) AS folio ,
            DATEPART(ww, a.fch_inicio) AS Semana ,
            SUM(a.importe) AS importe ,
            SUM(a.importe / 2) AS mitad ,
            SUM(a.importe) AS excento ,
            SUM(a.importe) AS gravable ,
            0.123456 AS factor
    INTO    dbo.Tmp_p_HrEx
    FROM    dbo.p_Kardex a
            INNER JOIN dbo.conceptos b ON a.num_conc = b.num_conc
                                          AND a.empresa = b.empresa
    WHERE   a.mes_operacion = @nMes
            AND a.ayo_operacion = @nAyo
            AND a.id_presup = @id_presup
            AND a.Empresa IN ( SELECT   empresa
                               FROM     p_empresas
                               WHERE    id_presup = @id_presup )
            AND b.num_conc IN ( 10, 11, 12, 13 )
            AND b.marca2 = 'A'
            AND a.nomina = @cTiponom
    GROUP BY a.empresa ,
            a.codigo ,
            a.num_conc ,
            DATEPART(ww, a.fch_inicio)
    ORDER BY a.codigo ,
            DATEPART(ww, a.fch_inicio)


    SELECT  codigo ,
            Empresa AS Empresa ,
            Semana ,
            ( CASE WHEN SUM(mitad) > ( @pSMin * 5 ) THEN ( @pSMin * 5 )
                   ELSE SUM(mitad)
              END ) / SUM(importe) AS proporcion
    INTO    dbo.Tmp_p_Proporcion
    FROM    dbo.Tmp_p_HrEx
    GROUP BY empresa ,
            codigo ,
            Semana


    UPDATE  dbo.Tmp_p_HrEx
    SET     excento = a.importe * b.proporcion ,
            gravable = a.importe - ( a.importe * b.proporcion ) ,
            factor = b.proporcion
    FROM    dbo.Tmp_p_HrEx a
            INNER JOIN dbo.Tmp_p_Proporcion b ON a.codigo = b.codigo
                                                 AND a.Semana = b.Semana
                                                 AND a.Empresa = b.Empresa

    UPDATE  a
    SET     a.iexento = a.Importe * b.factor ,
            a.igravable = a.importe - ROUND(( a.importe * b.factor ), 2)
    FROM    dbo.p_Kardex a
            INNER JOIN dbo.Tmp_p_HrEx b ON a.codigo = b.codigo
                                           AND a.num_conc = b.num_conc
                                           AND b.semana = DATEPART(ww,
                                                              a.fch_inicio)
                                           AND a.Empresa = b.Empresa
                                           AND a.nomina = @cTiponom
                                           AND a.mes_operacion = @nMes
                                           AND a.ayo_operacion = @nAyo
                                           AND a.id_presup = @id_presup

/* Tiempo extra gravable, no se analiza por semana */
    SELECT  a.codigo ,
            a.Empresa AS Empresa ,
            a.num_conc ,
            a.folio AS folio ,
            a.importe AS gravable ,
            0 AS excento
    INTO    dbo.Tmp_p_HrEx_gra
    FROM    dbo.p_Kardex a
            INNER JOIN dbo.conceptos b ON a.num_conc = b.num_conc
                                          AND a.empresa = b.empresa
    WHERE   a.mes_operacion = @nMes
            AND a.ayo_operacion = @nAyo
            AND a.id_presup = @id_presup
            AND a.Empresa IN ( SELECT   empresa
                               FROM     dbo.p_empresas
                               WHERE    id_presup = @id_presup )
            AND b.num_conc IN ( 10, 11, 12, 13 )
            AND b.marca2 = 'G'
            AND a.nomina = @cTiponom
    ORDER BY a.empresa ,
            a.codigo

    UPDATE  dbo.p_kardex
    SET     iexento = b.excento ,
            igravable = b.gravable
    FROM    dbo.p_Kardex a
            INNER JOIN dbo.Tmp_p_HrEx_gra b ON a.codigo = b.codigo
                                               AND a.num_conc = b.num_conc
                                               AND a.folio = b.folio
                                               AND a.Empresa = b.Empresa
                                               AND a.nomina = @cTiponom
                                               AND a.mes_operacion = @nMes
                                               AND a.ayo_operacion = @nAyo
                                               AND a.id_presup = @id_presup


    DROP TABLE dbo.Tmp_p_HrEx
    DROP TABLE dbo.Tmp_p_Proporcion
    DROP TABLE dbo.Tmp_p_HrEx_gra



    UPDATE  dbo.p_Kardex
    SET     IGravable = CASE WHEN Conceptos.Marca2 = 'G' THEN Kardex.Importe
                             ELSE 0
                        END ,
            IExento = CASE WHEN Conceptos.Marca2 = 'G' THEN 0
                           ELSE Kardex.Importe
                      END
    FROM    dbo.p_Kardex AS kardex
            LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = Kardex.Num_Conc
                                       AND Conceptos.Empresa = Kardex.Empresa
    WHERE   kardex.mes_operacion = @nMes
            AND kardex.ayo_operacion = @nAyo
            AND kardex.id_presup = @id_presup
            AND Kardex.Nomina = @cTipoNom
            AND Kardex.Num_Conc IN ( 1010, 1011, 1012, 1013 )
            AND Kardex.Empresa IN ( SELECT  empresa
                                    FROM    dbo.p_empresas
                                    WHERE   id_presup = @id_presup )





    SET DATEFIRST 1


GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_checa_primas_imss')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_checa_primas_imss
GO


CREATE PROCEDURE dbo.asp_pres_checa_primas_imss @id_presup INT
AS 
    DECLARE @ai INT ,
        @af INT ,
        @mi INT ,
        @dfecha DATETIME
    SELECT  @ai = ini_ejercicio ,
            @af = fin_ejercicio ,
            @mi = mes_inicio
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup

    SET @dFecha = CAST(@ai AS CHAR(4)) + '01' + '01'

    IF NOT EXISTS ( SELECT  periodo
                    FROM    dbo.primas_imss
                    WHERE   periodo = @dfecha ) 
        INSERT  INTO dbo.primas_imss
                SELECT  @dfecha ,
                        eymart25 ,
                        eympat25 ,
                        eymtra25 ,
                        eymart106I ,
                        eymart1062 ,
                        eympat1062 ,
                        eymtra1062 ,
                        eymart107 ,
                        eympat107 ,
                        eymtra107 ,
                        ivart147 ,
                        ivpat147 ,
                        ivtra147 ,
                        retiro ,
                        cvart168II ,
                        cvpat168II ,
                        cvtra168ii,
                        infonavit ,
                        art211 ,
                        seguroDesempleo
                FROM    dbo.primas_imss
                WHERE   periodo = '20080101'
    IF @ai < @af 
        BEGIN
            SET @dFecha = CAST(@af AS CHAR(4)) + '01' + '01'
            IF NOT EXISTS ( SELECT  periodo
                            FROM    dbo.primas_imss
                            WHERE   periodo = @dfecha ) 
                INSERT  INTO dbo.primas_imss
                        SELECT  @dfecha ,
                                eymart25 ,
                                eympat25 ,
                                eymtra25 ,
                                eymart106I ,
                                eymart1062 ,
                                eympat1062 ,
                                eymtra1062 ,
                                eymart107 ,
                                eympat107 ,
                                eymtra107 ,
                                ivart147 ,
                                ivpat147 ,
                                ivtra147 ,
                                retiro ,
                                cvart168II ,
                                cvpat168II ,
                                cvtra168ii,
                        infonavit ,
                        art211 ,
                        seguroDesempleo
                        FROM    dbo.primas_imss
                        WHERE   periodo = '20080101'
        END


go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Despensa')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Despensa
GO


CREATE PROCEDURE dbo.asp_p_Despensa
    @nTipoNom INT ,
    @id_presup INT
AS 
    DECLARE @nempresa INT 

    DECLARE @cMarca2 CHAR(1)
    DECLARE @cMarca1 CHAR(1)
    DECLARE @nDiaMes INT
    DECLARE @cContra CHAR(1)
    DECLARE @cPaga CHAR(1)
    DECLARE @dDia DATETIME
    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME
    DECLARE @cTipoNom CHAR(3)

    DECLARE @nAyo INT
    DECLARE @nMes INT


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @dPago = Periodos.pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio)
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup

    SET @cMarca1 = 'O'
    SET @cMarca2 = 'P'
    SET @nDiaMes = 0
    --SELECT  @cMarca1 = 'O' ,
    --        @cMarca2 = 'P',--ISNULL(MAX(Conceptos.Marca2), 'P') ,
    --        @nDiaMes = 0--ISNULL(MAX(Conceptos.Hrs_Min1), 0)
    --FROM    dbo.Conceptos
    --WHERE   Conceptos.Num_Conc = 31
    --        AND Conceptos.Uso = 'S'
    --        AND Conceptos.Empresa IN ( SELECT   empresa
    --                                   FROM     dbo.p_empresas
    --                                   WHERE    id_presup = @id_presup )


    SET @cContra = CASE WHEN ( SELECT   COUNT(Num_Conc)
                               FROM     dbo.Conceptos
                               WHERE    Conceptos.Num_Conc = 131
                                        AND Conceptos.Uso = 'S'
                                        AND Conceptos.Empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
                             ) > 0 THEN 'S'
                        ELSE 'N'
                   END


    IF OBJECT_ID('dbo.Tmp_p_Despensas') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Despensas
  
  
    SET @cPaga = 'S'

    IF @cMarca1 = 'O' 
        BEGIN
            IF @cMarca2 = 'M' 
                BEGIN
                    SET @dDia = @dInicio
                    WHILE @dDia <= @dCierre 
                        BEGIN

                            IF DAY(@dDia) = @nDiaMes 
                                SET @cPaga = 'S'

                            SET @dDia = @dDia + 1
                        END
                END


            IF @cPaga = 'S' 
                BEGIN
		
                    SELECT  Despensas.empresa ,
                            Despensas.Codigo ,
                            Despensas.Dias ,
                            31 AS Num_Conc ,
                            Despensas.Neto AS Importe ,
                            Despensas.Gravable AS IGravable ,
                            Despensas.Exento AS IExento ,
                            Despensas.Excedente AS VariaImss ,
                            Despensas.Sueldo ,
                            ISNULL(Folios.Folio, 0) + 1 AS Folio
                    INTO    dbo.Tmp_p_Despensas
                    FROM    dbo.p_Despensas AS Despensas
                            LEFT JOIN dbo.p_empleados_pres AS Llaves ON Despensas.Codigo = Llaves.Codigo
                                                              AND Despensas.Empresa = Llaves.Empresa
                                                              AND Despensas.id_presup = Llaves.id_presup
                            LEFT JOIN ( SELECT  empresa ,
                                                Codigo ,
                                                MAX(Folio) AS Folio
                                        FROM    dbo.p_kardex AS Kardex
                                        WHERE   Nomina = @cTipoNom
                                                AND Empresa IN (
                                                SELECT  empresa
                                                FROM    dbo.p_empresas
                                                WHERE   id_presup = @id_presup )
                                                AND id_presup = @id_presup
                                                AND ayo_operacion = @nAyo
                                                AND mes_operacion = @nMEs
                                        GROUP BY empresa ,
                                                Codigo
                                      ) AS Folios ON Despensas.Codigo = Folios.Codigo
                                                     AND Despensas.empresa = Folios.empresa
                    WHERE   Llaves.TipoNom = @nTipoNom
                            AND Llaves.id_presup = @id_presup
                            AND Despensas.Neto > 0
                            AND Despensas.Empresa IN (
                            SELECT  empresa
                            FROM    dbo.p_empresas
                            WHERE   id_presup = @id_presup ) 

                    IF @cContra = 'S' 
                        INSERT  INTO dbo.Tmp_p_Despensas
                                ( empresa ,
                                  Codigo ,
                                  Dias ,
                                  Num_Conc ,
                                  Importe ,
                                  IGravable ,
                                  IExento ,
                                  VariaImss ,
                                  Sueldo ,
                                  Folio
                                )
                                ( SELECT    Despensas.empresa ,
                                            Despensas.Codigo ,
                                            Despensas.Dias ,
                                            131 AS Num_Conc ,
                                            Despensas.Neto AS Importe ,
                                            0 AS IGravable ,
                                            Despensas.Neto AS IExento ,
                                            0 AS VariaImss ,
                                            Despensas.Sueldo ,
                                            ISNULL(Folios.Folio, 0) + 2 AS Folio
                                  FROM      dbo.p_Despensas AS despensas
                                            LEFT JOIN dbo.p_empleados_pres AS Llaves ON Despensas.Codigo = Llaves.Codigo
                                                              AND Despensas.Empresa = Llaves.Empresa
                                                              AND Despensas.id_presup = Llaves.id_presup
                                            LEFT JOIN ( SELECT
                                                              empresa ,
                                                              Codigo ,
                                                              MAX(Folio) AS Folio
                                                        FROM  dbo.p_Kardex AS Kardex
                                                        WHERE Nomina = @cTipoNom
                                                              AND Empresa IN (
                                                              SELECT
                                                              empresa
                                                              FROM
                                                              dbo.p_empresas
                                                              WHERE
                                                              id_presup = @id_presup )
                                                              AND id_presup = @id_presup
                                                              AND ayo_operacion = @nAyo
                                                              AND mes_operacion = @nMEs
                                                        GROUP BY empresa ,
                                                              Codigo
                                                      ) AS Folios ON Despensas.Codigo = Folios.Codigo
                                                              AND Despensas.empresa = Folios.empresa
                                  WHERE     Llaves.TipoNom = @nTipoNom
                                            AND Llaves.id_presup = @id_presup
                                            AND Despensas.Neto > 0
                                            AND Despensas.Empresa IN (
                                            SELECT  empresa
                                            FROM    dbo.p_empresas
                                            WHERE   id_presup = @id_presup )
                                )           



                    INSERT  INTO dbo.p_Kardex
                            ( Codigo ,
                              Empresa ,
                              Nomina ,
                              Centro ,
                              Num_Conc ,
                              Clase ,
                              Folio ,
                              Renglon ,
                              Fch_Inicio ,
                              Fch_Cierre ,
                              Fch_Pago ,
                              Dias ,
                              Inc ,
                              Aus ,
                              DiasTr ,
                              Dias_Imss ,
                              TPago_Desc ,
                              Concepto ,
                              VariaImss ,
                              Variable ,
                              Imss ,
                              Ispt ,
                              Ptu ,
                              Despensa ,
                              Mca_Agui ,
                              FdoAhorro ,
                              Calculo ,
                              Impor_Base ,
                              SalDiaInt ,
                              Tabulador ,
                              Unidades ,
                              Horas ,
                              Tipo_Mov ,
                              Secuencia ,
                              Importe ,
                              IGravable ,
                              IExento ,
                              Credito ,
                              Descuento ,
                              Saldo ,
                              Referencia ,
                              Siempre ,
                              Justificar ,
                              Septimo ,
                              PrevSocial ,
                              Varia1 ,
                              Varia2 ,
                              Varia3 ,
                              Varia4 ,
                              Variable1 ,
                              Variable2 ,
                              Variable3 ,
                              Variable4 ,
                              Masivo ,
                              Formula ,
                              Ispt_NG ,
                              Imss_NI ,
                              Marca ,
                              Serial ,
                              Informativo ,
                              id_presup ,
                              ayo_operacion ,
                              mes_operacion
                            )
                            ( SELECT    Tmp_p_Despensas.Codigo ,
                                        Tmp_p_Despensas.Empresa AS Empresa ,
                                        @cTipoNom AS Nomina ,
                                        ' ' AS Centro ,
                                        Tmp_p_Despensas.Num_Conc ,
                                        ' ' AS Clase ,
                                        Tmp_p_Despensas.Folio ,
                                        0 AS Renglon ,
                                        @dInicio AS Fch_Inicio ,
                                        @dCierre AS Fch_Cierre ,
                                        @dPago AS Fch_Pago ,
                                        Tmp_p_Despensas.Dias ,
                                        0 AS Inc ,
                                        0 AS Aus ,
                                        Tmp_p_Despensas.Dias AS DiasTr ,
                                        0 AS Dias_Imss ,
                                        CASE WHEN Tmp_p_Despensas.Num_Conc = 31
                                             THEN 'P'
                                             ELSE 'D'
                                        END AS TPago_Desc ,
                                        Conceptos.Concepto ,
                                        Tmp_p_Despensas.VariaImss ,
                                        0 AS Variable ,
                                        Conceptos.Imss ,
                                        Conceptos.Ispt ,
                                        Conceptos.Ptu ,
                                        Conceptos.Despensa ,
                                        Conceptos.Mca_Agui ,
                                        Conceptos.FdoAhorro ,
                                        'A' AS Calculo ,
                                        Tmp_p_Despensas.Sueldo AS Impor_Base ,
                                        Empleados.SalDiaInt ,
                                        0 AS Tabulador ,
                                        0 AS Unidades ,
                                        0 AS Horas ,
                                        'VAL' AS Tipo_Mov ,
                                        0 AS Secuencia ,
                                        Tmp_p_Despensas.Importe ,
                                        Tmp_p_Despensas.IGravable ,
                                        Tmp_p_Despensas.IExento ,
                                        0 AS Credito ,
                                        0 AS Descuento ,
                                        0 AS Saldo ,
                                        ' ' AS Referencia ,
                                        'N' AS Siempre ,
                                        ' ' AS Justificar ,
                                        ' ' AS Septimo ,
                                        Conceptos.PrevSocial ,
                                        0 AS Varia1 ,
                                        0 AS Varia2 ,
                                        0 AS Varia3 ,
                                        0 AS Varia4 ,
                                        ' ' AS Variable1 ,
                                        ' ' AS Variable2 ,
                                        ' ' AS Variable3 ,
                                        ' ' AS Variable4 ,
                                        'F' AS Masivo ,
                                        ' ' AS Formula ,
                                        ' ' AS Ispt_NG ,
                                        ' ' AS Imss_NI ,
                                        ' ' AS Marca ,
                                        0 AS Serial ,
                                        'F' AS Informativo ,
                                        @id_presup AS id_presup ,
                                        @nAyo AS ayo_operacion ,
                                        @nMes AS mes_operacion
                              FROM      dbo.Tmp_p_Despensas
                                        LEFT JOIN dbo.p_empleados_pres AS Empleados ON Tmp_p_Despensas.Codigo = Empleados.Codigo
                                                              AND Empleados.Empresa = Tmp_p_Despensas.Empresa
                                        LEFT JOIN dbo.Conceptos ON Tmp_p_Despensas.Num_Conc = Conceptos.Num_Conc
                                                              AND Conceptos.Empresa = Tmp_p_Despensas.Empresa
                              WHERE     empleados.id_presup = @id_presup
                            )


                    DROP TABLE dbo.Tmp_p_Despensas

                END
        END
GO


If OBJECT_ID('dbo.asp_p_Dominical') Is NOT NULL
  Drop Procedure dbo.asp_p_Dominical
Go



CREATE Procedure dbo.asp_p_Dominical
@idPresup Int,
@nTipoNom Int,
@nSalMin  Numeric(10,2),
@nUma     Numeric(10,2)

As


Declare @dPago    DateTime
Declare @cTipoNom Char(3)

Set @cTipoNom = Case When @nTipoNom = 1 Then 'SEM'
                     When @nTipoNom = 2 Then 'DEC'
                     When @nTipoNom = 3 Then 'CAT'
                     When @nTipoNom = 4 Then 'QNA'
                     When @nTipoNom = 5 Then 'MES' Else 'ESP' End

declare @mes int
declare @ayo int

Select @dPago = Periodos.Pago,@mes=Periodos.mes,@ayo=Periodos.ejercicio 
From p_dias as  Periodos Where Estatus = 'A' And id_presup = @idPresup And TipoNom = @nTipoNom



Set DateFirst 1

If OBJECT_ID('dbo.Tmp_p_Domingos') Is NOT NULL
  Drop Table dbo.Tmp_p_Domingos

Select Kardex.Codigo,
       9 As Num_Conc,
       dbo.Fun_R_ChecaDomingos(Kardex.Codigo,Kardex.Fch_Inicio,Kardex.Fch_Cierre,kardex.Empresa) As Domingos,
       Kardex.Impor_Base,
       Kardex.SalDiaInt,
       Kardex.Fch_Inicio,
       Kardex.Fch_Cierre,
       Conceptos.Concepto,
       Conceptos.Clase,
       Conceptos.Centro,
       Conceptos.Importe1,
       Conceptos.Porciento1,
       Convert(Numeric(12,2),Round(((Kardex.Impor_Base * (Conceptos.Porciento1/100)) + Conceptos.Importe1),2)) As Importe,
       Conceptos.Imss,
       Conceptos.Ispt,
       Conceptos.Ptu,
       Conceptos.Despensa,
       Conceptos.Mca_Agui,
       Conceptos.FdoAhorro,
       0 As Folio,
       kardex.empresa AS empresa,
       'DOM' AS tipo_mov,
       'A' as calculo       
Into dbo.Tmp_p_Domingos
From p_Kardex as Kardex
Inner Join P_Empleados_Pres as llaves On Kardex.Codigo = LLaves.Codigo And Kardex.Empresa = Llaves.Empresa And Kardex.id_presup = Llaves.id_presup
Inner Join Horarios_Catalogo On Llaves.Horario = Horarios_Catalogo.Horario And Llaves.Empresa = Horarios_Catalogo.Empresa
Left Join Conceptos On Conceptos.Num_Conc = 9 And Conceptos.Uso = 'S' And Conceptos.Captura = 'A' And
                       ((Conceptos.Centro = '' And Conceptos.Clase = '') Or
                       (Conceptos.Centro = Llaves.Centro And Conceptos.Clase = Llaves.Clase) Or
                       (Conceptos.Centro = '' And Conceptos.Clase = Llaves.Clase) Or
                       (Conceptos.Centro = Llaves.Centro And Conceptos.Clase = '')) And
                       Conceptos.Empresa = Kardex.Empresa
Where kardex.id_presup = @idPresup and 
	  Kardex.Num_Conc = @nTipoNom And 
      Kardex.Nomina = @cTipoNom And
      Llaves.TipoNom = @nTipoNom And
      CharIndex('7',Horarios_Catalogo.Descanso,1) = 0 And
      (Conceptos.Importe1 > 0 Or Conceptos.Porciento1 > 0)
	  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
Order By Kardex.Codigo


Update Tmp_p_Domingos Set Importe = Tmp_p_Domingos.Domingos * Round(((Tmp_p_Domingos.Impor_Base * (Tmp_p_Domingos.Porciento1/100)) + Tmp_p_Domingos.Importe1),2)


--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Domingos','Folio',0,0


Insert Into p_Kardex (Codigo,Empresa,Nomina,Centro,Num_Conc,Clase,Folio,Renglon,Fch_Inicio,Fch_Cierre,Fch_Pago,
                    Dias, Inc, Aus, DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable,
                    Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro, Calculo, Impor_Base, SalDiaInt,
                    Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento, Credito, Descuento,
                    Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                    Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca,
                    Serial, Informativo,mes_operacion,ayo_operacion,id_presup)
(
Select Tmp_p_Domingos.Codigo,
       Tmp_p_Domingos.Empresa As Empresa,
       @cTipoNom As Nomina,
       Tmp_p_Domingos.Centro,
       9 As Num_Conc,
       Tmp_p_Domingos.Clase,
       Tmp_p_Domingos.Folio,
       0 As Renglon,
       Tmp_p_Domingos.Fch_Inicio,
       Tmp_p_Domingos.Fch_Cierre,
       @dPago As Fch_Pago,
       Tmp_p_Domingos.Domingos As Dias,
       0 As Inc,
       0 As Aus,
       Tmp_p_Domingos.Domingos As DiasTr,
       0 As Dias_Imss,
       'P' As TPago_Desc,
       Tmp_p_Domingos.Concepto,
       Tmp_p_Domingos.Importe As VariaImss,
       Tmp_p_Domingos.Importe As Variable,
       Tmp_p_Domingos.Imss,
       Tmp_p_Domingos.Ispt,
       Tmp_p_Domingos.Ptu,
       Tmp_p_Domingos.Despensa,
       Tmp_p_Domingos.Mca_Agui,
       Tmp_p_Domingos.FdoAhorro,
       Tmp_p_Domingos.calculo,  --'A' As Calculo,
       Tmp_p_Domingos.Impor_Base,
       Tmp_p_Domingos.SalDiaInt,
       0 As Tabulador,
       Tmp_p_Domingos.Domingos As Unidades,
       0 As Horas,
       Tmp_p_Domingos.Tipo_Mov,
       5 As Secuencia,
       Tmp_p_Domingos.Importe,
       Case When Tmp_p_Domingos.Importe > Tmp_p_Domingos.Domingos * IsNull(@nUma,@nSalMin) Then Tmp_p_Domingos.Importe - (Tmp_p_Domingos.Domingos * IsNull(@nUma,@nSalMin)) Else 0 End As IGravable,
       Case When Tmp_p_Domingos.Importe < Tmp_p_Domingos.Domingos * IsNull(@nUma,@nSalMin) Then Tmp_p_Domingos.Importe Else Tmp_p_Domingos.Domingos * IsNull(@nUma,@nSalMin) End As IExento,
       0 As Credito,
       0 As Descuento,
       0 As Saldo,
       ' ' As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       'F' As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       ' ' As Formula,
       ' ' As Ispt_NG,
       ' ' As Imss_NI,
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo,
	   @mes,
	   @ayo,
	   @idPresup
From Tmp_p_Domingos
Where Tmp_p_Domingos.Importe > 0
)

Drop Table dbo.Tmp_p_Domingos

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_ds_2')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_ds_2
GO

CREATE PROCEDURE dbo.asp_pres_ds_2
    @ncodigo NUMERIC(8, 0) ,
    @nayo INT ,
    @nmes INT ,
    @dfch_fin_mes DATETIME ,
    @id_presup INT
AS 
    DECLARE @ninicio NUMERIC(8, 0)
    DECLARE @nfin NUMERIC(8, 0)

    IF @ncodigo = 0 
        BEGIN 
            SET @ninicio = 1
            SET @nfin = 99999999
        END
    ELSE 
        BEGIN
            SET @ninicio = @ncodigo
            SET @nfin = @ncodigo
        END

    UPDATE  a
    SET     a.diastr = 0
    FROM    dbo.p_empresas AS emps
            INNER JOIN dbo.tmp_p_avisos_imss AS a ON emps.empresa = a.empresa
                                                     AND emps.id_presup = a.id_presup
    WHERE   a.ayo_operacion = @nayo
            AND a.mes_operacion = @nmes
            AND a.id_presup = @id_presup 

    UPDATE  a
    SET     a.diastr = CASE WHEN a.mov = 'B' THEN 0
                            WHEN a.fch_mov = d.fch_mov
                                 AND d.mov <> 'B' THEN 0
                            WHEN d.fch_mov IS NULL
                            THEN DATEDIFF(dd, a.fch_mov, @dfch_fin_mes) + 1
                            ELSE DATEDIFF(dd, a.fch_mov, d.fch_mov)
                                 + CASE WHEN d.mov = 'B' THEN 1
                                        ELSE 0
                                   END
                       END
    FROM    dbo.p_empresas AS emps
            INNER JOIN dbo.tmp_p_avisos_imss AS a ON emps.empresa = a.empresa
                                                     AND emps.id_presup = a.id_presup
            LEFT JOIN dbo.tmp_p_avisos_imss AS d ON a.empresa = d.empresa
                                                    AND a.codigo = d.codigo
                                                    AND a.ayo_operacion = d.ayo_operacion
                                                    AND a.mes_operacion = d.mes_operacion
                                                    AND a.serial + 1 = d.serial
    WHERE   a.ayo_operacion = @nayo
            AND a.mes_operacion = @nmes
            AND a.id_presup = @id_presup



GO

If OBJECT_ID('dbo.asp_p_FdoAhorro') Is NOT NULL
  Drop Procedure dbo.asp_p_FdoAhorro
Go


CREATE Procedure dbo.asp_p_FdoAhorro
@id_presup  Int,
@nTipoNom  Int,
@dFf       DateTime,
@nSalMin   Numeric(10,2),
@nUma       Numeric(10,2)

As

Set DateFirst 1

Declare @cTipoNom   Char(3)
Declare @dInicio    DateTime
Declare @dCierre    DateTime
Declare @dPago      DateTime
Declare @nConcepto  Int

Declare @cMca108    Char(1)
Declare @cMca109    Char(1)
Declare @cMca110    Char(1)
Declare @cMca111    Char(1)
Declare @cMca120    Char(1)

Declare @dFechaTab  DateTime

Declare @cRegPat    Char(10)
Declare @cRfcPat    VarChar(13)

Declare @dFi        DateTime

Declare @cAus27     VarChar(5)

Declare @dLimiteTab DateTime

Set @dFi      = Convert(DateTime,Convert(Char(4),Year(@dFf)) + Right('0' + LTrim(Rtrim(Convert(Char(2),Month(@dFf)))),02) + '01')

Select Top 1 @cAus27 = IsNull(max(Variable2),'FPST') From Conceptos Where Num_Conc = 27 And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)

If @cAus27 = ''
  Set @cAus27 = 'FPST'


Select @cRegPat = max(Registro_Patronal),
       @cRfcPat = LTrim(max(Rfc_Empresa))
From Empresas Where Empresa in(select empresa from P_empresas where id_presup=@id_Presup)


Set @nConcepto = 126

Set @cTipoNom = Case When @nTipoNom = 1 Then 'SEM'
                     When @nTipoNom = 2 Then 'DEC'
                     When @nTipoNom = 3 Then 'CAT'
                     When @nTipoNom = 4 Then 'QNA'
                     When @nTipoNom = 5 Then 'MES' Else 'ESP' End


declare @mes int
declare @ayo int
Select @dInicio = Periodos.Inicio, @dCierre = Periodos.Cierre, @dPago = Periodos.Pago,@mes=Periodos.mes,@ayo=Periodos.ejercicio
From p_dias as  Periodos Where Estatus = 'A' And id_presup = @id_presup And TipoNom = @nTipoNom

Declare @DiasDelAyo int
set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@Ayo),0)

--select @DiasDelAyo as DiasDelAyo

Set @dLimiteTab = Case When @cRegPat = 'A341146210'
                       Then @dFf
                       Else @dCierre
                  End

-- Checar las marcas del ausentismo que afecta el fondo de ahorro
Select @cMca108 = Case When Num_Conc = 108 Then max(FdoAhorro) Else @cMca108 End,
       @cMca109 = Case When Num_Conc = 109 Then max(FdoAhorro) Else @cMca109 End,
       @cMca110 = Case When Num_Conc = 110 Then max(FdoAhorro) Else @cMca110 End,
       @cMca111 = Case When Num_Conc = 111 Then max(FdoAhorro) Else @cMca111 End,
       @cMca120 = Case When Num_Conc = 120 Then max(FdoAhorro) Else @cMca120 End
From Conceptos
Where Num_Conc In (108,109,110,111,120) And
      Clase = ' ' And
      Centro = ' ' And
      Empresa in(select empresa from P_empresas where id_presup=@id_Presup)
group by num_conc

-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
If @dPago > @dFF
  Set @dFechaTab = @dFF
Else
  Set @dFechaTab = @dPago
--


If OBJECT_ID('dbo.Tmp_p_Fondo') Is NOT NULL
  Drop Table dbo.Tmp_p_Fondo


If OBJECT_ID('dbo.Tmp_p_FdoTotal') Is NOT NULL
  Drop Table dbo.Tmp_p_FdoTotal


CREATE TABLE [dbo].[Tmp_p_Fondo] (
	[empresa] [numeric](8, 0) NULL ,
	[Codigo] [numeric](8, 0) NULL ,
	[Num_Conc] [int] NULL ,
	--[Fch_Inicio] [datetime] NULL ,
	--[Fch_Cierre] [datetime] NULL ,
	[Impor_Base] [numeric](12, 2) NULL ,
	[SalDiaInt] [numeric](12, 2) NULL ,
	[DiasTr] [numeric](16, 2) NULL ,
	[Dias] [numeric](6, 2) NULL ,
	[Inc] [int] NULL ,
	[Aus] [int] NULL ,
	[DiasReales] [numeric](29, 6) NULL ,
	[Descuento] [numeric](10, 2) NULL ,
	[Importe] [numeric](38, 6) NULL 
) ON [PRIMARY]


-- Si existe fondo de ahorro mensual, agregar a la tabla Tmp_p_Sueldos
-- los registros del Kardex_Anual para calcular esos conceptos
If Exists (Select max(Variable1) From Conceptos Where Num_Conc = 27 And Empresa in(select empresa from P_empresas where id_presup=@id_Presup) And Variable1 = 'MENSUAL' And ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos.Hrs_Min1 >= Day(@dInicio) And Conceptos.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) Else (Case When Conceptos.Hrs_Min1 >= Day(@dInicio) Or Conceptos.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End))
  Begin  
    If OBJECT_ID('dbo.Tmp_p_Mensual') Is Not NULL
      Drop Table dbo.Tmp_p_Mensual

    --If OBJECT_ID('dbo.Tmp_Faltas') Is Not NULL
    --  Drop Table dbo.Tmp_Faltas

    Select Kardex_Anual.Codigo,
           Kardex_Anual.Num_Conc,
           Kardex_Anual.Impor_Base As Sueldo,
           Kardex_Anual.SalDiaInt,
           Case When Kardex_Anual.Fch_Inicio < IsNull(Conceptos.Fecha1,@dFi) Then IsNull(Conceptos.Fecha1,@dFi) Else Kardex_Anual.Fch_Inicio End As Fch_Inicio,
           Case When Kardex_Anual.Fch_Cierre > IsNull(Conceptos.Fecha2,@dFf) Then IsNull(Conceptos.Fecha2,@dFf) Else Kardex_Anual.Fch_Cierre End As Fch_Cierre,
           Convert(Numeric(6,2),0) As Dias,
           Convert(Numeric(6,2),0) As Incap,
           Convert(Numeric(6,2),0) As Ausen,
           Convert(Numeric(6,2),0) As Faltas,
           Convert(Numeric(6,2),0) As Incap_Eg,
           Convert(Numeric(6,2),0) As Incap_Mat,
           Convert(Numeric(6,2),0) As Incap_Rt,
           Convert(Numeric(6,2),0) As Descuento,
           Convert(Numeric(6,2),0) As Vacaciones,
           Convert(Numeric(6,2),0) As F108,
           Convert(Numeric(6,2),0) As P108,
           Convert(Numeric(6,2),0) As S108,
           Convert(Numeric(6,2),0) As T108,
           Kardex_Anual.Empresa As Empresa
    Into dbo.Tmp_p_Mensual
    From Kardex_Anual
    Inner Join P_Empleados_Pres as Llaves On Llaves.Codigo = Kardex_Anual.Codigo And Llaves.Empresa = Kardex_Anual.Empresa
    --Inner Join Empleados On Empleados.Codigo = Kardex_Anual.Codigo And Empleados.Empresa = Kardex_Anual.Empresa
    Left Join Conceptos On Conceptos.Num_Conc = 27 And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = Kardex_Anual.Empresa
    Where --(Empleados.UltMov <> 'B' Or (Empleados.UltMov = 'B' And UltFchMov >= @dInicio)) And
           (Kardex_Anual.Fch_Inicio Between IsNull(Conceptos.Fecha1,@dFi) And IsNull(Conceptos.Fecha2,@dFf) Or 
           Kardex_Anual.Fch_Cierre Between IsNull(Conceptos.Fecha1,@dFi) And IsNull(Conceptos.Fecha2,@dFf)) And
          Kardex_Anual.Num_Conc In (1,2,3,4,5,6) And
          Kardex_Anual.TipoNom = @nTipoNom And
          Conceptos.Variable1 = 'MENSUAL' And
          ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos.Hrs_Min1 >= Day(@dInicio) And Conceptos.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                         Else (Case When Conceptos.Hrs_Min1 >= Day(@dInicio) Or Conceptos.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End) And
          --Kardex_Anual.Empresa = @nEmpresa 
		  Llaves.id_presup=@id_presup
    Order By Kardex_Anual.Codigo, Kardex_Anual.Fch_Inicio


    UpDate Tmp_p_Mensual
    Set Dias = Datediff(Day,Tmp_p_Mensual.Fch_Inicio,Tmp_p_Mensual.Fch_Cierre)+1

    --/* Esto es lo original
    UpDate Tmp_p_Mensual Set Faltas    = Tmp_Faltas.faltas   ,
                           Incap_Eg  = Tmp_Faltas.incap_eg ,
                           Incap_Mat = Tmp_Faltas.incap_mat,
                           Incap_Rt  = Tmp_Faltas.incap_rt ,
                           F108      = Tmp_Faltas.F108,
                           P108      = Tmp_Faltas.P108,
                           S108      = Tmp_Faltas.S108,
                           T108      = Tmp_Faltas.T108
    From Tmp_p_Mensual
    --Inner Join Tmp_Faltas On Tmp_p_Mensual.Codigo = Tmp_Faltas.codigo And Tmp_p_Mensual.Fch_Inicio = Tmp_Faltas.Fch_Inicio And Tmp_p_Mensual.Fch_Cierre = Tmp_Faltas.Fch_Cierre
    Inner Join (Select Tmp_p_Mensual.Codigo,
                       Tmp_p_Mensual.Fch_Inicio,
                       Tmp_p_Mensual.Fch_Cierre,
                       Sum( Case When Deducciones.Num_Conc = 108 Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As Faltas,
                       Sum( Case When Deducciones.Num_Conc = 109 Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As Incap_Eg,
                       Sum( Case When Deducciones.Num_Conc = 110 Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As Incap_Mat,
                       Sum( Case When Deducciones.Num_Conc = 111 Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As Incap_Rt,
                       Sum( Case When Deducciones.Num_Conc = 108 And Deducciones.Justificar = 'F' Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As F108,
                       Sum( Case When Deducciones.Num_Conc = 108 And Deducciones.Justificar = 'P' Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As P108,
                       Sum( Case When Deducciones.Num_Conc = 108 And Deducciones.Justificar = 'S' Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As S108,
                       Sum( Case When Deducciones.Num_Conc = 108 And Deducciones.Justificar = 'T' Then DateDiff( Day,
                                                                                Case When Deducciones.FchInicio < Tmp_p_Mensual.Fch_Inicio  Then Tmp_p_Mensual.Fch_Inicio Else Deducciones.FchInicio End,
                                                                                Case When Deducciones.FchTermino > Tmp_p_Mensual.Fch_Cierre Then Tmp_p_Mensual.Fch_Cierre Else Deducciones.FchTermino End ) + 1
                                                                 Else 0 End ) As T108
                --Into Tmp_Faltas
                From Tmp_p_Mensual
                Inner Join Deducciones on Tmp_p_Mensual.Codigo = Deducciones.Codigo And Tmp_p_Mensual.Empresa = Deducciones.Empresa
                Where Deducciones.Num_Conc In (108,109,110,111) And
                      ((Deducciones.FchInicio Between Tmp_p_Mensual.Fch_Inicio And Tmp_p_Mensual.Fch_Cierre) Or (Deducciones.FchInicio+Deducciones.Dias-1 Between Tmp_p_Mensual.Fch_Inicio and Tmp_p_Mensual.Fch_Cierre) or ( (Deducciones.FchInicio <= Tmp_p_Mensual.Fch_Inicio) and (Deducciones.FchTermino >= Tmp_p_Mensual.Fch_Cierre) )) And
                      Tmp_p_Mensual.Codigo = Deducciones.Codigo And Tmp_p_Mensual.Empresa = Deducciones.Empresa
                Group By Tmp_p_Mensual.Codigo,Tmp_p_Mensual.Fch_Inicio,Tmp_p_Mensual.Fch_Cierre) As Tmp_Faltas On Tmp_p_Mensual.Codigo = Tmp_Faltas.Codigo And Tmp_p_Mensual.Fch_Inicio = Tmp_Faltas.Fch_Inicio And Tmp_p_Mensual.Fch_Cierre = Tmp_Faltas.Fch_Cierre
    
    -- Vacaciones del periodo y anteriores
    UpDate Tmp_p_Mensual
    Set Vacaciones = dbo.Fun_R_LeeDsVacaciones(Tmp_p_Mensual.Codigo,Tmp_p_Mensual.Empresa,Tmp_p_Mensual.Fch_Inicio,Tmp_p_Mensual.Fch_Cierre,0,0,'DS','R')

    Insert Into dbo.Tmp_p_Sueldos (Codigo, Mov, Inicio, Termino, Sueldo, SalDiaInt, Dias, Dias_Imss,
                             Mes_Operacion, Ayo_Operacion, Vacaciones, Faltas, Incap_Eg, Incap_Mat,
                             Incap_Rt, Descuento, F108, P108, S108, T108, Horario, Alta, Baja, Ri, 
                             Folio, Elimina, Empresa, RestaVacaciones)
    (
    Select Tmp_p_Mensual.Codigo,
           ' ' As Mov,
           Fch_Inicio As Inicio,
           Fch_Cierre As Termino,
           llaves.Sueldo,
           llaves.SalDiaInt,
           Dias,
           Dias As Dias_Imss,
           Month(@dPago) As Mes_Operacion,
           Year(@dPago) As Ayo_Operacion,
           Vacaciones,
           Faltas,
           Incap_Eg,
           Incap_Mat,
           Incap_Rt,
           
           --0 As Descuento,
           (Select Top 1 Factor_Aus From Detalle_Horarios Where Horario = Llaves.Horario And Factor_Aus > 0 And Empresa = Tmp_p_Mensual.Empresa) As Descuento,
           
           F108,
           P108,
           S108,
           T108,
           0 As Horario,
           '' As Alta,
           '' As Baja,
           '' As Ri,
           0 As Folio,
           '' As Elimina,
           Tmp_p_Mensual.Empresa As Empresa,
           'N' As RestaVacaciones
    From Tmp_p_Mensual
    Inner Join P_Empleados_Pres as  Llaves On Llaves.Codigo = Tmp_p_Mensual.Codigo And Llaves.Empresa = Tmp_p_Mensual.Empresa
    )

    Drop Table dbo.Tmp_p_Mensual

    --Drop Table dbo.Tmp_Faltas

  End
--

While @nConcepto <= 127
  Begin
 
    -- Tomar como base la tabla Tmp_p_Sueldos porque ahi estan separadas las incapacidades por tipo, para poder validar la marca
    -- de si afecta o no el fondo de ahorro
    -- Sacar los registros del sueldo menos ausentismo, posteriormente agregar un registro nuevo si es que existen conceptos
    -- que afecten el fondo de ahorro...como comisiones; asi como agregar otro registro si existe algun concepto 7 o 107 y afecta el fondo de ahorro
    -- al final registrar un solo concepto 27
    Insert Into dbo.Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
    (
    Select  Tmp_p_Sueldos.Empresa,
			Tmp_p_Sueldos.Codigo,
           Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
           --Tmp_p_Sueldos.Inicio As Fch_Inicio,
           --Tmp_p_Sueldos.Termino As Fch_Cierre,
           Tmp_p_Sueldos.Sueldo As Impor_Base,
           Tmp_p_Sueldos.SalDiaInt,
           Tmp_p_Sueldos.Dias-(Case When CharIndex('F',@cAus27) > 0 Then F108 Else 0 End + 
                             Case When CharIndex('P',@cAus27) > 0 Then P108 Else 0 End +
                             Case When CharIndex('S',@cAus27) > 0 Then S108 Else 0 End +
                             Case When CharIndex('T',@cAus27) > 0 Then T108 Else 0 End) -
                             
                            (Case When Horarios_Catalogo.Semana_Red NOT IN ('S','T') Or (Tmp_p_Sueldos.Incap_EG+Tmp_p_Sueldos.Incap_Mat+Tmp_p_Sueldos.Incap_RT) = 0
                                  Then (Tmp_p_Sueldos.Incap_EG+Tmp_p_Sueldos.Incap_Mat+Tmp_p_Sueldos.Incap_RT)
                                  Else dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo, Tmp_p_Sueldos.Inicio, Tmp_p_Sueldos.Termino, Llaves.Horario, '0', llaves.Empresa)
                             End+Tmp_p_Sueldos.Vacaciones) As DiasTr,

           -- Esta linea estaba en lugar del -Tmp_p_Sueldos.Vacaciones ... Esto para agregar los registros de vacaciones posteriormente
           -- ya que con esta linea, cortaba las vacaciones a los dias del periodo nominal y el fondo salia incompleto
           --Case When Tmp_p_Sueldos.Vacaciones > 0 And IsNull(Vacaciones.Salio,'F') = 'T' And (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) = 0 Or (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) > 0 And IsNull(Vacaciones.Ordinaria,'F') = 'F')) Then Tmp_p_Sueldos.Vacaciones Else 0 End As DiasTr,

           Tmp_p_Sueldos.Dias,

           Case When Horarios_Catalogo.Semana_Red In ('S','T') And (Tmp_p_Sueldos.Incap_EG+Tmp_p_Sueldos.Incap_Mat+Tmp_p_Sueldos.Incap_RT) > 0
                Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo, Tmp_p_Sueldos.Inicio, Tmp_p_Sueldos.Termino, Llaves.Horario, '0', llaves.Empresa)
                Else Tmp_p_Sueldos.Incap_EG+Tmp_p_Sueldos.Incap_Mat+Tmp_p_Sueldos.Incap_RT
           End As Inc,

           Case When CharIndex('F',@cAus27) > 0 Then F108 Else 0 End + 
           Case When CharIndex('P',@cAus27) > 0 Then P108 Else 0 End +
           Case When CharIndex('S',@cAus27) > 0 Then S108 Else 0 End +
           Case When CharIndex('T',@cAus27) > 0 Then T108 Else 0 End As Aus,

           --Tmp_p_Sueldos.Faltas As Aus,

           Tmp_p_Sueldos.Dias - Case When @cMca108 = 'S' And CharIndex('F',@cAus27) > 0 Then Tmp_p_Sueldos.F108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                              Case When @cMca108 = 'S' And CharIndex('P',@cAus27) > 0 Then Tmp_p_Sueldos.P108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                              Case When @cMca108 = 'S' And CharIndex('S',@cAus27) > 0 Then Tmp_p_Sueldos.S108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                              Case When @cMca108 = 'S' And CharIndex('T',@cAus27) > 0 Then Tmp_p_Sueldos.T108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                              
                              Case When @cMca109 = 'S' 
                                   Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_EG > 0
                                             Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'1',llaves.Empresa)
                                             Else Tmp_p_Sueldos.Incap_EG
                                        End
                                   Else 0
                              End -
                              Case When @cMca110 = 'S'
                                   Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_Mat > 0
                                             Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'2',llaves.Empresa)
                                             Else Tmp_p_Sueldos.Incap_Mat
                                        End
                                   Else 0
                              End -
                              Case When @cMca111 = 'S'
                                   Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_RT > 0
                                             Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'3',llaves.Empresa)
                                             Else Tmp_p_Sueldos.Incap_RT
                                        End
                                   Else 0
                              End -
                              
                              Tmp_p_Sueldos.Vacaciones As DiasReales,
                              --Case When Tmp_p_Sueldos.Vacaciones > 0 And IsNull(Vacaciones.Salio,'F') = 'T' And (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) = 0 Or (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) > 0 And IsNull(Vacaciones.Ordinaria,'F') = 'F')) Then Tmp_p_Sueldos.Vacaciones Else 0 End As DiasReales,
           Tmp_p_Sueldos.Descuento,
           (((Tmp_p_Sueldos.Sueldo * (Tmp_p_Sueldos.Dias - 
                               Case When @cMca108 = 'S' And CharIndex('F',@cAus27) > 0 Then Tmp_p_Sueldos.F108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               Case When @cMca108 = 'S' And CharIndex('P',@cAus27) > 0 Then Tmp_p_Sueldos.P108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               Case When @cMca108 = 'S' And CharIndex('S',@cAus27) > 0 Then Tmp_p_Sueldos.S108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               Case When @cMca108 = 'S' And CharIndex('T',@cAus27) > 0 Then Tmp_p_Sueldos.T108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               
                               Case When @cMca109 = 'S'
                                    Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_EG > 0
                                              Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'1',llaves.Empresa)
                                              Else Tmp_p_Sueldos.Incap_EG
                                         End
                                    Else 0
                               End -
                               Case When @cMca110 = 'S'
                                    Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_Mat > 0
                                              Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'2',llaves.Empresa)
                                              Else Tmp_p_Sueldos.Incap_Mat
                                         End
                                    Else 0
                               End -
                               Case When @cMca111 = 'S'
                                    Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_RT > 0
                                              Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'3',llaves.Empresa)
                                              Else Tmp_p_Sueldos.Incap_RT
                                         End
                                    Else 0
                               End -
                               
                               Tmp_p_Sueldos.Vacaciones)) -
                               --Case When Tmp_p_Sueldos.Vacaciones > 0 And IsNull(Vacaciones.Salio,'F') = 'T' And (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) = 0 Or (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) > 0 And IsNull(Vacaciones.Ordinaria,'F') = 'F')) Then Tmp_p_Sueldos.Vacaciones Else 0 End)) - 
                               Case When @cMca120 = 'S' Then (Select IsNull(Sum(k.Importe),0) 
                                                              From Kardex As k
                                                              Where k.Empresa     = llaves.Empresa          and 
                                                                    k.Codigo      = Tmp_p_Sueldos.Codigo and
                                                                    k.Nomina      = @cTipoNom          and 
                                                                    k.Num_Conc    = 120                and
                                                                    k.Fch_Inicio >= Tmp_p_Sueldos.Inicio and 
                                                                    k.Fch_Inicio <= Tmp_p_Sueldos.Termino)
                                                        Else 0 End)  * 
            Case When @nConcepto = 126 Then (IsNull(Tablas_Int.FdoAhoTraP,0) / 100) Else (IsNull(Tablas_Int.FdoAhoPatP,0) / 100) End) +
            (Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraI,0) Else IsNull(Tablas_Int.FdoAhoPatI,0) End *
           (Tmp_p_Sueldos.Dias - Case When @cMca108 = 'S' And CharIndex('F',@cAus27) > 0 Then Tmp_p_Sueldos.F108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               Case When @cMca108 = 'S' And CharIndex('P',@cAus27) > 0 Then Tmp_p_Sueldos.P108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               Case When @cMca108 = 'S' And CharIndex('S',@cAus27) > 0 Then Tmp_p_Sueldos.S108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               Case When @cMca108 = 'S' And CharIndex('T',@cAus27) > 0 Then Tmp_p_Sueldos.T108*Tmp_p_Sueldos.Descuento/100 Else 0 End -
                               
                               Case When @cMca109 = 'S'
                                    Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_EG > 0
                                              Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'1',llaves.Empresa)
                                              Else Tmp_p_Sueldos.Incap_EG
                                         End
                                    Else 0
                               End -
                               Case When @cMca110 = 'S'
                                    Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_Mat > 0
                                              Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'2',llaves.Empresa)
                                              Else Tmp_p_Sueldos.Incap_Mat
                                         End
                                    Else 0
                               End -
                               Case When @cMca111 = 'S'
                                    Then Case When Horarios_Catalogo.Semana_Red In ('S','T') And Tmp_p_Sueldos.Incap_RT > 0
                                              Then dbo.Fun_R_TipoAusencias(Tmp_p_Sueldos.Codigo,Tmp_p_Sueldos.Inicio,Tmp_p_Sueldos.Termino,Llaves.Horario,'3',llaves.Empresa)
                                              Else Tmp_p_Sueldos.Incap_RT
                                         End
                                    Else 0
                               End -
                               
                               Tmp_p_Sueldos.Vacaciones)) As Importe
                               --Case When Tmp_p_Sueldos.Vacaciones > 0 And IsNull(Vacaciones.Salio,'F') = 'T' And (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) = 0 Or (IsNull(Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant,0) > 0 And IsNull(Vacaciones.Ordinaria,'F') = 'F')) Then Tmp_p_Sueldos.Vacaciones Else 0 End )) As Importe
    From Tmp_p_Sueldos
    Inner Join P_Empleados_Pres as Llaves On Tmp_p_Sueldos.Codigo = Llaves.Codigo And Llaves.Empresa = Tmp_p_Sueldos.Empresa and llaves.id_presup=@id_presup
    --Inner Join Empleados On Tmp_p_Sueldos.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa

    Inner Join Horarios_Catalogo On Horarios_Catalogo.Horario = Llaves.Horario And Horarios_Catalogo.Empresa = llaves.Empresa

    --Inner Join Tablas_Int On Llaves.Clase = Tablas_Int.Clase And Llaves.Empresa = Tablas_Int.Empresa And Convert(Int,Tablas_Int.Ayos) = Case When Case When @cRegPat In ('A100000000','Y431023410','A341146210') Then Convert(Int,(DateDiff(Day,Empleados.FchAntigua,Case When @cRegPat <> 'A341146210' Then @dFf Else @dCierre End)+1)/365)+1 Else Convert(Int,Round(DateDiff(Day,Empleados.FchAntigua,Case When @cRegPat <> 'A341146210' Then @dFf Else @dCierre End)/365,0)) End > 45 Then 45 Else Case When Case When @cRegPat In ('A100000000','Y431023410') Then Convert(Int,(DateDiff(Day,Empleados.FchAntigua,@dFf)+1)/365)+1 Else Convert(Int,Round(DateDiff(Day,Empleados.FchAntigua,Case When @cRegPat <> 'A341146210' Then @dFf Else @dCierre End)/365,0)) End < 1 Then 1 Else Case When @cRegPat In ('A100000000','Y431023410') Then Convert(Int,(DateDiff(Day,Empleados.FchAntigua,@dFf)+1)/365)+1 Else Convert(Int,Round(DateDiff(Day,Empleados.FchAntigua,Case When @cRegPat <> 'A341146210' Then @dFf Else @dCierre End)/365,0)) End End End And Tablas_Int.Mes_Operacion = Month(@dFechaTab) And Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

    Inner Join p_Tablas_Int as  Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                             Tablas_Int.id_presup = @id_presup and 
							 Llaves.Empresa = Tablas_Int.Empresa And
                             Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                 Then 45
                                                                 Else Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                           Then 1
                                                                           Else Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                      End
                                                            End And
                             Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                             Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

    Left Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
    Left Join (Select empresa,Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase  And Conceptos27.Empresa = llaves.Empresa
    
    --Left Join Vacaciones On Vacaciones.Codigo = Tmp_p_Sueldos.Codigo And Vacaciones.Empresa = @nEmpresa
    
    Where (Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraI Else Tablas_Int.FdoAhoPatI End > 0 Or Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraP Else Tablas_Int.FdoAhoPatP End > 0) And
          Conceptos.Uso = 'S' And 
          (Conceptos27.Variable1 <> 'MENSUAL' Or
          (Conceptos27.Variable1 = 'MENSUAL' And
          ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                         Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End))) And
          Tmp_p_Sueldos.Dias >= Tmp_p_Sueldos.Vacaciones                         
    )       
    --


    -- Insertar los registros de Vacaciones por separado, porque cuando amparan mas dias de los del periodo
    -- no los considera... el select de arriba, solo debe considerar los dias de sdo. - ausentismo
    Insert Into dbo.Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
    (
    Select Kardex.empresa,
		   Kardex.Codigo,
           Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
           Kardex.Impor_Base,
           Kardex.SalDiaInt,
           Case When Horarios_Catalogo.Semana_Red In ('T','S') Then Kardex.Varia1 Else Kardex.Dias End As DiasTr,
           Case When Horarios_Catalogo.Semana_Red In ('T','S') Then Kardex.Varia1 Else Kardex.Dias End As Dias,
           0 As Inc,
           0 As Aus,
           Kardex.Dias As DiasReales,
           0 As Descuento,
           ((Kardex.Impor_Base * Case When @nConcepto = 126 Then (IsNull(Tablas_Int.FdoAhoTraP,0) / 100) Else (IsNull(Tablas_Int.FdoAhoPatP,0) / 100) End) +
                                 Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraI,0) Else IsNull(Tablas_Int.FdoAhoPatI,0) End) *
           Case When Horarios_Catalogo.Semana_Red In ('T','S') Then Kardex.Varia1 Else Kardex.Dias End As Importe
    From p_Kardex as Kardex
    Inner Join P_Empleados_Pres as Llaves On Kardex.Codigo = Llaves.Codigo And Llaves.Empresa = Kardex.Empresa and llaves.id_presup=@id_presup
    Inner Join Horarios_Catalogo On Horarios_Catalogo.Horario = Llaves.Horario And Horarios_Catalogo.Empresa = Llaves.Empresa
    Inner Join p_Tablas_Int as  Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                             Tablas_Int.id_presup=@id_presup and 
							 Llaves.Empresa = Tablas_Int.Empresa And
                             Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                 Then 45
                                                                 Else Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                           Then 1
                                                                           Else Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                      End
                                                            End And
                             Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                             Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

    Left Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
    Left Join (Select Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase, Conceptos.Empresa From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase AND Conceptos27.empresa = llaves.empresa

    --Left Join Vacaciones On Vacaciones.Codigo = Kardex.Codigo And Vacaciones.Empresa = Kardex.Empresa

    Where (Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraI Else Tablas_Int.FdoAhoPatI End > 0 Or Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraP Else Tablas_Int.FdoAhoPatP End > 0) And
          Conceptos.Uso = 'S' And 
          (Conceptos27.Variable1 <> 'MENSUAL' Or
          (Conceptos27.Variable1 = 'MENSUAL' And
          ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                         Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End))) And
                         
          -- 10 Julio del 2012
          -- Se agrego la condicion de que Tipo_Mov sea diferente de 'FIN'... porque si agregan los saldos al finiquito, al recalcular
          -- la nomina, estaba considerando el concepto 30 del finiquito y ya no cuadraba con el saldo.
          -- Si quieren considerar las vacaciones del finiquito, para el calculo del fondo...en la pantalla de finiquitos
          -- existe la opcion de calcular "Prestaciones sobre vacaciones", se debe usar esa opcion.
          Kardex.Num_Conc = 30 And
          Kardex.Tipo_Mov <> 'FIN' And
          --
          
          Kardex.Nomina = @cTipoNom And
          
          --((Vacaciones.Fch_Pago >= @dInicio And Vacaciones.Fch_Pago <= @dCierre) Or Vacaciones.Fch_Pago = @dPago) And
          --Vacaciones.Ordinaria = 'T' And
          --Vacaciones.Salio = 'T' And
          --Vacaciones.Dias_Disfr+Vacaciones.Disf_Ant > 0 And
          
          Kardex.id_presup = @id_presup
		  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    )


    -- Si el fondo es MENSUAL, buscar los registros de vacaciones anteriores
    -- Insertar los registros de Vacaciones por separado, porque cuando amparan mas dias de los del periodo
    -- no los considera... el select de arriba, solo debe considerar los dias de sdo. - ausentismo
    Insert Into dbo.Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
    (
    Select Kardex_Anual.empresa,
		   Kardex_Anual.Codigo,
           Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
           Kardex_Anual.Impor_Base,
           Kardex_Anual.SalDiaInt,
           Case When Horarios_Catalogo.Semana_Red In ('T','S') Then Kardex_Anual.Varia1 Else Kardex_Anual.Dias End As DiasTr,
           Case When Horarios_Catalogo.Semana_Red In ('T','S') Then Kardex_Anual.Varia1 Else Kardex_Anual.Dias End As Dias,
           0 As Inc,
           0 As Aus,
           Kardex_Anual.Dias As DiasReales,
           0 As Descuento,
           ((Kardex_Anual.Impor_Base * Case When @nConcepto = 126 Then (IsNull(Tablas_Int.FdoAhoTraP,0) / 100) Else (IsNull(Tablas_Int.FdoAhoPatP,0) / 100) End) +
                                       Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraI,0) Else IsNull(Tablas_Int.FdoAhoPatI,0) End) *
           Kardex_Anual.Dias As Importe
    From Kardex_Anual
    Inner Join P_Empleados_Pres as  Llaves On Kardex_Anual.Codigo = Llaves.Codigo And Llaves.Empresa = Kardex_Anual.Empresa and llaves.id_presup=@id_presup
    --Inner Join Empleados On Kardex_Anual.Codigo = Empleados.Codigo And Empleados.Empresa = Kardex_Anual.Empresa
    Inner Join p_Tablas_Int as Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                             Llaves.Empresa = Tablas_Int.Empresa And
							 Tablas_Int.id_presup=@id_presup and 
                             Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                 Then 45
                                                                 Else Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                           Then 1
                                                                           Else Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                      End
                                                            End And
                             Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                             Tablas_Int.Ayo_Operacion = Year(@dFechaTab)
    Left Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
    Left Join (Select Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase, Conceptos.Empresa From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase And Conceptos27.Empresa = Llaves.Empresa
    Inner Join Horarios_Catalogo On Horarios_Catalogo.Horario = Llaves.Horario And Horarios_Catalogo.Empresa = Llaves.Empresa
    Where (Case When @nConcepto = 126 
                Then Tablas_Int.FdoAhoTraI 
                Else Tablas_Int.FdoAhoPatI 
           End > 0 Or 
           Case When @nConcepto = 126 
                Then Tablas_Int.FdoAhoTraP 
                Else Tablas_Int.FdoAhoPatP 
           End > 0) And
          Conceptos.Uso = 'S' And 
          Conceptos27.Variable1 = 'MENSUAL' And
          ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) 
                         Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) 
                                    Then 'PAGA'
                                    Else '' 
                               End)
                         Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) 
                                    Then 'PAGA' 
                                    Else '' 
                               End) 
                    End) And
          Kardex_Anual.Num_Conc = 30 And
          Kardex_Anual.Nomina In ('ORD','VAC') And
          Kardex_Anual.Tipo_Mov <> 'FIN' And
          Kardex_Anual.Fch_Pago BetWeen IsNull(Conceptos27.Fecha1,@dFi) And IsNull(Conceptos27.Fecha2,@dFf) And
          Kardex_Anual.Empresa in(select empresa from P_empresas where id_presup=@id_Presup)
    )
    --


    -- Percepciones y Deducciones que afectan fondo de ahorro, siempre y cuando sea en %
    Insert Into dbo.Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
    (
    Select Kardex.empresa,
		   Kardex.Codigo,
           Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
           --@dInicio As Fch_Inicio,
           --@dCierre As Fch_Cierre,
           Sum(Kardex.Importe) As Impor_Base, ---Max(IsNull(KardexDed.Importe,0)) As Impor_Base,
           0 As SalDiaInt,
           0 As DiasTr,
           0 As Dias,
           0 As Inc,
           0 As Aus,
           0 As DiasReales,
           0 As Descuento,
           --(Sum(Kardex.Importe)-Max(IsNull(KardexDed.Importe,0))) * Max(Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraP,0) Else IsNull(Tablas_Int.FdoAhoPatP,0) End) / 100 As Importe
           Sum(Kardex.Importe) * Max(Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraP,0) Else IsNull(Tablas_Int.FdoAhoPatP,0) End) / 100 As Importe
    From p_Kardex as Kardex
    Inner Join P_Empleados_Pres as Llaves On Kardex.Codigo = Llaves.Codigo And Llaves.Empresa = kardex.Empresa and Llaves.id_presup=@id_presup
    Inner Join p_Tablas_Int as Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                             Llaves.Empresa = Tablas_Int.Empresa And
							 Tablas_Int.id_presup=@id_presup and 
                             Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                 Then 45
                                                                 Else Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                           Then 1
                                                                           Else Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                      End
                                                            End And
                             Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                             Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

    Inner Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
    Inner Join (Select empresa,Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase and Conceptos27.Empresa = llaves.empresa

    Where Kardex.Nomina = @cTipoNom And 
          Kardex.TPago_Desc = 'P' And
          Kardex.Num_Conc > 7 And
          Kardex.Num_Conc <> 30 And
          Kardex.FdoAhorro = 'S' And
          Kardex.Tipo_Mov <> 'FIN' And
          (Kardex.Num_Conc Not In (18,19,20,21,22,23,24,25,26) Or (@cRegPat = '1308606310' And Kardex.Num_Conc = 19)) And
          Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraP Else Tablas_Int.FdoAhoPatP End > 0 And
          Conceptos.Uso = 'S' And
          (Conceptos27.Variable1 <> 'MENSUAL' Or
          (Conceptos27.Variable1 = 'MENSUAL' And
          ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                         Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End))) And
          Kardex.id_presup = @id_presup
		  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    Group By Kardex.empresa,Kardex.Codigo
    )

    Insert Into dbo.Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
    (
    Select Kardex.empresa,
		   Kardex.Codigo,
           Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
           --@dInicio As Fch_Inicio,
           --@dCierre As Fch_Cierre,
           Sum(Kardex.Importe) As Impor_Base,
           0 As SalDiaInt,
           0 As DiasTr,
           0 As Dias,
           0 As Inc,
           0 As Aus,
           0 As DiasReales,
           0 As Descuento,
           0-Sum(Kardex.Importe) * Max(Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraP,0) Else IsNull(Tablas_Int.FdoAhoPatP,0) End) / 100 As Importe
    From p_Kardex as Kardex
    Inner Join P_Empleados_Pres as  Llaves On Kardex.Codigo = Llaves.Codigo And Llaves.Empresa =Kardex.Empresa and llaves.id_presup=@id_presup
    Inner Join p_Tablas_Int as Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                             Llaves.Empresa = Tablas_Int.Empresa And
							 Tablas_Int.id_presup=@id_presup and 
                             Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                 Then 45
                                                                 Else Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                           Then 1
                                                                           Else Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                      End
                                                            End And
                             Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                             Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

    Inner Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
    Inner Join (Select empresa,Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase and Conceptos27.empresa = Llaves.empresa
    Where Kardex.Nomina = @cTipoNom And
          Kardex.TPago_Desc = 'D' And
          (Kardex.Num_Conc < 107 Or Kardex.Num_Conc > 111) And
          Kardex.Num_Conc <> 120 And
          Kardex.FdoAhorro = 'S' And
          Kardex.Tipo_Mov <> 'FIN' And
          Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraP Else Tablas_Int.FdoAhoPatP End > 0 And
          Conceptos.Uso = 'S' And
          (Conceptos27.Variable1 <> 'MENSUAL' Or
          (Conceptos27.Variable1 = 'MENSUAL' And
          ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                         Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End))) And
          Kardex.id_presup = @id_presup
		  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    Group By Kardex.empresa,Kardex.Codigo
    )
    --


    -- Ajustes de sueldo con el concepto 7
    If (Select Count(Num_Conc) From Conceptos Where Num_Conc = 7 And Uso = 'S' And FdoAhorro = 'S' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) > 0
      Begin
        Insert Into dbo.Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
        (
        Select Kardex.empresa,
			   Kardex.Codigo,
               Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
               --@dInicio As Fch_Inicio,
               --@dCierre As Fch_Cierre,
               Kardex.Impor_Base,
               Kardex.SalDIaInt,
               Kardex.Dias As DiasTr,
               Kardex.Dias,
               0 As Inc,
               0 As Aus,
               Kardex.Dias As DiasReales,
               0 As Descuento,
               Kardex.Dias * Case When @nConcepto = 126 Then ((Kardex.Impor_Base * (IsNull(Tablas_Int.FdoAhoTraP,0)/100))+IsNull(Tablas_Int.FdoAhoTraI,0))
                                                        Else ((Kardex.Impor_Base * (IsNull(Tablas_Int.FdoAhoPatP,0)/100))+IsNull(Tablas_Int.FdoAhoPatI,0)) End As Importe
        From p_Kardex as Kardex
        Inner Join P_Empleados_Pres as  Llaves On Kardex.Codigo = Llaves.Codigo And Llaves.Empresa = Kardex.Empresa and llaves.id_presup = @id_presup
        Inner Join p_Tablas_Int as Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                                 Llaves.Empresa = Tablas_Int.Empresa And
								 Tablas_Int.id_presup=@id_presup and 
                                 Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                     Then 45
                                                                     Else Case When Convert(Int,(DateDiff(Day,llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                               Then 1
                                                                               Else Convert(Int,(DateDiff(Day,Llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                          End
                                                                End And
                                 Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                                 Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

        Inner Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = Tablas_Int.Empresa
        Inner Join (Select empresa,Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase and Conceptos27.empresa = Llaves.empresa
        Where Kardex.Nomina = @cTipoNom And
              Kardex.Num_Conc = 7 And
              Kardex.id_presup = @id_presup And
			  kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo and 
              (Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraI Else Tablas_Int.FdoAhoPatI End > 0 Or Case When @nConcepto = 126 Then Tablas_Int.FdoAhoTraP Else Tablas_Int.FdoAhoPatP End > 0) And
              Conceptos.Uso = 'S' And
              (Conceptos27.Variable1 <> 'MENSUAL' Or
              (Conceptos27.Variable1 = 'MENSUAL' And
              ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                             Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End)))
        )
      End
    --


    -- Ajustes de sueldo con el concepto 107
    If (Select Count(Num_Conc) From Conceptos Where Num_Conc = 107 And Uso = 'S' And FdoAhorro = 'S' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) > 0
      Begin
        Insert Into Tmp_p_Fondo (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe)
        (
        Select Kardex.empresa,
			   Kardex.Codigo,
               Case When @nConcepto = 126 Then @nConcepto Else 27 End As Num_Conc,
               --@dInicio As Fch_Inicio,
               --@dCierre As Fch_Cierre,
               Kardex.Impor_Base,
               Kardex.SalDIaInt,
               0-Kardex.Dias As DiasTr,
               0-Kardex.Dias,
               0 As Inc,
               0 As Aus,
               0-Kardex.Dias As DiasReales,
               0 As Descuento,
               0 - (Kardex.Dias * ((Kardex.Impor_Base * ( Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraP,0) Else IsNull(Tablas_Int.FdoAhoPatP,0) End/100))+Case When @nConcepto = 126 Then IsNull(Tablas_Int.FdoAhoTraI,0) Else IsNull(Tablas_Int.FdoAhoPatI,0) End)) As Importe
        From p_Kardex as Kardex
        Inner Join P_Empleados_Pres as  Llaves On Kardex.Codigo = Llaves.Codigo And Llaves.Empresa = Kardex.Empresa and llaves.id_presup=@id_presup
        Inner Join p_Tablas_Int as Tablas_Int On Llaves.Clase = Tablas_Int.Clase And
                                 Llaves.Empresa = Tablas_Int.Empresa And
								 Tablas_Int.id_presup=@id_presup and 
                                 Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,(DateDiff(Day,Llaves.FchAntigua,@dLimiteTab)+1)/365)+1 > 45
                                                                     Then 45
                                                                     Else Case When Convert(Int,(DateDiff(Day,Llaves.FchAntigua,@dLimiteTab)+1)/365)+1 < 1
                                                                               Then 1
                                                                               Else Convert(Int,(DateDiff(Day,Llaves.FchAntigua,@dLimiteTab)+1)/365)+1
                                                                          End
                                                                End And
                                 Tablas_Int.Mes_Operacion = Month(@dFechaTab) And
                                 Tablas_Int.Ayo_Operacion = Year(@dFechaTab)

        Inner Join Conceptos On Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
        Inner Join (Select empresa,Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase From Conceptos Where Conceptos.Num_Conc = Case When @nConcepto = 126 Then @nConcepto Else 27 End) As Conceptos27 On Conceptos27.Clase = Llaves.Clase and Conceptos27.empresa = Llaves.empresa
        Where Kardex.Nomina = @cTipoNom And
              Kardex.Num_Conc = 107 And
              Kardex.id_presup = @id_presup And
			  kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo and 
              (Tablas_Int.FdoAhoPatI > 0 Or Tablas_Int.FdoAhoPatP > 0) And
              Conceptos.Uso = 'S' And
              (Conceptos27.Variable1 <> 'MENSUAL' Or
              (Conceptos27.Variable1 = 'MENSUAL' And
              ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                             Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End)))
        )
      End
      --

    Set @nConcepto = @nConcepto + 1

  End


-- Sumar totales por concepto, para agregar uno solo al kardex
Select  Tmp_p_Fondo.empresa,
		Tmp_p_Fondo.Codigo,
       Tmp_p_Fondo.Num_Conc,
       --Min(Tmp_p_Fondo.Fch_Inicio) As Fch_Inicio,
       --Max(Tmp_p_Fondo.Fch_Cierre) As Fch_Cierre,
       Max(Llaves.Sueldo) As Impor_Base,
       Max(Llaves.SalDiaInt) As SalDiaInt,
       Sum(Tmp_p_Fondo.DiasTr) As DiasTr,
       Sum(Tmp_p_Fondo.Dias) As Dias,
       Sum(Tmp_p_Fondo.Inc) As Inc,
       Sum(Tmp_p_Fondo.Aus) As Aus,
       Sum(Tmp_p_Fondo.DiasReales) As DiasReales,
       Max(Tmp_p_Fondo.Descuento) As Descuento,
       --Round(Sum(Tmp_p_Fondo.Importe),2) As Importe
       Case When Max(Conceptos.Marca2) = 'T' And Round(Sum(Tmp_p_Fondo.Importe),2) > ( Round(IsNull(@nUma,@nSalMin) * 10.00 * 0.13,2) * Sum(Tmp_p_Fondo.DiasReales)) Then ( Round(IsNull(@nUma,@nSalMin) * 10 * 0.13,2) * Sum(Tmp_p_Fondo.DiasReales)) Else Round(Sum(Tmp_p_Fondo.Importe),2) End As Importe,
       CONVERT(NUMERIC(10,2),0) As IExento
Into dbo.Tmp_p_FdoTotal
From Tmp_p_Fondo
--Inner Join Empleados On Tmp_p_Fondo.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa
Inner Join P_Empleados_Pres as  Llaves    On Tmp_p_Fondo.Codigo = Llaves.Codigo And Llaves.Empresa = Tmp_p_Fondo.Empresa and llaves.id_presup=@id_presup
Inner Join Conceptos On Conceptos.Num_Conc = Tmp_p_Fondo.Num_Conc And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = llaves.Empresa
Where Tmp_p_Fondo.Importe <> 0 Or Tmp_p_Fondo.Dias <> 0
Group By Tmp_p_Fondo.empresa,Tmp_p_Fondo.Codigo,Tmp_p_Fondo.Num_Conc
Order By Tmp_p_Fondo.Codigo,Tmp_p_Fondo.Num_Conc
--


-- Si tiene la marca de topar al 13% de 10 sm, checar los que exceden
/*
Update Tmp_p_FdoTotal Set Importe = Case When Conceptos.Marca2 = 'T' And Tmp_p_FdoTotal.Importe > (@nSalMin * 10 * 0.13 * Tmp_p_FdoTotal.Diasreales) Then (@nSalMin * 10 * 0.13 * Tmp_p_FdoTotal.Diasreales) Else Tmp_p_FdoTotal.Importe End
From Tmp_p_FdoTotal
Inner Join Llaves On Tmp_p_FdoTotal.Codigo = Llaves.Codigo And Llaves.Empresa = @nEmpresa
Inner Join Conceptos On Conceptos.Num_Conc = Tmp_p_FdoTotal.Num_Conc And Conceptos.Clase = Llaves.Clase And Conceptos.Empresa = @nEmpresa
*/
--


-- Para Naosa, redondear el Fdo. a pesos
If @cRegPat In ('R121858010','C167560510','R125154110','Z293771510','Z293771310','Z294139110') OR @cRfcPat = 'TPA061005QB3'
  UpDate Tmp_p_FdoTotal
  Set Importe = Convert(Int,Importe)
--

-- Si tiene en uso el concepto 127, agregar una copia de los conceptos 27 con el numero 127
Insert Into Tmp_p_FdoTotal (empresa,Codigo,Num_Conc,Impor_Base,SalDiaInt,DiasTr,Dias,Inc,Aus,DiasReales,Descuento,Importe,IExento)
(
Select Tmp_p_FdoTotal.empresa,
	   Tmp_p_FdoTotal.Codigo,
       127 As Num_Conc,
       --Tmp_p_FdoTotal.Fch_Inicio,
       --Tmp_p_FdoTotal.Fch_Cierre,
       Tmp_p_FdoTotal.Impor_Base,
       Tmp_p_FdoTotal.SalDiaInt,
       Tmp_p_FdoTotal.DiasTr,
       Tmp_p_FdoTotal.Dias,
       Tmp_p_FdoTotal.Inc,
       Tmp_p_FdoTotal.Aus,
       Tmp_p_FdoTotal.DiasReales,
       Tmp_p_FdoTotal.Descuento,
       Tmp_p_FdoTotal.Importe,
       0 As IExento
From Tmp_p_FdoTotal
Inner Join P_Empleados_Pres as Llaves On Tmp_p_FdoTotal.Codigo = Llaves.Codigo And Llaves.Empresa = Tmp_p_FdoTotal.Empresa and llaves.id_presup=@id_presup
Inner Join Conceptos On Conceptos.Num_Conc = 127 And Conceptos.Clase = ' ' And Conceptos.Empresa = llaves.Empresa
Inner Join (Select empresa,Conceptos.Hrs_Min1, Conceptos.Fecha1, Conceptos.Fecha2, Conceptos.Variable1 As Variable1, Conceptos.Clase As Clase From Conceptos Where Conceptos.Num_Conc = 27) As Conceptos27 On Conceptos27.Clase = Llaves.Clase and Conceptos27.empresa = Llaves.empresa
Where Tmp_p_FdoTotal.Num_Conc = 27 And 
      Conceptos.Uso = 'S' And 
      (Conceptos27.Variable1 <> 'MENSUAL' Or
       (Conceptos27.Variable1 = 'MENSUAL' And
       ('PAGA' = Case When Month(@dInicio) = Month(@dCierre) Then (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) And Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End)
                      Else (Case When Conceptos27.Hrs_Min1 >= Day(@dInicio) Or Conceptos27.Hrs_Min1 <= Day(@dCierre) Then 'PAGA' Else '' End) End)))
)
--


Declare @cExiste126 Char(1)
Declare @cExiste127 Char(1)

Set @cExiste126 = Case When Exists(Select Num_Conc From Tmp_p_FdoTotal Where Num_Conc = 126) Then 'S' Else 'N' End
Set @cExiste127 = Case When Exists(Select Num_Conc From Tmp_p_FdoTotal Where Num_Conc = 127) Then 'S' Else 'N' End


Update Tmp_p_FdoTotal
Set IExento =  Round(Case When Tmp_p_FdoTotal.Num_Conc <> 27 Or Tmp_p_FdoTotal.Importe <= Tmp_p_FdoTotal.DiasReales * Round(IsNull(@nUma,@nSalMin) * 10.00 * 0.13,2) Then Tmp_p_FdoTotal.Importe Else Tmp_p_FdoTotal.DiasReales * IsNull(@nUma,@nSalMin) * 10 * 0.13 End,2)


-- Generar un kardex temporal para llenar el campo FOLIO, la rutina lo requiere ordenado por codigo
Select Tmp_p_FdoTotal.Codigo,
       Tmp_p_FdoTotal.Empresa As Empresa,
       @cTipoNom As Nomina,
       ' ' As Centro,
       Tmp_p_FdoTotal.Num_Conc,
       Case When Tmp_p_FdoTotal.Num_Conc <> 127 Then Llaves.Clase Else ' ' End As Clase,
       0 As Folio,
       0 As Renglon,
       @dInicio As Fch_Inicio,
       @dCierre As Fch_Cierre,
       @dPago As Fch_Pago,
       Tmp_p_FdoTotal.DiasTr As Dias,  --Tmp_p_FdoTotal.Dias,
       Tmp_p_FdoTotal.Inc,
       Tmp_p_FdoTotal.Aus,
       Tmp_p_FdoTotal.DiasTr,
       0 As Dias_Imss,
       Case When Tmp_p_FdoTotal.Num_Conc < 100 Then 'P' Else 'D' End As TPago_Desc,
       Conceptos.Concepto,
       Case When @cRegPat In ('0407407810','B901592910','5501198410','8301375610','E741243110','8401627210','L013704310','E753836710','8401564610','R142854310','B983076510','R142972110','A481766710','A102803610','R125925010','B691406410') -- Para Radial integrar el fdo.
            Then Tmp_p_FdoTotal.Importe
       Else 0 End As VariaImss,
       0 As Variable,
       IsNull(Conceptos.Imss,'N') As Imss,
       IsNull(Conceptos.Ispt,'N') As Ispt,
       IsNull(Conceptos.Ptu,'N') As Ptu,
       IsNull(Conceptos.Despensa,'N') As Despensa,
       IsNull(Conceptos.Mca_Agui,'N') As Mca_Agui,
       IsNull(Conceptos.FdoAhorro,'N') As FdoAhorro,
       'A' As Calculo,
       llaves.Sueldo As Impor_Base,
       llaves.SalDiaInt,
       0 As Tabulador,
       0 As Unidades,
       0 As Horas,
       'TAB' As Tipo_Mov,
       0 As Secuencia,
       Tmp_p_FdoTotal.Importe,

       Tmp_p_FdoTotal.Importe - Tmp_p_FdoTotal.IExento As IGravable, --Case When Tmp_p_FdoTotal.Num_Conc <> 27 Or Tmp_p_FdoTotal.Importe <= Tmp_p_FdoTotal.DiasReales * Round(IsNull(@nUma,@nSalMin) * 10.00 * 0.13,2) Then 0 Else Tmp_p_FdoTotal.Importe - (Tmp_p_FdoTotal.DiasReales * IsNull(@nUma,@nSalMin) * 10 * 0.13) End As IGravable,
       Tmp_p_FdoTotal.IExento As IExento, --Case When Tmp_p_FdoTotal.Num_Conc <> 27 Or Tmp_p_FdoTotal.Importe <= Tmp_p_FdoTotal.DiasReales * Round(IsNull(@nUma,@nSalMin) * 10.00 * 0.13,2) Then Tmp_p_FdoTotal.Importe Else Tmp_p_FdoTotal.DiasReales * IsNull(@nUma,@nSalMin) * 10 * 0.13 End As IExento,
       0 As Credito,
       0 As Descuento,
       Case When Tmp_p_FdoTotal.Num_Conc > 100 Then IsNull(Acum_Conc.Acu_Recibo,0)-IsNull(Retiros.Retiro/Case When @cExiste126 = 'S' And @cExiste127 = 'S' Then 2 Else 1 End,0) Else 0 End As Saldo,
       ' ' As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       IsNull(Conceptos.PrevSocial,'N') As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       ' ' As Formula,
       ' ' As Ispt_NG,
       ' ' As Imss_NI,
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo
Into dbo.Tmp_p_Kardex
From Tmp_p_FdoTotal
--Inner Join Empleados On Tmp_p_FdoTotal.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa
Inner Join P_Empleados_Pres as Llaves    On Tmp_p_FdoTotal.Codigo = Llaves.Codigo And Llaves.Empresa = Tmp_p_FdoTotal.Empresa  and llaves.id_presup = @id_presup
Inner Join Conceptos On Tmp_p_FdoTotal.Num_Conc = Conceptos.Num_Conc And Conceptos.Clase = Case When Tmp_p_FdoTotal.Num_Conc <> 127 Then Llaves.Clase Else ' ' End And Conceptos.Empresa = llaves.Empresa
Left Join Acum_Conc  On Tmp_p_FdoTotal.Codigo = Acum_Conc.Codigo And Tmp_p_FdoTotal.Num_Conc = Acum_Conc.Num_Conc And Acum_Conc.Empresa = llaves.Empresa And Acum_Conc.Ejercicio = Year(@dPago)

Left Join (Select empresa,
				  Codigo,
                  Sum(Credito) As Retiro
           From Prestamos_De_Fondo
           Where Retiro = 'S'
           Group By empresa,Codigo) As Retiros On Retiros.Codigo = Tmp_p_FdoTotal.Codigo and Retiros.empresa = Tmp_p_FdoTotal.empresa

Where Tmp_p_FdoTotal.Importe > 0
Order By Tmp_p_FdoTotal.Codigo,Tmp_p_FdoTotal.Num_Conc


-- Determinar los folios para la insercion en el kardex
--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Kardex','Folio',0,0
----


-- Pasar los registros al kardex real
Insert Into p_Kardex (Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago, Dias, Inc, Aus,
                    DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro,
                    Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento,
                    Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                    Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo,id_presup,mes_operacion,ayo_operacion)

Select Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago, Dias, Inc, Aus,
                    DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro,
                    Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento,
                    Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                    Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo,
					@id_presup,@mes,@ayo
From Tmp_p_Kardex

--


Drop Table dbo.Tmp_p_Fondo
Drop Table dbo.Tmp_p_FdoTotal
Drop Table dbo.Tmp_p_Kardex
Drop Table dbo.Tmp_p_Sueldos

Drop Table dbo.Tmp_p_Avisos_Imss
--Drop Table dbo.Tmp_p_KardexVac

GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_formu_all')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_formu_all
GO

CREATE PROCEDURE dbo.asp_pres_formu_all
    @id_presup INT ,
    @ntiponom INT ,
    @nayo INT ,
    @nsalmin NUMERIC(12, 2) ,
    @nsaldf NUMERIC(12, 2) ,
    @cque_calcula CHAR(10) ,
    @nperiodo INT ,
    @cper_ded CHAR(3)
--@nresultado  int output
AS 
    SET nocount OFF


    DECLARE @nempresa INT

-- declaracion de variables para la tabla conceptos
    DECLARE @nnum_conc INT
    DECLARE @cclase CHAR(2)
    DECLARE @ccentro CHAR(15)
    DECLARE @cconcepto VARCHAR(30)
    DECLARE @cispt CHAR(1)
    DECLARE @cimss CHAR(1)
    DECLARE @cmca_agui CHAR(1)
    DECLARE @cptu CHAR(1)
    DECLARE @cdespensa CHAR(1)
    DECLARE @cfdoahorro CHAR(1)
    DECLARE @ccondicion1 CHAR(1)
    DECLARE @ccondicion2 CHAR(1)
    DECLARE @cformula VARCHAR(750)
    DECLARE @cformula2 VARCHAR(750)
    DECLARE @cispt_ng VARCHAR(750)
    DECLARE @cimss_ni VARCHAR(750)
    DECLARE @dfecha1 DATETIME
    DECLARE @dfecha2 DATETIME
    DECLARE @dfecha3 DATETIME
    DECLARE @nhrs_min1 NUMERIC(6, 2)
    DECLARE @nhrs_min2 NUMERIC(6, 2)
    DECLARE @nhrs_min3 NUMERIC(6, 2)
    DECLARE @nimporte1 NUMERIC(12, 2)
    DECLARE @nimporte2 NUMERIC(12, 2)
    DECLARE @nimporte3 NUMERIC(12, 2)
    DECLARE @nporciento1 NUMERIC(12, 2)
    DECLARE @nporciento2 NUMERIC(12, 2)
    DECLARE @nporciento3 NUMERIC(12, 2)
    DECLARE @cvariable1 VARCHAR(20)
    DECLARE @cvariable2 VARCHAR(20)
    DECLARE @cvariable3 VARCHAR(20)
    DECLARE @cvariable4 VARCHAR(20)
    DECLARE @cmarca1 CHAR(1)
    DECLARE @cmarca2 CHAR(1)
    DECLARE @ccondicion VARCHAR(750)
    DECLARE @ctotales VARCHAR(750)
    DECLARE @ctotales2 VARCHAR(750)
    DECLARE @ctotales3 VARCHAR(750)
    DECLARE @cprevsocial CHAR(1)
    DECLARE @carreglo1 VARCHAR(750)
    DECLARE @carreglo2 VARCHAR(750)
    DECLARE @cacumulado1 VARCHAR(750)
    DECLARE @cacumulado2 VARCHAR(750)
    DECLARE @cacumulado3 VARCHAR(750)
    DECLARE @ncod_for NUMERIC(12, 2)
    DECLARE @nfol_for INT

-- variables para el periodo de nomina a calcular
    DECLARE @dfchinicio DATETIME
    DECLARE @dfchcierre DATETIME
    DECLARE @dfchpago DATETIME
    DECLARE @cnomina CHAR(3)
    DECLARE @cestatus VARCHAR(5)
    DECLARE @cfchinicio CHAR(10)
    DECLARE @nfrecuencia INT
    DECLARE @ndiasper INT


--set @cestatus = char(39) + 'C' + char(39)


-- variable para detectar la nomina de despensa
-- cuando se paga en nomina NO ordinaria para el
-- total conceptos
    DECLARE @cconvales CHAR(1)
    DECLARE @cmarca1_des CHAR(1)
    DECLARE @cmarca2_des CHAR(1)
    DECLARE @ccaptura_des CHAR(1)
    DECLARE @ndia_des NUMERIC(6, 2)
    DECLARE @dfchtmp DATETIME
    SET @cconvales = 'N'
    SET @cmarca1_des = ' '
    SET @cmarca2_des = ' '
    SET @ccaptura_des = ' '
    SET @ndia_des = 0



-- Variables de trabajo
    DECLARE @cpago_desc CHAR(3)
    DECLARE @npercep NUMERIC(12, 2)
    DECLARE @npercept DECIMAL(12, 2)
    DECLARE @ndeducc NUMERIC(12, 2)
    DECLARE @nimporte NUMERIC(12, 2)
    DECLARE @csuma CHAR(3)
    DECLARE @cresta CHAR(3)
    DECLARE @cperiodo1 VARCHAR(20)
    DECLARE @cperiodo2 VARCHAR(20)
    DECLARE @csw CHAR(1)
    DECLARE @ncod_del NUMERIC(8)
    DECLARE @ncod_cond NUMERIC(8)
    DECLARE @ncodigo NUMERIC(8)
    DECLARE @nfolio INT
    DECLARE @nfol_tmp INT
--declare @nvaria1     decimal(12,4)
--declare @nvaria2     decimal(12,4)
--declare @nvaria3     decimal(12,4)
--declare @nvaria4     decimal(12,4)
    DECLARE @nposvar1 INT
    DECLARE @nposvar2 INT
    DECLARE @nposvar3 INT
    DECLARE @nposvar4 INT
    DECLARE @cclaseg CHAR(3)
    DECLARE @ccentrog CHAR(3)
    DECLARE @cnomina_gion VARCHAR(7)

--declare @nresultado  int output


--declare @ccap        char(1)
--declare @ccalcula    char(1)


    SET @npercep = 0
    SET @npercept = 0
    SET @ndeducc = 0
    SET @nimporte = 0
    SET @csuma = CHAR(39) + 'S' + CHAR(39)
    SET @cresta = CHAR(39) + 'R' + CHAR(39)
--set @nvaria1  = 0
--set @nvaria2  = 0
--set @nvaria3  = 0
--set @nvaria4  = 0


    DECLARE @cpercep CHAR(1)
    DECLARE @cdeducc CHAR(1)

    DECLARE @cpercep2 CHAR(1)
    DECLARE @cdeducc2 CHAR(1)

    DECLARE @cpercep3 CHAR(1)
    DECLARE @cdeducc3 CHAR(1)

    DECLARE @cperacu1 VARCHAR(5)
    DECLARE @cdedacu1 VARCHAR(5)
    DECLARE @cperini1 CHAR(2)
    DECLARE @cperfin1 CHAR(2)
    DECLARE @cvaracu1 CHAR(15)
    DECLARE @cfldimp1 CHAR(15)
    DECLARE @cfldper1 CHAR(15)
    DECLARE @cfldded1 CHAR(15)
    DECLARE @cfldacu1 CHAR(15)
    DECLARE @ntotacu1 NUMERIC(12, 2)

    DECLARE @cperacu2 VARCHAR(5)
    DECLARE @cdedacu2 VARCHAR(5)
    DECLARE @cperini2 CHAR(2)
    DECLARE @cperfin2 CHAR(2)
    DECLARE @cvaracu2 CHAR(15)
    DECLARE @cfldimp2 CHAR(15)
    DECLARE @cfldper2 CHAR(15)
    DECLARE @cfldded2 CHAR(15)
    DECLARE @nperacu2 NUMERIC(12, 2)
    DECLARE @ndedacu2 NUMERIC(12, 2)
    DECLARE @cfldacu2 CHAR(15)
    DECLARE @ntotacu2 NUMERIC(12, 2)

    DECLARE @cperacu3 VARCHAR(5)
    DECLARE @cdedacu3 VARCHAR(5)
    DECLARE @cperini3 CHAR(2)
    DECLARE @cperfin3 CHAR(2)
    DECLARE @cvaracu3 CHAR(15)
    DECLARE @cfldimp3 CHAR(15)
    DECLARE @cfldper3 CHAR(15)
    DECLARE @cfldded3 CHAR(15)
    DECLARE @nperacu3 NUMERIC(12, 2)
    DECLARE @ndedacu3 NUMERIC(12, 2)
    DECLARE @cfldacu3 CHAR(15)
    DECLARE @ntotacu3 NUMERIC(12, 2)

    DECLARE @ctmp_tab11 VARCHAR(750)
    DECLARE @ctmp_tab12 VARCHAR(750)
    DECLARE @npos_tab11 INT
    DECLARE @npos_tab12 INT
    DECLARE @npos_tab13 INT
    DECLARE @nele_tab11 NUMERIC(12, 2)
    DECLARE @nele_tab12 NUMERIC(12, 2)
    DECLARE @cval_tab11 VARCHAR(20)
    DECLARE @nimp_tab NUMERIC(12, 2)
    DECLARE @nciclo INT

    DECLARE @ctmp_tab21 VARCHAR(500)
    DECLARE @ctmp_tab22 VARCHAR(500)
    DECLARE @npos_tab21 INT
    DECLARE @npos_tab22 INT
    DECLARE @npos_tab23 INT
    DECLARE @nele_tab21 NUMERIC(12, 2)
    DECLARE @nele_tab22 NUMERIC(12, 2)
    DECLARE @cval_tab21 VARCHAR(20)


    DECLARE @calias VARCHAR(10)
    DECLARE @empresaC INT

--declare @ntmp_dias decimal(6,2)
--set @ntmp_dias = 0


-- Incluido 24 de Octubre del 2007
-- Los Mayan Palace y Autocamiones de Chihuahua no pagan los premios de Puntualidad y Asistencia
-- sobre los conceptos de Vacaciones, ya que ellos tienen un tratamiento especial para el pago del concepto 30
    DECLARE @cesp37y38 CHAR(1)
    DECLARE @cregpat CHAR(10)

    SELECT  @cregpat = registro_patronal
    FROM    dbo.empresas
    WHERE   empresa = @nempresa


    SET @cesp37y38 = 'N'


    IF @cque_calcula IN ( 'ACSNTOT', 'ACCNTOTCI', 'ACCNTOTSI', 'ASC' )
        AND @cregpat IN ( '3301121210', '3309345610', '3302109910',
                          'A812073210', 'A839270310', 'Y771267910',
                          'A806357610', 'A807199710',  -- Reg. patronales de Autocamiones
                          'B613479810', 'B614331710', 'Y721331110',
                          'E701352310', 'E701283310', 'Y431263110',
                          'B982383910',               -- Reg. patronales del Mayan
                          'Y431163510', 'B982764710', 'Y431326210',
                          'M621750410', 'E701535210', 'B615400310',
                          'Y431415510', 'B615400310', 'Y721557510',
                          'E701535210', 'Y431415510', 'M621765610',
                          'S123456710', 'Y721715210', 'Y721799410',
                          'Y721798810', 'L015182910', 'Y721594110',
                          'Y721800410', 'L015289310' )                                         -- Reg. patronales de Barcelo
        SET @cesp37y38 = 'S'


    SET @cnomina = CASE @ntiponom
                     WHEN 1 THEN 'SEM'
                     WHEN 2 THEN 'DEC'
                     WHEN 3 THEN 'CAT'
                     WHEN 4 THEN 'QNA'
                     WHEN 5 THEN 'MES'
                     WHEN 6 THEN 'ESP'
                   END

    SET @cnomina_gion = CHAR(39) + @cnomina + CHAR(39)

    DECLARE @nMes INT


-- saca las fechas del periodo a calcular
    SELECT  @dfchinicio = inicio ,
            @dfchcierre = cierre ,
            @dfchpago = pago ,
            @nMes = mes ,
            @nAyo = ejercicio ,  --select * from p_dias
            @nDiasPer = Periodos.Dias
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup


    DECLARE @cMes CHAR(2) ,
        @cAyo AS CHAR(4)
    SET @cMes = CAST(@nMes AS CHAR(2))
    SET @cAyo = CAST(@nAyo AS CHAR(4))
--    PRINT @nMEs
--    PRINT @nAyo

    SET @nfrecuencia = ( SELECT MAX(Frecuencia)
                         FROM   dbo.Nominas
                         WHERE  TipoNom = @ntiponom
                                AND Empresa IN ( SELECT empresa
                                                 FROM   dbo.p_empresas
                                                 WHERE  id_presup = @id_presup )
                       )



    SET @cfchinicio = CHAR(39) + LTRIM(STR(YEAR(@dfchinicio)))
        + SUBSTRING(LTRIM(STR(100 + MONTH(@dfchinicio))), 2, 2)
        + SUBSTRING(LTRIM(STR(100 + DAY(@dfchinicio))), 2, 2) + CHAR(39)




    PRINT 'fecha inicio en caracter ' + @cfchinicio





-- variable para detectar la nomina de despensa
-- cuando se paga en nomina NO ordinaria para el
-- total conceptos
    SELECT  @cmarca1_des = b.marca1 ,
            @cmarca2_des = b.marca2 ,
            @ccaptura_des = b.captura ,
            @ndia_des = b.hrs_min1
    FROM    dbo.p_empresas AS a
            INNER JOIN dbo.conceptos AS b ON a.empresa = b.empresa
                                             AND a.id_presup = @id_presup
    WHERE   b.num_conc = 31

    IF @cmarca1_des = 'O' 
        SET @cconvales = 'N'
    ELSE 
        IF @cmarca2_des = 'P'
            OR @ccaptura_des = 'M' 
            SET @cconvales = 'S'
        ELSE 
            IF @cmarca2_des = 'M' 
                BEGIN
                    SET @cconvales = 'N'
                    SET @dfchtmp = @dfchinicio

                    WHILE @dfchtmp <= @dfchcierre 
                        BEGIN
                            IF @ndia_des = DAY(@dfchtmp) 
                                SET @cconvales = 'S'

                            SET @dfchtmp = @dfchtmp + 1
                        END
                END





-- solo temporal
-- mientras se hacen las pruebas
--delete kardex where folio = 0 and empresa = @nempresa



    IF OBJECT_ID('dbo.p_conc_tmp') IS NOT NULL 
        DROP TABLE dbo.p_conc_tmp


-- calculos :
-- 1.- Manuales siempre
-- 2.- Formulas automaticas con condicion sin la variable
--     ntotpercep o ntotcond
-- 3.- Formulas automaticas con condicion con la variable
--     ntotpercep o ntotcond y la marca ispt = 'S'
-- 4.- Formulas automaticas con condicion con la variable
--     ntotpercep o ntotcond y la marca ispt <> 'S'
-- 5.- Formulas automaticas sin condicion sin la variable
--     ntotpercep o ntotcond
-- 6.- Manuales sin marca siempre
-- 7.- calculo igual 'M'
--     Concepto del 1 al 18 excepto 10,11,12,13 y
--     101 al 138 excepto 107,108,109,110,111

-- 8.- provisiones 216

-- 1.-
-- Manuales siempre
    IF @cque_calcula = 'MS' 
        BEGIN

     --set @ccap = 'M'

            IF OBJECT_ID('dbo.p_conc_man') IS NOT NULL 
                DROP TABLE dbo.p_conc_man

            IF @cper_ded = 'P' 
                SELECT DISTINCT
                        c.empresa ,
                        c.num_conc ,
                        c.clase ,
                        c.centro --, p.codigo, p.folio  --, p.varia1, p.varia2, p.varia3, p.varia4
                INTO    dbo.p_conc_man
                FROM    dbo.p_empresas AS e
                        INNER JOIN dbo.conceptos AS c ON e.empresa = c.empresa
                                                         AND e.id_presup = @id_presup
                        INNER JOIN dbo.p_percepciones AS p ON p.id_presup = @id_presup
                                                              AND p.tiponom = @ntiponom
                                                              AND p.mes = @nperiodo
                                                              AND p.ayo_operacion = @nayo
                                                              AND
                                          --p.siempre       = 'S'        and --checar  --select * from p_percepciones
                                                              p.num_conc = c.num_conc
                                                              AND p.clase = c.clase
                                                              AND p.centro = c.centro
                                                              AND ( p.num_conc >= 39
                                                              AND p.num_conc <= 99
                                                              )
                WHERE   c.captura = 'M'
                        AND c.uso = 'S'
                        AND e.id_presup = @id_presup



     /*if @cper_ded = 'D'
        select distinct c.empresa, c.num_conc, c.clase, c.centro --, p.codigo, p.folio  --, p.varia1, p.varia2, p.varia3, p.varia4
        into dbo.p_conc_man
        from conceptos as c
        inner join deducciones as d on d.empresa       = @nempresa  and
                                       d.tiponom       = @ntiponom  and
                                       d.periodo       = @nperiodo  and
                                       d.ayo_operacion = @nayo      and
                                       d.siempre       = 'S'        and
                                       d.num_conc      = c.num_conc and
                                       d.clase         = c.clase    and
                                       d.centro        = c.centro   and
                                       (d.num_conc     >= 139        and
                                        d.num_conc     <= 199)
        where c.empresa = @nempresa and
              c.captura = 'M' and
              c.uso     = 'S'*/


--select * from p_conc_man



     --insert into p_conc_man (num_conc, clase, centro)  --, codigo, folio)  --, varia1, varia2, varia3, varia4)
     --                      select distinct d.num_conc, d.clase, d.centro --, d.codigo, d.folio   --, d.varia1, d.varia2, d.varia3, d.varia4
     --                      from deducciones as d
     --                      where d.empresa       = @nempresa and
     --                            d.tiponom       = @ntiponom and
     --                            d.periodo       = @nperiodo and
     --                            d.ayo_operacion = @nayo     and
     --                            d.siempre       = 'S'  and
     --                            (d.num_conc     >= 139 and
     --                             d.num_conc     <= 199)




--     select * from p_conc_man

            SELECT  c.empresa ,
                    c.num_conc ,
                    c.clase ,
                    c.centro ,
                    c.concepto ,
                    c.uso ,
                    c.ispt ,
                    c.imss ,
                    c.mca_agui ,
                    c.ptu ,
                    c.despensa ,
                    c.fdoahorro ,
                    c.captura ,
                    c.condicion1 ,
                    c.condicion2 ,
                    c.formula ,
                    c.formula2 ,
                    c.ispt_ng ,
                    c.imss_ni ,
                    c.fecha1 ,
                    c.fecha2 ,
                    c.fecha3 ,
                    c.hrs_min1 ,
                    c.hrs_min2 ,
                    c.hrs_min3 ,
                    c.importe1 ,
                    c.importe2 ,
                    c.importe3 ,
                    c.porciento1 ,
                    c.porciento2 ,
                    c.porciento3 ,
                    c.variable1 ,
                    c.variable2 ,
                    c.variable3 ,
                    c.variable4 ,
                    c.marca1 ,
                    c.marca2 ,
                    c.condicion ,
                    c.totales ,
                    c.totales2 ,
                    c.totales3 ,
                    c.prevsocial ,
                    c.arreglo1 ,
                    c.arreglo2 ,
                    c.acumulado1 ,
                    c.acumulado2 ,
                    c.acumulado3
            --cm.codigo,
            --cm.folio
            INTO    dbo.p_conc_tmp
            FROM    dbo.p_empresas AS e
                    INNER JOIN dbo.conceptos AS c ON e.empresa = c.empresa
                                                     AND e.id_presup = @id_presup
                    INNER JOIN dbo.p_conc_man AS cm ON cm.num_conc = c.num_conc
                                                       AND cm.clase = c.clase
                                                       AND cm.centro = c.centro
            WHERE   c.captura = 'M'
                    AND c.uso = 'S'
            ORDER BY c.num_conc ,
                    c.clase ,
                    c.centro

--     select * from dbo.p_conc_tmp
        END
-- 2.-
-- Para formulas Automaticas con condicion
-- sin ntotpercep o ntotcond
    IF @cque_calcula = 'ACSNTOT' 
        BEGIN

            SELECT  *
            INTO    dbo.p_conc_tmp
            FROM    dbo.conceptos AS c
            WHERE   c.empresa IN ( SELECT   empresa
                                   FROM     dbo.p_empresas
                                   WHERE    id_presup = @id_presup )
                    AND c.captura = 'A'
                    AND c.uso = 'S'
                    AND ( ( c.num_conc > 036
                            AND c.num_conc < 100
                          )
                          OR ( c.num_conc > 136
                               AND c.num_conc < 200
                             ) -- or
                          
                        )
                    AND
            --num_conc = 216 or
            --(num_conc >= 219 and num_conc <= 299)) and
                    ( LEN(RTRIM(LTRIM(c.formula))) > 0
                      OR LEN(RTRIM(LTRIM(c.formula2))) > 0
                    )
                    AND ( CHARINDEX('NTOTPERCEP', UPPER(c.formula)) = 0
                          AND CHARINDEX('NTOTPERCEP', UPPER(c.formula2)) = 0
                          AND CHARINDEX('NTOTCOND', UPPER(c.condicion)) = 0
                        )
                    AND LEN(dbo.checa_formula(c.condicion, 'C')) > 0
           -- (len(condicion) > 0 and charindex('.T.', upper(condicion)) = 0)
           --SELECT * FROM  p_conc_tmp ORDER BY num_conc
        END
-- 3.-
-- Para formulas Automaticas con condicion
-- con ntotpercep o ntotcond y ispt = 'S'
    IF @cque_calcula = 'ACCNTOTCI' 
        BEGIN

            SELECT  *
            INTO    dbo.p_conc_tmp
            FROM    dbo.conceptos AS c
            WHERE   c.empresa IN ( SELECT   empresa
                                   FROM     dbo.p_empresas
                                   WHERE    id_presup = @id_presup )
                    AND c.captura = 'A'
                    AND c.uso = 'S'
                    AND c.ispt = 'S'
                    AND ( ( c.num_conc > 036
                            AND c.num_conc < 100
                          )
                          OR ( c.num_conc > 136
                               AND c.num_conc < 200
                             ) --or
                          
                        )
                    AND
            --num_conc = 216 or
            --(num_conc >= 219 and num_conc <= 299)) and
                    ( LEN(RTRIM(LTRIM(c.formula))) > 0
                      OR LEN(RTRIM(LTRIM(c.formula2))) > 0
                    )
                    AND ( CHARINDEX('NTOTPERCEP', UPPER(c.formula)) > 0
                          OR CHARINDEX('NTOTPERCEP', UPPER(c.formula2)) > 0
                          OR CHARINDEX('NTOTCOND', UPPER(c.condicion)) > 0
                        )
                    AND LEN(dbo.checa_formula(c.condicion, 'C')) > 0
            --(len(condicion) > 0 and charindex('.T.', upper(condicion)) = 0)
            --select * from dbo.p_conc_tmp
        END



-- 4.-
-- Para formulas Automaticas con condicion
-- con ntotpercep o ntotcond y ispt <> 'S'
    IF @cque_calcula = 'ACCNTOTSI' 
        BEGIN

            SELECT  *
            INTO    dbo.p_conc_tmp
            FROM    dbo.conceptos AS c
            WHERE   c.empresa IN ( SELECT   empresa
                                   FROM     dbo.p_empresas
                                   WHERE    id_presup = @id_presup )
                    AND c.captura = 'A'
                    AND c.uso = 'S'
                    AND c.ispt <> 'S'
                    AND ( ( c.num_conc > 036
                            AND c.num_conc < 100
                          )
                          OR ( c.num_conc > 136
                               AND c.num_conc < 200
                             )
                        )
                    AND  -- or
            --num_conc = 216) and
                    ( LEN(RTRIM(LTRIM(c.formula))) > 0
                      OR LEN(RTRIM(LTRIM(c.formula2))) > 0
                    )
                    AND ( CHARINDEX('NTOTPERCEP', UPPER(c.formula)) > 0
                          OR CHARINDEX('NTOTPERCEP', UPPER(c.formula2)) > 0
                          OR CHARINDEX('NTOTCOND', UPPER(c.condicion)) > 0
                        )
                    AND LEN(dbo.checa_formula(c.condicion, 'C')) > 0
            --len(condicion) > 0 and charindex('.T.', upper(condicion)) = 0
            
        END





-- 5.-
-- Para formulas Automaticas sin condicion
    IF @cque_calcula = 'ASC' 
        BEGIN
            SELECT  *
            INTO    dbo.p_conc_tmp
            FROM    dbo.conceptos AS c
            WHERE   c.empresa IN ( SELECT   empresa
                                   FROM     dbo.p_empresas
                                   WHERE    id_presup = @id_presup )
                    AND c.captura = 'A'
                    AND c.uso = 'S'
                    AND ( ( c.num_conc > 036
                            AND c.num_conc < 100
                          )
                          OR ( c.num_conc > 136
                               AND c.num_conc < 200
                             )
                          OR c.num_conc = 125
                        )
                    AND
            --num_conc = 125 or
            --num_conc > 215 and num_conc < 300) and
                    ( LEN(RTRIM(LTRIM(c.formula))) > 0
                      OR LEN(RTRIM(LTRIM(c.formula2))) > 0
                    )
                    AND
            --charindex('NTOTPERCEP', upper(formula)) = 0 and
            --charindex('NTOTPERCEP', upper(formula2)) = 0 and
            --charindex('NTOTCOND', upper(condicion)) = 0
                    LEN(dbo.checa_formula(c.condicion, 'C')) = 0
            --len(condicion) = 0 and charindex('.T.', upper(condicion)) = 0
     --set @ccalcula = 'S'

	
     --Si es una nomina partida en dos periodos (por cierre de mes), incluir los conceptos con marca siempre = 'S' y prestamos, solo
     --si es la nomina que tiene mas dias o el ultimo movto. es baja ... para no duplicarlos en ambas nominas
            IF ( @nfrecuencia = 7
                 AND @ndiasper <= 3
               )
                OR ( @nfrecuencia = 14
                     AND @ndiasper <= 6
                   )
                OR ( @nfrecuencia = 14
                     AND DAY(@dfchcierre) >= 28
                   ) 
                DELETE  a
                FROM    dbo.p_empresas AS e
                        INNER JOIN dbo.p_conc_tmp AS a ON e.empresa = a.empresa
                WHERE   a.num_conc > 100
                        AND a.num_conc < 200
        
        END


-- 6.-
-- solo manuales y marca siempre = 'N'
    IF @cque_calcula = 'M' 
        BEGIN
            SELECT DISTINCT
                    c.empresa ,
                    c.num_conc ,
                    c.clase ,
                    c.centro ,
                    c.concepto ,
                    c.uso ,
                    c.ispt ,
                    c.imss ,
                    c.mca_agui ,
                    c.ptu ,
                    c.despensa ,
                    c.fdoahorro ,
                    c.captura ,
                    c.condicion1 ,
                    c.condicion2 ,
                    c.formula ,
                    c.formula2 ,
                    c.ispt_ng ,
                    c.imss_ni ,
                    c.fecha1 ,
                    c.fecha2 ,
                    c.fecha3 ,
                    c.hrs_min1 ,
                    c.hrs_min2 ,
                    c.hrs_min3 ,
                    c.importe1 ,
                    c.importe2 ,
                    c.importe3 ,
                    c.porciento1 ,
                    c.porciento2 ,
                    c.porciento3 ,
                    c.variable1 ,
                    c.variable2 ,
                    c.variable3 ,
                    c.variable4 ,
                    c.marca1 ,
                    c.marca2 ,
                    c.condicion ,
                    c.totales ,
                    c.totales2 ,
                    c.totales3 ,
                    c.prevsocial ,
                    c.arreglo1 ,
                    c.arreglo2 ,
                    c.acumulado1 ,
                    c.acumulado2 ,
                    c.acumulado3
            INTO    dbo.p_conc_tmp
            FROM    dbo.p_empresas AS e
                    INNER JOIN dbo.conceptos AS c ON e.empresa = c.empresa
                    INNER JOIN dbo.p_kardex AS k ON k.empresa = c.empresa
                                                    AND k.num_conc = c.num_conc
                                                    AND k.clase = c.clase
                                                    AND k.centro = c.centro
                                                    AND k.nomina = @cnomina
                                                    AND k.siempre = 'N'
                                                    AND k.mes_operacion = @nMes
                                                    AND k.ayo_operacion = @nAyo
            WHERE   c.captura = 'M'
                    AND k.id_presup = @id_presup
                    AND c.uso = 'S'
                    AND
           --c.num_conc = 160
                    ( ( c.num_conc > 0036
                        AND c.num_conc < 0100
                      )
                      OR ( c.num_conc > 0136
                           AND c.num_conc < 0200
                         )
                      OR ( c.num_conc > 1036
                           AND c.num_conc < 1100
                         )
                      OR ( c.num_conc > 1136
                           AND c.num_conc < 1200
                         )
                    )
            ORDER BY c.num_conc ,
                    c.clase ,
                    c.centro



        END


-- 7.-
-- conceptos con calculo = 'M'
-- Calculo igual a M
    IF @cque_calcula = 'CM' 
        BEGIN
            SELECT DISTINCT
                    c.empresa ,
                    c.num_conc ,
                    c.clase ,
                    c.centro ,
                    c.concepto ,
                    c.uso ,
                    c.ispt ,
                    c.imss ,
                    c.mca_agui ,
                    c.ptu ,
                    c.despensa ,
                    c.fdoahorro ,
                    c.captura ,
                    c.condicion1 ,
                    c.condicion2 ,
                    c.formula ,
                    c.formula2 ,
                    c.ispt_ng ,
                    c.imss_ni ,
                    c.fecha1 ,
                    c.fecha2 ,
                    c.fecha3 ,
                    c.hrs_min1 ,
                    c.hrs_min2 ,
                    c.hrs_min3 ,
                    c.importe1 ,
                    c.importe2 ,
                    c.importe3 ,
                    c.porciento1 ,
                    c.porciento2 ,
                    c.porciento3 ,
                    c.variable1 ,
                    c.variable2 ,
                    c.variable3 ,
                    c.variable4 ,
                    c.marca1 ,
                    c.marca2 ,
                    c.condicion ,
                    c.totales ,
                    c.totales2 ,
                    c.totales3 ,
                    c.prevsocial ,
                    c.arreglo1 ,
                    c.arreglo2 ,
                    c.acumulado1 ,
                    c.acumulado2 ,
                    c.acumulado3
            INTO    dbo.p_conc_tmp
            FROM    dbo.p_empresas AS e
                    INNER JOIN dbo.conceptos AS c ON e.empresa = c.empresa
                    INNER JOIN dbo.p_kardex AS k ON k.empresa = @nempresa
                                                    AND k.id_presup = @id_presup
                                                    AND k.num_conc = c.num_conc
                                                    AND k.clase = c.clase
                                                    AND k.centro = c.centro
                                                    AND k.nomina = @cnomina
                                                    AND
                               --k.siempre  = 'N'
                                                    k.calculo = 'M'
                                                    AND k.mes_operacion = @nMes
                                                    AND k.ayo_operacion = @nAyo
            WHERE   ( ( c.empresa IN ( SELECT   empresa
                                       FROM     dbo.p_empresas
                                       WHERE    id_presup = @id_presup )
                        AND c.uso = 'S'
                      )
                      AND ( ( c.num_conc = 0008
                              OR c.num_conc = 0009
                            )
                            OR ( c.num_conc >= 0014
                                 AND c.num_conc <= 0099
                               )
                            OR    -- <= 38
                            ( c.num_conc >= 0112
                              AND c.num_conc <= 0199
                            )
                            OR    -- <= 138
                            ( c.num_conc >= 1001
                              AND c.num_conc <= 1199
                            )
                          )
                    )
        END



-- 8.-
-- provisiones 216
    IF @cque_calcula = 'PV' 
        BEGIN

            SELECT  *
            INTO    dbo.p_conc_tmp
            FROM    dbo.conceptos AS c
            WHERE   c.empresa IN ( SELECT   empresa
                                   FROM     dbo.p_empresas
                                   WHERE    id_presup = @id_presup )
                    AND c.captura = 'A'
                    AND c.uso = 'S'
                    AND ( c.num_conc = 216
                          OR ( c.num_conc >= 219
                               AND c.num_conc <= 299
                             )
                        )
        END
		--select * from p_conc_tmp


--if @cque_calcula <> 'MS'
--   begin
	
    DECLARE conceptos_auto CURSOR
    FOR
    SELECT num_conc  ,
    clase     ,
    centro    ,
    concepto  ,
    ispt      ,
    imss      ,
    mca_agui  ,
    ptu       ,
    despensa  ,
    fdoahorro ,
    condicion1,
    condicion2,
    dbo.checa_formula(LTRIM(RTRIM(formula )), 'F'),
    dbo.checa_formula(LTRIM(RTRIM(formula2)), 'F2'),
    --     ispt_ng,
    dbo.checa_formula(LTRIM(RTRIM(ispt_ng )), 'ISR'),
    dbo.checa_formula(LTRIM(RTRIM(imss_ni )), 'IMSS'),
    fecha1    ,
    fecha2    ,
    fecha3    ,
    hrs_min1  ,
    hrs_min2  ,
    hrs_min3  ,
    importe1  ,
    importe2  ,
    importe3  ,
    porciento1,
    porciento2,
    porciento3,
    variable1 ,
    variable2 ,
    variable3 ,
    variable4 ,
    marca1    ,
    marca2    ,
    dbo.checa_formula(LTRIM(RTRIM(condicion)), 'C'),
    totales   ,
    totales2  ,
    totales3  ,
    prevsocial,
    dbo.checa_formula(LTRIM(RTRIM(arreglo1)),'T'),
    dbo.checa_formula(LTRIM(RTRIM(arreglo2)),'T') ,
    acumulado1,
    acumulado2,
    acumulado3,
    empresa
    FROM dbo.p_conc_tmp 
    WHERE ISNULL(LEN(LTRIM(RTRIM(acumulado1))),0) = 0 AND ISNULL(LEN(LTRIM(RTRIM(acumulado2))),0) =0 AND ISNULL(LEN(LTRIM(RTRIM(acumulado3))),0) =0 


    PRINT '001'

    OPEN conceptos_auto

    PRINT '002'

--if @cque_calcula <> 'MS'
    FETCH NEXT FROM conceptos_auto INTO @nnum_conc  ,
                                       @cclase     ,
                                       @ccentro    ,
                                       @cconcepto  ,
                                       @cispt      ,
                                       @cimss      ,
                                       @cmca_agui  ,
                                       @cptu       ,
                                       @cdespensa  ,
                                       @cfdoahorro ,
                                       @ccondicion1,
                                       @ccondicion2,
                                       @cformula   ,
                                       @cformula2  ,
                                       @cispt_ng   ,
                                       @cimss_ni   ,
                                       @dfecha1    ,
                                       @dfecha2    ,
                                       @dfecha3    ,
                                       @nhrs_min1  ,
                                       @nhrs_min2  ,
                                       @nhrs_min3  ,
                                       @nimporte1  ,
                                       @nimporte2  ,
                                       @nimporte3  ,
                                       @nporciento1,
                                       @nporciento2,
                                       @nporciento3,
                                       @cvariable1 ,
                                       @cvariable2 ,
                                       @cvariable3 ,
                                       @cvariable4 ,
                                       @cmarca1    ,
                                       @cmarca2    ,
                                       @ccondicion ,
                                       @ctotales   ,
                                       @ctotales2  ,
                                       @ctotales3  ,
                                       @cprevsocial,
                                       @carreglo1  ,
                                       @carreglo2  ,
                                       @cacumulado1,
                                       @cacumulado2,
                                       @cacumulado3,
                                       @empresaC


    PRINT @empresaC
    PRINT 'Empresa'


    PRINT '003'


--Select @@FETCH_STATUS
    WHILE ( @@FETCH_STATUS <> -1 ) 
        BEGIN


--select * from dbo.p_conc_tmp

            PRINT 'qq'
            PRINT ''
            PRINT ''
            PRINT 'INICIO CONCEPTO '
            PRINT ''
            PRINT ''
            PRINT ''



            PRINT 'isr ' + CASE WHEN @cispt_ng IS NULL
                                     OR @cispt_ng = ' ' THEN '0'
                                ELSE @cispt_ng
                           END
            PRINT 'imss ' + CASE WHEN @cimss_ni IS NULL
                                      OR @cimss_ni = ' ' THEN '0'
                                 ELSE @cimss_ni
                            END





            SET @cispt_ng = CASE WHEN @cispt_ng IS NULL
                                      OR @cispt_ng = ' ' THEN '0'
                                 ELSE @cispt_ng
                            END
            SET @cimss_ni = CASE WHEN @cimss_ni IS NULL
                                      OR @cimss_ni = ' ' THEN '0'
                                 ELSE @cimss_ni
                            END


            IF CHARINDEX('.T.', @ccondicion) > 0 
                SET @ccondicion = ''



   -- SR.- percepciones menos deducciones
   -- RS.- deducciones menos percepciones
   -- SS.- percepciones mas deducciones

   -- para cuando SI cumple la condicion


            PRINT 'a'



   --if charindex('ntotpercep', @cformula) > 0
            IF LEN(@ctotales) > 0 --charindex('ntotpercep', @cformula) > 0
      -- VERIFICAR SI LAS PERCEPCIONES Y LAS DEDUCCIONES DE LA VARIABLE
      -- TOTAL DE CONCEPTOS, SE SUMAN O SE RESTAN DEL IMPORTE
                IF RIGHT(@ctotales, 1) <> '}' 
                    BEGIN
                        SET @cpercep = SUBSTRING(@ctotales, LEN(@ctotales) - 1,
                                                 1)
                        SET @cdeducc = SUBSTRING(@ctotales, LEN(@ctotales) - 0,
                                                 1)
                        SET @ctotales = SUBSTRING(@ctotales, 2,
                                                  LEN(@ctotales) - 4)
                    END

            PRINT 'b'


            IF LEN(@ctotales3) > 0 --charindex('ntotpercep', @cformula2) > 0
                IF RIGHT(@ctotales3, 1) <> '}' 
                    BEGIN
                        SET @cpercep3 = SUBSTRING(@ctotales3,
                                                  LEN(@ctotales3) - 1, 1)
                        SET @cdeducc3 = SUBSTRING(@ctotales3,
                                                  LEN(@ctotales3) - 0, 1)
                        SET @ctotales3 = SUBSTRING(@ctotales3, 2,
                                                   LEN(@ctotales3) - 4)

                        PRINT @cpercep3
                        PRINT @cdeducc3
                        PRINT @ctotales3


                    END


            PRINT 'c'


            IF LEN(@ctotales2) > 0 --charindex('ntotcond', @ccondicion) > 0
                IF RIGHT(@ctotales2, 1) <> '}' 
                    BEGIN
                        SET @cpercep2 = SUBSTRING(@ctotales2,
                                                  LEN(@ctotales2) - 1, 1)
                        SET @cdeducc2 = SUBSTRING(@ctotales2,
                                                  LEN(@ctotales2) - 0, 1)
                        SET @ctotales2 = SUBSTRING(@ctotales2, 2,
                                                   LEN(@ctotales2) - 4)
                    END



            PRINT '@ctotales  ' + @ctotales
            PRINT '@ctotales2 ' + @ctotales2
            PRINT '@ctotales3 ' + @ctotales3


            PRINT 'd'

            PRINT @nnum_conc
            PRINT @cclase



         -- -- - - - - - - -  --  - - -
         -- Tablas
            IF LEN(@carreglo1) > 0 
                BEGIN
                    SET @npos_tab11 = 0
                    SET @npos_tab12 = 0
                    SET @npos_tab13 = 0
                    SET @cval_tab11 = ''

                    SET @nciclo = 1


                    PRINT @carreglo1
                    PRINT CHARINDEX('@', @carreglo1)

                    SET @ctmp_tab11 = case when len(@carreglo1)>0 and CHARINDEX('@', @carreglo1)>0 then  SUBSTRING(@carreglo1, 2,
                                                CHARINDEX('@', @carreglo1) - 3)
									  else '' end

                    SET @npos_tab13 = CHARINDEX('@', @carreglo1)
                    IF @npos_tab13 > 0 
                        SET @cval_tab11 = SUBSTRING(@carreglo1,
                                                    @npos_tab13 + 1,
                                                    LEN(@carreglo1))

                    --select 1
					WHILE @nciclo = 1 
                        BEGIN
                            SET @npos_tab11 = CHARINDEX('{', @ctmp_tab11)
                            SET @npos_tab12 = CHARINDEX('}', @ctmp_tab11)


                            IF @npos_tab11 > 0
                                AND @npos_tab12 > 0 
                                BEGIN

                                    IF OBJECT_ID('dbo.p_tab_arr1') IS NULL 
                                        BEGIN
                                            CREATE TABLE dbo.p_tab_arr1
                                                (
                                                  ele_ini NUMERIC(12, 2)
                                                    NOT NULL ,
                                                  ele_fin NUMERIC(12, 2)
                                                    NOT NULL ,
                                                  importe NUMERIC(12, 2)
                                                    NOT NULL
                                                )
                                        END

                                    SET @ctmp_tab12 = SUBSTRING(@ctmp_tab11,
                                                              @npos_tab11 + 1,
                                                              @npos_tab12 - 2)

                                    SET @nele_tab11 = SUBSTRING(@ctmp_tab12, 1,
                                                              CHARINDEX(',',
                                                              @ctmp_tab12) - 1)

                                    SET @ctmp_tab12 = SUBSTRING(@ctmp_tab12,
                                                              CHARINDEX(',',
                                                              @ctmp_tab12) + 1,
                                                              LEN(@ctmp_tab12))
                                    SET @nele_tab12 = SUBSTRING(@ctmp_tab12, 1,
                                                              CHARINDEX(',',
                                                              @ctmp_tab12) - 1)

                                    SET @nimp_tab = SUBSTRING(@ctmp_tab12,
                                                              CHARINDEX(',',
                                                              @ctmp_tab12) + 1,
                                                              LEN(@ctmp_tab12))

                                    INSERT  p_tab_arr1
                                            ( ele_ini ,
                                              ele_fin ,
                                              importe
                                            )
                                    VALUES  ( @nele_tab11 ,
                                              @nele_tab12 ,
                                              @nimp_tab
                                            )

                                    SET @ctmp_tab11 = SUBSTRING(@ctmp_tab11,
                                                              @npos_tab12 + 2,
                                                              LEN(@ctmp_tab11))
                                END

                            ELSE 
                                SET @nciclo = 0
                        END
                END





            IF LEN(@carreglo2) > 0 
                BEGIN
					
                    SET @npos_tab21 = 0
                    SET @npos_tab22 = 0
                    SET @npos_tab23 = 0
                    SET @cval_tab21 = ''

                    SET @nciclo = 1

                    
					SET @ctmp_tab21 = SUBSTRING(@carreglo2, 2,
                                                CHARINDEX('@', @carreglo2) - 3)

                    SET @npos_tab23 = CHARINDEX('@', @carreglo2)
                    IF @npos_tab23 > 0 
                        SET @cval_tab21 = SUBSTRING(@carreglo2,
                                                    @npos_tab23 + 1,
                                                    LEN(@carreglo2))

                    WHILE @nciclo = 1 
                        BEGIN
                            SET @npos_tab21 = CHARINDEX('{', @ctmp_tab21)
                            SET @npos_tab22 = CHARINDEX('}', @ctmp_tab21)


                            IF @npos_tab21 > 0
                                AND @npos_tab22 > 0 
                                BEGIN

                                    IF OBJECT_ID('dbo.p_tab_arr2') IS NULL 
                                        BEGIN
                                            CREATE TABLE dbo.p_tab_arr2
                                                (
                                                  ele_ini NUMERIC(12, 2)
                                                    NOT NULL ,
                                                  ele_fin NUMERIC(12, 2)
                                                    NOT NULL ,
                                                  importe NUMERIC(12, 2)
                                                    NOT NULL
                                                )
                                        END

                                    
									SET @ctmp_tab22 = SUBSTRING(@ctmp_tab21,
                                                              @npos_tab21 + 1,
                                                              @npos_tab22 - 2)

                                    SET @nele_tab21 = SUBSTRING(@ctmp_tab22, 1,
                                                              CHARINDEX(',',
                                                              @ctmp_tab22) - 1)

                                    SET @ctmp_tab22 = SUBSTRING(@ctmp_tab22,
                                                              CHARINDEX(',',
                                                              @ctmp_tab22) + 1,
                                                              LEN(@ctmp_tab22))
                                    SET @nele_tab22 = SUBSTRING(@ctmp_tab22, 1,
                                                              CHARINDEX(',',
                                                              @ctmp_tab22) - 1)

                                    SET @nimp_tab = SUBSTRING(@ctmp_tab22,
                                                              CHARINDEX(',',
                                                              @ctmp_tab22) + 1,
                                                              LEN(@ctmp_tab22))

                                    INSERT  p_tab_arr2
                                            ( ele_ini ,
                                              ele_fin ,
                                              importe
                                            )
                                    VALUES  ( @nele_tab21 ,
                                              @nele_tab22 ,
                                              @nimp_tab
                                            )

									SET @ctmp_tab21 = SUBSTRING(@ctmp_tab21,
                                                              @npos_tab22 + 2,
                                                              LEN(@ctmp_tab21))
                                END

                            ELSE 
                                SET @nciclo = 0
                        END
                END


   -- tabla temporal
            IF OBJECT_ID('dbo.p_kardex_tmp') IS NOT NULL 
                DROP TABLE dbo.p_kardex_tmp



            IF @cque_calcula = 'MS'
                OR @cque_calcula = 'M'
                OR @cque_calcula = 'CM' 
                BEGIN
        --select @nvaria1 = varia1,
        --       @nvaria2 = varia2,
        --       @nvaria3 = varia3,
        --       @nvaria4 = varia4
        --from p_conc_man
        --where num_conc = @nnum_conc and
        --      clase    = @cclase    and
        --      centro   = @ccentro

                    SET @ccondicion1 = 'T'
                    SET @ccondicion2 = 'A'
                    SET @ccondicion = ''
                END



            PRINT 'k_001'

            IF @cque_calcula = 'MS' 
                BEGIN
                    IF @cper_ded = 'P' 
                        SELECT  k.empresa ,
                                k.codigo ,
                                @nnum_conc AS 'num_conc' , --k.num_conc,
                                ( SELECT    ISNULL(MAX(folio), 0)
                                  FROM      dbo.p_kardex AS kf
                                  WHERE     kf.empresa = k.empresa
                                            AND kf.nomina = @cnomina
                                            AND kf.codigo = k.codigo
											AND kf.id_presup = @id_presup
                                ) AS 'folio' ,
                                k.impor_base AS 'impor_base' , --(select case when sum(kn.impor_base) is null then 0 else sum(kn.impor_base) end from kardex_pba as kn where kn.empresa = @nempresa and kn.codigo = k.codigo and kn.num_conc in (1,2,3,4,5,6,7,30)) as 'impor_base',
                                k.saldiaint ,
                                ISNULL(k.dias, 0) AS 'dias' , --(select case when sum(kn.dias) is null then 0 else sum(kn.dias) end from kardex_pba as kn where kn.empresa = @nempresa and kn.codigo = k.codigo and kn.num_conc in (1,2,3,4,5,6,7,30)) as 'dias',
                                ISNULL(k.inc, 0) AS 'inc' , --(select case when sum(kn.inc) is null then 0 else sum(kn.inc) end from kardex_pba as kn where kn.empresa = @nempresa and kn.codigo = k.codigo and kn.num_conc in (109,110,111)) as 'inc',
                                ISNULL(k.aus, 0) * ( k.descuento / 100 ) AS 'aus' ,  -- se guarda la proporcion del septimo dia (suma las proporciones que corresponde a cada y las divide entre el numeros de dias de faltas saca la proprocion diaria y esa es la que guarda
                                @nsaldf AS 'saldf' ,
                                @nsalmin AS 'salmin' ,
                                @npercep AS 'ntotpercep' ,
                                @npercep AS 'percep_tot' ,
                                @ndeducc AS 'deducc_tot' ,
                                @ctotales AS 'totales' ,
                                @npercep AS 'nvalesper' ,
                                @npercep AS 'nvalesded' ,
                                ( SELECT TOP 1
                                            ISNULL(dh.factor_aus, 0)
                                  FROM      dbo.detalle_horarios AS dh
                                  WHERE     empresa = k.empresa
                                            AND dh.factor_aus > 0
                                            AND ll.horario = dh.horario
                                ) AS 'nfactus' ,
                                @ntiponom AS 'ntiponom' ,
                                ISNULL(ll.horario, 0) AS 'nhorario' ,
                                ISNULL(ll.ocupacion, 0) AS 'ntabular' ,
                                0 AS 'nsupervisor' ,-- isnull(ll.supervisor,0)as 'nsupervisor',
                                ll.fchalta AS 'dfchalta' ,
                                ll.fchantigua AS 'dfchantigua' ,
                                NULL AS 'dfchnac' ,--e.fchnac               as 'dfchnac',  -- select * from p_empleados_pres
                                @dfchinicio AS 'dfchinicio' ,
                                @dfchcierre AS 'dfchcierre' ,
                                @dfchpago AS 'dfchpago' ,
                                k.fch_inicio ,
                                k.fch_cierre ,
                                ISNULL(k.dias, 0) - ISNULL(k.aus, 0)
                                - ISNULL(k.inc, 0) AS 'ndstr' ,
                                CASE WHEN @cque_calcula = 'CM' THEN k.importe
                                     ELSE @nimporte
                                END AS 'importe1' ,
                  --@nimporte              as 'importe1',
                                @nimporte AS 'importe2' ,
                  --k.importe              as 'importe_kardex',
                                @nimporte AS 'isr' ,
                                @nimporte AS 'imss' ,
                                @csw AS 'cumple_cond' ,
                                ll.clase ,
                                ll.centro ,
                                @ctotales3 AS 'totales3' ,
                                @npercep AS 'percep_tot3' ,
                                @npercep AS 'ntotpercep3' ,
                                @ndeducc AS 'deducc_tot3' ,
                                @npercep AS 'nvalesper3' ,
                                @npercep AS 'nvalesded3' ,
                                @cformula AS 'formula' ,
                                @cformula2 AS 'formula2' ,
                                @ccondicion AS 'condicion' ,
                                @npercep AS 'nacumimpo1' ,
                                @npercep AS 'nacuimpop1' ,
                                @npercep AS 'nacuimpod1' ,
                                @npercep AS 'nacumimpo2' ,
                                @npercep AS 'nacuimpop2' ,
                                @npercep AS 'nacuimpod2' ,
                                @npercep AS 'nacumimpo3' ,
                                @npercep AS 'nacuimpop3' ,
                                @npercep AS 'nacuimpod3' ,
                                @npercep AS 'nacumd1' ,
                                @npercep AS 'nacumdp1' ,
                                @npercep AS 'nacumdd1' ,
                                @npercep AS 'nacumd2' ,
                                @npercep AS 'nacumdp2' ,
                                @npercep AS 'nacumdd2' ,
                                @npercep AS 'nacumd3' ,
                                @npercep AS 'nacumdp3' ,
                                @npercep AS 'nacumdd3' ,
                                @npercep AS 'nacumhras1' ,
                                @npercep AS 'nacumhrasp1' ,
                                @npercep AS 'nacumhrasd1' ,
                                @npercep AS 'nacumhras2' ,
                                @npercep AS 'nacumhrasp2' ,
                                @npercep AS 'nacumhrasd2' ,
                                @npercep AS 'nacumhras3' ,
                                @npercep AS 'nacumhrasp3' ,
                                @npercep AS 'nacumhrasd3' ,
                                @npercep AS 'nacumvaria11' ,
                                @npercep AS 'nacumvariap11' ,
                                @npercep AS 'nacumvariad11' ,
                                @npercep AS 'nacumvaria12' ,
                                @npercep AS 'nacumvariap12' ,
                                @npercep AS 'nacumvariad12' ,
                                @npercep AS 'nacumvaria13' ,
                                @npercep AS 'nacumvariap13' ,
                                @npercep AS 'nacumvariad13' ,
                                @npercep AS 'nacumvaria21' ,
                                @npercep AS 'nacumvariap21' ,
                                @npercep AS 'nacumvariad21' ,
                                @npercep AS 'nacumvaria22' ,
                                @npercep AS 'nacumvariap22' ,
                                @npercep AS 'nacumvariad22' ,
                                @npercep AS 'nacumvaria23' ,
                                @npercep AS 'nacumvariap23' ,
                                @npercep AS 'nacumvariad23' ,
                                @npercep AS 'nacumvaria31' ,
                                @npercep AS 'nacumvariap31' ,
                                @npercep AS 'nacumvariad31' ,
                                @npercep AS 'nacumvaria32' ,
                                @npercep AS 'nacumvariap32' ,
                                @npercep AS 'nacumvariad32' ,
                                @npercep AS 'nacumvaria33' ,
                                @npercep AS 'nacumvariap33' ,
                                @npercep AS 'nacumvariad33' ,
                                @npercep AS 'nacumvaria41' ,
                                @npercep AS 'nacumvariap41' ,
                                @npercep AS 'nacumvariad41' ,
                                @npercep AS 'nacumvaria42' ,
                                @npercep AS 'nacumvariap42' ,
                                @npercep AS 'nacumvariad42' ,
                                @npercep AS 'nacumvaria43' ,
                                @npercep AS 'nacumvariap43' ,
                                @npercep AS 'nacumvariad43' ,
                                @npercep AS 'nvalortab1' ,
                                @npercep AS 'nvalortab2' ,
                                NULL AS 'dfchcumple' ,--convert(datetime, convert(char(4),@nayo) + substring(Convert(Char(3),100 + month(e.fchnac)),2,2) + substring(Convert(Char(3),100 + case when day(e.fchnac) = 29 and @nayo % 4 <> 0 then 28 else day(e.fchnac) end ),2,2))   as 'dfchcumple',
                                k.num_conc AS 'conc_num' ,
                                1 AS 'fol_tmp', --p.folio as 'fol_tmp',
								isnull((select uma from dbo.P_SalMin where id_Presup=@id_presup and year(fecha)=@nayo),0) as umadiario,
								0 as nDsReales
                        INTO    dbo.p_kardex_tmp
                        FROM    dbo.p_kardex AS k
                                INNER JOIN dbo.p_empleados_pres AS ll ON ll.empresa = k.empresa
                                                              AND ll.id_presup = k.id_presup
                                                              AND ll.tiponom = @ntiponom
                                                              AND ll.codigo = k.codigo
                                                              AND ll.id_presup = k.id_presup
                                                              AND ll.clase BETWEEN CASE
                                                              WHEN @cclase = ' '
                                                              THEN 'A'
                                                              ELSE @cclase
                                                              END
                                                              AND
                                                              CASE
                                                              WHEN @cclase = ' '
                                                              THEN 'Z'
                                                              ELSE @cclase
                                                              END
                                                              AND ll.centro BETWEEN CASE
                                                              WHEN @ccentro = ' '
                                                              THEN ' '
                                                              ELSE @ccentro
                                                              END
                                                              AND
                                                              CASE
                                                              WHEN @ccentro = ' '
                                                              THEN '99999999999999'
                                                              ELSE @ccentro
                                                              END
                                                              AND ll.codigo = k.codigo
                                                              AND ( ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'T'
                                                              THEN ' '
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'T'
                                                              THEN 'S'
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'T'
                                                              THEN 'C'
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'S'
                                                              THEN 'S'
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'C'
                                                              THEN 'C'
                                                              END
                                                              ) /*and
                                        (e.sexo = case when @ccondicion2 = 'A' then ' ' end or
                                         e.sexo = case when @ccondicion2 = 'A' then 'M' end or
                                         e.sexo = case when @ccondicion2 = 'A' then 'F' end or
                                         e.sexo = case when @ccondicion2 = 'M' then 'M' end or
                                         e.sexo = case when @ccondicion2 = 'F' then 'F' end)*/
                                INNER JOIN dbo.p_percepciones AS p ON --p.empresa       = @nempresa  and
                                             p.ayo_operacion = @nayo
                                                              AND p.mes = @nperiodo
                                                              AND p.tiponom = @ntiponom
                                                              AND p.num_conc = @nnum_conc
                                                              AND p.clase = @cclase
                                                              AND p.centro = @ccentro
                                                              AND p.siempre = 'S'
                                                              AND p.id_presup = @id_presup

           -- para el Ayuntamiento de Vallarta, no considerar las Vacaciones para el concepto 40
                        WHERE   k.nomina = @cnomina
                                AND k.empresa = @empresaC
                                AND k.num_conc IN ( 1, 2, 3, 4, 5, 6, 7,
                                                    ( CASE WHEN @cregpat <> 'A100000000'
                                                              OR @nnum_conc <> 40
                                                           THEN 30
                                                           ELSE 1
                                                      END ) )     -- and k.num_conc = @ntiponom
                                AND k.mes_operacion = @nMes
                                AND k.ayo_operacion = @nAyo
                                AND k.id_presup = @id_presup
                        GROUP BY k.empresa ,
                                k.codigo ,
                                k.num_conc ,
                                ll.clase ,
                                ll.centro ,
                                ll.sueldo ,
                                ll.saldiaint ,
                                ll.horario ,
                                k.dias ,
                                k.inc ,
                                k.aus ,
                                k.impor_base ,
                                k.diastr ,
                                k.dias_imss ,
                                k.fch_inicio ,
                                k.saldiaint ,
                    --e.fchnac,
                                ll.ocupacion ,
                    --ll.supervisor,
                                ll.fchalta ,
                                ll.fchantigua ,
                                k.fch_cierre ,
                                k.importe ,
                                k.descuento
                    --p.folio
                        ORDER BY k.codigo ,
                                k.num_conc ,
                                k.fch_inicio
		
                END

            ELSE 
                SELECT  k.empresa ,
                        k.codigo ,
                        @nnum_conc AS 'num_conc' , --k.num_conc,
                        ( SELECT    ISNULL(MAX(folio), 0)
                          FROM      dbo.p_kardex AS kf
                          WHERE     kf.empresa = k.empresa
                                    AND kf.nomina = @cnomina
                                    AND kf.codigo = k.codigo
									AND kf.id_presup = @id_presup
                        ) AS 'folio' ,
                        k.impor_base AS 'impor_base' , --(select case when sum(kn.impor_base) is null then 0 else sum(kn.impor_base) end from kardex_pba as kn where kn.empresa = @nempresa and kn.codigo = k.codigo and kn.num_conc in (1,2,3,4,5,6,7,30)) as 'impor_base',
                        k.saldiaint ,
                        ISNULL(k.dias, 0) AS 'dias' , --(select case when sum(kn.dias) is null then 0 else sum(kn.dias) end from kardex_pba as kn where kn.empresa = @nempresa and kn.codigo = k.codigo and kn.num_conc in (1,2,3,4,5,6,7,30)) as 'dias',
                        ISNULL(k.inc, 0) AS 'inc' , --(select case when sum(kn.inc) is null then 0 else sum(kn.inc) end from kardex_pba as kn where kn.empresa = @nempresa and kn.codigo = k.codigo and kn.num_conc in (109,110,111)) as 'inc',
                        ISNULL(k.aus, 0) * ( k.descuento / 100 ) AS 'aus' ,  -- se guarda la proporcion del septimo dia (suma las proporciones que corresponde a cada y las divide entre el numeros de dias de faltas saca la proprocion diaria y esa es la que guarda
                        @nsaldf AS 'saldf' ,
                        @nsalmin AS 'salmin' ,
                        @npercep AS 'ntotpercep' ,
                        @npercep AS 'percep_tot' ,
                        @ndeducc AS 'deducc_tot' ,
                        @ctotales AS 'totales' ,
                        @npercep AS 'nvalesper' ,
                        @npercep AS 'nvalesded' ,
                        ( SELECT TOP 1
                                    ISNULL(dh.factor_aus, 0)
                          FROM      dbo.detalle_horarios AS dh
                          WHERE     empresa = k.empresa
                                    AND dh.factor_aus > 0
                                    AND ll.horario = dh.horario
                        ) AS 'nfactus' ,
                        @ntiponom AS 'ntiponom' ,
                        ISNULL(ll.horario, 0) AS 'nhorario' ,
                        ISNULL(ll.ocupacion, 0) AS 'ntabular' ,
                        0 AS 'nsupervisor' ,--isnull(ll.supervisor,0) as 'nsupervisor',
                        ll.fchalta AS 'dfchalta' ,
                        ll.fchantigua AS 'dfchantigua' ,
                        NULL AS 'dfchnac' ,--e.fchnac               as 'dfchnac',
                        @dfchinicio AS 'dfchinicio' ,
                        @dfchcierre AS 'dfchcierre' ,
                        @dfchpago AS 'dfchpago' ,
                        k.fch_inicio ,
                        k.fch_cierre ,
                        ISNULL(k.dias, 0) - ISNULL(k.aus, 0) - ISNULL(k.inc, 0) AS 'ndstr' ,
                        CASE WHEN @cque_calcula = 'CM' THEN k.importe
                             ELSE @nimporte
                        END AS 'importe1' ,
             --@nimporte              as 'importe1',
                        @nimporte AS 'importe2' ,
             --k.importe              as 'importe_kardex',
                        @nimporte AS 'isr' ,
                        @nimporte AS 'imss' ,
                        @csw AS 'cumple_cond' ,
                        ll.clase ,
                        ll.centro ,
                        @ctotales3 AS 'totales3' ,
                        @npercep AS 'percep_tot3' ,
                        @npercep AS 'ntotpercep3' ,
                        @ndeducc AS 'deducc_tot3' ,
                        @npercep AS 'nvalesper3' ,
                        @npercep AS 'nvalesded3' ,
                        @cformula AS 'formula' ,
                        @cformula2 AS 'formula2' ,
                        @ccondicion AS 'condicion' ,
                        @npercep AS 'nacumimpo1' ,
                        @npercep AS 'nacuimpop1' ,
                        @npercep AS 'nacuimpod1' ,
                        @npercep AS 'nacumimpo2' ,
                        @npercep AS 'nacuimpop2' ,
                        @npercep AS 'nacuimpod2' ,
                        @npercep AS 'nacumimpo3' ,
                        @npercep AS 'nacuimpop3' ,
                        @npercep AS 'nacuimpod3' ,
                        @npercep AS 'nacumd1' ,
                        @npercep AS 'nacumdp1' ,
                        @npercep AS 'nacumdd1' ,
                        @npercep AS 'nacumd2' ,
                        @npercep AS 'nacumdp2' ,
                        @npercep AS 'nacumdd2' ,
                        @npercep AS 'nacumd3' ,
                        @npercep AS 'nacumdp3' ,
                        @npercep AS 'nacumdd3' ,
                        @npercep AS 'nacumhras1' ,
                        @npercep AS 'nacumhrasp1' ,
                        @npercep AS 'nacumhrasd1' ,
                        @npercep AS 'nacumhras2' ,
                        @npercep AS 'nacumhrasp2' ,
                        @npercep AS 'nacumhrasd2' ,
                        @npercep AS 'nacumhras3' ,
                        @npercep AS 'nacumhrasp3' ,
                        @npercep AS 'nacumhrasd3' ,
                        @npercep AS 'nacumvaria11' ,
                        @npercep AS 'nacumvariap11' ,
                        @npercep AS 'nacumvariad11' ,
                        @npercep AS 'nacumvaria12' ,
                        @npercep AS 'nacumvariap12' ,
                        @npercep AS 'nacumvariad12' ,
                        @npercep AS 'nacumvaria13' ,
                        @npercep AS 'nacumvariap13' ,
                        @npercep AS 'nacumvariad13' ,
                        @npercep AS 'nacumvaria21' ,
                        @npercep AS 'nacumvariap21' ,
                        @npercep AS 'nacumvariad21' ,
                        @npercep AS 'nacumvaria22' ,
                        @npercep AS 'nacumvariap22' ,
                        @npercep AS 'nacumvariad22' ,
                        @npercep AS 'nacumvaria23' ,
                        @npercep AS 'nacumvariap23' ,
                        @npercep AS 'nacumvariad23' ,
                        @npercep AS 'nacumvaria31' ,
                        @npercep AS 'nacumvariap31' ,
                        @npercep AS 'nacumvariad31' ,
                        @npercep AS 'nacumvaria32' ,
                        @npercep AS 'nacumvariap32' ,
                        @npercep AS 'nacumvariad32' ,
                        @npercep AS 'nacumvaria33' ,
                        @npercep AS 'nacumvariap33' ,
                        @npercep AS 'nacumvariad33' ,
                        @npercep AS 'nacumvaria41' ,
                        @npercep AS 'nacumvariap41' ,
                        @npercep AS 'nacumvariad41' ,
                        @npercep AS 'nacumvaria42' ,
                        @npercep AS 'nacumvariap42' ,
                        @npercep AS 'nacumvariad42' ,
                        @npercep AS 'nacumvaria43' ,
                        @npercep AS 'nacumvariap43' ,
                        @npercep AS 'nacumvariad43' ,
                        @npercep AS 'nvalortab1' ,
                        @npercep AS 'nvalortab2' ,

             --@nvaria1               as 'nvar1',
             --@nvaria2               as 'nvar2',
             --@nvaria3               as 'nvar3',
             --@nvaria4               as 'nvar4',
                        NULL AS 'dfchcumple' ,--convert(datetime, convert(char(4),@nayo) + substring(Convert(Char(3),100 + month(e.fchnac)),2,2) + substring(Convert(Char(3),100 + case when day(e.fchnac) = 29 and @nayo % 4 <> 0 then 28 else day(e.fchnac) end ),2,2))   as 'dfchcumple',
                        k.num_conc AS 'conc_num' ,
                        0 AS 'fol_tmp',
						isnull((select uma from dbo.P_SalMin where id_Presup=@id_presup and year(fecha)=@nAyo),0) as umadiario,
						0 as nDsReales 
                INTO    dbo.p_kardex_tmp
                FROM    dbo.p_kardex AS k
                        INNER JOIN dbo.p_empleados_pres AS ll ON ll.empresa = k.empresa
                                                              AND ll.tiponom = @ntiponom
                                                              AND ll.codigo = k.codigo
                                                              AND ll.id_presup = k.id_presup
                                                              AND ll.clase BETWEEN CASE
                                                              WHEN @cclase = ' '
                                                              THEN 'A'
                                                              ELSE @cclase
                                                              END
                                                              AND
                                                              CASE
                                                              WHEN @cclase = ' '
                                                              THEN 'Z'
                                                              ELSE @cclase
                                                              END
                                                              AND ll.centro BETWEEN CASE
                                                              WHEN @ccentro = ' '
                                                              THEN ' '
                                                              ELSE @ccentro
                                                              END
                                                              AND
                                                              CASE
                                                              WHEN @ccentro = ' '
                                                              THEN '99999999999999'
                                                              ELSE @ccentro
                                                              END
                                                              AND--inner join empleados as e on e.empresa = @nempresa and
                                   --e.codigo  = k.codigo  and
                                                              ( ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'T'
                                                              THEN ' '
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'T'
                                                              THEN 'S'
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'T'
                                                              THEN 'C'
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'S'
                                                              THEN 'S'
                                                              END
                                                              OR ll.sindicato = CASE
                                                              WHEN @ccondicion1 = 'C'
                                                              THEN 'C'
                                                              END
                                                              )
                                                              AND k.mes_operacion = @nMes
                                                              AND k.ayo_operacion = @nAyo
                WHERE   k.empresa = @empresaC
                        AND k.nomina = @cnomina
                        AND ll.id_presup = @id_presup
                        AND 
-- aqui adecuar la extraccion del concepto 30 para los Mayan y Autocamiones de Chihuahua en los conceptos 37 y 38
--      para Plus, no considerar las vacaciones en los conceptos automaticos
                        k.num_conc IN ( 1, 2, 3, 4, 5, 6, 7,
                                        ( CASE WHEN @cesp37y38 <> 'S'
                                                    OR @nnum_conc NOT IN ( 37,
                                                              38 )
                                               THEN CASE WHEN NOT @cregpat IN (
                                                              'R131234636',
                                                              'C166197810',
                                                              'C166939010',
                                                              'C167952510',
                                                              'R131234638' )
                                                         THEN 30
                                                         ELSE 1
                                                    END
                                               ELSE 1
                                          END ) )     -- and k.num_conc = @ntiponom
                        AND k.mes_operacion = @nMes
                        AND k.ayo_operacion = @nAyo
                GROUP BY k.empresa ,
                        k.codigo ,
                        k.num_conc ,
                        ll.clase ,
                        ll.centro ,
                        ll.sueldo ,
                        ll.saldiaint ,
                        ll.horario ,
                        k.dias ,
                        k.inc ,
                        k.aus ,
                        k.impor_base ,
                        k.diastr ,
                        k.dias_imss ,
                        k.fch_inicio ,
                        k.saldiaint ,
               --null as fchnac,--e.fchnac,
                        ll.ocupacion ,
               --0 as supervisor,--ll.supervisor,
                        ll.fchalta ,
                        ll.fchantigua ,
                        k.fch_cierre ,
                        k.importe ,
                        k.descuento
                ORDER BY k.codigo ,
                        k.num_conc ,
                        k.fch_inicio

--select * from dbo.p_kardex_tmp where num_conc=41




            PRINT 'k_002'

   -- tabla temporal
            IF OBJECT_ID('dbo.p_kardex_cond') IS NOT NULL 
                DROP TABLE dbo.p_kardex_cond

            PRINT 'j_1'

            IF @cque_calcula = 'MS' 
                BEGIN
                    PRINT 'j_2'
                    SELECT DISTINCT
                            k1.empresa ,
                            k1.codigo AS 'ncodigo' ,
                            @npercep AS 'serial' ,
                            k1.fch_inicio ,
                            k1.fch_cierre ,
                            k1.impor_base AS 'nsdo' ,
                            k1.saldiaint AS 'nsdimss' ,
                            ( SELECT    SUM(k2.dias)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) AS 'nds' , --and k2.num_conc in (1,2,3,4,5,6,7,30)) as 'nds',
                            ( SELECT    SUM(k2.inc)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) AS 'ninc' , --and k2.num_conc in (109,110,111)) as 'ninc',
                            ( SELECT    SUM(k2.aus)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) AS 'naus' , --and k2.num_conc = 108) as 'naus',
                            ( SELECT    SUM(k2.dias)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) - --and k2.num_conc in (1,2,3,4,5,6,7,30)) -
               ( SELECT SUM(k2.inc)
                 FROM   dbo.p_kardex_tmp AS k2
                 WHERE  k2.codigo = k1.codigo
               ) - --and k2.num_conc in (109,110,111)) -
               ( SELECT SUM(k2.aus)
                 FROM   dbo.p_kardex_tmp AS k2
                 WHERE  k2.codigo = k1.codigo
               ) AS 'ndiastr' , --and k2.num_conc = 108) as 'ndstr'
                            k1.saldf ,
                            k1.salmin ,
                            @npercep AS 'ntotcond' ,
                            @npercep AS 'ntotcond_per' ,
                            @ndeducc AS 'ntotcond_ded' ,
                            k1.nfactus ,
                            ntiponom ,
                            k1.nhorario ,
                            k1.ntabular ,
                            k1.nsupervisor ,
                            k1.dfchalta ,
                            k1.dfchantigua AS 'dantigua' ,
                            k1.dfchnac ,
                            k1.dfchinicio AS 'dinicio' ,
                            k1.dfchcierre AS 'dcierre' ,
                            k1.dfchpago AS 'dpago' ,
                            k1.fol_tmp,
							k1.nDsReales as nDsReales
                    INTO    dbo.p_kardex_cond
                    FROM    dbo.p_kardex_tmp AS k1
                    WHERE   SUBSTRING(LTRIM(STR(100000000 + k1.codigo)), 2, 8)
                            + SUBSTRING(LTRIM(STR(10000 + YEAR(k1.fch_inicio))),
                                        2, 4) + SUBSTRING(LTRIM(STR(100
                                                              + MONTH(k1.fch_inicio))),
                                                          2, 2)
                            + SUBSTRING(LTRIM(STR(100 + DAY(k1.fch_inicio))),
                                        2, 2) = ( SELECT TOP 1
                                                            SUBSTRING(LTRIM(STR(100000000
                                                              + k2.codigo)), 2,
                                                              8)
                                                            + SUBSTRING(LTRIM(STR(10000
                                                              + YEAR(k2.fch_inicio))),
                                                              2, 4)
                                                            + SUBSTRING(LTRIM(STR(100
                                                              + MONTH(k2.fch_inicio))),
                                                              2, 2)
                                                            + SUBSTRING(LTRIM(STR(100
                                                              + DAY(k2.fch_inicio))),
                                                              2, 2)
                                                  FROM      dbo.p_kardex_tmp
                                                            AS k2
                                                  WHERE     k1.codigo = k2.codigo
                                                            AND k1.empresa = k2.empresa
                                                  ORDER BY  k2.codigo ,
                                                            k2.fch_inicio ,
                                                            k2.fol_tmp DESC
                                                )

                    SET @ncodigo = 0
                    SET @nfolio = 0
                    SET @nfol_tmp = 0

                    UPDATE  dbo.p_kardex_cond
                    SET     @nfolio = CASE WHEN @ncodigo <> ncodigo
                                                AND @nfol_tmp <> fol_tmp
                                           THEN 0
                                           ELSE @nfolio
                                      END ,
                            @nfolio = @nfolio + 1 ,
                            serial = @nfolio ,
                   --serial   = case when @nfolio > 1 then 0 else @nfolio end,
                            @ncodigo = ncodigo ,
                            @nfol_tmp = fol_tmp

        --delete kardex_cond where serial = 0
        --select * from kardex_cond order by ncodigo, serial  --where ncodigo = 10 or ncodigo = 221

--drop table p_kardex_tmp

                END
            ELSE 
                BEGIN
                    PRINT 'j_3'
                    SELECT DISTINCT
                            k1.empresa ,
                            k1.codigo AS 'ncodigo' ,
                            @npercep AS 'serial' ,
                            k1.fch_inicio ,
                            k1.fch_cierre ,
                            k1.impor_base AS 'nsdo' ,
                            k1.saldiaint AS 'nsdimss' ,
                            ( SELECT    SUM(k2.dias)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) AS 'nds' , --and k2.num_conc in (1,2,3,4,5,6,7,30)) as 'nds',
                            ( SELECT    SUM(k2.inc)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) AS 'ninc' , --and k2.num_conc in (109,110,111)) as 'ninc',
                            ( SELECT    SUM(k2.aus)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) AS 'naus' , --and k2.num_conc = 108) as 'naus',
                            ( SELECT    SUM(k2.dias)
                              FROM      dbo.p_kardex_tmp AS k2
                              WHERE     k2.codigo = k1.codigo
                            ) - --and k2.num_conc in (1,2,3,4,5,6,7,30)) -
               ( SELECT SUM(k2.inc)
                 FROM   dbo.p_kardex_tmp AS k2
                 WHERE  k2.codigo = k1.codigo
               ) - --and k2.num_conc in (109,110,111)) -
               ( SELECT SUM(k2.aus)
                 FROM   dbo.p_kardex_tmp AS k2
                 WHERE  k2.codigo = k1.codigo
               ) AS 'ndiastr' , --and k2.num_conc = 108) as 'ndstr'
                            k1.saldf ,
                            k1.salmin ,
                            @npercep AS 'ntotcond' ,
                            @npercep AS 'ntotcond_per' ,
                            @ndeducc AS 'ntotcond_ded' ,
                            k1.nfactus ,
                            ntiponom ,
                            k1.nhorario ,
                            k1.ntabular ,
                            k1.nsupervisor ,
                            k1.dfchalta ,
                            k1.dfchantigua AS 'dantigua' ,
                            k1.dfchnac ,
                            k1.dfchinicio AS 'dinicio' ,
                            k1.dfchcierre AS 'dcierre' ,
                            k1.dfchpago AS 'dpago' ,
                            0 AS 'fol_tmp'
                    INTO    dbo.p_kardex_cond
                    FROM    dbo.p_kardex_tmp AS k1
                    WHERE   SUBSTRING(LTRIM(STR(100000000 + k1.codigo)), 2, 8)
                            + SUBSTRING(LTRIM(STR(10000 + YEAR(k1.fch_inicio))),
                                        2, 4) + SUBSTRING(LTRIM(STR(100
                                                              + MONTH(k1.fch_inicio))),
                                                          2, 2)
                            + SUBSTRING(LTRIM(STR(100 + DAY(k1.fch_inicio))),
                                        2, 2) = ( SELECT TOP 1
                                                            SUBSTRING(LTRIM(STR(100000000
                                                              + k2.codigo)), 2,
                                                              8)
                                                            + SUBSTRING(LTRIM(STR(10000
                                                              + YEAR(k2.fch_inicio))),
                                                              2, 4)
                                                            + SUBSTRING(LTRIM(STR(100
                                                              + MONTH(k2.fch_inicio))),
                                                              2, 2)
                                                            + SUBSTRING(LTRIM(STR(100
                                                              + DAY(k2.fch_inicio))),
                                                              2, 2)
                                                  FROM      dbo.p_kardex_tmp
                                                            AS k2
                                                  WHERE     k1.codigo = k2.codigo
                                                  ORDER BY  k2.codigo ,
                                                            k2.fch_inicio DESC
                                                )
			--select * from dbo.p_kardex_cond-- where num_conc=41
                    SET @ncodigo = 0
                    SET @nfolio = 0

                    UPDATE  dbo.p_kardex_cond
                    SET     @nfolio = CASE WHEN @ncodigo <> ncodigo THEN 0
                                           ELSE @nfolio
                                      END ,
                            @nfolio = @nfolio + 1 ,
                            serial = CASE WHEN @nfolio > 1 THEN 0
                                          ELSE @nfolio
                                     END ,
                            @ncodigo = ncodigo

                    DELETE  dbo.p_kardex_cond
                    WHERE   serial = 0 --cuidado con el serial
                END




   --select 'b2'
   --select * from kardex_cond order by ncodigo





            IF OBJECT_ID('dbo.p_kardex_res') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.p_kardex_res
                END

            IF @cque_calcula = 'MS' 
                SELECT DISTINCT
                        k1.empresa ,
                        k1.codigo ,
                        @nnum_conc AS 'num_conc' ,
                        @cconcepto AS 'concepto' ,
                        @cclase AS 'clase' ,
                        @ccentro AS 'centro' ,
                        k1.folio ,
                        @npercep AS 'importe' ,
                        @npercep AS 'isr' ,
                        @npercep AS 'imss' ,
                        @npercept AS 'ntotpercep' ,
                        @npercept AS 'ntotpercep3' ,
                        k1.fol_tmp
                INTO    dbo.p_kardex_res
                FROM    dbo.p_kardex_tmp AS k1

            ELSE 
                SELECT DISTINCT
                        k1.empresa ,
                        k1.codigo ,
                        @nnum_conc AS 'num_conc' ,
                        @cconcepto AS 'concepto' ,
                        @cclase AS 'clase' ,
                        @ccentro AS 'centro' ,
                        k1.folio ,
                        @npercep AS 'importe' ,
                        @npercep AS 'isr' ,
                        @npercep AS 'imss' ,
                        @npercept AS 'ntotpercep' ,
                        @npercept AS 'ntotpercep3' ,
                        0 AS 'fol_tmp'
                INTO    dbo.p_kardex_res
                FROM    dbo.p_kardex_tmp AS k1
                
                
                --SELECT * FROM p_kardex_res WHERE num_conc=216

--if @nnum_conc = 98
--   begin
--     select * from kardex_res where codigo = 10 or codigo = 221
--     select * from kardex_cond where ncodigo = 10 or ncodigo = 221
--   end


    --select 'b3'
    --select * from kardex_res order by codigo



   -- importes totales para cuando SI cumple la condicion



            IF LEN(@ctotales) > 0 
                BEGIN
					
					SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)

					declare @SSSSS varchar(max)
					declare @tots varchar(max)
					set @tots = @ctotales
					set @tots = replace(@ctotales,'{','')
					set @tots = replace(@tots,'}','')
					
					
					set @SSSSS = 'update k1 set k1.percep_tot = (select isnull(sum(k2.importe),0) from dbo.p_kardex as k2 '
                    + ' where k1.empresa=k2.empresa and k1.codigo = k2.codigo and k2.id_presup=' + str(@id_presup) + ' and k2.mes_operacion=' + @cMes  + ' and k2.ayo_operacion=' + @cAyo + ' and k2.num_conc in (' + @Tots + ') and k2.tpago_desc = ' + @cpago_desc + ' and k2.nomina = ' + @cnomina_gion + ') from dbo.p_kardex_tmp as k1'
                    PRINT '1'
                    
					Print(@SSSSS)
					EXEC(@SSSSS)


                    IF @nnum_conc > 100
                        AND @nnum_conc < 200 
                        BEGIN
                            IF @cconvales = 'S' 
                                IF CHARINDEX('31', @ctotales) > 0 
                                    UPDATE  k
                                    SET     k.percep_tot = k.percep_tot
                                            + ISNULL(( SELECT d.total
                                                       FROM   dbo.p_despensas
                                                              AS d
                                                       WHERE  d.id_presup = @id_presup
                                                              AND d.empresa IN (
                                                              SELECT
                                                              empresa
                                                              FROM
                                                              dbo.p_empresas
                                                              WHERE
                                                              id_presup = @id_presup )
                                                              AND d.nomina = 'V'
                                                              AND d.codigo = k.codigo
                                                     ), 0)
                                    FROM    dbo.p_kardex_tmp AS k
                                    WHERE   k.empresa IN (
                                            SELECT  empresa
                                            FROM    dbo.p_empresas
                                            WHERE   id_presup = @id_presup )

                        END


--select 'b4'
--select * from p_kardex_tmp order by codigo

                    PRINT '2'

                    SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)

					declare @SSSSS2 varchar(max)
					declare @tots2 varchar(2500)
					set @tots2 = @ctotales
					set @tots2 = replace(@ctotales,'{','')
					set @tots2 = replace(@tots2,'}','')
					set @SSSSS2 = 'update k1 set k1.deducc_tot =
                    (select case when sum(k2.importe) is null then 0 else sum(k2.importe) end
                    from dbo.p_kardex as k2
                    where k1.empresa=k2.empresa and k1.codigo = k2.codigo and k2.id_presup=' + cast(@id_presup as varchar(12))  + ' and k2.mes_operacion=' + @cMes  + ' and k2.ayo_operacion=' + @cAyo + ' ' +' 
                    and k2.num_conc in (' + @tots2 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    from dbo.p_kardex_tmp as k1'

                    print(@SSSSS2)
					EXEC(@SSSSS2)

             --asi estaba
             --where k2.empresa = ' + @nempresa + ' and k1.codigo = k2.codigo and k2.num_conc in (' + @ctotales + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')     
--select 'b5'
--select * from p_kardex_tmp order by codigo


                    PRINT '3'

        -- SR.- percepciones menos deducciones
        -- RS.- deducciones menos percepciones
        -- SS.- percepciones mas deducciones

                    UPDATE  dbo.p_kardex_tmp
                    SET     ntotpercep = CASE WHEN @cpercep = 'S'
                                                   AND @cdeducc = 'R'
                                              THEN percep_tot - deducc_tot
                                              WHEN @cpercep = 'R'
                                                   AND @cdeducc = 'S'
                                              THEN deducc_tot - percep_tot
                                              WHEN @cpercep = 'S'
                                                   AND @cdeducc = 'S'
                                              THEN percep_tot + deducc_tot
                                              ELSE 0
                                         END

--select 'a2'
--select * from p_kardex_tmp order by codigo


                END

--select * from p_kardex_tmp

            PRINT '4'
            PRINT @ctotales3

   -- importes totales para NO cumple la condicion
            IF LEN(@ctotales3)> 0  and @ctotales3<>'{000}'
                BEGIN
                    SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)
                    EXEC('update k1 set k1.percep_tot3 =
                    (select case when sum(k2.importe) is null then 0 else sum(k2.importe) end
                    from dbo.p_kardex as k2
                    where k1.empresa=k2.empresa and k1.codigo = k2.codigo and k2.id_presup=' + @id_presup  + ' and k2.mes_operacion=' + @cMes  + ' and k2.ayo_operacion=' + @cAyo + ' ' +' 
                    and k2.num_conc in (' + @ctotales3 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    from dbo.p_kardex_tmp as k1')

 
      --asi estaba  
      --where k2.empresa = ' + @nempresa + ' and k1.codigo = k2.codigo and k2.num_conc in (' + @ctotales3 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    PRINT '5'


                    SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                    EXEC('update k1 set k1.deducc_tot3 =
                    (select case when sum(k2.importe) is null then 0 else sum(k2.importe) end
                    from dbo.p_kardex as k2
                    where k1.empresa=k2.empresa and k1.codigo = k2.codigo and k2.id_presup=' + @id_presup  + ' and k2.mes_operacion=' + @cMes  + ' and k2.ayo_operacion=' + @cAyo + ' ' +'
                    and k2.num_conc in (' + @ctotales3 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    from dbo.p_kardex_tmp as k1')

             --asi estaba
             --where k2.empresa = ' + @nempresa + ' and k1.codigo = k2.codigo and k2.num_conc in (' + @ctotales3 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    PRINT '6'
        -- SR.- percepciones menos deducciones
        -- RS.- deducciones menos percepciones
        -- SS.- percepciones mas deducciones
                    UPDATE  dbo.p_kardex_tmp
                    SET     ntotpercep3 = CASE WHEN @cpercep3 = 'S'
                                                    AND @cdeducc3 = 'R'
                                               THEN percep_tot3 - deducc_tot3
                                               WHEN @cpercep3 = 'R'
                                                    AND @cdeducc3 = 'S'
                                               THEN deducc_tot3 - percep_tot3
                                               WHEN @cpercep3 = 'S'
                                                    AND @cdeducc3 = 'S'
                                               THEN percep_tot3 + deducc_tot3
                                               ELSE 0
                                          END

                END
            PRINT '7'
--print @ctotales2


   -- importes totales para la condicion
            IF LEN(@ctotales2) > 0 
                BEGIN
                    SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)
                    EXEC('update k1 set k1.ntotcond_per =
                    (select case when sum(k2.importe) is null then 0 else sum(k2.importe) end
                    from dbo.p_kardex as k2
                    where k1.empresa=k2.empresa and k1.ncodigo = k2.codigo and k2.id_presup=' + @id_presup  + ' and k2.mes_operacion=' + @cMes  + ' and k2.ayo_operacion=' + @cAyo + ' ' +'
                    and k2.num_conc in (' + @ctotales2 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    from dbo.p_kardex_cond as k1')

          --asi estaba
          --where k2.empresa = ' + @nempresa + ' and k1.ncodigo = k2.codigo and k2.num_conc in (' + @ctotales2 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    PRINT '8'
                    SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                    EXEC('update k1 set k1.ntotcond_ded =
                    (select case when sum(k2.importe) is null then 0 else sum(k2.importe) end
                    from dbo.p_kardex as k2
                    where k1.empresa=k2.empresa and k1.ncodigo = k2.codigo and k2.id_presup=' + @id_presup  + ' and k2.mes_operacion=' + @cMes  + ' and k2.ayo_operacion=' + @cAyo + ' ' +'
                    and k2.num_conc in (' + @ctotales2 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
                    from dbo.p_kardex_cond as k1')

          --asi estaba
          --where k2.empresa = ' + @nempresa + ' and k1.ncodigo = k2.codigo and k2.num_conc in (' + @ctotales2 + ') and k2.tpago_desc = ' + @cpago_desc + ' and nomina = ' + @cnomina_gion + ')
           
                    PRINT '9'
          -- SR.- percepciones menos deducciones
          -- RS.- deducciones menos percepciones
          -- SS.- percepciones mas deducciones
                    UPDATE  dbo.p_kardex_cond
                    SET     ntotcond = CASE WHEN @cpercep2 = 'S'
                                                 AND @cdeducc2 = 'R'
                                            THEN ntotcond_per - ntotcond_ded
                                            WHEN @cpercep2 = 'R'
                                                 AND @cdeducc2 = 'S'
                                            THEN ntotcond_ded - ntotcond_per
                                            WHEN @cpercep2 = 'S'
                                                 AND @cdeducc2 = 'S'
                                            THEN ntotcond_per + ntotcond_ded
                                            ELSE 0
                                       END
                END

	--aqui
   -- acumulados 1 --
   -- ----------------------------------------------------------------------
   -- es por rango de periodos  (1)
            IF CONVERT(INT, @cperini1) > 0
                AND CONVERT(INT, @cperfin1) > 0 
                BEGIN
                    IF LEN(@cacumulado1) > 0 
                        BEGIN

                            PRINT '10'

                            SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)

                            EXEC('update k1 set ' + @cfldper1 + ' = (select sum(' + @cfldacu1 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +')and
                            k2.codigo        = k1.codigo           and
                            k2.tiponom       = '  + @ntiponom + '  and
                            k2.ayo_operacion = '  + @nayo     + '  and
                            k2.periodo       >= ' + @cperini1 + '  and
                            k2.periodo       <= ' + @cperfin1 + '  and
                            k2.num_conc in (' + @cacumulado1  + ') and
                            k2.tpago_desc = ' + @cpago_desc   + ')
                            from dbo.p_kardex_tmp as k1')
                      --asi estaba --where k2.empresa       = ' + @nempresa  + '  and

                -- para los importes que sean nulos poner ceros
                --   porque si no al momento de hacer la suma o resta
                --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldper1 + ' = 0
                            where ' + @cfldper1 + ' is null')


                            PRINT '11'

                            SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                            EXEC('update k1 set ' + @cfldded1 + ' = (select sum(' + @cfldacu1 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                            k2.codigo        = k1.codigo           and
                            k2.tiponom       = '  + @ntiponom + '  and
                            k2.ayo_operacion = '  + @nayo     + '  and
                            k2.periodo       >= ' + @cperini1 + '  and
                            k2.periodo       <= ' + @cperfin1 + '  and
                            k2.num_conc in (' + @cacumulado1  + ') and
                            k2.tpago_desc = ' + @cpago_desc   + ')
                            from dbo.p_kardex_tmp as k1')

                --asi estaba -- where k2.empresa       = ' + @nempresa  + '  and
                -- para los importes que sean nulos poner ceros
                --   porque si no al momento de hacer la suma o resta
                --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldded1 + ' = 0
                            where ' + @cfldded1 + ' is null')


                -- SR.- percepciones menos deducciones
                -- RS.- deducciones menos percepciones
                -- SS.- percepciones mas deducciones
                            PRINT '12'

                            EXEC('update dbo.p_kardex_tmp set ' + @cfldimp1 + ' = case when ' + @cperacu1 + ' = ' + @csuma  + ' and ' + @cdedacu1 + ' = ' + @cresta + ' then ' + @cfldper1 + ' - ' + @cfldded1 + '
                            when ' + @cperacu1 + ' = ' + @cresta + ' and ' + @cdedacu1 + ' = ' + @csuma  + ' then ' + @cfldper1 + ' - ' + @cfldded1 + '
                            when ' + @cperacu1 + ' = ' + @csuma  + ' and ' + @cdedacu1 + ' = ' + @csuma  + ' then ' + @cfldper1 + ' - ' + @cfldded1 + '
                            else 0
                            end')
                        END
                END



   -- ----------------------------------------------------------------------
   -- por periodos anteriores    (1)
            ELSE 
                PRINT 'per_1.- '
            PRINT @cperini1
            PRINT CONVERT(INT, @cperini1)
            PRINT 'per_2.- '
            PRINT CONVERT(INT, @cperfin1)
            PRINT @cperfin1

            IF CONVERT(INT, @cperini1) > 0
                AND CONVERT(INT, @cperfin1) = 0 
                BEGIN
                    IF LEN(@cacumulado1) > 0 
                        BEGIN
                            SET @cestatus = 'C'
                            PRINT '13'

                    -- saca el periodo inmediato anterior al actual
                            SELECT TOP 1
                                    @cperiodo1 = LTRIM(STR(p.ayo_operacion))
                                    + SUBSTRING(LTRIM(STR(100 + p.periodo)), 2,
                                                2)
                            FROM    dbo.periodos AS p
                            WHERE   p.empresa IN (
                                    SELECT  empresa
                                    FROM    dbo.p_empresas
                                    WHERE   id_presup = @id_presup )
                                    AND p.tiponom = @ntiponom
                                    AND p.estatus = @cestatus
                                    AND p.inicio < @dfchinicio
                            ORDER BY p.inicio DESC

                            SET @cestatus = CHAR(39) + 'C' + CHAR(39)

                            IF OBJECT_ID('dbo.tmp_per') IS NOT NULL 
                                DROP TABLE dbo.tmp_per

                            PRINT '14'

                    -- saca el ultimo periodo deseado
                            EXEC('select top ' + @cperini1 + ' ltrim(str(ayo_operacion)) + substring(ltrim(str(100 + periodo)),2,2) as ' + @cestatus + '
                            into dbo.tmp_per
                            from dbo.periodos
                            where empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                            tiponom = ' + @ntiponom + ' and
                            estatus = ' + @cestatus + ' and
                            inicio < ' + @cfchinicio + '
                            order by inicio desc')

                            SELECT  @cperiodo2 = c
                            FROM    dbo.tmp_per

                            IF OBJECT_ID('dbo.tmp_per') IS NOT NULL 
                                DROP TABLE dbo.tmp_per

                            PRINT '15'

                            SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)

                            EXEC('update k1 set ' + @cfldper1 + ' = (select sum(' + @cfldacu1 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                            k2.tiponom       = ' + @ntiponom + ' and
                            ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) >= ' + @cperiodo2 + ' and
                            ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) <= ' + @cperiodo1 + ' and
                            k2.codigo        = k1.codigo         and
                            k2.num_conc      in (' + @cacumulado1 + ') and
                            k2.tpago_desc    = ' + @cpago_desc + ')
                            from dbo.p_kardex_tmp as k1')


                    -- para los importes que sean nulos poner ceros
                    --   porque si no al momento de hacer la suma o resta
                    --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldper1 + ' = 0
                            where ' + @cfldper1 + ' is null')


--select * from p_kardex_tmp


                            PRINT '16'

                            SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                            EXEC('update k1 set ' + @cfldded1 + ' = (select sum(' + @cfldacu1 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                            k2.tiponom       = ' + @ntiponom + ' and
                            ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) >= ' + @cperiodo2 + ' and
                            ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) <= ' + @cperiodo1 + ' and
                            k2.codigo        = k1.codigo         and
                            k2.num_conc      in (' + @cacumulado1 + ') and
                            k2.tpago_desc    = ' + @cpago_desc + ')
                            from dbo.p_kardex_tmp as k1')

                    -- para los importes que sean nulos poner ceros
                    --   porque si no al momento de hacer la suma o resta
                    --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldded1 + ' = 0
                            where ' + @cfldded1 + ' is null')

                            PRINT '17'


                            EXEC('update dbo.p_kardex_tmp set ' + @cfldimp1 + ' = case when ' + @cperacu1 + ' = ' + @csuma  + ' and ' + @cdedacu1 + ' = ' + @cresta + ' then ' + @cfldper1 + ' - ' + @cfldded1 + '
                            when ' + @cperacu1 + ' = ' + @cresta + ' and ' + @cdedacu1 + ' = ' + @csuma  + ' then ' + @cfldper1 + ' - ' + @cfldded1 + '
                            when ' + @cperacu1 + ' = ' + @csuma  + ' and ' + @cdedacu1 + ' = ' + @csuma  + ' then ' + @cfldper1 + ' - ' + @cfldded1 + '
                            else 0
                            end')

--select * from p_kardex_tmp

                        END
                END



   -- ----------------------------------------------------------------------
   -- es por rango de periodos  (2)
            IF CONVERT(INT, @cperini2) > 0
                AND CONVERT(INT, @cperfin2) > 0 
                BEGIN
                    IF LEN(@cacumulado2) > 0 
                        BEGIN

                            PRINT '18'
                            SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)
                            EXEC('update k1 set ' + @cfldper2 + ' = (select sum(' + @cfldacu2 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +')  and
                            k2.codigo        = k1.codigo           and
                            k2.tiponom       = '  + @ntiponom + '  and
                            k2.ayo_operacion = '  + @nayo     + '  and
                            k2.periodo       >= ' + @cperini2 + '  and
                            k2.periodo       <= ' + @cperfin2 + '  and
                            k2.num_conc in (' + @cacumulado2  + ') and
                            k2.tpago_desc = ' + @cpago_desc   + ')
                            from dbo.p_kardex_tmp as k1')


                 -- para los importes que sean nulos poner ceros
                 --   porque si no al momento de hacer la suma o resta
                 --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldper2 + ' = 0
                            where ' + @cfldper2 + ' is null')

                            PRINT '19'

                            SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                            EXEC('update k1 set ' + @cfldded2 + ' = (select sum(' + @cfldacu2 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                            k2.codigo        = k1.codigo           and
                            k2.tiponom       = '  + @ntiponom + '  and
                            k2.ayo_operacion = '  + @nayo     + '  and
                            k2.periodo       >= ' + @cperini2 + '  and
                            k2.periodo       <= ' + @cperfin2 + '  and
                            k2.num_conc in (' + @cacumulado2  + ') and
                            k2.tpago_desc = ' + @cpago_desc   + ')
                            from dbo.p_kardex_tmp as k1')


                 -- para los importes que sean nulos poner ceros
                 --   porque si no al momento de hacer la suma o resta
                 --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldded2 + ' = 0
                            where ' + @cfldded2 + ' is null')


                 -- SR.- percepciones menos deducciones
                 -- RS.- deducciones menos percepciones
                 -- SS.- percepciones mas deducciones

                            PRINT '20'
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldimp2 + ' = case when ' + @cperacu2 + ' = ' + @csuma  + ' and ' + @cdedacu2 + ' = ' + @cresta + ' then ' + @cfldper2 + ' - ' + @cfldded2 + '
                            when ' + @cperacu2 + ' = ' + @cresta + ' and ' + @cdedacu2 + ' = ' + @csuma  + ' then ' + @cfldper2 + ' - ' + @cfldded2 + '
                            when ' + @cperacu2 + ' = ' + @csuma  + ' and ' + @cdedacu2 + ' = ' + @csuma  + ' then ' + @cfldper2 + ' - ' + @cfldded2 + '
                            else 0
                            end')
                        END
                END



   -- ----------------------------------------------------------------------
   -- por periodos anteriores   (2)
            ELSE 
                IF CONVERT(INT, @cperini2) > 0
                    AND CONVERT(INT, @cperfin2) = 0 
                    BEGIN
                        IF LEN(@cacumulado2) > 0 
                            BEGIN
                                SET @cestatus = 'C'

                                PRINT '21'
                    -- saca el periodo inmediato anterior al actual
                                SELECT TOP 1
                                        @cperiodo2 = LTRIM(STR(p.ayo_operacion))
                                        + SUBSTRING(LTRIM(STR(100 + p.periodo)),
                                                    2, 2)
                                FROM    dbo.periodos AS p
                                WHERE   p.empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = ' + @id_presup +' )
                                        AND p.tiponom = @ntiponom
                                        AND p.estatus = @cestatus
                                        AND p.inicio < @dfchinicio
                                ORDER BY p.inicio DESC

                                SET @cestatus = CHAR(39) + 'C' + CHAR(39)

                                IF OBJECT_ID('dbo.tmp_per') IS NOT NULL 
                                    DROP TABLE dbo.tmp_per

                                PRINT '22'

                    -- saca el ultimo periodo deseado
                                EXEC('select top ' + @cperini2 + ' ltrim(str(ayo_operacion)) + substring(ltrim(str(100 + periodo)),2,2) as ' + @cestatus + '
                                into dbo.tmp_per
                                from dbo.periodos
                                where empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                tiponom = ' + @ntiponom + ' and
                                estatus = ' + @cestatus + ' and
                                inicio < ' + @cfchinicio + '
                                order by inicio desc')

                                SELECT  @cperiodo2 = c
                                FROM    dbo.tmp_per

                                IF OBJECT_ID('dbo.tmp_per') IS NOT NULL 
                                    DROP TABLE dbo.tmp_per


                                PRINT '23'
                                PRINT @cfldper2
                                PRINT @cfldacu2

                                SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)

                                EXEC('update k1 set ' + @cfldper2 + ' = (select sum(' + @cfldacu2 + ')
                                from dbo.kardex_anual as k2
                                where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                k2.tiponom       = ' + @ntiponom + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) >= ' + @cperiodo2 + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) <= ' + @cperiodo1 + ' and
                                k2.codigo        = k1.codigo         and
                                k2.num_conc      in (' + @cacumulado2 + ') and
                                k2.tpago_desc    = ' + @cpago_desc + ')
                                from dbo.p_kardex_tmp as k1')

--select * from p_kardex_tmp where codigo = 1723 or codigo = 5150


                    -- para los importes que sean nulos poner ceros
                    --   porque si no al momento de hacer la suma o resta
                    --   es valor resultado de nulo
                                EXEC('update dbo.p_kardex_tmp set ' + @cfldper2 + ' = 0
                                where ' + @cfldper2 + ' is null')

                                PRINT '24'

                                SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                                EXEC('update k1 set ' + @cfldded2 + ' = (select sum(' + @cfldacu2 + ')
                                from dbo.kardex_anual as k2
                                where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                k2.tiponom       = ' + @ntiponom + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) >= ' + @cperiodo2 + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) <= ' + @cperiodo1 + ' and
                                k2.codigo        = k1.codigo         and
                                k2.num_conc      in (' + @cacumulado2 + ') and
                                k2.tpago_desc    = ' + @cpago_desc + ')
                                from dbo.p_kardex_tmp as k1')

--select * from p_kardex_tmp where codigo = 1723 or codigo = 5150



                    -- para los importes que sean nulos poner ceros
                    --   porque si no al momento de hacer la suma o resta
                    --   es valor resultado de nulo
                                EXEC('update dbo.p_kardex_tmp set ' + @cfldded2 + ' = 0
                                where ' + @cfldded2 + ' is null')

                                PRINT '25'

                                EXEC('update dbo.p_kardex_tmp set ' + @cfldimp2 + ' = case when ' + @cperacu2 + ' = ' + @csuma  + ' and ' + @cdedacu2 + ' = ' + @cresta + ' then ' + @cfldper2 + ' - ' + @cfldded2 + '
                                when ' + @cperacu2 + ' = ' + @cresta + ' and ' + @cdedacu2 + ' = ' + @csuma  + ' then ' + @cfldper2 + ' - ' + @cfldded2 + '
                                when ' + @cperacu2 + ' = ' + @csuma  + ' and ' + @cdedacu2 + ' = ' + @csuma  + ' then ' + @cfldper2 + ' - ' + @cfldded2 + '
                                else 0
                                end')

--select * from p_kardex_tmp where codigo = 1723 or codigo = 5150
                            END
                    END





   -- ----------------------------------------------------------------------
   -- es por rango de periodos  (3)
            IF CONVERT(INT, @cperini3) > 0
                AND CONVERT(INT, @cperfin3) > 0 
                BEGIN
                    IF LEN(@cacumulado1) > 0 
                        BEGIN
                            PRINT '26'
                            SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)
                            EXEC('update k1 set ' + @cfldper3 + ' = (select sum(' + @cfldacu3 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +')  and
                            k2.codigo        = k1.codigo           and
                            k2.tiponom       = '  + @ntiponom + '  and
                            k2.ayo_operacion = '  + @nayo     + '  and
                            k2.periodo       >= ' + @cperini2 + '  and
                            k2.periodo       <= ' + @cperfin2 + '  and
                            k2.num_conc in (' + @cacumulado3  + ') and
                            k2.tpago_desc = ' + @cpago_desc   + ')
                            from dbo.p_kardex_tmp as k1')


                -- para los importes que sean nulos poner ceros
                --   porque si no al momento de hacer la suma o resta
                --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldper3 + ' = 0
                            where ' + @cfldper3 + ' is null')

                            PRINT '27'

                            SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                            EXEC('update k1 set ' + @cfldded3 + ' = (select sum(' + @cfldacu3 + ')
                            from dbo.kardex_anual as k2
                            where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                            k2.codigo        = k1.codigo           and
                            k2.tiponom       = '  + @ntiponom + '  and
                            k2.ayo_operacion = '  + @nayo     + '  and
                            k2.periodo       >= ' + @cperini2 + '  and
                            k2.periodo       <= ' + @cperfin2 + '  and
                            k2.num_conc in (' + @cacumulado3  + ') and
                            k2.tpago_desc = ' + @cpago_desc   + ')
                            from dbo.p_kardex_tmp as k1')


                -- para los importes que sean nulos poner ceros
                --   porque si no al momento de hacer la suma o resta
                --   es valor resultado de nulo
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldded3 + ' = 0
                            where ' + @cfldded3 + ' is null')


                -- SR.- percepciones menos deducciones
                -- RS.- deducciones menos percepciones
                -- SS.- percepciones mas deducciones
                            PRINT '28'
                            EXEC('update dbo.p_kardex_tmp set ' + @cfldimp3 + ' = case when ' + @cperacu3 + ' = ' + @csuma  + ' and ' + @cdedacu3 + ' = ' + @cresta + ' then ' + @cfldper3 + ' - ' + @cfldded3 + '
                            when ' + @cperacu3 + ' = ' + @cresta + ' and ' + @cdedacu3 + ' = ' + @csuma  + ' then ' + @cfldper3 + ' - ' + @cfldded3 + '
                            when ' + @cperacu3 + ' = ' + @csuma  + ' and ' + @cdedacu3 + ' = ' + @csuma  + ' then ' + @cfldper3 + ' - ' + @cfldded3 + '
                            else 0
                            end')
                        END
                END



   -- ------------------------------------------------------------------------
   -- por periodos anteriores   (3)
            ELSE 
                IF CONVERT(INT, @cperini3) > 0
                    AND CONVERT(INT, @cperfin3) = 0 
                    BEGIN
                        IF LEN(@cacumulado3) > 0 
                            BEGIN
                                SET @cestatus = 'C'

                                PRINT '29'

                    -- saca el periodo inmediato anterior al actual
                                SELECT TOP 1
                                        @cperiodo2 = LTRIM(STR(p.ayo_operacion))
                                        + SUBSTRING(LTRIM(STR(100 + p.periodo)),
                                                    2, 2)
                                FROM    dbo.periodos AS p
                                WHERE   p.empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
                                        AND p.tiponom = @ntiponom
                                        AND p.estatus = @cestatus
                                        AND p.inicio < @dfchinicio
                                ORDER BY p.inicio DESC

                                SET @cestatus = CHAR(39) + 'C' + CHAR(39)

                                IF OBJECT_ID('dbo.tmp_per') IS NOT NULL 
                                    DROP TABLE dbo.tmp_per

                                PRINT '30'

                    -- saca el ultimo periodo deseado
                                EXEC('select top ' + @cperini2 + ' ltrim(str(ayo_operacion)) + substring(ltrim(str(100 + periodo)),2,2) as ' + @cestatus + '
                                into dbo.tmp_per
                                from dbo.periodos
                                where empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                tiponom = ' + @ntiponom + ' and
                                estatus = ' + @cestatus + ' and
                                inicio < ' + @cfchinicio + '
                                order by inicio desc')

                                SELECT  @cperiodo2 = c
                                FROM    dbo.tmp_per

                                IF OBJECT_ID('dbo.tmp_per') IS NOT NULL 
                                    DROP TABLE dbo.tmp_per


                                PRINT '31'

                                SET @cpago_desc = CHAR(39) + 'P' + CHAR(39)
                                EXEC('update k1 set ' + @cfldper3 + ' = (select sum(' + @cfldacu3 + ')
                                from dbo.kardex_anual as k2
                                where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                k2.tiponom       = ' + @ntiponom + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) >= ' + @cperiodo2 + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) <= ' + @cperiodo1 + ' and
                                k2.codigo        = k1.codigo         and
                                k2.num_conc      in (' + @cacumulado3 + ') and
                                k2.tpago_desc    = ' + @cpago_desc + ')
                                from dbo.p_kardex_tmp as k1')

                    -- para los importes que sean nulos poner ceros
                    --   porque si no al momento de hacer la suma o resta
                    --   es valor resultado de nulo
                                EXEC('update dbo.p_kardex_tmp set ' + @cfldper3 + ' = 0
                                where ' + @cfldper3 + ' is null')


                                PRINT '32'

                                SET @cpago_desc = CHAR(39) + 'D' + CHAR(39)
                                EXEC('update k1 set ' + @cfldded3 + ' = (select sum(' + @cfldacu3 + ')
                                from dbo.kardex_anual as k2
                                where k2.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                k2.tiponom       = ' + @ntiponom + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) >= ' + @cperiodo2 + ' and
                                ltrim(str(k2.ayo_operacion)) + substring(ltrim(str(100 + k2.periodo)),2,2) <= ' + @cperiodo1 + ' and
                                k2.codigo        = k1.codigo         and
                                k2.num_conc      in (' + @cacumulado3 + ') and
                                k2.tpago_desc    = ' + @cpago_desc + ')
                                from dbo.p_kardex_tmp as k1')


                    -- para los importes que sean nulos poner ceros
                    --   porque si no al momento de hacer la suma o resta
                    --   es valor resultado de nulo
                                EXEC('update dbo.p_kardex_tmp set ' + @cfldded3 + ' = 0
                                where ' + @cfldded3 + ' is null')


                                PRINT '33'

                                EXEC('update dbo.p_kardex_tmp set ' + @cfldimp3 + ' = case when ' + @cperacu3 + ' = ' + @csuma  + ' and ' + @cdedacu3 + ' = ' + @cresta + ' then ' + @cfldper3 + ' - ' + @cfldded3 + '
                                when ' + @cperacu3 + ' = ' + @cresta + ' and ' + @cdedacu3 + ' = ' + @csuma  + ' then ' + @cfldper3 + ' - ' + @cfldded3 + '
                                when ' + @cperacu3 + ' = ' + @csuma  + ' and ' + @cdedacu3 + ' = ' + @csuma  + ' then ' + @cfldper3 + ' - ' + @cfldded3 + '
                                else 0
                                end')
                            END
                    END




            PRINT '34'

            IF LEN(@carreglo1) > 0 
                BEGIN
                    IF OBJECT_ID('dbo.p_tab_arr1') IS NOT NULL 
                        BEGIN
                            EXEC('update kt set kt.nvalortab1 = (select top 1 (select max(t1.importe)
                            from dbo.p_tab_arr1 as t1
                            where kc.' + @cval_tab11 + ' between t1.ele_ini and t1.ele_fin)
                            from dbo.p_kardex_cond as kc
                            where kc.ncodigo = kt.codigo and kc.empresa=kt.empresa)
                            from dbo.p_kardex_tmp as kt')
                        END
                END


            IF LEN(@carreglo2) > 0 
                BEGIN
                    IF OBJECT_ID('dbo.p_tab_arr2') IS NOT NULL 
                        BEGIN
                            EXEC('update kt set kt.nvalortab2 = (select top 1 (select t2.importe
                            from dbo.p_tab_arr2 as t2
                            where kc.' + @cval_tab21 + ' between t2.ele_ini and t2.ele_fin)
                            from dbo.p_kardex_cond as kc
                            where kc.ncodigo = kt.codigo)
                            from dbo.p_kardex_tmp as kt')
                        END
                END


   --select * from p_kardex_tmp where codigo = 5210 or codigo = 221

            PRINT 'c1 ' + @ccondicion
            PRINT 'Formula .- ' + @cformula
            PRINT 'Formula2.- ' + @cformula2
   --print 'IIF(nHorario=VAL("2").OR.nHorario=VAL("3"),VAL("5"),VAL("10"))'

            IF LEN(@ccondicion) > 0 
                BEGIN
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NSDO',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NSDIMSS',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NDS',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NINC',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NAUS',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'SALDF',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'SALMIN',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NTOTCOND',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NFACTUS',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NTIPONOM',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NHORARIO',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NTABULAR',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion,
                                                      'NSUPERVISOR', 'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'DFCHALTA',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'DANTIGUA',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'DFCHNAC',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'DINICIO',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'DCIERRE',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NCODIGO',
                                                      'kc.')
                    SET @ccondicion = dbo.checa_alias(@ccondicion, 'NDIASTR',
                                                      'kc.')
                END



            IF LEN(@cformula) > 0 
                BEGIN
                    SET @cformula = dbo.checa_alias(@cformula, 'IMPOR_BASE',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'SALDIAINT',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'DIAS', 'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'INC', 'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'AUS', 'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'SALDF', 'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'SALMIN', 'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NTOTPERCEP',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NFACTUS',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NTIPONOM',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NHORARIO',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NTABULAR',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NUPERVISOR',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'DFCHALTA',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'DFCHANTIGUA',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'DFCHNAC',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'DFCHINICIO',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'DFCHCIERRE',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NCODIGO',
                                                    'kt.')
                    SET @cformula = dbo.checa_alias(@cformula, 'NDSTR', 'kt.')

                    PRINT '2.- ' + @cformula
                    PRINT 'c2.- ' + @ccondicion

                    SET @cpago_desc = CHAR(39) + 'S' + CHAR(39)

                    IF LEN(@ccondicion) > 0
                        AND ( @cque_calcula = 'ACSNTOT'
                              OR @cque_calcula = 'ACCNTOTCI'
                              OR @cque_calcula = 'ACCNTOTSI'
                              OR @cque_calcula = 'ASC'
                              OR @cque_calcula = 'PV'
                            ) 
                        BEGIN
                            EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                            from dbo.p_kardex_tmp as kt
                            inner join dbo.p_kardex_cond as kc on kt.empresa = kc.empresa and kt.codigo = kc.ncodigo and ' + @ccondicion)

             --select 'd1'
             --select * from p_kardex_tmp order by codigo
                        END

                    ELSE 
                        BEGIN
                            SET @nposvar1 = CHARINDEX('NVAR1', @cformula)
                            SET @nposvar2 = CHARINDEX('NVAR2', @cformula)
                            SET @nposvar3 = CHARINDEX('NVAR3', @cformula)
                            SET @nposvar4 = CHARINDEX('NVAR4', @cformula)

                            IF @cque_calcula = 'MS'
                                OR @cque_calcula = 'M'
                                OR @cque_calcula = 'CM'    --and (@nposvar1 > 0 or @nposvar2 > 0 or @nposvar3 > 0 or @nposvar4 > 0)
                                BEGIN
                                    IF ( @nposvar1 > 0
                                         OR @nposvar2 > 0
                                         OR @nposvar3 > 0
                                         OR @nposvar4 > 0
                                       ) 
                                        BEGIN
                                            IF @nposvar1 > 0 
                                                BEGIN
                                                    SET @nposvar1 = CHARINDEX('NVAR1',
                                                              @cformula)
                                                    SET @cformula = SUBSTRING(@cformula,
                                                              1, @nposvar1 - 1)
                                                        + CASE
                                                              WHEN @nnum_conc >= 39
                                                              AND @nnum_conc <= 99
                                                              THEN 'p.'
                                                              ELSE 'd.'
                                                          END + 'varia1'
                                                        + SUBSTRING(@cformula,
                                                              @nposvar1 + 5,
                                                              LEN(@cformula))
                                                END

                                            IF @nposvar2 > 0 
                                                BEGIN
                                                    SET @nposvar2 = CHARINDEX('NVAR2',
                                                              @cformula)
                                                    SET @cformula = SUBSTRING(@cformula,
                                                              1, @nposvar2 - 1)
                                                        + CASE
                                                              WHEN @nnum_conc >= 39
                                                              AND @nnum_conc <= 99
                                                              THEN 'p.'
                                                              ELSE 'd.'
                                                          END + 'varia2'
                                                        + SUBSTRING(@cformula,
                                                              @nposvar2 + 5,
                                                              LEN(@cformula))
                                                END

                                            IF @nposvar3 > 0 
                                                BEGIN
                                                    SET @nposvar3 = CHARINDEX('NVAR3',
                                                              @cformula)
                                                    SET @cformula = SUBSTRING(@cformula,
                                                              1, @nposvar3 - 1)
                                                        + CASE
                                                              WHEN @nnum_conc >= 39
                                                              AND @nnum_conc <= 99
                                                              THEN 'p.'
                                                              ELSE 'd.'
                                                          END + 'varia3'
                                                        + SUBSTRING(@cformula,
                                                              @nposvar3 + 5,
                                                              LEN(@cformula))
                                                END

                                            IF @nposvar4 > 0 
                                                BEGIN
                                                    SET @nposvar4 = CHARINDEX('NVAR4',
                                                              @cformula)
                                                    SET @cformula = SUBSTRING(@cformula,
                                                              1, @nposvar4 - 1)
                                                        + CASE
                                                              WHEN @nnum_conc >= 39
                                                              AND @nnum_conc <= 99
                                                              THEN 'p.'
                                                              ELSE 'd.'
                                                          END + 'varia4'
                                                        + SUBSTRING(@cformula,
                                                              @nposvar4 + 5,
                                                              LEN(@cformula))
                                                END
                                        END

                                    PRINT 'cms'
                                    PRINT @cformula

                                    SET @cclaseg = CHAR(39)
                                        + RTRIM(LTRIM(@cclase)) + CHAR(39)
                                    SET @ccentrog = CHAR(39)
                                        + RTRIM(LTRIM(@ccentro)) + CHAR(39)

                                    IF @nnum_conc >= 39
                                        AND @nnum_conc <= 99 
                                        IF @cque_calcula = 'MS'
                          --Print 'Aqui'
                                            EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                                            from dbo.p_kardex_tmp as kt
                                            inner join dbo.p_percepciones as p on p.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                            p.ayo_operacion        = ' + @nayo     + ' and
                                            p.mes                  = ' + @nperiodo + ' and
                                            p.tiponom              = ' + @ntiponom + ' and
                                            p.codigo               = kt.codigo   and
                                            p.num_conc             = kt.num_conc and
                                            rtrim(ltrim(p.clase))  = ' + @cclaseg + '    and
                                            rtrim(ltrim(p.centro)) = ' + @ccentrog + '   and
                                            p.siempre              = ' + @cpago_desc + ' and
                                            p.folio                = kt.fol_tmp')

                             --inner join percepciones as p on p.empresa  = ' + @nempresa  + ' and
                             --                                p.num_conc = ' + @nnum_conc + ' and
                             --                                rtrim(ltrim(p.clase))    = ' + @cclaseg   + ' and
                             --                                rtrim(ltrim(p.centro))   = ' + @ccentrog  + ' and
                             --                                p.codigo   = kt.codigo and
                             --                                p.folio    = kt.fol_tmp
                             --inner join kardex_cond as kc on kt.codigo = kc.ncodigo and kt.folio = kc.fol_tmp')
                                        ELSE 
                                            EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                                            from dbo.p_kardex_tmp as kt
                                            inner join dbo.p_percepciones as p on p.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                            p.ayo_operacion        = ' + @nayo     + ' and
                                            p.mes                  = ' + @nperiodo + ' and
                                            p.tiponom              = ' + @ntiponom + ' and
                                            p.codigo               = kt.codigo   and
                                            p.num_conc             = kt.num_conc and
                                            rtrim(ltrim(p.clase))  = ' + @cclaseg + '    and
                                            rtrim(ltrim(p.centro)) = ' + @ccentrog + '   and
                                            p.siempre              = ' + @cpago_desc + '
                                            inner join dbo.p_kardex_cond as kc on kt.codigo = kc.ncodigo')

                             --inner join percepciones as p on p.empresa  = ' + @nempresa  + ' and
                             --                                p.num_conc = ' + @nnum_conc + ' and
                             --                                rtrim(ltrim(p.clase))    = ' + @cclaseg   + ' and
                             --                                rtrim(ltrim(p.centro))   = ' + @ccentrog  + ' and
                             --                                p.codigo   = kt.codigo
                             --inner join kardex_cond as kc on kt.codigo = kc.ncodigo')





                     --else
                     --   exec('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                     --         from p_kardex_tmp as kt
                     --         inner join percepciones as p on p.empresa  = ' + @nempresa  + ' and
                     --                                         p.num_conc = ' + @nnum_conc + ' and
                     --                                         rtrim(ltrim(p.clase))    = ' + @cclaseg   + ' and
                     --                                         rtrim(ltrim(p.centro))   = ' + @ccentrog  + ' and
                     --                                         p.codigo   = kt.codigo and
                     --                                         p.codigo   = ' + @ncod_for + ' and
                     --                                         p.folio    = ' + @nfol_for + '
                     --         inner join kardex_cond as kc on kt.codigo = kc.ncodigo')


                     --if @nnum_conc = 61
                     --   begin
                     --     select '1'
                     --     select * from p_kardex_tmp where num_conc = 61 and importe1 > 0 order by codigo
                     --   end


                                    IF @nnum_conc >= 139
                                        AND @nnum_conc <= 199
                     --if @cque_calcula <> 'MS'
                                        IF @cque_calcula = 'MS' 
                                            EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                                            from dbo.p_kardex_tmp as kt
                                            inner join dbo.deducciones as d on d.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                            d.ayo_operacion        = ' + @nayo     + ' and
                                            d.periodo              = ' + @nperiodo + ' and
                                            d.tiponom              = ' + @ntiponom + ' and
                                            d.codigo               = kt.codigo   and
                                            d.num_conc             = kt.num_conc and
                                            rtrim(ltrim(d.clase))  = ' + @cclaseg + '    and
                                            rtrim(ltrim(d.centro)) = ' + @ccentrog + '   and
                                            d.siempre              = ' + @cpago_desc + ' and
                                            d.folio                = kt.fol_tmp')

                              --inner join deducciones as d on d.empresa                = ' + @nempresa  + ' and
                              --                               d.num_conc               = ' + @nnum_conc + ' and
                              --                               rtrim(ltrim(d.clase))    = ' + @cclaseg   + ' and
                              --                               rtrim(ltrim(d.centro))   = ' + @ccentrog  + ' and
                              --                               d.codigo                 = kt.codigo          and
                              --                               d.folio                  = kt.fol_tmp
                              --inner join kardex_cond as kc on kt.codigo = kc.ncodigo and kt.folio = kc.fol_tmp')
                                        ELSE 
                                            EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                                            from dbo.p_kardex_tmp as kt
                                            inner join dbo.deducciones as d on d.empresa in(select empresa from dbo.p_empresas where id_presup=' + @id_presup +') and
                                            d.ayo_operacion        = ' + @nayo     + ' and
                                            d.periodo              = ' + @nperiodo + ' and
                                            d.tiponom              = ' + @ntiponom + ' and
                                            d.codigo               = kt.codigo   and
                                            d.num_conc             = kt.num_conc and
                                            rtrim(ltrim(d.clase))  = ' + @cclaseg + '    and
                                            rtrim(ltrim(d.centro)) = ' + @ccentrog + '   and
                                            d.siempre              = ' + @cpago_desc + '
                                            inner join dbo.p_kardex_cond as kc on kt.codigo = kc.ncodigo')

                              --inner join deducciones as d on d.empresa  = ' + @nempresa  + ' and
                              --                               d.num_conc = ' + @nnum_conc + ' and
                              --                               rtrim(ltrim(d.clase))    = ' + @cclaseg   + ' and
                              --                               rtrim(ltrim(d.centro))   = ' + @ccentrog  + ' and
                              --                               d.codigo   = kt.codigo
                              --inner join kardex_cond as kc on kt.codigo = kc.ncodigo')

                     --           update p set p.nomina   = kr.importe,
                     --                        p.variable = kr.importe


                  --else
                  --   exec('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                  --         from p_kardex_tmp as kt
                  --         inner join deducciones as d on d.empresa  = ' + @nempresa  + ' and
                  --                                        d.num_conc = ' + @nnum_conc + ' and
                  --                                        rtrim(ltrim(d.clase))    = ' + @cclaseg   + ' and
                  --                                        rtrim(ltrim(d.centro))   = ' + @ccentrog  + ' and
                  --                                        d.codigo   = kt.codigo and
                  --                                        d.codigo   = ' + @ncod_for + ' and
                  --                                        d.folio    = ' + @nfol_for + '
                  --         inner join kardex_cond as kc on kt.codigo = kc.ncodigo')

                                END

                            ELSE 
                                IF ( @cque_calcula = 'ACSNTOT'
                                     OR @cque_calcula = 'ACCNTOTCI'
                                     OR @cque_calcula = 'ACCNTOTSI'
                                     OR @cque_calcula = 'ASC'
                                     OR @cque_calcula = 'PV'
                                   )
                   --begin
                                    EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe1 = ' + @cformula + '
                                    from dbo.p_kardex_tmp as kt
                                    inner join dbo.p_kardex_cond as kc on kt.codigo = kc.ncodigo')

                   --select 'a3'
                   --select * from kardex_cond order by ncodigo

                   --select 'e1'
                   --select * from p_kardex_tmp order by codigo
                   --end
                        END

                    PRINT 'x1'

                END


            IF LEN(@cformula2) > 0
                AND LEN(@ccondicion) > 0
                AND ( @cque_calcula = 'ACSNTOT'
                      OR @cque_calcula = 'ACCNTOTCI'
                      OR @cque_calcula = 'ACCNTOTSI'
                      OR @cque_calcula = 'ASC'
                      OR @cque_calcula = 'PV'
                    ) 
                BEGIN
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'IMPOR_BASE',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'SALDIAINT',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'DIAS', 'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'INC', 'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'AUS', 'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'SALDF',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'SALMIN',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NTOTPERCEP',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NFACTUS',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NTIPONOM',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NHORARIO',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NTABULAR',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NUPERVISOR',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'DFCHALTA',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'DFCHANTIGUA',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'DFCHNAC',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'DFCHINICIO',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'DFCHCIERRE',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NCODIGO',
                                                     'kt.')
                    SET @cformula2 = dbo.checa_alias(@cformula2, 'NDSTR',
                                                     'kt.')

                    PRINT '3.- ' + @cformula2
                    PRINT 'c3.- ' + @ccondicion

                    SET @cpago_desc = CHAR(39) + 'N' + CHAR(39)
                    EXEC('update kt set kt.cumple_cond = ' + @cpago_desc + ', kt.importe2 = ' + @cformula2 + '
                    from dbo.p_kardex_tmp as kt
                    inner join dbo.p_kardex_cond as kc on kt.codigo = kc.ncodigo and not ' + @ccondicion)
                    PRINT 'x2'
                END



            PRINT 'x3'



            IF @cque_calcula = 'MS' 
                BEGIN
                    UPDATE  kr
                    SET     kr.importe = ( SELECT TOP 1
                                                    CASE WHEN k1.cumple_cond = 'S'
                                                         THEN CASE
                                                              WHEN CHARINDEX('DIAS',
                                                              UPPER(@cformula)) > 0
                                                              OR CHARINDEX('INC',
                                                              UPPER(@cformula)) > 0
                                                              OR CHARINDEX('AUS',
                                                              UPPER(@cformula)) > 0
                                                              THEN ( SELECT
                                                              SUM(kt.importe1)
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              AND kt.fol_tmp = kr.fol_tmp
                                                              )
                                                              ELSE ( SELECT TOP 1
                                                              kt.importe1
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              AND kt.fol_tmp = kr.fol_tmp
                                                              ORDER BY kt.fch_inicio DESC
                                                              )
                                                              END
                                                         ELSE kr.importe
                                                    END
                                           FROM     dbo.p_kardex_tmp AS k1
                                           WHERE    k1.codigo = kr.codigo
                                                    AND k1.fol_tmp = kr.fol_tmp
                                         )
                    FROM    dbo.p_kardex_res AS kr


        --select 'a4'
        --select * from kardex_res order by codigo

        --select 'f1'
        --select * from p_kardex_tmp order by codigo

                    PRINT 'x4'
                END

            ELSE 
                BEGIN
                    UPDATE  kr
                    SET     kr.importe = ( SELECT TOP 1
                                                    CASE WHEN k1.cumple_cond = 'S'
                                                         THEN CASE
                                                              WHEN CHARINDEX('DIAS',
                                                              UPPER(@cformula)) > 0
                                                              OR CHARINDEX('INC',
                                                              UPPER(@cformula)) > 0
                                                              OR CHARINDEX('AUS',
                                                              UPPER(@cformula)) > 0
                                                              THEN ( SELECT
                                                              SUM(kt.importe1)
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              )
                                                              ELSE ( SELECT TOP 1
                                                              kt.importe1
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              ORDER BY kt.fch_inicio DESC
                                                              )
                                                              END
                                                         ELSE kr.importe
                                                    END
                                           FROM     dbo.p_kardex_tmp AS k1
                                           WHERE    k1.codigo = kr.codigo
                                         ) ,
                            kr.ntotpercep = ( SELECT TOP 1
                                                        CASE WHEN k1.cumple_cond = 'S'
                                                             THEN CASE
                                                              WHEN CHARINDEX('DIAS',
                                                              UPPER(@cformula)) > 0
                                                              OR CHARINDEX('INC',
                                                              UPPER(@cformula)) > 0
                                                              OR CHARINDEX('AUS',
                                                              UPPER(@cformula)) > 0
                                                              THEN ( SELECT
                                                              SUM(kt.ntotpercep)
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              )
                                                              ELSE ( SELECT TOP 1
                                                              kt.ntotpercep
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              ORDER BY kt.fch_inicio DESC
                                                              )
                                                              END
                                                             ELSE kr.ntotpercep
                                                        END
                                              FROM      dbo.p_kardex_tmp AS k1
                                              WHERE     k1.codigo = kr.codigo
                                            )
                    FROM    dbo.p_kardex_res AS kr


        --select 'a4'
        --select * from kardex_res order by codigo

        --select 'f1'
        --select * from p_kardex_tmp order by codigo

                    PRINT 'x4'



                    UPDATE  kr
                    SET     kr.importe = ( SELECT TOP 1
                                                    CASE WHEN k1.cumple_cond = 'N'
                                                         THEN CASE
                                                              WHEN CHARINDEX('DIAS',
                                                              UPPER(@cformula2)) > 0
                                                              OR CHARINDEX('INC',
                                                              UPPER(@cformula2)) > 0
                                                              OR CHARINDEX('AUS',
                                                              UPPER(@cformula2)) > 0
                                                              THEN ( SELECT
                                                              SUM(kt.importe2)
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              )
                                                              ELSE ( SELECT TOP 1
                                                              kt.importe2
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              ORDER BY kt.fch_inicio DESC
                                                              )
                                                              END
                                                         ELSE kr.importe
                                                    END
                                           FROM     dbo.p_kardex_tmp AS k1
                                           WHERE    k1.codigo = kr.codigo
                                         ) ,
                            kr.ntotpercep = ( SELECT TOP 1
                                                        CASE WHEN k1.cumple_cond = 'N'
                                                             THEN CASE
                                                              WHEN CHARINDEX('DIAS',
                                                              UPPER(@cformula2)) > 0
                                                              OR CHARINDEX('INC',
                                                              UPPER(@cformula2)) > 0
                                                              OR CHARINDEX('AUS',
                                                              UPPER(@cformula2)) > 0
                                                              THEN ( SELECT
                                                              SUM(kt.ntotpercep3)
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              )
                                                              ELSE ( SELECT TOP 1
                                                              kt.ntotpercep3
                                                              FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                              WHERE
                                                              kt.codigo = kr.codigo
                                                              ORDER BY kt.fch_inicio DESC
                                                              )
                                                              END
                                                             ELSE kr.ntotpercep
                                                        END
                                              FROM      dbo.p_kardex_tmp AS k1
                                              WHERE     k1.codigo = kr.codigo
                                            )
                    FROM    dbo.p_kardex_res AS kr
                END


   --select 'a5'
   --select * from kardex_res order by codigo


            PRINT 'x5'


            PRINT 'ISR'
            PRINT @cispt_ng

            IF @cispt = 'S'
                AND ( @cque_calcula = 'M'
                      OR @cque_calcula = 'CM'
                      OR @cque_calcula = 'ACSNTOT'
                      OR @cque_calcula = 'ACCNTOTCI'
                      OR @cque_calcula = 'ACCNTOTSI'
                      OR @cque_calcula = 'ASC'
                      OR @cque_calcula = 'PV'
                    ) 
                BEGIN
                    exec('update kt set kt.isr = ' + @cispt_ng + '
                    from dbo.p_kardex_tmp as kt
                    --inner join dbo.p_kardex_cond as kc on kt.codigo = kc.ncodigo')


        --if @nnum_conc = 61
        --   begin
        --     select '2'
        --     select * from p_kardex_tmp where importe1 > 0 order by codigo
        --   end


                    UPDATE  kr
                    SET     kr.isr = ( SELECT TOP 1
                                                CASE WHEN CHARINDEX('DIAS',
                                                              UPPER(@cispt_ng)) > 0
                                                          OR CHARINDEX('INC',
                                                              UPPER(@cispt_ng)) > 0
                                                          OR CHARINDEX('AUS',
                                                              UPPER(@cispt_ng)) > 0
                                                     THEN ( SELECT
                                                              SUM(kt.isr)
                                                            FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                            WHERE
                                                              kt.codigo = kr.codigo
                                                          )
                                                     ELSE ( SELECT TOP 1
                                                              kt.isr
                                                            FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                            WHERE
                                                              kt.codigo = kr.codigo
                                                            ORDER BY kt.fch_inicio DESC
                                                          )
                                                END
                                       FROM     dbo.p_kardex_tmp AS k1
                                       WHERE    k1.codigo = kr.codigo
                                     )
                    FROM    dbo.p_kardex_res AS kr
                END

   --else
        --update kr set kr.isr = 0
        --from kardex_res as kr




   --select * from kardex_res

            PRINT 'IMSS'


            IF @cimss = 'S'
                AND ( @cque_calcula = 'ACSNTOT'
                      OR @cque_calcula = 'ACCNTOTCI'
                      OR @cque_calcula = 'ACCNTOTSI'
                      OR @cque_calcula = 'ASC'
                      OR
       --@cque_calcula = 'MS'        or
                      @cque_calcula = 'PV'
                    ) 
                BEGIN
                    EXEC('update kt set kt.imss = ' + @cimss_ni + '
                    from dbo.p_kardex_tmp as kt
                    --inner join dbo.p_kardex_cond as kc on kt.codigo = kc.ncodigo')

                    UPDATE  kr
                    SET     kr.imss = ( SELECT TOP 1
                                                CASE WHEN CHARINDEX('DIAS',
                                                              UPPER(@cimss_ni)) > 0
                                                          OR CHARINDEX('INC',
                                                              UPPER(@cimss_ni)) > 0
                                                          OR CHARINDEX('AUS',
                                                              UPPER(@cimss_ni)) > 0
                                                     THEN ( SELECT
                                                              SUM(kt.imss)
                                                            FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                            WHERE
                                                              kt.codigo = kr.codigo
                                                          )
                                                     ELSE ( SELECT TOP 1
                                                              kt.imss
                                                            FROM
                                                              dbo.p_kardex_tmp
                                                              AS kt
                                                            WHERE
                                                              kt.codigo = kr.codigo
                                                            ORDER BY kt.fch_inicio DESC
                                                          )
                                                END
                                        FROM    dbo.p_kardex_tmp AS k1
                                        WHERE   k1.codigo = kr.codigo
                                      )
                    FROM    dbo.p_kardex_res AS kr
                END

   --if @nnum_conc = 216
   --   select sum(percep_tot), sum(deducc_tot) from p_kardex_tmp where num_conc = 216
   --begin
   --select * from p_kardex_tmp  --where codigo = 5210 or codigo = 221
   --select * from kardex_cond --where ncodigo = 10 or ncodigo = 221
   --select * from kardex_res where importe > 0  --where codigo  = 10 or codigo  = 221  --  importe > 0   --where codigo = 5210 or codigo = 221
   --end



            PRINT 'x6'



   -- ya evaluada la formula
   -- la inserto en kardex
            IF @cque_calcula = 'M' --or @cque_calcula = 'CM'
                BEGIN
                    PRINT 'ola'

        --select * from kardex where num_conc = 41 and nomina = 'SEM'

                    UPDATE  k
                    SET     iexento = ( SELECT  CASE WHEN @cispt <> 'S'
                                                     THEN k.importe
                                                     ELSE CASE
                                                              WHEN kr.isr > k.importe
                                                              THEN k.importe
                                                              ELSE kr.isr
                                                          END
                                                END
                                        FROM    dbo.p_kardex_res AS kr
                                        WHERE   --kr.importe  > 0          and
                                                kr.empresa IN (
                                                SELECT  empresa
                                                FROM    dbo.p_empresas
                                                WHERE   id_presup = @id_presup )
                                                AND kr.codigo = k.codigo
                                                AND kr.num_conc = @nnum_conc
                                                AND kr.clase = @cclase
                                                AND kr.centro = @ccentro
                                      )
                    FROM    dbo.p_kardex AS k
                    WHERE   k.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND k.id_presup = @id_presup
                            AND k.num_conc = @nnum_conc
                            AND k.clase = @cclase
                            AND k.centro = @ccentro
                            AND
              --k.captura = 'M' and
                            k.siempre = 'N'
                            AND k.nomina = @cnomina


        --select * from kardex where num_conc = 32 and nomina = 'SEM'


                    UPDATE  k
                    SET     igravable = ( SELECT    CASE WHEN @cispt <> 'S'
                                                         THEN 0
                                                         ELSE CASE
                                                              WHEN k.importe
                                                              - CASE
                                                              WHEN kr.isr > k.importe
                                                              THEN k.importe
                                                              ELSE kr.isr
                                                              END < 0 THEN 0
                                                              ELSE k.importe
                                                              - CASE
                                                              WHEN kr.isr > k.importe
                                                              THEN k.importe
                                                              ELSE kr.isr
                                                              END
                                                              END
                                                    END
                                          FROM      dbo.p_kardex_res AS kr
                                          WHERE     --kr.importe  > 0          and
                                                    kr.empresa IN (
                                                    SELECT  empresa
                                                    FROM    dbo.p_empresas
                                                    WHERE   id_presup = @id_presup )
                                                    AND kr.codigo = k.codigo
                                                    AND kr.num_conc = @nnum_conc
                                                    AND kr.clase = @cclase
                                                    AND kr.centro = @ccentro
                                        )
                    FROM    dbo.p_kardex AS k
                    WHERE   k.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND k.id_presup = @id_presup
                            AND k.num_conc = @nnum_conc
                            AND k.clase = @cclase
                            AND k.centro = @ccentro
                            AND
              --k.captura = 'M' and
                            k.siempre = 'N'
                            AND k.nomina = @cnomina



        /*
        update k set igravable = (select case when @cispt <> 'S' then 0 else case when k.importe - kr.isr < 0 then 0 else k.importe - kr.isr end end
                                  from kardex_res as kr
                                  where --kr.importe  > 0          and
                                        kr.empresa  = @nempresa  and
                                        kr.codigo   = k.codigo   and
                                        kr.num_conc = @nnum_conc and
                                        kr.clase    = @cclase    and
                                        kr.centro   = @ccentro)
        from kardex as k
        where k.empresa  = @nempresa  and
              k.num_conc = @nnum_conc and
              k.clase    = @cclase    and
              k.centro   = @ccentro   and
              --k.captura = 'M' and
              k.siempre  = 'N'
        */

        --select * from kardex where num_conc = 41 and nomina = 'SEM'

        /*
        update k set iexento   = (select case when @cispt <> 'S' then k.importe else kr.isr end
                                  from kardex_res as kr
                                  where --kr.importe  > 0          and
                                        kr.empresa  = @nempresa  and
                                        kr.codigo   = k.codigo   and
                                        kr.num_conc = @nnum_conc and
                                        kr.clase    = @cclase    and
                                        kr.centro   = @ccentro)
        from kardex as k
        where k.empresa = @nempresa and
              k.num_conc = @nnum_conc and
              k.clase = @cclase and
              k.centro = @ccentro and
              --k.captura = 'M' and
              k.siempre = 'N'
        */

        --select * from kardex where num_conc = @nnum_conc and nomina = 'SEM'

                END



            IF @cque_calcula = 'CM' --or @cque_calcula = 'M'
                BEGIN
                    PRINT 'ola M'

        --select * from kardex where num_conc = 41 and nomina = 'SEM'

        --if @nnum_conc = 61
        --   begin
        --     select '31'
        --     select * from kardex_res order by codigo
        --   end


                    UPDATE  k
                    SET     iexento = ( SELECT  CASE WHEN @cispt <> 'S'
                                                     THEN k.importe
                                                     ELSE CASE
                                                              WHEN kr.isr > k.importe
                                                              THEN k.importe
                                                              ELSE kr.isr
                                                          END
                                                END
                                        FROM    dbo.p_kardex_res AS kr
                                        WHERE   --kr.importe  > 0          and
                                                kr.empresa IN (
                                                SELECT  empresa
                                                FROM    dbo.p_empresas
                                                WHERE   id_presup = @id_presup )
                                                AND kr.codigo = k.codigo
                                                AND kr.num_conc = @nnum_conc
                                                AND kr.clase = @cclase
                                                AND kr.centro = @ccentro
                                      )
                    FROM    dbo.p_kardex AS k
                    WHERE   k.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND k.id_presup = @id_presup
                            AND k.num_conc = @nnum_conc
                            AND k.clase = @cclase
                            AND k.centro = @ccentro
                            AND
              --k.captura = 'M' and
                            k.calculo = 'M'
                            AND k.nomina = @cnomina

        --if @nnum_conc = 61
        --   begin
        --     select '3'
        --     select * from kardex where num_conc = 61 order by codigo
        --   end


        --if @nnum_conc = 1171
        --select * from kardex where num_conc = 1171 and nomina = 'SEM'


                    UPDATE  k
                    SET     igravable = ( SELECT    CASE WHEN @cispt <> 'S'
                                                         THEN 0
                                                         ELSE CASE
                                                              WHEN k.importe
                                                              - CASE
                                                              WHEN kr.isr > k.importe
                                                              THEN k.importe
                                                              ELSE kr.isr
                                                              END < 0 THEN 0
                                                              ELSE k.importe
                                                              - CASE
                                                              WHEN kr.isr > k.importe
                                                              THEN k.importe
                                                              ELSE kr.isr
                                                              END
                                                              END
                                                    END
                                          FROM      dbo.p_kardex_res AS kr
                                          WHERE     --kr.importe  > 0          and
                                                    kr.empresa IN (
                                                    SELECT  empresa
                                                    FROM    dbo.p_empresas
                                                    WHERE   id_presup = @id_presup )
                                                    AND kr.codigo = k.codigo
                                                    AND kr.num_conc = @nnum_conc
                                                    AND kr.clase = @cclase
                                                    AND kr.centro = @ccentro
                                        )
                    FROM    dbo.p_kardex AS k
                    WHERE   k.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND k.id_presup = @id_presup
                            AND k.num_conc = @nnum_conc
                            AND k.clase = @cclase
                            AND k.centro = @ccentro
                            AND
              --k.captura = 'M' and
                            k.calculo = 'M'
                            AND k.nomina = @cnomina

        --if @nnum_conc = 61
        --   begin
        --     select '4'
        --     select * from kardex where num_conc = 61 order by codigo
        --   end


                END

            ELSE 
                BEGIN
                    IF --@cque_calcula <> 'MS'
                        @cque_calcula = 'ACSNTOT'
                        OR @cque_calcula = 'ACCNTOTCI'
                        OR @cque_calcula = 'ACCNTOTSI'
                        OR @cque_calcula = 'ASC'
                        OR @cque_calcula = 'PV' 
                        BEGIN
                            INSERT  INTO dbo.p_kardex
                                    ( codigo ,
                                      empresa ,
                                      nomina ,
                                      centro ,
                                      num_conc ,
                                      clase ,
                                      folio ,
                                      renglon ,
                                      fch_inicio ,
                                      fch_cierre ,
                                      fch_pago ,
                                      dias ,
                                      inc ,
                                      aus ,
                                      diastr ,
                                      dias_imss ,
                                      tpago_desc ,
                                      concepto ,
                                      variaimss ,
                                      variable ,
                                      imss ,
                                      ispt ,
                                      ptu ,
                                      despensa ,
                                      mca_agui ,
                                      fdoahorro ,
                                      calculo ,
                                      impor_base ,
                                      saldiaint ,
                                      tabulador ,
                                      unidades ,
                                      horas ,
                                      tipo_mov ,
                                      secuencia ,
                                      importe ,
                                      igravable ,
                                      iexento ,
                                      credito ,
                                      descuento ,
                                      saldo ,
                                      referencia ,
                                      siempre ,
                                      justificar ,
                                      septimo ,
                                      prevsocial ,
                                      varia1 ,
                                      varia2 ,
                                      varia3 ,
                                      varia4 ,
                                      variable1 ,
                                      variable2 ,
                                      variable3 ,
                                      variable4 ,
                                      masivo ,
                                      formula ,
                                      ispt_ng ,
                                      imss_ni ,
                                      marca ,
                                      serial ,
                                      informativo ,
                                      mes_operacion ,
                                      ayo_operacion ,
                                      id_presup
                                    )
                                    ( SELECT    kr.codigo ,
                                                kr.empresa ,
                                                @cnomina ,
                                                @ccentro ,
                                                @nnum_conc ,
                                                @cclase ,
                                                kr.folio + 1 , --(select isnull(max(k.folio),0) + 1 from kardex as k where empresa = @nempresa and k.codigo = kr.codigo),
                                                0 ,
                                                @dfchinicio ,
                                                @dfchcierre ,
                                                @dfchpago ,
                                                kc.nds ,
                                                kc.ninc ,
                                                kc.naus ,
                                                kc.ndiastr ,
                                                0 ,--dias_imss,
                                                CASE WHEN @nnum_conc > 0
                                                          AND @nnum_conc < 100
                                                     THEN 'P'
                                                     WHEN @nnum_conc > 100
                                                          AND @nnum_conc < 200
                                                     THEN 'D'
                                                     WHEN @nnum_conc > 200
                                                          AND @nnum_conc < 300
                                                     THEN 'I'
                                                END ,
                                                @cconcepto ,
                                                CASE WHEN @cimss <> 'S' THEN 0
                                                     ELSE CASE
                                                              WHEN kr.importe
                                                              - kr.imss < 0
                                                              THEN 0
                                                              ELSE kr.importe
                                                              - kr.imss
                                                          END
                                                END ,  --     0, --CASE WHEN importe - no_int_imss > 0 THEN importe - no_int_imss ELSE 0 END,   --0 variaimss
                                                0 ,   -- variable
                                                @cimss ,
                                                @cispt ,
                                                @cptu ,
                                                @cdespensa ,
                                                @cmca_agui ,
                                                @cfdoahorro ,
                                                'A' ,   -- calculo
                                                CASE WHEN @nnum_conc = 216
                                                     THEN kr.ntotpercep
                                                     ELSE kc.nsdo
                                                END ,      -- impor_base
                                                kc.nsdimss , --kc.saldiaint,        --saldiaint
                                                0 ,        --tabulador
                                                CASE WHEN @nnum_conc = 216
                                                     THEN ROUND(( kr.importe
                                                              / kr.ntotpercep )
                                                              * 100, 0)
                                                     ELSE 0
                                                END ,        --unidades
                                                0 ,        --horas
                                                CASE WHEN @nnum_conc > 0
                                                          AND @nnum_conc < 100
                                                     THEN 'PER'
                                                     WHEN @nnum_conc > 100
                                                          AND @nnum_conc < 200
                                                     THEN 'DED'
                                                     WHEN @nnum_conc > 200
                                                          AND @nnum_conc < 300
                                                     THEN 'PRO'
                                                END ,              --case when @nnum_conc < 100 then 'PER' else 'DED' end,   -- tipo_mov
                                                CASE WHEN @cque_calcula = 'ACCNTOTSI'
                                                     THEN 29
                                                     ELSE 0
                                                END , -- secuencia
                                                kr.importe ,
                                                CASE WHEN @cispt <> 'S' THEN 0
                                                     ELSE CASE
                                                              WHEN kr.importe
                                                              - kr.isr < 0
                                                              THEN 0
                                                              ELSE kr.importe
                                                              - kr.isr
                                                          END
                                                END ,   -- 0, --CASE WHEN importe - exento > 0 THEN importe - exento ELSE 0 END,  --0 igravable
                                                CASE WHEN @cispt <> 'S'
                                                     THEN kr.importe
                                                     ELSE kr.isr
                                                END , --exento,  --0 iexento
                                                0 ,  --credito
                                                0 ,  --descuento
                                                0 ,  --saldo
                                                0 ,  --referencia
                                                'N' ,   --siempre,
                                                ' ' ,   --justificar,
                                                0 ,  --septimo
                                                @cprevsocial ,
                                                0 , --varia1
                                                0 , --varia2
                                                0 , --varia3
                                                0 , --varia4
                                                0 , --variable1
                                                0 , --variable2
                                                0 , --variable3
                                                0 , --variable4
                                                'F' ,  --masivo
                                                ' ' , --@cformula,
                                                @cispt_ng ,
                                                @cimss_ni ,
                                                ' ' ,  --marca
                                                0 ,  --serial
                                                'F' ,--, --informativo
                                                @nmes ,
                                                @nayo ,
                                                @id_presup
                                      FROM      dbo.p_kardex_res AS kr
                                                INNER JOIN dbo.p_kardex_cond
                                                AS kc ON kc.ncodigo = kr.codigo
                                      WHERE     kr.importe > 0
                                                AND kr.clase = @cclase
                                                AND kr.centro = @ccentro
                                    )


								--SELECT * FROM p_kardex_res WHERE num_conc=216 ORDER BY codigo
								

                                 /*
                                 select 'a6'

                                 (select kr.codigo,
                                         @nempresa,
                                         @cnomina,
                                         @ccentro,
                                         @nnum_conc,
                                         @cclase,
                                         kr.folio + 1, --(select isnull(max(k.folio),0) + 1 from kardex as k where empresa = @nempresa and k.codigo = kr.codigo),
                                         0,
                                         @dfchinicio,
                                         @dfchcierre,
                                         @dfchpago,
                                         kc.nds,
                                         kc.ninc,
                                         kc.naus,
                                         kc.ndiastr,
                                         0,--dias_imss,
                                         case when @nnum_conc > 0   and @nnum_conc < 100 then 'P'
                                              when @nnum_conc > 100 and @nnum_conc < 200 then 'D'
                                              when @nnum_conc > 200 and @nnum_conc < 300 then 'I'
                                         end,
                                         @cconcepto,
                                         case when @cimss <> 'S' then 0 else case when kr.importe - kr.imss < 0 then 0 else kr.importe - kr.imss end end,  --     0, --CASE WHEN importe - no_int_imss > 0 THEN importe - no_int_imss ELSE 0 END,   --0 variaimss
                                         0,   -- variable
                                         @cimss,
                                         @cispt,
                                         @cptu,
                                         @cdespensa,
                                         @cmca_agui,
                                         @cfdoahorro,
                                         'A',   -- calculo
                                         case when @nnum_conc = 216 then kr.ntotpercep else kc.nsdo end,      -- impor_base
                                         kc.nsdimss, --kc.saldiaint,        --saldiaint
                                         0,        --tabulador
                                         case when @nnum_conc = 216 then round((kr.importe/kr.ntotpercep) * 100,0) else 0 end,        --unidades
                                         0,        --horas
                                         case when @nnum_conc > 0   and @nnum_conc < 100 then 'PER'
                                              when @nnum_conc > 100 and @nnum_conc < 200 then 'DED'
                                              when @nnum_conc > 200 and @nnum_conc < 300 then 'PRO'
                                         end,              --case when @nnum_conc < 100 then 'PER' else 'DED' end,   -- tipo_mov
                                         case when @cque_calcula = 'ACCNTOTSI' then 29 else 0 end, -- secuencia
                                         kr.importe,
                                         case when @cispt <> 'S' then 0 else case when kr.importe - kr.isr < 0 then 0 else kr.importe - kr.isr end end,   -- 0, --CASE WHEN importe - exento > 0 THEN importe - exento ELSE 0 END,  --0 igravable
                                         case when @cispt <> 'S' then kr.importe else kr.isr end, --exento,  --0 iexento
                                         0,  --credito
                                         0,  --descuento
                                         0,  --saldo
                                         0,  --referencia
                                         'N',   --siempre,
                                         ' ',   --justificar,
                                         0,  --septimo
                                         @cprevsocial,
                                         0, --varia1
                                         0, --varia2
                                         0, --varia3
                                         0, --varia4
                                         0, --variable1
                                         0, --variable2
                                         0, --variable3
                                         0, --variable4
                                         'F',  --masivo
                                         ' ', --@cformula,
                                         @cispt_ng,
                                         @cimss_ni,
                                         ' ',  --marca
                                         0,  --serial
                                         'F'--, --informativo
                                  from kardex_res as kr
                                  inner join kardex_cond as kc on kc.ncodigo = kr.codigo
                                  where kr.importe > 0 and kr.clase = @cclase and kr.centro = @ccentro)
                                 */

                                 --group by kr.codigo)
             --        select @nresultado = @@error

             --     print ISQLServerErrorInfo

                        END


                    ELSE 
                        IF @cque_calcula = 'MS' 
                            BEGIN
                                IF @nnum_conc >= 39
                                    AND @nnum_conc < 100
                   --begin
                   --select * from kardex_res order by codigo
                                    UPDATE  p
                                    SET     p.nomina = kr.importe ,
                                            p.variable = kr.importe
                                    FROM    dbo.p_kardex_res AS kr
                                            INNER JOIN dbo.p_percepciones AS p ON p.empresa = @nempresa
                                                              AND p.ayo_operacion = @nayo
                                                              AND p.mes = @nperiodo
                                                              AND p.tiponom = @ntiponom
                                                              AND p.codigo = kr.codigo
                                                              AND p.num_conc = kr.num_conc
                                                              AND p.clase = kr.clase
                                                              AND p.centro = kr.centro
                                                              AND p.siempre = 'S'
                                                              AND p.folio = kr.fol_tmp
                   --end

                                ELSE 
                                    IF @nnum_conc >= 139
                                        AND @nnum_conc < 200 
                                        UPDATE  d
                                        SET     d.descuento = kr.importe
                                        FROM    dbo.p_kardex_res AS kr
                                                INNER JOIN dbo.deducciones AS d ON d.empresa IN (
                                                              SELECT
                                                              empresa
                                                              FROM
                                                              dbo.p_empresas
                                                              WHERE
                                                              id_presup = @id_presup )
                                                              AND d.ayo_operacion = @nayo
                                                              AND d.periodo = @nperiodo
                                                              AND d.tiponom = @ntiponom
                                                              AND d.codigo = kr.codigo
                                                              AND d.num_conc = kr.num_conc
                                                              AND d.clase = kr.clase
                                                              AND d.centro = kr.centro
                                                              AND d.siempre = 'S'         --and
                                                     --d.folio         = kr.fol_tmp
                            END
                END


            PRINT 'x7'

--break


   --if @nnum_conc = 61
   --   begin
   --select * from p_kardex_tmp order by codigo --where codigo = 119
   --select * from kardex_res order by codigo --where codigo = 119

   --select 'a7'
   --select * from kardex order by codigo --where num_conc = 61 --where num_conc = @nnum_conc and nomina = 'CAT' and codigo = 119
   --   end

   -- borro las tablas temporales
            DROP TABLE dbo.p_kardex_tmp
            DROP TABLE dbo.p_kardex_cond
            DROP TABLE dbo.p_kardex_res

            IF LEN(@carreglo1) > 0 
                BEGIN
                    IF OBJECT_ID('dbo.p_p_tab_arr1') IS NOT NULL 
                        BEGIN
                            DROP TABLE dbo.p_p_tab_arr1
                        END
                END


            IF LEN(@carreglo2) > 0 
                BEGIN
                    IF OBJECT_ID('dbo.p_tab_arr2') IS NOT NULL 
                        BEGIN
                            DROP TABLE dbo.p_tab_arr2
                        END
                END


      -- exec asp_genera_folio @nempresa, 0, 'kardex', 'folio', 0, 0

            PRINT ''
            PRINT ''
            PRINT ''
            PRINT 'FIN CONCEPTO '
            PRINT ''
            PRINT ''
            PRINT ''




   -- if @cque_calcula <> 'MS'
            FETCH NEXT FROM conceptos_auto INTO @nnum_conc  ,
                                       @cclase     ,
                                       @ccentro    ,
                                       @cconcepto  ,
                                       @cispt      ,
                                       @cimss      ,
                                       @cmca_agui  ,
                                       @cptu       ,
                                       @cdespensa  ,
                                       @cfdoahorro ,
                                       @ccondicion1,
                                       @ccondicion2,
                                       @cformula   ,
                                       @cformula2  ,
                                       @cispt_ng   ,
                                       @cimss_ni   ,
                                       @dfecha1    ,
                                       @dfecha2    ,
                                       @dfecha3    ,
                                       @nhrs_min1  ,
                                       @nhrs_min2  ,
                                       @nhrs_min3  ,
                                       @nimporte1  ,
                                       @nimporte2  ,
                                       @nimporte3  ,
                                       @nporciento1,
                                       @nporciento2,
                                       @nporciento3,
                                       @cvariable1 ,
                                       @cvariable2 ,
                                       @cvariable3 ,
                                       @cvariable4 ,
                                       @cmarca1    ,
                                       @cmarca2    ,
                                       @ccondicion ,
                                       @ctotales   ,
                                       @ctotales2  ,
                                       @ctotales3  ,
                                       @cprevsocial,
                                       @carreglo1  ,
                                       @carreglo2  ,
                                       @cacumulado1,
                                       @cacumulado2,
                                       @cacumulado3,
                                       @empresaC
        END

    DEALLOCATE conceptos_auto

    IF OBJECT_ID('dbo.p_conc_tmp') IS NOT NULL 
        DROP TABLE dbo.p_conc_tmp

    IF OBJECT_ID('dbo.p_conc_man') IS NOT NULL 
        DROP TABLE dbo.p_conc_man

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Gravables')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Gravables
GO

-- exec dbo.asp_p_Gravables 4,1,52.59


CREATE  PROCEDURE dbo.asp_p_Gravables
    @nTipoNom INT ,
    @id_presup INT ,
    @nSalMin NUMERIC(10, 2)
AS 
    DECLARE @nEmpresa INT

    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @cTipoNom CHAR(3)
    DECLARE @cRISR86_15 CHAR(1)
    DECLARE @cRISR86_16 CHAR(1)

    DECLARE @cRegPat CHAR(10)

    DECLARE @nAyo INT
    DECLARE @nMes INT
-- Analizar Tpo. Extra antes de llenar Nomina_Tot con los totales de gravables y exentos
--Exec asp_Fun_R_AnalizaTE @nEmpresa, @nSalMin
--

/*
Declare @nTipoNom    Int
Declare @nEmpresa    Int
Declare @nSalMin     Numeric(10,2)

Set @nTipoNom = 3
Set @nEmpresa = 1
Set @nSalMin  = 50
*/

    SELECT  @cRegPat = Registro_Patronal
    FROM    dbo.Empresas --Where Empresa = @nEmpresa


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


--select @dInicio = Periodos.Inicio, @dCierre = Periodos.Cierre From Periodos Where Estatus = 'A' And Empresa = @nEmpresa And TipoNom = @nTipoNom
    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio)
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup


    SET @cRISR86_15 = CASE WHEN ( SELECT    COUNT(Num_Conc)
                                  FROM      dbo.Conceptos
                                  WHERE     Num_Conc = 15
                                            AND Variable2 = '86'
                                            AND Marca1 = 'O'
                                            AND Empresa IN (
                                            SELECT  empresa
                                            FROM    dbo.p_empresas
                                            WHERE   id_presup = @id_presup )
                                ) > 0 THEN 'S'
                           ELSE 'N'
                      END


-- Inicializar las tablas
    DELETE  dbo.p_Nomina_Tot
    WHERE   TipoNom = @nTipoNom
            AND mes_operacion = @nMes
            AND ayo_operacion = @nAyo
            AND id_presup = @id_presup
--Delete p_Mes Where TipoNom = @nTipoNom and mes_operacion=@nMes and ayo_operacion=@nAyo and id_presup=@id_presup
--


-- Armar los registros de NOMINA_TOT con las sumas de KARDEX de acuerdo a cada concepto y sus caracteristicas
    INSERT  INTO dbo.p_Nomina_Tot
            ( Codigo ,
              Empresa ,
              TipoNom ,
              MovImss ,
              FchInicio ,
              FchCierre ,
              DiasTr_Nom ,
              Dias_Pagar ,
              Aus ,
              Incap ,
              Incap_EG ,
              Incap_Mat ,
              Incap_RT ,
              Retardos ,
              Tot_Sueldo ,
              Tot_Percep ,
              Tot_Deducc ,
              Perc_Grava ,
              Perc_Exento ,
              Dedu_Grava ,
              Dedu_Exent ,
              Neto ,
              Ptu ,
              Mca_Baja ,
              Base_I_Est ,
              Tot_Ispt ,
              Base_I_Fed ,
              PrevSocial ,
              IsptReal ,
              CredReal ,
              IsptContra ,
              CredContra ,
              HorasLab ,
              HorasDes ,
              DiasLab ,
              SdoLab ,
              DiasDes ,
              SdoDes ,
              Tot_Imss ,
              Subsidio ,
              SubsidioN ,
              PrevGrava ,
              id_presup ,
              ayo_operacion ,
              mes_operacion ,
              prevexenta
            )
            ( SELECT    Kardex.Codigo ,
                        Kardex.Empresa ,
                        @nTipoNom AS TipoNom ,
                        '' AS MovImss ,--Max(Empleados.UltMov) As MovImss,
                        @dInicio AS FchInicio ,
                        @dCierre AS FchCierre ,
       -- Suma de dias laborados menos ausentismos
                        SUM(CASE WHEN Kardex.Num_Conc IN ( @nTipoNom, 7, 30,
                                                           1107, 1108, 1109,
                                                           1110, 1111 )
                                      AND Kardex.Tipo_Mov <> 'FIN'
                                 THEN Kardex.Dias
                                 ELSE 0
                            END)
                        - SUM(CASE WHEN Kardex.Num_Conc IN ( 107, 108, 109,
                                                             110, 111 )
                                   THEN Kardex.Dias
                                   ELSE 0
                              END) AS DiasTr_Nom ,
       --
                        SUM(CASE WHEN Kardex.Num_Conc IN ( @nTipoNom, 7, 30,
                                                           1107, 1108, 1109,
                                                           1110, 1111 )
                                      AND Kardex.Tipo_Mov <> 'FIN'
                                 THEN Kardex.Dias
                                 ELSE 0
                            END)
                        - SUM(CASE WHEN Kardex.Num_Conc IN ( 107, 108, 109,
                                                             110, 111 )
                                   THEN Kardex.Dias
                                   ELSE 0
                              END) AS Dias_Pagar ,
       --
                        SUM(CASE WHEN Kardex.Num_Conc IN ( 107, 108 )
                                 THEN Kardex.Dias
                                 ELSE 0
                            END) AS Aus ,
                        SUM(CASE WHEN Kardex.Num_Conc IN ( 109, 110, 111 )
                                 THEN Kardex.Dias
                                 ELSE 0
                            END) AS Incap ,
                        SUM(CASE WHEN Kardex.Num_Conc = 109 THEN Kardex.Dias
                                 ELSE 0
                            END) AS Incap_EG ,
                        SUM(CASE WHEN Kardex.Num_Conc = 110 THEN Kardex.Dias
                                 ELSE 0
                            END) AS Incap_Mat ,
                        SUM(CASE WHEN Kardex.Num_Conc = 111 THEN Kardex.Dias
                                 ELSE 0
                            END) AS Incap_RT ,
       --
                        MAX(ISNULL(Retardos.Retardos, 0)) AS Retardos ,
       --
                        SUM(CASE WHEN Kardex.Num_Conc IN ( @nTipoNom, 7, 30,
                                                           1107, 1108, 1109,
                                                           1110, 1111 )
                                 THEN Kardex.Importe
                                 ELSE 0
                            END) AS Tot_Sueldo ,
       --
                        SUM(CASE WHEN Kardex.TPago_Desc = 'P'
                                 THEN Kardex.Importe
                                 ELSE 0
                            END) AS Tot_Percep ,
       --
                        SUM(CASE WHEN Kardex.TPago_Desc = 'D'
                                 THEN Kardex.Importe
                                 ELSE 0
                            END) AS Tot_Deducc ,
       --
                        SUM(CASE WHEN Kardex.TPago_Desc = 'P'
                                      AND ISNULL(Conceptos.PrevSocial, 'N') NOT IN (
                                      'S', 'T' ) THEN Kardex.IGravable
                                 ELSE 0
                            END) AS Perc_Grava ,
                        SUM(CASE WHEN Kardex.TPago_Desc = 'P'
                                 THEN CASE WHEN ISNULL(Conceptos.PrevSocial,
                                                       'N') IN ( 'S', 'T' )
                                           THEN Kardex.Importe
                                           ELSE Kardex.IExento
                                      END
                                 ELSE 0
                            END) AS Perc_Exento ,
       --
                        SUM(CASE WHEN Kardex.TPago_Desc = 'D'
                                 THEN Kardex.IGravable
                                 ELSE 0
                            END) AS Dedu_Grava ,
                        SUM(CASE WHEN Kardex.TPago_Desc = 'D'
                                 THEN Kardex.IExento
                                 ELSE 0
                            END) AS Dedu_Exent ,       --
       --Left(@cTipoNom,1) As Tipo_Nomi,
       --
                        0 AS Neto ,
       --
                        SUM(CASE WHEN Kardex.TPago_Desc = 'P'
                                      AND Conceptos.Ptu = 'S'
                                 THEN Kardex.Importe
                                 ELSE 0
                            END) AS Ptu ,
       --
                        '' AS Mca_Baja ,--Max(Case When Empleados.UltMov = 'B' Then 'B' Else ' ' End) As Mca_Baja,
                        SUM(CASE WHEN Kardex.TPago_Desc = 'P'
                                      AND ( ( Kardex.Tipo_Mov = 'PTU'
                                              AND @cRISR86_15 = 'S'
                                            )
                                            OR ( Kardex.Tipo_Mov = 'AGI'
                                                 AND Conceptos.Variable2 = '86'
                                                 AND Conceptos.Marca1 = 'O'
                                               )
                                            OR Kardex.Tipo_Mov = 'FIN'
                                          ) THEN Kardex.IGravable
                                 ELSE 0
                            END)
                        - SUM(CASE WHEN Kardex.TPago_Desc = 'D'
                                        AND ( ( Kardex.Tipo_Mov = 'PTU'
                                                AND @cRISR86_15 = 'S'
                                              )
                                              OR ( Kardex.Tipo_Mov = 'AGI'
                                                   AND Conceptos.Variable2 = '86'
                                                   AND Conceptos.Marca1 = 'O'
                                                 )
                                              OR Kardex.Tipo_Mov = 'FIN'
                                            ) THEN Kardex.IGravable
                                   ELSE 0
                              END) AS Base_I_Est ,
       --
                        0 AS Tot_Ispt ,   -- Actualizar con ISPTREAL - CREDREAL
       --
                        SUM(CASE WHEN Kardex.Num_Conc = 108
                                 THEN Kardex.Descuento - 100
                                 ELSE 0
                            END) AS Base_I_Fed ,
       --
       --Sum(Case When Kardex.Num_Conc = 108 Then (Kardex.Dias*Kardex.Descuento/100)*Kardex.Dias Else 0 End) As Factor,
       --
                        SUM(CASE WHEN Kardex.TPago_Desc = 'P'
                                      AND ISNULL(Conceptos.PrevSocial, 'N') IN (
                                      'S', 'T' ) THEN Kardex.Importe
                                 ELSE 0
                            END) AS PrevSocial ,
       --
                        SUM(CASE WHEN Kardex.Num_Conc = 136
                                 THEN Kardex.Importe
                                 ELSE 0
                            END)
                        - SUM(CASE WHEN Kardex.Num_Conc = 1136
                                   THEN Kardex.Importe
                                   ELSE 0
                              END) AS IsptReal ,
       --
                        SUM(CASE WHEN Kardex.Num_Conc = 36 THEN Kardex.Importe
                                 ELSE 0
                            END)
                        - SUM(CASE WHEN Kardex.Num_Conc = 1036
                                   THEN Kardex.Importe
                                   ELSE 0
                              END) AS CredReal ,
       --
                        SUM(CASE WHEN Kardex.Num_Conc = 1136
                                 THEN Kardex.Importe
                                 ELSE 0
                            END) AS IsptContra ,
                        SUM(CASE WHEN Kardex.Num_Conc = 1036
                                 THEN Kardex.Importe
                                 ELSE 0
                            END) AS CredContra ,
       --
                        0 AS HorasLab ,
                        0 AS HorasDes ,
                        0 AS DiasLab ,
                        0 AS SdoLab ,
                        0 AS DiasDes ,
                        0 AS SdoDes ,
                        SUM(CASE WHEN Kardex.Num_Conc <> 36
                                      AND Kardex.Num_Conc <> 1136
                                      AND Kardex.TPago_Desc = 'P'
                                 THEN Kardex.VariaImss
                                 ELSE 0
                            END) AS Tot_Imss ,
                        0 AS Subsidio ,
                        0 AS SubsidioN ,
                        0 AS PrevGrava ,
                        Kardex.id_presup ,
                        Kardex.ayo_operacion ,
                        Kardex.mes_operacion ,
                        0 AS prevexena
              FROM      dbo.p_Kardex AS kardex
                        INNER JOIN dbo.p_Empleados_pres AS Empleados ON Kardex.Codigo = Empleados.Codigo
                                                              AND Kardex.Empresa = Empleados.Empresa
                                                              AND Kardex.id_presup = Empleados.id_presup
--Inner Join Llaves On Kardex.Codigo = Llaves.Codigo And Kardex.Empresa = Llaves.Empresa
                        INNER JOIN dbo.Conceptos ON Kardex.Num_Conc = Conceptos.Num_Conc
                                                    AND Kardex.Clase = Conceptos.Clase
                                                    AND Kardex.Centro = Conceptos.Centro
                                                    AND Conceptos.Empresa = kardex.Empresa
                        LEFT JOIN ( SELECT  empresa ,
                                            Codigo ,
                                            COUNT(Codigo) AS Retardos
                                    FROM    dbo.Kardex
                                    WHERE   Num_Conc = 120
                                    GROUP BY empresa ,
                                            Codigo
                                  ) AS Retardos ON Kardex.Codigo = Retardos.Codigo
                                                   AND Kardex.empresa = Retardos.empresa
                        LEFT JOIN dbo.nomina_tot ON nomina_tot.codigo = kardex.codigo
                                                    AND nomina_tot.empresa = kardex.empresa
              WHERE     Kardex.Nomina = @cTipoNom
                        AND empleados.id_presup = @id_presup
                        AND Kardex.ayo_operacion = @nAyo
                        AND Kardex.mes_operacion = @nMes
              GROUP BY  Kardex.empresa ,
                        Kardex.Codigo ,
                        Kardex.id_presup ,
                        Kardex.ayo_operacion ,
                        Kardex.mes_operacion
            )
--


-- Ajustar el Neto y el ISR real
    UPDATE  dbo.p_Nomina_Tot
    SET     Tot_Ispt = Nomina_Tot.IsptReal - Nomina_Tot.CredReal ,
            Neto = Nomina_Tot.Tot_Percep - Nomina_Tot.Tot_Deducc
    FROM    dbo.p_Nomina_Tot AS nomina_tot
            LEFT JOIN dbo.p_empleados_pres AS Llaves ON Nomina_Tot.Codigo = Llaves.Codigo
                                                        AND Nomina_Tot.Empresa = Llaves.Empresa
                                                        AND Nomina_Tot.id_presup = Llaves.id_presup
    WHERE   Llaves.TipoNom = @nTipoNom
            AND llaves.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes
--


-- Ajustar GRAVABLE y EXENTO de PREVISION SOCIAL
    UPDATE  dbo.p_Nomina_Tot
    SET     Perc_Grava = Nomina_Tot.Perc_Grava + ( ( Nomina_Tot.PrevSocial
                                                     + Mensual.PrevSocial )
                                                   - ( @nSalMin * 30.4 ) )
            - Mensual.PrevGrava ,
            Perc_Exento = Nomina_Tot.Perc_Exento + ( ( Nomina_Tot.PrevSocial
                                                       + Mensual.PrevSocial )
                                                     - ( @nSalMin * 30.4 ) )
            - Mensual.PrevGrava ,
            PrevGrava = ( ( Nomina_Tot.PrevSocial + Mensual.PrevSocial )
                          - ( @nSalMin * 30.4 ) ) - Mensual.PrevGrava ,
            PrevExenta = Nomina_Tot.PrevSocial - ( ( Nomina_Tot.PrevSocial
                                                     + Mensual.PrevSocial )
                                                   - ( @nSalMin * 30.4 ) )
            - Mensual.PrevGrava
    FROM    dbo.p_Nomina_Tot AS nomina_tot
            LEFT JOIN dbo.p_empleados_pres AS Llaves ON Nomina_Tot.Codigo = Llaves.Codigo
                                                        AND Nomina_Tot.Empresa = Llaves.Empresa
                                                        AND Nomina_Tot.id_presup = Llaves.id_presup
            LEFT JOIN dbo.Mensual ON Nomina_Tot.Codigo = Mensual.Codigo
                                     AND Nomina_Tot.Empresa = Mensual.Empresa
    WHERE   Llaves.TipoNom = @nTipoNom
            AND Nomina_Tot.Tot_Percep + Mensual.Gravable + Mensual.Exento
            - Nomina_Tot.Dedu_Grava > @nSalMin * 7 * ( Nomina_Tot.Dias_Pagar
                                                       + Mensual.Dias )
            AND Nomina_Tot.PrevSocial + Mensual.PrevSocial > @nSalMin * 30.4
            AND llaves.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes
--


-- Para los que no exceden el tope de PREVISION SOCIAL, dejarla como exenta
    UPDATE  dbo.p_Nomina_Tot
    SET     PrevGrava = 0 ,
            PrevExenta = Nomina_Tot.PrevSocial
    FROM    dbo.p_Nomina_Tot AS nomina_tot
            LEFT JOIN dbo.p_empleados_pres AS Llaves ON Nomina_Tot.Codigo = Llaves.Codigo
                                                        AND Nomina_Tot.Empresa = Llaves.Empresa
                                                        AND Nomina_Tot.id_presup = Llaves.id_presup
            LEFT JOIN dbo.Mensual ON Nomina_Tot.Codigo = Mensual.Codigo
                                     AND Nomina_Tot.Empresa = Mensual.Empresa
    WHERE   Llaves.TipoNom = @nTipoNom
            AND Nomina_Tot.Tot_Percep + Mensual.Gravable + Mensual.Exento
            - Nomina_Tot.Dedu_Grava > @nSalMin * 7 * ( Nomina_Tot.Dias_Pagar
                                                       + Mensual.Dias )
            AND Nomina_Tot.PrevSocial + Mensual.PrevSocial <= @nSalMin * 30.4
            AND llaves.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes
--


-- Para los que tienen convenio para la retencion de ISR sobre un % del SDI
    UPDATE  dbo.p_Nomina_Tot
    SET     Perc_Grava = Especial.Especial ,
            Perc_Exento = CASE WHEN Especial.Especial > Nomina_Tot.Tot_Percep
                               THEN 0
                               ELSE Nomina_Tot.Tot_Percep - Especial.Especial
                          END ,
            Dedu_Grava = 0 ,
            Dedu_Exent = Nomina_Tot.Tot_Deducc
    FROM    dbo.p_Nomina_Tot AS nomina_tot
            INNER JOIN dbo.p_empleados_pres AS Llaves ON Nomina_Tot.Codigo = Llaves.Codigo
                                                         AND Nomina_Tot.Empresa = Llaves.Empresa
                                                         AND Nomina_Tot.id_presup = Llaves.id_presup
            INNER JOIN dbo.Tabulador ON Llaves.Ocupacion = Tabulador.Ocupacion
                                        AND Llaves.Empresa = Tabulador.Empresa
            INNER JOIN ( SELECT kardex.empresa ,
                                Kardex.Codigo ,
                                SUM(Kardex.SalDiaInt * ( Kardex.Dias
                                                         - Kardex.Aus
                                                         - Kardex.Inc )) AS Especial ,
                                MAX(Tabulador.Porc_Isr) AS Porc_Isr
                         FROM   dbo.p_Kardex AS kardex
                                INNER JOIN dbo.p_empleados_pres AS Llaves ON Kardex.Codigo = Llaves.Codigo
                                                              AND Kardex.Empresa = Llaves.Empresa
                                                              AND Kardex.id_presup = Llaves.id_presup
                                INNER JOIN dbo.Tabulador ON Llaves.Ocupacion = Tabulador.Ocupacion
                                                            AND Llaves.Empresa = Tabulador.Empresa
                         WHERE  Kardex.Nomina = @cTipoNom
                                AND llaves.id_presup = @id_presup
                                AND kardex.ayo_operacion = @nAyo
                                AND kardex.mes_operacion = @nMes
                         GROUP BY kardex.empresa ,
                                Kardex.Codigo
                       ) AS Especial ON Nomina_Tot.Codigo = Especial.Codigo
                                        AND especial.empresa = nomina_tot.empresa
    WHERE   Llaves.TipoNom = @nTipoNom
            AND Tabulador.Convenio_Isr IN ( 'S', 'T' )
            AND llaves.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes
--


-- Para ATASA, tomar los dias del concepto 44...sobre eso se calcula el ISR
    IF @cRegPat = '0401232110'
        AND @nTipoNom = 4 
        UPDATE  p_Nomina_Tot
        SET     DiasTr_Nom = Dias.Dias ,
                Dias_Pagar = Dias.Dias
        FROM    dbo.p_Nomina_Tot AS Nomina_Tot
                LEFT JOIN ( SELECT  empresa ,
                                    Codigo ,
                                    SUM(Dias) AS Dias
                            FROM    dbo.p_Kardex AS kardex
                            WHERE   Num_Conc = 44
                                    AND Nomina = @cTipoNom
                                    AND id_presup = @id_presup
                                    AND mes_operacion = @nMes
                                    AND ayo_operacion = @nAyo
                            GROUP BY empresa ,
                                    Codigo
                          ) AS Dias ON Dias.Codigo = Nomina_Tot.Codigo
                                       AND Dias.empresa = Nomina_Tot.empresa
        WHERE   Nomina_Tot.TipoNom = @nTipoNom
                AND nomina_tot.id_presup = @id_presup
                AND nomina_tot.ayo_operacion = @nAyo
                AND nomina_tot.mes_operacion = @nMes
--


GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Impuestos2008')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Impuestos2008
GO
-- dbo.asp_p_Impuestos2008 4,1

CREATE PROCEDURE dbo.asp_p_Impuestos2008
    @nTipoNom INT ,
    @id_presup INT
AS /*
Declare @nTipoNom   Int
Declare @nEmpresa   Int
*/

    DECLARE @nEmpresa INT

    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME
    DECLARE @nDiasPer NUMERIC(6, 2)
    DECLARE @cTipoNom CHAR(3)


    DECLARE @cIsptVal CHAR(1)

--Declare @cPtu       Char(1)

    DECLARE @cBase CHAR(1)
    DECLARE @cAjusta CHAR(1)

    DECLARE @cVariable1 CHAR(10)
    DECLARE @cVariable2 CHAR(10)
    DECLARE @cVariable3 CHAR(10)

    DECLARE @nDiasCalc1 INT
    DECLARE @nDiasCalc2 INT
    DECLARE @nDiasCalc3 INT

    DECLARE @nProyecta NUMERIC(6, 2)

    DECLARE @cGrava100 CHAR(1)

    DECLARE @nMes INT
    DECLARE @nAyo INT

/*
Set @nEmpresa = 7
Set @nTipoNom = 4
*/

    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END

    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @dCierre = Periodos.pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio)
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup

    SET @cIsptVal = CASE WHEN ( SELECT  COUNT(Num_Conc)
                                FROM    dbo.Conceptos
                                WHERE   Num_Conc = 31
                                        AND Uso = 'S'
                                        AND Marca1 <> 'O'
                                        AND Hrs_Min3 = 2
                                        AND Empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
                              ) > 0 THEN 'S'
                         ELSE 'N'
                    END

--Set @cPtu     = Case When (Select Count(Num_Conc) From Conceptos Where Num_Conc = 15 And Marca1 = 'N' And Empresa = @nEmpresa) > 0 Then 'S' Else 'N' End

    SET @cBase = ( SELECT TOP 1
                            Base_Calc
                   FROM     dbo.ApsiIspt
                   WHERE    Mca_Ultimo = 'U'
                            AND Articulo = ' '
                            AND Empresa IN ( SELECT empresa
                                             FROM   dbo.p_empresas
                                             WHERE  id_presup = @id_presup )
                 )
    SET @cAjusta = CASE WHEN @cBase = 'M' THEN 'S'
                        ELSE 'N'
                   END


    SELECT  @cVariable1 = Variable1 ,
            @cVariable2 = Variable2 ,
            @cVariable3 = Variable3 ,
            @nDiasCalc1 = CONVERT(INT, Porciento1) ,
            @nDiasCalc2 = CONVERT(INT, Porciento2) ,
            @nDiasCalc3 = CONVERT(INT, Porciento3) ,
            @nProyecta = ( CASE WHEN Hrs_Min3 = 30 THEN 30
                                ELSE 30.4
                           END )
    FROM    dbo.Conceptos
    WHERE   Num_Conc = 136
            AND Empresa IN ( SELECT empresa
                             FROM   dbo.p_empresas
                             WHERE  id_presup = @id_presup )--= @nEmpresa


-- Con esta variable controlar provisionalmente si debe o no gravar el total de percepciones
    SELECT  @cGrava100 = CASE WHEN Variable1 = '100' THEN 'S'
                              ELSE 'N'
                         END
    FROM    dbo.Conceptos
    WHERE   Num_Conc = 36
            AND Empresa IN ( SELECT empresa
                             FROM   dbo.p_empresas
                             WHERE  id_presup = @id_presup )--= @nEmpresa


    IF OBJECT_ID('dbo.Tmp_p_Isr') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Isr

    IF OBJECT_ID('dbo.Tmp_p_Deducciones') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Deducciones

    IF OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Kardex


-- Armar una tabla temporal para hacer los procesos sobre esa, despues pasar los resultados
-- a la tabla original
    SELECT  Nomina_Tot.empresa ,
            Nomina_Tot.Codigo ,
            Nomina_Tot.Perc_Grava - Nomina_Tot.Dedu_Grava
            - Nomina_Tot.Base_I_Est
            + ( CASE WHEN @cGrava100 = 'S' THEN Nomina_Tot.Perc_Exento
                     ELSE 0
                END ) AS Percepcion ,
            Nomina_Tot.Dias_Pagar ,
            Nomina_Tot.Aus ,
            Nomina_Tot.Incap ,
            CONVERT(NUMERIC(10, 2), 0) AS Valor1 ,  -- Isr del 2008
            CONVERT(NUMERIC(10, 2), 0) AS Valor2 ,  -- Subsidio para el empleo
            Conceptos.Marca1 AS Aguinaldo ,
            ISNULL('N', Tabulador.Convenio_Isr) AS Convenio_Isr ,
            ISNULL(0, Tabulador.Porc_Isr) AS Porc_Isr ,
            Empleados.TipoSal ,
            0 AS Jornada ,--Empleados.Jornada,
            CASE WHEN Empleados.TipoSal = 1 THEN Empleados.SalDiaInt
                 ELSE Empleados.Sueldo
            END AS Sueldo ,
            Empleados.SalDiaInt ,
            CASE WHEN Empleados.TipoSal = 0 THEN @cVariable1
                 WHEN Empleados.TipoSal = 1 THEN @cVariable2
                 ELSE @cVariable3
            END AS Variable ,
            CASE WHEN Empleados.TipoSal = 0 THEN @nDiasCalc1
                 WHEN Empleados.TipoSal = 1 THEN @nDiasCalc2
                 ELSE @nDiasCalc3
            END AS DiasCalc ,
            CONVERT(NUMERIC(6, 2), 0) AS Dias ,
            CONVERT(NUMERIC(10, 2), 0) AS Gravable ,
            CONVERT(NUMERIC(10, 2), 0) AS Ispt ,
            CONVERT(NUMERIC(10, 2), 0) AS Credito ,
            CONVERT(NUMERIC(10, 2), 0) AS Subsidio ,
            CONVERT(NUMERIC(6, 2), 0) AS DiasLabor ,
            CONVERT(NUMERIC(10, 2), 0) AS DevIspt ,
            CONVERT(NUMERIC(10, 2), 0) AS RetCredito ,
            CONVERT(NUMERIC(10, 2), 0) AS DevSubs ,
            ISNULL(Excepciones.Excepcion1, ' ') AS Excepcion ,
            CONVERT(NUMERIC(10, 2), 0) AS IsrReal ,
            CONVERT(NUMERIC(10, 2), 0) AS TotIspt ,
            CONVERT(NUMERIC(10, 2), 0) AS C36 ,
            CONVERT(NUMERIC(10, 2), 0) AS C136 ,
            CONVERT(NUMERIC(10, 2), 0) AS C1036 ,
            CONVERT(NUMERIC(10, 2), 0) AS C1136 ,
            CASE WHEN @cIsptVal = 'S' THEN ISNULL(Despensas.Ispt, 0)
                 ELSE 0
            END AS IsptDespensa
    INTO    dbo.Tmp_p_Isr
    FROM    dbo.p_Nomina_Tot AS Nomina_Tot --Left Join Llaves      On Nomina_Tot.Codigo  = Llaves.Codigo And Nomina_Tot.Empresa = Llaves.Empresa
            LEFT JOIN dbo.p_Empleados_pres AS Empleados ON Nomina_Tot.Codigo = Empleados.Codigo
                                                           AND Nomina_Tot.Empresa = Empleados.Empresa
                                                           AND Nomina_Tot.id_presup = Empleados.id_presup
            LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 16
                                       AND empleados.Clase = Conceptos.Clase
                                       AND Conceptos.Empresa = empleados.Empresa
            LEFT JOIN dbo.Tabulador ON empleados.Ocupacion = Tabulador.Ocupacion
                                       AND empleados.Empresa = Tabulador.Empresa
--Left Join Empleados   On Nomina_Tot.Codigo  = Empleados.Codigo And Nomina_Tot.Empresa = Empleados.Empresa
            LEFT JOIN dbo.Excepciones ON Nomina_Tot.Codigo = Excepciones.Codigo
                                         AND Excepciones.Excepcion1 = '115'
                                         AND Excepciones.Empresa = Nomina_Tot.Empresa
            LEFT JOIN dbo.Despensas ON Nomina_Tot.Codigo = Despensas.Codigo
                                       AND ( ( Despensas.FchPago >= @dInicio
                                               AND Despensas.FchPago <= @dCierre
                                             )
                                             OR Despensas.FchPago = @dPago
                                           )
                                       AND Despensas.Ispt > 0
    WHERE   Nomina_Tot.TipoNom = @nTipoNom
            AND empleados.id_presup = @id_presup
            AND Nomina_Tot.ayo_operacion = @nAyo
            AND Nomina_Tot.mes_operacion = @nMes

-- Si es calculo Mensualizado y sobre los dias del periodo, actualizar la columna Dias incrementandole los ausentismos
    UPDATE  dbo.Tmp_p_Isr
    SET     Dias = Dias_Pagar + CASE WHEN DiasCalc = 1
                                          OR @cBase = 'P' THEN 0
                                     ELSE Aus + Incap
                                END
--


    IF @cBase = 'M' 
        BEGIN

    -- Sacar de Mensual los valores acumulados del mes para hacer el ajuste
            UPDATE  dbo.Tmp_p_Isr
            SET     Tmp_p_Isr.Gravable = Mensual.Gravable ,
                    Tmp_p_Isr.Ispt = Mensual.Ispt ,
                    Tmp_p_Isr.Credito = Mensual.CreditoSal ,
                    Tmp_p_Isr.DiasLabor = Mensual.Dias ,
                    Tmp_p_Isr.Subsidio = CASE WHEN Mensual.Subsidio = 0
                                              THEN Mensual.CredTotal
                                              ELSE Mensual.Subsidio
                                         END ,
                    Tmp_p_Isr.DevIspt = CASE WHEN @cAjusta = 'S'
                                                  AND ( Tmp_p_Isr.Jornada = 0
                                                        OR Tmp_p_Isr.Jornada = 6
                                                      )
                                                  AND Mensual.Ispt > 0
                                             THEN Mensual.Ispt
                                             ELSE 0
                                        END ,
                    Tmp_p_Isr.RetCredito = CASE WHEN @cAjusta = 'S'
                                                     AND ( Tmp_p_Isr.Jornada = 0
                                                           OR Tmp_p_Isr.Jornada = 6
                                                         )
                                                     AND Mensual.CreditoSal > 0
                                                THEN Mensual.CreditoSal
                                                ELSE 0
                                           END ,
                    Tmp_p_Isr.DevSubs = CASE WHEN @cAjusta = 'S'
                                                  AND ( Tmp_p_Isr.Jornada = 0
                                                        OR Tmp_p_Isr.Jornada = 6
                                                      )
                                             THEN CASE WHEN Mensual.Subsidio = 0
                                                       THEN Mensual.CredTotal
                                                       ELSE Mensual.Subsidio
                                                  END
                                             ELSE 0
                                        END
            FROM    dbo.Tmp_p_Isr
                    LEFT JOIN dbo.Mensual ON Tmp_p_Isr.Codigo = Mensual.Codigo
                                             AND Mensual.TipoNom = @nTipoNom
                                             AND Mensual.Empresa IN (
                                             SELECT empresa
                                             FROM   dbo.p_empresas
                                             WHERE  id_presup = @id_presup )
            WHERE   EXISTS ( SELECT Codigo
                             FROM   dbo.Mensual
                             WHERE  Mensual.Codigo = Tmp_p_Isr.Codigo
                                    AND Mensual.TipoNom = @nTipoNom
                                    AND Mensual.Empresa = Tmp_p_Isr.Empresa )
    --


    -- Actualizar el campo Sueldo con el promedio
            UPDATE  dbo.Tmp_p_Isr
            SET     Tmp_p_Isr.Sueldo = ( Tmp_p_Isr.Percepcion
                                         + Tmp_p_Isr.Gravable )
                    / ( Tmp_p_Isr.DiasLabor
                        + CASE WHEN Tmp_p_Isr.Dias <= 0 THEN 1
                               ELSE Tmp_p_Isr.Dias
                          END )
            WHERE   Tmp_p_Isr.Variable = 'PROMEDIO'
                    AND ( Tmp_p_Isr.Jornada = 0
                          OR Tmp_p_Isr.Jornada = 6
                        )
    --


    -- Si tiene el mes laborado, ajustar a lo definido en la funcion I...ya sea a 30 o 30.4 dias
            IF @nProyecta = 30 
                UPDATE  dbo.Tmp_p_Isr
                SET     Tmp_p_Isr.Dias = Tmp_p_Isr.Dias + ( 30
                                                            - ( Tmp_p_Isr.Dias
                                                              + Tmp_p_Isr.DiasLabor ) )
                WHERE   ( ( Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor = 30
                            AND MONTH(@dInicio) <> 2
                          )
                          OR ( ( Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor >= 28
                                 AND Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor <= 31
                               )
                               AND MONTH(@dInicio) = 2
                             )
                        )
                        AND ( Tmp_p_Isr.Jornada = 0
                              OR Tmp_p_Isr.Jornada = 6
                            )
            ELSE 
                UPDATE  dbo.Tmp_p_Isr
                SET     Tmp_p_Isr.Dias = Tmp_p_Isr.Dias + ( 30.4
                                                            - ( Tmp_p_Isr.Dias
                                                              + Tmp_p_Isr.DiasLabor ) )
                WHERE   ( ( ( Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor = 30
                              OR Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor = 31
                            )
                            AND MONTH(@dInicio) <> 2
                          )
                          OR ( ( Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor >= 28
                                 AND Tmp_p_Isr.Dias + Tmp_p_Isr.DiasLabor <= 31
                               )
                               AND MONTH(@dInicio) = 2
                             )
                        )
                        AND ( Tmp_p_Isr.Jornada = 0
                              OR Tmp_p_Isr.Jornada = 6
                            )
    --


    -- Sino tiene dias y tiene percepcion, registrarle un dia para poder hacer el calculo del ISR
            UPDATE  dbo.Tmp_p_Isr
            SET     Dias = 1
            WHERE   Tmp_p_Isr.Dias <= 0
                    AND Tmp_p_Isr.Percepcion > 0
    --


    -- Llamar a la funcion que calcula el ISR
            UPDATE  dbo.Tmp_p_Isr
            SET     Valor1 = dbo.Fun_R_Isr_Mensual(Tmp_p_Isr.Percepcion,
                                                   Tmp_p_Isr.Dias,
                                                   Tmp_p_Isr.Gravable,
                                                   Tmp_p_Isr.DiasLabor,
                                                   Tmp_p_Isr.Ispt,
                                                   Tmp_p_Isr.Credito,
                                                   CASE WHEN Tmp_p_Isr.Variable = 'SALDIAINT'
                                                        THEN Tmp_p_Isr.SalDiaInt
                                                        ELSE Tmp_p_Isr.Sueldo
                                                   END, Tmp_p_Isr.Subsidio, 0,
                                                   0, Tmp_p_Isr.Excepcion,
                                                   @nProyecta,
                                                   Tmp_p_Isr.Variable, 'N',
                                                   YEAR(@dPago), 7,
                                                   Tmp_p_Isr.Empresa) ,
                    Valor2 = dbo.Fun_R_Isr_Mensual(Tmp_p_Isr.Percepcion,
                                                   Tmp_p_Isr.Dias,
                                                   Tmp_p_Isr.Gravable,
                                                   Tmp_p_Isr.DiasLabor,
                                                   Tmp_p_Isr.Ispt,
                                                   Tmp_p_Isr.Credito,
                                                   CASE WHEN Tmp_p_Isr.Variable = 'SALDIAINT'
                                                        THEN Tmp_p_Isr.SalDiaInt
                                                        ELSE Tmp_p_Isr.Sueldo
                                                   END, Tmp_p_Isr.Subsidio, 0,
                                                   0, Tmp_p_Isr.Excepcion,
                                                   @nProyecta,
                                                   Tmp_p_Isr.Variable, 'N',
                                                   YEAR(@dPago), 8,
                                                   Tmp_p_Isr.Empresa)
            WHERE   Tmp_p_Isr.Percepcion > 1
                    AND ( Tmp_p_Isr.Jornada = 0
                          OR Tmp_p_Isr.Jornada = 6
                        )
                    AND ( Tmp_p_Isr.Convenio_Isr <> 'S'
                          OR Tmp_p_Isr.Porc_Isr <= 0
                        )
    --

    -- Para los empleados con semana reducida, no aplica el calculo mensual...asi es que debe aplicar el periodico
            UPDATE  dbo.Tmp_p_Isr
            SET     Valor1 = dbo.Fun_R_Isr_Periodico(Tmp_p_Isr.Percepcion,
                                                     Tmp_p_Isr.Dias_Pagar, 0,
                                                     YEAR(@dPago), 7,
                                                     Tmp_p_Isr.Empresa) , -- Isr 2008
                    Valor2 = dbo.Fun_R_Isr_Periodico(Tmp_p_Isr.Percepcion,
                                                     Tmp_p_Isr.Dias_Pagar, 0,
                                                     YEAR(@dPago), 8,
                                                     Tmp_p_Isr.Empresa)  -- Subsidio para el empleo
            WHERE   Tmp_p_Isr.Percepcion > 1
                    AND Tmp_p_Isr.Jornada <> 0
                    AND Tmp_p_Isr.Jornada <> 6
                    AND ( Tmp_p_Isr.Convenio_Isr <> 'S'
                          OR Tmp_p_Isr.Porc_Isr <= 0
                        )
    --

        END


-- Ejecutar la funcion que determina el ISR periodico
    ELSE 
        BEGIN

    -- a los que no tienen dias, pero si base gravable...registrarles un dia para el calculo del isr
            UPDATE  dbo.Tmp_p_Isr
            SET     Dias_Pagar = @nDiasPer
            WHERE   Percepcion > 0
                    AND Dias_Pagar <= 0
                    AND ( Convenio_Isr <> 'S'
                          OR Porc_Isr <= 0
                        )

            UPDATE  dbo.Tmp_p_Isr
            SET     Valor1 = dbo.Fun_R_Isr_Periodico(Tmp_p_Isr.Percepcion,
                                                     Tmp_p_Isr.Dias_Pagar, 0,
                                                     YEAR(@dPago), 7,
                                                     Tmp_p_Isr.Empresa) ,  -- Isr 2008
                    Valor2 = dbo.Fun_R_Isr_Periodico(Tmp_p_Isr.Percepcion,
                                                     Tmp_p_Isr.Dias_Pagar, 0,
                                                     YEAR(@dPago), 8,
                                                     Tmp_p_Isr.Empresa)   -- Subsidio para el empleo
            WHERE   Tmp_p_Isr.Percepcion > 1
                    AND ( Tmp_p_Isr.Convenio_Isr <> 'S'
                          OR Tmp_p_Isr.Porc_Isr <= 0
                        )

        END


-- Empleados con convenio para la retencion de ISR sobre el Integrado del IMSS
    UPDATE  dbo.Tmp_p_Isr
    SET     Percepcion = Tmp_p_Isr.SalDiaInt * Tmp_p_Isr.Dias_Pagar ,
            Valor1 = Tmp_p_Isr.SalDiaInt * Tmp_p_Isr.Dias_Pagar
            * ( Tmp_p_Isr.Porc_Isr / 100 ) ,
            Valor2 = 0
    WHERE   Tmp_p_Isr.Convenio_Isr = 'S'
            AND Tmp_p_Isr.Porc_Isr > 0
--


-- Para los empleados a los que solo se les aplica el ISR, sin subsidio ni credito
    UPDATE  dbo.Tmp_p_Isr
    SET     Valor2 = 0
    WHERE   Tmp_p_Isr.Excepcion = '115'
--


-- Llenar los campos con el ISR neto real
    UPDATE  dbo.Tmp_p_Isr
    SET     IsrReal = Tmp_p_Isr.Valor1 - Tmp_p_Isr.Valor2 ,
            TotIspt = Tmp_p_Isr.Valor1 - Tmp_p_Isr.Valor2
--


-- Si tiene calculo mensualizado y no tiene ingresos, inicializar los campos
-- las contras de ISR y credito al salario
    IF ( ( ( @cBase = 'M'
             OR @cBase = 'T'
           )
           AND @cAjusta = 'S'
         )
         OR @cBase = 'A'
       ) 
        UPDATE  dbo.Tmp_p_Isr
        SET     DevIspt = 0 ,
                RetCredito = 0 ,
                DevSubs = 0
        WHERE   Tmp_p_Isr.Percepcion < 1
--


-- Si tiene calculo mensualizado, analizar las contras de Devoluciones y Retenciones segun corresponda
    IF @cAjusta = 'S' --@cBase = 'M'
        BEGIN

    /* Asi estaba: 04/Mzo/2008
    Update Tmp_p_Isr Set C36   = Case When Tmp_p_Isr.Valor1 < 0 And Tmp_p_Isr.RetCredito = 0 Then Abs(Tmp_p_Isr.Valor1) -- Si tiene Credito mensual y no se le ha pagado nada, aplicar el total
                                    When Tmp_p_Isr.Valor1 < 0 And Abs(Tmp_p_Isr.Valor1) > Tmp_p_Isr.RetCredito Then Abs(Tmp_p_Isr.Valor1) - Tmp_p_Isr.RetCredito -- Sino, aplicar la diferencia unicamente (si el mensual es menor al que se ha pagado)
                                    Else 0 End,
                       C136  = Case When Tmp_p_Isr.Valor1 > 0 And Tmp_p_Isr.DevIspt = 0 Then Tmp_p_Isr.Valor1 -- Si tiene ISR y no se le ha retenido nada, retener el total
                                    When Tmp_p_Isr.Valor1 > 0 And Tmp_p_Isr.DevIspt > 0 And Tmp_p_Isr.Valor1 > Tmp_p_Isr.DevIspt Then Tmp_p_Isr.Valor1 - Tmp_p_Isr.DevIspt -- Sino, retener la diferencia (si el mensual es menor al retenido)
                                    Else 0 End,
                       C1036 = Case When Tmp_p_Isr.Valor1 < 0 And Tmp_p_Isr.RetCredito > 0 And Abs(Tmp_p_Isr.Valor1) < Tmp_p_Isr.RetCredito Then Tmp_p_Isr.RetCredito - Abs(Tmp_p_Isr.Valor1)
                                    When Tmp_p_Isr.Valor1 > 0 And Tmp_p_Isr.RetCredito > 0 Then Tmp_p_Isr.RetCredito
                                    Else 0 End,
                       C1136 = Case When Tmp_p_Isr.Valor1 < 0 And Tmp_p_Isr.DevIspt > 0 Then Tmp_p_Isr.DevIspt  -- Si se le retuvo ISR y a fin de mes tiene Credito, devolver el ISR
                                    When Tmp_p_Isr.Valor1 > 0 And Tmp_p_Isr.DevIspt > 0 And Tmp_p_Isr.Valor1 < Tmp_p_Isr.DevIspt Then Tmp_p_Isr.DevIspt - Tmp_p_Isr.Valor1  -- Si se le retuvo ISR de mas, devolver la diferencia
                                    Else 0 End
    Where (Tmp_p_Isr.Jornada = 0 Or Tmp_p_Isr.Jornada = 6)
    */

            UPDATE  dbo.Tmp_p_Isr
            SET     C36 = CASE WHEN Tmp_p_Isr.IsrReal < 0
                                    AND Tmp_p_Isr.RetCredito = 0
                               THEN ABS(Tmp_p_Isr.IsrReal) -- Si tiene Credito mensual y no se le ha pagado nada, aplicar el total
                               WHEN Tmp_p_Isr.IsrReal < 0
                                    AND ABS(Tmp_p_Isr.IsrReal) > Tmp_p_Isr.RetCredito
                               THEN ABS(Tmp_p_Isr.IsrReal)
                                    - Tmp_p_Isr.RetCredito -- Sino, aplicar la diferencia unicamente (si el mensual es menor al que se ha pagado)
                               ELSE 0
                          END ,
                    C136 = CASE WHEN Tmp_p_Isr.IsrReal > 0
                                     AND Tmp_p_Isr.DevIspt = 0
                                THEN Tmp_p_Isr.IsrReal -- Si tiene ISR y no se le ha retenido nada, retener el total
                                WHEN Tmp_p_Isr.IsrReal > 0
                                     AND Tmp_p_Isr.DevIspt > 0
                                     AND Tmp_p_Isr.IsrReal > Tmp_p_Isr.DevIspt
                                THEN Tmp_p_Isr.IsrReal - Tmp_p_Isr.DevIspt -- Sino, retener la diferencia (si el mensual es menor al retenido)
                                ELSE 0
                           END ,
                    C1036 = CASE WHEN Tmp_p_Isr.IsrReal < 0
                                      AND Tmp_p_Isr.RetCredito > 0
                                      AND ABS(Tmp_p_Isr.IsrReal) < Tmp_p_Isr.RetCredito
                                 THEN Tmp_p_Isr.RetCredito
                                      - ABS(Tmp_p_Isr.IsrReal)
                                 WHEN Tmp_p_Isr.IsrReal > 0
                                      AND Tmp_p_Isr.RetCredito > 0
                                 THEN Tmp_p_Isr.RetCredito
                                 ELSE 0
                            END ,
                    C1136 = CASE WHEN Tmp_p_Isr.IsrReal < 0
                                      AND Tmp_p_Isr.DevIspt > 0
                                 THEN Tmp_p_Isr.DevIspt  -- Si se le retuvo ISR y a fin de mes tiene Credito, devolver el ISR
                                 WHEN Tmp_p_Isr.IsrReal > 0
                                      AND Tmp_p_Isr.DevIspt > 0
                                      AND Tmp_p_Isr.IsrReal < Tmp_p_Isr.DevIspt
                                 THEN Tmp_p_Isr.DevIspt - Tmp_p_Isr.IsrReal  -- Si se le retuvo ISR de mas, devolver la diferencia
                                 ELSE 0
                            END
            WHERE   ( Tmp_p_Isr.Jornada = 0
                      OR Tmp_p_Isr.Jornada = 6
                    )


            UPDATE  dbo.Tmp_p_Isr
            SET     TotIspt = ( C136 + C1036 ) - ( C36 - C1136 )
            WHERE   ( Tmp_p_Isr.Jornada = 0
                      OR Tmp_p_Isr.Jornada = 6
                    )


            UPDATE  dbo.Tmp_p_Isr
            SET     Valor2 = Tmp_p_Isr.Valor2 - Tmp_p_Isr.DevSubs
            WHERE   Tmp_p_Isr.Percepcion > 1
                    AND ( Tmp_p_Isr.Jornada = 0
                          OR Tmp_p_Isr.Jornada = 6
                        )
                    AND ( Tmp_p_Isr.Convenio_Isr <> 'S'
                          OR Tmp_p_Isr.Porc_Isr <= 0
                        )


    -- Para los de semana reducida, no hay ajuste mensual, solo registrar los conceptos
    -- del calculo periodico
            UPDATE  dbo.Tmp_p_Isr
            SET     C36 = CASE WHEN Tmp_p_Isr.IsrReal < 0
                               THEN ABS(Tmp_p_Isr.IsrReal)
                               ELSE 0
                          END ,
                    C136 = CASE WHEN Tmp_p_Isr.IsrReal > 0
                                THEN Tmp_p_Isr.IsrReal
                                ELSE 0
                           END
            WHERE   Tmp_p_Isr.Jornada <> 0
                    AND Tmp_p_Isr.Jornada <> 6


        END

-- Si el calculo periodico, solo registrar los importes en el campo respectivo
    ELSE 
        UPDATE  dbo.Tmp_p_Isr
        SET     C36 = CASE WHEN Tmp_p_Isr.IsrReal < 0
                           THEN ABS(Tmp_p_Isr.IsrReal)
                           ELSE 0
                      END ,
                C136 = CASE WHEN Tmp_p_Isr.IsrReal > 0 THEN Tmp_p_Isr.IsrReal
                            ELSE 0
                       END


-- Si tiene la indicacion de gravar todas las percepciones al 100%
-- actualizar los campos
    IF @cGrava100 = 'S' 
        UPDATE  dbo.p_Nomina_Tot
        SET     Perc_Grava = p_Nomina_Tot.Perc_Grava
                + p_Nomina_Tot.Perc_Exento ,
                Perc_Exento = 0
        WHERE   p_Nomina_Tot.TipoNom = @nTipoNom
                AND p_Nomina_Tot.Empresa IN ( SELECT    empresa
                                              FROM      dbo.p_empresas
                                              WHERE     id_presup = @id_presup )


-- Actualizar los valores de Nomina_Tot
    UPDATE  p_Nomina_Tot
    SET     Tot_Ispt = ISNULL(Nomina_Tot.Tot_Ispt, 0) + Tmp_p_Isr.TotIspt
            + Tmp_p_Isr.IsptDespensa ,
            IsptReal = ISNULL(Nomina_Tot.IsptReal, 0) + ISNULL(Tmp_p_Isr.C136,
                                                              0) ,
            CredReal = ISNULL(Nomina_Tot.CredReal, 0) + ISNULL(Tmp_p_Isr.C36,
                                                              0) ,
            IsptContra = ISNULL(Nomina_Tot.IsptContra, 0)
            + ISNULL(Tmp_p_Isr.C1136, 0) ,
            CredContra = ISNULL(Nomina_Tot.CredContra, 0)
            + ISNULL(Tmp_p_Isr.C1036, 0) ,
            Perc_Exento = ISNULL(Nomina_Tot.Perc_Exento, 0)
            + ISNULL(Tmp_p_Isr.C36, 0) + ISNULL(Tmp_p_Isr.C1136, 0) ,
            Tot_Percep = ISNULL(Nomina_Tot.Tot_Percep, 0)
            + ISNULL(Tmp_p_Isr.C36, 0) + ISNULL(Tmp_p_Isr.C1136, 0) ,
            Dedu_Exent = ISNULL(Nomina_Tot.Dedu_Exent, 0)
            + ISNULL(Tmp_p_Isr.C136, 0) + ISNULL(Tmp_p_Isr.C1036, 0)
            + ISNULL(Tmp_p_Isr.IsptDespensa, 0) ,
            Tot_Deducc = ISNULL(Nomina_Tot.Tot_Deducc, 0)
            + ISNULL(Tmp_p_Isr.C136, 0) + ISNULL(Tmp_p_Isr.C1036, 0)
            + ISNULL(Tmp_p_Isr.IsptDespensa, 0) ,
            Subsidio = Tmp_p_Isr.Valor2
    FROM    dbo.p_Nomina_Tot AS Nomina_Tot
            LEFT JOIN dbo.Tmp_p_Isr ON Tmp_p_Isr.Codigo = Nomina_Tot.Codigo
                                       AND Nomina_Tot.Empresa = Tmp_p_Isr.Empresa
    WHERE   Nomina_Tot.id_presup = @id_presup
            AND Nomina_Tot.TipoNom = @nTipoNom
            AND Nomina_Tot.Empresa IN ( SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
--


-- Actualizar el neto
    UPDATE  dbo.p_Nomina_Tot
    SET     Neto = p_Nomina_Tot.Tot_Percep - p_Nomina_Tot.Tot_Deducc
    WHERE   p_Nomina_Tot.id_presup = @id_presup
            AND p_Nomina_Tot.TipoNom = @nTipoNom 
--


-- Actualizar tabla MES, con los resultados del calculo
/*
Update Mes Set Ispt_Reten = Mes.Ispt_Reten + (Tmp_p_Isr.C136 - Tmp_p_Isr.C36) - Tmp_p_Isr.C1136 - (0-Tmp_p_Isr.C1036) + Tmp_p_Isr.IsptDespensa,
               Subsidio   = Tmp_p_Isr.Valor2,
               CredTotal  = Tmp_p_Isr.Valor2,
               Fecha_Afec = @dPago,
               CreditoSal = Mes.CreditoSal + Tmp_p_Isr.C36 - C1036,
               Ispt       = Mes.Ispt + Tmp_p_Isr.C136 - Tmp_p_Isr.C1136 + Tmp_p_Isr.IsptDespensa
From Mes
Left Join Tmp_p_Isr On Mes.Codigo = Tmp_p_Isr.Codigo And Mes.Empresa = @nEmpresa
Where Mes.TipoNom = @nTipoNom And
      Mes.Empresa = @nEmpresa
*/
--<


-- Armar un archivo temporal con los conceptos
    SELECT  Tmp_p_Isr.Codigo ,
            Tmp_p_Isr.Empresa ,
            @cTipoNom AS Nomina ,
            ' ' AS Centro ,
            36 AS Num_Conc ,
            ' ' AS Clase ,
            0 AS Folio ,
            0 AS Renglon ,
            @dInicio AS Fch_Inicio ,
            @dCierre AS Fch_Cierre ,
            @dPago AS Fch_Pago ,
            Tmp_p_Isr.Dias ,
            0 AS Inc ,
            0 AS Aus ,
            Tmp_p_Isr.Dias AS DiasTr ,
            0 AS Dias_Imss ,
            'P' AS TPago_Desc ,
            Conceptos.Concepto ,
            0 AS VariaImss ,
            0 AS Variable ,
            Conceptos.Imss ,
            Conceptos.Ispt ,
            Conceptos.Ptu ,
            Conceptos.Despensa ,
            Conceptos.Mca_Agui ,
            Conceptos.FdoAhorro ,
            'A' AS Calculo ,
            CASE WHEN @cBase = 'M'
                      AND Tmp_p_Isr.Variable = 'INTEGRADO'
                 THEN Tmp_p_Isr.SalDiaInt
                 ELSE Tmp_p_Isr.Sueldo
            END AS Impor_Base ,
            Tmp_p_Isr.SalDiaInt ,
            0 AS Tabulador ,
            0 AS Unidades ,
            0 AS Horas ,
            'ISP' AS Tipo_Mov ,
            0 AS Secuencia ,
            Tmp_p_Isr.C36 AS Importe ,
            0 AS IGravable ,
            0 AS IExento ,
            0 AS Credito ,
            0 AS Descuento ,
            0 AS Saldo ,
            ' ' AS Referencia ,
            'N' AS Siempre ,
            ' ' AS Justificar ,
            ' ' AS Septimo ,
            'F' AS PrevSocial ,
            Tmp_p_Isr.Valor2 AS Varia1 ,
            0 AS Varia2 ,
            0 AS Varia3 ,
            0 AS Varia4 ,
            ' ' AS Variable1 ,
            Conceptos.Variable2 ,
            ' ' AS Variable3 ,
            ' ' AS variable4 ,
            'F' AS Masivo ,
            ' ' AS Formula ,
            ' ' AS Ispt_NG ,
            ' ' AS Imss_NI ,
            ' ' AS Marca ,
            0 AS Serial ,
            'F' AS Informativo ,
            @id_presup AS id_presup ,
            @nAyo AS ayo_operacion ,
            @nMes AS mes_operacion
    INTO    dbo.Tmp_p_Deducciones
    FROM    dbo.Tmp_p_Isr
            LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 36
                                       AND Conceptos.Empresa = Tmp_p_Isr.Empresa
    WHERE   Tmp_p_Isr.C36 > 0



    INSERT  INTO dbo.Tmp_p_Deducciones
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_p_Isr.Codigo ,
                        Tmp_p_Isr.Empresa AS Empresa ,
                        @cTipoNom AS Nomina ,
                        ' ' AS Centro ,
                        136 AS Num_Conc ,
                        ' ' AS Clase ,
                        0 AS Folio ,
                        0 AS Renglon ,
                        @dInicio AS Fch_Inicio ,
                        @dCierre AS Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        Tmp_p_Isr.Dias ,
                        0 AS Inc ,
                        0 AS Aus ,
                        Tmp_p_Isr.Dias AS DiasTr ,
                        0 AS Dias_Imss ,
                        'D' AS TPago_Desc ,
                        Conceptos.Concepto ,
                        0 AS VariaImss ,
                        0 AS Variable ,
                        Conceptos.Imss ,
                        Conceptos.Ispt ,
                        Conceptos.Ptu ,
                        Conceptos.Despensa ,
                        Conceptos.Mca_Agui ,
                        Conceptos.FdoAhorro ,
                        'A' AS Calculo ,
                        CASE WHEN @cBase = 'M'
                                  AND Tmp_p_Isr.Variable = 'INTEGRADO'
                             THEN Tmp_p_Isr.SalDiaInt
                             ELSE Tmp_p_Isr.Sueldo
                        END AS Impor_Base ,
                        Tmp_p_Isr.SalDiaInt ,
                        0 AS Tabulador ,
                        0 AS Unidades ,
                        0 AS Horas ,
                        'ISP' AS Tipo_Mov ,
                        0 AS Secuencia ,
                        Tmp_p_Isr.C136 + Tmp_p_Isr.IsptDespensa AS Importe ,
                        0 AS IGravable ,
                        0 AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        ' ' AS Referencia ,
                        'N' AS Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        'F' AS PrevSocial ,
                        CASE WHEN Tmp_p_Isr.C36 = 0 THEN Tmp_p_Isr.Valor2
                             ELSE 0
                        END AS Varia1 ,
                        0 AS Varia2 ,
                        0 AS Varia3 ,
                        0 AS Varia4 ,
                        ' ' AS Variable1 ,
                        Conceptos.Variable2 ,
                        ' ' AS Variable3 ,
                        ' ' AS variable4 ,
                        'F' AS Masivo ,
                        ' ' AS Formula ,
                        ' ' AS Ispt_NG ,
                        ' ' AS Imss_NI ,
                        ' ' AS Marca ,
                        0 AS Serial ,
                        'F' AS Informativo ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.Tmp_p_Isr
                        LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 136
                                                   AND Conceptos.Empresa = Tmp_p_Isr.Empresa
              WHERE     Tmp_p_Isr.C136 > 0
                        OR Tmp_p_Isr.IsptDespensa > 0
            )



    INSERT  INTO dbo.Tmp_p_Deducciones
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_p_Isr.Codigo ,
                        Tmp_p_Isr.Empresa AS Empresa ,
                        @cTipoNom AS Nomina ,
                        ' ' AS Centro ,
                        1136 AS Num_Conc ,
                        ' ' AS Clase ,
                        0 AS Folio ,
                        0 AS Renglon ,
                        @dInicio AS Fch_Inicio ,
                        @dCierre AS Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        Tmp_p_Isr.Dias ,
                        0 AS Inc ,
                        0 AS Aus ,
                        Tmp_p_Isr.Dias AS DiasTr ,
                        0 AS Dias_Imss ,
                        'P' AS TPago_Desc ,
                        Conceptos.Concepto ,
                        0 AS VariaImss ,
                        0 AS Variable ,
                        Conceptos.Imss ,
                        Conceptos.Ispt ,
                        Conceptos.Ptu ,
                        Conceptos.Despensa ,
                        Conceptos.Mca_Agui ,
                        Conceptos.FdoAhorro ,
                        'A' AS Calculo ,
                        CASE WHEN @cBase = 'M'
                                  AND Tmp_p_Isr.Variable = 'INTEGRADO'
                             THEN Tmp_p_Isr.SalDiaInt
                             ELSE Tmp_p_Isr.Sueldo
                        END AS Impor_Base ,
                        Tmp_p_Isr.SalDiaInt ,
                        0 AS Tabulador ,
                        0 AS Unidades ,
                        0 AS Horas ,
                        'ISP' AS Tipo_Mov ,
                        0 AS Secuencia ,
                        Tmp_p_Isr.C1136 AS Importe ,
                        0 AS IGravable ,
                        0 AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        ' ' AS Referencia ,
                        'N' AS Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        'F' AS PrevSocial ,
                        CASE WHEN Tmp_p_Isr.C36 = 0
                                  AND Tmp_p_Isr.C136 = 0 THEN Tmp_p_Isr.Valor2
                             ELSE 0
                        END AS Varia1 ,
                        0 AS Varia2 ,
                        0 AS Varia3 ,
                        0 AS Varia4 ,
                        ' ' AS Variable1 ,
                        ' ' AS Variable2 ,
                        ' ' AS Variable3 ,
                        ' ' AS variable4 ,
                        'F' AS Masivo ,
                        ' ' AS Formula ,
                        ' ' AS Ispt_NG ,
                        ' ' AS Imss_NI ,
                        ' ' AS Marca ,
                        0 AS Serial ,
                        'F' AS Informativo ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.Tmp_p_Isr
                        LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 136
                                                   AND Conceptos.Empresa = Tmp_p_Isr.Empresa
              WHERE     Tmp_p_Isr.C1136 > 0
            )


    INSERT  INTO dbo.Tmp_p_Deducciones
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_p_Isr.Codigo ,
                        Tmp_p_Isr.Empresa AS Empresa ,
                        @cTipoNom AS Nomina ,
                        ' ' AS Centro ,
                        1036 AS Num_Conc ,
                        ' ' AS Clase ,
                        0 AS Folio ,
                        0 AS Renglon ,
                        @dInicio AS Fch_Inicio ,
                        @dCierre AS Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        Tmp_p_Isr.Dias ,
                        0 AS Inc ,
                        0 AS Aus ,
                        Tmp_p_Isr.Dias AS DiasTr ,
                        0 AS Dias_Imss ,
                        'D' AS TPago_Desc ,
                        Conceptos.Concepto ,
                        0 AS VariaImss ,
                        0 AS Variable ,
                        Conceptos.Imss ,
                        Conceptos.Ispt ,
                        Conceptos.Ptu ,
                        Conceptos.Despensa ,
                        Conceptos.Mca_Agui ,
                        Conceptos.FdoAhorro ,
                        'A' AS Calculo ,
                        CASE WHEN @cBase = 'M'
                                  AND Tmp_p_Isr.Variable = 'INTEGRADO'
                             THEN Tmp_p_Isr.SalDiaInt
                             ELSE Tmp_p_Isr.Sueldo
                        END AS Impor_Base ,
                        Tmp_p_Isr.SalDiaInt ,
                        0 AS Tabulador ,
                        0 AS Unidades ,
                        0 AS Horas ,
                        'ISP' AS Tipo_Mov ,
                        0 AS Secuencia ,
                        Tmp_p_Isr.C1036 AS Importe ,
                        0 AS IGravable ,
                        0 AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        ' ' AS Referencia ,
                        'N' AS Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        'F' AS PrevSocial ,
                        CASE WHEN Tmp_p_Isr.C36 = 0
                                  AND Tmp_p_Isr.C136 = 0
                                  AND Tmp_p_Isr.C1136 = 0
                             THEN Tmp_p_Isr.Valor2
                             ELSE 0
                        END AS Varia1 ,
                        0 AS Varia2 ,
                        0 AS Varia3 ,
                        0 AS Varia4 ,
                        ' ' AS Variable1 ,
                        ' ' AS Variable2 ,
                        ' ' AS Variable3 ,
                        ' ' AS variable4 ,
                        'F' AS Masivo ,
                        ' ' AS Formula ,
                        ' ' AS Ispt_NG ,
                        ' ' AS Imss_NI ,
                        ' ' AS Marca ,
                        0 AS Serial ,
                        'F' AS Informativo ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.Tmp_p_Isr
                        LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 36
                                                   AND Conceptos.Empresa = Tmp_p_Isr.Empresa
              WHERE     Tmp_p_Isr.C1036 > 0
            )


    INSERT  INTO dbo.Tmp_p_Deducciones
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_p_Isr.Codigo ,
                        Tmp_p_Isr.Empresa AS Empresa ,
                        @cTipoNom AS Nomina ,
                        ' ' AS Centro ,
                        211 AS Num_Conc ,
                        ' ' AS Clase ,
                        0 AS Folio ,
                        0 AS Renglon ,
                        @dInicio AS Fch_Inicio ,
                        @dCierre AS Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        Tmp_p_Isr.Dias ,
                        0 AS Inc ,
                        0 AS Aus ,
                        Tmp_p_Isr.Dias AS DiasTr ,
                        0 AS Dias_Imss ,
                        'I' AS TPago_Desc ,
                        Conceptos.Concepto ,
                        0 AS VariaImss ,
                        0 AS Variable ,
                        Conceptos.Imss ,
                        Conceptos.Ispt ,
                        Conceptos.Ptu ,
                        Conceptos.Despensa ,
                        Conceptos.Mca_Agui ,
                        Conceptos.FdoAhorro ,
                        'A' AS Calculo ,
                        CASE WHEN @cBase = 'M'
                                  AND Tmp_p_Isr.Variable = 'INTEGRADO'
                             THEN Tmp_p_Isr.SalDiaInt
                             ELSE Tmp_p_Isr.Sueldo
                        END AS Impor_Base ,
                        Tmp_p_Isr.SalDiaInt ,
                        0 AS Tabulador ,
                        0 AS Unidades ,
                        0 AS Horas ,
                        'ISP' AS Tipo_Mov ,
                        0 AS Secuencia ,
                        Tmp_p_Isr.Valor2 AS Importe ,
                        0 AS IGravable ,
                        0 AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        ' ' AS Referencia ,
                        'N' AS Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        'F' AS PrevSocial ,
                        0 AS Varia1 ,
                        0 AS Varia2 ,
                        0 AS Varia3 ,
                        0 AS Varia4 ,
                        ' ' AS Variable1 ,
                        ' ' AS Variable2 ,
                        ' ' AS Variable3 ,
                        ' ' AS variable4 ,
                        'F' AS Masivo ,
                        ' ' AS Formula ,
                        ' ' AS Ispt_NG ,
                        ' ' AS Imss_NI ,
                        ' ' AS Marca ,
                        0 AS Serial ,
                        'F' AS Informativo ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.Tmp_p_Isr
                        LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 211
                                                   AND Conceptos.Empresa = Tmp_p_Isr.Empresa
              WHERE     Tmp_p_Isr.Valor2 > 0
            )


--Generar un Kardex temporal para llamar a la funcion que genera los Folios, lo requiere ordenado por codigo
    SELECT  *
    INTO    dbo.Tmp_p_Kardex
    FROM    dbo.Tmp_p_Deducciones
    ORDER BY Codigo ,
            Num_Conc
--


-- Determinar los folios para la insercion en el kardex
--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Kardex','Folio',0,0
--


-- Insertar la informacion definitiva en el Kardex
    INSERT  INTO dbo.p_Kardex
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    *
              FROM      dbo.Tmp_p_Kardex
            )
--


    DROP TABLE dbo.Tmp_p_Isr
    DROP TABLE dbo.Tmp_p_Deducciones
    DROP TABLE dbo.Tmp_p_Kardex


GO


If OBJECT_ID('dbo.asp_p_Imss') Is NOT NULL
  Drop Procedure dbo.asp_p_Imss
Go


Create Procedure dbo.asp_p_Imss
@id_presup      Int,
@nTipoNom      Int,
@nSalMin       Numeric(10,2),
@nSalDF        Numeric(10,2),
@dFF           DateTime,
@cReformas2014 Char(1)

As


Declare @cMinimos  Char(1)
Declare @nTope     Int
Declare @dInicio   DateTime
Declare @dCierre   DateTime
Declare @dPago     DateTime
Declare @cTipoNom  Char(3)
Declare @cMarca108 Char(1)
Declare @cMarca106 Char(1)
Declare @nConcepto Int

Declare @dFechaTab DateTime

Set @nConcepto = 101

Set @cTipoNom = Case When @nTipoNom = 1 Then 'SEM'
                     When @nTipoNom = 2 Then 'DEC'
                     When @nTipoNom = 3 Then 'CAT'
                     When @nTipoNom = 4 Then 'QNA'
                     When @nTipoNom = 5 Then 'MES' Else 'ESP' End

declare @mes int
declare @ayo int

Select @dInicio = Periodos.Inicio, @dCierre = Periodos.Cierre, @dPago = Periodos.Pago,@mes=Periodos.mes,@ayo=Periodos.ejercicio
From p_dias as  Periodos Where Estatus = 'A' And id_presup = @id_presup And TipoNom = @nTipoNom

Set @nTope    = Case When Year(@dFF) < 2009 Then 15 + Case When Year(@dPago) >= 1997 Then Year(@dPago)-1997 Else 0 End Else 25 End

Set @cMinimos = Case When (Select Count(Num_Conc) From Conceptos Where Num_Conc = 101 And Marca1 = 'S' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) > 0 Then 'S' Else 'N' End

Set @cMarca108 = (Select max(Imss) From Conceptos Where Num_Conc = 108 And Centro = '' And Clase = '' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup))

Set @cMarca106 = (Select max(Uso) From Conceptos Where Num_Conc = 106 And Uso = 'S' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup))


If @nTope > 25
  Set @nTope = 25


-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
If @dPago > @dFF
  Set @dFechaTab = @dFF
Else
  Set @dFechaTab = @dPago
--


--If OBJECT_ID('dbo.Tmp_p_Provisiona') Is NOT NULL
--  Drop Table dbo.Tmp_p_Provisiona

If OBJECT_ID('dbo.Tmp_p_Imss') Is NOT NULL
  Drop Table dbo.Tmp_p_Imss

If OBJECT_ID('dbo.Tmp_p_Kardex') Is NOT NULL
  Drop Table dbo.Tmp_p_Kardex


CREATE TABLE dbo.Tmp_p_Imss
(
  empresa      Numeric(8,0) NOT NULL ,
  Codigo       Numeric(8,0) NOT NULL ,
  Num_Conc     Int NOT NULL,
  Dias         Numeric(6,2) NOT NULL,
  Dias_Imss    Numeric(6,2) NOT NULL,
  Aus          Numeric(6,2) NOT NULL,
  Inc          Numeric(6,2) NOT NULL,
  Impor_Base   Numeric(10,2) NOT NULL,
  SalDiaInt    Numeric(10,2) NOT NULL,
  Importe      Numeric(10,2) NOT NULL,
  Fch_Inicio   DateTime NOT NULL,
  Fch_Cierre   DateTime NOT NULL,
  Folio        Int NOT NULL,
  Tabulador    Int NULL,
  --Gobierno     Char(1) NULL,
  SalDiaReal   Numeric(10,2) NOT NULL
) ON [PRIMARY]

While @nConcepto <= Case When @cMarca108 = 'S' And @cMarca106 = 'S' Then 106 Else 105 End
Begin
  If (Select max(Registro_Patronal) From Empresas Where Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) <> 'C1217580103'
	begin
	Insert Into Tmp_p_Imss (empresa,Codigo,Num_Conc,Dias_Imss,Dias,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,SalDiaReal)
    Select Tmp_p_Provisiona.empresa,
			Tmp_p_Provisiona.Codigo,
           @nConcepto As Num_Conc,
           Tmp_p_Provisiona.Dias_Imss - Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End - Tmp_p_Provisiona.Inc,
           (Case When @nConcepto <> 106 Then Tmp_p_Provisiona.Dias_Imss Else Tmp_p_Provisiona.Aus-Tmp_p_Provisiona.Tabulador End) As Dias,
           Tmp_p_Provisiona.Aus,
           Tmp_p_Provisiona.Inc,
           Tmp_p_Provisiona.Impor_Base,
           Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
           Case When @nConcepto = 101 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc )*Tmp_p_Provisiona.SalDiaEyM*Primas_Imss.EyMTra25/100)
                When @nConcepto = 102 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc )*(Tmp_p_Provisiona.SalDiaEyM-(IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo)*3))*Primas_Imss.EyMTra1062/100)
                When @nConcepto = 103 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc )*Tmp_p_Provisiona.SalDiaEyM*Primas_Imss.EyMTra107/100)
                When @nConcepto = 104 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc )*Tmp_p_Provisiona.SalDiaIV*Primas_Imss.IVTra147/100)
                When @nConcepto = 105 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc )*Tmp_p_Provisiona.SalDiaIV*Primas_Imss.CVTra168II/100)
                Else Convert(Numeric(10,2), (Tmp_p_Provisiona.Aus - Tmp_p_Provisiona.Tabulador)*Tmp_p_Provisiona.SalDiaEyM*(Primas_Imss.EyMTra25+Primas_Imss.EyMTra107)/100)+
                     (Case When Tmp_p_Provisiona.SalDiaEyM > IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo) * 3 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Aus-Tmp_p_Provisiona.Tabulador)*(Tmp_p_Provisiona.SalDiaEyM-(IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo)*3))*Primas_Imss.EyMTra1062/100) Else 0 End) End As Importe,
           Tmp_p_Provisiona.Fch_Inicio,
           Tmp_p_Provisiona.Fch_Cierre,
		   1 as folio,
           Tmp_p_Provisiona.SalDiaReal
    From Tmp_p_Provisiona
    Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)
    Left Join Excepciones On Tmp_p_Provisiona.Codigo = Excepciones.Codigo And Excepciones.Empresa = Tmp_p_Provisiona.Empresa And Excepciones.Excepcion1 = 'NOIMSS'
    Left Join P_Empleados_Pres as Empleados   On Empleados.Codigo = Tmp_p_Provisiona.Codigo And Empleados.Empresa = Tmp_p_Provisiona.Empresa and empleados.id_presup=@id_presup
    Left Join (Select empresa,
					  Codigo, 
                      Sum(Dias_Imss) As Dias,
                      Sum(Inc) As Inc,
                      Sum(Aus) As Aus
               From Tmp_p_Provisiona
               --Where Num_Conc In (@nTipoNom,7,30,1107) And Empresa = @nEmpresa
               Group By empresa,Codigo) As DsTotales On DsTotales.Codigo = Tmp_p_Provisiona.Codigo and DsTotales.empresa = Tmp_p_Provisiona.empresa

    --Left Join Salarios_Minimos As SalMins On SalMins.Fecha_Ini <= Tmp_p_Provisiona.Fch_Inicio And SalMins.Fecha_Fin >= Tmp_p_Provisiona.Fch_Inicio

    Where --Empleados.Cotiza_Imss = 'S' And
          Tmp_p_Provisiona.Dias_Imss + (Case When @cMarca108 <> 'S' Then Tmp_p_Provisiona.Aus Else 0 End) > 0 And
          Tmp_p_Provisiona.SoloPatron <> 'S' And
			
          (Tmp_p_Provisiona.Dias_Totales - Tmp_p_Provisiona.Aus_Totales - Tmp_p_Provisiona.Inc_Totales > 0 Or Tmp_p_Provisiona.Dias_Imss > Tmp_p_Provisiona.Dias) And
          
          IsNull(Excepciones.Excepcion1,' ') <> 'NOIMSS' And
          (Case When @nConcepto = 101 Then IsNull(Tmp_p_Provisiona.Cv,' ') Else ' ' End) <> 'CV' And
          Tmp_p_Provisiona.SalDiaEyM > (Case When @nConcepto = 102 Then IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo) * 3 Else 0 End) And
          (Case When @nConcepto = 104 Then IsNull(Tmp_p_Provisiona.Cv,' ') Else ' ' End) <> 'CV' And
          (Case When @nConcepto = 104 Then IsNull(Tmp_p_Provisiona.Iv,' ') Else ' ' End) <> 'IV' And
          (Case When @nConcepto = 106 Then Tmp_p_Provisiona.Aus-Tmp_p_Provisiona.Tabulador Else 1 End) > 0 And
          (Case When @nConcepto = 106 Then DsTotales.Dias-DsTotales.Inc-DsTotales.Aus Else 1 End) > 0
    end
  -- Para la empresa 17 de Galaz Yamasaky, calcular IMSS sobre 30.4 dias
  Else begin
	--select 'aqui'
    Insert Into Tmp_p_Imss (empresa,Codigo,Num_Conc,Dias_Imss,Dias,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,SalDiaReal)
    (
    Select Tmp_p_Provisiona.empresa,
		   Tmp_p_Provisiona.Codigo,
           @nConcepto As Num_Conc,
           --Tmp_p_Provisiona.Dias_Imss - Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End - Tmp_p_Provisiona.Inc,
           Case When @nConcepto < 106 
                Then 30.4 - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc
                Else Tmp_p_Provisiona.Aus - Tmp_p_Provisiona.Tabulador
           End As Dias_Imss,
           Case When @nConcepto < 106 
                Then 30.4 - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc
                Else Tmp_p_Provisiona.Aus - Tmp_p_Provisiona.Tabulador
           End As Dias,
           Tmp_p_Provisiona.Aus,
           Tmp_p_Provisiona.Inc,
           Tmp_p_Provisiona.Impor_Base,
           Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
           Convert(Numeric(10,2), (Case When @nConcepto < 106 
										Then 30.4 - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc
                                        --Then Case When Empleados.FchAlta <= @dInicio And (Empleados.UltMov <> 'B' Or Empleados.UltFchMov > @dCierre)
                                        --          Then 30.40
                                        --          When Empleados.FchAlta > @dInicio And (Empleados.UltMov <> 'B' Or Empleados.UltFchMov > @dCierre)
                                        --          Then 30.40 - DateDiff(dd,@dInicio,Empleados.FchAlta)
                                        --          When Empleados.FchAlta < @dInicio And (Empleados.UltMov = 'B' Or Empleados.UltFchMov < @dCierre)
                                        --          Then 30.40 - DateDiff(dd,Empleados.UltFchMov,@dCierre)
                                        --          Else 30.40 - DateDiff(dd,@dInicio,Empleados.FchAlta) - DateDiff(dd,Empleados.UltFchMov,@dCierre)
                                        --     End - (Case When @cMarca108 = 'S' Then Tmp_p_Provisiona.Aus Else 0 End) - Tmp_p_Provisiona.Inc
                                        Else Tmp_p_Provisiona.Aus - Tmp_p_Provisiona.Tabulador
                                   End *
                                   Case When @nConcepto <> 102
                                        Then Tmp_p_Provisiona.SalDiaEyM
                                        Else Tmp_p_Provisiona.SalDiaEyM-(IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo)*3)
                                   End *
                                   Case @nConcepto When 101 Then Primas_Imss.EyMTra25
                                                   When 102 Then Primas_Imss.EyMTra1062
                                                   When 103 Then Primas_Imss.EyMTra107
                                                   When 104 Then Primas_Imss.IVTra147
                                                   When 105 Then Primas_Imss.CVTra168II
                                                   Else (Primas_Imss.EyMTra25+Primas_Imss.EyMTra107)
                                   End / 100)) +
                                   (Case When @nConcepto = 106 And Tmp_p_Provisiona.SalDiaEyM > IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo) * 3 Then Convert(Numeric(10,2),(Tmp_p_Provisiona.Aus-Tmp_p_Provisiona.Tabulador)*(Tmp_p_Provisiona.SalDiaEyM-(IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo)*3))*Primas_Imss.EyMTra1062/100) Else 0 End) As Importe,
           Tmp_p_Provisiona.Fch_Inicio,
           Tmp_p_Provisiona.Fch_Cierre,
           0 As Folio,
           
           Tmp_p_Provisiona.SalDiaReal
    From Tmp_p_Provisiona
    Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)
    Left Join Excepciones On Tmp_p_Provisiona.Codigo = Excepciones.Codigo And Excepciones.Empresa = Tmp_p_Provisiona.Empresa And Excepciones.Excepcion1 = 'NOIMSS'
    Left Join P_Empleados_Pres as Empleados   On Empleados.Codigo = Tmp_p_Provisiona.Codigo And Empleados.Empresa = Tmp_p_Provisiona.Empresa and Empleados.id_presup=@id_presup
    Left Join (Select Codigo, 
					  empresa,
                      Sum(Dias_Imss) As Dias,
                      Sum(Inc) As Inc,
                      Sum(Aus) As Aus
               From Tmp_p_Provisiona
               --Where Num_Conc In (@nTipoNom,7,30,1107) And Empresa = @nEmpresa
               Group By empresa,Codigo) As DsTotales On DsTotales.Codigo = Tmp_p_Provisiona.Codigo and DsTotales.empresa = Tmp_p_Provisiona.empresa
    Left Join Salarios_Minimos As SalMins On SalMins.Fecha_Ini <= Tmp_p_Provisiona.Fch_Inicio And SalMins.Fecha_Fin >= Tmp_p_Provisiona.Fch_Inicio
    Where --Empleados.Cotiza_Imss = 'S' And
          Tmp_p_Provisiona.Dias_Imss + (Case When @cMarca108 <> 'S' Then Tmp_p_Provisiona.Aus Else 0 End) > 0 And
          Tmp_p_Provisiona.SoloPatron <> 'S' And
          
          Tmp_p_Provisiona.Dias_Totales - Tmp_p_Provisiona.Aus_Totales - Tmp_p_Provisiona.Inc_Totales > 0 And
          IsNull(Excepciones.Excepcion1,' ') <> 'NOIMSS' And
          (Case When @nConcepto = 101 Then IsNull(Tmp_p_Provisiona.Cv,' ') Else ' ' End) <> 'CV' And
          Tmp_p_Provisiona.SalDiaEyM > (Case When @nConcepto = 102 Then IsNull(Tmp_p_Provisiona.Uma,Tmp_p_Provisiona.SalarioMinimo) * 3 Else 0 End) And
          (Case When @nConcepto = 104 Then IsNull(Tmp_p_Provisiona.Cv,' ') Else ' ' End) <> 'CV' And
          (Case When @nConcepto = 104 Then IsNull(Tmp_p_Provisiona.Iv,' ') Else ' ' End) <> 'IV' And
          (Case When @nConcepto = 106 Then Tmp_p_Provisiona.Aus-Tmp_p_Provisiona.Tabulador Else 1 End) > 0 And
          (Case When @nConcepto = 106 Then DsTotales.Dias-DsTotales.Inc-DsTotales.Aus Else 1 End) > 0
    )
	end
  Set @nConcepto = @nConcepto+1
End


--La rutina que genera los Folios, requiere la tabla ordenada por codigo
Select Codigo,Num_Conc,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Tabulador,Tmp_p_Imss.Empresa As Empresa
Into dbo.Tmp_p_Kardex
From Tmp_p_Imss
--Where Gobierno <> 'S'
Order by Codigo,Num_Conc


Insert Into p_Kardex (Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago, Dias, Inc, Aus,
                    DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro,
                    Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento,
                    Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                    Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo,id_presup,mes_operacion,ayo_operacion)

Select Tmp_p_Kardex.Codigo,
       Tmp_p_Kardex.Empresa As Empresa,
       @cTipoNom As Nomina,
       ' ' As Centro,
       Tmp_p_Kardex.Num_Conc,
       ' ' As Clase,
       Tmp_p_Kardex.Folio,
       0 As Renglon,
       Tmp_p_Kardex.Fch_Inicio,
       Tmp_p_Kardex.Fch_Cierre,
       @dPago As Fch_Pago,
       Case When Tmp_p_Kardex.Num_Conc = 106 Then Tmp_p_Kardex.Aus-IsNull(Tmp_p_Kardex.Tabulador,0) Else Tmp_p_Kardex.Dias_Imss End As Dias,
       Tmp_p_Kardex.Inc,
       Tmp_p_Kardex.Aus - Case When Tmp_p_Kardex.Num_Conc = 106 Then IsNull(Tmp_p_Kardex.Tabulador,0) Else 0 End As Aus,
       Tmp_p_Kardex.Dias_Imss As DiasTr,
       Tmp_p_Kardex.Dias_Imss,
       Case When Tmp_p_Kardex.Num_Conc < 200 Then 'D' Else 'I' End  As TPago_Desc,
       Conceptos.Concepto,
       0 As VariaImss,
       0 As Variables,
       Conceptos.Imss,
       Conceptos.Ispt,
       Conceptos.Ptu,
       Conceptos.Despensa,
       Conceptos.Mca_Agui,
       Conceptos.FdoAhorro,
       'A' As Calculo,
       Tmp_p_Kardex.Impor_Base,
       Tmp_p_Kardex.SalDiaInt,
       0 As Tabulador,
       0 As Unidades,
       0 As Horas,
       'IMS' As Tipo_Mov,
       0 As Secuencia,
       Tmp_p_Kardex.Importe,
       0 As IGravable,
       Tmp_p_Kardex.Importe As IExento,
       0 As Credito,
       0 As Descuento,
       0 As Saldo,
       ' ' As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       'F' As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       ' ' As Formula,
       ' ' As Ispt_NG,
       ' ' As Imss_NI,
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo,
	   @id_presup,
	   @mes,
	   @ayo
From Tmp_p_Kardex
Left Join Conceptos On Tmp_p_Kardex.Num_Conc = Conceptos.Num_Conc And Conceptos.Empresa = Tmp_p_Kardex.Empresa



--Drop Table Tmp_p_Provisiona  <-- Tampoco borrarlo aqui, lo necesitare para el INFONAVIT
Drop Table dbo.Tmp_p_Imss
Drop Table dbo.Tmp_p_Kardex

GO

If OBJECT_ID('dbo.asp_p_Infonavit') Is NOT NULL
  Drop Procedure dbo.asp_p_Infonavit
Go


CREATE Procedure dbo.asp_p_Infonavit
@id_Presup Int,
@nTipoNom Int,
@nSalMin Numeric(10,2),
@nSalDF Numeric(10,2),
@dFI DateTime,
@dFF DateTime

As

Declare @cTipoNom      Char(3)
Declare @cMarca108     Char(1)
Declare @cMarca112     Char(1)
Declare @cConvenio     Char(1)
Declare @dInicio       DateTime
Declare @dCierre       DateTime
Declare @dPago         DateTime
Declare @nPeriodo      Int
Declare @nDiasBim1     Int
Declare @nDiasBim2     Int
Declare @cCierreSigBim Char(1)
Declare @nHrs_Min2     Int

Declare @cRegPat       Char(10)
Declare @cRfcPat       VarChar(13)

Declare @nDiasRadial   Numeric(6,2)

Declare @cUso112       Char(1)
Declare @cUso113       Char(1)

Declare @cAyo          Char(2)
Declare @cBimestre     Char(12)

Declare @cSoloRadial   Char(1)



Select @cRegPat = max(Registro_Patronal),
       @cRfcPat = LTrim(max(Rfc_Empresa))
From Empresas Where Empresa in(select empresa from P_empresas where id_presup=@id_Presup)

Set @cMarca108 = (Select max(Imss) From Conceptos Where Num_Conc = 108 And Centro = '' And Clase = '' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup))
Set @cConvenio = Case When (Select Count(Num_Conc) From Conceptos Where Num_Conc = 112 And Variable1 = 'CONVENIO' And Importe1 > 0 And Centro = '' And Clase = '' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) > 0 Then 'S' Else 'N' End

--Set @cMarca112 = (Select Imss From Conceptos Where Num_Conc = 112 And Centro = '' And Clase = '' And Empresa = @nEmpresa)

Select @cUso112 = max(Uso), @cMarca112 = max(Marca2), @nHrs_Min2 = max(Hrs_Min2) From Conceptos Where Num_Conc = 112 And Centro = '' And Clase = '' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)
Select @cUso113 = max(Uso) From Conceptos Where Num_Conc = 113 And Centro = '' And Clase = '' And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)

Set @cTipoNom = Case When @nTipoNom = 1 Then 'SEM'
                     When @nTipoNom = 2 Then 'DEC'
                     When @nTipoNom = 3 Then 'CAT'
                     When @nTipoNom = 4 Then 'QNA'
                     When @nTipoNom = 5 Then 'MES' Else 'ESP' End

declare @mes int
declare @ayo int
Select @dInicio = Periodos.Inicio, @dCierre = Periodos.Cierre, @dPago = Periodos.Pago, @nPeriodo = Periodos.mes,@mes=Periodos.mes,@ayo=Periodos.ejercicio
From p_dias as  Periodos Where Estatus = 'A' And id_presup = @id_presup And TipoNom = @nTipoNom

Declare @DiasDelAyo int
set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@Ayo),0)

--select @DiasDelAyo as DiasDelAyo

Set @cAyo       = Right(Convert(Char(4),Year(@dPago)),2)
Set @cBimestre  = Case When Month(@dPago) In ( 1, 2) Then 'ENE' + @cAyo + ', FEB' + @cAyo
                       When Month(@dPago) In ( 3, 4) Then 'MAR' + @cAyo + ', ABR' + @cAyo
                       When Month(@dPago) In ( 5, 6) Then 'MAY' + @cAyo + ', JUN' + @cAyo
                       When Month(@dPago) In ( 7, 8) Then 'JUL' + @cAyo + ', AGO' + @cAyo
                       When Month(@dPago) In ( 9,10) Then 'SEP' + @cAyo + ', OCT' + @cAyo
                       Else 'NOV' + @cAyo + ', DIC' + @cAyo
                  End

--Calcular los dias de cada bimestre para el calculo de los creditos tipo 2 y 3
Set @nDiasBim1 = Case When Month(@dInicio) In (1,2) Then DateDiff(Day,Convert(DateTime,Convert(Char(4),Year(@dInicio)) + '0101'),Convert(DateTime,Convert(Char(4),Year(@dInicio)) + '0301')-1) + 1
                      When Month(@dInicio) In (7,8) Then 62 Else 61 End

Set @nDiasBim2 = Case When Month(@dCierre) In (1,2) Then DateDiff(Day,Convert(Char(4),Year(@dCierre)) + '0101',Convert(DateTime,Convert(Char(4),Year(@dCierre)) + '0301')-1) + 1
                      When Month(@dCierre) In (7,8) Then 62 Else 61 End
--

-- Detectar si el inicio es de un bimestre y el cierre de otro, para guardar los respectivos conceptos con la marca de cada bimestre
Set @cCierreSigBim = (Case When Month(@dInicio)/2 - Convert(Int, Month(@dInicio)/2 ) > 0 And Month(@dCierre)/2 - Convert(Int, Month(@dCierre)/2) = 0 Then 'S' Else 'N' End)


-- Dias del otro periodo del mes, solo para las retenciones de Radial registradas en Excepciones
If Day(@dInicio) < 16
  Set @nDiasRadial = Case When Month(@dInicio) In (1,3,5,7,8,10,12) Then 16 Else Case When Month(@dInicio)= 2 Then DateDiff(dd,Convert(Char(4),Year(@dPago)) + '0216',Convert(Char(4),Year(@dPago)) + '0301') Else 15 End End
Else
  Set @nDiasRadial = 15


If OBJECT_ID('dbo.Tmp_p_Infonavit') Is NOT NULL
  Drop Table dbo.Tmp_p_Infonavit

If OBJECT_ID('dbo.Tmp_p_Retenciones') Is NOT NULL
  Drop Table dbo.Tmp_p_Retenciones

If OBJECT_ID('dbo.Tmp_p_Kardex') Is NOT NULL
  Drop Table dbo.Tmp_p_Kardex

Select Tmp_p_Provisiona.empresa,
		Tmp_p_Provisiona.Codigo,
       Tmp_p_Provisiona.Dias_Imss - Case When @dPago < '20120501'
                                       Then Case When IsNull(Cambios.Tipo_Cred,Infonavit.Tipo_Cred) = 1 Or @nHrs_Min2 <> 999
                                                 Then Tmp_p_Provisiona.Aus
                                                 Else 0
                                            End + Case When @cConvenio = 'S' Or (@nHrs_Min2 = 999 And IsNull(Cambios.Tipo_Cred,Infonavit.Tipo_Cred) <> 1)
                                                       Then 0 
                                                       Else Tmp_p_Provisiona.Inc 
                                                  End
                                       Else Case When @nHrs_Min2 <> 999 Or Tmp_p_Provisiona.SalDiaReal <= Tmp_p_Provisiona.SalarioMinimo * Tablas_Int.Factor
                                                 Then Tmp_p_Provisiona.Aus
                                                 Else 0
                                            End + Case When @cConvenio = 'S' Or (@nHrs_Min2 = 999 And Tmp_p_Provisiona.SalDiaReal > Tmp_p_Provisiona.SalarioMinimo * Tablas_Int.Factor)
                                                       Then 0 
                                                       Else Tmp_p_Provisiona.Inc 
                                                  End
                                  End As Dias_Imss,

       Case When @dPago < '20120501'
            Then Case When IsNull(Cambios.Tipo_Cred,Infonavit.Tipo_Cred) = 1 Or @nHrs_Min2 <> 999
                      Then Tmp_p_Provisiona.Aus
                      Else 0
                 End
            Else Case When @nHrs_Min2 <> 999 Or Tmp_p_Provisiona.SalDiaReal <= Tmp_p_Provisiona.SalarioMinimo * Tablas_Int.Factor 
                      Then Tmp_p_Provisiona.Aus
                      Else 0
                 End
       End As Aus,
       
       Case When @dPago < '20120501'
            Then Case When @cConvenio = 'S' Or (@nHrs_Min2 = 999 And IsNull(Cambios.Tipo_Cred,Infonavit.Tipo_Cred) <> 1)
                      Then 0
                      Else Tmp_p_Provisiona.Inc
                 End
            Else Case When @cConvenio = 'S' Or (@nHrs_Min2 = 999 And Tmp_p_Provisiona.SalDiaReal > Tmp_p_Provisiona.SalarioMinimo * Tablas_Int.Factor)
                      Then 0
                      Else Tmp_p_Provisiona.Inc
                 End
       End As Inc,
       
       Tmp_p_Provisiona.SalDiaReal,
       Tmp_p_Provisiona.Impor_Base,
       Case When Tmp_p_Provisiona.Fch_Inicio < Infonavit.Fecha       Then Infonavit.Fecha       Else Tmp_p_Provisiona.Fch_Inicio End As Fch_Inicio,
       --Case When Tmp_p_Provisiona.Fch_Cierre > Infonavit.Fch_Termino Then Infonavit.Fch_Termino Else Tmp_p_Provisiona.Fch_Cierre End As Fch_Cierre,
       Case When Tmp_p_Provisiona.Fch_Cierre > IsNull(Infonavit.FechaSuspension,Infonavit.Fch_Termino) Then IsNull(Infonavit.FechaSuspension,Infonavit.Fch_Termino) Else Tmp_p_Provisiona.Fch_Cierre End As Fch_Cierre,
       IsNull(Cambios.Tipo_Cred,Infonavit.Tipo_Cred) As Tipo_Cred,
       Infonavit.NumCredito,
       IsNull(Cambios.Descuento,Infonavit.Descuento) As Descuento,
       Infonavit.Fecha,
       Infonavit.Fch_Otorga,
       IsNull(Infonavit.FechaSuspension,Infonavit.Fch_Termino) As Fch_Termino,
       Convert(Numeric(10,2),0) As PrimerSDI,
       Convert(Numeric(12,6),0) As NvoDescuento,
       Convert(Numeric(12,6),0) As Importe,
       llaves.FchAlta,
       Infonavit.Seguro_Vivienda,
       Tmp_p_Provisiona.Fch_Inicio As InicioOriginal,

       Tmp_p_Provisiona.SalarioMinimo AS SalDF, --IsNull(Salarios_Minimos.Zona_A,@nSalDF) As SalDF,
       
       Tmp_p_Provisiona.Num_Conc,

       Tmp_p_Provisiona.Uma
      
Into dbo.Tmp_p_Infonavit
From Tmp_p_Provisiona
Inner Join Infonavit On Tmp_p_Provisiona.Codigo = Infonavit.Codigo And Infonavit.Empresa = Tmp_p_Provisiona.Empresa
Left Join Infonavit_Cambios As Cambios On Cambios.Codigo = Tmp_p_Provisiona.Codigo And Cambios.Fecha = Tmp_p_Provisiona.Fch_Inicio And Cambios.Empresa = Tmp_p_Provisiona.Empresa
Inner Join P_Empleados_Pres as  Llaves On Llaves.Codigo = Tmp_p_Provisiona.Codigo And Llaves.Empresa = Tmp_p_Provisiona.Empresa and llaves.id_presup=@id_Presup
Inner Join Conceptos On Conceptos.Num_Conc = 112 And Conceptos.Empresa = llaves.Empresa
Left Join P_Tablas_Int AS Tablas_Int On Tablas_Int.id_presup=@id_Presup and Llaves.Clase = Tablas_Int.Clase And Llaves.Empresa = Tablas_Int.Empresa And Convert(Int,Tablas_Int.Ayos) = Case When Round(DateDiff(Day,llaves.FchAntigua,@dFf)/365,0)+1 <= 45 Then Convert(Int,Round(DateDiff(Day,llaves.FchAntigua,@dFf)/365,0)+1) Else 45 End And Tablas_Int.Mes_Operacion = Month(@dFI) And Tablas_Int.Ayo_Operacion = Year(@dFI)
Where 
      (Tmp_p_Provisiona.Dias_Totales - Tmp_p_Provisiona.Aus_Totales - Tmp_p_Provisiona.Inc_Totales > 0 Or Tmp_p_Provisiona.Dias_Imss > Tmp_p_Provisiona.Dias) And
      Infonavit.Fecha <= Tmp_p_Provisiona.Fch_Cierre And
      Infonavit.Fch_Termino >= Tmp_p_Provisiona.Fch_Inicio And
      IsNull(Infonavit.FechaSuspension,Infonavit.Fch_Termino) >= Tmp_p_Provisiona.Fch_Inicio And
      Tmp_p_Provisiona.Num_Conc <> Case When Infonavit.Fecha > @dInicio And Tmp_p_Provisiona.Fch_Inicio > @dInicio 
                                      Then 30
                                      Else 0
                                 End

      /*
      Exists (Select Codigo From Infonavit Where Infonavit.Codigo = Tmp_p_Provisiona.Codigo And 
                                                 Infonavit.Empresa = @nEmpresa And
                                                 Infonavit.Fecha <= Tmp_p_Provisiona.Fch_Cierre And
                                                 Infonavit.Fch_Termino >= Tmp_p_Provisiona.Fch_Inicio And
                                                 IsNull(Infonavit.FechaSuspension,Tmp_p_Provisiona.Fch_Inicio) >= Tmp_p_Provisiona.Fch_Inicio ) And
      */


-- Para creditos que inician en el periodo, ajustar los registros de vacaciones (en caso de haber)
-- paraque solo se calculen los dias posteriores al cierre de la nomina
Update Tmp_p_Infonavit
Set Fch_Inicio = @dCierre + 1
Where Num_Conc = 30 And
      Fch_Cierre > @dCierre And
      Fecha > @dInicio


Delete Tmp_p_Infonavit
Where Num_Conc = 30 And
      Fch_Inicio >= @dInicio And
      Fch_Cierre <= @dCierre And
      Fecha > @dInicio
-- 7 Feb 2016      
      

--Dias comprendidos entre cada periodo, unicamente por si la fecha de inicio o termino de descuento esta dentro del periodo
--Buscar el primer integrado del bimestre, para los creditos otorgados hasta el 30 de enero del 98

--Set Dias_Imss = (DateDiff(Day,Tmp_p_Infonavit.Fch_Inicio,Tmp_p_Infonavit.Fch_Cierre) + 1)- (Case When @cMarca108 <> 'S' Then 0 Else Tmp_p_Infonavit.Aus End) - (Case When @cConvenio = 'S' Then 0 Else Tmp_p_Infonavit.Inc End)

Update Tmp_p_Infonavit
Set Dias_Imss = (DateDiff(Day,Tmp_p_Infonavit.Fch_Inicio,Tmp_p_Infonavit.Fch_Cierre) + 1)- 
                 Case When @cMarca108 <> 'S'
                      Then 0
                      Else dbo.Fun_R_TipoAusencias(Tmp_p_Infonavit.Codigo, Tmp_p_Infonavit.Fch_Inicio, Tmp_p_Infonavit.Fch_Cierre, NULL, 'F', Tmp_p_Infonavit.Empresa)
                 End -
                 Case When @cConvenio = 'S' 
                      Then 0 
                      Else dbo.Fun_R_TipoAusencias(Tmp_p_Infonavit.Codigo, Tmp_p_Infonavit.Fch_Inicio, Tmp_p_Infonavit.Fch_Cierre, NULL, '0', Tmp_p_Infonavit.Empresa)
                 End
Where Tmp_p_Infonavit.Fecha > Tmp_p_Infonavit.InicioOriginal Or
      (Tmp_p_Infonavit.Fch_Termino >= Tmp_p_Infonavit.Fch_Inicio And Tmp_p_Infonavit.Fch_Termino <= Tmp_p_Infonavit.Fch_Cierre)

Update Tmp_p_Infonavit Set PrimerSDI = IsNull(dbo.Fun_R_PrimerSDI(Tmp_p_Infonavit.Codigo, Tmp_p_Infonavit.FchAlta, Tmp_p_Infonavit.Fch_Inicio, Tmp_p_Infonavit.Empresa),Tmp_p_Infonavit.SalDiaReal)
--

Delete Tmp_p_Infonavit
Where Tmp_p_Infonavit.Dias_Imss < 0 And
      (Tmp_p_Infonavit.Fecha > Tmp_p_Infonavit.InicioOriginal Or
       (Tmp_p_Infonavit.Fch_Termino >= Tmp_p_Infonavit.Fch_Inicio And Tmp_p_Infonavit.Fch_Termino <= Tmp_p_Infonavit.Fch_Cierre))


-- Topar integrado a 25 SMDF
Update Tmp_p_Infonavit
Set SalDiaReal = Case When SalDiaReal > IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) * 25
                      Then IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) * 25
                      Else SalDiaReal
                 End,
    PrimerSDI  = Case When PrimerSDI > IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) * 25
                      Then IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) * 25
                      Else PrimerSDI
                 End
Where (SalDiaReal > IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) * 25 OR PrimerSDI > IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) * 25) AND
      Tipo_Cred = 1
-- 25 NOV 2014


--Determinar el nuevo % de descuento para los creditos tipo 1 otorgados hasta el 30 de enero del 98
Update Tmp_p_Infonavit Set NvoDescuento = Case When Tmp_p_Infonavit.Fch_Otorga < '19980130' Then dbo.Fun_R_TablaInfonavit(Tmp_p_Infonavit.PrimerSDI, Tmp_p_Infonavit.Descuento, Tmp_p_Infonavit.SalDF, Tmp_p_Infonavit.Uma) Else Tmp_p_Infonavit.Descuento End
Where Tmp_p_Infonavit.Tipo_Cred = 1
--


--Armar una tabla temporal con las retenciones del concepto 112, posteriormente se agregara el 113 del seguro de vivienda
Select Tmp_p_Infonavit.Codigo,
       Tmp_p_Infonavit.Empresa As Empresa,
       @cTipoNom As Nomina,
       ' ' As Centro,
       112 As Num_Conc,
       ' ' As Clase,
       0 As Folio,
       0 As Renglon,
       Tmp_p_Infonavit.Fch_Inicio,
       Tmp_p_Infonavit.Fch_Cierre,
       @dPago As Fch_Pago,
       Tmp_p_Infonavit.Dias_Imss As Dias,
       Case When @cConvenio = 'N' Then Tmp_p_Infonavit.Inc Else 0 End As Inc,
       Case When @cMarca108 = 'S' Then Tmp_p_Infonavit.Aus Else 0 End As Aus,
       Tmp_p_Infonavit.Dias_Imss As DiasTr,
       Tmp_p_Infonavit.Dias_Imss,
       'D' As TPago_Desc,
       Conceptos.Concepto,
       0 As VariaImss,
       0 As Variable,
       Conceptos.Imss,
       Conceptos.Ispt,
       Conceptos.Ptu,
       Conceptos.Despensa,
       Conceptos.Mca_Agui,
       Conceptos.FdoAhorro,
       'H' As Calculo,

       Case When Tmp_p_Infonavit.Tipo_Cred = 1 Then Tmp_p_Infonavit.Impor_Base Else Case When Tmp_p_Infonavit.Tipo_Cred = 2 Then Tmp_p_Infonavit.Descuento Else Tmp_p_Infonavit.Descuento*IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) End End As Impor_Base,

       --Case When Tmp_p_Infonavit.Tipo_Cred = 1 Then Tmp_p_Infonavit.Impor_Base Else Case When Tmp_p_Infonavit.Tipo_Cred = 2 Then Tmp_p_Infonavit.Descuento Else Tmp_p_Infonavit.Descuento*Tmp_p_Infonavit.SalDF End End As Impor_Base,

       Case When @cMarca112 = 'M' Or Tmp_p_Infonavit.Fch_Otorga > '19980130' Then Tmp_p_Infonavit.SalDiaReal Else Tmp_p_Infonavit.PrimerSDI End As SalDiaInt,
       Tmp_p_Infonavit.Tipo_Cred As Tabulador,
       0 As Unidades,
       0 As Horas,
       Case When Month(Tmp_p_Infonavit.Fch_Inicio) = Month(@dInicio) Or @cCierreSigBim = 'N' Then 'INF' Else 'SIN' End As Tipo_Mov,
       0 As Secuencia,
       Case When Tmp_p_Infonavit.Tipo_Cred = 1 Then (Tmp_p_Infonavit.Dias_Imss * (Case When @cMarca112 = 'M' Or Tmp_p_Infonavit.Fch_Otorga > '19980130' 
                                                                                   Then Tmp_p_Infonavit.SalDiaReal
                                                                                   Else Tmp_p_Infonavit.PrimerSDI End) * (Tmp_p_Infonavit.NvoDescuento/100) )
                                             Else (Tmp_p_Infonavit.Descuento * (Case When Tmp_p_Infonavit.Tipo_Cred = 2
                                                                                   Then 1 
                                                                                   Else IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) End) * 2 / (Case When Month(Tmp_p_Infonavit.Fch_Inicio) = Month(@dInicio) 
                                                                                   --Else Tmp_p_Infonavit.SalDF End) * 2 / (Case When Month(Tmp_p_Infonavit.Fch_Inicio) = Month(@dInicio) 
                                                                                                                 Then @nDiasBim1 
                                                                                                                 Else @nDiasBim2 End) * Tmp_p_Infonavit.Dias_Imss) End As Importe,
       0 As IGravable,
       Case When Tmp_p_Infonavit.Tipo_Cred = 1 Then (Tmp_p_Infonavit.Dias_Imss * (Case When @cMarca112 = 'M' Or Tmp_p_Infonavit.Fch_Otorga > '19980130' Then Tmp_p_Infonavit.SalDiaReal Else Tmp_p_Infonavit.PrimerSDI End) * (Tmp_p_Infonavit.NvoDescuento/100))
                                             Else (Tmp_p_Infonavit.Descuento * (Case When Tmp_p_Infonavit.Tipo_Cred = 2 Then 1 Else IsNull(Tmp_p_Infonavit.Uma,Tmp_p_Infonavit.SalDF) End) * 2 / (Case When Month(Tmp_p_Infonavit.Fch_Inicio) = Month(@dInicio) Then @nDiasBim1 Else @nDiasBim2 End) * Tmp_p_Infonavit.Dias_Imss) End As IExento,
                                             --Else (Tmp_p_Infonavit.Descuento * (Case When Tmp_p_Infonavit.Tipo_Cred = 2 Then 1 Else Tmp_p_Infonavit.SalDF End) * 2 / (Case When Month(Tmp_p_Infonavit.Fch_Inicio) = Month(@dInicio) Then @nDiasBim1 Else @nDiasBim2 End) * Tmp_p_Infonavit.Dias_Imss) End As IExento,
       0 As Credito,
       Tmp_p_Infonavit.NvoDescuento As Descuento,
       0 As Saldo,
       Convert(Char(10),Tmp_p_Infonavit.NumCredito) As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       'F' As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       ' ' As Formula,
       ' ' As Ispt_NG,
       ' ' As Imss_NI,
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo
Into dbo.Tmp_p_Retenciones
From Tmp_p_Infonavit
Left Join Conceptos On Conceptos.Num_Conc = 112 And Conceptos.Empresa = Tmp_p_Infonavit.Empresa

  Insert Into Tmp_p_Retenciones (Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago, Dias, Inc, Aus,
                               DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro,
                               Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento,
                               Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                               Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo)
  (
  Select Infonavit.Codigo,
         Infonavit.Empresa,
         @cTipoNom As Nomina,
         ' ' As Centro,
         113 As Num_Conc,
         ' ' As Clase,
         0 As Folio,
         0 As Renglon,
         @dFI As Fch_Inicio,
         @dFF As Fch_Cierre,
         @dPago As Fch_Pago,
         DateDiff(Day,@dFI,@dFF)+01 As Dias,
         0 As Inc,
         0 As Aus,
         DateDiff(Day,@dFI,@dFF)+01 As DiasTr,
         DateDiff(Day,@dFI,@dFF)+01 As Dias_Imss,
         'D' As TPago_Desc,
         Conceptos.Concepto,
         0 As VariaImss,
         0 As Variable,
         Conceptos.Imss,
         Conceptos.Ispt,
         Conceptos.Ptu,
         Conceptos.Despensa,
         Conceptos.Mca_Agui,
         Conceptos.FdoAhorro,
         'H' As Calculo,

         --Convert(Numeric(10,2), Case When Year(@dPago) < 2009 Then 8 Else 13 End) As Impor_Base,

         Case When @dPago > '20101101' Then 15
              When @dPago > '20090101' Then 13
              Else 8
         End As Impor_Base,

         0 As SalDiaInt,
         0 As Tabulador,
         0 As Unidades,
         0 As Horas,
         'INF' As Tipo_Mov,
         0 As Secuencia,

         Case When @dPago > '20101101' Then 15
              When @dPago > '20090101' Then 13
              Else 8
         End - IsNull(Seguro.Importe,0) AS Importe,

         --Convert(Numeric(10,2), Case When Year(@dPago) < 2009 Then 8 Else 13 End) As Importe,

         0 As IGravable,

         Case When @dPago > '20101101' Then 15
              When @dPago > '20090101' Then 13
              Else 8
         End - IsNull(Seguro.Importe,0) AS IExento,

         --Convert(Numeric(10,2), Case When Year(@dPago) < 2009 Then 8 Else 13 End) As IExento,

         0 As Credito,
         0 As Descuento,
         0 As Saldo,
         ' ' As Referencia,
         'N' As Siempre,
         ' ' As Justificar,
         ' ' As Septimo,
         'F' As PrevSocial,
         0 As Varia1,
         0 As Varia2,
         0 As Varia3,
         0 As Varia4,
         ' ' As Variable1,
         ' ' As Variable2,
         ' ' As Variable3,
         ' ' As Variable4,
         'F' As Masivo,
         ' ' As Formula,
         ' ' As Ispt_NG,
         ' ' As Imss_NI,
         ' ' As Marca,
         0 As Serial,
         'F' As Informativo
  From Infonavit
  Left Join Conceptos On Conceptos.Num_Conc = 113 And Conceptos.Clase = '' And Conceptos.Centro = '' And Conceptos.Empresa = infonavit.Empresa
  Left Join (Select Codigo,
                    Empresa,
                    Sum(Importe) As Importe
             From Kardex_Anual
             Where Num_Conc = 113 And
                   CharIndex(Mes,@cBimestre) > 0 And
                   Year(Fch_Pago) = Year(@dPago) 
             Group By Codigo, Empresa) As Seguro On Seguro.Codigo = Infonavit.Codigo And Seguro.Empresa = Infonavit.Empresa 
  Where Exists (Select Codigo From Tmp_p_Infonavit Where Tmp_p_Infonavit.Codigo = Infonavit.Codigo) And
        (IsNull(Infonavit.Seguro_Vivienda,'F') = 'F' Or IsNull(Seguro.Importe,0) < 15) And       
        Infonavit.Descuento > 0 And
        Infonavit.Empresa in(select empresa from P_empresas where id_presup=@id_Presup)
  )
--


-- Para Radial, tiene empleados a los que les descuenta en una quincena (ya sea en la primera o en la segunda)
-- todo el mes del Infonavit porque en ese periodo les pagan las comisiones
If @cRegPat In ('0407407810','B901592910','5501198410','8301375610','E741243110',
                '8401627210','L013704310','E753836710','8401564610','R142854310',
                'B983076510','R142972110','A481766710','A102803610','R125925010',
                'C415453610','Z341286710','B691406410','B691406410','A684650210',
                'A653270910','A621502710','A521269210','B704252710','E648199610')
  Begin
    -- Eliminar a los que no se les retiene en el periodo actual, segun la excepcion
    Delete Tmp_p_Retenciones
    From Tmp_p_Retenciones
    Left Join Excepciones On Excepciones.Codigo = Tmp_p_Retenciones.Codigo And Excepciones.Empresa = Tmp_p_Retenciones.Empresa And Excepciones.Excepcion1 = 'INF'
    Where IsNull(Excepciones.Excepcion2,0) = Case When Day(@dInicio) < 16 Then 2 Else 1 End


    --Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Retenciones','Folio',0,0


    -- Sumar a los que si se les retiene, el importe de la otra quincena del mes...
    -- promediando la retencion del periodo actual
    UpDate Tmp_p_Retenciones
    --Set Importe = (Retencion.Importe/Retencion.Dias) * (@nDiasRadial + Retencion.Dias)
    Set Importe   = (Tmp_p_Retenciones.Importe/Tmp_p_Retenciones.Dias_Imss) * (@nDiasRadial + Tmp_p_Retenciones.Dias_Imss),
        Dias_Imss = Tmp_p_Retenciones.Dias_Imss + @nDiasRadial
    From Tmp_p_Retenciones
    --Left Join (Select Tmp_p_Retenciones.Codigo, Sum(Tmp_p_Retenciones.Dias_Imss) As Dias, Sum(Tmp_p_Retenciones.Importe) As Importe From Tmp_p_Retenciones Where Tmp_p_Retenciones.Num_Conc = 112 Group By Tmp_p_Retenciones.Codigo) As Retencion On Retencion.Codigo = Tmp_p_Retenciones.Codigo
    Left Join Excepciones On Excepciones.Codigo = Tmp_p_Retenciones.Codigo And Excepciones.Empresa = Tmp_p_Retenciones.Empresa And Excepciones.Excepcion1 = 'INF'
    Where Tmp_p_Retenciones.Num_Conc = 112 And
          Exists (Select Codigo From Excepciones Where Excepciones.Codigo = Tmp_p_Retenciones.Codigo And Excepciones.Empresa = Tmp_p_Retenciones.Empresa And Excepciones.Excepcion1 = 'INF') And
          Tmp_p_Retenciones.Folio = (Select Top 1 Folio From Tmp_p_Retenciones As RetFolio Where RetFolio.Codigo = Tmp_p_Retenciones.Codigo And RetFolio.Num_Conc = 112) And
          Tmp_p_Retenciones.Dias_Imss > 0
  End
--

-- Para Uranga, a los quincenales les retienen todo el mes en la primer quincena
If @cRegPat = 'C122534310' And @nTipoNom = 4
  Begin
    If Day(@dInicio) < 15
      -- Sumar a los que si se les retiene, el importe de la otra quincena del mes...
      -- promediando la retencion del periodo actual, siempre y cuando tengan el concepto 40 en el periodo actual
      UpDate Tmp_p_Retenciones
      Set Importe = (Retencion.Importe/Retencion.Dias) * (@nDiasRadial + Retencion.Dias)
      From Tmp_p_Retenciones
      Left Join (Select Tmp_p_Retenciones.Codigo, Sum(Tmp_p_Retenciones.Dias_Imss) As Dias, Sum(Tmp_p_Retenciones.Importe) As Importe From Tmp_p_Retenciones Where Tmp_p_Retenciones.Num_Conc = 112 Group By Tmp_p_Retenciones.Codigo) As Retencion On Retencion.Codigo = Tmp_p_Retenciones.Codigo
      Where Tmp_p_Retenciones.Num_Conc = 112 And Exists (Select Codigo From Percepciones Where Codigo = Tmp_p_Retenciones.Codigo And Num_Conc = 40 And Periodo = @nPeriodo And Ayo_Operacion = Year(@dPago) And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) 

    -- En la segunda quincena, quitar los empleados que tienen el concepto 40 en la primer quincena del mes...ya que ahi se les retuvo todo el mes
    Else
      Delete Tmp_p_Retenciones
      Where Tmp_p_Retenciones.Num_Conc = 112 And Exists (Select Codigo From Percepciones Where Codigo = Tmp_p_Retenciones.Codigo And Num_Conc = 40 And Periodo = @nPeriodo-1 And Ayo_Operacion = Year(@dPago) And Empresa in(select empresa from P_empresas where id_presup=@id_Presup)) 

  End
--


--Crear una tabla temporal, ordenada por codigo y numero de concepto, porque la rutina que genera los folios la requiere ordenada
Select * Into dbo.Tmp_p_Kardex From Tmp_p_Retenciones Order By Codigo,Num_Conc
--

-- Determinar los folios para la insercion en el kardex
--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Kardex','Folio',0,0
--

--Pasar los importes al kardex real
Insert Into p_Kardex (Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago, Dias, Inc, Aus,
                    DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro,
                    Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento,
                    Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                    Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo,
					id_presup,mes_operacion,ayo_operacion)

Select --(select 1 from P_Empleados_Pres as aa where aa.id_presup=@id_Presup and  aa.empresa=Tmp_p_Kardex.empresa and aa.codigo=Tmp_p_Kardex.codigo) as existe,
		Tmp_p_Kardex.Codigo,
       Tmp_p_Kardex.Empresa As Empresa,
       @cTipoNom As Nomina,
       ' ' As Centro,
       Tmp_p_Kardex.Num_Conc,
       ' ' As Clase,
       isnull(MaxFolio.Folio,0)+1,
       0 As Renglon,
       Tmp_p_Kardex.Fch_Inicio,
       Tmp_p_Kardex.Fch_Cierre,
       @dPago As Fch_Pago,
       Case When Tmp_p_Kardex.Num_Conc = 106 Then Tmp_p_Kardex.Aus-IsNull(Tmp_p_Kardex.Tabulador,0) Else Tmp_p_Kardex.Dias_Imss End As Dias,
       Tmp_p_Kardex.Inc,
       Tmp_p_Kardex.Aus - Case When Tmp_p_Kardex.Num_Conc = 106 Then IsNull(Tmp_p_Kardex.Tabulador,0) Else 0 End As Aus,
       Tmp_p_Kardex.Dias_Imss As DiasTr,
       Tmp_p_Kardex.Dias_Imss,
       'D' As TPago_Desc,
       Conceptos.Concepto,
       0 As VariaImss,
       0 As Variables,
       Conceptos.Imss,
       Conceptos.Ispt,
       Conceptos.Ptu,
       Conceptos.Despensa,
       Conceptos.Mca_Agui,
       Conceptos.FdoAhorro,
       'A' As Calculo,
       Tmp_p_Kardex.Impor_Base,
       Tmp_p_Kardex.SalDiaInt,
       0 As Tabulador,
       0 As Unidades,
       0 As Horas,
       Tmp_p_Kardex.Tipo_Mov,
       0 As Secuencia,
       Tmp_p_Kardex.Importe,
       0 As IGravable,
       Tmp_p_Kardex.Importe As IExento,
       0 As Credito,
       Tmp_p_Kardex.Descuento,
       Case When Tmp_p_Kardex.Num_Conc = 112 And Tmp_p_Kardex.Folio = MaxFolio.Folio And Conceptos.Hrs_Min1 = 999 Then IsNull(Acum_Conc.Imp_Acum,0)+MaxFolio.Importe-Tmp_p_Kardex.Importe Else 0 End As Saldo,
       ' ' As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       'F' As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       ' ' As Formula,
       ' ' As Ispt_NG,
       ' ' As Imss_NI,
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo,
	   @id_Presup,
	   @mes,
	   @ayo
From Tmp_p_Kardex
inner join dbo.P_Empleados_Pres as em on em.id_presup=@id_Presup and em.empresa=Tmp_p_Kardex.Empresa and em.Codigo=Tmp_p_Kardex.codigo
Left Join Conceptos On Tmp_p_Kardex.Num_Conc = Conceptos.Num_Conc And Conceptos.Clase = '' And Conceptos.Centro = '' And Conceptos.Empresa = Tmp_p_Kardex.Empresa
Left Join Acum_Conc On Acum_Conc.Codigo = Tmp_p_Kardex.Codigo And Acum_Conc.Num_Conc = Tmp_p_Kardex.Num_Conc And Acum_Conc.Ejercicio = Year(@dPago) And Acum_Conc.Empresa = Tmp_p_Kardex.Empresa
--Left Join (Select Codigo, Max(Folio) As Folio From Tmp_p_Kardex Where Tmp_p_Kardex.Num_Conc = 112 Group By Codigo) As MaxFolio On MaxFolio.Codigo = Tmp_p_Kardex.Codigo
outer apply(Select Max(Folio) As Folio,Sum(a1.Importe) as importe
			From Tmp_p_Kardex as a1
			Where	a1.Num_Conc = 112 
					and a1.Empresa=Tmp_p_Kardex.empresa
					and a1.codigo=Tmp_p_Kardex.codigo
			) As MaxFolio --On MaxFolio.Codigo = Tmp_p_Kardex.Codigo
--Left Join (Select Codigo, Sum(Tmp_p_Kardex.Importe) As Importe From Tmp_p_Kardex Where Tmp_p_Kardex.Num_Conc = 112 Group By Codigo) As TotInfo On TotInfo.Codigo = Tmp_p_Kardex.Codigo
Where Tmp_p_Kardex.Num_Conc IN (Case When @cUso112 = 'S' Then 112 Else 0 End,Case When @cUso113 = 'S' Then 113 Else 0 End)


--Eliminar tablas temporales
Drop Table dbo.Tmp_p_Infonavit
Drop Table dbo.Tmp_p_Retenciones
Drop Table dbo.Tmp_p_Kardex
Drop Table dbo.Tmp_p_Provisiona

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_InsertaIMAltasPlan')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_InsertaIMAltasPlan
GO

--exec p_InsertaEmpsNomina 2,1
CREATE PROCEDURE dbo.p_InsertaIMAltasPlan
    @id_presup INT ,
    @empresa INT ,
    @Codigo NUMERIC(12) ,
    @FchA DATETIME ,
    @FchB DATETIME ,
    @ayo2 NUMERIC(4) ,
    @mes2 INT
AS 
    DECLARE @Fecha DATETIME

    DECLARE @ayo1 NUMERIC(4) ,
        @mes1 INT
    SELECT  @ayo1 = YEAR(@FchA) ,
            @mes1 = MONTH(@FchA) + 1
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup

    IF @ayo2 = @ayo1 
        BEGIN

            WHILE @mes1 <= @mes2 
                BEGIN
                    SET @fecha = CAST(@ayo1 AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 WHEN @mes1 >= 10 THEN CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes1 AS mes ,
                                    @ayo1 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND codigo = @Codigo
                                    AND activo = 'S'
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

        END

    IF @ayo2 > @ayo1 
        BEGIN

            WHILE @mes1 <= 12 
                BEGIN
                    SET @fecha = CAST(@ayo1 AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 WHEN @mes1 >= 10 THEN CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes1 AS mes ,
                                    @ayo1 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND codigo = @Codigo
                                    AND activo = 'S'
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

            SET @Mes1 = 1
   
            WHILE @mes1 <= @Mes2 --select * from p_avisos_imss
                BEGIN
                    SET @fecha = CAST(@ayo2 AS CHAR(4))
                        + ( CASE WHEN @mes1 <= 9
                                 THEN '0' + CAST(@mes1 AS CHAR(1))
                                 WHEN @mes1 >= 10 THEN CAST(@mes1 AS CHAR(2))
                            END ) + '01'
                    INSERT  INTO dbo.p_avisos_imss
                            ( id_presup ,
                              empresa ,
                              serial ,
                              codigo ,
                              mov ,
                              fch_mov ,
                              sueldo ,
                              Saldiaint ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            SELECT  id_presup ,
                                    empresa ,
                                    1 AS serial ,
                                    codigo ,
                                    'IM' AS mov ,
                                    @fecha AS fch_mov ,
                                    sueldo ,
                                    saldiaint ,
                                    @mes1 AS mes ,
                                    @ayo2 AS ayo
                            FROM    dbo.p_empleados_pres
                            WHERE   id_presup = @id_presup
                                    AND empresa = @empresa
                                    AND codigo = @Codigo
                                    AND activo = 'S'
                    SET @Mes1 = @Mes1 + 1
                    CONTINUE
                END

        END

-- Insertando Baja
    INSERT  INTO dbo.p_avisos_imss
            ( id_presup ,
              empresa ,
              serial ,
              codigo ,
              mov ,
              fch_mov ,
              sueldo ,
              Saldiaint ,
              mes_operacion ,
              ayo_operacion
            )
            SELECT  id_presup ,
                    empresa ,
                    ( SELECT    ISNULL(MAX(serial), 0) + 1
                      FROM      dbo.p_avisos_imss
                      WHERE     id_presup = @id_presup
                                AND empresa = @empresa
                                AND codigo = @Codigo
                                AND mes_operacion = MONTH(@FchB)
                                AND ayo_operacion = YEAR(@FchB)
                    ) AS serial ,
                    codigo ,
                    'B' AS mov ,
                    @FchB AS fch_mov ,
                    sueldo ,
                    saldiaint ,
                    MONTH(@FchB) AS mes ,
                    YEAR(@FchB) AS ayo
            FROM    dbo.p_empleados_pres
            WHERE   id_presup = @id_presup
                    AND empresa = @empresa
                    AND codigo = @Codigo

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_ParteVariable')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_ParteVariable
GO


CREATE PROCEDURE dbo.asp_pres_ParteVariable
--Declare 
    @nNum_Conc NUMERIC(4, 0) ,
    @nSueldo NUMERIC(10, 2) ,
    @nSaldiaInt NUMERIC(10, 2) ,
    @nDiasPag NUMERIC(4, 2) ,
    @nImpo_For NUMERIC(10, 2)
AS --select * from p_empleados_pres where codigo=7676
/*
Set @nNum_conc  = 37
Set @nSueldo    = 485.33
Set @nSaldiaint = 568.64
Set @nDiasPag   = 31.0
Set @nImpo_for  = 2000.00
*/

    DECLARE @cNewMask CHAR(500)
    DECLARE @cNoIntegra CHAR(500)
    DECLARE @cMascara CHAR(500)
    DECLARE @cFormCalc CHAR(500)
    DECLARE @dFch_Form DATETIME
    DECLARE @cFormula CHAR(500) ,
        @cNewForm CHAR(500) ,
        @cNwFrmImss CHAR(500) ,
        @cCalc_Form CHAR(500)
    DECLARE @cVaria1 CHAR(500) ,
        @cVaria2 CHAR(500) ,
        @cVaria3 CHAR(500) ,
        @cVaria4 CHAR(500)
    DECLARE @nVaria1 NUMERIC(10, 2) ,
        @nVaria2 NUMERIC(10, 2) ,
        @nVaria3 NUMERIC(10, 2) ,
        @nVaria4 NUMERIC(10, 2) ,
        @nIncap INT ,
        @nAusen INT ,
        @nNoIntegra NUMERIC(10, 2)
    DECLARE @nImpo NUMERIC(10, 2) ,
        @nSaldf NUMERIC(10, 2)

    SET @nImpo = @nImpo_For

    SET @nVaria1 = 0
    SET @nVaria2 = 0
    SET @nVaria3 = 0
    SET @nVaria4 = 0
    SET @cNoIntegra = ' '
    SET @nIncap = 0
    SET @nAusen = 0
    SET @nSueldo = @nSueldo
    SET @nSaldiaInt = @nSaldiaInt
    SET @nDiasPag = @nDiasPag

   
    SELECT  @nSaldf = a.zona_a
    FROM    dbo.salarios_minimos AS a
    WHERE   a.fecha_ini = ( SELECT  MAX(fecha_ini)
                            FROM    dbo.salarios_minimos
                          )



    SELECT  @cNoIntegra = ISNULL(MAX(imss_ni), 0)
    FROM    dbo.conceptos
    WHERE   num_conc = @nnum_conc
    GROUP BY num_conc

	
    SET @cNwFrmImss = UPPER(@cNoIntegra)
    --Print @cNwFrmImss 
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'IMPOR_BASE',
                              CAST(@nSueldo AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'SALDIAINT',
                              CAST(@nSaldiaint AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'DIAS', CAST(@nDiasPag AS CHAR(07)))	
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'INC', CAST(@nIncap AS CHAR(01)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'AUS', CAST(@nAusen AS CHAR(01)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'NVAR1', CAST(@nVaria1 AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'NVAR2', CAST(@nVaria2 AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'NVAR2', CAST(@nVaria2 AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'NVAR3', CAST(@nVaria3 AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'NVAR4', CAST(@nVaria4 AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'IMPORTE', CAST(@nImpo AS CHAR(15)))
    SET @cNwFrmImss = REPLACE(@cNwFrmImss, 'SALDF', CAST(@nSaldf AS CHAR(15)))

    PRINT @cNwFrmImss
    SET @cNwFrmImss = ( SELECT  dbo.checa_formula(@cNwFrmImss, 'imss_ni')
                      )
	
    SET @cNwFrmImss = CASE WHEN @cNwFrmImss = ' '
                                OR @cNwFrmImss = NULL THEN '0+0'
                           ELSE @cNwFrmImss
                      END

    DECLARE @SQL NVARCHAR(800)
	
    SET @SQL = 'select isnull(' + @cNwFrmImss + ',0) '
    --PRINT 'SQL ' + @SQL
	--exec (@SQL)	
	

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_Percepciones')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_Percepciones
GO


CREATE PROCEDURE dbo.asp_pres_Percepciones
    @cUsiPat CHAR(11) ,
    @id_presup INT ,
    @nTipoNom INT
AS /*
Declare @cUsiPat  Char(11)
Declare @nEmpresa Int
Declare @nTipoNom Int
*/
    DECLARE @nEmpresa INT

    DECLARE @cTipoNom CHAR(3)
    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME

    DECLARE @nPeriodo INT
    DECLARE @nAyo INT
    DECLARE @nMes INT
    DECLARE @nDiasPer NUMERIC(6, 2)

    DECLARE @cMarcaDesc CHAR(1)
    DECLARE @cMarcaDoble CHAR(1)
    DECLARE @cMarcaTriple CHAR(1)

/*
Set @cUsiPat = '33011212-10'
Set @nEmpresa = 1
Set @nTipoNom = 1
*/

    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


--Set @cMarcaDesc   = (Select Marca2 From Conceptos Where Num_Conc = 10)
--Set @cMarcaDoble  = (Select Marca2 From Conceptos Where Num_Conc = 12)
--Set @cMarcaTriple = (Select Marca2 From Conceptos Where Num_Conc = 13)


    SELECT  @dinicio = inicio ,
            @dcierre = cierre ,
            @dpago = pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio) ,
            @nDiasPer = Periodos.Dias ,
            @nPeriodo = periodos.mes
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup

    IF OBJECT_ID('dbo.Tmp_p_Percepciones') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Percepciones


    SELECT  Percepciones.Codigo ,
            Percepciones.Num_Conc ,
            Percepciones.Centro ,
            Percepciones.Clase ,
            Percepciones.Nomina ,
            Percepciones.Varia_Imss ,
            Percepciones.Horas_Ex AS Horas ,
            0 AS operacion ,--Percepciones.Operacion,
            Percepciones.Siempre ,
            0 AS Folio ,--select * from p_percepciones
            @dPago AS Fch_Inicio ,--Percepciones.Fch_Pago As Fch_Inicio,
            @dPago AS Fch_cierre ,--Percepciones.Fch_Pago As Fch_Cierre,
            @dPago AS Fch_Pago ,
            'S' AS aplica ,--dbo.Fun_R_ChecaFiniquito(Percepciones.Codigo,Percepciones.Fch_Pago,@nEmpresa) As Aplica,
            0 AS Unidades ,--Percepciones.Unidades,
            Percepciones.Varia1 ,
            Percepciones.Varia2 ,
            Percepciones.Varia3 ,
            Percepciones.Varia4 ,
            'N' AS Masivo ,--Percepciones.Masivo,
            percepciones.empresa AS Empresa
    INTO    dbo.Tmp_p_Percepciones -- drop table dbo.Tmp_p_Percepciones
    FROM    dbo.p_Percepciones AS Percepciones
            LEFT JOIN dbo.p_empleados_pres AS Empleados ON Percepciones.Codigo = Empleados.Codigo
                                                           AND Percepciones.Empresa = Empleados.Empresa
                                                           AND Percepciones.id_presup = Empleados.id_presup
    WHERE   empleados.TipoNom = @nTipoNom
            AND Percepciones.id_presup = @id_presup
            AND Percepciones.mes = @nPeriodo
            AND Percepciones.Ayo_Operacion = @nAyo
            AND Percepciones.Siempre <> 'V'
            AND -- Esto porque esta asi en el prg????? checar!
      --empleados.activo='S' and
            Percepciones.Empresa IN ( SELECT    empresa
                                      FROM      dbo.p_empresas
                                      WHERE     id_presup = @id_presup )
    ORDER BY Percepciones.Codigo ,
            Percepciones.Num_Conc
--SELECT  * FROM  dbo.Tmp_p_Percepciones

    DELETE  dbo.Tmp_p_Percepciones
    WHERE   Aplica <> 'S'


    CREATE INDEX [IX_Tmp_p_percepciones] ON [dbo].[Tmp_p_percepciones]([Codigo], [Num_Conc]) ON [PRIMARY]


--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Percepciones','Folio',0,0


--Pasar la informacion al Kardex real
    INSERT  INTO dbo.p_Kardex
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_Percepciones.Codigo ,
                        Tmp_Percepciones.empresa AS Empresa ,
                        @cTipoNom AS Nomina ,
                        Tmp_Percepciones.Centro ,
                        Tmp_Percepciones.Num_Conc ,
                        Tmp_Percepciones.Clase ,
                        Tmp_Percepciones.Folio ,
                        0 AS Renglon ,
                        Tmp_Percepciones.Fch_Inicio ,
                        Tmp_Percepciones.Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        CASE WHEN Tmp_Percepciones.Num_Conc = 07
                                  OR Tmp_Percepciones.Num_Conc = 08
                                  OR ( Tmp_Percepciones.Num_Conc >= 1107
                                       AND Tmp_Percepciones.Num_Conc <= 1111
                                     ) THEN Tmp_Percepciones.Unidades
                             WHEN Tmp_Percepciones.Num_Conc = 17
                             THEN Tmp_Percepciones.Varia1
                             WHEN Tmp_Percepciones.Num_Conc = 99
                             THEN ISNULL(Netos.Dias - Netos.Aus - Netos.Inc, 0)
                             WHEN @cUsiPat = '04012321-10'
                                  AND Tmp_Percepciones.Num_Conc = 44
                             THEN Tmp_Percepciones.Varia2
                             ELSE @nDiasPer
                        END AS Dias ,  -- Para ATASA
                        0 AS Inc ,
                        0 AS Aus ,
                        CASE WHEN Tmp_Percepciones.Num_Conc = 07
                             THEN Tmp_Percepciones.Unidades
                             ELSE 0
                        END AS DiasTr ,
                        CASE WHEN Tmp_Percepciones.Num_Conc = 07
                             THEN Tmp_Percepciones.Unidades
                             ELSE 0
                        END AS Dias_Imss ,
                        'P' AS TPago_Desc ,
                        Conceptos.Concepto ,
                        Tmp_Percepciones.Varia_Imss AS Varia_Imss ,
                        Tmp_Percepciones.Varia_Imss AS Variable ,
                        Conceptos.Imss ,
                        Conceptos.Ispt ,
                        Conceptos.Ptu ,
                        Conceptos.Despensa ,
                        Conceptos.Mca_Agui ,
                        Conceptos.FdoAhorro ,
                        'M' AS Calculo ,
                        CASE WHEN Tmp_Percepciones.Num_Conc <> 8
                             THEN Empleados.Sueldo
                             ELSE CASE WHEN Tmp_Percepciones.unidades = 0
                                       THEN ISNULL(Tmp_Percepciones.Nomina / 1,
                                                   0)
                                       ELSE ISNULL(Tmp_Percepciones.Nomina
                                                   / Tmp_Percepciones.Unidades,
                                                   0)
                                  END
                        END AS Impor_Base ,
                        Empleados.SalDiaInt ,
                        Tmp_Percepciones.Operacion AS Tabulador ,
                        Tmp_Percepciones.Unidades ,
                        Tmp_Percepciones.Horas ,
                        'PER' AS Tipo_Mov ,
                        4 AS Secuencia ,
                        Tmp_Percepciones.Nomina AS Importe ,
                        CASE WHEN Tmp_Percepciones.Num_Conc >= 1101
                                  AND Tmp_Percepciones.Num_Conc <= 1106 THEN 0
                             WHEN Tmp_Percepciones.Num_Conc >= 1107
                                  AND Tmp_Percepciones.Num_Conc <= 1111
                                  AND Conceptos.Ispt = 'S'
                             THEN Tmp_Percepciones.Nomina
                             WHEN Tmp_Percepciones.Num_Conc = 1112 THEN 0
                             WHEN Tmp_Percepciones.Num_Conc = 1114 THEN 0
                             WHEN Tmp_Percepciones.Num_Conc >= 1115
                                  AND Tmp_Percepciones.Num_Conc <= 1117 THEN 0
                             WHEN Tmp_Percepciones.Num_Conc >= 1125
                                  AND Tmp_Percepciones.Num_Conc <= 1127 THEN 0
                             WHEN Tmp_Percepciones.Num_Conc = 1136 THEN 0
                             ELSE 0
                        END AS IGravable ,
                        CASE WHEN Tmp_Percepciones.Num_Conc >= 1101
                                  AND Tmp_Percepciones.Num_Conc <= 1106
                             THEN Tmp_Percepciones.Nomina
                             WHEN Tmp_Percepciones.Num_Conc >= 1107
                                  AND Tmp_Percepciones.Num_Conc <= 1111
                                  AND Conceptos.Ispt = 'S' THEN 0
                             WHEN Tmp_Percepciones.Num_Conc = 1112
                             THEN Tmp_Percepciones.Nomina
                             WHEN Tmp_Percepciones.Num_Conc = 1114
                             THEN Tmp_Percepciones.Nomina
                             WHEN Tmp_Percepciones.Num_Conc >= 1115
                                  AND Tmp_Percepciones.Num_Conc <= 1117
                             THEN Tmp_Percepciones.Nomina
                             WHEN Tmp_Percepciones.Num_Conc >= 1125
                                  AND Tmp_Percepciones.Num_Conc <= 1127
                             THEN Tmp_Percepciones.Nomina
                             WHEN Tmp_Percepciones.Num_Conc = 1136
                             THEN Tmp_Percepciones.Nomina
                             ELSE 0
                        END AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        CASE WHEN Tmp_Percepciones.Num_Conc >= 1107
                                  AND Tmp_Percepciones.Num_Conc <= 1111
                             THEN 'C-AUS'
                             WHEN Tmp_Percepciones.Num_Conc >= 10
                                  AND Tmp_Percepciones.Num_Conc <= 13
                             THEN CONVERT(CHAR(10), Tmp_Percepciones.Fch_Pago)
                             WHEN @cUsiPat IN ( 'R1312346-36', 'C1661978-10',
                                                'C1669390-10', 'C1679525-10',
                                                'R1312346-38' )
                                  AND Tmp_Percepciones.Num_Conc = 53
                             THEN RIGHT(CONVERT(CHAR(10), Tmp_Percepciones.Fch_Pago),
                                        02) + '/'
                                  + SUBSTRING(CONVERT(CHAR(10), Tmp_Percepciones.Fch_Pago),
                                              05, 02) + '/'
                                  + LEFT(CONVERT(CHAR(10), Tmp_Percepciones.Fch_Pago),
                                         04)  -- para Plus
                             ELSE ' '
                        END AS Referencia ,
                        Tmp_Percepciones.Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        Conceptos.PrevSocial ,
                        Tmp_Percepciones.Varia1 ,
                        Tmp_Percepciones.Varia2 ,
                        Tmp_Percepciones.Varia3 ,
                        CASE WHEN @cUsiPat IN ( 'R1312346-36', 'C1661978-10',
                                                'C1669390-10', 'C1679525-10',
                                                'R1312346-38' )
                                  AND Tmp_Percepciones.Num_Conc = 53 THEN 0
                             ELSE Tmp_Percepciones.Varia4
                        END AS Varia4 , -- Para Plus
                        Conceptos.Variable1 ,
                        Conceptos.Variable2 ,
                        Conceptos.Variable3 ,
                        Conceptos.Variable4 ,
                        Tmp_Percepciones.Masivo ,
                        ISNULL(Conceptos.Formula, ' ') AS Formula ,
                        ISNULL(Conceptos.Ispt_NG, ' ') AS Ispt_NG ,
                        ISNULL(Conceptos.Imss_NI, ' ') AS Imss_NI ,
                        ' ' AS Marca ,
                        Tmp_Percepciones.Folio AS Serial ,
                        ISNULL(Conceptos.Informativo, 'N') ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
--Into Tmp
              FROM      dbo.Tmp_p_Percepciones AS Tmp_Percepciones
                        INNER JOIN dbo.p_Empleados_pres AS empleados ON Tmp_Percepciones.Codigo = Empleados.Codigo
                                                              AND Empleados.Empresa = Tmp_Percepciones.empresa
                                                              AND empleados.id_presup = @id_presup
                        INNER JOIN dbo.Conceptos ON Tmp_Percepciones.Num_Conc = Conceptos.Num_Conc
                                                    --AND Tmp_Percepciones.Clase = Conceptos.Clase
                                                    --AND Tmp_Percepciones.Centro = Conceptos.Centro
                                                    AND Conceptos.Empresa = Tmp_Percepciones.empresa
                        INNER JOIN ( SELECT Codigo ,
                                            SUM(Kardex.Dias) AS Dias ,
                                            SUM(Kardex.Inc) AS Inc ,
                                            SUM(Kardex.Aus) AS Aus
                                     FROM   dbo.p_Kardex AS kardex
                                     WHERE  kardex.mes_operacion = @nMes
                                            AND kardex.ayo_operacion = @nAyo
                                            AND kardex.id_presup = @id_presup
                                            AND Nomina = @cTipoNom
                                            AND Num_Conc <= 06
                                     GROUP BY Codigo
                                   ) AS Netos ON Tmp_Percepciones.Codigo = Netos.Codigo
            )


    DROP TABLE dbo.Tmp_p_Percepciones


GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_PolDisk')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_PolDisk
GO

CREATE PROCEDURE dbo.asp_p_PolDisk
    @nTipoNom INT ,
    @id_presup INT ,
    @nDetalle INT ,
    @nDesglosa INT ,
    @cTotalCta CHAR(1)
AS 
    DECLARE @nempresa INT
    DECLARE @cTipoNom CHAR(3)
    DECLARE @cMascara CHAR(20)
    DECLARE @nEspacio INT
    DECLARE @nEspacios INT
    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME
    DECLARE @nPeriodo INT

    DECLARE @cRegPat CHAR(10)

/*
Declare @nTipoNom  Int
Declare @nEmpresa  Int
Declare @nDetalle  Int
Declare @nDesglosa Int
Declare @cTotalCta Char(1)


SET @nDetalle   = 1
SET @nDesglosa  = 2
SET @cTotalCta  = 'S'
Set @nTipoNom  = 4
Set @nEmpresa  = 7

select * from p_dias
*/
    DECLARE @nAyo INT
    DECLARE @nMes INT

    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @dPago = Periodos.Pago ,
            @nPeriodo = mes ,
            @nayo = ejercicio ,
            @nMes = mes
    FROM    dbo.p_dias AS Periodos
    WHERE   Estatus = 'A'
            AND id_presup = @id_presup
            AND TipoNom = @nTipoNom

    DELETE  dbo.p_PolDisk
    WHERE   TipoNom = @nTipoNom
            AND id_presup = @id_presup
            AND ayo_operacion = @nAyo
            AND mes_operacion = @nMes


    SELECT  @cRegPat = MAX(Registro_Patronal)
    FROM    dbo.Empresas
    WHERE   Empresa IN ( SELECT empresa
                         FROM   dbo.p_empresas
                         WHERE  id_presup = @id_presup )


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


    SET @cMascara = ( SELECT    RTRIM(MAX(Mascara))
                      FROM      dbo.Empresas
                      WHERE     Empresa IN ( SELECT empresa
                                             FROM   dbo.p_empresas
                                             WHERE  id_presup = @id_presup )
                    )
    SET @nEspacio = CHARINDEX(' ', RTRIM(@cMascara), 1)
    SET @nEspacios = CASE WHEN @nEspacio > 0 THEN 1
                          ELSE 0
                     END


    WHILE @nEspacio > 0 
        BEGIN
            SET @nEspacio = CHARINDEX(' ', RTRIM(@cMascara), @nEspacio + 1)  
            SET @nEspacios = @nEspacios + CASE WHEN @nEspacio > 0 THEN 1
                                               ELSE 0
                                          END
        END


    IF OBJECT_ID('dbo.Tmp_p_PolDisk') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_PolDisk


    SELECT  kardex.empresa ,
            Kardex.Codigo ,
            Kardex.Num_Conc ,
            SUBSTRING(Kardex.Concepto, 1, 20) AS concepto ,
            SUBSTRING(CASE WHEN Cuentas.Clasifica IN ( 'E', 'G' )
                           THEN REPLICATE(' ', 14)
                           ELSE Llaves.Centro + REPLICATE(' ',
                                                          14
                                                          - LEN(Llaves.Centro))
                      END, 1, 14) AS Centro ,
            Kardex.Importe ,
            ISNULL(CASE WHEN Kardex.Num_Conc < 1000
                        THEN CASE WHEN Cuentas.Tipo = 'D' THEN Kardex.Importe
                                  ELSE 0
                             END
                        ELSE CASE WHEN Cuentas.Tipo = 'D' THEN 0
                                  ELSE Kardex.Importe
                             END
                   END, 0) AS Debe ,
            ISNULL(CASE WHEN Kardex.Num_Conc < 1000
                        THEN CASE WHEN Cuentas.Tipo = 'H' THEN Kardex.Importe
                                  ELSE 0
                             END
                        ELSE CASE WHEN Cuentas.Tipo = 'H' THEN 0
                                  ELSE Kardex.Importe
                             END
                   END, 0) AS Haber ,
            ' ' AS cuenta ,--Case When Cuentas.Clasifica <> 'E' Then Cuentas.Cuenta1 Else Empleados.Cuenta End As Cuenta,
            CASE WHEN Cuentas.Clasifica <> 'E'
                 THEN CASE WHEN LEN(SUBSTRING(Cuentas.NomCuenta, 1, 20)) > 0
                           THEN SUBSTRING(Cuentas.NomCuenta, 1, 20)
                           ELSE SUBSTRING(Kardex.Concepto, 1, 20)
                      END
                 ELSE SUBSTRING(RTRIM(llaves.nombre), 1, 20)
            END AS NomCuenta ,
            CASE WHEN Kardex.Num_Conc < 1000 THEN Cuentas.Tipo
                 WHEN Cuentas.Tipo = 'D' THEN 'H'
                 ELSE 'D'
            END AS Tipo ,
            Cuentas.Clasifica ,
            CASE WHEN Cuentas.Clasifica = 'E' THEN ' '
                 WHEN Cuentas.Clasifica = 'G'
                 THEN CASE WHEN @nDetalle = 1 THEN STR(Kardex.Num_Conc, 4)
                           ELSE ''
                      END + REPLICATE(' ', 14) + Cuentas.Cuenta1
                 ELSE CASE WHEN @nDetalle = 1 THEN STR(Kardex.Num_Conc, 4)
                           ELSE ''
                      END
                      + CASE WHEN @nDesglosa = 1
                             THEN SUBSTRING(Llaves.Centro, 1,
                                            CHARINDEX(' ', RTRIM(@cMascara), 1)
                                            - 1) + REPLICATE('0',
                                                             LEN(RTRIM(Llaves.Centro))
                                                             - ( CHARINDEX(' ',
                                                              RTRIM(@cMascara),
                                                              1) - 1 ))
                             ELSE RTRIM(Llaves.Centro) + REPLICATE(' ',
                                                              14
                                                              - LEN(Llaves.Centro))
                        END + Cuentas.Cuenta1
            END AS Indice
    INTO    dbo.Tmp_p_PolDisk
    FROM    dbo.p_Kardex AS Kardex --Inner Join Llaves  On Kardex.Codigo = Llaves.Codigo And Kardex.Empresa = Llaves.Empresa
            INNER JOIN dbo.p_empleados_pres AS llaves ON Kardex.Codigo = Llaves.Codigo
                                                         AND Kardex.Empresa = Llaves.Empresa
--inner join empleados as empleados on llaves.empresa=empleados.empresa
            INNER JOIN dbo.Cuentas ON Kardex.Num_Conc
                                      - CASE WHEN Kardex.Num_Conc > 1000
                                             THEN 1000
                                             ELSE 0
                                        END = Cuentas.Num_Conc
                                      AND Kardex.Clase = Cuentas.Clase
                                      AND Kardex.Centro = Cuentas.Centro
                                      AND Kardex.Empresa = Cuentas.Empresa
                                      AND Cuentas.TipoNom = @nTipoNom
    WHERE   Kardex.Nomina = @cTipoNom
            AND LEN(RTRIM(CASE WHEN Cuentas.Clasifica = 'E' THEN ' '
                               ELSE Cuentas.Cuenta1
                          END)) > 0
            AND Kardex.id_presup = @id_presup
            AND kardex.mes_operacion = @nMes
            AND kardex.ayo_operacion = @nAyo
      --(Kardex.Num_Conc < 200 Or Kardex.Num_Conc > 300)

      --(Cuentas.Clasifica <> 'E' Or (Kardex.Num_Conc > 200 And Kardex.Num_Conc < 300))

-- Conceptos que tienen cuenta por EMPLEADO

    INSERT  INTO dbo.Tmp_p_PolDisk
            ( empresa ,
              Codigo ,
              Num_Conc ,
              Concepto ,
              Centro ,
              Importe ,
              Debe ,
              Haber ,
              Cuenta ,
              NomCuenta ,
              Tipo ,
              Clasifica ,
              Indice
            )
            ( SELECT    kardex.empresa ,
                        Kardex.Codigo ,
                        Kardex.Num_Conc ,
                        SUBSTRING(Kardex.Concepto, 1, 20) ,
                        SUBSTRING(CASE WHEN Cuentas.Clasifica2 = 'G'
                                       THEN REPLICATE(' ', 14)
                                       ELSE Llaves.Centro + REPLICATE(' ',
                                                              14
                                                              - LEN(Llaves.Centro))
                                  END, 1, 14) AS Centro ,
                        Kardex.Importe ,
                        CASE WHEN Cuentas.Tipo = 'H' THEN Kardex.Importe
                             ELSE 0
                        END AS Debe ,
                        CASE WHEN Cuentas.Tipo = 'D' THEN Kardex.Importe
                             ELSE 0
                        END AS Haber ,
                        SUBSTRING(Cuentas.Cuenta2, 1, 20) AS Cuenta ,
                        SUBSTRING(Cuentas.NomCuenta2, 1, 20) AS NomCuenta ,
                        CASE WHEN Cuentas.Tipo = 'D' THEN 'H'
                             ELSE 'D'
                        END AS Tipo ,
                        Cuentas.Clasifica2 AS Clasifica ,
                        CASE WHEN Cuentas.Clasifica2 = 'G'
                             THEN CASE WHEN @nDetalle = 1
                                       THEN STR(Kardex.Num_Conc, 4)
                                       ELSE ''
                                  END + REPLICATE(' ', 14) + Cuentas.Cuenta2
                             ELSE CASE WHEN @nDetalle = 1
                                       THEN STR(Kardex.Num_Conc, 4)
                                       ELSE ' '
                                  END
                                  + CASE WHEN @nDesglosa = 1
                                         THEN SUBSTRING(Llaves.Centro, 1,
                                                        CHARINDEX(' ',
                                                              RTRIM(@cMascara),
                                                              1) - 1)
                                              + REPLICATE('0',
                                                          LEN(RTRIM(Llaves.Centro))
                                                          - ( CHARINDEX(' ',
                                                              RTRIM(@cMascara),
                                                              1) - 1 ))
                                         ELSE RTRIM(Llaves.Centro)
                                              + REPLICATE(' ',
                                                          14
                                                          - LEN(Llaves.Centro))
                                    END + Cuentas.Cuenta2
                        END AS Indice
              FROM      dbo.p_Kardex AS Kardex
                        INNER JOIN dbo.Llaves ON Kardex.Codigo = Llaves.Codigo
                                                 AND Kardex.Empresa = Llaves.Empresa
                        INNER JOIN dbo.Cuentas ON Kardex.Num_Conc = Cuentas.Num_Conc
                                                  AND Kardex.Clase = Cuentas.Clase
                                                  AND Kardex.Centro = Cuentas.Centro
                                                  AND Kardex.Empresa = Cuentas.Empresa
                                                  AND Cuentas.TipoNom = @nTipoNom
              WHERE     Kardex.Nomina = @cTipoNom
                        AND Kardex.Num_Conc > 200
                        AND Kardex.Num_Conc < 300
                        AND LEN(RTRIM(Cuentas.Cuenta2)) > 0
                        AND Kardex.id_presup = @id_presup
                        AND kardex.mes_operacion = @nMes
                        AND kardex.ayo_operacion = @nAyo
            )

--
    IF @cTotalCta = 'S' 
        BEGIN
            UPDATE  dbo.Tmp_p_PolDisk
            SET     Debe = Tmp_p_PolDisk.Debe - Tmp_p_PolDisk.Haber
            WHERE   Tmp_p_PolDisk.Tipo = 'D'
            UPDATE  dbo.Tmp_p_PolDisk
            SET     Haber = Tmp_p_PolDisk.Haber - Tmp_p_PolDisk.Debe
            WHERE   Tmp_p_PolDisk.Tipo = 'H'
        END


    IF ( SELECT COUNT(Num_Conc)
         FROM   dbo.Tmp_p_PolDisk
       ) > 0 
        BEGIN
            INSERT  INTO dbo.Tmp_p_PolDisk
                    ( empresa ,
                      Codigo ,
                      Num_Conc ,
                      Concepto ,
                      Centro ,
                      Importe ,
                      Debe ,
                      Haber ,
                      Cuenta ,
                      NomCuenta ,
                      Tipo ,
                      Clasifica ,
                      Indice
                    )
                    ( SELECT    Tmp_PolDisk.empresa ,
                                0 AS Codigo ,
                                9999 AS Num_Conc ,
                                ' ' AS Concepto ,
                                MAX(SUBSTRING(Nominas.CtaCuadre, 1, 14)) AS Centro ,
                                SUM(ISNULL(Tmp_PolDisk.Importe, 0)) AS Importe ,
                                0 AS Debe ,
                                SUM(ISNULL(Tmp_PolDisk.Debe
                                           - Tmp_PolDisk.Haber, 0)) AS Haber ,
                                MAX(SUBSTRING(Nominas.CtaCuadre, 15, 14)) AS Cuenta ,
                                SUBSTRING(MAX(Nominas.NombreCta), 1, 20) AS NomCuenta ,
                                ' ' AS Tipo ,
                                'G' AS Clasifica ,
                                ' ' AS Indice
                      FROM      dbo.Tmp_p_PolDisk AS Tmp_PolDisk
                                LEFT JOIN dbo.Nominas ON Nominas.TipoNom = @nTipoNom
                                                         AND Nominas.Empresa = Tmp_PolDisk.Empresa
                      GROUP BY  Tmp_PolDisk.Empresa
                    )


    -- Para Uranga, los centros de costos tienen solo 3 digitos en la nomina
    -- pero en contabilidad 6
            IF @cRegPat = 'C122534310' 
                UPDATE  dbo.Tmp_p_PolDisk
                SET     Centro = CASE WHEN @nTipoNom = 1 THEN '500'
                                      ELSE '700'
                                 END + Tmp_p_PolDisk.Centro
                WHERE   Clasifica NOT IN ( 'E', 'G' )


            INSERT  INTO dbo.p_PolDisk
                    ( Concepto ,
                      Centro ,
                      Cuenta ,
                      TipoNom ,
                      Empresa ,
                      NomConcep ,
                      NomCuenta ,
                      Importe ,
                      Debe ,
                      Haber ,
                      Fch_Inicio ,
                      Fch_Cierre ,
                      Fch_Pago ,
                      Numero ,
                      Clasifica ,
                      Depto ,
                      id_presup ,
                      mes_operacion ,
                      ayo_operacion
                    )
                    ( SELECT    MAX(Tmp_PolDisk.Num_Conc) AS Concepto ,
                                MAX(Tmp_PolDisk.Centro) ,
                                MAX(Tmp_PolDisk.Cuenta) ,
                                @nTipoNom AS TipoNom ,
                                Tmp_PolDisk.Empresa AS Empresa ,
                                MAX(LEFT(Tmp_PolDisk.Concepto, 20)) AS NomConcep ,
                                LEFT(MAX(Tmp_PolDisk.NomCuenta), 20) AS NomCuenta ,
                                SUM(Tmp_PolDisk.Importe) AS Importe ,
                                SUM(Tmp_PolDisk.Debe) AS Debe ,
                                SUM(Tmp_PolDisk.Haber) AS Haber ,
                                @dInicio AS Fch_Inicio ,
                                @dCierre AS Fch_Cierre ,
                                @dPago AS Fch_Pago ,
                                @nPeriodo AS Numero ,
                                MAX(Tmp_PolDisk.Clasifica) AS Clasifica ,
                                ' ' AS Depto ,
                                @id_presup ,
                                @nMes ,
                                @nAyo
                      FROM      dbo.Tmp_p_PolDisk AS Tmp_PolDisk
                      GROUP BY  Tmp_PolDisk.empresa ,
                                Indice
                    )
        END

--Drop Table dbo.Tmp_p_PolDisk


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Polizas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Polizas
GO

CREATE PROCEDURE dbo.asp_p_Polizas
    @id_presup INT ,
    @nTipoNom INT
AS 
    DECLARE @nEmpresa INT

    DECLARE @pN1 INT
    DECLARE @pN2 INT
    DECLARE @pN3 INT
    DECLARE @pN4 INT
    DECLARE @pN5 INT
    DECLARE @pN6 INT
    DECLARE @pN7 INT
    DECLARE @pLen INT
    DECLARE @pLenNiv1 INT
    DECLARE @pLenNiv2 INT
    DECLARE @pLenNiv3 INT
    DECLARE @pLenNiv4 INT
    DECLARE @pLenNiv5 INT
    DECLARE @pLenNiv6 INT
    DECLARE @pLenNiv7 INT

    DECLARE @cMascara VARCHAR(30)

    DECLARE @nLenNiv1 INT
    DECLARE @nLenNiv2 INT
    DECLARE @nLenNiv3 INT
    DECLARE @nLenNiv4 INT
    DECLARE @nLenNiv5 INT
    DECLARE @nLenNiv6 INT
    DECLARE @nLenNiv7 INT

    DECLARE @nNivel INT
    DECLARE @nNiveles INT

    DECLARE @nLongitud INT
    DECLARE @nCeros INT

    DECLARE @cTipoNom CHAR(3)
    DECLARE @dPago DATETIME

    DECLARE @nAyo INT 
    DECLARE @nMes INT
/*
Declare @nEmpresa  Int
Declare @nTipoNom  Int

Set @nEmpresa = 1
Set @nTipoNom = 4
*/
    SELECT  @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio) ,
            @dPago = Periodos.Pago
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup


    DELETE  dbo.p_Polizas
    WHERE   TipoNom = @nTipoNom
            AND Empresa IN ( SELECT empresa
                             FROM   dbo.p_empresas
                             WHERE  id_presup = @id_presup )
            AND id_presup = @id_presup
            AND ayo_operacion = @nAyo
            AND mes_operacion = @nMes--= @nEmpresa


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END

--Select @dPago = Periodos.Pago From Periodos Where Estatus = 'A' And Empresa = @nEmpresa And TipoNom = @nTipoNom

    SET @pN1 = 0
    SET @pN2 = 0
    SET @pN3 = 0
    SET @pN4 = 0
    SET @pN5 = 0
    SET @pN6 = 0
    SET @pN7 = 0

    SET @cMascara = LTRIM(RTRIM(( SELECT    REPLACE(MAX(Mascara), '-', ' ')
                                  FROM      dbo.Empresas
                                )))

    SET @pLen = LEN(LTRIM(RTRIM(@cMascara)))

    SET @pN1 = CHARINDEX(' ', LTRIM(@cMascara), 1)

    IF @pLen > @pN1
        AND @pN1 > 0 
        BEGIN
            SET @pN2 = CHARINDEX(' ', LTRIM(@cMascara), @pN1 + 1)
            IF @pN2 = 0 
                SET @pN2 = LEN(@cMascara) + 1
        END

    IF @pLen > @pN2
        AND @pN2 > 0 
        BEGIN
            SET @pN3 = CHARINDEX(' ', LTRIM(@cMascara), @pN2 + 1)
            IF @pN3 = 0 
                SET @pN3 = LEN(@cMascara) + 1
        END

    IF @pLen > @pN3
        AND @pN3 > 0 
        BEGIN
            SET @pN4 = CHARINDEX(' ', LTRIM(@cMascara), @pN3 + 1)
            IF @pN4 = 0 
                SET @pN4 = LEN(@cMascara) + 1
        END

    IF @pLen > @pN4
        AND @pN4 > 0 
        BEGIN
            SET @pN5 = CHARINDEX(' ', LTRIM(@cMascara), @pN4 + 1)
            IF @pN5 = 0 
                SET @pN5 = LEN(@cMascara) + 1
        END

    IF @pLen > @pN5
        AND @pN5 > 0 
        BEGIN
            SET @pN6 = CHARINDEX(' ', LTRIM(@cMascara), @pN5 + 1)
            IF @pN6 = 0 
                SET @pN6 = LEN(@cMascara) + 1
        END

    IF @pLen > @pN6
        AND @pN6 > 0 
        BEGIN
            SET @pN7 = CHARINDEX(' ', LTRIM(@cMascara), @pN6 + 1)
            IF @pN7 = 0 
                SET @pN7 = LEN(@cMascara) + 1
        END


    SET @nLenNiv1 = CASE WHEN @pN1 > 0 THEN @pN1 - 1
                         ELSE LEN(@cMascara)
                    END
    SET @nLenNiv2 = 0
    SET @nLenNiv3 = 0
    SET @nLenNiv4 = 0
    SET @nLenNiv5 = 0
    SET @nLenNiv6 = 0
    SET @nLenNiv7 = 0


    IF @pN2 > 0 
        SET @nLenNiv2 = ( @pN2 ) - ( @pN1 + 1 )
    IF @pN3 > 0 
        SET @nLenNiv3 = ( @pN3 ) - ( @pN2 + 1 )
    IF @pN4 > 0 
        SET @nLenNiv4 = ( @pN4 ) - ( @pN3 + 1 )
    IF @pN5 > 0 
        SET @nLenNiv5 = ( @pN5 ) - ( @pN4 + 1 )
    IF @pN6 > 0 
        SET @nLenNiv6 = ( @pN6 ) - ( @pN5 + 1 )
    IF @pN7 > 0 
        SET @nLenNiv7 = ( @pN7 ) - ( @pN6 + 1 )


    SET @nNivel = 1
    SET @nLongitud = 0

    SET @nNiveles = CASE WHEN @nLenNiv7 > 0 THEN 7
                         WHEN @nLenNiv6 > 0 THEN 6
                         WHEN @nLenNiv5 > 0 THEN 5
                         WHEN @nLenNiv4 > 0 THEN 4
                         WHEN @nLenNiv3 > 0 THEN 3
                         WHEN @nLenNiv2 > 0 THEN 2
                         ELSE 1
                    END


    DELETE  dbo.p_Polizas
    WHERE   TipoNom = @nTipoNom
            AND Empresa IN ( SELECT empresa
                             FROM   dbo.p_empresas
                             WHERE  id_presup = @id_presup )
            AND id_presup = @id_presup
            AND ayo_operacion = @nAyo
            AND mes_operacion = @nMes--= @nEmpresa
--Delete Estatal Where TipoNom = @nTipoNom And Empresa in(select empresa from p_empresas where id_presup=@id_presup) and id_presup=@id_presup and ayo_operacion=@nAyo and mes_operacion=@nMes--= @nEmpresa
--Delete Resumen Where TipoNom = @nTipoNom And Empresa in(select empresa from p_empresas where id_presup=@id_presup) and id_presup=@id_presup and ayo_operacion=@nAyo and mes_operacion=@nMes--= @nEmpresa


    WHILE @nNivel <= @nNiveles 
        BEGIN

            SET @nLongitud = CASE WHEN @nNivel = 1 THEN @nLenNiv1
                                  WHEN @nNivel = 2
                                       AND @nLenNiv2 > 0
                                  THEN @nLenNiv1 + @nLenNiv2
                                  WHEN @nNivel = 3
                                       AND @nLenNiv3 > 0
                                  THEN @nLenNiv1 + @nLenNiv2 + @nLenNiv3
                                  WHEN @nNivel = 4
                                       AND @nLenNiv4 > 0
                                  THEN @nLenNiv1 + @nLenNiv2 + @nLenNiv3
                                       + @nLenNiv4
                                  WHEN @nNivel = 5
                                       AND @nLenNiv5 > 0
                                  THEN @nLenNiv1 + @nLenNiv2 + @nLenNiv3
                                       + @nLenNiv4 + @nLenNiv5
                                  WHEN @nNivel = 6
                                       AND @nLenNiv6 > 0
                                  THEN @nLenNiv1 + @nLenNiv2 + @nLenNiv3
                                       + @nLenNiv4 + @nLenNiv5 + @nLenNiv6
                                  WHEN @nNivel = 7
                                       AND @nLenNiv7 > 0
                                  THEN @nLenNiv1 + @nLenNiv2 + @nLenNiv3
                                       + @nLenNiv4 + @nLenNiv5 + @nLenNiv6
                                       + @nLenNiv7
                                  ELSE 0
                             END

            SET @nCeros = CASE WHEN @nNivel = 1
                               THEN @nLenNiv2 + @nLenNiv3 + @nLenNiv4
                                    + @nLenNiv5 + @nLenNiv6 + @nLenNiv7
                               WHEN @nNivel = 2
                               THEN @nLenNiv3 + @nLenNiv4 + @nLenNiv5
                                    + @nLenNiv6 + @nLenNiv7
                               WHEN @nNivel = 3
                               THEN @nLenNiv4 + @nLenNiv5 + @nLenNiv6
                                    + @nLenNiv7
                               WHEN @nNivel = 4
                               THEN @nLenNiv5 + @nLenNiv6 + @nLenNiv7
                               WHEN @nNivel = 5 THEN @nLenNiv6 + @nLenNiv7
                               WHEN @nNivel = 6 THEN @nLenNiv7
                               ELSE 0
                          END

            IF @nLongitud > 0 
                BEGIN

                    INSERT  INTO dbo.p_Polizas
                            ( Num_Conc ,
                              Concepto ,
                              Centro ,
                              TipoNom ,
                              Empresa ,
                              Renglon ,
                              TPago_Desc ,
                              Fch_Pago ,
                              Importe ,
                              Gravable ,
                              Exento ,
                              Empleados ,
                              Dias ,
                              Horas ,
                              Tipo ,
                              Varia1 ,
                              id_presup ,
                              ayo_operacion ,
                              mes_operacion
                            )
                            ( SELECT    Kardex.Num_Conc ,
                                        MAX(Kardex.Concepto) AS Concepto ,
                                        Centros.Centro , --Substring(Llaves.Centro,1,@nLongitud)+Replicate('0',@nCeros) As Centro,
                                        @nTipoNom AS TipoNom ,
                                        Kardex.Empresa ,
                                        0 AS Renglon ,
                                        MAX(TPago_Desc) AS TPago_Desc ,
                                        @dPago AS Fch_Pago ,
                                        SUM(Kardex.Importe) AS Importe ,
                                        SUM(ISNULL(Kardex.IGravable, 0)) AS Gravable ,
                                        SUM(ISNULL(Kardex.IExento, 0)) AS Exento ,
                                        COUNT(DISTINCT Kardex.Codigo) AS Empleados ,
                                        SUM(CASE WHEN Kardex.Num_Conc IN (
                                                      @nTipoNom, 7, 30, 107,
                                                      108, 109, 110, 111, 133 )
                                                 THEN Kardex.Dias
                                                 ELSE 0
                                            END) AS Dias ,
                                        SUM(CASE WHEN Kardex.Num_Conc IN ( 10,
                                                              11, 12, 13 )
                                                 THEN Kardex.Horas
                                                 ELSE 0
                                            END) AS Horas ,
                                        MAX(CASE WHEN Kardex.Num_Conc = 108
                                                 THEN Kardex.Justificar
                                                 ELSE ' '
                                            END) AS Tipo ,
                                        SUM(CASE WHEN Kardex.Num_Conc IN ( 36,
                                                              136 )
                                                 THEN ISNULL(Kardex.Varia1, 0)
                                                 ELSE 0
                                            END) AS Varia1 ,
                                        @id_presup AS id_presup ,
                                        @nAyo AS ayo_operacion ,
                                        @nMes AS mes_operacion
                              FROM      dbo.centros
                                        INNER JOIN dbo.p_empleados_pres AS llaves ON ( centros.centro = SUBSTRING(Llaves.Centro,
                                                              1, @nLongitud)
                                                              + REPLICATE('0',
                                                              @nCeros)
                                                              AND centros.empresa = llaves.empresa
                                                              )
                                        RIGHT JOIN dbo.p_Kardex AS kardex ON ( kardex.codigo = llaves.codigo
                                                              AND kardex.empresa = llaves.empresa
                                                              )
                              WHERE     --centros.empresa = @nEmpresa AND
                                        Kardex.Nomina = @cTipoNom
                                        AND Kardex.Empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
                                        AND --= @nEmpresa And
                                        Kardex.Num_Conc <> 108
                                        AND Kardex.Num_Conc <> 133
                                        AND kardex.ayo_operacion = @nAyo
                                        AND kardex.mes_operacion = @nMes
                                        AND LEN(LTRIM(centros.defindpto2)) > 0
                                        AND CONVERT(INT, centros.defindpto2) = @nNivel
                              GROUP BY  kardex.empresa ,
                                        centros.centro ,
                                        Num_Conc
                            )


                    INSERT  INTO dbo.p_Polizas
                            ( Num_Conc ,
                              Concepto ,
                              Centro ,
                              TipoNom ,
                              Empresa ,
                              Renglon ,
                              TPago_Desc ,
                              Fch_Pago ,
                              Importe ,
                              Gravable ,
                              Exento ,
                              Empleados ,
                              Dias ,
                              Horas ,
                              Tipo ,
                              Varia1 ,
                              id_presup ,
                              ayo_operacion ,
                              mes_operacion
                            )
                            ( SELECT    Kardex.Num_Conc AS Num_Conc ,
                                        MAX(Kardex.Concepto) AS Concepto ,
                                        Centros.Centro , --Substring(Llaves.Centro,1,@nLongitud)+Replicate('0',@nCeros) As Centro,
                                        @nTipoNom AS TipoNom ,
                                        Kardex.Empresa AS Empresa ,
                                        0 AS Renglon ,
                                        MAX(TPago_Desc) AS TPago_Desc ,
                                        @dPago AS Fch_Pago ,
                                        SUM(Kardex.Importe) AS Importe ,
                                        SUM(ISNULL(Kardex.IGravable, 0)) AS Gravable ,
                                        SUM(ISNULL(Kardex.IExento, 0)) AS Exento ,
                                        COUNT(DISTINCT Kardex.Codigo) AS Empleados ,
                                        SUM(Kardex.Dias) AS Dias ,
                                        0 AS Horas ,
                                        Kardex.Justificar AS Tipo ,
                                        0 AS Varia1 ,
                                        @id_presup AS id_presup ,
                                        @nAyo AS ayo_operacion ,
                                        @nMes AS mes_operacion
                              FROM      dbo.centros
                                        INNER JOIN dbo.p_empleados_pres AS llaves ON ( centros.centro = SUBSTRING(Llaves.Centro,
                                                              1, @nLongitud)
                                                              + REPLICATE('0',
                                                              @nCeros)
                                                              AND centros.empresa = llaves.empresa
                                                              )
                                        RIGHT JOIN dbo.p_Kardex AS Kardex ON ( kardex.codigo = llaves.codigo
                                                              AND kardex.empresa = llaves.empresa
                                                              )
                              WHERE     Kardex.Nomina = @cTipoNom
                                        AND Kardex.Empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
                                        AND --= @nEmpresa And
                                        kardex.ayo_operacion = @nAyo
                                        AND kardex.mes_operacion = @nMes
                                        AND ( Kardex.Num_Conc = 108
                                              OR Kardex.Num_Conc = 133
                                            )
                                        AND LEN(LTRIM(centros.defindpto2)) > 0
                                        AND CONVERT(INT, centros.defindpto2) = @nNivel
                              GROUP BY  kardex.empresa ,
                                        Centros.centro ,
                                        kardex.num_conc ,
                                        Justificar
                            )

        /*
        Insert Into Estatal (Centro,Porciento,Empresa,Base,Importe,TipoNom,Registros)
        (
        Select centros.centro,
               Kardex.Unidades As Porciento,
               @nEmpresa As Empresa,
               Sum(Kardex.Impor_Base) As Base,
               Sum(Kardex.Importe) As Importe,
               @nTipoNom As TipoNom,
               Count(Distinct Kardex.Codigo)
        From centros
        inner Join llaves  ON (centros.centro = Substring(Llaves.Centro,1,@nLongitud)+Replicate('0',@nCeros) AND centros.empresa = llaves.empresa)     
        Right Join Kardex ON (kardex.codigo = llaves.codigo and kardex.empresa = llaves.empresa)
        Where Kardex.Num_Conc = 216 And Kardex.Nomina = @cTipoNom And Kardex.Empresa = @nEmpresa And
             LEN(LTRIM(centros.defindpto2)) > 0 AND  
              convert(int,centros.defindpto2) = @nNivel 
        Group By Centros.centro,Kardex.Unidades
        )


        Insert Into Resumen (Empresa,Centro,Empleados,TipoNom)
        (
        Select @nEmpresa As Empresa,
               Centros.centro, --Substring(Llaves.Centro,1,@nLongitud)+Replicate('0',@nCeros) As Centro,
               Count(Distinct Kardex.Codigo) As Empleados,
               @nTipoNom As TipoNom
        From centros
        inner Join llaves  ON (centros.centro = Substring(Llaves.Centro,1,@nLongitud)+Replicate('0',@nCeros) AND centros.empresa = llaves.empresa)     
        Right Join Kardex ON (kardex.codigo = llaves.codigo and kardex.empresa = llaves.empresa)
        Where Kardex.Nomina = @cTipoNom And 
              Kardex.Empresa = @nEmpresa And
             LEN(LTRIM(centros.defindpto2)) > 0 AND  
              convert(int,centros.defindpto2) = @nNivel 
        Group By centros.centro
        )
      */
                END


            SET @nNivel = @nNivel + 1

        END

    INSERT  INTO dbo.p_Polizas
            ( Num_Conc ,
              Concepto ,
              Centro ,
              TipoNom ,
              Empresa ,
              Renglon ,
              TPago_Desc ,
              Fch_Pago ,
              Importe ,
              Gravable ,
              Exento ,
              Empleados ,
              Dias ,
              Horas ,
              Tipo ,
              Varia1 ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Kardex.Num_Conc ,
                        MAX(Kardex.Concepto) AS Concepto ,
                        '99999999999997' AS Centro ,
                        @nTipoNom AS TipoNom ,
                        Kardex.Empresa AS Empresa ,
                        0 AS Renglon ,
                        MAX(TPago_Desc) AS TPago_Desc ,
                        @dPago AS Fch_Pago ,
                        SUM(Kardex.Importe) AS Importe ,
                        SUM(ISNULL(Kardex.IGravable, 0)) AS Gravable ,
                        SUM(ISNULL(Kardex.IExento, 0)) AS Exento ,
                        COUNT(DISTINCT Kardex.Codigo) AS Empleados ,
                        SUM(CASE WHEN Kardex.Num_Conc IN ( @nTipoNom, 7, 30,
                                                           107, 108, 109, 110,
                                                           111 )
                                 THEN Kardex.Dias
                                 ELSE 0
                            END) AS Dias ,
                        SUM(CASE WHEN Kardex.Num_Conc IN ( 10, 11, 12, 13 )
                                 THEN Kardex.Horas
                                 ELSE 0
                            END) AS Horas ,
                        MAX(CASE WHEN Kardex.Num_Conc = 108
                                 THEN Kardex.Justificar
                                 ELSE ' '
                            END) AS Tipo ,
                        SUM(CASE WHEN Kardex.Num_Conc IN ( 36, 136 )
                                 THEN ISNULL(Kardex.Varia1, 0)
                                 ELSE 0
                            END) AS Varia1 ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.p_Kardex AS Kardex
                        LEFT JOIN dbo.p_empleados_pres AS Llaves ON Kardex.Codigo = Llaves.Codigo
                                                              AND Kardex.Empresa = Llaves.Empresa
                        INNER JOIN dbo.centros ON ( centros.centro = SUBSTRING(Llaves.Centro,
                                                              1, @nLongitud)
                                                    + REPLICATE('0', @nCeros)
                                                    AND centros.empresa = Llaves.Empresa
                                                  )
              WHERE     Kardex.Nomina = @cTipoNom
                        AND Kardex.Empresa IN ( SELECT  empresa
                                                FROM    dbo.p_empresas
                                                WHERE   id_presup = @id_presup )
                        AND --= @nEmpresa And
                        kardex.ayo_operacion = @nAyo
                        AND kardex.mes_operacion = @nMes
                        AND
--      Exists (Select Centro From Centros Where Centros.Centro = Llaves.Centro) And
                        Kardex.Num_Conc <> 108
                        AND Kardex.Num_Conc <> 133
              GROUP BY  kardex.empresa ,
                        Kardex.Num_Conc
            )


    INSERT  INTO dbo.p_Polizas
            ( Num_Conc ,
              Concepto ,
              Centro ,
              TipoNom ,
              Empresa ,
              Renglon ,
              TPago_Desc ,
              Fch_Pago ,
              Importe ,
              Gravable ,
              Exento ,
              Empleados ,
              Dias ,
              Horas ,
              Tipo ,
              Varia1 ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    108 AS Num_Conc ,
                        MAX(Kardex.Concepto) AS Concepto ,
                        '99999999999997' AS Centro ,
                        @nTipoNom AS TipoNom ,
                        kardex.Empresa AS Empresa ,
                        0 AS Renglon ,
                        MAX(TPago_Desc) AS TPago_Desc ,
                        @dPago AS Fch_Pago ,
                        SUM(Kardex.Importe) AS Importe ,
                        SUM(ISNULL(Kardex.IGravable, 0)) AS Gravable ,
                        SUM(ISNULL(Kardex.IExento, 0)) AS Exento ,
                        COUNT(DISTINCT Kardex.Codigo) AS Empleados ,
                        SUM(Kardex.Dias) AS Dias ,
                        0 AS Horas ,
                        Kardex.Justificar AS Tipo ,
                        0 AS Varia1 ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.p_Kardex AS Kardex
                        LEFT JOIN dbo.p_empleados_pres AS Llaves ON Kardex.Codigo = Llaves.Codigo
                                                              AND Kardex.Empresa = Llaves.Empresa
              WHERE     Kardex.Nomina = @cTipoNom
                        AND Kardex.Empresa IN ( SELECT  empresa
                                                FROM    dbo.p_empresas
                                                WHERE   id_presup = @id_presup )
                        AND --= @nEmpresa And
                        EXISTS ( SELECT Centro
                                 FROM   dbo.Centros
                                 WHERE  Centros.Centro = Llaves.Centro )
                        AND kardex.ayo_operacion = @nAyo
                        AND kardex.mes_operacion = @nMes
                        AND ( Kardex.Num_Conc = 108
                              OR Kardex.Num_Conc = 133
                            )
              GROUP BY  kardex.empresa ,
                        Kardex.Num_Conc ,
                        Kardex.Justificar
            )

/*
Insert Into Estatal (Centro,Porciento,Empresa,Base,Importe,TipoNom,Registros)
(
Select '99999999999997' As Centro,
       Kardex.Unidades As Porciento,
       @nEmpresa As Empresa,
       Sum(Kardex.Impor_Base) As Base,
       Sum(Kardex.Importe) As Importe,
       @nTipoNom As TipoNom,
       Count(Distinct Kardex.Codigo)
From Kardex
Left Join Llaves On Kardex.Codigo = Llaves.Codigo And Kardex.Empresa = Llaves.Empresa
Where Kardex.Num_Conc = 216 And Kardex.Nomina = @cTipoNom And Kardex.Empresa = @nEmpresa And
      Exists (Select Centro From Centros Where Centros.Centro = Llaves.Centro)
Group By Kardex.Unidades
)


Insert Into Resumen (Empresa,Centro,Empleados,TipoNom)
(
Select @nEmpresa As Empresa,
       '99999999999997' As Centro,
       Count(Distinct Kardex.Codigo) As Empleados,
       @nTipoNom As TipoNom
From Kardex
Where Kardex.Nomina = @cTipoNom And 
      Kardex.Empresa = @nEmpresa
)
*/

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Provisiona')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Provisiona
GO

CREATE  PROCEDURE dbo.asp_p_Provisiona
    @id_presup INT ,
    @nTipoNom INT ,
    @nSalMin NUMERIC(10, 2) ,
    @nSalDF NUMERIC(10, 2) ,
    @dFF DATETIME ,
    @nPrimaGuard NUMERIC(7, 4) ,
    @nPrimaInfo NUMERIC(7, 4)
AS /*
declare @nEmpresa    Int
declare @nTipoNom    Int
declare @nSalMin     Numeric(10,2)
declare @nSalDF      Numeric(10,2)
declare @dFF         DateTime
declare @nPrimaGuard Numeric(7,4)
declare @nPrimaInfo  Numeric(7,4)
*/
    DECLARE @nempresa INT

    DECLARE @cMinimos CHAR(1)
    DECLARE @nTope INT
    DECLARE @dPago DATETIME
    DECLARE @cTipoNom CHAR(3)
    DECLARE @dInicio DATETIME
    DECLARE	@dCierre DATETIME

    DECLARE @dFechaTab DATETIME

    DECLARE @cPatronPaga CHAR(1)

    DECLARE @nMes INT
    DECLARE @nAyo INT
    
    DECLARE @diasImss AS INT

/*
SET @nEmpresa = 1
SET @nTiponom = 1
SET @dFF = '20070531'
SET @nSALDF = 48.67
SET @nSalMin = 47.16
SET @nPrimaGuard = 1.00000
SET @nPrimaInfo  = 5.00000
*/


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END

    SELECT  @dPago = Pago ,
            @nMes = MONTH(Inicio) ,
            @nAyo = YEAR(Inicio),
            @dInicio = inicio,
            @dcierre = cierre,
            @diasImss = DATEDIFF(dd,inicio,cierre) + 1
    FROM    dbo.p_dias
    WHERE   Estatus = 'A'
            AND id_presup = @id_presup
            AND TipoNom = @nTipoNom

    Declare @DiasDelAyo int
	set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@nAyo),0)

	--select @DiasDelAyo as DiasDelAyo

	
	SET @nTope = 15 + CASE WHEN YEAR(@dPago) >= 1997 THEN YEAR(@dPago) - 1997
                           ELSE 0
                      END

    SET @cMinimos = CASE WHEN ( SELECT  COUNT(Num_Conc)
                                FROM    dbo.Conceptos
                                WHERE   Num_Conc = 101
                                        AND Marca1 = 'S'
                              ) > 0 THEN 'S'
                         ELSE 'N'
                    END

    SET @cPatronPaga = ( SELECT MAX(Patron_Paga_Cuotas_Imss)
                         FROM   dbo.Empresas
                       )


    IF @nTope > 25 
        SET @nTope = 25


-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
    IF @dPago > @dFF 
        SET @dFechaTab = @dFF
    ELSE 
        SET @dFechaTab = @dPago
--


    IF OBJECT_ID('dbo.Tmp_p_Provisiona') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.Tmp_p_Provisiona
        END
	
    IF OBJECT_ID('dbo.Tmp_p_Provisiones') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.Tmp_p_Provisiones
        END

    IF OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.Tmp_p_Kardex
        END
        
    IF OBJECT_ID('dbo.tmp_pres_primasrt') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.tmp_pres_primasrt
        END
                
    SELECT  empresa ,
            CASE WHEN prima_modificada > 0
                      AND ( mes <= @nMes
                            AND @nAyo >= ayo
                          ) THEN prima_modificada
                 ELSE prima_rt
            END AS Prima_RT
    INTO    dbo.tmp_pres_primasrt
    FROM    dbo.p_primas_rt
    WHERE   id_presup = @id_presup

    SELECT  Kardex.Codigo ,
            Kardex.Dias ,
            @diasImss AS Dias_Imss ,
            ISNULL(Kardex.Aus, 0) AS Aus ,
            ISNULL(Kardex.Inc, 0) AS Inc ,
            Kardex.Impor_Base ,
            @dinicio AS Fch_Inicio ,
            @dcierre AS Fch_Cierre ,
            CASE WHEN Kardex.SalDiaInt > @nSalDF * 25 THEN @nSalDF * 25
                 ELSE Kardex.SalDiaInt
            END AS SalDiaEyM ,
            CASE WHEN Kardex.SalDiaInt > @nSalDF * 25 THEN @nSalDF * 25
                 ELSE Kardex.SalDiaInt
            END AS SalDiaIV ,
            Kardex.SalDiaInt AS SalDiaReal ,
            CASE WHEN YEAR(Kardex.Fch_Inicio) > 1997
                      AND MONTH(Kardex.Fch_Inicio) < 7 THEN @nTope - 1
                 ELSE @nTope
            END AS Tope ,
            CONVERT(NUMERIC(10, 2), @nSalMin * Tablas_Int.Factor) AS SalMinInt ,
            @cPatronPaga AS SoloPatron ,
            Empleados.TipoSal ,
            ISNULL(CV.Excepcion1, ' ') AS CV ,
            ISNULL(IV.Excepcion1, ' ') AS IV ,
            Kardex.Descuento ,
            Kardex.Tabulador ,
            Totales.Dias AS Dias_Totales ,
            Totales.Aus AS Aus_Totales ,
            Totales.Inc AS Inc_Totales ,
            Kardex.Num_Conc ,
            'S' AS Cotiza_Imss ,--Empleados.Cotiza_Imss,
            kardex.empresa AS Empresa
    INTO    dbo.Tmp_p_Provisiona
    FROM    dbo.p_Kardex AS kardex
            INNER JOIN dbo.p_empleados_pres AS Empleados ON Kardex.Codigo = Empleados.Codigo
                                                            AND Kardex.Empresa = Empleados.Empresa
                                                            AND Kardex.id_presup = Empleados.id_presup
--Inner Join Llaves On Kardex.Codigo = Llaves.Codigo And Kardex.Empresa = Llaves.Empresa
            INNER JOIN dbo.p_tablas_int AS Tablas_Int ON empleados.Clase = Tablas_Int.Clase
                                                         AND empleados.Empresa = Tablas_Int.Empresa
                                                         AND empleados.id_presup = Tablas_Int.id_presup
                                                         AND CONVERT(INT, Tablas_Int.Ayos) = CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)
                                                         + 1)
                                                         AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                         AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
                                                         AND Tablas_Int.id_presup = @id_presup
            LEFT JOIN dbo.Excepciones AS CV ON CV.Codigo = Kardex.Codigo
                                               AND CV.Empresa = Kardex.Empresa
                                               AND CV.Excepcion1 = 'CV'
            LEFT JOIN dbo.Excepciones AS IV ON IV.Codigo = Kardex.Codigo
                                               AND IV.Empresa = Kardex.Empresa
                                               AND IV.Excepcion1 = 'IV'
            LEFT JOIN ( SELECT  Codigo ,
                                SUM(Dias) AS Dias ,
                                SUM(Aus * Descuento / 100) AS Aus ,
                                SUM(Inc) AS Inc ,
                                empresa
                        FROM    dbo.p_kardex
                        WHERE   Nomina = @cTipoNom
                                AND Num_Conc IN ( @nTipoNom, 7, 30, 1107 )
                                AND Tipo_Mov <> 'FIN' --And 
                 --Empresa = kardex.empresa 
                        GROUP BY Codigo ,
                                empresa
                      ) AS Totales ON Kardex.Codigo = Totales.Codigo
                                      AND Kardex.empresa = Totales.empresa
    WHERE   kardex.mes_operacion = @nMes
            AND kardex.ayo_operacion = @nAyo
            AND empleados.id_presup = @id_presup
            AND Kardex.Nomina = @cTipoNom
            AND Kardex.Num_Conc IN ( @nTipoNom, 7, 30, 1107 )
            AND Kardex.Tipo_Mov <> 'FIN'
            AND Kardex.Empresa IN ( SELECT  empresa
                                    FROM    dbo.p_empresas
                                    WHERE   id_presup = @id_presup )


    UPDATE  dbo.Tmp_p_Provisiona
    SET     SoloPatron = 'S'
    WHERE   ( CASE WHEN @cMinimos = 'S'
                        AND Tmp_p_Provisiona.TipoSal <> 01
                   THEN Tmp_p_Provisiona.Impor_Base
                   ELSE Tmp_p_Provisiona.SalDiaEyM
              END ) <= ( CASE WHEN @cMinimos = 'S'
                                   AND Tmp_p_Provisiona.TipoSal <> 01
                              THEN @nSalMin
                              ELSE Tmp_p_Provisiona.SalMinInt
                         END )

    UPDATE  dbo.Tmp_p_Provisiona
    SET     SalDiaIV = CASE WHEN Tmp_p_Provisiona.SalDiaEyM > @nSalDF
                                 * Tmp_p_Provisiona.Tope
                            THEN @nSalDF * Tmp_p_Provisiona.Tope
                            ELSE Tmp_p_Provisiona.SalDiaEyM
                       END


-- Concepto 201 EyM Art. 25
    SELECT  Tmp_Provisiona.Codigo ,
            201 AS Num_Conc ,
            Tmp_Provisiona.Dias ,
            Tmp_Provisiona.Dias_Imss ,
            Tmp_Provisiona.Aus ,
            Tmp_Provisiona.Inc ,
            Tmp_Provisiona.Impor_Base ,
            Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
            CONVERT(NUMERIC(10, 2), ( Tmp_Provisiona.Dias_Imss
                                      - Tmp_Provisiona.Inc )
            * Tmp_Provisiona.SalDiaEyM
            * ( CASE WHEN Tmp_Provisiona.SoloPatron = 'S'
                     THEN Primas_Imss.EyMArt25
                     ELSE Primas_Imss.EyMPat25
                END ) / 100) AS Importe ,
            Tmp_Provisiona.Fch_Inicio ,
            Tmp_Provisiona.Fch_Cierre ,
            0 AS Folio ,
            Tmp_Provisiona.Empresa AS Empresa
    INTO    dbo.Tmp_p_Provisiones
    FROM    dbo.Tmp_p_Provisiona AS Tmp_Provisiona
            LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
    WHERE   Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc > 0
            AND ISNULL(Tmp_Provisiona.Cv, ' ') <> 'CV'
            AND Tmp_Provisiona.Cotiza_Imss = 'S'


-- Concepto 202 EyM Art. 106-I
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        202 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), @nSalDF
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc )
                        * Primas_Imss.EyMArt106I / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = @nAyo
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 203 EyM Art. 106-II
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        203 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), ( Tmp_Provisiona.Dias_Imss
                                                  - Tmp_Provisiona.Inc )
                        * ( Tmp_Provisiona.SalDiaEyM - ( @nSalDF * 3 ) )
                        * ( CASE WHEN Tmp_Provisiona.SoloPatron = 'S'
                                 THEN Primas_Imss.EyMArt1062
                                 ELSE Primas_Imss.EyMPat1062
                            END ) / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc > 0
                        AND Tmp_Provisiona.SalDiaEyM > @nSalDF * 3
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 204 EyM Art. 107
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        204 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaEyM
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc )
                        * ( CASE WHEN Tmp_Provisiona.SoloPatron = 'S'
                                 THEN Primas_Imss.EyMArt107
                                 ELSE Primas_Imss.EyMPat107
                            END ) / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 205 IV Art. 147
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        205 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaIV
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                            - Tmp_Provisiona.Aus )
                        * ( CASE WHEN Tmp_Provisiona.SoloPatron = 'S'
                                 THEN Primas_Imss.IVArt147
                                 ELSE Primas_Imss.IVPat147
                            END ) / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                        - Tmp_Provisiona.Aus > 0
                        AND ISNULL(Tmp_Provisiona.IV, ' ') <> 'IV'
                        AND ISNULL(Tmp_Provisiona.CV, ' ') <> 'CV'
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 206 CV Art. 168-I
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        206 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaEyM
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Aus )
                        * Primas_Imss.Retiro / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Aus > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 207 CV Art. 168-II
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        207 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaIV
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                            - Tmp_Provisiona.Aus )
                        * ( CASE WHEN Tmp_Provisiona.SoloPatron = 'S'
                                 THEN Primas_Imss.CVArt168II
                                 ELSE Primas_Imss.CVPat168II
                            END ) / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                        - Tmp_Provisiona.Aus > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 208 RT Art. 71
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        208 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaEyM
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                            - Tmp_Provisiona.Aus ) * Primas_RT.Prima_RT / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.tmp_pres_primasrt AS Primas_RT ON Primas_RT.id_Presup=tmp_provisiona.id_presup and Primas_RT.Empresa = Tmp_Provisiona.Empresa
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                        - Tmp_Provisiona.Aus > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 209 Guarderias Art. 211
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        209 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaEyM
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                            - Tmp_Provisiona.Aus ) * @nPrimaGuard / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Inc
                        - Tmp_Provisiona.Aus > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


-- Concepto 210 Infonavit
    INSERT  INTO dbo.Tmp_p_Provisiones
            ( Codigo ,
              Num_Conc ,
              Dias ,
              Dias_Imss ,
              Aus ,
              Inc ,
              Impor_Base ,
              SalDiaInt ,
              Importe ,
              Fch_Inicio ,
              Fch_Cierre ,
              Folio ,
              Empresa
            )
            ( SELECT    Tmp_Provisiona.Codigo ,
                        210 AS Num_Conc ,
                        Tmp_Provisiona.Dias ,
                        Tmp_Provisiona.Dias_Imss ,
                        Tmp_Provisiona.Aus ,
                        Tmp_Provisiona.Inc ,
                        Tmp_Provisiona.Impor_Base ,
                        Tmp_Provisiona.SalDiaEyM AS SalDiaInt ,
                        CONVERT(NUMERIC(10, 2), Tmp_Provisiona.SalDiaIV
                        * ( Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Aus )
                        * @nPrimaInfo / 100) AS Importe ,
                        Tmp_Provisiona.Fch_Inicio ,
                        Tmp_Provisiona.Fch_Cierre ,
                        0 AS Folio ,
                        Tmp_Provisiona.Empresa AS Empresa
              FROM      dbo.Tmp_p_Provisiona AS Tmp_Provisiona
                        LEFT JOIN dbo.Primas_Imss ON YEAR(Primas_Imss.Periodo) = YEAR(@dPago)
              WHERE     Tmp_Provisiona.Dias_Imss - Tmp_Provisiona.Aus > 0
                        AND Tmp_Provisiona.Cotiza_Imss = 'S'
            )


--La rutina que genera los Folios, requiere la tabla ordenada por codigo
    SELECT  Codigo ,
            Num_Conc ,
            Dias ,
            Dias_Imss ,
            Aus ,
            Inc ,
            Impor_Base ,
            SalDiaInt ,
            Importe ,
            Fch_Inicio ,
            Fch_Cierre ,
            Folio ,
            Empresa
    INTO    dbo.Tmp_p_Kardex
    FROM    dbo.Tmp_p_Provisiones
    ORDER BY Codigo ,
            Num_Conc


-- Crear indice para que ordene por codigo y num_conc
    CREATE  INDEX [IX_Tmp_p_Kardex] ON [dbo].[Tmp_p_Kardex]([Codigo], [num_conc]) ON [PRIMARY]
-- Determinar los folios para la insercion en el kardex
--Exec asp_genera_folio @nEmpresa,0,'Tmp_Kardex','Folio',0,0


    INSERT  INTO dbo.p_Kardex
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_Kardex.Codigo ,
                        Tmp_Kardex.Empresa AS Empresa ,
                        @cTipoNom AS Nomina ,
                        ' ' AS Centro ,
                        Tmp_Kardex.Num_Conc ,
                        ' ' AS Clase ,
                        Tmp_Kardex.Folio ,
                        0 AS Renglon ,
                        Tmp_Kardex.Fch_Inicio ,
                        Tmp_Kardex.Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        Tmp_Kardex.Dias AS Dias ,
                        Tmp_Kardex.Inc ,
                        Tmp_Kardex.Aus ,
                        Tmp_Kardex.Dias_Imss AS DiasTr ,
                        Tmp_Kardex.Dias_Imss ,
                        'I' AS TPago_Desc ,
                        Conceptos.Concepto ,
                        0 AS VariaImss ,
                        0 AS Variable ,
                        Conceptos.Imss ,
                        Conceptos.Ispt ,
                        Conceptos.Ptu ,
                        Conceptos.Despensa ,
                        Conceptos.Mca_Agui ,
                        Conceptos.FdoAhorro ,
                        'A' AS Calculo ,
                        Tmp_Kardex.Impor_Base ,
                        Tmp_Kardex.SalDiaInt ,
                        0 AS Tabulador ,
                        0 AS Unidades ,
                        0 AS Horas ,
                        'PRO' AS Tipo_Mov ,
                        0 AS Secuencia ,
                        Tmp_Kardex.Importe ,
                        0 AS IGravable ,
                        0 AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        ' ' AS Referencia ,
                        'N' AS Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        'F' AS PrevSocial ,
                        0 AS Varia1 ,
                        0 AS Varia2 ,
                        0 AS Varia3 ,
                        0 AS Varia4 ,
                        ' ' AS Variable1 ,
                        ' ' AS Variable2 ,
                        ' ' AS Variable3 ,
                        ' ' AS Variable4 ,
                        'F' AS Masivo ,
                        ' ' AS Formula ,
                        ' ' AS Ispt_NG ,
                        ' ' AS Imss_NI ,
                        ' ' AS Marca ,
                        0 AS Serial ,
                        'F' AS Informativo ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.Tmp_p_Kardex AS Tmp_Kardex
                        LEFT JOIN dbo.Conceptos ON Tmp_Kardex.Num_Conc = Conceptos.Num_Conc
                                                   AND Conceptos.Empresa = Tmp_Kardex.Empresa
                                                   AND Conceptos.Clase = ' '
              WHERE     Tmp_Kardex.Importe > 0
            )


    DROP TABLE dbo.Tmp_p_Provisiones
    DROP TABLE dbo.Tmp_p_Kardex
    IF OBJECT_ID('dbo.tmp_pres_primasrt') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.tmp_pres_primasrt
        END


GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_ProviTabla')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_ProviTabla
GO


CREATE PROCEDURE dbo.asp_p_ProviTabla
    @nTipoNom INT ,
    @id_presup INT ,
    @dFf DATETIME
AS -- exec dbo.asp_p_ProviTabla 4,1,'20080301'

--Declare @nTipoNom  Int
--Declare @nEmpresa  Int
--Declare @dFF       DateTime

    DECLARE @nEmpresa INT 

    DECLARE @cTipoNom CHAR(3)
    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME
    DECLARE @nConcepto INT

    DECLARE @dFechaTab DATETIME

    DECLARE @nAyo INT
    DECLARE @nMes INT 

--Set @nTipoNom = 1
--Set @nEmpresa = 1
--Set @dFf      = '20070531'


    SET @nConcepto = 213


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @dPago = Periodos.pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio)
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup
            AND Periodos.estatus = 'A'

	
	Declare @DiasDelAyo int
	set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@nAyo),0)

	--select @DiasDelAyo as DiasDelAyo


-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
    IF @dPago > @dFF 
        SET @dFechaTab = @dFF
    ELSE 
        SET @dFechaTab = @dPago
--




    WHILE @nConcepto <= 215 
        BEGIN
            IF ( SELECT MAX(USO)
                 FROM   dbo.conceptos
                 WHERE  Num_conc = @nConcepto
               ) = 'S' 
                BEGIN
                    INSERT  INTO dbo.p_Kardex
                            ( Codigo ,
                              Empresa ,
                              Nomina ,
                              Centro ,
                              Num_Conc ,
                              Clase ,
                              Folio ,
                              Renglon ,
                              Fch_Inicio ,
                              Fch_Cierre ,
                              Fch_Pago ,
                              Dias ,
                              Inc ,
                              Aus ,
                              DiasTr ,
                              Dias_Imss ,
                              TPago_Desc ,
                              Concepto ,
                              VariaImss ,
                              Variable ,
                              Imss ,
                              Ispt ,
                              Ptu ,
                              Despensa ,
                              Mca_Agui ,
                              FdoAhorro ,
                              Calculo ,
                              Impor_Base ,
                              SalDiaInt ,
                              Tabulador ,
                              Unidades ,
                              Horas ,
                              Tipo_Mov ,
                              Secuencia ,
                              Importe ,
                              IGravable ,
                              IExento ,
                              Credito ,
                              Descuento ,
                              Saldo ,
                              Referencia ,
                              Siempre ,
                              Justificar ,
                              Septimo ,
                              PrevSocial ,
                              Varia1 ,
                              Varia2 ,
                              Varia3 ,
                              Varia4 ,
                              Variable1 ,
                              Variable2 ,
                              Variable3 ,
                              Variable4 ,
                              Masivo ,
                              Formula ,
                              Ispt_NG ,
                              Imss_NI ,
                              Marca ,
                              Serial ,
                              Informativo ,
                              id_presup ,
                              ayo_operacion ,
                              mes_operacion
                            )
                            ( SELECT    Nomina_Tot.Codigo ,
                                        Nomina_Tot.Empresa ,
										--Nomina_Tot.Dias_Pagar,
										--@DiasDelAyo,
                                        @cTipoNom AS Nomina ,
                                        ' ' AS Centro ,
                                        @nConcepto AS Num_Conc ,
                                        ' ' AS Clase ,
                                        40 AS folio ,--Folios.Folio + (@nConcepto - 213) + 1 As Folio,
                                        0 AS Renglon ,
                                        @dInicio AS Fch_Inicio ,
                                        @dCierre AS Fch_Cierre ,
                                        @dPago AS Fch_Pago ,
                                        Nomina_Tot.Dias_Pagar AS Dias ,
                                        0 AS Inc ,
                                        0 AS Aus ,
                                        Nomina_Tot.Dias_Pagar AS DiasTr ,
                                        0 AS Dias_Imss ,
                                        'I' AS TPago_Desc ,
                                        conceptos.concepto ,--(select max(concepto) from conceptos where empresa=nomina_tot.empresa and num_conc=@nConcepto) as concepto,--Conceptos.Concepto,
                                        0 AS VariaImss ,
                                        0 AS Variable ,
                                        ISNULL(Conceptos.Imss, 'N') ,
                                        ISNULL(Conceptos.Ispt, 'N') ,
                                        ISNULL(Conceptos.Ptu, 'N') ,
                                        ISNULL(Conceptos.Despensa, 'N') ,
                                        ISNULL(Conceptos.Mca_Agui, 'N') ,
                                        ISNULL(Conceptos.FdoAhorro, 'N') ,
                                        'A' AS Calculo ,
           --Empleados.Sueldo As Impor_Base,
           --Empleados.SalDiaInt,
                                        
										Sueldos.Impor_Base ,
                                        Sueldos.SalDiaInt ,
                                        0 AS Tabulador ,
                                        0 AS Unidades ,
                                        0 AS Horas ,
                                        'PRO' AS Tipo_Mov ,
                                        0 AS Secuencia ,
										ROUND(CASE @nConcepto
                                                WHEN 213
                                                THEN ISNULL(Tablas_Int.Aguinaldo,
                                                            0)
                                                     * Sueldos.Impor_Base
                                                     / @DiasDelAyo
                                                     * Nomina_Tot.Dias_Pagar
                                                WHEN 214
                                                THEN ISNULL(Tablas_Int.Dias_Vac,
                                                            0)
                                                     * Sueldos.Impor_Base
                                                     / @DiasDelAyo
                                                     * Nomina_Tot.Dias_Pagar
                                                ELSE 
													( ( ISNULL(Tablas_Int.Dias_Vac,
                                                              0)
                                                         * Sueldos.Impor_Base
                                                         * ISNULL(Tablas_Int.Prima_Vac,
                                                              0) / 100 )
                                                       + ( ISNULL(Tablas_Int.PmaVacDias,
                                                              0)
                                                           * Sueldos.Impor_Base )
                                                       + ISNULL(Tablas_Int.PmaVacImpo,
                                                              0) ) / @DiasDelAyo
                                                     * Nomina_Tot.Dias_Pagar
                                              END, 2) AS Importe ,
                                        0 AS IGravable ,
                                        0 AS IExento ,
                                        0 AS Credito ,
                                        0 AS Descuento ,
                                        0 AS Saldo ,
                                        ' ' AS Referencia ,
                                        'N' AS Siempre ,
                                        ' ' AS Justificar ,
                                        ' ' AS Septimo ,
                                        'F' AS PrevSocial ,
                                        0 AS Varia1 ,
                                        0 AS Varia2 ,
                                        0 AS Varia3 ,
                                        0 AS Varia4 ,
                                        ' ' AS Variable1 ,
                                        ' ' AS Variable2 ,
                                        ' ' AS Variable3 ,
                                        ' ' AS Variable4 ,
                                        'F' AS Masivo ,
                                        ' ' AS Formula ,
                                        ' ' AS Ispt_NG ,
                                        ' ' AS Imss_NI ,
                                        ' ' AS Marca ,
                                        0 AS Serial ,
                                        'F' AS Informativo ,
                                        @id_presup AS id_presup ,
                                        @nAyo AS ayo_operacion ,
                                        @nMes AS mes_operacion
										--,Tablas_Int.Prima_Vac,
										--Tablas_Int.PmaVacImpo,
										--Tablas_Int.Dias_Vac,
										--DATEDIFF(Day,Empleados.FchAntigua,@dCierre)+1 as diant
                              FROM      dbo.p_Nomina_Tot AS Nomina_Tot --select * from p_nomina_tot
                                        INNER JOIN dbo.p_Empleados_pres AS Empleados ON Nomina_Tot.Codigo = Empleados.Codigo
                                                              AND Nomina_Tot.Empresa = Empleados.Empresa
                                                              AND Nomina_Tot.id_presup = Empleados.id_presup
    --Inner Join Llaves On Nomina_Tot.Codigo = Llaves.Codigo And Nomina_Tot.Empresa = Llaves.Empresa
                                        INNER JOIN dbo.p_Tablas_Int AS Tablas_Int ON empleados.Clase = Tablas_Int.Clase
                                                              AND empleados.Empresa = Tablas_Int.Empresa
                                                              AND Empleados.id_presup = Tablas_Int.id_presup
                                                              AND CONVERT(INT, Tablas_Int.Ayos) = CASE
                                                              WHEN CONVERT(INT, ( DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dCierre) + 1 )
                                                              / 365) + 1 > 45
                                                              THEN 45
                                                              ELSE CONVERT(INT, ( DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dCierre) + 1 )
                                                              / 365) + 1
                                                              END
                                                              AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                              AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
                                                              AND Tablas_Int.id_presup = @id_presup
                                        LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = @nConcepto
                                                              AND nomina_tot.Empresa = Conceptos.Empresa --and Conceptos.clase = empleados.clase
    --Inner Join (Select empresa,Codigo,Max(Folio) As Folio 
      --          From p_Kardex 
       --         Where Nomina = @cTipoNom And Empresa = in(select empresa from p_empresas where id_presup=@id_presup)and id_presup=@id_presup and ayo_operacion=@nAyo and mes_operacion=@nMes--= @nEmpresa 
        --        Group By empresa,Codigo) As Folios On Nomina_Tot.Codigo = Folios.Codigo And Nomina_Tot.Empresa = Folios.Empresa
                                        INNER JOIN ( SELECT empresa ,
                                                            Codigo ,
                                                            MAX(Fch_Cierre) AS Fch_Cierre ,
                                                            MAX(Impor_Base) AS Impor_Base ,
                                                            MAX(SalDiaInt) AS SalDiaInt
                                                     FROM   dbo.p_Kardex
                                                     WHERE  Num_Conc = @nTipoNom
                                                            AND Nomina = @cTipoNom
                                                            AND Empresa IN (
                                                            SELECT
                                                              empresa
                                                            FROM
                                                              dbo.p_empresas
                                                            WHERE
                                                              id_presup = @id_presup )
                                                            AND id_presup = @id_presup
                                                            AND ayo_operacion = @nAyo
                                                            AND mes_operacion = @nMes--= @nEmpresa 
                                                     GROUP BY empresa ,
                                                            Codigo
                                                   ) AS Sueldos ON Sueldos.Codigo = Nomina_Tot.Codigo
                                                              AND Sueldos.empresa = Nomina_Tot.empresa
                              WHERE     empleados.id_presup = @id_presup
                                        AND empleados.TipoNom = @nTipoNom
                                        AND Nomina_Tot.Dias_Pagar > 0
                                        AND Nomina_Tot.Empresa IN (
                                        SELECT  empresa
                                        FROM    dbo.p_empresas
                                        WHERE   id_presup = @id_presup )
                                        AND empleados.id_presup = @id_presup
                                        AND nomina_tot.mes_operacion = @nMes
                                        AND nomina_tot.ayo_operacion = @nAyo
										--and num_conc=213
                            )
                END
            SET @nConcepto = @nConcepto + 1

        END




GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Redondeo')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Redondeo
GO


CREATE PROCEDURE dbo.asp_p_Redondeo
    @nTipoNom INT ,
    @id_presup INT
AS 
    DECLARE @nEmpresa INT

    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME
    DECLARE @cTipoNom CHAR(3)
    DECLARE @cMarca CHAR(1)
    DECLARE @cMarca32 CHAR(1)
    DECLARE @cConcepto132 CHAR(30)
    DECLARE @cConcepto32 CHAR(30)

    DECLARE @nAyo INT
    DECLARE @nMes INT
--Set @nTipoNom = 4
--Set @nEmpresa = 3


    SELECT  @cMarca = ISNULL(Conceptos.Marca1, 'S') ,
            @cConcepto132 = Conceptos.Concepto
    FROM    dbo.Conceptos
    WHERE   Conceptos.Num_Conc = 132
            AND Conceptos.Uso = 'S'
            AND Conceptos.Empresa IN ( SELECT   empresa
                                       FROM     dbo.p_empresas
                                       WHERE    id_presup = @id_presup )--= @nEmpresa
    SELECT  @cMarca32 = ISNULL(Conceptos.Marca1, 'P') ,
            @cConcepto32 = Conceptos.Concepto
    FROM    dbo.Conceptos
    WHERE   Conceptos.Num_Conc = 32
            AND Conceptos.Uso = 'S'
            AND Conceptos.Empresa IN ( SELECT   empresa
                                       FROM     dbo.p_empresas
                                       WHERE    id_presup = @id_presup )--@nEmpresa


    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @dCierre = Periodos.pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio)
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup


-- Primero actualizar Nomina_Tot con los importes de las formulas totalizadas que van despues de ISR
    IF OBJECT_ID('dbo.Tmp_p_ImpFormulas') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_ImpFormulas

    SELECT  Kardex.Codigo ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'P' THEN Kardex.Importe
                     ELSE 0
                END) AS Tot_Percep ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'D' THEN Kardex.Importe
                     ELSE 0
                END) AS Tot_Deducc ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'P' THEN Kardex.IGravable
                     ELSE 0
                END) AS Perc_Grava ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'P' THEN Kardex.IExento
                     ELSE 0
                END) AS Perc_Exento ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'D' THEN Kardex.IGravable
                     ELSE 0
                END) AS Dedu_Grava ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'D' THEN Kardex.IExento
                     ELSE 0
                END) AS Dedu_Exent ,
            SUM(CASE WHEN Kardex.Mca_Agui = 'S'
                     THEN CASE WHEN Kardex.TPago_Desc = 'P'
                               THEN Kardex.Importe
                               ELSE 0 - Kardex.Importe
                          END
                     ELSE 0
                END) AS Aguinaldo ,
            SUM(CASE WHEN Kardex.Ptu = 'S'
                     THEN CASE WHEN Kardex.TPago_Desc = 'P'
                               THEN Kardex.Importe
                               ELSE 0 - Kardex.Importe
                          END
                     ELSE 0
                END) AS Ptu ,
            SUM(CASE WHEN Kardex.TPago_Desc = 'P' THEN Kardex.Importe
                     ELSE 0 - Kardex.Importe
                END) AS Neto
    INTO    dbo.Tmp_p_ImpFormulas
    FROM    dbo.p_Kardex AS Kardex
            LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = Kardex.Num_Conc
                                       AND Conceptos.Clase = Kardex.Clase
                                       AND Conceptos.Centro = Kardex.Centro
                                       AND Conceptos.Empresa = Kardex.Empresa
    WHERE   ISNULL(Kardex.Secuencia, 0) = 29
            AND Kardex.Nomina = @cTipoNom
            AND Kardex.id_presup = @id_presup
            AND Kardex.Empresa IN ( SELECT  empresa
                                    FROM    dbo.p_empresas
                                    WHERE   id_presup = @id_presup )--= @nEmpresa
GROUP BY    Kardex.Codigo


    UPDATE  p_Nomina_Tot
    SET     Tot_Percep = Nomina_Tot.Tot_Percep
            + ISNULL(Tmp_p_ImpFormulas.Tot_Percep, 0) ,
            Tot_Deducc = Nomina_Tot.Tot_Deducc
            + ISNULL(Tmp_p_ImpFormulas.Tot_Deducc, 0) ,
            Perc_Grava = Nomina_Tot.Perc_Grava
            + ISNULL(Tmp_p_ImpFormulas.Perc_Grava, 0) ,
            Perc_Exento = Nomina_Tot.Perc_Exento
            + ISNULL(Tmp_p_ImpFormulas.Perc_Exento, 0) ,
            Dedu_Grava = Nomina_Tot.Dedu_Grava
            + ISNULL(Tmp_p_ImpFormulas.Dedu_Grava, 0) ,
            Dedu_Exent = Nomina_Tot.Dedu_Exent
            + ISNULL(Tmp_p_ImpFormulas.Dedu_Exent, 0) ,
    --Aguinaldo   = Nomina_Tot.Aguinaldo   + Tmp_p_ImpFormulas.Aguinaldo,
            Ptu = Nomina_Tot.Ptu + ISNULL(Tmp_p_ImpFormulas.Ptu, 0) ,
            Neto = Nomina_Tot.Neto + ISNULL(Tmp_p_ImpFormulas.Neto, 0)
    FROM    dbo.p_Nomina_Tot AS Nomina_Tot
            LEFT JOIN dbo.Tmp_p_ImpFormulas ON Tmp_p_ImpFormulas.Codigo = Nomina_Tot.Codigo
    WHERE   Nomina_Tot.Empresa IN ( SELECT  empresa
                                    FROM    dbo.p_empresas
                                    WHERE   id_presup = @id_presup )
            AND Nomina_Tot.TipoNom = @nTipoNom
            AND nomina_tot.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes

/*
UpDate Mes
Set Gravable = Mes.Gravable + (IsNull(Tmp_p_ImpFormulas.Perc_Grava,0) - IsNull(Tmp_p_ImpFormulas.Dedu_Grava,0)),
    Exento   = Mes.Exento + IsNull(Tmp_p_ImpFormulas.Perc_Exento,0)
From Mes
Left Join Tmp_p_ImpFormulas On Tmp_p_ImpFormulas.Codigo = Mes.Codigo
Where Mes.Empresa = @nEmpresa And Mes.TipoNom = @nTipoNom
*/

    DROP TABLE dbo.Tmp_p_ImpFormulas
--


    IF OBJECT_ID('dbo.Tmp_P_Redondeo') IS NOT NULL 
        DROP TABLE dbo.Tmp_P_Redondeo


    SELECT  Nomina_Tot.empresa ,
            Nomina_Tot.Codigo ,
            dbo.Fun_R_SacaDecimales(Nomina_Tot.Neto, @cMarca, @cMarca32) AS Redondeo ,
            0 AS Num_Conc
    INTO    dbo.Tmp_P_Redondeo
    FROM    dbo.p_Nomina_Tot AS Nomina_Tot
    WHERE   Nomina_Tot.Neto > 0
            AND nomina_tot.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes
            AND Nomina_Tot.tiponom = @nTiponom
    ORDER BY empresa ,
            Codigo


    UPDATE  dbo.Tmp_P_Redondeo
    SET     Num_Conc = CASE WHEN Tmp_P_Redondeo.Redondeo > 0 THEN 132
                            ELSE 32
                       END


    INSERT  INTO dbo.p_Kardex
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    Tmp_P_Redondeo.Codigo ,
                        tmp_p_redondeo.Empresa ,
                        @cTipoNom AS Nomina ,
                        ' ' AS Centro ,
                        Tmp_P_Redondeo.Num_Conc ,
                        ' ' AS Clase ,
                        Folios.Folio ,
                        0 AS Renglon ,
                        @dInicio AS Fch_Inicio ,
                        @dCierre AS Fch_Cierre ,
                        @dPago AS Fch_Pago ,
                        Nomina_Tot.Dias_Pagar ,
                        0 AS Inc ,
                        0 AS Aus ,
                        Nomina_Tot.Dias_Pagar AS DiasTr ,
                        0 AS Dias_Imss ,
                        CASE WHEN Tmp_P_Redondeo.Num_Conc = 132 THEN 'D'
                             ELSE 'P'
                        END AS TPago_Desc ,
                        CASE WHEN Tmp_P_Redondeo.Num_Conc = 132
                             THEN @cConcepto132
                             ELSE @cConcepto32
                        END AS Concepto ,
                        0 AS VariaImss ,
                        0 AS Variable ,
                        'N' AS Imss ,
                        'N' AS Ispt ,
                        'N' AS Ptu ,
                        'N' AS Despensa ,
                        'N' AS Mca_Agui ,
                        'N' AS FdoAhorro ,
                        'A' AS Calculo ,
                        Empleados.Sueldo AS Impor_Base ,
                        Empleados.SalDiaInt ,
                        0 AS Tabulador ,
                        0 AS Unidades ,
                        0 AS Horas ,
                        'RED' AS Tipo_Mov ,
                        0 AS Secuencia ,
                        ABS(Tmp_P_Redondeo.Redondeo) AS Importe ,
                        0 AS IGravable ,
                        ABS(Tmp_P_Redondeo.Redondeo) AS IExento ,
                        0 AS Credito ,
                        0 AS Descuento ,
                        0 AS Saldo ,
                        ' ' AS Referencia ,
                        'N' AS Siempre ,
                        ' ' AS Justificar ,
                        ' ' AS Septimo ,
                        'F' AS PrevSocial ,
                        0 AS Varia1 ,
                        0 AS Varia2 ,
                        0 AS Varia3 ,
                        0 AS Varia4 ,
                        ' ' AS Variable1 ,
                        ' ' AS Variable2 ,
                        ' ' AS Variable3 ,
                        ' ' AS Variable4 ,
                        'F' AS Masivo ,
                        ' ' AS Formula ,
                        ' ' AS Ispt_NG ,
                        ' ' AS Imss_NI ,
                        ' ' AS Marca ,
                        0 AS Serial ,
                        'F' AS Informativo ,
                        @id_presup AS id_presup ,
                        @nAyo AS ayo_operacion ,
                        @nMes AS mes_operacion
              FROM      dbo.Tmp_P_Redondeo
                        LEFT JOIN dbo.p_Empleados_pres AS empleados ON Tmp_P_Redondeo.Codigo = Empleados.Codigo
                                                              AND Empleados.Empresa = Tmp_P_Redondeo.Empresa
                        LEFT JOIN dbo.p_Nomina_Tot AS nomina_tot ON Tmp_P_Redondeo.Codigo = Nomina_Tot.Codigo
                                                              AND Nomina_Tot.Empresa = Tmp_P_Redondeo.Empresa
                        LEFT JOIN ( SELECT  empresa ,
                                            Codigo ,
                                            MAX(Folio) AS Folio
                                    FROM    dbo.p_Kardex
                                    WHERE   Nomina = @cTipoNom
                                            AND id_presup = @id_presup
                                            AND ayo_operacion = @nAyo
                                            AND mes_operacion = @nMes
                                    GROUP BY empresa ,
                                            Codigo
                                  ) AS Folios ON Tmp_P_Redondeo.Codigo = Folios.Codigo
                                                 AND Tmp_P_Redondeo.empresa = Folios.empresa
              WHERE     Tmp_P_Redondeo.Redondeo <> 0
                        AND nomina_tot.id_presup = @id_presup
                        AND nomina_tot.ayo_operacion = @nAyo
                        AND nomina_tot.mes_operacion = @nMes
            )


    UPDATE  Nomina_Tot
    SET     Dedu_Exent = Nomina_Tot.Dedu_Exent
            + CASE WHEN Tmp_P_Redondeo.Num_Conc = 132
                   THEN Tmp_P_Redondeo.Redondeo
                   ELSE 0
              END ,
            Tot_Deducc = Nomina_Tot.Tot_Deducc
            + CASE WHEN Tmp_P_Redondeo.Num_Conc = 132
                   THEN Tmp_P_Redondeo.Redondeo
                   ELSE 0
              END ,
            Perc_Exento = Nomina_Tot.Perc_Exento
            + CASE WHEN Tmp_P_Redondeo.Num_Conc = 32
                   THEN ABS(Tmp_P_Redondeo.Redondeo)
                   ELSE 0
              END ,
            Tot_Percep = Nomina_Tot.Tot_Percep
            + CASE WHEN Tmp_P_Redondeo.Num_Conc = 32
                   THEN ABS(Tmp_P_Redondeo.Redondeo)
                   ELSE 0
              END ,
            Neto = Nomina_Tot.Neto
            - CASE WHEN Tmp_P_Redondeo.Num_Conc = 132
                   THEN Tmp_P_Redondeo.Redondeo
                   ELSE 0
              END
            + CASE WHEN Tmp_P_Redondeo.Num_Conc = 32
                   THEN ABS(Tmp_P_Redondeo.Redondeo)
                   ELSE 0
              END
    FROM    dbo.p_Nomina_Tot AS nomina_tot
            LEFT JOIN dbo.Tmp_P_Redondeo ON Nomina_Tot.Codigo = Tmp_P_Redondeo.Codigo
                                            AND Nomina_Tot.Empresa = Tmp_P_Redondeo.Empresa
    WHERE   Nomina_Tot.TipoNom = @nTipoNom
            AND nomina_tot.id_presup = @id_presup
            AND nomina_tot.ayo_operacion = @nAyo
            AND nomina_tot.mes_operacion = @nMes


    DROP TABLE dbo.Tmp_P_Redondeo



GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_RepartePercep')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_RepartePercep
GO


CREATE PROCEDURE dbo.asp_pres_RepartePercep
    @id_presup INT ,
    @mes INT ,
    @ayo INT,
    @tiponom int
AS

    DECLARE @Aini INT ,
        @Afin INT
    DECLARE @fch_ini DATETIME ,
        @fch_fin DATETIME

    DELETE  dbo.p_percepciones
    WHERE   id_presup = @id_presup
            AND mes = @mes
            AND ayo_operacion = @ayo
            AND tiponom = @tiponom

	

    SELECT  @Aini = ini_ejercicio ,
            @Afin = fin_ejercicio
    FROM    dbo.p_parametro
    WHERE   id_presup = @id_presup

    IF OBJECT_ID('dbo.tmp_cents') IS NOT NULL 
        DROP TABLE dbo.tmp_cents


    SELECT  z.centro ,
            z.num_conc ,
            ISNULL(( CASE WHEN @mes = 1
                               AND @ayo = @Aini THEN z.ene1
                          WHEN @mes = 2
                               AND @ayo = @Aini THEN z.feb1
                          WHEN @mes = 3
                               AND @ayo = @Aini THEN z.mar1
                          WHEN @mes = 4
                               AND @ayo = @Aini THEN z.abr1
                          WHEN @mes = 5
                               AND @ayo = @Aini THEN z.may1
                          WHEN @mes = 6
                               AND @ayo = @Aini THEN z.jun1
                          WHEN @mes = 7
                               AND @ayo = @Aini THEN z.jul1
                          WHEN @mes = 8
                               AND @ayo = @Aini THEN z.ago1
                          WHEN @mes = 9
                               AND @ayo = @Aini THEN z.sep1
                          WHEN @mes = 10
                               AND @ayo = @Aini THEN z.oct1
                          WHEN @mes = 11
                               AND @ayo = @Aini THEN z.nov1
                          WHEN @mes = 12
                               AND @ayo = @Aini THEN z.dic1
                          WHEN @mes = 1
                               AND @ayo = @Afin THEN z.ene2
                          WHEN @mes = 2
                               AND @ayo = @Afin THEN z.feb2
                          WHEN @mes = 3
                               AND @ayo = @Afin THEN z.mar2
                          WHEN @mes = 4
                               AND @ayo = @Afin THEN z.abr2
                          WHEN @mes = 5
                               AND @ayo = @Afin THEN z.may2
                          WHEN @mes = 6
                               AND @ayo = @Afin THEN z.jun2
                          WHEN @mes = 7
                               AND @ayo = @Afin THEN z.jul2
                          WHEN @mes = 8
                               AND @ayo = @Afin THEN z.ago2
                          WHEN @mes = 9
                               AND @ayo = @Afin THEN z.sep2
                          WHEN @mes = 10
                               AND @ayo = @Afin THEN z.oct2
                          WHEN @mes = 11
                               AND @ayo = @Afin THEN z.nov2
                          WHEN @mes = 12
                               AND @ayo = @Afin THEN z.dic2
                     END ), 0)
            / ISNULL(( SELECT   COUNT(DISTINCT ( a.codigo ))
                       FROM     dbo.p_empleados_pres AS a
                                INNER JOIN dbo.p_avisos_imss AS b ON a.empresa = b.empresa
                                                              AND a.codigo = b.codigo
                                                              AND a.id_presup = b.id_presup
                                                              AND ( b.mov = 'IM'
                                                              OR b.mov = 'A'
                                                              )
                                                              AND b.mes_operacion = @mes
                                                              AND b.ayo_operacion = @ayo
                                                              AND a.tiponom=@tiponom
                       WHERE    a.centro = z.centro
                                AND a.id_presup = z.id_presup
                     ), 0) AS importe ,
            ( SELECT    COUNT(DISTINCT ( a.codigo ))
              FROM      dbo.p_empleados_pres AS a
                        INNER JOIN dbo.p_avisos_imss AS b ON a.empresa = b.empresa
                                                             AND a.codigo = b.codigo
                                                             AND a.id_presup = b.id_presup
                                                             AND ( b.mov = 'IM'
                                                              OR b.mov = 'A'
                                                              )
                                                             AND b.mes_operacion = @mes
                                                             AND b.ayo_operacion = @ayo
                                                             AND a.tiponom=@tiponom
              WHERE     a.centro = z.centro
                        AND a.id_presup = z.id_presup
            ) AS emps ,
            ISNULL(( CASE WHEN @mes = 1
                               AND @ayo = @Aini THEN z.ene1
                          WHEN @mes = 2
                               AND @ayo = @Aini THEN z.feb1
                          WHEN @mes = 3
                               AND @ayo = @Aini THEN z.mar1
                          WHEN @mes = 4
                               AND @ayo = @Aini THEN z.abr1
                          WHEN @mes = 5
                               AND @ayo = @Aini THEN z.may1
                          WHEN @mes = 6
                               AND @ayo = @Aini THEN z.jun1
                          WHEN @mes = 7
                               AND @ayo = @Aini THEN z.jul1
                          WHEN @mes = 8
                               AND @ayo = @Aini THEN z.ago1
                          WHEN @mes = 9
                               AND @ayo = @Aini THEN z.sep1
                          WHEN @mes = 10
                               AND @ayo = @Aini THEN z.oct1
                          WHEN @mes = 11
                               AND @ayo = @Aini THEN z.nov1
                          WHEN @mes = 12
                               AND @ayo = @Aini THEN z.dic1
                          WHEN @mes = 1
                               AND @ayo = @Afin THEN z.ene2
                          WHEN @mes = 2
                               AND @ayo = @Afin THEN z.feb2
                          WHEN @mes = 3
                               AND @ayo = @Afin THEN z.mar2
                          WHEN @mes = 4
                               AND @ayo = @Afin THEN z.abr2
                          WHEN @mes = 5
                               AND @ayo = @Afin THEN z.may2
                          WHEN @mes = 6
                               AND @ayo = @Afin THEN z.jun2
                          WHEN @mes = 7
                               AND @ayo = @Afin THEN z.jul2
                          WHEN @mes = 8
                               AND @ayo = @Afin THEN z.ago2
                          WHEN @mes = 9
                               AND @ayo = @Afin THEN z.sep2
                          WHEN @mes = 10
                               AND @ayo = @Afin THEN z.oct2
                          WHEN @mes = 11
                               AND @ayo = @Afin THEN z.nov2
                          WHEN @mes = 12
                               AND @ayo = @Afin THEN z.dic2
                     END ), 0) AS impo ,
            @mes AS mes ,
            @ayo AS ayo
    INTO    dbo.tmp_cents
    FROM    dbo.p_pagos_variables_tiponom AS z
    WHERE   z.id_presup = @id_presup
			AND z.tiponom = @tiponom
            AND ISNULL(( CASE WHEN @mes = 1
                                   AND @ayo = @Aini THEN z.ene1
                              WHEN @mes = 2
                                   AND @ayo = @Aini THEN z.feb1
                              WHEN @mes = 3
                                   AND @ayo = @Aini THEN z.mar1
                              WHEN @mes = 4
                                   AND @ayo = @Aini THEN z.abr1
                              WHEN @mes = 5
                                   AND @ayo = @Aini THEN z.may1
                              WHEN @mes = 6
                                   AND @ayo = @Aini THEN z.jun1
                              WHEN @mes = 7
                                   AND @ayo = @Aini THEN z.jul1
                              WHEN @mes = 8
                                   AND @ayo = @Aini THEN z.ago1
                              WHEN @mes = 9
                                   AND @ayo = @Aini THEN z.sep1
                              WHEN @mes = 10
                                   AND @ayo = @Aini THEN z.oct1
                              WHEN @mes = 11
                                   AND @ayo = @Aini THEN z.nov1
                              WHEN @mes = 12
                                   AND @ayo = @Aini THEN z.dic1
                              WHEN @mes = 1
                                   AND @ayo = @Afin THEN z.ene2
                              WHEN @mes = 2
                                   AND @ayo = @Afin THEN z.feb2
                              WHEN @mes = 3
                                   AND @ayo = @Afin THEN z.mar2
                              WHEN @mes = 4
                                   AND @ayo = @Afin THEN z.abr2
                              WHEN @mes = 5
                                   AND @ayo = @Afin THEN z.may2
                              WHEN @mes = 6
                                   AND @ayo = @Afin THEN z.jun2
                              WHEN @mes = 7
                                   AND @ayo = @Afin THEN z.jul2
                              WHEN @mes = 8
                                   AND @ayo = @Afin THEN z.ago2
                              WHEN @mes = 9
                                   AND @ayo = @Afin THEN z.sep2
                              WHEN @mes = 10
                                   AND @ayo = @Afin THEN z.oct2
                              WHEN @mes = 11
                                   AND @ayo = @Afin THEN z.nov2
                              WHEN @mes = 12
                                   AND @ayo = @Afin THEN z.dic2
                         END ), 0) > 0
            AND ISNULL(( SELECT COUNT(DISTINCT ( a.codigo ))
                         FROM   dbo.p_empleados_pres AS a
                                INNER JOIN dbo.p_avisos_imss AS b ON a.empresa = b.empresa
                                                              AND a.id_presup = b.id_presup
                                                              AND a.codigo = b.codigo
                                                              AND ( b.mov = 'IM'
                                                              OR b.mov = 'A'
                                                              )
                                                              AND b.mes_operacion = @mes
                                                              AND b.ayo_operacion = @ayo
                                                              AND a.tiponom=@tiponom
                         WHERE  a.centro = z.centro
                                AND a.id_presup = z.id_presup
                       ), 0) > 0
ORDER BY    num_conc ,
            centro

    DELETE  dbo.tmp_cents
    WHERE   impo = 0
            AND mes = @mes
            AND ayo = @ayo

    INSERT  INTO dbo.p_percepciones
            ( id_presup ,
              empresa ,
              codigo ,
              num_conc ,
              nomina ,
              varia_imss ,
              fch_real ,
              tiponom ,
              horas_ex ,
              mes ,
              ayo_operacion ,
              siempre ,
              clase ,
              centro
            )
            SELECT  @id_presup AS id_presup ,
                    b.empresa ,
                    b.codigo ,
                    a.num_conc ,
                    a.importe AS nomina ,
                    0 AS varia ,
                    ( SELECT    inicio
                      FROM      dbo.p_dias
                      WHERE     id_presup = @id_presup
                                AND mes = @mes
                                AND ejercicio = @ayo
                                AND tiponom = b.tiponom
                    ) ,
                    b.tiponom ,
                    0 AS hrsext ,
                    @mes AS mes ,
                    @ayo AS ayo_operacion ,
                    'N' AS siempre ,
                    '' AS clase ,
                    '' AS centro
            FROM    dbo.tmp_cents AS a
                    INNER JOIN dbo.p_empleados_pres AS b ON a.centro = b.centro
                    INNER JOIN dbo.p_avisos_imss AS d ON b.id_presup = d.id_presup
                                                         AND b.empresa = d.empresa
                                                         AND b.codigo = d.codigo
                                                         AND ( d.mov = 'IM'
                                                              OR d.mov = 'A'
                                                             )
                                                         AND d.mes_operacion = @mes
                                                         AND d.ayo_operacion = @ayo
            WHERE   b.id_presup = @id_presup and b.tiponom=@tiponom
GROUP BY            b.empresa ,
                    b.codigo ,
                    a.num_conc ,
                    a.importe ,
                    a.centro ,
                    b.tiponom
            ORDER BY a.centro ,
                    a.num_conc ,
                    b.empresa ,
                    b.codigo


--drop table tmp_cents

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_pres_Retroactivos')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_pres_Retroactivos
GO

CREATE PROCEDURE dbo.asp_pres_Retroactivos
    @nTipoNom INT ,
    @dFi DATETIME ,
    @dFf DATETIME ,
    @id_presup INT
AS /*
Declare @nTipoNom Int
Declare @dFi      DateTime
Declare @dFf      DateTime
Declare @nEmpresa Int
*/
 
    DECLARE @nDiasAnteriores INT
    DECLARE @dInicio DATETIME
    DECLARE @dTermino DATETIME
    DECLARE @dPago DATETIME
    DECLARE @cTipoNom CHAR(3)
    DECLARE @nAyo INT
    DECLARE @nMes INT
    DECLARE @nDiasPer INT
    DECLARE @nConcepto INT

/*
Set @nTipoNom = 1
Set @dFi      = '20080601'
Set @dFf      = '20080630'
Set @nEmpresa = 1
*/

    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END

    SELECT  @dInicio = Periodos.Inicio ,
            @dTermino = Periodos.cierre ,
            @dPago = Periodos.Pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio) ,
            @nDiasPer = Periodos.Dias
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup

    SET @nDiasAnteriores = ( SELECT MAX(Hrs_Min3)
                             FROM   dbo.Conceptos
                             WHERE  Num_Conc = @nTipoNom
                             GROUP BY num_conc
                           )
--Set @dTermino = @dInicio - 1
    SET @nDiasAnteriores = 0
    SET @dInicio = @dInicio - @nDiasAnteriores

    IF OBJECT_ID('dbo.Tmp_p_Retroactivos') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Retroactivos

    IF OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Kardex

    IF OBJECT_ID('dbo.Tmp_p_Faltas') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Faltas


    IF @nDiasAnteriores > 0
        AND ( SELECT    COUNT(Num_Conc)
              FROM      dbo.Conceptos
              WHERE     ( Num_Conc = 7
                          OR Num_Conc = 107
                        )
                        AND Uso = 'S'
                        AND Captura = 'A'
            ) > 0 
        BEGIN

            SELECT  Tmp_Avisos_Imss.Codigo ,
                    Tmp_Avisos_Imss.Mov ,
                    CASE WHEN Tmp_Avisos_Imss.Fch_Mov < @dInicio THEN @dInicio
                         ELSE Tmp_Avisos_Imss.Fch_Mov
                    END AS 'Inicio' ,
                    CASE WHEN Tmp_Avisos_Imss.Fch_Mov + Tmp_Avisos_Imss.DiasTr
                              - CASE WHEN Tmp_Avisos_Imss.Mov <> 'B' THEN 01
                                     ELSE 0
                                END > @dTermino THEN @dTermino
                         ELSE Tmp_Avisos_Imss.Fch_Mov + Tmp_Avisos_Imss.DiasTr
                              - CASE WHEN Tmp_Avisos_Imss.Mov <> 'B' THEN 01
                                     ELSE 0
                                END
                    END AS 'Termino' ,
                    Tmp_Avisos_Imss.Sueldo ,
                    Tmp_Avisos_Imss.SalDiaInt ,
                    0 AS Dias ,
                    0 AS Vacaciones ,
                    0 AS Faltas ,
                    0 AS Permisos ,
                    0 AS Suspension ,
                    0 AS Tecnico ,
                    0 AS Incap_eg ,
                    0 AS Incap_mat ,
                    0 AS Incap_rt ,
                    Horarios_Catalogo.Dias_Sem ,
                    Horarios_Catalogo.Semana_Red ,
                    empleados.Horario ,
                    ( CASE WHEN Tmp_Avisos_Imss.mov = 'A' THEN 'A'
                           ELSE ''
                      END ) AS alta ,--Case When (Empleados.FchAlta >= @dInicio And Empleados.FchAlta <= @dTermino) Then 'A' Else '' End As Alta,
                    ( CASE WHEN Tmp_Avisos_Imss.mov = 'B' THEN 'B'
                           ELSE ''
                      END ) AS baja ,--Case When (Empleados.UltMov = 'B' And Empleados.UltFchMov >= @dInicio And Empleados.UltFchMov <= @dTermino) Then 'B' Else '' End As Baja,
                    empleados.empresa AS 'Empresa' ,
                    0 AS Folio ,
                    empleados.id_presup AS id_presup
            INTO    dbo.Tmp_p_Retroactivos
            FROM    dbo.p_empresas AS emps
                    INNER JOIN dbo.Tmp_p_Avisos_Imss AS Tmp_Avisos_Imss ON emps.empresa = Tmp_Avisos_Imss.empresa
                                                              AND emps.id_presup = Tmp_Avisos_Imss.id_presup
                    LEFT JOIN dbo.p_Empleados_pres AS empleados ON Tmp_Avisos_Imss.Codigo = Empleados.Codigo
                                                              AND Tmp_Avisos_Imss.Empresa = Empleados.Empresa
                    LEFT JOIN dbo.Horarios_Catalogo ON empleados.Horario = Horarios_Catalogo.Horario
                                                       AND empleados.Empresa = Horarios_Catalogo.Empresa
            WHERE   Empleados.id_presup = @id_presup
                    AND Empleados.Activo = 'S'
                    AND empleados.TipoNom = @nTipoNom
                    AND          --Tmp_Avisos_Imss.Fch_Mov+Tmp_Avisos_Imss.DiasTr - Case When Tmp_Avisos_Imss.Mov = 'B' Then 0 Else 1 End >= @dInicio And
                    Tmp_Avisos_Imss.Fch_Mov <= @dTermino
                    AND          --(Tmp_Avisos_Imss.DiasTr > 0 Or Tmp_Avisos_Imss.Mov = 'B') And  
                    Tmp_Avisos_Imss.Mes_Operacion >= MONTH(@dInicio)
                    AND Tmp_Avisos_Imss.Ayo_Operacion >= YEAR(@dInicio)
                    AND Tmp_Avisos_Imss.id_presup = @id_presup
            ORDER BY Tmp_Avisos_Imss.Codigo ,
                    Tmp_Avisos_Imss.Fch_Mov

            UPDATE  dbo.Tmp_p_Retroactivos
            SET     Dias = CASE WHEN Tmp_p_Retroactivos.Mov <> 'B'
                                THEN DATEDIFF(Day, Tmp_p_Retroactivos.Inicio,
                                              Tmp_p_Retroactivos.Termino) + 1
                                ELSE 0
                           END

            UPDATE  dbo.Tmp_p_Retroactivos
            SET     Dias = dbo.Fun_R_FactorSeptimoDia(Tmp_p_Retroactivos.Inicio,
                                                      Tmp_p_Retroactivos.Termino,
                                                      Tmp_p_Retroactivos.Dias,
                                                      Tmp_p_Retroactivos.Horario,
                                                      Tmp_p_Retroactivos.empresa,
                                                      'F')
            WHERE   Tmp_p_Retroactivos.Semana_Red = 'T'
                    OR Tmp_p_Retroactivos.Alta = 'A'
                    OR Tmp_p_Retroactivos.Baja = 'B'

    --

            IF ( SELECT COUNT(Num_Conc)
                 FROM   dbo.Conceptos
                 WHERE  Num_Conc = 7
                        AND Uso = 'S'
                        AND Captura = 'A'
               ) > 0 
                BEGIN

                    SELECT  Tmp_Retroactivos.Codigo ,
                            Tmp_Retroactivos.empresa ,
                            @cTipoNom AS Nomina ,
                            SPACE(14) AS Centro ,
                            7 AS Num_Conc ,
                            ' ' AS Clase ,
                            0 AS Folio ,
                            0 AS Renglon ,
                            @dInicio AS Fch_Inicio ,
                            @dTermino AS Fch_Cierre ,
                            @dPago AS Fch_Pago ,
                            Tmp_Retroactivos.Dias - ( Tmp_Retroactivos.Faltas
                                                      + Tmp_Retroactivos.Permisos
                                                      + Tmp_Retroactivos.Suspension
                                                      + Tmp_Retroactivos.Tecnico
                                                      + Tmp_Retroactivos.Incap_Eg
                                                      + Tmp_Retroactivos.Incap_Mat
                                                      + Tmp_Retroactivos.Incap_Rt ) AS Dias ,
                            0 AS Inc ,
                            0 AS Aus ,
                            Tmp_Retroactivos.Dias - ( Tmp_Retroactivos.Faltas
                                                      + Tmp_Retroactivos.Permisos
                                                      + Tmp_Retroactivos.Suspension
                                                      + Tmp_Retroactivos.Tecnico
                                                      + Tmp_Retroactivos.Incap_Eg
                                                      + Tmp_Retroactivos.Incap_Mat
                                                      + Tmp_Retroactivos.Incap_Rt ) AS DiasTr ,
                            Tmp_Retroactivos.Dias - ( Tmp_Retroactivos.Faltas
                                                      + Tmp_Retroactivos.Permisos
                                                      + Tmp_Retroactivos.Suspension
                                                      + Tmp_Retroactivos.Tecnico
                                                      + Tmp_Retroactivos.Incap_Eg
                                                      + Tmp_Retroactivos.Incap_Mat
                                                      + Tmp_Retroactivos.Incap_Rt ) AS Dias_Imss ,
                            'P' AS TPago_Desc ,
                            Conceptos.Concepto ,
                            0 AS VariaImss ,
                            0 AS Variable ,
                            Conceptos.Imss ,
                            Conceptos.Ispt ,
                            Conceptos.Ptu ,
                            Conceptos.Despensa ,
                            Conceptos.Mca_Agui ,
                            Conceptos.FdoAhorro ,
                            'A' AS Calculo ,
                            Tmp_Retroactivos.Sueldo AS Impor_Base ,
                            Tmp_Retroactivos.SalDiaInt ,
                            0 AS Tabulador ,
                            0 AS Unidades ,
                            0 AS Horas ,
                            'AJU' AS Tipo_Mov ,
                            0 AS Secuencia ,
                            ( Tmp_Retroactivos.Dias
                              - ( Tmp_Retroactivos.Faltas
                                  + Tmp_Retroactivos.Permisos
                                  + Tmp_Retroactivos.Suspension
                                  + Tmp_Retroactivos.Tecnico
                                  + Tmp_Retroactivos.Incap_Eg
                                  + Tmp_Retroactivos.Incap_Mat
                                  + Tmp_Retroactivos.Incap_Rt ) )
                            * Tmp_Retroactivos.Sueldo AS Importe ,
                            ( Tmp_Retroactivos.Dias
                              - ( Tmp_Retroactivos.Faltas
                                  + Tmp_Retroactivos.Permisos
                                  + Tmp_Retroactivos.Suspension
                                  + Tmp_Retroactivos.Tecnico
                                  + Tmp_Retroactivos.Incap_Eg
                                  + Tmp_Retroactivos.Incap_Mat
                                  + Tmp_Retroactivos.Incap_Rt ) )
                            * Tmp_Retroactivos.Sueldo AS IGravable ,
                            0 AS IExento ,
                            0 AS Credito ,
                            0 AS Descuento ,
                            0 AS Saldo ,
                            ' ' AS Referencia ,
                            'N' AS Siempre ,
                            ' ' AS Justificar ,
                            ' ' AS Septimo ,
                            'F' AS PrevSocial ,
                            0 AS Varia1 ,
                            0 AS Varia2 ,
                            0 AS Varia3 ,
                            0 AS Varia4 ,
                            ' ' AS Variable1 ,
                            ' ' AS Variable2 ,
                            ' ' AS Variable3 ,
                            ' ' AS Variable4 ,
                            'F' AS Masivo ,
                            Conceptos.Formula ,
                            Conceptos.Ispt_NG ,
                            Conceptos.Imss_NI ,
                            ' ' AS Marca ,
                            0 AS Serial ,
                            'F' AS Informativo ,
                            Tmp_Retroactivos.id_presup
                    INTO    dbo.Tmp_p_Kardex
                    FROM    dbo.Tmp_p_Retroactivos AS Tmp_Retroactivos
                            LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 7
                                                       AND Conceptos.Empresa = Tmp_Retroactivos.empresa
                            LEFT JOIN dbo.p_Empleados_pres AS empleados ON Tmp_Retroactivos.Codigo = Empleados.Codigo
                                                              AND Tmp_Retroactivos.Empresa = Empleados.Empresa
                    WHERE   empleados.id_presup = @id_presup
                            AND Tmp_Retroactivos.Dias
                            - ( Tmp_Retroactivos.Faltas
                                + Tmp_Retroactivos.Permisos
                                + Tmp_Retroactivos.Suspension
                                + Tmp_Retroactivos.Tecnico
                                + Tmp_Retroactivos.Incap_Eg
                                + Tmp_Retroactivos.Incap_Mat
                                + Tmp_Retroactivos.Incap_Rt ) > 0
                            AND Empleados.FchAlta >= @dInicio
                            AND Empleados.FchAlta <= @dTermino
                    ORDER BY Tmp_Retroactivos.Codigo

        --Exec asp_genera_folio @nEmpresa,0,'Tmp_Kardex','Folio',0,0
                    PRINT @nAyo

                    INSERT  INTO dbo.p_Kardex
                            ( Codigo ,
                              Empresa ,
                              Nomina ,
                              Centro ,
                              Num_Conc ,
                              Clase ,
                              Folio ,
                              Renglon ,
                              Fch_Inicio ,
                              Fch_Cierre ,
                              Fch_Pago ,
                              Dias ,
                              Inc ,
                              Aus ,
                              DiasTr ,
                              Dias_Imss ,
                              TPago_Desc ,
                              Concepto ,
                              VariaImss ,
                              Variable ,
                              Imss ,
                              Ispt ,
                              Ptu ,
                              Despensa ,
                              Mca_Agui ,
                              FdoAhorro ,
                              Calculo ,
                              Impor_Base ,
                              SalDiaInt ,
                              Tabulador ,
                              Unidades ,
                              Horas ,
                              Tipo_Mov ,
                              Secuencia ,
                              Importe ,
                              IGravable ,
                              IExento ,
                              Credito ,
                              Descuento ,
                              Saldo ,
                              Referencia ,
                              Siempre ,
                              Justificar ,
                              Septimo ,
                              PrevSocial ,
                              Varia1 ,
                              Varia2 ,
                              Varia3 ,
                              Varia4 ,
                              Variable1 ,
                              Variable2 ,
                              Variable3 ,
                              Variable4 ,
                              Masivo ,
                              Formula ,
                              Ispt_NG ,
                              Imss_NI ,
                              Marca ,
                              Serial ,
                              Informativo ,
                              id_presup ,
                              mes_operacion ,
                              ayo_operacion
                            )
                            ( SELECT    Codigo ,
                                        Empresa ,
                                        Nomina ,
                                        Centro ,
                                        Num_Conc ,
                                        Clase ,
                                        Folio ,
                                        Renglon ,
                                        Fch_Inicio ,
                                        Fch_Cierre ,
                                        Fch_Pago ,
                                        Dias ,
                                        Inc ,
                                        Aus ,
                                        DiasTr ,
                                        Dias_Imss ,
                                        TPago_Desc ,
                                        Concepto ,
                                        VariaImss ,
                                        Variable ,
                                        Imss ,
                                        Ispt ,
                                        Ptu ,
                                        Despensa ,
                                        Mca_Agui ,
                                        FdoAhorro ,
                                        Calculo ,
                                        Impor_Base ,
                                        SalDiaInt ,
                                        Tabulador ,
                                        Unidades ,
                                        Horas ,
                                        Tipo_Mov ,
                                        Secuencia ,
                                        Importe ,
                                        IGravable ,
                                        IExento ,
                                        Credito ,
                                        Descuento ,
                                        Saldo ,
                                        Referencia ,
                                        Siempre ,
                                        Justificar ,
                                        Septimo ,
                                        PrevSocial ,
                                        Varia1 ,
                                        Varia2 ,
                                        Varia3 ,
                                        Varia4 ,
                                        Variable1 ,
                                        Variable2 ,
                                        Variable3 ,
                                        Variable4 ,
                                        Masivo ,
                                        Formula ,
                                        Ispt_NG ,
                                        Imss_NI ,
                                        Marca ,
                                        Serial ,
                                        Informativo ,
                                        id_presup ,
                                        @nMes AS mes_operacion ,
                                        @nAyo AS ayo_operacion
                              FROM      dbo.Tmp_p_Kardex
                            )

                    DROP TABLE dbo.Tmp_p_Kardex

                END


            IF ( SELECT COUNT(Num_Conc)
                 FROM   dbo.Conceptos
                 WHERE  Num_Conc = 107
                        AND Uso = 'S'
                        AND Captura = 'A'
               ) > 0 
                BEGIN

                    SET @nConcepto = 1

                    WHILE @nConcepto <= 07 
                        BEGIN

                            SELECT  Tmp_Retroactivos.Codigo ,
                                    Tmp_Retroactivos.Empresa ,
                                    @cTipoNom AS Nomina ,
                                    SPACE(14) AS Centro ,
                                    107 AS Num_Conc ,
                                    ' ' AS Clase ,
                                    0 AS Folio ,
                                    0 AS Renglon ,
                                    @dInicio AS Fch_Inicio ,
                                    @dTermino AS Fch_Cierre ,
                                    @dPago AS Fch_Pago ,
                                    CASE @nConcepto
                                      WHEN 1 THEN Tmp_Retroactivos.Faltas
                                      WHEN 2 THEN Tmp_Retroactivos.Permisos
                                      WHEN 3 THEN Tmp_Retroactivos.Suspension
                                      WHEN 4 THEN Tmp_Retroactivos.Tecnico
                                      WHEN 5 THEN Tmp_Retroactivos.Incap_Eg
                                      WHEN 6 THEN Tmp_Retroactivos.Incap_Mat
                                      ELSE Tmp_Retroactivos.Incap_Rt
                                    END AS Dias ,
                                    0 AS Inc ,
                                    0 AS Aus ,
                                    CASE @nConcepto
                                      WHEN 1 THEN Tmp_Retroactivos.Faltas
                                      WHEN 2 THEN Tmp_Retroactivos.Permisos
                                      WHEN 3 THEN Tmp_Retroactivos.Suspension
                                      WHEN 4 THEN Tmp_Retroactivos.Tecnico
                                      WHEN 5 THEN Tmp_Retroactivos.Incap_Eg
                                      WHEN 6 THEN Tmp_Retroactivos.Incap_Mat
                                      ELSE Tmp_Retroactivos.Incap_Rt
                                    END AS DiasTr ,
                                    CASE @nConcepto
                                      WHEN 1 THEN Tmp_Retroactivos.Faltas
                                      WHEN 2 THEN Tmp_Retroactivos.Permisos
                                      WHEN 3 THEN Tmp_Retroactivos.Suspension
                                      WHEN 4 THEN Tmp_Retroactivos.Tecnico
                                      WHEN 5 THEN Tmp_Retroactivos.Incap_Eg
                                      WHEN 6 THEN Tmp_Retroactivos.Incap_Mat
                                      ELSE Tmp_Retroactivos.Incap_Rt
                                    END AS Dias_Imss ,
                                    'D' AS TPago_Desc ,
                                    Conceptos.Concepto ,
                                    0 AS VariaImss ,
                                    0 AS Variable ,
                                    Conceptos.Imss ,
                                    Conceptos.Ispt ,
                                    Conceptos.Ptu ,
                                    Conceptos.Despensa ,
                                    Conceptos.Mca_Agui ,
                                    Conceptos.FdoAhorro ,
                                    'A' AS Calculo ,
                                    Tmp_Retroactivos.Sueldo AS Impor_Base ,
                                    Tmp_Retroactivos.SalDiaInt ,
                                    0 AS Tabulador ,
                                    0 AS Unidades ,
                                    0 AS Horas ,
                                    'AJU' AS Tipo_Mov ,
                                    0 AS Secuencia ,
                                    CASE @nConcepto
                                      WHEN 1 THEN Tmp_Retroactivos.Faltas
                                      WHEN 2 THEN Tmp_Retroactivos.Permisos
                                      WHEN 3 THEN Tmp_Retroactivos.Suspension
                                      WHEN 4 THEN Tmp_Retroactivos.Tecnico
                                      WHEN 5 THEN Tmp_Retroactivos.Incap_Eg
                                      WHEN 6 THEN Tmp_Retroactivos.Incap_Mat
                                      ELSE Tmp_Retroactivos.Incap_Rt
                                    END * Tmp_Retroactivos.Sueldo AS Importe ,
                                    CASE @nConcepto
                                      WHEN 1 THEN Tmp_Retroactivos.Faltas
                                      WHEN 2 THEN Tmp_Retroactivos.Permisos
                                      WHEN 3 THEN Tmp_Retroactivos.Suspension
                                      WHEN 4 THEN Tmp_Retroactivos.Tecnico
                                      WHEN 5 THEN Tmp_Retroactivos.Incap_Eg
                                      WHEN 6 THEN Tmp_Retroactivos.Incap_Mat
                                      ELSE Tmp_Retroactivos.Incap_Rt
                                    END * Tmp_Retroactivos.Sueldo AS IGravable ,
                                    0 AS IExento ,
                                    0 AS Credito ,
                                    0 AS Descuento ,
                                    0 AS Saldo ,
                                    ' ' AS Referencia ,
                                    'N' AS Siempre ,
                                    ' ' AS Justificar ,
                                    ' ' AS Septimo ,
                                    'F' AS PrevSocial ,
                                    0 AS Varia1 ,
                                    0 AS Varia2 ,
                                    0 AS Varia3 ,
                                    0 AS Varia4 ,
                                    ' ' AS Variable1 ,
                                    ' ' AS Variable2 ,
                                    ' ' AS Variable3 ,
                                    ' ' AS Variable4 ,
                                    'F' AS Masivo ,
                                    Conceptos.Formula ,
                                    Conceptos.Ispt_NG ,
                                    Conceptos.Imss_NI ,
                                    ' ' AS Marca ,
                                    0 AS Serial ,
                                    'F' AS Informativo ,
                                    Tmp_Retroactivos.id_presup
                            INTO    dbo.Tmp_p_Kardex
                            FROM    dbo.Tmp_p_Retroactivos AS Tmp_Retroactivos
                                    LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = 107
                                                              AND Conceptos.Empresa = Tmp_Retroactivos.empresa
                                    LEFT JOIN dbo.p_Empleados_pres AS empleados ON Tmp_Retroactivos.Codigo = Empleados.Codigo
                                                              AND Tmp_Retroactivos.Empresa = Empleados.Empresa
                            WHERE   CASE @nConcepto
                                      WHEN 1 THEN Tmp_Retroactivos.Faltas
                                      WHEN 2 THEN Tmp_Retroactivos.Permisos
                                      WHEN 3 THEN Tmp_Retroactivos.Suspension
                                      WHEN 4 THEN Tmp_Retroactivos.Tecnico
                                      WHEN 5 THEN Tmp_Retroactivos.Incap_Eg
                                      WHEN 6 THEN Tmp_Retroactivos.Incap_Mat
                                      ELSE Tmp_Retroactivos.Incap_Rt
                                    END > 0
                                    AND empleados.id_presup = @id_presup
                            ORDER BY Tmp_Retroactivos.Codigo

          --Exec asp_genera_folio @nEmpresa,0,'Tmp_Kardex','Folio',0,0

                            INSERT  INTO dbo.p_Kardex
                                    ( Codigo ,
                                      Empresa ,
                                      Nomina ,
                                      Centro ,
                                      Num_Conc ,
                                      Clase ,
                                      Folio ,
                                      Renglon ,
                                      Fch_Inicio ,
                                      Fch_Cierre ,
                                      Fch_Pago ,
                                      Dias ,
                                      Inc ,
                                      Aus ,
                                      DiasTr ,
                                      Dias_Imss ,
                                      TPago_Desc ,
                                      Concepto ,
                                      VariaImss ,
                                      Variable ,
                                      Imss ,
                                      Ispt ,
                                      Ptu ,
                                      Despensa ,
                                      Mca_Agui ,
                                      FdoAhorro ,
                                      Calculo ,
                                      Impor_Base ,
                                      SalDiaInt ,
                                      Tabulador ,
                                      Unidades ,
                                      Horas ,
                                      Tipo_Mov ,
                                      Secuencia ,
                                      Importe ,
                                      IGravable ,
                                      IExento ,
                                      Credito ,
                                      Descuento ,
                                      Saldo ,
                                      Referencia ,
                                      Siempre ,
                                      Justificar ,
                                      Septimo ,
                                      PrevSocial ,
                                      Varia1 ,
                                      Varia2 ,
                                      Varia3 ,
                                      Varia4 ,
                                      Variable1 ,
                                      Variable2 ,
                                      Variable3 ,
                                      Variable4 ,
                                      Masivo ,
                                      Formula ,
                                      Ispt_NG ,
                                      Imss_NI ,
                                      Marca ,
                                      Serial ,
                                      Informativo ,
                                      id_presup ,
                                      ayo_operacion ,
                                      mes_operacion
                                    )
                                    ( SELECT    Codigo ,
                                                Empresa ,
                                                Nomina ,
                                                Centro ,
                                                Num_Conc ,
                                                Clase ,
                                                Folio ,
                                                Renglon ,
                                                Fch_Inicio ,
                                                Fch_Cierre ,
                                                Fch_Pago ,
                                                Dias ,
                                                Inc ,
                                                Aus ,
                                                DiasTr ,
                                                Dias_Imss ,
                                                TPago_Desc ,
                                                Concepto ,
                                                VariaImss ,
                                                Variable ,
                                                Imss ,
                                                Ispt ,
                                                Ptu ,
                                                Despensa ,
                                                Mca_Agui ,
                                                FdoAhorro ,
                                                Calculo ,
                                                Impor_Base ,
                                                SalDiaInt ,
                                                Tabulador ,
                                                Unidades ,
                                                Horas ,
                                                Tipo_Mov ,
                                                Secuencia ,
                                                Importe ,
                                                IGravable ,
                                                IExento ,
                                                Credito ,
                                                Descuento ,
                                                Saldo ,
                                                Referencia ,
                                                Siempre ,
                                                Justificar ,
                                                Septimo ,
                                                PrevSocial ,
                                                Varia1 ,
                                                Varia2 ,
                                                Varia3 ,
                                                Varia4 ,
                                                Variable1 ,
                                                Variable2 ,
                                                Variable3 ,
                                                Variable4 ,
                                                Masivo ,
                                                Formula ,
                                                Ispt_NG ,
                                                Imss_NI ,
                                                Marca ,
                                                Serial ,
                                                Informativo ,
                                                id_presup ,
                                                @nAyo ,
                                                @nMes
                                      FROM      dbo.Tmp_p_Kardex
                                    )

                            DROP TABLE dbo.Tmp_p_Kardex

                            SET @nConcepto = @nConcepto + 1

                        END
        
                END


            DROP TABLE dbo.Tmp_p_Retroactivos
    --Drop Table dbo.Tmp_Faltas

        END


--Drop Table Tmp_Avisos_Imss


GO

IF OBJECT_ID('dbo.Tmp_p_Avisos_Imss2') IS NOT NULL 
begin 
	DROP TABLE dbo.Tmp_p_Avisos_Imss2
end 

GO


IF OBJECT_ID('dbo.Tmp_p_Avisos_Imss') IS NOT NULL 
begin
	DROP TABLE dbo.Tmp_p_Avisos_Imss
end
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_Fun_pres_Sueldo')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
begin
    DROP PROCEDURE dbo.asp_Fun_pres_Sueldo
end

GO

CREATE PROCEDURE dbo.asp_Fun_pres_Sueldo
    @nTipoNom INT ,
    @dFi DATETIME ,
    @dFf DATETIME ,
    @nSalDF DECIMAL(10, 2) ,
    @cCalculaSDI CHAR(1) ,
    @id_presup INT
AS 
    DECLARE @cTipoNom CHAR(3)
    DECLARE @dInicio DATETIME
    DECLARE @dTermino DATETIME
    DECLARE @dPago DATETIME
    DECLARE @nMes INT
    DECLARE @nAyo INT
    DECLARE @nDiasper DECIMAL(6, 2)
    DECLARE @nDiasdif DECIMAL(6, 2)
    DECLARE @nAyo3 INT
    DECLARE @mes_op INT 
    DECLARE @ayo_op INT 

    

    DECLARE @nMes1 INT
    DECLARE @nMes2 INT
    DECLARE @dMesAnterior DATETIME
    DECLARE @dFinMes DATETIME
    DECLARE @nMes3 INT
    DECLARE @dFinMesNext DATETIME


    SET DateFirst 1

	SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END

    EXEC dbo.UPDATE_presup_dias @id_presup
	
    SELECT  @dInicio = Periodos.Inicio ,
            @dTermino = Periodos.Inicio + Periodos.Dias ,
            @dPago = Periodos.Pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio) ,
            @nDiasPer = Periodos.Dias
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup
	
    SET @mes_op = @nMes
    SET @ayo_op = @nAyo

    SET @nAyo = YEAR(@dFi)
    SET @nMes1 = MONTH(@dFi) - 1
    SET @nMes2 = MONTH(@dFi)
    SET @nMes3 = MONTH(@dFi + 1)
    SET @nAyo3 = YEAR(@dFi + 1)

    SET @dFinMesNext = Dbo.Fin_Mes(@nMes3, @nAyo3)

    IF OBJECT_ID('dbo.TMP_P_PROVISIONES') IS NOT NULL 
        DROP TABLE dbo.TMP_P_PROVISIONES

    IF OBJECT_ID('dbo.p_conc_tmp') IS NOT NULL 
        DROP TABLE dbo.p_conc_tmp


    IF @nDiasPer > DATEDIFF(Day, @dInicio, @dTermino) - 1 --Round(@nDiasPer,0)
        SET @nDiasDif = @nDiasPer - DATEDIFF(Day, @dInicio, @dTermino) - 1 --Round(@nDiasPer,0)
    ELSE 
        SET @nDiasDif = 0

    SET @dMesAnterior = @dFi - 1

    SET @dFinMes = CASE WHEN @dTermino > @dFF THEN @dTermino
                        ELSE @dFf
                   END

-- Inicializar las tablas antes de calcular
    IF ( SELECT COUNT(Num_Conc)
         FROM   dbo.Conceptos
         WHERE  Num_Conc = 31
                AND Uso = 'S'
                AND Marca1 = 'O'
                AND Captura = 'A'
       ) > 0 
        BEGIN

            UPDATE  a
            SET     Dias = 0 ,
                    Aus = 0 ,
                    Inc = 0 ,
                    Comision = 0 ,
                    Total = 0 ,
                    Gravable = 0 ,
                    Exento = 0 ,
                    Excedente = 0 ,
                    Excede = 0 ,
                    Redondeo = 0 ,
                    Neto = 0 ,
                    Ispt = 0
            FROM    dbo.p_empresas AS emps
                    INNER JOIN dbo.p_Despensas AS a ON emps.empresa = a.empresa
                                                       AND emps.id_presup = a.id_presup
                    INNER JOIN dbo.p_empleados_pres AS b ON a.Codigo = b.codigo
                                                            AND a.Empresa = b.Empresa
                                                            AND a.id_presup = b.id_presup
            WHERE   b.TipoNom = @nTipoNom
                    AND a.Marca = 'T'
                    AND a.id_presup = @id_presup
        END

    DELETE  dbo.p_Kardex
    WHERE   Nomina = @cTipoNom
            AND mes_operacion = @nMes
            AND ayo_operacion = @nAyo
            AND id_presup = @id_presup

    DELETE  dbo.p_Nomina_Tot
    WHERE   TipoNom = @nTipoNom
            AND mes_operacion = @nMes
            AND ayo_operacion = @nAyo
            AND id_presup = @id_presup

    DELETE  dbo.p_PolDisk
    WHERE   TipoNom = @nTipoNom
            AND mes_operacion = @nMes
            AND ayo_operacion = @nAyo
            AND id_presup = @id_presup


    DELETE  dbo.p_Polizas
    WHERE   TipoNom = @nTipoNom
            AND mes_operacion = @nMes
            AND ayo_operacion = @nAyo
            AND id_presup = @id_presup

-- Depurar los registros que tienen en llaves el Tipo de nomina a calcular
-- por si algun empleado cambio de tipo de nomina

-- Insertar MS del primer dia del bimestre si la nomina tiene dias de dos meses o la nomina es del siguiente y no ha aplicado variables
    IF OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Kardex

    IF OBJECT_ID('dbo.Tmp_p_Faltas') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Faltas

    IF OBJECT_ID('dbo.Tmp_p_Avisos_Imss') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Avisos_Imss

    IF OBJECT_ID('dbo.Tmp_p_Avisos_Imss2') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Avisos_Imss2

    IF OBJECT_ID('dbo.Tmp_p_Sueldos') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Sueldos

    CREATE TABLE [dbo].[Tmp_p_Avisos_Imss2]
        (
          [Empresa] [int] NOT NULL ,
          [id_presup] [numeric](8, 0) NOT NULL ,
          [Codigo] [numeric](8, 0) NOT NULL ,
          [Serial] [int] NOT NULL ,
          [Mes_Operacion] [int] NOT NULL ,
          [Ayo_Operacion] [int] NOT NULL ,
          [Fch_Mov] [datetime] NOT NULL ,
          [Fch_Real] [datetime] NULL ,
          [Mov] [varchar](2) NOT NULL ,
          [SalDiaInt] [numeric](12, 2) NOT NULL ,
          [SalDiaIV] [numeric](12, 2) NOT NULL ,
          [Sueldo] [numeric](12, 2) NOT NULL ,
          [DiasTr] [numeric](6, 2) NOT NULL ,
          [Incap] [int] NOT NULL ,
          [Ausen] [int] NULL,
		  [NaturalesImss] [varchar](1) NULL,
		  [DiasNaturales] [int] NOT NULL
            CONSTRAINT PK6888_2
            PRIMARY KEY NONCLUSTERED
            ( Codigo, empresa, id_presup, mes_operacion, ayo_operacion, mov, serial )
        ) 

-- Insertar movimientos en orden
-- 1. Avisos del mes en proceso
-- 2. Mvto. de IM con fecha del 1er. dia del sig. mes (desde aqui, validar que el empleado no sea baja del mes)
-- 3. MS por variables
-- 4. Mvtos. del siguiente mes
-- select * from p_avisos_imss where fch_mov='20090101'
-- 1. Avisos del mes en proceso
	
    INSERT  INTO dbo.Tmp_p_Avisos_Imss2
            ( Empresa ,
              Codigo ,
              Serial ,
              Mes_Operacion ,
              Ayo_Operacion ,
              Fch_Mov ,
              Fch_Real ,
              Mov ,
              SalDiaInt ,
              SalDiaIV ,
              Sueldo ,
              DiasTr ,
              Incap ,
              Ausen ,
              id_presup,
			  NaturalesImss,
			  DiasNaturales
            )
            SELECT  Avisos_Imss.Empresa ,
                    Avisos_Imss.Codigo ,
                    Serial + 3 ,
                    Avisos_Imss.Mes_Operacion ,
                    Avisos_Imss.Ayo_Operacion ,
                    Avisos_Imss.Fch_Mov ,
                    Avisos_Imss.Fch_Real ,
                    Avisos_Imss.Mov ,
                    Avisos_Imss.SalDiaInt ,
                    ISNULL(Avisos_Imss.SalDiaIV, 0) ,
                    Avisos_Imss.Sueldo ,
                    ISNULL(Avisos_Imss.DiasTr,0),
                    ISNULL(Avisos_Imss.Incap, 0) ,
                    ISNULL(Avisos_Imss.Ausen, 0) ,
                    @id_presup AS id_presup,
					isnull(par.NaturalesImss,'F') as NaturalesImss,
					(DATEDIFF(day, rtrim(ltrim(str(@ayo_op))) + dbo.padl(@mes_op,'',2,'0')+ '01', DATEADD(mm, DATEDIFF(m,0,rtrim(ltrim(str(@ayo_op))) + dbo.padl(@mes_op,'',2,'0')+ '01')+1,0)-1) + 1) as diasNaturales
            FROM    dbo.p_empresas AS emps
					left join dbo.P_parametro as par on par.id_Presup=@id_presup
                    INNER JOIN dbo.p_Avisos_Imss AS Avisos_Imss ON emps.empresa = Avisos_Imss.empresa
                                                              AND emps.id_presup = Avisos_Imss.id_presup
                    LEFT JOIN dbo.p_empleados_pres AS Llaves ON Llaves.Codigo = Avisos_Imss.Codigo
                                                              AND Llaves.Empresa = Avisos_Imss.Empresa
                                                              AND Llaves.id_presup = Avisos_Imss.id_presup
                                                              AND Llaves.TipoNom = @nTipoNom
            WHERE   Avisos_Imss.Mes_Operacion = @nMes
                    AND Avisos_Imss.Ayo_Operacion = @nAyo
                    AND llaves.id_presup = @id_presup
            ORDER BY Avisos_Imss.Codigo ,
                    Avisos_Imss.Fch_Mov ,
                    Avisos_Imss.Serial
    
	
    SELECT  *
    INTO    dbo.Tmp_p_Avisos_Imss
    FROM    dbo.Tmp_p_Avisos_Imss2
    WHERE   id_presup = @id_presup
    ORDER BY Codigo ,
            Fch_Mov ,
            Serial
	
    EXEC dbo.asp_pres_ds_2 0, @nAyo, @nMes, /*@dTermino*/ @dFinMes, @id_presup 
	
-- Checar movimientos del periodo
    SELECT  Tmp_Avisos_Imss.Codigo ,
            Tmp_Avisos_Imss.Mov ,
            CASE WHEN Tmp_Avisos_Imss.Fch_Mov < @dInicio THEN @dInicio
                 ELSE Tmp_Avisos_Imss.Fch_Mov
            END AS Inicio ,
            CASE WHEN Tmp_Avisos_Imss.Fch_Mov + Tmp_Avisos_Imss.DiasTr
                      - CASE WHEN Tmp_Avisos_Imss.Mov <> 'B' THEN 01
                             ELSE 0
                        END > @dTermino THEN @dTermino
                 ELSE Tmp_Avisos_Imss.Fch_Mov + Tmp_Avisos_Imss.DiasTr
                      - CASE WHEN Tmp_Avisos_Imss.Mov <> 'B' THEN 01
                             ELSE 0
                        END
            END AS Termino ,
            Tmp_Avisos_Imss.Sueldo ,
            Tmp_Avisos_Imss.SalDiaInt ,
            --CONVERT(NUMERIC(8, 4), Tmp_Avisos_Imss.DiasTr) AS Dias ,
            CASE WHEN Tmp_Avisos_Imss.mov = 'MS' THEN  case when Tmp_Avisos_Imss.DiasTr>=@nDiasPer then @nDiasPer 
															else Tmp_Avisos_Imss.diastr -abs( cast((ISNULL(@nDiasPer, 0) - ISNULL((SELECT SUM(ISNULL(a.diastr,0)) 
																					 FROM Tmp_p_Avisos_Imss AS a 
																					 WHERE a.empresa = Tmp_Avisos_Imss.empresa AND a.codigo = Tmp_Avisos_Imss.codigo AND a.id_presup=@id_presup  AND a.Mes_Operacion = @nMes
																					    	AND a.Ayo_Operacion = @nAyo),0)  ) as numeric(10,2)) )
																
																end

			ELSE case when ISNULL(Tmp_Avisos_Imss.diastr, 0)>@nDiasPer then @nDiasPer else ISNULL(Tmp_Avisos_Imss.diastr, 0)end END AS Dias,
			ISNULL((SELECT SUM(ISNULL(@nDiasPer,0)) 
			  FROM Tmp_p_Avisos_Imss AS a WHERE a.empresa = Tmp_Avisos_Imss.empresa AND a.id_presup=@id_presup  AND a.Mes_Operacion = @nMes
					AND a.Ayo_Operacion = @nAyo AND a.mov='MS'),0)  as dd,
            CASE WHEN Tmp_Avisos_Imss.mov = 'MS' THEN  case when Tmp_Avisos_Imss.DiasTr>=case when NaturalesImss='T' then DiasNaturales else @nDiasPer end then case when NaturalesImss='T' then DiasNaturales else @nDiasPer end - ISNULL((SELECT SUM(ISNULL(a.diastr,0)) 
																					 FROM Tmp_p_Avisos_Imss AS a 
																					 WHERE a.empresa = Tmp_Avisos_Imss.empresa AND a.codigo = Tmp_Avisos_Imss.codigo AND a.id_presup=@id_presup  AND a.Mes_Operacion = @nMes
																					    	AND a.Ayo_Operacion = @nAyo and a.Mov='IM'),0)
															else Tmp_Avisos_Imss.diastr - abs( cast((ISNULL(case when NaturalesImss='T' then DiasNaturales else @nDiasPer end, 0) - ISNULL((SELECT SUM(ISNULL(a.diastr,0)) 
																					 FROM Tmp_p_Avisos_Imss AS a 
																					 WHERE a.empresa = Tmp_Avisos_Imss.empresa AND a.codigo = Tmp_Avisos_Imss.codigo AND a.id_presup=@id_presup  AND a.Mes_Operacion = @nMes
																					    	AND a.Ayo_Operacion = @nAyo),0)  ) as numeric(10,2)) )
																
																end

			ELSE case when ISNULL(Tmp_Avisos_Imss.diastr, 0)>case when NaturalesImss='T' then DiasNaturales else case when NaturalesImss='T' then DiasNaturales else @nDiasPer end end then case when NaturalesImss='T' then DiasNaturales else @nDiasPer end else ISNULL(Tmp_Avisos_Imss.diastr, 0)end END AS Dias_Imss,
			--case when isnull((select NaturalesImss 
			--                  from P_parametro 
			--				  where id_presup=@id_presup),'F')='F' 
			--	  then @nDiasper else (DATEDIFF(day, rtrim(ltrim(str(@ayo_op))) + dbo.padl(@mes_op,'',2,'0')+ '01', EOMONTH ( rtrim(ltrim(str(@ayo_op))) + dbo.padl(@mes_op,'',2,'0')+ '01' )) + 1) end AS Dias_Imss ,
            
			
			Tmp_Avisos_Imss.Mes_Operacion ,
            Tmp_Avisos_Imss.Ayo_Operacion ,
            0 AS Vacaciones ,
            0 AS Faltas ,
            0 AS Incap_eg ,
            0 AS Incap_mat ,
            0 AS Incap_rt ,
            0 AS ConNomina ,
            Horarios_Catalogo.Dias_Sem ,
            Horarios_Catalogo.Semana_Red ,
            empleados.Horario ,
            ' ' AS Alta ,
            ' ' AS Baja ,
            ' ' AS Ri ,
            Tmp_Avisos_Imss.empresa AS 'Empresa' ,
            CONVERT(NUMERIC(10, 2), 0) AS Descuento ,
            CONVERT(NUMERIC(10, 2), 0) AS Tabulador ,
            Tmp_Avisos_Imss.serial AS Folio ,
            ' ' AS Elimina,Convert(Numeric(6,2),0) As F108,
		   Convert(Numeric(6,2),0) As P108,
		   Convert(Numeric(6,2),0) As S108,
		   Convert(Numeric(6,2),0) As T108,
		   'S' As RestaVacaciones
    INTO    dbo.Tmp_p_Kardex
    FROM    dbo.Tmp_p_Avisos_Imss AS Tmp_Avisos_Imss
            INNER  JOIN dbo.p_Empleados_pres AS Empleados ON Tmp_Avisos_Imss.id_presup = Empleados.id_presup
                                                             AND Tmp_Avisos_Imss.Codigo = Empleados.Codigo
                                                             AND Tmp_Avisos_Imss.Empresa = Empleados.Empresa
                                                             AND Empleados.Activo = 'S'
                                                             AND Empleados.TipoNom = @nTipoNom
															 and empleados.id_presup=@id_presup
            LEFT JOIN dbo.Horarios_Catalogo ON Empleados.Horario = Horarios_Catalogo.Horario
                                               AND Empleados.Empresa = Horarios_Catalogo.Empresa
    WHERE   ( Tmp_Avisos_Imss.Mes_Operacion = @nMes-->= MONTH(@dInici--o)
              AND Tmp_Avisos_Imss.Ayo_Operacion = @nAyo-->= YEAR(@dInicio)
            )
            AND --or 
            Tmp_Avisos_Imss.id_presup = @id_presup
    ORDER BY Tmp_Avisos_Imss.Codigo ,
            'Inicio'
	--SELECT * FROM dbo.Tmp_p_Kardex WHERE codigo=90000000
	
	--update Tmp_p_Kardex set Dias_Imss=case when Dias<@nDiasper then dias else Dias_Imss end

-- Checar si tiene vacaciones y cuantos dias del periodo para no calcular sueldo sobre esos dias
    UPDATE  Tmp_p_Kardex
    SET     Vacaciones = CASE WHEN Vacaciones.Disfrute >= Tmp_p_Kardex.Inicio
                                   AND Vacaciones.Fin_Disfru <= Tmp_p_Kardex.Termino
                              THEN DATEDIFF(Day, Vacaciones.Disfrute,
                                            Vacaciones.Fin_Disfru) + 1
                              WHEN Vacaciones.Disfrute < Tmp_p_Kardex.Inicio
                                   AND Vacaciones.Fin_Disfru >= Tmp_p_Kardex.Inicio
                                   AND Vacaciones.Fin_Disfru <= Tmp_p_Kardex.Termino
                              THEN DATEDIFF(Day, Tmp_p_Kardex.Inicio,
                                            Vacaciones.Fin_Disfru) + 1
                              WHEN Vacaciones.Disfrute < Tmp_p_Kardex.Inicio
                                   AND Vacaciones.Fin_Disfru > Tmp_p_Kardex.Termino
                              THEN DATEDIFF(Day, Tmp_p_Kardex.Inicio,
                                            Tmp_p_Kardex.Termino) + 1
                              WHEN Vacaciones.Disfrute >= Tmp_p_Kardex.Inicio
                                   AND Vacaciones.Fin_Disfru > Tmp_p_Kardex.Termino
                              THEN DATEDIFF(Day, Vacaciones.Disfrute,
                                            Tmp_p_Kardex.Termino) + 1
                         END
    FROM    dbo.Tmp_p_Kardex
            INNER JOIN dbo.Vacaciones ON Tmp_p_Kardex.Codigo = Vacaciones.Codigo
                                         AND Tmp_p_Kardex.Empresa = Vacaciones.Empresa
    WHERE   ( ( Vacaciones.Disfrute >= Tmp_p_Kardex.Inicio
                AND Vacaciones.Disfrute <= Tmp_p_Kardex.Termino
              )
              OR ( Vacaciones.Disfrute < Tmp_p_Kardex.Inicio
                   AND Vacaciones.Fin_Disfru >= Tmp_p_Kardex.Inicio
                   AND Vacaciones.Fin_Disfru <= Tmp_p_Kardex.Termino
                 )
              OR ( Vacaciones.Disfrute >= Tmp_p_Kardex.Inicio
                   AND Vacaciones.Disfrute <= Tmp_p_Kardex.Termino
                   AND Vacaciones.Fin_Disfru >= Tmp_p_Kardex.Termino
                 )
            )
            AND Vacaciones.Salio = 'T'

	
    UPDATE  Tmp_p_Kardex--select * from Tmp_p_Kardex
    SET     Dias = CONVERT(NUMERIC(8, 4), dbo.Fun_R_FactorSeptimoDia(Tmp_Kardex.Inicio,
                                                              Tmp_Kardex.Inicio
                                                              + ( Tmp_Kardex.Dias
                                                              + CASE
                                                              WHEN Tmp_Kardex.Alta = 'A'
                                                              AND Empleados.FchAlta > @dInicio
                                                              AND @nDiasDif < 0
                                                              THEN @nDiasDif
                                                              ELSE 0
                                                              END ) - 1,
                                                              Tmp_Kardex.Dias
                                                              + ( CASE
                                                              WHEN Tmp_Kardex.Alta = 'A'
                                                              AND Empleados.FchAlta > @dInicio
                                                              AND @nDiasDif < 0
                                                              THEN @nDiasDif
                                                              ELSE 0
                                                              END ),
                                                              Tmp_Kardex.Horario,
                                                              Tmp_Kardex.empresa,
                                                              'DS'))
            + CASE WHEN Tmp_Kardex.Alta = 'A'
                        AND Empleados.FchAlta > @dInicio
                        AND @nDiasDif < 0 THEN ABS(@nDiasDif)
                   ELSE 0
              END
    FROM    dbo.Tmp_p_Kardex AS Tmp_Kardex
            LEFT JOIN dbo.p_Empleados_pres AS Empleados ON Empleados.Codigo = Tmp_Kardex.Codigo
    WHERE   Empleados.id_presup = @id_presup
            AND ( Tmp_Kardex.Semana_Red = 'S'
                  OR ( Tmp_Kardex.Alta = 'A'
                       AND Empleados.FchAlta > @dInicio
                     )
                  OR ISNULL(Tmp_Kardex.Ri, '') = 'RI'
                  OR ( Tmp_Kardex.Baja = 'B'
                       AND Tmp_Kardex.Mov <> 'B'
                       AND ISNULL(( SELECT  MAX(Fch_Mov)
                                    FROM    dbo.Avisos_Imss
                                    WHERE   Codigo = Tmp_Kardex.Codigo
                                            AND id_presup = @id_presup
                                            AND Avisos_Imss.Mov = 'B'
                                  ), @dTermino) < @dTermino
                     )
                )


    UPDATE  dbo.Tmp_p_Kardex
    SET     Faltas = CONVERT(NUMERIC(6, 2), dbo.Fun_R_Ausencias(Tmp_p_Kardex.Codigo,
                                                              Tmp_p_Kardex.Inicio,
                                                              Tmp_p_Kardex.Termino,
                                                              Tmp_p_Kardex.Horario,
                                                              'A',
                                                              Tmp_p_Kardex.empresa)) ,
            Descuento = CONVERT(NUMERIC(10, 2), dbo.Fun_R_Ausencias(Tmp_p_Kardex.Codigo,
                                                              Tmp_p_Kardex.Inicio,
                                                              Tmp_p_Kardex.Termino,
                                                              Tmp_p_Kardex.Horario,
                                                              'F',
                                                              Tmp_p_Kardex.empresa)
            * 100) --,
                      --Tabulador = IsNull(Convert(Numeric(10,2),dbo.Fun_R_Ausencias(Tmp_Kardex.Codigo, Tmp_Kardex.Inicio, Tmp_Kardex.Termino, Tmp_Kardex.Horario, 'P', @nEmpresa)),0)
    WHERE   Faltas > 0

    UPDATE  dbo.Tmp_p_Kardex
    SET     Descuento = ( ( ( Tmp_p_Kardex.Descuento / 100 )
                            / Tmp_p_Kardex.Faltas ) + 01 ) * 100
    WHERE   Tmp_p_Kardex.Faltas > 0


    CREATE  INDEX [IX_Tmp_p_Kardex] ON [dbo].[Tmp_p_Kardex]([empresa],[Codigo], [Folio]) ON [PRIMARY]
-- Determinar los folios para la insercion en el kardex

-- Armar el Kardex
	
	--select * from Tmp_p_Kardex where codigo=4

    INSERT  INTO dbo.p_Kardex
            SELECT  @id_presup AS id_presup ,
                    Tmp_Kardex.Empresa AS Empresa ,
                    Tmp_Kardex.Codigo AS Codigo ,
                    @cTipoNom AS Nomina ,
                    Conceptos.Centro AS Centro ,
                    @nTipoNom AS Num_Conc ,
                    Conceptos.Clase AS Clase ,
                    Tmp_Kardex.Folio AS Folio ,
                    @nmes AS ayo_operacion ,
                    @nayo AS mes_operacion ,
                    1 AS Renglon ,
                    Tmp_Kardex.Inicio AS Fch_Inicio ,
                    Tmp_Kardex.Termino AS Fch_Cierre ,
                    @dPago AS Fch_Pago ,
                    Tmp_Kardex.Dias - Tmp_Kardex.Vacaciones AS Dias ,
                    Tmp_Kardex.Incap_eg + Tmp_Kardex.Incap_Mat
                    + Tmp_Kardex.Incap_rt AS Inc ,
                    Tmp_Kardex.Faltas AS Aus ,
                    Tmp_Kardex.Dias AS DiasTr ,
                    Tmp_Kardex.Dias_Imss - Tmp_Kardex.Vacaciones AS Dias_Imss ,
                    'P' AS TPago_Desc ,
                    Conceptos.Concepto AS Concepto ,
                    0 AS VariaImss ,
                    0 AS Variable ,
                    Conceptos.Imss ,
                    Conceptos.Ispt ,
                    Conceptos.Ptu ,
                    Conceptos.Despensa ,
                    Conceptos.Mca_Agui ,
                    Conceptos.FdoAhorro ,
                    'A' AS Calculo ,
                    Tmp_Kardex.Sueldo AS Impor_Base ,
                    Tmp_Kardex.SalDiaInt AS SalDiaInt ,
                    Tmp_Kardex.Tabulador AS Tabulador ,
                    0 AS Unidades ,
                    0 AS Horas ,
                    'SDO' AS Tipo_Mov ,
                    0 AS Secuencia ,
                    ( Tmp_Kardex.Dias - Tmp_Kardex.Vacaciones )
                    * Tmp_Kardex.Sueldo AS Importe ,
                    ( Tmp_Kardex.Dias - Tmp_Kardex.Vacaciones )
                    * Tmp_Kardex.Sueldo AS IGravable ,
                    0 AS IExento ,
                    0 AS Credito ,
                    Tmp_Kardex.Descuento ,
                    0 AS Saldo ,
                    '' AS Referencia ,
                    'N' AS Siempre ,
                    '' AS Justificar ,
                    '' AS Septimo ,
                    'F' AS PrevSocial ,
                    0 AS Varia1 ,
                    0 AS Varia2 ,
                    0 AS Varia3 ,
                    0 AS Varia4 ,
                    '' AS Variable1 ,
                    '' AS Variable2 ,
                    '' AS Variable3 ,
                    '' AS Variable4 ,
                    'F' AS Masivo ,
                    '' AS Formula ,
                    '' AS Ispt_NG ,
                    '' AS Imss_NI ,
                    '' AS Marca ,
                    0 AS Serial ,
                    'F' AS Informativo ,
                    '' AS Detalle_Prn
            FROM    dbo.Tmp_p_Kardex AS Tmp_Kardex
                    LEFT JOIN dbo.p_empleados_pres AS llaves ON Tmp_Kardex.Codigo = Llaves.Codigo
                                                              AND Tmp_Kardex.Empresa = Llaves.Empresa
                                                              AND Llaves.id_presup = @id_presup
                    LEFT JOIN dbo.Conceptos ON Conceptos.Num_Conc = @nTipoNom
                                               AND Tmp_Kardex.Empresa = Conceptos.Empresa
            WHERE   Tmp_Kardex.Dias > 0
                    AND llaves.id_presup = @id_presup

    SELECT  *
    INTO    dbo.Tmp_p_Sueldos
    FROM    dbo.Tmp_p_Kardex

    DROP TABLE dbo.Tmp_p_Kardex
    DROP TABLE dbo.Tmp_p_Avisos_Imss2

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.asp_p_Tablas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.asp_p_Tablas
GO

CREATE PROCEDURE dbo.asp_p_Tablas
    @id_presup INT ,
    @nTipoNom INT ,
    @dFf DATETIME
AS /*
Declare @nEmpresa Int
Declare @nTipoNom Int
Declare @dFF      DateTime
*/
    DECLARE @nEmpresa INT

    DECLARE @cTipoNom CHAR(3)
    DECLARE @dInicio DATETIME
    DECLARE @dCierre DATETIME
    DECLARE @dPago DATETIME
    DECLARE @nConcepto INT

    DECLARE @dFechaTab DATETIME

    DECLARE @nMes INT
    DECLARE @nAyo INT
    DECLARE @nDiasPer INT
/*
SET @nEmpresa = 5
SET @nTiponom = 1
SET @dFF = '20070630'
*/

    SET @cTipoNom = CASE WHEN @nTipoNom = 1 THEN 'SEM'
                         WHEN @nTipoNom = 2 THEN 'DEC'
                         WHEN @nTipoNom = 3 THEN 'CAT'
                         WHEN @nTipoNom = 4 THEN 'QNA'
                         WHEN @nTipoNom = 5 THEN 'MES'
                         ELSE 'ESP'
                    END


    SELECT  @dInicio = Periodos.Inicio ,
            @dCierre = Periodos.Cierre ,
            @dPago = Periodos.Pago ,
            @nMes = MONTH(Periodos.Inicio) ,
            @nAyo = YEAR(Periodos.Inicio) ,
            @nDiasPer = Periodos.Dias
    FROM    dbo.p_dias AS Periodos
    WHERE   Periodos.Estatus = 'A'
            AND Periodos.TipoNom = @nTipoNom
            AND Periodos.id_presup = @id_presup

	Declare @DiasDelAyo int
	set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@nAyo),0)

	--select @DiasDelAyo as DiasDelAyo


-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
    IF @dPago > @dFF 
        SET @dFechaTab = @dFF
    ELSE 
        SET @dFechaTab = @dPago
--


    IF OBJECT_ID('dbo.Tmp_p_Bases') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Bases

    IF OBJECT_ID('dbo.Tmp_p_Tablas') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Tablas

    IF EXISTS ( SELECT  name
                FROM    sysindexes
                WHERE   name = 'IX_tmp_p_kardex' ) 
        DROP INDEX dbo.Tmp_p_Kardex_tab.IX_Tmp_p_kardex_tab

    IF OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL 
        DROP TABLE dbo.Tmp_p_Kardex_tab


    SELECT  Kardex.empresa ,
            Kardex.Codigo ,
            kardex.num_conc ,
            Kardex.Fch_Inicio ,
            Kardex.Fch_Cierre ,
            Kardex.Impor_Base ,
            Kardex.SalDiaInt ,
            Kardex.Dias ,
            Kardex.DiasTr ,
            Kardex.Inc ,
            Kardex.Aus ,
            Kardex.DiasTr + Kardex.Aus - ( Kardex.Aus * Kardex.Descuento / 100 ) AS DiasReales ,
            Kardex.DiasTr + Kardex.Aus + Kardex.Inc AS DiasTotales ,
            Kardex.Descuento ,
            Empleados.FchNac ,
            dbo.NvaFecha(CASE WHEN DAY(Empleados.FchNac) = 29
                                   AND MONTH(Empleados.FchNac) = 2 THEN 28
                              ELSE DAY(Empleados.FchNac)
                         END, MONTH(Empleados.FchNac), YEAR(@dInicio)) AS CumpleAyos ,
            dbo.NvaFecha(CASE WHEN DAY(Empleados.FchNac) = 29
                                   AND MONTH(Empleados.FchNac) = 2 THEN 28
                              ELSE DAY(Empleados.FchNac)
                         END, MONTH(Empleados.FchNac), YEAR(@dCierre)) AS CumpleAyos2 ,
            Empleados.FchAntigua ,
            dbo.NvaFecha(CASE WHEN DAY(Empleados.FchAntigua) = 29
                                   AND MONTH(Empleados.FchAntigua) = 2 THEN 28
                              ELSE DAY(Empleados.FchAntigua)
                         END, MONTH(Empleados.FchAntigua), YEAR(@dInicio)) AS Aniversario ,
            dbo.NvaFecha(CASE WHEN DAY(Empleados.FchAntigua) = 29
                                   AND MONTH(Empleados.FchAntigua) = 2 THEN 28
                              ELSE DAY(Empleados.FchAntigua)
                         END, MONTH(Empleados.FchAntigua), YEAR(@dCierre)) AS Aniversario2
    INTO    dbo.Tmp_p_Bases
    FROM    dbo.p_Kardex AS Kardex
            LEFT JOIN dbo.p_empleados_pres AS Empleados ON Kardex.Codigo = Empleados.Codigo
                                                           AND Kardex.Empresa = Empleados.Empresa
                                                           AND Kardex.id_presup = Empleados.id_presup
    WHERE   kardex.ayo_operacion = @nAyo
            AND kardex.mes_operacion = @nMes
            AND empleados.id_presup = @id_presup
            AND Kardex.Nomina = @cTipoNom
            AND ( Kardex.Num_Conc = @nTipoNom
                  OR ( Kardex.Num_Conc = 30
                       AND Tipo_Mov <> 'FIN'
                     )
                )
            AND Kardex.Empresa IN ( SELECT  empresa
                                    FROM    dbo.p_empresas
                                    WHERE   id_presup = @id_presup )


-- Concepto 18 - Despensa en Efectivo
    SELECT  Tmp_Bases.empresa ,
            Tmp_Bases.Codigo ,
            18 AS Num_Conc ,
            Tmp_Bases.Fch_Inicio ,
            Tmp_Bases.Fch_Cierre ,
            Tmp_Bases.Impor_Base ,
            Tmp_Bases.SalDiaInt ,
            Tmp_Bases.DiasTr ,
            Tmp_Bases.Dias ,
            Tmp_Bases.Inc ,
            Tmp_Bases.Aus ,
            Tmp_Bases.DiasReales ,
            Tmp_Bases.Descuento ,
            ( ( ISNULL(Tablas_Int.Despensa, 0) / 100
                * ISNULL(Tmp_Bases.Impor_Base, 0) ) + Tablas_Int.DespensaIm )
            * Tmp_Bases.DiasReales AS Importe --,
--       0 As VariaImss
    INTO    dbo.Tmp_p_Tablas
    FROM    dbo.Tmp_p_Bases AS Tmp_Bases
            INNER JOIN dbo.p_empleados_pres AS Llaves ON Tmp_Bases.Codigo = Llaves.Codigo
                                                         AND Llaves.Empresa = Tmp_Bases.Empresa
                                                         AND Llaves.id_presup = @id_presup
--Inner Join Empleados On Tmp_Bases.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa
            INNER JOIN dbo.p_Tablas_Int AS Tablas_Int ON Llaves.Clase = Tablas_Int.Clase
                                                         AND Llaves.Empresa = Tablas_Int.Empresa
                                                         AND Llaves.id_presup = Tablas_Int.id_presup
                                                         AND CONVERT(INT, Tablas_Int.Ayos) = CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              llaves.FchAntigua,
                                                              @dFf) / 365, 0)) > 45
                                                              THEN 45
                                                              ELSE CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              llaves.FchAntigua,
                                                              @dFf) / 365, 0)) < 1
                                                              THEN 1
                                                              ELSE CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              llaves.FchAntigua,
                                                              @dFf) / 365, 0))
                                                              END
                                                              END
                                                         AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                         AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
            INNER JOIN dbo.Clases ON Llaves.Clase = Clases.Clase
                                     AND Llaves.Empresa = Clases.Empresa
            INNER JOIN dbo.Conceptos ON Conceptos.Num_Conc = 18
                                        AND Conceptos.Clase = Llaves.Clase
                                        AND Conceptos.Empresa = Llaves.Empresa
    WHERE   Conceptos.Uso = 'S'
            AND Clases.ValesDesp <> 'N'  -- Ojo: La Marca VALESDESP = 'N' cuando son vales, y diferente cuando es efectivo


--UpDate Tmp_Tablas Set VariaImss = Tmp_Tablas.Importe Where Empleados.TipoSal = 1
--From Tmp_Tablas
--Inner Join Empleados On Tmp_Tablas.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa


-- Conceptos 19 - Dias x Ao
--           20 - Porcentaje x Ao
--           21 - Importe por Ao

    SET @nConcepto = 19

    WHILE @nConcepto <= 21 
        BEGIN
            INSERT  INTO dbo.Tmp_p_Tablas
                    ( Codigo ,
                      empresa ,
                      Num_Conc ,
                      Fch_Inicio ,
                      Fch_Cierre ,
                      Impor_Base ,
                      SalDiaInt ,
                      DiasTr ,
                      Dias ,
                      Inc ,
                      Aus ,
                      DiasReales ,
                      Descuento ,
                      Importe
                    )
                    ( SELECT DISTINCT
                                Tmp_Bases.Codigo ,
                                Tmp_Bases.empresa ,
                                @nConcepto AS Num_Conc ,
                                @dInicio AS Fch_Inicio ,
                                @dCierre AS Fch_Cierre ,
                                llaves.Sueldo AS Impor_Base ,
                                llaves.SalDiaInt ,
                                0 AS DiasTr ,
                                0 AS Dias ,
                                0 AS Inc ,
                                0 AS Aus ,
                                0 AS DiasReales ,
                                0 AS Descuento ,
           --Tablas_Int.Dias_Ayo,
                                CASE @nConcepto
                                  WHEN 19
                                  THEN Tablas_Int.Dias_Ayo
                                       * ( CASE WHEN llaves.TipoSal = 1
                                                THEN llaves.SalDiaInt
                                                ELSE llaves.Sueldo
                                           END )
                                  WHEN 20
                                  THEN Tablas_Int.Porc_Ayo / 100
                                       * ( ( CASE WHEN llaves.TipoSal = 1
                                                  THEN llaves.SalDiaInt
                                                  ELSE llaves.Sueldo
                                             END ) * @DiasDelAyo )
                                  ELSE Tablas_Int.Imp_Ayo
                                END AS Importe
    --Into Tmp_Tablas
                      FROM      dbo.Tmp_p_Bases AS Tmp_Bases
                                INNER JOIN dbo.p_empleados_pres AS Llaves ON Tmp_Bases.Codigo = Llaves.Codigo
                                                              AND Llaves.Empresa = Tmp_Bases.Empresa
                                                              AND Llaves.id_presup = @id_presup
    --Inner Join Empleados On Tmp_Bases.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa
                                INNER JOIN dbo.p_Tablas_Int AS Tablas_Int ON Llaves.Clase = Tablas_Int.Clase
                                                              AND Llaves.Empresa = Tablas_Int.Empresa
                                                              AND Llaves.id_presup = Tablas_Int.id_presup
                                                              AND CONVERT(INT, Tablas_Int.Ayos) = CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              llaves.FchAntigua,
                                                              @dFf) / 365, 0)) > 45
                                                              THEN 45
                                                              ELSE CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              llaves.FchAntigua,
                                                              @dFf) / 365, 0)) < 1
                                                              THEN 1
                                                              ELSE CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              llaves.FchAntigua,
                                                              @dFf) / 365, 0))
                                                              END
                                                              END
                                                              AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                              AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
                                INNER JOIN dbo.Conceptos ON Conceptos.Num_Conc = @nConcepto
                                                            AND Conceptos.Clase = Llaves.Clase
                                                            AND Conceptos.empresa = Llaves.empresa
                      WHERE     ( ( Conceptos.Marca2 = 'A'
                                    AND ( ( Tmp_Bases.Aniversario >= @dInicio
                                            AND Tmp_Bases.Aniversario <= @dCierre
                                          )
                                          OR ( Tmp_Bases.Aniversario2 >= @dInicio
                                               AND Tmp_Bases.Aniversario2 <= @dCierre
                                             )
                                        )
                                  )
                                  OR ( Conceptos.Marca2 = 'C'
                                       AND ( ( Tmp_Bases.CumpleAyos >= @dInicio
                                               AND Tmp_Bases.CumpleAyos <= @dCierre
                                             )
                                             OR ( Tmp_Bases.CumpleAyos2 >= @dInicio
                                                  AND Tmp_Bases.CumpleAyos2 <= @dCierre
                                                )
                                           )
                                     )
                                  OR ( CONVERT(DATETIME, CONVERT(CHAR(4), YEAR(Conceptos.Fecha1))
                                       + RIGHT('0'
                                               + RTRIM(CONVERT(CHAR(2), MONTH(@dPago))),
                                               2) + RIGHT('0'
                                                          + RTRIM(CONVERT(CHAR(2), DAY(@dPago))),
                                                          2)) >= @dInicio
                                       AND CONVERT(DATETIME, CONVERT(CHAR(4), YEAR(Conceptos.Fecha1))
                                       + RIGHT('0'
                                               + RTRIM(CONVERT(CHAR(2), MONTH(@dPago))),
                                               2) + RIGHT('0'
                                                          + RTRIM(CONVERT(CHAR(2), DAY(@dPago))),
                                                          2)) <= @dCierre
                                     )
                                )
                                AND ( CASE @nConcepto
                                        WHEN 19 THEN Tablas_Int.Dias_Ayo
                                        WHEN 20 THEN Tablas_Int.Porc_Ayo
                                        ELSE Tablas_Int.Imp_Ayo
                                      END ) > 0
                                AND Conceptos.Uso = 'S'
                    )

            SET @nConcepto = @nConcepto + 1

        END


-- Conceptos 22 - Dias x Mes
--           23 - Porcentaje x Mes
--           24 - Importe por mes

    SET @nConcepto = 22

    WHILE @nConcepto <= 24 
        BEGIN
            INSERT  INTO dbo.Tmp_p_Tablas
                    ( Codigo ,
                      empresa ,
                      Num_Conc ,
                      Fch_Inicio ,
                      Fch_Cierre ,
                      Impor_Base ,
                      SalDiaInt ,
                      DiasTr ,
                      Dias ,
                      Inc ,
                      Aus ,
                      DiasReales ,
                      Descuento ,
                      Importe
                    )
                    ( SELECT DISTINCT
                                Tmp_Bases.Codigo ,
                                Tmp_Bases.empresa ,
                                @nConcepto AS Num_Conc ,
                                @dInicio AS Fch_Inicio ,
                                @dCierre AS Fch_Cierre ,
                                Empleados.Sueldo ,
                                Empleados.SalDiaInt ,
                                0 AS DiasTr ,
                                0 AS Dias ,
                                0 AS Inc ,
                                0 AS Aus ,
                                0 AS DiasReales ,
                                0 AS Descuento ,
                                CASE @nConcepto
                                  WHEN 22
                                  THEN Tablas_Int.Dias_Mes
                                       * ( CASE WHEN Empleados.TipoSal = 1
                                                THEN Empleados.SalDiaInt
                                                ELSE Empleados.Sueldo
                                           END )
                                  WHEN 23
                                  THEN Tablas_Int.Porc_Mes / 100
                                       * ( ( CASE WHEN Empleados.TipoSal = 1
                                                  THEN Empleados.SalDiaInt
                                                  ELSE Empleados.Sueldo
                                             END ) * 30.4 )
                                  ELSE Tablas_Int.Imp_Mes
                                END AS Importe
                      FROM      dbo.Tmp_p_Bases AS Tmp_Bases
                                INNER JOIN dbo.p_empleados_pres AS empleados ON Tmp_Bases.Codigo = empleados.Codigo
                                                              AND empleados.Empresa = Tmp_Bases.Empresa
                                                              AND empleados.id_presup = @id_presup
    --Inner Join Empleados On Tmp_Bases.Codigo = Empleados.Codigo And Empleados.Empresa = @nEmpresa
                                INNER JOIN dbo.p_Tablas_Int AS Tablas_Int ON empleados.Clase = Tablas_Int.Clase
                                                              AND empleados.Empresa = Tablas_Int.Empresa
                                                              AND empleados.id_presup = Tablas_Int.id_presup
                                                              AND CONVERT(INT, Tablas_Int.Ayos) = CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)) > 45
                                                              THEN 45
                                                              ELSE CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)) < 1
                                                              THEN 1
                                                              ELSE CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0))
                                                              END
                                                              END
                                                              AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                              AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
                                INNER JOIN dbo.Conceptos ON Conceptos.Num_Conc = @nConcepto
                                                            AND Conceptos.Clase = empleados.Clase
                                                            AND Conceptos.empresa = empleados.empresa
                      WHERE     ( CASE WHEN MONTH(@dInicio) <> MONTH(@dCierre)
                                       THEN ( CASE WHEN ( Conceptos.Hrs_Min1 >= DAY(@dInicio)
                                                          AND Conceptos.Hrs_Min1 <= DAY(CONVERT(DATETIME, CONVERT(CHAR(4), YEAR(@dCierre))
                                                              + RIGHT('0'
                                                              + RTRIM(CONVERT(CHAR(2), MONTH(@dCierre))),
                                                              2) + '01') - 1)
                                                        )
                                                        OR ( Conceptos.Hrs_Min1 >= DAY(CONVERT(DATETIME, CONVERT(CHAR(4), YEAR(@dCierre))
                                                              + RIGHT('0'
                                                              + RTRIM(CONVERT(CHAR(2), MONTH(@dCierre))),
                                                              2) + '01'))
                                                             AND Conceptos.Hrs_Min1 <= DAY(@dCierre)
                                                           ) THEN 'S'
                                                   ELSE 'N'
                                              END )
                                       ELSE CASE WHEN Conceptos.Hrs_Min1 >= DAY(@dInicio)
                                                      AND Conceptos.Hrs_Min1 <= DAY(@dCierre)
                                                 THEN 'S'
                                                 ELSE 'N'
                                            END
                                  END ) = 'S'
                                AND ( CASE @nConcepto
                                        WHEN 22 THEN Tablas_Int.Dias_Mes
                                        WHEN 23 THEN Tablas_Int.Porc_Mes
                                        ELSE Tablas_Int.Imp_Mes
                                      END ) > 0
                                AND Conceptos.Uso = 'S'
                    )

            SET @nConcepto = @nConcepto + 1

        END


-- Conceptos 25 - Porcentaje Diario
--           26 - Importe Diario

    SET @nConcepto = 25

    WHILE @nConcepto <= 26 
        BEGIN
            INSERT  INTO dbo.Tmp_p_Tablas
                    ( Codigo ,
                      empresa ,
                      Num_Conc ,
                      Fch_Inicio ,
                      Fch_Cierre ,
                      Impor_Base ,
                      SalDiaInt ,
                      DiasTr ,
                      Dias ,
                      Inc ,
                      Aus ,
                      DiasReales ,
                      Descuento ,
                      Importe
                    )
                    ( SELECT    Tmp_Bases.Codigo ,
                                Tmp_Bases.empresa ,
                                @nConcepto AS Num_Conc ,
                                Tmp_Bases.Fch_Inicio ,
                                Tmp_Bases.Fch_Cierre ,
                                Tmp_Bases.Impor_Base ,
                                Tmp_Bases.SalDiaInt ,
                                Tmp_Bases.DiasTr ,
                                Tmp_Bases.Dias ,
                                Tmp_Bases.Inc ,
                                Tmp_Bases.Aus ,
                                Tmp_Bases.DiasReales ,
                                Tmp_Bases.Descuento ,
                                ( CASE @nConcepto
                                    WHEN 25
                                    THEN Tablas_Int.Porc_Dia / 100
                                         * ( CASE WHEN Empleados.TipoSal = 1
                                                  THEN Tmp_Bases.SalDiaInt
                                                  ELSE Tmp_Bases.Impor_Base
                                             END )
                                    ELSE Tablas_Int.Imp_Dia
                                  END ) * Tmp_Bases.DiasReales AS Importe
                      FROM      dbo.Tmp_p_Bases AS Tmp_Bases --Inner Join Llaves On Tmp_Bases.Codigo = Llaves.Codigo And Llaves.Empresa = @nEmpresa
                                INNER JOIN dbo.p_Empleados_pres AS Empleados ON Tmp_Bases.Codigo = Empleados.Codigo
                                                              AND Empleados.Empresa = Tmp_Bases.Empresa
                                                              AND Empleados.id_presup = @id_presup
                                INNER JOIN dbo.p_Tablas_Int AS Tablas_Int ON empleados.Clase = Tablas_Int.Clase
                                                              AND empleados.Empresa = Tablas_Int.Empresa
                                                              AND Empleados.id_presup = Tablas_Int.id_presup
                                                              AND CONVERT(INT, Tablas_Int.Ayos) = CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)) > 45
                                                              THEN 45
                                                              ELSE CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)) < 1
                                                              THEN 1
                                                              ELSE CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0))
                                                              END
                                                              END
                                                              AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                              AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
                                INNER JOIN dbo.Conceptos ON Conceptos.Num_Conc = @nConcepto
                                                            AND Conceptos.Clase = empleados.Clase
                                                            AND Conceptos.empresa = empleados.empresa
                      WHERE     ( CASE @nConcepto
                                    WHEN 25 THEN Tablas_Int.Porc_Dia
                                    ELSE Tablas_Int.Imp_Dia
                                  END ) > 0
                                AND Conceptos.Uso = 'S'
                    )

            SET @nConcepto = @nConcepto + 1

        END


-- Concepto 28 - Premio Anual 1
--          29 - Premio Anual 2
    SET @nConcepto = 28

    WHILE @nConcepto <= 29 
        BEGIN
            INSERT  INTO dbo.Tmp_p_Tablas
                    ( Codigo ,
                      empresa ,
                      Num_Conc ,
                      Fch_Inicio ,
                      Fch_Cierre ,
                      Impor_Base ,
                      SalDiaInt ,
                      DiasTr ,
                      Dias ,
                      Inc ,
                      Aus ,
                      DiasReales ,
                      Descuento ,
                      Importe
                    )
                    ( SELECT DISTINCT
                                Tmp_Bases.Codigo ,
                                Tmp_Bases.empresa ,
                                @nConcepto AS Num_Conc ,
                                @dInicio AS Fch_Inicio ,
                                @dCierre AS Fch_Cierre ,
                                Empleados.Sueldo AS Impor_Base ,
                                Empleados.SalDiaInt ,
                                0 AS DiasTr ,
                                0 AS Dias ,
                                0 AS Inc ,
                                0 AS Aus ,
                                0 AS DiasReales ,
                                0 AS Descuento ,
                                CASE WHEN Conceptos.Fecha1 >= @dInicio
                                          AND Conceptos.Fecha1 <= @dCierre
                                     THEN CASE @nConcepto
                                            WHEN 28
                                            THEN Tablas_Int.Pmo1AyoPor / 100
                                                 * @DiasDelAyo * Empleados.Sueldo
                                            ELSE Tablas_Int.Pmo2AyoPor / 100
                                                 * @DiasDelAyo * Empleados.Sueldo
                                          END
                                     ELSE 0
                                END
                                + CASE WHEN Conceptos.Fecha2 >= @dInicio
                                            AND Conceptos.Fecha2 <= @dCierre
                                       THEN CASE @nConcepto
                                              WHEN 28
                                              THEN Tablas_Int.Pmo1AyoImp
                                              ELSE Tablas_Int.Pmo2AyoImp
                                            END
                                       ELSE 0
                                  END AS Importe
                      FROM      dbo.Tmp_p_Bases AS Tmp_Bases --Inner Join Llaves On Tmp_Bases.Codigo = Llaves.Codigo And Llaves.Empresa = @nEmpresa
                                INNER JOIN dbo.p_Empleados_pres AS Empleados ON Tmp_Bases.Codigo = Empleados.Codigo
                                                              AND Empleados.Empresa = Tmp_Bases.Empresa
                                                              AND Empleados.id_presup = @id_presup
                                INNER JOIN dbo.p_Tablas_Int AS Tablas_Int ON empleados.Clase = Tablas_Int.Clase
                                                              AND empleados.Empresa = Tablas_Int.Empresa
                                                              AND Empleados.id_presup = Tablas_Int.id_presup
                                                              AND CONVERT(INT, Tablas_Int.Ayos) = CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)) > 45
                                                              THEN 45
                                                              ELSE CASE
                                                              WHEN CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0)) < 1
                                                              THEN 1
                                                              ELSE CONVERT(INT, ROUND(DATEDIFF(Day,
                                                              Empleados.FchAntigua,
                                                              @dFf) / 365, 0))
                                                              END
                                                              END
                                                              AND Tablas_Int.Mes_Operacion = MONTH(@dFechaTab)
                                                              AND Tablas_Int.Ayo_Operacion = YEAR(@dFechaTab)
                                INNER JOIN dbo.Conceptos ON Conceptos.Num_Conc = @nConcepto
                                                            AND Conceptos.Clase = empleados.Clase
                                                            AND Conceptos.empresa = empleados.empresa
                      WHERE     ( CASE @nConcepto
                                    WHEN 28
                                    THEN Tablas_Int.Pmo1AyoPor
                                         + Tablas_Int.Pmo1AyoImp
                                    ELSE Tablas_Int.Pmo2AyoPor
                                         + Tablas_Int.Pmo2AyoImp
                                  END ) > 0
                                AND Conceptos.Uso = 'S'
                    )

            SET @nConcepto = @nConcepto + 1

        END



    SELECT  Tmp_Tablas.Codigo ,
            Tmp_Tablas.Empresa AS Empresa ,
            @cTipoNom AS Nomina ,
            ' ' AS Centro ,
            Tmp_Tablas.Num_Conc ,
            Llaves.Clase ,
            0 AS Folio ,
            0 AS Renglon ,
            Tmp_Tablas.Fch_Inicio ,
            Tmp_Tablas.Fch_Cierre ,
            @dPago AS Fch_Pago ,
            Tmp_Tablas.DiasReales AS Dias ,
            Tmp_Tablas.Inc ,
            Tmp_Tablas.Aus ,
            Tmp_Tablas.DiasReales AS DiasTr ,
            0 AS Dias_Imss ,
            'P' AS TPago_Desc ,
            Conceptos.Concepto ,
            0 AS VariaImss ,
            0 AS Variable ,
            Conceptos.Imss ,
            Conceptos.Ispt ,
            Conceptos.Ptu ,
            Conceptos.Despensa ,
            Conceptos.Mca_Agui ,
            Conceptos.FdoAhorro ,
            'A' AS Calculo ,
            Tmp_Tablas.Impor_Base ,
            Tmp_Tablas.SalDiaInt ,
            0 AS Tabulador ,
            0 AS Unidades ,
            0 AS Horas ,
            'TAB' AS Tipo_Mov ,
            0 AS Secuencia ,
            Tmp_Tablas.Importe ,
            Tmp_Tablas.Importe AS IGravable ,
            0 AS IExento ,
            0 AS Credito ,
            0 AS Descuento ,
            0 AS Saldo ,
            ' ' AS Referencia ,
            'N' AS Siempre ,
            ' ' AS Justificar ,
            ' ' AS Septimo ,
            'F' AS PrevSocial ,
            0 AS Varia1 ,
            0 AS Varia2 ,
            0 AS Varia3 ,
            0 AS Varia4 ,
            ' ' AS Variable1 ,
            ' ' AS Variable2 ,
            ' ' AS Variable3 ,
            ' ' AS Variable4 ,
            'F' AS Masivo ,
            ' ' AS Formula ,
            ' ' AS Ispt_NG ,
            ' ' AS Imss_NI ,
            ' ' AS Marca ,
            0 AS Serial ,
            'F' AS Informativo ,
            @id_presup AS id_presup ,
            @nAyo AS ayo_operacion ,
            @nMes AS mes_operacion
    INTO    dbo.Tmp_p_Kardex_tab
    FROM    dbo.Tmp_p_Tablas AS Tmp_Tablas
            LEFT JOIN dbo.p_empleados_pres AS Llaves ON Tmp_Tablas.Codigo = Llaves.Codigo
                                                        AND Llaves.Empresa = Tmp_Tablas.Empresa
                                                        AND Llaves.id_presup = @id_presup
            LEFT JOIN dbo.Conceptos ON Tmp_Tablas.Num_Conc = Conceptos.Num_Conc
                                       AND Conceptos.Clase = Llaves.Clase
                                       AND Conceptos.Empresa = llaves.Empresa
    WHERE   Tmp_tablas.importe > 0
    ORDER BY tmp_tablas.Codigo ASC ,
            Tmp_Tablas.Num_Conc


    CREATE  INDEX [IX_Tmp_p_kardex_tab] ON [dbo].[Tmp_p_Kardex_tab]([Codigo],[empresa]) ON [PRIMARY]


-- Determinar los folios para la insercion en el kardex
--Exec asp_genera_folio @nEmpresa,0,'Tmp_Kardex_tab','Folio',0,0
--

-- Pasar los registros al kardex real
    INSERT  INTO dbo.p_Kardex
            ( Codigo ,
              Empresa ,
              Nomina ,
              Centro ,
              Num_Conc ,
              Clase ,
              Folio ,
              Renglon ,
              Fch_Inicio ,
              Fch_Cierre ,
              Fch_Pago ,
              Dias ,
              Inc ,
              Aus ,
              DiasTr ,
              Dias_Imss ,
              TPago_Desc ,
              Concepto ,
              VariaImss ,
              Variable ,
              Imss ,
              Ispt ,
              Ptu ,
              Despensa ,
              Mca_Agui ,
              FdoAhorro ,
              Calculo ,
              Impor_Base ,
              SalDiaInt ,
              Tabulador ,
              Unidades ,
              Horas ,
              Tipo_Mov ,
              Secuencia ,
              Importe ,
              IGravable ,
              IExento ,
              Credito ,
              Descuento ,
              Saldo ,
              Referencia ,
              Siempre ,
              Justificar ,
              Septimo ,
              PrevSocial ,
              Varia1 ,
              Varia2 ,
              Varia3 ,
              Varia4 ,
              Variable1 ,
              Variable2 ,
              Variable3 ,
              Variable4 ,
              Masivo ,
              Formula ,
              Ispt_NG ,
              Imss_NI ,
              Marca ,
              Serial ,
              Informativo ,
              id_presup ,
              ayo_operacion ,
              mes_operacion
            )
            ( SELECT    *
              FROM      dbo.Tmp_p_Kardex_tab
            )
--



    DROP TABLE dbo.Tmp_p_Bases
    DROP TABLE dbo.Tmp_p_Tablas

    IF EXISTS ( SELECT  name
                FROM    sysindexes
                WHERE   name = 'IX_tmp_p_kardex' ) 
        DROP INDEX dbo.Tmp_p_Kardex_tab.IX_Tmp_p_kardex_tab

    DROP TABLE dbo.Tmp_p_Kardex_tab

GO


If OBJECT_ID('dbo.asp_pres_Vacaciones') Is NOT NULL
  Drop Procedure dbo.asp_pres_Vacaciones
Go


Create Procedure dbo.asp_pres_Vacaciones
@nTipoNom INT,
@dFi DateTime,
@dFf DateTime,
@id_Presup INT,
@nSalMin Numeric(10,2),
@nUma Numeric(10,2)

As

Declare @dInicio   DateTime
Declare @dTermino  DateTime
Declare @dPago     DateTime
Declare @cTipoNom  Char(3)

Declare @dFechaTab DateTime

Declare @cRegPat   Char(10)
Declare @cRfcPat   VarChar(13)

Declare @tPromedios Table
(
  Codigo   Integer,
  Promedio Numeric(12,2) 
 )

Declare @tSemanaReducida Table
(
  Codigo     Integer,
  Dias_Sem   VarChar(6),
  Proporcion Numeric(6,4),
  Dias_Vac   Integer
)



Select @cRegPat = max(Registro_Patronal),
       @cRfcPat = max(LTrim(Rfc_Empresa))
From Empresas Where Empresa in(select empresa from P_empresas where id_presup=@id_Presup)

Set @cTipoNom = Case When @nTipoNom = 1 Then 'SEM'
                     When @nTipoNom = 2 Then 'DEC'
                     When @nTipoNom = 3 Then 'CAT'
                     When @nTipoNom = 4 Then 'QNA'
                     When @nTipoNom = 5 Then 'MES' Else 'ESP' End


Set DateFirst 1
declare @mes int
declare @ayo int

Select @dInicio = Periodos.Inicio, @dTermino = Periodos.Cierre, @dPago = Periodos.Pago,@mes=Periodos.mes,@ayo=Periodos.ejercicio 
From P_dias as Periodos Where Estatus = 'A' And id_presup = @id_Presup And TipoNom = @nTipoNom

Declare @DiasDelAyo int
set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@Ayo),0)

--select @DiasDelAyo as DiasDelAyo


-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
If @dPago > @dFF
  Set @dFechaTab = @dFF
Else
  Set @dFechaTab = @dPago
--


-- Para Speak, calcular prima vacacional sobre Sueldo+Promedio anual (del ejercicio anterior)
-- y registrar como Integrable la parte calculada por el promedio
If @cRegPat In ('R125154110','Z293771510','Z293771310','Z294139110','R121858010') OR @cRfcPat = 'TPA061005QB3'
  Insert Into @tPromedios
  Select Codigo,
         Promedio
  From SPEAK_Promedios
  Where Ejercicio = Year(@dFF) - 1 And
        Empresa in(select empresa from P_empresas where id_presup=@id_Presup)
--


If OBJECT_ID('dbo.Tmp_p_Vacaciones') IS NOT NULL
  Drop Table dbo.Tmp_p_Vacaciones

If OBJECT_ID('dbo.Tmp_p_Kardex') IS NOT NULL
  Drop Table dbo.Tmp_p_Kardex


-- Validar para cuando sea la primera vez que entrar a Multi-Vacaciones
-- si ya traen vacaciones programadas de la version normal... el SERIAL estara en cero
-- solo ponerle el valor 1
UpDate Kardex
Set Serial    = 1,
    Marca     = Case When Vacaciones.Ordinaria = 'T' Then 'O' Else 'V' End,
    Variable4 = Case When Kardex.Num_Conc = 30
                     Then Convert(Char(4),Vacaciones.Ejercicio) + '/' + Convert(Char(4),Vacaciones.Ejercicio_Ant)
                     Else ''
                End
From p_Kardex as Kardex
Inner Join Vacaciones On Vacaciones.Codigo = Kardex.Codigo And Vacaciones.Empresa = Kardex.Empresa
Where Kardex.Serial = 0 And
      Kardex.Nomina = 'VAC' And
      Kardex.id_presup = @id_Presup
	  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo


-- Pasar los importes de vacaciones del Kardex, solo de los empleados que se pagan en la nomina ordinaria y estan dentro del periodo
-- o cuando mucho un dia despues del cierre
Select a.Codigo,
       a.Empresa,
       @cTipoNom As Nomina,
       a.Centro,
       a.Num_Conc,
       a.Clase,
       a.Folio,
       a.Renglon,
       a.Fch_Inicio,
       a.Fch_Cierre,
       a.Fch_Pago,
       a.Dias,
       0 As Inc,
       0 As Aus,
       a.DiasTr,
       a.Dias_Imss,
       a.TPago_Desc,
       a.Concepto,
       a.VariaImss,
       a.Variable,
       IsNull(a.Imss,'N') As Imss,
       IsNull(a.Ispt,'N') As Ispt,
       IsNull(a.Ptu,'N') As Ptu,
       IsNull(a.Despensa,'N') As Despensa,
       IsNull(a.Mca_Agui,'N') As Mca_Agui,
       IsNull(a.FdoAhorro,'N') As FdoAhorro,
       a.Calculo,
       
       -- Para el concepto de vacaciones de colomer, calcularlo con el importe entre los dias
       Case When @cRegPat <> '1308606310' Or a.Num_Conc <> 30
            Then a.Impor_Base
            Else a.Importe/a.Dias
       End As Impor_Base,
       
       a.SalDiaInt,
       0 As Tabulador,
       IsNull(a.Unidades,0) As Unidades,
       IsNull(a.Horas,0) As Horas,
       IsNull(a.Tipo_Mov,'VAC') As Tipo_Mov,
       0 As Secuencia,
       a.Importe,
       a.IGravable,
       a.IExento,
       IsNull(a.Credito,0) As Credito,
       IsNull(a.Descuento,0) As Descuento,
       IsNull(a.Saldo,0) As Saldo,
       a.Referencia,
       a.Siempre,
       IsNull(a.Justificar,' ') As Justificar,
       IsNull(a.Septimo,0) As Septimo,
       a.PrevSocial,
       a.Varia1,
       a.Varia2,
       a.Varia3,
       a.Varia4,
       a.Variable1,
       a.Variable2,
       a.Variable3,
       a.Variable4,
       a.Masivo,
       a.Formula,
       a.Ispt_NG,
       a.Imss_NI,
       a.Marca,
       a.Serial,
       IsNull(a.Informativo,'F') As Informativo,
       ' ' As Detalle_Prn
Into dbo.Tmp_p_Vacaciones
From p_Kardex  as a
--Left Join Vacaciones On a.Codigo = Vacaciones.Codigo And a.Empresa = Vacaciones.Empresa
Left Join P_Empleados_Pres as  Llaves     On a.Codigo = Llaves.Codigo     And a.Empresa = Llaves.Empresa And a.id_presup = Llaves.id_presup
Where Llaves.TipoNom = @nTipoNom And 
      a.Nomina = 'VAC' And
      a.Marca = 'O' And
      a.Fch_Pago <= @dPago And
      a.id_presup = @id_Presup
	  and a.mes_operacion =@mes and a.ayo_operacion=@ayo




-- Llenar tabla con proporciones para semana reducida
Insert Into @tSemanaReducida
Select Llaves.Codigo,
       Horarios_Catalogo.Dias_Sem,
	   Round( Len(Horarios_Catalogo.Dias_Sem) / 7.00, 4 ),
       Round(Tablas_Int.Dias_Vac * Round( Len(Horarios_Catalogo.Dias_Sem) / 7.00, 4 ),0)
From P_Empleados_Pres as Llaves
--Inner Join Empleados On Empleados.Codigo = Llaves.Codigo And Empleados.Empresa = Llaves.Empresa
Inner Join Horarios_Catalogo On Horarios_Catalogo.Horario = Llaves.Horario And Horarios_Catalogo.Empresa = Llaves.Empresa
Left Join p_Tablas_Int as Tablas_Int On Tablas_Int.id_presup = @id_Presup and  Llaves.Clase = Tablas_Int.Clase And Llaves.Empresa = Tablas_Int.Empresa And Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,DateDiff(Day,Llaves.FchAntigua,dbo.NvaFecha(Day(Llaves.FchAntigua),Month(Llaves.FchAntigua),Year(@dTermino)))/365) > 45 Then 45 Else Case When Convert(Int,DateDiff(Day,llaves.FchAntigua,dbo.NvaFecha(Day(llaves.FchAntigua),Month(llaves.FchAntigua),Year(@dTermino)) )/365) < 1 Then 1 Else Convert(Int,DateDiff(Day,llaves.FchAntigua,dbo.NvaFecha(Day(llaves.FchAntigua),Month(llaves.FchAntigua),Year(@dTermino)) )/365) End End And Tablas_Int.Mes_Operacion = Month(@dFechaTab) And Tablas_Int.Ayo_Operacion = Year(@dFechaTab)
Where Horarios_Catalogo.Semana_Red = 'S' And
      Llaves.id_presup = @id_Presup
--


-- Calcular prima vacacional para los empleados que la tienen programada para pagar al ao o en una fecha determinada
-- cuando caiga dentro del periodo nominal en proceso
Insert Into Tmp_p_Vacaciones
Select a.Codigo,
       a.Empresa,
       @cTipoNom As Nomina,
       Space(14) As Centro,
       17 As Num_Conc,
       a.Clase,
       0 As Folio,
       0 As Renglon, 
       @dInicio As Fch_Inicio,
       @dTermino As Fch_Cierre,
       @dPago As Fch_Pago,
       Tablas_Int.Dias_Vac As Dias,
       0 As Inc,
       0 As Aus,
       0 As DiasTr,
       0 As Dias_Imss,
       'P' As TPago_Desc,
       Conceptos.Concepto,
       
       --0 As Varia_Imss,
       --0 As Variable,
       
       Case When vacaciones.sueldo > 0 And IsNull(tPromedios.Promedio,0) > 0 -- Esta condicion es solo para Speak
            Then (IsNull(tPromedios.Promedio,0) * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100)) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * IsNull(tPromedios.Promedio,0))
			When a.tiposal = 1 And isnull(conceptos.hrs_min1,0) = 999 -- Agregada el 9 Mzo 2016 para considerar la marca de integrar la prima de los empleados con salario variable
			Then Case When vacaciones.sueldo = 0 Then vacaciones.SalDiaInt Else (vacaciones.sueldo+IsNull(tPromedios.Promedio,0)) End * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End)
            Else 0
       End As Varia_Imss,

       Case When vacaciones.sueldo > 0 And IsNull(tPromedios.Promedio,0) > 0 -- Esta condicion es solo para Speak
            Then (IsNull(tPromedios.Promedio,0) * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100)) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * IsNull(tPromedios.Promedio,0))
			When a.tiposal = 1 And isnull(conceptos.hrs_min1,0) = 999 -- Agregada el 9 Mzo 2016 para considerar la marca de integrar la prima de los empleados con salario variable
			Then Case When vacaciones.sueldo = 0 Then vacaciones.SalDiaInt Else (vacaciones.sueldo+IsNull(tPromedios.Promedio,0)) End * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End)
            Else 0
       End As Variable,
       
       IsNull(Conceptos.Imss,'N'),
       IsNull(Conceptos.Ispt,'S'),
       IsNull(Conceptos.Ptu,'N'),
       IsNull(Conceptos.Despensa,'N'),
       IsNull(Conceptos.Mca_Agui,'N'),
       IsNull(Conceptos.FdoAhorro,'N'),
       'A' As Calculo,
       Case When Vacaciones.Sueldo > 0 Then Vacaciones.Sueldo Else Vacaciones.SalDiaInt End As Impor_Base,
       a.SalDiaInt,
       0 As Tabulador,
       0 As Unidades,
       0 As Horas,
       'PVA' As Tipo_Mov,
       0 As Secuencia,
       
       isnull(Case When vacaciones.sueldo = 0 Then vacaciones.SalDiaInt Else (vacaciones.sueldo+IsNull(tPromedios.Promedio,0)) End * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End),0) As Importe,

       Case When (Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End) * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * (Case When vacaciones.sueldo = 0 Then vacaciones.SalDiaInt Else (vacaciones.sueldo+IsNull(tPromedios.Promedio,0)) End)) > IsNull(@nUma,@nSalMin)*15
            Then (Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End)) - IsNull(@nUma,@nSalMin)*15
            Else 0 End As IGravable,

       Case When (Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End) * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End) > IsNull(@nUma,@nSalMin)*15
            Then IsNull(@nUma,@nSalMin) * 15
            Else (Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End * IsNull(tReducida.Dias_Vac,Tablas_Int.Dias_Vac) * (Tablas_Int.Prima_Vac/100) + 
                 Tablas_Int.PmaVacImpo + (Tablas_Int.PmaVacDias * Case When Vacaciones.Sueldo = 0 Then Vacaciones.SalDiaInt Else (Vacaciones.Sueldo+IsNull(tPromedios.Promedio,0)) End)) End As IExento,
                 
       0 As Credito,
       0 As Descuento,
       0 As Saldo,
       ' ' As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       'F' As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       Conceptos.Formula,
       Conceptos.Ispt_NG,
       ISNULL(Conceptos.Imss_NI,''),
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo,
       ' ' As Detalle_Prn
From P_Empleados_Pres as a 
--left Join Vacaciones On a.Codigo = Vacaciones.Codigo And a.Empresa = Vacaciones.Empresa
outer apply(
			select top 1	a1.Sueldo,a1.SalDiaInt,
							convert(datetime,convert(varchar,@ayo)+substring(convert(varchar,a.fchAntigua,112),5,4)) as Disfrute,
							convert(datetime,convert(varchar,@ayo)+substring(convert(varchar,a.fchAntigua,112),5,4)) as fin_Disfru
			from dbo.P_Avisos_IMSS as a1
			where	a1.id_presup=a.id_presup
					and a1.empresa=a.empresa
					and a1.Codigo=a.Codigo
					and a1.ayo_operacion=@ayo
					and a1.mes_operacion=@mes
			order by a1.fch_mov desc
			) as vacaciones
Inner Join Conceptos  On Conceptos.Num_Conc = 17 And Conceptos.Clase = a.Clase And Conceptos.Empresa = a.Empresa
Left Join p_Tablas_Int as Tablas_Int On Tablas_Int.id_presup=@id_Presup and a.Clase = Tablas_Int.Clase And a.Empresa = Tablas_Int.Empresa And Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,DateDiff(Day,a.FchAntigua,dbo.NvaFecha(Day(a.FchAntigua),Month(a.FchAntigua),Year(@dTermino)))/365) > 45 Then 45 Else Case When Convert(Int,DateDiff(Day,a.FchAntigua,dbo.NvaFecha(Day(a.FchAntigua),Month(a.FchAntigua),Year(@dTermino)) )/365) < 1 Then 1 Else Convert(Int,DateDiff(Day,a.FchAntigua,dbo.NvaFecha(Day(a.FchAntigua),Month(a.FchAntigua),Year(@dTermino)) )/365) End End And Tablas_Int.Mes_Operacion = Month(@dFechaTab) And Tablas_Int.Ayo_Operacion = Year(@dFechaTab)
Left Join p_Kardex as Kardex     On Kardex.Codigo = a.Codigo And Kardex.Empresa = a.Empresa And
                        Case When Conceptos.Marca2 = 'F' Then dbo.NvaFecha(Day(Conceptos.Fecha1),Month(Conceptos.Fecha1),Year(@dFF)) Else dbo.NvaFecha(Day(a.FchAntigua),Month(a.FchAntigua),Year(@dFF)) End BetWeen Kardex.Fch_Inicio And Kardex.Fch_Cierre And
                        Kardex.Num_Conc = @nTipoNom
						and kardex.id_presup=a.id_presup
Left Join @tPromedios As tPromedios On tPromedios.Codigo = a.Codigo
Left Join Acum_Conc On Acum_Conc.Codigo = a.Codigo And Acum_Conc.Ejercicio = Year(@dPago) And Acum_Conc.Num_Conc = 17 And Acum_Conc.Empresa = a.empresa

Left Join @tSemanaReducida As tReducida On tReducida.Codigo = a.Codigo
where a.id_presup=@id_presup And
		kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo and 
      --a.Pagar_Nomina = 'S' And
     -- a.Borrado = 'N' And
      --Vacaciones.Pagada = 'F' And
      DateDiff(Day,a.FchAntigua,Case When Conceptos.Marca2 <> 'F' Then @dTermino Else dbo.NvaFecha(Day(a.FchAntigua),Month(a.FchAntigua),Year(@dTermino)) End)/@DiasDelAyo >= 1 And
      a.TipoNom = @nTipoNom And
      a.Activo = 'S' And
      Conceptos.Marca2 IN ('A','F') And

      ((dbo.NvaFecha(Day( Case When Conceptos.Marca2 = 'F' Then Conceptos.Fecha1 Else a.FchAntigua End),
                     Month( Case When Conceptos.Marca2 = 'F' Then Conceptos.Fecha1 Else a.FchAntigua End),
                     Year(@dFF)) BetWeen @dInicio And @dTermino) Or
       (dbo.NvaFecha(Day( Case When Conceptos.Marca2 = 'F' Then Conceptos.Fecha1 Else a.FchAntigua End),
                     Month( Case When Conceptos.Marca2 = 'F' Then Conceptos.Fecha1 Else a.FchAntigua End),
                     Year(@dFF) + Case When Year(@dFF) < Year(@dTermino) 
                                       Then 1 
                                       Else 0 
                                  End) BetWeen @dInicio And @dTermino) Or 
                                  
       -- 30 Jul 2014 Para Avicola, si las vacaciones amparan la fecha de aniversario...pagar la prima aunque corresponda al siguiente periodo
       (dbo.NvaFecha(Day( Case When Conceptos.Marca2 = 'F' Then Conceptos.Fecha1 Else a.FchAntigua End),
                     Month( Case When Conceptos.Marca2 = 'F' Then Conceptos.Fecha1 Else a.FchAntigua End),
                     Year(@dFF)) BetWeen Vacaciones.Disfrute And Vacaciones.Fin_Disfru And Vacaciones.Disfrute <> Vacaciones.Fin_Disfru And @cRegPat In ('E151601510','E152174210','E753951010','L151626010','E753951010') ) ) And

      -- Para Avicola, pagar Prima vacacional solo sino se ha pagado durante el ejercicio
      (Acum_Conc.Codigo Is Null Or @cRegPat Not In ('E151601510','E152174210','E753951010','L151626010','E753951010') ) And

      -- Para Avicola, si no tiene registros de sueldo o vacaciones...no calcular (le programaron vacaciones el periodo anterior)
      (@cRegPat Not In ('E151601510','E152174210','E753951010','L151626010','E753951010') Or
       Exists (Select Distinct K.Codigo
               From Kardex As K
               Where K.Codigo = a.Codigo And
                     ((K.Num_Conc = @nTipoNom And K.Nomina = @cTipoNom) Or 
                      (K.Num_Conc = 30 And K.Nomina = 'VAC')) And
                     K.Empresa = a.empresa)) And

      
       IsNull(Tablas_Int.Prima_Vac,0) > 0 And
       --(a.UltMov <> 'B' Or a.UltFchMov >= @dInicio) And
       Not Exists (Select Finiquitos.Codigo From Finiquitos Where Finiquitos.Codigo = a.Codigo And Finiquitos.Empresa = a.Empresa)
Order By a.codigo

-- 8 Jul 2016  Buscar acumulado de prima vacacional del ejercicio, para ajustar la parte gravable y exenta
UpDate Tmp_p_Vacaciones
Set IGravable = Case When Acum_Conc.Imp_Grava > 0 Or Acum_Conc.Imp_Exento >= IsNull(@nUma,@nSalMin) * 15 -- Si ya trae importe gravadoa acumulado o lo exento acumulado es mayor o igual a 15 salarios minimos, gravar todo
                     Then Tmp_p_Vacaciones.Importe
                     When Tmp_p_Vacaciones.Importe <= (IsNull(@nUma,@nSalMin) * 15) - IsNull(Acum_Conc.Imp_Exento,0) -- Si el importe a pagar es menor a 15 salarios menos lo exento acumulado, no gravar nada
                     Then 0
                     Else Tmp_p_Vacaciones.Importe - ((IsNull(@nUma,@nSalMin) * 15) - IsNull(Acum_Conc.Imp_Exento,0)) -- Gavar la diferencia considerando lo exento acumulado
                End,
    IExento = Case When Acum_Conc.Imp_Grava > 0 Or Acum_Conc.Imp_Exento >= IsNull(@nUma,@nSalMin) * 15 -- Si ya trae importe gravadoa acumulado o lo exento acumulado es mayor o igual a 15 salarios minimos, gravar todo
                   Then 0
                   When Tmp_p_Vacaciones.Importe <= (IsNull(@nUma,@nSalMin) * 15) - IsNull(Acum_Conc.Imp_Exento,0) -- Si el importe a pagar es menor a 15 salarios menos lo exento acumulado, no gravar nada
                   Then Tmp_p_Vacaciones.Importe
                   Else ((IsNull(@nUma,@nSalMin) * 15) - IsNull(Acum_Conc.Imp_Exento,0)) -- Gavar la diferencia considerando lo exento acumulado
              End
From Tmp_p_Vacaciones
Inner Join Acum_Conc On Acum_Conc.Codigo = Tmp_p_Vacaciones.Codigo And Acum_Conc.Num_Conc = 17 And Acum_Conc.Ejercicio = Year(@dPago) And Acum_Conc.Empresa = Tmp_p_Vacaciones.Empresa
Where Tmp_p_Vacaciones.Num_Conc = 17 And
      Tmp_p_Vacaciones.Nomina = @cTipoNom And
      Tmp_p_Vacaciones.Tipo_Mov = 'PVA' --And
      --Tmp_p_Vacaciones.Empresa = @nEmpresa
--


-- Para la empresa 'TEC LAC CONSULTORES' de Ismael, calcular el ISR de la prima vacacional aunque se pague en la ordinaria
If @cRegPat In ('A362034910','P341006013','E464852410','E646917610','A201090910','A365074410', 'A366148410','A366146910','Y392543610')
  Begin

    Insert Into Tmp_p_Vacaciones
    Select Tmp_p_Vacaciones.Codigo,
           Tmp_p_Vacaciones.Empresa,
           @cTipoNom As Nomina,
           Space(14) As Centro,
           136 As Num_Conc,
           '' As Clase,
           0 As Folio,
           0 As Renglon, 
           @dInicio As Fch_Inicio,
           @dTermino As Fch_Cierre,
           @dPago As Fch_Pago,
           Tmp_p_Vacaciones.Dias,
           0 As Inc,
           0 As Aus,
           0 As DiasTr,
           0 As Dias_Imss,
           'D' As TPago_Desc,
           Conceptos.Concepto,
           0 As Varia_Imss,
           0 As Variable,
           IsNull(Conceptos.Imss,'N'),
           IsNull(Conceptos.Ispt,'S'),
           IsNull(Conceptos.Ptu,'N'),
           IsNull(Conceptos.Despensa,'N'),
           IsNull(Conceptos.Mca_Agui,'N'),
           IsNull(Conceptos.FdoAhorro,'N'),
           'A' As Calculo,
           Tmp_p_Vacaciones.Impor_Base,
           Tmp_p_Vacaciones.SalDiaInt,
           0 As Tabulador,
           0 As Unidades,
           0 As Horas,
           'ISR' As Tipo_Mov,
           0 As Secuencia,
       
           Case When Conceptos.Importe1 <> 999
                Then Case When Conceptos.Importe2 = 999 Or dbo.Fun_R_Isr_Periodico(Impor_Base * 30.40, 30.40, 0, Year(@dPago), 7, Tmp_p_Vacaciones.Empresa)-dbo.Fun_R_Isr_Periodico(Impor_Base * 30.40, 30.40, 0, Year(@dPago), 8, Tmp_p_Vacaciones.Empresa) > 0
                          Then (dbo.Fun_R_Isr_Periodico( (Impor_Base * 30.40)+(IGravable/@DiasDelAyo*30.40), 30.40, 0, Year(@dPago), 7, Tmp_p_Vacaciones.Empresa)-
                                dbo.Fun_R_Isr_Periodico( Impor_Base * 30.40, 30.40, 0, Year(@dPago), 7, Tmp_p_Vacaciones.Empresa))/(IGravable/@DiasDelAyo*30.40)*IGravable
                          Else 0
                     End
                Else( (dbo.Fun_R_Isr_Periodico( (Impor_Base * 30.40)+(IGravable/@DiasDelAyo*30.40), 30.40, 0, Year(@dPago), 7, Tmp_p_Vacaciones.Empresa) -
                           dbo.Fun_R_Isr_Periodico( (Impor_Base * 30.40)+(IGravable/@DiasDelAyo*30.40), 30.40, 0, Year(@dPago), 8, Tmp_p_Vacaciones.Empresa)) -
                          (dbo.Fun_R_Isr_Periodico( Impor_Base * 30.40, 30.40, 0, Year(@dPago), 7, Tmp_p_Vacaciones.Empresa) - 
                           dbo.Fun_R_Isr_Periodico( Impor_Base * 30.40, 30.40, 0, Year(@dPago), 8, Tmp_p_Vacaciones.Empresa)) ) / (IGravable/@DiasDelAyo*30.40)*IGravable
           End As Importe,
                 
           0 As IGravable,
           0 As IExento,
           0 As Credito,
           0 As Descuento,
           0 As Saldo,
           ' ' As Referencia,
           'N' As Siempre,
           ' ' As Justificar,
           ' ' As Septimo,
           'F' As PrevSocial,
           0 As Varia1,
           0 As Varia2,
           0 As Varia3,
           0 As Varia4,
           ' ' As Variable1,
           ' ' As Variable2,
           ' ' As Variable3,
           ' ' As Variable4,
           'F' As Masivo,
           Conceptos.Formula,
           Conceptos.Ispt_NG,
           ISNULL(Conceptos.Imss_NI,''),
           ' ' As Marca,
           0 As Serial,
           'F' As Informativo,
           ' ' As Detalle_Prn
    From Tmp_p_Vacaciones
    Inner Join Conceptos  On Conceptos.Num_Conc = 136 And Conceptos.Empresa = Tmp_p_Vacaciones.Empresa
    Where Tmp_p_Vacaciones.Num_Conc = 17 And
          IGravable > 0
    Order By Tmp_p_Vacaciones.Codigo
  
  End
--


--La rutina que genera los Folios requiere la tabla ordenada por codigo
Select Tmp_p_Vacaciones.*
Into dbo.Tmp_p_Kardex
From Tmp_p_Vacaciones
Inner Join P_Empleados_Pres as Empleados On Empleados.id_presup=@id_Presup and  Empleados.Codigo = Tmp_p_Vacaciones.Codigo And Empleados.Empresa = Tmp_p_Vacaciones.Empresa
--Left Join Finiquitos On Finiquitos.Codigo = Tmp_p_Vacaciones.Codigo And Finiquitos.FchBaja = Empleados.UltFchMov And Finiquitos.Empresa = Empleados.Empresa
Where Tmp_p_Vacaciones.Importe > 0
Order By Tmp_p_Vacaciones.Codigo, Tmp_p_Vacaciones.Num_Conc


--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Kardex','Folio',0,0


Insert Into p_Kardex
--Select @id_Presup as id_presup,* From Tmp_p_Kardex
select @id_Presup as id_presu,
        empresa,Codigo, 
		Nomina, 
		Centro, 
		Num_Conc, 
		Clase, 
		Folio, 
		@mes as mes_operacion,
		@ayo as ayo_operacion,
		Renglon, 
		Fch_Inicio, 
		Fch_Cierre, 
		Fch_Pago, 
		Dias, 
		Inc, 
		Aus, 
		DiasTr, 
		Dias_Imss, 
		TPago_Desc, 
		Concepto, 
		VariaImss, 
		Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro, Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento, Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4, Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo, Detalle_Prn 
--from p_kardex
from Tmp_p_Vacaciones
--where --num_conc>6 and 
--mes_operacion =@mes and ayo_operacion=@ayo

Drop Table dbo.Tmp_p_Vacaciones
Drop Table dbo.Tmp_p_Kardex

GO

If OBJECT_ID('dbo.asp_p_Vales') Is NOT NULL
  Drop Procedure dbo.asp_p_Vales
Go


Create Procedure dbo.asp_p_Vales
@id_presup   Int,
@nTipoNom   Int,
@dFf        DateTime,
@nSalMin    Numeric(10,2),
@nSalDF     Numeric(10,2),
@nUma       Numeric(10,2)

As

Declare @cUso       Char(1)
Declare @cMarca1    Char(1)
Declare @cMarca2    Char(1)
Declare @nRedondea  Int
Declare @nDisminuye Int
Declare @nDiaMes    Int
Declare @cRedondea  Char(1)
Declare @cAjusta    Char(10)
Declare @cTope      Char(1)
Declare @cCambioMes Char(1)
Declare @cIspt      Char(1)
Declare @cCaptura   Char(1)

Declare @dInicio    DateTime
Declare @dCIerre    DateTime
Declare @dPago      DateTime
Declare @cTipoNom   Char(3)

Declare @dDia       DateTime

Declare @dFechaTab  DateTime

Declare @cAus31     Char(4)

Declare @cRegPat    Char(10)


Select @cRegPat = max(Registro_Patronal) From Empresas Where empresa in(select empresa from P_empresas where id_presup=@id_Presup)


Set @cTipoNom = Case When @nTipoNom = 1 Then 'SEM'
                     When @nTipoNom = 2 Then 'DEC'
                     When @nTipoNom = 3 Then 'CAT'
                     When @nTipoNom = 4 Then 'QNA'
                     When @nTipoNom = 5 Then 'MES' Else 'ESP' End


declare @mes int
declare @ayo int
Select @dInicio = Periodos.Inicio, @dCierre = Periodos.Cierre, @dPago = Periodos.Pago,@mes=Periodos.mes,@ayo=Periodos.ejercicio 
From P_dias as  Periodos Where Estatus = 'A' And id_presup = @id_presup And TipoNom = @nTipoNom

Declare @DiasDelAyo int
set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@Ayo),0)

--select @DiasDelAyo as DiasDelAyo


-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
If @dPago > @dFF
  Set @dFechaTab = @dFF
Else
  Set @dFechaTab = @dPago
--

SELECT  @cUso = 'S' ,
            @cIspt = Conceptos.Ispt ,
            @cMarca1 = 'O',--Conceptos.Marca1 ,
            --@cMarca2 = Conceptos.Marca2 ,
            @cMarca2    = 'P',
            @nDiaMes = 28,--Conceptos.Hrs_Min1 ,
            @nRedondea = Conceptos.Hrs_Min2 ,
            @nDisminuye = Conceptos.Hrs_Min3 ,
            @cAjusta = RTRIM(Conceptos.Variable1) ,
            @cTope = CASE WHEN RTRIM(Conceptos.Variable2) = 'CONTOPE' THEN 'S'
                          ELSE 'N'
                     END ,
            @cCaptura = 'A'--Conceptos.Captura
    FROM    dbo.Conceptos
    WHERE   Conceptos.Num_Conc = 31 And Conceptos.Empresa in(select empresa from P_empresas where id_presup=@id_Presup)


If @cUso = 'S' And @cCaptura = 'A'
  Begin

    Set @cCambioMes = Case When Month(@dInicio) = Month(@dCierre+(@dCierre-@dInicio+1)) Then 'N' Else 'S' End

    Set @cRedondea = 'S'

    -- Si tiene pago mensual, checar si se paga dentro de el periodo en proceso
    If @cMarca2 = 'M'
      Begin
        Set @cRedondea = 'N'
        Set @dDia  = @dInicio

        While @dDia <= @dCierre
          Begin
            If Day(@dDia) = @nDiaMes
              Set @cRedondea = 'S'

            Set @dDia = @dDia + 1
          End
      End
    --

	
    -- Inicializar la tabla de DESPENSAS
    Update Despensas Set Despensas.FchInicio = NULL,
                         Despensas.FchCierre = NULL,
                         Despensas.FchPago   = NULL,
                         Despensas.Dias      = 0,
                         Despensas.Aus       = 0,
                         Despensas.Inc       = 0,
                         Despensas.Comision  = 0,
                         Despensas.Total     = 0,
                         Despensas.Gravable  = 0,
                         Despensas.Exento    = 0,
                         Despensas.Ispt      = 0,
                         Despensas.Redondeo  = 0,
                         Despensas.Neto      = 0,
                         Despensas.Excedente = 0,
                         Despensas.Excede    = 0,
                         Despensas.Pagada    = 'F',
                         Despensas.Nomina    = ' '
    From p_Despensas as Despensas
    Inner Join P_Empleados_Pres as  Llaves On Despensas.Codigo = Llaves.Codigo And Llaves.Empresa = despensas.Empresa and Llaves.id_presup = despensas.id_presup
    Where Despensas.Marca = 'T' And
          Llaves.TipoNom = @nTipoNom And
          Despensas.id_presup=@id_presup
    --


    If OBJECT_ID('dbo.Tmp_p_Despensa') Is NOT NULL
      Drop Table dbo.Tmp_p_Despensa
    If OBJECT_ID('dbo.Tmp_p_Aus') Is NOT NULL
      Drop Table dbo.Tmp_p_Aus
    If OBJECT_ID('dbo.Tmp_p_Comision') Is NOT NULL
      Drop Table dbo.Tmp_p_Comision


    -- Base para la despensa
    Select Kardex.empresa,
		   Kardex.Codigo,
           Min(Kardex.Fch_Inicio)               As Fch_Inicio,
           Max(Kardex.Fch_Cierre)               As Fch_Cierre,
           Max(llaves.Sueldo)                As Sueldo,
           Max(Llaves.SalDiaInt)             As SalDiaInt,
           Sum(Kardex.Importe)                  As ImpBase, --Sum(Kardex.Impor_Base*Kardex.Dias) As ImpBase,
           Sum(Kardex.Dias)                     As Dias,
           Max(KardexSdo.Ds)                    As Ds,
           Max(KardexSdo.Incap)                 As Incap,
           Max(KardexSdo.Ausen)                 As Ausen,
           Convert(Numeric(10,2),0)             As ImpFaltas,
           Convert(Numeric(6,2),0)              As DsFaltas,
           Convert(Numeric(10,2),0)             As ImpIncap,
           Convert(Numeric(6,2),0)              As DsIncap,
           Convert(Numeric(10,2),0)             As Comisiones,
           Convert(Numeric(10,2),0)             As DespComisiones,
           Max(IsNull(Tablas_Int.Despensa,0))   As Despensa,
           Max(IsNull(Tablas_Int.DespensaIm,0)) As DespensaIm,
           Convert(Numeric(10,2),0)             As Total,
           Convert(Numeric(10,2),0)             As Excede,
           Convert(Numeric(10,2),0)             As Excedente,
           Convert(Numeric(10,2),0)             As Exento,
           Convert(Numeric(10,2),0)             As Gravable,
           Convert(Numeric(10,2),0)             As Ispt,
           Convert(Numeric(10,2),0)             As Redondeo,
           Convert(Numeric(10,2),0)             As Neto,
           Case When (@cRedondea = 'S' And @cMarca2 = 'M') Or @cMarca2 = 'P' Then 'S' Else 'N' End As Pagada,
           Case When (@cRedondea = 'S' And @cMarca2 = 'M') Or @cMarca2 = 'P' Then 'S' Else 'N' End As Pagarla
    Into dbo.Tmp_p_Despensa
    From p_Kardex as Kardex
    --Inner Join Empleados  On Kardex.Codigo = Empleados.Codigo And Kardex.Empresa = Empleados.Empresa
    Inner Join P_Empleados_Pres as  Llaves     On Kardex.Codigo = Llaves.Codigo And Kardex.Empresa = Llaves.Empresa and llaves.id_presup=@id_presup
    Inner Join p_Tablas_Int as Tablas_Int On Tablas_Int.id_presup=@id_presup and Llaves.Clase = Tablas_Int.Clase And Llaves.Empresa = Tablas_Int.Empresa And Convert(Int,Tablas_Int.Ayos) = Case When Convert(Int,Round(DateDiff(Day,llaves.FchAntigua,@dFf)/365,0)) > 45 Then 45 Else Case When Convert(Int,Round(DateDiff(Day,Llaves.FchAntigua,@dFf)/365,0)) < 1 Then 1 Else Convert(Int,Round(DateDiff(Day,Llaves.FchAntigua,@dFf)/365,0)) End End And Tablas_Int.Mes_Operacion = Month(@dFechaTab) And Tablas_Int.Ayo_Operacion = Year(@dFechaTab)
    Left Join (Select Kardex.Codigo    As Codigo,
                      Sum(Kardex.Dias) As Ds,
                      Sum(Kardex.Inc)  As Incap,
                      Sum(Kardex.Aus)  As Ausen
               From p_Kardex as Kardex
               Where Kardex.Nomina = @cTipoNom And
                     Kardex.id_presup = @id_presup And
                     (Kardex.Num_Conc = @nTipoNom Or
                      (Kardex.Num_Conc = 30 And Kardex.Tipo_Mov <> 'FIN') Or
                      (Kardex.Num_Conc >= 1108 And Kardex.Num_Conc <= 1111))
               Group By Codigo) As KardexSdo On KardexSdo.Codigo = Kardex.Codigo
    Where Kardex.id_presup = @id_presup And
          Kardex.Nomina = @cTipoNom And
          (Kardex.Num_Conc = @nTipoNom Or
           Kardex.Num_Conc = 7 Or
           (Kardex.Num_Conc = 30 And Kardex.Tipo_Mov <> 'FIN') Or
           (Kardex.Num_Conc >= 1108 And Kardex.Num_Conc <= 1111))
		   and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    Group By Kardex.empresa,Kardex.Codigo
    --

    -- Dias e importes de ausentismo que afecta la despensa
    Select Kardex.Codigo,
           Sum( Case When (Kardex.Num_Conc = 108 Or Kardex.Num_Conc = 107) And CharIndex(Kardex.Justificar,@cAus31) > 0 Then Kardex.Importe Else 0 End) As ImpFaltas,
           Sum( Case When Kardex.Num_Conc In (109,110,111) Or (Kardex.Num_Conc = 107 And Kardex.Justificar <> 'F') Then Kardex.Importe Else 0 End) As ImpIncap,
           Sum( Case When (Kardex.Num_Conc = 108 Or Kardex.Num_Conc = 107) And CharIndex(Kardex.Justificar,@cAus31) > 0 Then Kardex.Dias * Case When Kardex.Num_Conc = 108 Then Kardex.Descuento/100 Else 1 End Else 0 End) As DsFaltas,
           Sum( Case When Kardex.Num_Conc In (109,110,111) Or (Kardex.Num_Conc = 107 And Kardex.Justificar In ('1','2','3','4')) Then Kardex.Dias Else 0 End) As DsIncap
    Into dbo.Tmp_p_Aus
    From p_Kardex as Kardex
    Inner Join Conceptos On Kardex.Num_Conc = Conceptos.Num_Conc And Kardex.Empresa = Conceptos.Empresa
    Where Kardex.Nomina = @cTipoNom And
          Kardex.id_presup = @id_presup And
          Kardex.Num_Conc In (107,108,109,110,111) And
          Conceptos.Despensa = 'S'
		  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    Group By Kardex.Codigo --,Kardex.Num_Conc,Kardex.Justificar
    --


    -- Actualizar dias e importes de ausentismo de la tabla principal
    UpDate Tmp_p_Despensa Set Dias      = Tmp_p_Despensa.Dias - (IsNull(Tmp_p_Aus.DsFaltas,0)+IsNull(Tmp_p_Aus.DsIncap,0)),
                            ImpBase   = Tmp_p_Despensa.ImpBase - (IsNull(Tmp_p_Aus.ImpFaltas,0)+IsNull(Tmp_p_Aus.ImpIncap,0)),
                            ImpFaltas = IsNull(Tmp_p_Aus.ImpFaltas,0),
                            ImpIncap  = IsNull(Tmp_p_Aus.ImpIncap ,0),
                            DsFaltas  = IsNull(Tmp_p_Aus.DsFaltas ,0),
                            DsIncap   = IsNull(Tmp_p_Aus.DsIncap  ,0)
    From Tmp_p_Despensa
    Left Join Tmp_p_Aus On Tmp_p_Despensa.Codigo = Tmp_p_Aus.Codigo
    --


    -- Checar los demas conceptos que afectan la despensa
    Select Kardex.Codigo,
           Sum( Case When Kardex.TPago_Desc = 'P' Then Kardex.Importe Else 0-Kardex.Importe End) As Importe
    Into dbo.Tmp_p_Comision
    From p_Kardex as Kardex
    Inner Join Conceptos On Kardex.Num_Conc = Conceptos.Num_Conc And Kardex.Clase = Conceptos.Clase And Kardex.Centro = Conceptos.Centro And Kardex.Empresa = Conceptos.Empresa
    Where Kardex.Nomina = @cTipoNom And
          Kardex.id_presup = @id_presup And
          NOT Kardex.Num_Conc In (@nTipoNom,7,30,1108,1109,1110,1111,107,108,109,110,111) And
          Kardex.Tipo_Mov <> 'FIN' And
          Conceptos.Despensa = 'S'
		  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    Group By Kardex.Codigo
    --


    -- Actualizar el campo de comisiones de la tabla principal
    Update Tmp_p_Despensa Set Comisiones = IsNull(Tmp_p_Comision.Importe,0)
    From Tmp_p_Despensa
    Left Join Tmp_p_Comision On Tmp_p_Despensa.Codigo = Tmp_p_Comision.Codigo
    --


    -- Para Autocamiones, tomar de la tabla de promedios los importes base
    --If @cRegPat In ('3301121210','3309345610','3302109910','A812073210','A839270310','Y771267910','A806357610','A807199710','A805144110')
    -- Se quitaron 3 regs. patronales que se fueron a Mty (24 Ene 2013)
    If @cRegPat In ('3301121210','3309345610','3302109910','A806357610','A807199710')
      UpDate Tmp_p_Despensa
      Set Comisiones = AutoCamiones.Base + Case When AutoCamiones.BaseVac > 0 Then AutoCamiones.BaseVac Else 0 End
      From Tmp_p_Despensa
      Inner Join Empleados On Empleados.Codigo = Tmp_p_Despensa.Codigo And Empleados.Empresa = Tmp_p_Despensa.Empresa
      Inner Join AutoCamiones On AutoCamiones.Codigo = Tmp_p_Despensa.Codigo And AutoCamiones.Empresa = Tmp_p_Despensa.Empresa And AutoCamiones.Periodo = 'M' And AutoCamiones.Mes_Operacion = Month(@dPago) And AutoCamiones.Ayo_Operacion = Year(@dPago)
      Where Empleados.TipoSal = 2      


    -- Sumar a los campos del periodo los acumulados al periodo anterior, si es despensa mensual
    If @cRedondea = 'S' And @cMarca2 = 'M'
      Update Tmp_p_Despensa Set Dias       = Tmp_p_Despensa.Dias + IsNull(Despensas.Dias_Ant,0),
                              DsFaltas   = Tmp_p_Despensa.DsFaltas + IsNull(Despensas.Aus_Ant,0),
                              DsIncap    = Tmp_p_Despensa.DsIncap + IsNull(Despensas.Inc_Ant,0),
                              Total      = (Tmp_p_Despensa.ImpBase * Tmp_p_Despensa.Despensa / 100) + (Tmp_p_Despensa.DespensaIm * Tmp_p_Despensa.Dias) + IsNull(Despensas.Total_Ant,0),
                              Fch_Inicio = IsNull(Despensas.Inicio_Ant,Tmp_p_Despensa.Fch_Inicio)
      From Tmp_p_Despensa
      Left Join p_Despensas as Despensas On Tmp_p_Despensa.Codigo = Despensas.Codigo And Despensas.id_presup = @id_presup

    -- Sino, solo calcular lo del periodo
    Else
      Update Tmp_p_Despensa Set Total      = (Tmp_p_Despensa.ImpBase * Tmp_p_Despensa.Despensa / 100) + (Tmp_p_Despensa.DespensaIm * Tmp_p_Despensa.Dias)
    --


    -- Si esta definida para topar, recalcular los que exceden el tope
    If @cTope = 'S'
      Update Tmp_p_Despensa Set Total = Tmp_p_Despensa.Dias * IsNull(@nUma,@nSalMin)
      Where Tmp_p_Despensa.Total > Tmp_p_Despensa.Dias * IsNull(@nUma,@nSalMin)
    --


    -- Si tiene comisiones y despensa en % calcular la despensa por estos importes
    -- considerando si esta topada o no
    Update Tmp_p_Despensa Set DespComisiones = Case When @cTope <> 'S' Or Tmp_p_Despensa.Total + (Tmp_p_Despensa.Comisiones * Tmp_p_Despensa.Despensa / 100) <= @nSalMin * Tmp_p_Despensa.Dias
                                                  Then Tmp_p_Despensa.Comisiones * Tmp_p_Despensa.Despensa / 100
                                                  --Else ((Tmp_p_Despensa.Total + (Tmp_p_Despensa.Comisiones * Tmp_p_Despensa.Despensa / 100)) - @nSalMin * Tmp_p_Despensa.Dias) - Tmp_p_Despensa.Total End
                                                  Else (@nSalMin * Tmp_p_Despensa.Dias) - Tmp_p_Despensa.Total End
    Where Tmp_p_Despensa.Comisiones > 0 And Tmp_p_Despensa.Despensa > 0 And (@cTope <> 'S' Or Tmp_p_Despensa.Total < IsNull(@nUma,@nSalMin) * Tmp_p_Despensa.Dias)

    /* Porque estaba asi?
    Update Tmp_p_Despensa Set DespComisiones = Case When Tmp_p_Despensa.Total + (Tmp_p_Despensa.Comisiones * Tmp_p_Despensa.Despensa / 100) <= @nSalDF * 0.4 * Tmp_p_Despensa.Dias
                                                  Then Tmp_p_Despensa.Comisiones * Tmp_p_Despensa.Despensa / 100
                                                  Else (Tmp_p_Despensa.Total + (Tmp_p_Despensa.Comisiones * Tmp_p_Despensa.Despensa / 100)) - @nSalDF * 0.4 * Tmp_p_Despensa.Dias End
    Where Tmp_p_Despensa.Comisiones > 0 And Tmp_p_Despensa.Despensa > 0 And (@cTope <> 'S' Or Tmp_p_Despensa.Total < @nSalDF * 0.4 * Tmp_p_Despensa.Dias)
    */
    --

    Update Tmp_p_Despensa Set Total = Tmp_p_Despensa.Total + Tmp_p_Despensa.DespComisiones


    -- Calcular el excedente para IMSS
    -- El campo Excede es el integrable total, pero una parte ya esta en las tablas de integracion
    -- el campo excedente es la parte variable a integrar, sobre todo si tiene variables que afectan
    -- la despensa y no estan considerados en las tablas de integracion
    Update Tmp_p_Despensa Set Excede    = Tmp_p_Despensa.Total - IsNull(@nUma,@nSalDF) * 0.4 * Tmp_p_Despensa.Dias,
                            Excedente = Case When Tmp_p_Despensa.Total - Tmp_p_Despensa.DespComisiones < IsNull(@nUma,@nSalDF) * 0.4 * Tmp_p_Despensa.Dias
                                             Then Tmp_p_Despensa.Total - IsNull(@nUma,@nSalDF) * 0.4 * Tmp_p_Despensa.Dias
                                             Else Tmp_p_Despensa.DespComisiones End
    Where Tmp_p_Despensa.Total > IsNull(@nUma,@nSalDF) * 0.4 * Tmp_p_Despensa.Dias
    --


    -- Calcular exento y gravable, si tiene la opcion de ajustar al mes hacer el proceso
    If @cMarca2 = 'M' And @cRedondea = 'S'
      Begin
        If @cIspt = 'S'
          Begin
            Update Tmp_p_Despensa Set Exento = Case When Tmp_p_Despensa.Total > IsNull(@nUma,@nSalMin) * Case When @cAjusta = 'AJUSTA' Then 30.4 Else Tmp_p_Despensa.Dias End
                                                  Then IsNull(@nUma,@nSalMin) * Case When @cAjusta = 'AJUSTA' Then 30.4 Else Tmp_p_Despensa.Dias End
                                                  Else Tmp_p_Despensa.Total End
            Update Tmp_p_Despensa Set Gravable = Tmp_p_Despensa.Total - Tmp_p_Despensa.Exento
          End
        Else
          Begin
            Update Tmp_p_Despensa Set Exento = Tmp_p_Despensa.Total,
                                    Gravable = 0
          End
      End

    Else
      Begin
        If @cAjusta = 'AJUSTA' And @cIspt = 'S'
          Begin

            Update Tmp_p_Despensa Set Exento = Case When Tmp_p_Despensa.Total+IsNull(Despensas.Total_Ant,0) > IsNull(@nUma,@nSalMin) * Case When @cAjusta = 'AJUSTA' Then 30.4 Else Tmp_p_Despensa.Dias+IsNull(Despensas.Dias_Ant,0) End
                                                  Then IsNull(@nUma,@nSalMin) * Case When @cAjusta = 'AJUSTA' Then 30.4 Else Tmp_p_Despensa.Dias+IsNull(Despensas.Dias_Ant,0) End
                                                  Else Tmp_p_Despensa.Total+IsNull(Despensas.Total_Ant,0)
                                             End - 
                                             IsNull(Despensas.Exento_Ant,0) - 
                                             Case When IsNull(Despensas.Grava_Ant,0) > 0 
                                                  Then 0
                                                  Else IsNull(Despensas.Redondeo_A,0)
                                             End
            From Tmp_p_Despensa
            Left Join p_Despensas as Despensas On Tmp_p_Despensa.Codigo = Despensas.Codigo And Despensas.id_presup = @id_presup

            Update Tmp_p_Despensa Set Gravable = (Tmp_p_Despensa.Total+IsNull(Despensas.Total_Ant,0)) - 
                                               Tmp_p_Despensa.Exento - 
                                               IsNull(Despensas.Exento_Ant,0) -
                                               IsNull(Despensas.Grava_Ant,0) - 
                                               Case When IsNull(Despensas.Grava_Ant,0) > 0 
                                                    Then IsNull(Despensas.Redondeo_A,0) 
                                                    Else 0 
                                               End
            From Tmp_p_Despensa
            Left Join p_Despensas as Despensas On Tmp_p_Despensa.Codigo = Despensas.Codigo And Despensas.id_presup = @id_presup

          End
        Else
          Begin
            If @cIspt = 'S'
              Begin
                Update Tmp_p_Despensa Set Exento   = Case When Tmp_p_Despensa.Total < IsNull(@nUma,@nSalMin) * Tmp_p_Despensa.Dias Then Tmp_p_Despensa.Total Else IsNull(@nUma,@nSalMin) * Tmp_p_Despensa.Dias End
                Update Tmp_p_Despensa Set Gravable = Tmp_p_Despensa.Total - Tmp_p_Despensa.Exento
              End
            Else
              Update Tmp_p_Despensa Set Exento   = Tmp_p_Despensa.Total,
                                      Gravable = 0
          End
      End
    --

    -- Si se paga en la nomina especial, calcular el isr sobre la despensa gravable
    If @cMarca1 <> 'O' And
       -- 20 Feb 2013
       -- Para las empresas American Beef, de Alicia...calcular el ISR de la despensa
       -- junto con el gravable de la nomina ordinaria; aun cuando esta se paga en la nomina especial (T)
       -- se ajustaro tambien el SP asp_Fun_R_Impuestos2008 para que sume la base gravable de la
       -- despensa al gravable de la nomina ordinaria antes de determinar el ISR
       @cRegPat Not In ('A804212010','B941937710','Y606234910')
       
      Update Tmp_p_Despensa Set Ispt = dbo.Fun_R_Isr_Periodico(Tmp_p_Despensa.Gravable/Tmp_p_Despensa.Dias*30.4, 30.4, 0, Year(@dPago), 7, Tmp_p_Despensa.Empresa)/30.4*Tmp_p_Despensa.Dias
      Where Tmp_p_Despensa.Gravable > 0 And Tmp_p_Despensa.Dias > 0
    --


    -- Redondear
    If @cRedondea = 'S' And @nRedondea <> 0
      Update Tmp_p_Despensa Set Redondeo = dbo.Fun_R_SacaDecimales(Tmp_p_Despensa.Total-(Case When @cMarca1 <> 'O' And @nDisminuye = 1 Then Tmp_p_Despensa.Ispt Else 0 End), Case When @nRedondea = 1 Then 'P' Else 'C' End,'A')
    --


    -- Recalcular los excedentes y gravables considerando el redondeo
    Update Tmp_p_Despensa Set Excede    = Tmp_p_Despensa.Excede    - Case When Tmp_p_Despensa.Excede > 0 Then Tmp_p_Despensa.Redondeo Else 0 End,
                            Excedente = Tmp_p_Despensa.Excedente - Case When Tmp_p_Despensa.Excedente > 0 Then Tmp_p_Despensa.Redondeo Else 0 End,
                            Gravable  = Tmp_p_Despensa.Gravable  - Case When Tmp_p_Despensa.Gravable > 0 Then Tmp_p_Despensa.Redondeo Else 0 End,
                            Exento    = Tmp_p_Despensa.Exento    - Case When Tmp_p_Despensa.Exento > 0 And Tmp_p_Despensa.Gravable = 0 Then Tmp_p_Despensa.Redondeo Else 0 End,
                            Neto      = Tmp_p_Despensa.Total - (Case When @nDisminuye = 1 Then Tmp_p_Despensa.Ispt Else 0 End) - Tmp_p_Despensa.Redondeo,
                            -- Para evitar diferencias de centavos a fin de ao, ajustar el total con el redondeo y desaparecer este ultimo
                            -- ya que el neto a pagar se debe guardar como despensa y daba diferencias por los centavos redondeados.
                            -- 22/Feb/2012
                            Total     = Tmp_p_Despensa.Total - Tmp_p_Despensa.Redondeo,
                            Redondeo  = 0
    --


    -- Eliminar registros con Neto = 0
    Delete Despensas
    From p_Despensas as Despensas
    Inner Join Llaves On Llaves.Codigo = Despensas.Codigo And Llaves.Empresa = Despensas.Empresa
    Where Llaves.TipoNom = @nTipoNom And
          Despensas.Total+Case When @cMarca2 = 'P' AND @cAjusta <> 'AJUSTA' Then 0 Else Despensas.Total_Ant End <= 0 And
          Despensas.id_presup = @id_presup
    --


    -- Actualizar los registros que si existen en la tabla de Despensas con los importes y parametros calculados
    Update Despensas Set Importe   = Tmp_p_Despensa.DespensaIm,
                         Porciento = Tmp_p_Despensa.Despensa,
                         Sueldo    = Tmp_p_Despensa.Sueldo,
                         Nomina    = 'O',
                         Dias      = Tmp_p_Despensa.Dias,
                         Aus       = Tmp_p_Despensa.DsFaltas,
                         Inc       = Tmp_p_Despensa.DsIncap,
                         Total     = Tmp_p_Despensa.Total,
                         FchInicio = Tmp_p_Despensa.Fch_Inicio,
                         FchCierre = Tmp_p_Despensa.Fch_Cierre,
                         FchPago   = @dPago,
                         Pagada    = IsNull(Tmp_p_Despensa.Pagada , Case When (@cRedondea = 'S' And @cMarca2 = 'M') Or @cMarca2 = 'P' Then 'S' Else 'N' End),
                         Pagarla   = IsNull(Tmp_p_Despensa.Pagarla, Case When (@cRedondea = 'S' And @cMarca2 = 'M') Or @cMarca2 = 'P' Then 'S' Else 'N' End),
                         Marca     = 'T',
                         Excede    = Tmp_p_Despensa.Excede,
                         Excedente = Tmp_p_Despensa.Excedente,
                         Exento    = Tmp_p_Despensa.Exento,
                         Gravable  = Tmp_p_Despensa.Gravable,
                         Ispt      = Tmp_p_Despensa.Ispt,
                         Redondeo  = Tmp_p_Despensa.Redondeo,
                         Neto      = Tmp_p_Despensa.Neto,
                         Comision  = Tmp_p_Despensa.Comisiones
    From p_Despensas as Despensas
    Left Join Tmp_p_Despensa On Despensas.Codigo = Tmp_p_Despensa.Codigo And Despensas.id_presup = id_presup
    Inner Join P_Empleados_Pres as Llaves On Despensas.Codigo = Llaves.Codigo And Despensas.Empresa = Llaves.Empresa And Despensas.id_presup = Llaves.id_presup
    Inner Join Clases On Llaves.Clase = Clases.Clase And Llaves.Empresa = Clases.Empresa
    Where Llaves.TipoNom = @nTipoNom And
          Despensas.id_presup = @id_presup And
          Clases.ValesDesp = 'N'
    --


    -- Agregar los que no existan
    Insert Into p_Despensas (id_presup, Codigo,Empresa,Sueldo,Importe,Porciento,FchInicio,FchCierre,FchPago,Dias,Aus,
                           Inc,Comision,Total,Gravable,Exento,Ispt,Redondeo,Neto,Excedente,Excede,
                           Inicio_Ant,Cierre_Ant,Pago_Ant,Dias_Ant,Aus_Ant,Inc_Ant,Comision_A,
                           Total_Ant,Grava_Ant,Exento_Ant,Redondeo_A,Nomina,Marca,Pagada,Pagarla,mes_operacion,ayo_operacion)
    (
     Select @id_presup,
			Tmp_p_Despensa.Codigo,
            Tmp_p_Despensa.Empresa As Empresa,
            Tmp_p_Despensa.Sueldo,
            Tmp_p_Despensa.DespensaIm As Importe,
            Tmp_p_Despensa.Despensa As Porciento,
            Tmp_p_Despensa.Fch_Inicio As FchInicio,
            Tmp_p_Despensa.Fch_Cierre As FchCierre,
            @dPago As FchPago,
            Tmp_p_Despensa.Dias,
            Tmp_p_Despensa.DsFaltas As Aus,
            Tmp_p_Despensa.DsIncap As Inc,
            Tmp_p_Despensa.Comisiones As Comision,
            Tmp_p_Despensa.Total,
            Tmp_p_Despensa.Gravable,
            Tmp_p_Despensa.Exento,
            Tmp_p_Despensa.Ispt,
            Tmp_p_Despensa.Redondeo,
            Tmp_p_Despensa.Neto,
            Tmp_p_Despensa.Excedente,
            Tmp_p_Despensa.Excede,
            NULL As Inicio_Ant,
            NULL As Cierre_Ant,
            NULL As Pago_Ant,
            0 As Dias_Ant,
            0 As Aus_Ant,
            0 As Inc_Ant,
            0 As Comision_Ant,
            0 As Total_Ant,
            0 As Grava_Ant,
            0 As Exento_Ant,
            0 As Redondeo_A,
            'O' As Nomina,
            'T' As Marca,
            Tmp_p_Despensa.Pagada,
            Tmp_p_Despensa.Pagarla,
			@mes,
			@ayo
      From Tmp_p_Despensa
      Inner Join P_Empleados_Pres as  Llaves On Llaves.Codigo = Tmp_p_Despensa.Codigo And Llaves.Empresa = Tmp_p_Despensa.Empresa and Llaves.id_presup=@id_presup
      Inner Join Clases On Llaves.Clase = Clases.Clase And Llaves.Empresa = Clases.Empresa
      Where NOT Exists (Select Codigo From p_Despensas Where Codigo = Tmp_p_Despensa.Codigo And id_presup = @id_presup) And
            Tmp_p_Despensa.Neto > 0 And
            Clases.ValesDesp = 'N'

    )
    --


    -- Para Radial, buscar las contras de Despensa y descontarlas del campo Neto de la tabla DESPENSAS
    -- porque de ahi se genera el disco de pago y quieren que salga el neto real
    --If @cRegPat In ('0407407810','B901592910','5501198410','8301375610','E741243110','8401627210','L013704310','E753836710','8401564610','R142854310','B983076510','R142972110','A481766710','A102803610','R125925010')
      UpDate Despensas
      Set Neto = Despensas.Neto - IsNull(Kardex.Importe,0)
      From p_Despensas as Despensas
      Left Join p_Kardex as Kardex On Kardex.Codigo = Despensas.Codigo And Kardex.Num_Conc = 1031 And Kardex.Empresa = Despensas.Empresa and kardex.id_presup=@id_presup
      Inner Join P_Empleados_Pres as  Llaves On Llaves.Codigo = Despensas.Codigo And Llaves.Empresa = Despensas.Empresa and Llaves.id_presup=@id_presup
      Where Llaves.TipoNom = @nTipoNom And Despensas.id_presup = @id_presup and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    --


    -- Si se paga en la nomina especial, determinar el ISN
    Delete Kardex
    From p_Kardex as Kardex
    Inner Join P_Empleados_Pres as  Llaves On Llaves.empresa = Kardex.empresa and Llaves.Codigo = Kardex.Codigo And Llaves.id_presup = @id_presup
    Where Llaves.TipoNom = @nTipoNom And
          Kardex.Num_Conc = 216 And
          Kardex.Nomina = 'DES' And
          Kardex.id_presup = @id_presup
		  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
    
    --If @cMarca1 <> 'O' And
    --   Exists (Select Num_Conc
    --           From Conceptos
    --           Where Num_Conc = 216 And
    --                 CharIndex(',31,',Totales) > 0 And
    --                 Empresa = @nEmpresa)
    --  Begin
    
    --    Declare @nCodigo    Integer
    --    Declare @nIsn       Numeric(12,2)
    --    Declare @cFormula   VarChar(500)
    --    Declare @cTotales   VarChar(1000)
    --    Declare @cClase     VarChar(2)
    --    Declare @cCentro    VarChar(14)
    --    Declare @nDespensa  Numeric(12,2)
        
        Declare @tIsn Table
        (
          Codigo INTEGER,
          Isn    NUMERIC(10,2),
          Base   NUMERIC(10,2),
          Clase  VARCHAR(2),
          Centro VARCHAR(14)
        )

    --    Declare CursorIsn  Cursor
    --    For
    --      Select Despensas.Codigo,
    --             Despensas.Total
    --      From Despensas
    --      Inner Join Llaves On Llaves.Codigo = Despensas.Codigo And Llaves.Empresa = Despensas.Empresa
    --      Where IsNull(Despensas.Total,0) <> 0 And
    --            Llaves.TipoNom = @nTipoNom And
    --            Despensas.Empresa = @nEmpresa

    --    Open CursorIsn

    --    Fetch Next From CursorIsn Into @nCodigo,
    --                                   @nDespensa

    --    While (@@FETCH_STATUS <> -1)
    --      Begin

    --        Select Top 1 @cFormula   = Conceptos.Formula,
    --                     @cTotales   = Conceptos.Totales,
    --                     @cClase     = Conceptos.Clase,
    --                     @cCentro    = Conceptos.Centro
    --        From Conceptos
    --        Inner Join Llaves On Llaves.Codigo = @nCodigo And Llaves.Empresa = @nEmpresa
    --        Where Conceptos.Num_Conc = 216 And
    --              (Conceptos.Clase = '' Or Conceptos.Clase = Llaves.Clase) And
    --              (Conceptos.Centro = '' Or Conceptos.Centro = Llaves.Centro) And
    --              Conceptos.Empresa = @nEmpresa

    --        If Len(@cFormula) > 0 And Len(@cTotales) > 0 And CharIndex(',31,',@cTotales) > 0
    --          Exec dbo.EvaluateFormulate @nCodigo, @nEmpresa, @cFormula, 0, 0, 0, 0, 0, 0, @nDespensa, 0, 0, 0, 0, 0, @nIsn OUTPUT
    --        Else
    --          Set @nIsn = 0

    --        Insert Into @tIsn(Codigo, Isn, Base, Clase, Centro)
    --        Values (@nCodigo, @nIsn, @nDespensa, @cClase, @cCentro)
      
    --        Fetch Next From CursorIsn Into @nCodigo,
    --                                       @nDespensa

    --      End

    --    Close CursorIsn

    --    Deallocate CursorIsn

        --Insert Into p_Kardex (Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago,
        --                    Dias, Inc, Aus, DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu,
        --                    Despensa, Mca_Agui, FdoAhorro, Calculo, Impor_Base, SalDiaInt, Tipo_Mov, Importe, IGravable, IExento,
        --                    Masivo, Formula, Ispt_Ng, Imss_Ni, Marca)
        --Select tIsn.Codigo,
        --       Despensas.Empresa As Empresa,
        --       'DES' As Nomina,
        --       tIsn.Centro,
        --       216 As Num_Conc,
        --       tIsn.Clase,
        --       0 As Folio,
        --       0 As Renglon,
        --       Despensas.FchInicio As Fch_Inicio,
        --       Despensas.FchCierre As Fch_Cierre,
        --       Despensas.FchPago As Fch_Pago,
        --       0 As Dias,
        --       0 As Inc,
        --       0 As Aus,
        --       0 As DiasTr,
        --       0 As Dias_Imss,
        --       'I' As TPago_Desc,
        --       Conceptos.Concepto,
        --       0 As VariaImss,
        --       0 As Variable,
        --       Conceptos.Imss,
        --       Conceptos.Ispt,
        --       Conceptos.Ptu,
        --       Conceptos.Despensa,
        --       Conceptos.Mca_Agui,
        --       Conceptos.FdoAhorro,
        --       'A' As Calculo,
        --       tIsn.Base As Impor_Base,
        --       0 As SalDiaInt,
        --       'PRO' As Tipo_Mov,
        --       tIsn.Isn As Importe,
        --       0 As IGravable,
        --       0 As IExento,
        --       'F' As Masivo,
        --       '' As Formula,
        --       '' As Ispt_NG,
        --       '' As Imss_NI,
        --       '' As Marca
        --From @tIsn As tIsn
        --Inner Join Conceptos On Conceptos.Num_Conc = 216 And Conceptos.Clase = tIsn.Clase And Conceptos.Centro = tIsn.Centro And Conceptos.Empresa = tIsn.Empresa
        --Inner Join p_Despensas as Despensas On Despensas.Codigo = tIsn.Codigo And Despensas.id_presup = @id_presup
      
     -- End
    -- 13 Agosto 2015


    Drop Table dbo.Tmp_p_Despensa
    Drop Table dbo.Tmp_p_Aus
    Drop Table dbo.Tmp_p_Comision

  End

GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_Importa_Presup')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_Importa_Presup
GO


CREATE PROCEDURE dbo.p_Importa_Presup
    @id_presup INT ,
    @cDias CHAR(1) ,
    @cConc CHAR(1) ,
    @cAltas CHAR(1) ,
    @cSals CHAR(1) ,
    @cMS CHAR(1)
AS 
    DECLARE @id_presup_ant INT

    SET @id_presup_ant = @id_presup - 1  
    PRINT @id_presup
    PRINT @id_presup_ant
    DELETE  dbo.p_Kardex
    WHERE   id_presup = @id_presup

    IF @cDias = 'S' 
        BEGIN

            UPDATE  a
            SET     dias = b.dias
            FROM    dbo.p_dias AS a
                    INNER JOIN dbo.p_dias AS b ON b.tiponom = a.tiponom
                                                  AND b.mes = a.mes
                                                  AND b.ejercicio = a.ejercicio
                                                  AND b.id_presup = @id_presup_ant
            WHERE   a.id_presup = @id_presup

	
        END


    IF @cConc = 'S' 
        BEGIN

            DELETE  dbo.p_conc_pres_nomina
            WHERE   id_presup = @id_presup

            DELETE  dbo.p_conc_pres
            WHERE   id_presup = @id_presup

            SELECT  *
            INTO    #tmp_conc_pres
            FROM    dbo.p_conc_pres
            WHERE   id_presup = @id_presup_ant

            SELECT  *
            INTO    #tmp_conc_pres_nomi
            FROM    dbo.p_conc_pres_nomina
            WHERE   id_presup = @id_presup_ant


            UPDATE  #tmp_conc_pres
            SET     id_presup = @id_presup
            UPDATE  #tmp_conc_pres_nomi
            SET     id_presup = @id_presup 

            INSERT  INTO dbo.p_conc_pres
                    SELECT  *
                    FROM    #tmp_conc_pres
            INSERT  INTO dbo.p_conc_pres_nomina
                    SELECT  *
                    FROM    #tmp_conc_pres_nomi

            DROP TABLE #tmp_conc_pres      
            DROP TABLE #tmp_conc_pres_nomi 
        END

    IF @cAltas = 'S' 
        BEGIN
--	Select * from p_empleados_pres
	
            DELETE  dbo.p_percepciones
            WHERE   id_presup = @id_presup
                    AND codigo >= 90000000	

            DELETE  dbo.p_avisos_imss
            WHERE   id_presup = @id_presup
                    AND codigo >= 90000000

            DELETE  dbo.p_empleados_pres
            WHERE   id_presup = @id_presup
                    AND codigo >= 90000000
                    AND empresa IN ( SELECT empresa
                                     FROM   dbo.p_empresas
                                     WHERE  id_presup = @id_presup )
	
            SELECT  *
            INTO    #tmp_p_empleados
            FROM    dbo.p_empleados_pres
            WHERE   id_presup = @id_presup_ant
                    AND codigo >= 90000000
                    AND empresa IN ( SELECT empresa
                                     FROM   dbo.p_empresas
                                     WHERE  id_presup = @id_presup )

            SELECT  *
            INTO    #tmp_p_avisos_imss
            FROM    dbo.p_avisos_imss
            WHERE   id_presup = @id_presup_ant
                    AND codigo >= 90000000
                    --AND mov = 'A'
                    AND empresa IN ( SELECT empresa
                                     FROM   dbo.p_empresas
                                     WHERE  id_presup = @id_presup )
	
            UPDATE  a
            SET     a.id_presup = @id_presup ,
                    a.sueldo = ( SELECT sueldo
                                 FROM   dbo.p_avisos_imss
                                 WHERE  id_presup = @id_presup_ant
                                        AND codigo = a.codigo
                                        AND empresa = a.empresa
                                        AND mov = 'A'
                               ) ,
                    a.saldiaint = ( SELECT  saldiaint
                                    FROM    dbo.p_avisos_imss
                                    WHERE   id_presup = @id_presup_ant
                                            AND codigo = a.codigo
                                            AND empresa = a.empresa
                                            AND mov = 'A'
                                  )
            FROM    #tmp_p_empleados AS a

            UPDATE  a
            SET     a.id_presup = @id_presup ,
                    a.sueldo = ( SELECT sueldo
                                 FROM   dbo.p_avisos_imss
                                 WHERE  id_presup = @id_presup_ant
                                        AND codigo = a.codigo
                                        AND empresa = a.empresa
                                        AND mov = 'A'
                               ) ,
                    a.saldiaint = ( SELECT  saldiaint
                                    FROM    dbo.p_avisos_imss
                                    WHERE   id_presup = @id_presup_ant
                                            AND codigo = a.codigo
                                            AND empresa = a.empresa
                                            AND mov = 'A'
                                  )
            FROM    #tmp_p_avisos_imss AS a
            
            INSERT  INTO dbo.p_empleados_pres
                    SELECT  *
                    FROM    #tmp_p_empleados
            INSERT  INTO dbo.p_avisos_imss
                    SELECT  *
                    FROM    #tmp_p_avisos_imss

            DROP TABLE #tmp_p_avisos_imss
            DROP TABLE #tmp_p_empleados

        END

    IF @cSals = 'S' 
        BEGIN

            DELETE  dbo.p_salmin
            WHERE   id_presup = @id_presup
	
            SELECT  *
            INTO    #tmp_p_salmin
            FROM    dbo.p_salmin
            WHERE   id_presup = @id_presup_ant

            UPDATE  #tmp_p_salmin
            SET     id_presup = @id_presup
	
            INSERT  INTO dbo.p_salmin
                    SELECT  *
                    FROM    #tmp_p_salmin

            DROP TABLE #tmp_p_salmin

            UPDATE  dbo.p_parametro
            SET     prima_rt = ( SELECT prima_rt
                                 FROM   dbo.p_parametro
                                 WHERE  id_presup = @id_presup_ant
                               )
            WHERE   id_presup = @id_presup

--	select * from p_parametro

        END

    IF @cMS = 'S' 
        BEGIN
--	Select * from p_empleados_pres
	
            DELETE  dbo.p_avisos_imss
            WHERE   id_presup = @id_presup
                    AND mov = 'MS'
	
            SELECT  *
            INTO    #tmp_p_avisos_imss_ms
            FROM    dbo.p_avisos_imss
            WHERE   id_presup = @id_presup_ant
                    AND mov = 'MS'
                    AND empresa IN ( SELECT empresa
                                     FROM   dbo.p_empresas
                                     WHERE  id_presup = @id_presup )
            ORDER BY codigo
	
              
            UPDATE  a
            SET     id_presup = @id_presup ,
                    serial = serial + 3
            FROM    #tmp_p_avisos_imss_ms AS a

            INSERT  INTO dbo.p_avisos_imss
                    SELECT  *
                    FROM    #tmp_p_avisos_imss_ms
                    ORDER BY mes_operacion ,
                            codigo

            DROP TABLE #tmp_p_avisos_imss_ms

        END

    EXEC dbo.Update_Salarys @id_presup
GO



IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.plantillas')
                        AND name = 'idtipo' ) 
    ALTER TABLE plantillas ALTER COLUMN idtipo CHAR(1) 
GO

--update plantillas set idtipo='P' where idtipo=1 or idtipo=2

/*Actualiza los campos*/


IF EXISTS ( SELECT  *
            FROM    dbo.syscolumns
            WHERE   id = OBJECT_ID('dbo.plantillas')
                    AND name = 'autorizada' ) 
    ALTER TABLE dbo.plantillas DROP COLUMN autorizada 
GO



IF EXISTS ( SELECT  *
            FROM    dbo.syscolumns
            WHERE   id = OBJECT_ID('dbo.plantillas')
                    AND name = 'motivo' ) 
    ALTER TABLE plantillas DROP COLUMN motivo
GO


IF EXISTS ( SELECT  *
            FROM    dbo.syscolumns
            WHERE   id = OBJECT_ID('dbo.presupuesto_autorizado')
                    AND name = 'plantillas' ) 
    ALTER TABLE plantillas DROP COLUMN presupuesto_autorizado 
GO


IF EXISTS ( SELECT  syscolumns.name
            FROM    syscolumns
                    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
            WHERE   syscolumns.name = 'fecha_autorizada'
                    AND sysobjects.name = 'plantillas' ) 
    EXEC sp_rename 'plantillas.fecha_autorizada', 'fechainicio', 'COLUMN' 
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'fechainicio'
                        AND sysobjects.name = 'plantillas' ) 
    ALTER TABLE plantillas ADD fechainicio DATETIME
GO

IF EXISTS ( SELECT  syscolumns.name
            FROM    syscolumns
                    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
            WHERE   syscolumns.name = 'fecha_termino'
                    AND sysobjects.name = 'plantillas' ) 
    EXEC sp_rename 'plantillas.fecha_termino', 'fechafinal', 'COLUMN' 
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'fechafinal'
                        AND sysobjects.name = 'plantillas' ) 
    ALTER TABLE plantillas ADD fechafinal DATETIME
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'fechafinal'
                        AND sysobjects.name = 'plantillas' ) 
    ALTER TABLE plantillas ADD fechafinal DATETIME
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'staffing'
                        AND sysobjects.name = 'plantillas' ) 
    ALTER TABLE plantillas ADD staffing CHAR(1)

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'centro'
                        AND sysobjects.name = 'plantillas_puestos' ) 
    ALTER TABLE plantillas_puestos ADD centro CHAR(15)

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'clase'
                        AND sysobjects.name = 'plantillas_puestos' ) 
    BEGIN
        ALTER TABLE dbo.plantillas_puestos ADD clase CHAR(2) 
        ALTER TABLE dbo.plantillas_puestos ADD horario INT NULL 
        ALTER TABLE dbo.plantillas_puestos ADD tiposal INT NULL 
        ALTER TABLE dbo.plantillas_puestos ADD sueldo DECIMAL(12,2) 
        ALTER TABLE dbo.plantillas_puestos ADD sindicato CHAR(1) 
        ALTER TABLE dbo.plantillas_puestos ADD varia_imss DECIMAL(8,2) NULL
        ALTER TABLE dbo.plantillas_puestos ADD reqAutorizacion CHAR(1) NULL
        ALTER TABLE dbo.plantillas_puestos ADD nivelAutorizacion INT NULL 
        ALTER TABLE dbo.plantillas_puestos ADD autorizador1 VARCHAR(50) NULL
        ALTER TABLE dbo.plantillas_puestos ADD autorizador2 VARCHAR(50) NULL
        ALTER TABLE dbo.plantillas_puestos ADD autorizador3 VARCHAR(50) NULL
        ALTER TABLE dbo.plantillas_puestos ADD autorizador4 VARCHAR(50) NULL 
        ALTER TABLE dbo.plantillas_puestos ADD cetron CHAR(15) NULL 
        ALTER TABLE dbo.plantillas_puestos ADD tiponom INT NULL 
    END 

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'p_Plantillas')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE [dbo].[p_Plantillas]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL
                                        DEFAULT ( 0 ) ,
              [plantilla_id] [bigint] IDENTITY(1, 1)
                                      NOT NULL ,
              [nombre] [varchar](40) NOT NULL ,
              [idtipo] [char](1) NULL ,
              [fechainicio] [datetime] NULL ,
              [fechafinal] [datetime] NULL ,
              [staffing] [char](1) NULL ,
              CONSTRAINT [PK666112] PRIMARY KEY NONCLUSTERED
                ( [id_presup] ASC, [empresa] ASC, [plantilla_id] ASC )
            )
        ON  [PRIMARY]

    END

GO


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_Plantillas_Centros')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE [dbo].[p_Plantillas_Centros]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL
                                        DEFAULT ( 0 ) ,
              [centro] [char](15) NOT NULL ,
              [plantilla_id] [bigint] NOT NULL ,
              CONSTRAINT [p_Plantillas_centrosPK] PRIMARY KEY NONCLUSTERED
                ( [id_presup] ASC, [empresa] ASC, [centro] ASC, [plantilla_id] ASC )
            )
        ON  [PRIMARY]

        ALTER TABLE [dbo].[p_Plantillas_Centros]  WITH CHECK ADD  CONSTRAINT [Refcentros666855] FOREIGN KEY([centro], [empresa])
        REFERENCES [dbo].[centros] ([centro], [empresa])

        ALTER TABLE [dbo].[p_Plantillas_Centros] CHECK CONSTRAINT [Refcentros666855]

        ALTER TABLE [dbo].[p_Plantillas_Centros]  WITH CHECK ADD  CONSTRAINT [Refp_Plantillas666854] FOREIGN KEY([id_presup],[empresa], [plantilla_id])
        REFERENCES [dbo].[p_Plantillas] ([id_presup],[empresa], [plantilla_id])

        ALTER TABLE [dbo].[p_Plantillas_Centros] CHECK CONSTRAINT [Refp_Plantillas666854]

    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_Plantillas_Puestos')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE [dbo].[p_Plantillas_Puestos]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NULL
                                        DEFAULT ( 0 ) ,
              [plantilla_id] [bigint] NULL ,
              [ocupacion] [int] NULL
                                DEFAULT ( 0 ) ,
              [cantidad] [int] NULL ,
              [disponibles] [int] NULL ,
              [clase] [char](2) NULL ,
              [horario] [int] NULL ,
              [tiposal] [int] NULL ,
              [sueldo] [decimal](12, 2) NULL ,
              [sindicato] [char](1) NULL ,
              [varia_imss] [decimal](8, 2) NULL ,
              [reqAutorizacion] [char](1) NULL ,
              [nivelAutorizacion] [int] NULL ,
              [autorizador1] [varchar](50) NULL ,
              [autorizador2] [varchar](50) NULL ,
              [autorizador3] [varchar](50) NULL ,
              [autorizador4] [varchar](50) NULL ,
              [centro] [char](15) NULL ,
              [tiponom] [int] NULL
            )
        ON  [PRIMARY]

        ALTER TABLE [dbo].[p_Plantillas_Puestos]  WITH CHECK ADD  CONSTRAINT [Refp_Plantillas666852] FOREIGN KEY([id_presup],[empresa], [plantilla_id])
        REFERENCES [dbo].[p_Plantillas] ([id_presup],[empresa], [plantilla_id])

        ALTER TABLE [dbo].[p_Plantillas_Puestos] CHECK CONSTRAINT [Refp_Plantillas666852]

        ALTER TABLE [dbo].[p_Plantillas_Puestos]  WITH CHECK ADD  CONSTRAINT [Reftabulador666853] FOREIGN KEY([empresa], [ocupacion])
        REFERENCES [dbo].[tabulador] ([empresa], [ocupacion])

        ALTER TABLE [dbo].[p_Plantillas_Puestos] CHECK CONSTRAINT [Reftabulador666853]

    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_plantilla_propuestos')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
	
        CREATE TABLE [dbo].[p_plantilla_propuestos]
            (
              [id_presup] [int] NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL ,
              [idPlantilla] [bigint] NOT NULL ,
              [ocupacion] [int] NOT NULL ,
              [tipo] [char](1) NOT NULL ,
              [clave] [numeric](8, 0) NOT NULL ,
              [autorizado] [char](1) NULL ,
              [tiponom] [int] NULL ,
              [clase] [char](2) NULL ,
              [horario] [int] NULL ,
              [tiposal] [int] NULL ,
              [sueldo] [decimal](12, 2) NULL ,
              [sindicato] [char](1) NULL ,
              [varia_imss] [decimal](8, 2) NULL ,
              [centro] [char](15) NOT NULL ,
              CONSTRAINT [PK_p_plantilla_propuestos] PRIMARY KEY CLUSTERED
                ( [id_presup] ASC, [empresa] ASC, [idPlantilla] ASC, [ocupacion] ASC, [tipo] ASC, [clave] ASC, [centro] ASC )
            )
        ON  [PRIMARY]
    END 

GO

--drop table p_plantillas_puestosTemp  drop table p_Plantillas_CentrosTemp drop table p_plantillasTemp

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_PlantillasTemp')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE [dbo].[p_PlantillasTemp]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL
                                        DEFAULT ( 0 ) ,
              [plantilla_id] [bigint] NOT NULL ,
              [nombre] [varchar](40) NOT NULL ,
              [idtipo] [char](1) NULL ,
              [fechainicio] [datetime] NULL ,
              [fechafinal] [datetime] NULL ,
              [staffing] [char](1) NULL ,
              CONSTRAINT [PK666612] PRIMARY KEY NONCLUSTERED
                ( [id_presup] ASC, [empresa] ASC, [plantilla_id] ASC )
            )
        ON  [PRIMARY]

    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_Plantillas_CentrosTemp')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE [dbo].[p_Plantillas_CentrosTemp]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL
                                        DEFAULT ( 0 ) ,
              [centro] [char](15) NOT NULL ,
              [plantilla_id] [bigint] NOT NULL ,
              CONSTRAINT [p_Plantillas_centrostempPK] PRIMARY KEY NONCLUSTERED
                ( [id_presup] ASC, [empresa] ASC, [centro] ASC, [plantilla_id] ASC )
            )
        ON  [PRIMARY]

        ALTER TABLE [dbo].[p_Plantillas_Centrostemp]  WITH CHECK ADD  CONSTRAINT [Refcentros666655] FOREIGN KEY([centro], [empresa])
        REFERENCES [dbo].[centros] ([centro], [empresa])

        ALTER TABLE [dbo].[p_Plantillas_CentrosTemp] CHECK CONSTRAINT [Refcentros666655]

        ALTER TABLE [dbo].[p_Plantillas_CentrosTemp]  WITH CHECK ADD  CONSTRAINT [Refp_PlantillasTemp666654] FOREIGN KEY([id_presup],[empresa], [plantilla_id])
        REFERENCES [dbo].[p_PlantillasTemp] ([id_presup],[empresa], [plantilla_id])

        ALTER TABLE [dbo].[p_Plantillas_CentrosTemp] CHECK CONSTRAINT [Refp_PlantillasTemp666654]

    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'p_Plantillas_PuestosTemp')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

        CREATE TABLE [dbo].[p_Plantillas_PuestosTemp]
            (
              [id_presup] [numeric](8, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NULL
                                        DEFAULT ( 0 ) ,
              [plantilla_id] [bigint] NULL ,
              [ocupacion] [int] NULL
                                DEFAULT ( 0 ) ,
              [cantidad] [int] NULL ,
              [disponibles] [int] NULL ,
              [clase] [char](2) NULL ,
              [horario] [int] NULL ,
              [tiposal] [int] NULL ,
              [sueldo] [decimal](12, 2) NULL ,
              [sindicato] [char](1) NULL ,
              [varia_imss] [decimal](8, 2) NULL ,
              [reqAutorizacion] [char](1) NULL ,
              [nivelAutorizacion] [int] NULL ,
              [autorizador1] [varchar](50) NULL ,
              [autorizador2] [varchar](50) NULL ,
              [autorizador3] [varchar](50) NULL ,
              [autorizador4] [varchar](50) NULL ,
              [centro] [char](15) NULL ,
              [tiponom] [int] NULL
            )
        ON  [PRIMARY]

        ALTER TABLE [dbo].[p_Plantillas_PuestosTemp]  WITH CHECK ADD  CONSTRAINT [Refp_PlantillasTemp666652] FOREIGN KEY([id_presup],[empresa], [plantilla_id])
        REFERENCES [dbo].[p_PlantillasTemp] ([id_presup],[empresa], [plantilla_id])

        ALTER TABLE [dbo].[p_Plantillas_PuestosTemp] CHECK CONSTRAINT [Refp_PlantillasTemp666652]

        ALTER TABLE [dbo].[p_Plantillas_PuestosTemp]  WITH CHECK ADD  CONSTRAINT [Reftabulador666653] FOREIGN KEY([empresa], [ocupacion])
        REFERENCES [dbo].[tabulador] ([empresa], [ocupacion])

        ALTER TABLE [dbo].[p_Plantillas_PuestosTemp] CHECK CONSTRAINT [Reftabulador666653]

    END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_PlantillaGeneral')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_PlantillaGeneral
GO

CREATE PROCEDURE [dbo].[p_PlantillaGeneral]
--Declare 
    @id_presup INT ,
    @empresa NUMERIC(4, 2)
AS --Set @id_presup = 1
--Set @empresa   = 3

    DECLARE @plantilla_id INT

--delete p_plantillas_puestos where id_presup=@id_presup and empresa=@empresa
--delete p_plantillas_centros where id_presup=@id_presup and empresa=@empresa
--delete p_plantillas where id_presup=@id_presup and empresa=@empresa and idtipo='G'

    IF OBJECT_ID('dbo.tmp_p_plantillas') IS NOT NULL 
        DROP TABLE dbo.tmp_p_plantillas
--select * from p_plantilla
    INSERT  INTO dbo.p_plantillas
            ( id_presup ,
              empresa ,
              nombre ,
              idtipo
            )
    VALUES  ( @id_presup ,
              @empresa ,
              'GENERAL' ,
              'G'
            )

    SELECT  a.centro ,
            a.ocupacion ,
            COUNT(DISTINCT ( a.codigo )) AS plazas
    INTO    dbo.tmp_p_plantillas
    FROM    dbo.llaves AS a
            INNER JOIN dbo.empleados AS b ON a.empresa = b.empresa
                                             AND a.codigo = b.codigo
                                             AND b.activo = 'S'
                                             AND b.ultmov <> 'B'
    WHERE   a.empresa = @empresa
    GROUP BY a.centro ,
            a.ocupacion

    SELECT  @plantilla_id = plantilla_id
    FROM    dbo.p_plantillas
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND idtipo = 'G'

    INSERT  INTO dbo.p_plantillas_centros
            ( id_presup ,
              empresa ,
              centro ,
              plantilla_id
            )
            SELECT  @id_presup ,
                    @empresa ,
                    centro ,
                    @plantilla_id
            FROM    dbo.tmp_p_plantillas
            GROUP BY centro
            ORDER BY centro


    INSERT  INTO dbo.p_plantillas_puestos
            ( id_presup ,
              empresa ,
              plantilla_id ,
              centro ,
              ocupacion ,
              cantidad ,
              tiponom
            )
            SELECT  @id_presup ,
                    @empresa ,
                    @plantilla_id ,
                    centro ,
                    ocupacion ,
                    plazas ,
                    0
            FROM    dbo.tmp_p_plantillas
            ORDER BY centro ,
                    ocupacion

    IF OBJECT_ID('dbo.tmp_p_plantillas') IS NOT NULL 
        DROP TABLE dbo.tmp_p_plantillas
--select * from p_plantillas_puestos

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PlantillasTemporales')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PlantillasTemporales
GO

CREATE PROCEDURE dbo.PlantillasTemporales
--Declare 
    @id_presup INT ,
    @empresa NUMERIC(3) ,
    @plantilla_id INT

-- exec PlantillasTemporales 5,2,0
AS --Set @empresa      = 2
--Set @id_presup    = 5
--Set @plantilla_id = 0


    IF @plantilla_id = 0 
        BEGIN 

            DELETE  dbo.p_plantilla_propuestos
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_puestosTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_centrosTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillasTemp
            WHERE   id_presup = @id_presup

            INSERT  INTO dbo.p_plantillasTemp
                    ( id_presup ,
                      empresa ,
                      plantilla_id ,
                      nombre ,
                      idtipo ,
                      fechainicio ,
                      fechafinal ,
                      staffing
                    )
                    SELECT  @id_presup ,
                            empresa ,
                            plantilla_id ,
                            nombre ,
                            idtipo ,
                            fechainicio ,
                            fechafinal ,
                            staffing
                    FROM    dbo.plantillas
                    WHERE   empresa = @empresa
                            AND idtipo = 'T'
	
            INSERT  INTO dbo.p_plantillas_centrosTemp
                    ( id_presup ,
                      empresa ,
                      centro ,
                      plantilla_id
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.centro ,
                            b.plantilla_id
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.plantillas_centros AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.plantilla_id
                    WHERE   a.empresa = @empresa
                            AND a.idtipo = 'T'
	
            INSERT  INTO dbo.p_plantillas_puestostemp
                    ( id_presup ,
                      empresa ,
                      plantilla_id ,
                      ocupacion ,
                      cantidad ,
                      disponibles ,
                      clase ,
                      horario ,
                      tiposal ,
                      sueldo ,
                      sindicato ,
                      varia_imss ,
                      centro ,
                      tiponom
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.plantilla_id ,
                            b.ocupacion ,
                            b.cantidad ,
                            b.disponibles ,
                            b.clase ,
                            b.horario ,
                            b.tiposal ,
                            b.sueldo ,
                            b.sindicato ,
                            b.varia_imss ,
                            b.centro ,
                            b.tiponom
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.plantillas_puestos AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.plantilla_id
                    WHERE   a.empresa = @empresa
                            AND a.idtipo = 'T'
	
            INSERT  INTO dbo.p_plantilla_propuestos
                    ( id_presup ,
                      empresa ,
                      idplantilla ,
                      ocupacion ,
                      tipo ,
                      clave ,
                      tiponom ,
                      clase ,
                      horario ,
                      tiposal ,
                      sueldo ,
                      sindicato ,
                      varia_imss ,
                      centro ,
                      autorizado
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.idplantilla ,
                            b.ocupacion ,
                            b.tipo ,
                            b.clave ,
                            b.tiponom ,
                            b.clase ,
                            b.horario ,
                            b.tiposal ,
                            b.sueldo ,
                            b.sindicato ,
                            b.varia_imss ,
                            b.centro ,
                            b.autorizado
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.p_plantilla_propuestos AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.idplantilla
                                                              AND b.autorizado = 'S'
                    WHERE   a.empresa = @empresa
                            AND a.idtipo = 'T'


        END


    IF @plantilla_id > 0 
        BEGIN 

            DELETE  dbo.p_plantilla_propuestos
            WHERE   idplantilla = @plantilla_id
            DELETE  dbo.p_plantillas_puestosTemp
            WHERE   plantilla_id = @plantilla_id
            DELETE  dbo.p_plantillas_centrosTemp
            WHERE   plantilla_id = @plantilla_id
            DELETE  dbo.p_plantillasTemp
            WHERE   plantilla_id = @plantilla_id

            INSERT  INTO dbo.p_plantillasTemp
                    ( id_presup ,
                      empresa ,
                      plantilla_id ,
                      nombre ,
                      idtipo ,
                      fechainicio ,
                      fechafinal ,
                      staffing
                    )
                    SELECT  @id_presup ,
                            empresa ,
                            plantilla_id ,
                            nombre ,
                            idtipo ,
                            fechainicio ,
                            fechafinal ,
                            staffing
                    FROM    dbo.plantillas
                    WHERE   empresa = @empresa
                            AND idtipo = 'T'
                            AND plantilla_id = @plantilla_id
	
            INSERT  INTO dbo.p_plantillas_centrosTemp
                    ( id_presup ,
                      empresa ,
                      centro ,
                      plantilla_id
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.centro ,
                            b.plantilla_id
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.plantillas_centros AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.plantilla_id
                    WHERE   a.empresa = @empresa
                            AND a.idtipo = 'T'
                            AND a.plantilla_id = @plantilla_id
	
            INSERT  INTO dbo.p_plantillas_puestostemp
                    ( id_presup ,
                      empresa ,
                      plantilla_id ,
                      ocupacion ,
                      cantidad ,
                      disponibles ,
                      clase ,
                      horario ,
                      tiposal ,
                      sueldo ,
                      sindicato ,
                      varia_imss ,
                      centro ,
                      tiponom
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.plantilla_id ,
                            b.ocupacion ,
                            b.cantidad ,
                            b.disponibles ,
                            b.clase ,
                            b.horario ,
                            b.tiposal ,
                            b.sueldo ,
                            b.sindicato ,
                            b.varia_imss ,
                            b.centro ,
                            b.tiponom
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.plantillas_puestos AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.plantilla_id
                    WHERE   a.empresa = @empresa
                            AND a.idtipo = 'T'
                            AND a.plantilla_id = @plantilla_id
	
            INSERT  INTO dbo.p_plantilla_propuestos
                    ( id_presup ,
                      empresa ,
                      idplantilla ,
                      ocupacion ,
                      tipo ,
                      clave ,
                      tiponom ,
                      clase ,
                      horario ,
                      tiposal ,
                      sueldo ,
                      sindicato ,
                      varia_imss ,
                      centro ,
                      autorizado
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.idplantilla ,
                            b.ocupacion ,
                            b.tipo ,
                            b.clave ,
                            b.tiponom ,
                            b.clase ,
                            b.horario ,
                            b.tiposal ,
                            b.sueldo ,
                            b.sindicato ,
                            b.varia_imss ,
                            b.centro ,
                            b.autorizado
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.p_plantilla_propuestos AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.idplantilla
                                                              AND b.autorizado = 'S'
                    WHERE   a.empresa = @empresa
                            AND a.idtipo = 'T'
                            AND a.plantilla_id = @plantilla_id


        END

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_Inicializa')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_Inicializa
GO 

CREATE PROCEDURE dbo.p_Inicializa
--Declare 
    @id_presup INT ,
    @Todo CHAR(1) ,
    @captura CHAR(1) ,
    @SoloImportes CHAR(1) ,
    @MS CHAR(1) ,
    @Baja CHAR(1) ,
    @Alta CHAR(1) ,
    @Tablas CHAR(1) ,
    @Conceptos CHAR(1) ,
    @PlanTemp CHAR(1)
AS /*
Set @id_presup    = 1
Set @Todo         = 'S'
Set @Captura      = 'N'
Set @SoloImportes = 'N'
Set @MS           = 'N'
Set @Baja         = 'N'
Set @Alta         = 'N'
Set @Tablas       = 'N'
Set @Conceptos    = 'N'
*/
    DELETE  dbo.p_poldisk
    WHERE   id_presup = @id_presup
    DELETE  dbo.p_polizas
    WHERE   id_presup = @id_presup
    DELETE  dbo.p_nomina_tot
    WHERE   id_presup = @id_presup
    DELETE  dbo.p_despensas
    WHERE   id_presup = @id_presup
    DELETE  dbo.p_kardex
    WHERE   id_presup = @id_presup
    DELETE  dbo.p_percepciones
    WHERE   id_presup = @id_presup


    IF @Todo = 'S' 
        BEGIN
			DELETE dbo.p_kardex_resumen_detalle
			WHERE   id_presup = @id_presup
			
			DELETE dbo.p_kardex_resumen_emps
			WHERE   id_presup = @id_presup
			
			
			DELETE dbo.p_kardex_empleados
			WHERE   id_presup = @id_presup

            DELETE  dbo.p_plantilla_propuestos
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_puestosTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_centrosTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillasTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_puestos
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_centros
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas
            WHERE   id_presup = @id_presup
            DELETE  p_pagos_Variables
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_avisos_imss
            WHERE   id_presup = @id_presup
            
			DELETE  dbo.p_empleados_pres
            WHERE   id_presup = @id_presup


            DELETE  dbo.p_tablas_int
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_dias
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_salmin
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_conc_pres_nomina
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_conc_pres
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_dias
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_SalMin
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_tablas_int
            WHERE   id_presup = @id_presup
            
			DELETE dbo.p_empresas
			WHERE   id_presup = @id_presup

			DELETE  dbo.p_parametro
            WHERE   id_presup = @id_presup

			DELETE  dbo.p_catalogo_pres
            WHERE   id_presup = @id_presup

        END

    IF @Captura = 'S' 
        BEGIN
			IF @Todo = 'S' 
                BEGIN
                    DELETE  dbo.p_pagos_variables_tiponom
                    WHERE   id_presup = @id_presup
                    PRINT 'Toda la Captura'
             END
        END
	IF @SoloImportes = 'S'
                BEGIN
                    UPDATE  dbo.p_pagos_variables_tiponom
                    SET     ene1 = 0 ,
                            feb1 = 0 ,
                            mar1 = 0 ,
                            abr1 = 0 ,
                            may1 = 0 ,
                            jun1 = 0 ,
                            jul1 = 0 ,
                            ago1 = 0 ,
                            sep1 = 0 ,
                            oct1 = 0 ,
                            nov1 = 0 ,
                            dic1 = 0 ,
                            ene2 = 0 ,
                            feb2 = 0 ,
                            mar2 = 0 ,
                            abr2 = 0 ,
                            may2 = 0 ,
                            jun2 = 0 ,
                            jul2 = 0 ,
                            ago2 = 0 ,
                            sep2 = 0 ,
                            oct2 = 0 ,
                            nov2 = 0 ,
                            dic2 = 0
                    WHERE   id_presup = @id_presup
                    
                    
                    PRINT 'Solo importes'
                END
    IF @MS = 'S' 
        BEGIN 
            IF OBJECT_ID('dbo.Tmp_p_eliminams') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.Tmp_p_eliminams
                END

            SELECT  empresa ,
                    codigo
            INTO    dbo.Tmp_p_eliminams
            FROM    dbo.p_avisos_imss
            WHERE   mov = 'MS'
                    AND id_presup = @id_presup
            GROUP BY empresa ,
                    codigo
	
            UPDATE  av
            SET     sueldo = e.sueldo_i ,
                    saldiaint = e.saldiaint_i
            FROM    dbo.Tmp_p_eliminams AS a
                    INNER JOIN dbo.p_empleados_pres AS e ON a.empresa = e.empresa
                                                            AND a.codigo = e.codigo
                                                            AND e.id_presup = @id_presup
                    INNER JOIN dbo.p_avisos_imss AS av ON e.empresa = av.empresa
                                                          AND e.codigo = av.codigo
                                                          AND e.id_presup = av.id_presup

            DELETE  av
            FROM    dbo.Tmp_p_eliminams AS a
                    INNER JOIN dbo.p_empleados_pres AS e ON a.empresa = e.empresa
                                                            AND a.codigo = e.codigo
                                                            AND e.id_presup = @id_presup
                    INNER JOIN dbo.p_avisos_imss AS av ON e.empresa = av.empresa
                                                          AND e.codigo = av.codigo
                                                          AND e.id_presup = av.id_presup
                                                          AND av.mov = 'MS'
	
            UPDATE  a
            SET     sueldo = a.sueldo_i ,
                    saldiaint = a.saldiaint_i
            FROM    dbo.p_empleados_pres AS a
            WHERE   a.id_presup = @id_presup
	
            IF OBJECT_ID('dbo.Tmp_p_eliminams') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.Tmp_p_eliminams
                END
        END

    IF @Baja = 'S' 
        BEGIN 
            IF OBJECT_ID('dbo.Tmp_p_eliminabaja') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.Tmp_p_eliminabaja
                END
	
            SELECT  a.empresa ,
                    a.codigo ,
                    a.fch_mov ,
                    a.sueldo ,
                    a.saldiaint
            INTO    dbo.Tmp_p_eliminabaja
            FROM    dbo.p_avisos_imss AS a
                    INNER JOIN dbo.p_empleados_pres AS b ON a.empresa = b.empresa
                                                            AND a.codigo = b.codigo
                                                            AND ( b.origen = 'P'
                                                              OR b.origen = 'N'
                                                              )
            WHERE   a.mov = 'B'
                    AND a.id_presup = @id_presup
            GROUP BY a.empresa ,
                    a.codigo ,
                    a.fch_mov ,
                    a.sueldo ,
                    a.saldiaint
	

            DECLARE @nEmp INT ,
                @nCod NUMERIC(8, 0) ,
                @FchMov DATETIME ,
                @mes_ini INT ,
                @mes_fin INT ,
                @ayo_ini INT ,
                @ayo_fin INT ,
                @sueldo NUMERIC(12, 2) ,
                @saldiaint NUMERIC(12, 2) ,
                @ayo_mov INT ,
                @fecha DATETIME ,
                @mes_mov INT ,
                @mes1 INT
            SELECT  @mes_ini = mes_inicio ,
                    @mes_fin = mes_final ,
                    @ayo_ini = ini_ejercicio ,
                    @ayo_fin = fin_ejercicio
            FROM    dbo.p_parametro
            WHERE   id_presup = @id_presup

            DECLARE Bajas CURSOR FOR

            SELECT empresa,codigo,fch_mov,sueldo,saldiaint
            FROM dbo.Tmp_p_eliminabaja

            OPEN Bajas
            FETCH FROM Bajas INTO @nEmp,@nCod,@FchMov,@sueldo,@saldiaint
            SET @ayo_mov = YEAR(@FchMov)	
            SET @mes_mov = MONTH(@FchMov)	
            WHILE ( @@FETCH_STATUS <> -1 ) 
                BEGIN
                    IF @ayo_ini = @ayo_fin --and @ayo_mov=@ayo_ini
                        BEGIN
                            SET @mes1 = @mes_mov + 1
                            WHILE @mes1 <= @mes_fin 
                                BEGIN
                                    SET @fecha = CAST(@ayo_mov AS CHAR(4))
                                        + ( CASE WHEN @mes1 <= 9
                                                 THEN '0'
                                                      + CAST(@mes1 AS CHAR(1))
                                                 WHEN @mes1 >= 10
                                                 THEN CAST(@mes1 AS CHAR(2))
                                            END ) + '01'
                                    PRINT @Fecha
                                    INSERT  INTO dbo.p_avisos_imss
                                            ( id_presup ,
                                              empresa ,
                                              serial ,
                                              codigo ,
                                              mov ,
                                              fch_mov ,
                                              sueldo ,
                                              saldiaint ,
                                              mes_operacion ,
                                              ayo_operacion
                                            )
                                    VALUES  ( @id_presup ,
                                              @nEmp ,
                                              1 ,
                                              @nCod ,
                                              'IM' ,
                                              @fecha ,
                                              @sueldo ,
                                              @saldiaint ,
                                              @mes1 ,
                                              @ayo_mov
                                            )
                                    SET @Mes1 = @Mes1 + 1
                                    CONTINUE
                                END

                        END
			--Update p_parametro set fin_ejercicio=2009
                    IF @ayo_ini < @ayo_fin --and @ayo_mov=@ayo_ini
                        BEGIN
                            SET @mes1 = @mes_mov + 1
                            WHILE @mes1 <= 12 
                                BEGIN
                                    SET @fecha = CAST(@ayo_mov AS CHAR(4))
                                        + ( CASE WHEN @mes1 <= 9
                                                 THEN '0'
                                                      + CAST(@mes1 AS CHAR(1))
                                                 WHEN @mes1 >= 10
                                                 THEN CAST(@mes1 AS CHAR(2))
                                            END ) + '01'
                                    PRINT @Fecha
                                    INSERT  INTO dbo.p_avisos_imss
                                            ( id_presup ,
                                              empresa ,
                                              serial ,
                                              codigo ,
                                              mov ,
                                              fch_mov ,
                                              sueldo ,
                                              saldiaint ,
                                              mes_operacion ,
                                              ayo_operacion
                                            )
                                    VALUES  ( @id_presup ,
                                              @nEmp ,
                                              1 ,
                                              @nCod ,
                                              'IM' ,
                                              @fecha ,
                                              @sueldo ,
                                              @saldiaint ,
                                              @mes1 ,
                                              @ayo_mov
                                            )
                                    SET @Mes1 = @Mes1 + 1
                                    CONTINUE
                                END
                            SET @Mes1 = 1
                            WHILE @mes1 <= @Mes_fin 
                                BEGIN
                                    SET @fecha = CAST(@ayo_fin AS CHAR(4))
                                        + ( CASE WHEN @mes1 <= 9
                                                 THEN '0'
                                                      + CAST(@mes1 AS CHAR(1))
                                                 WHEN @mes1 >= 10
                                                 THEN CAST(@mes1 AS CHAR(2))
                                            END ) + '01'
                                    PRINT @Fecha
                                    INSERT  INTO dbo.p_avisos_imss
                                            ( id_presup ,
                                              empresa ,
                                              serial ,
                                              codigo ,
                                              mov ,
                                              fch_mov ,
                                              sueldo ,
                                              saldiaint ,
                                              mes_operacion ,
                                              ayo_operacion
                                            )
                                    VALUES  ( @id_presup ,
                                              @nEmp ,
                                              1 ,
                                              @nCod ,
                                              'IM' ,
                                              @fecha ,
                                              @sueldo ,
                                              @saldiaint ,
                                              @mes1 ,
                                              @ayo_fin
                                            )
                                    SET @Mes1 = @Mes1 + 1
                                    CONTINUE
                                END

                        END
                    PRINT @nCod
                    FETCH NEXT FROM Bajas INTO @nEmp,@nCod,@FchMov,@sueldo,@saldiaint
                END
            DEALLOCATE Bajas 
            UPDATE  dbo.p_empleados_pres
            SET     baja = 'N'
            WHERE   id_presup = @id_presup
                    AND codigo IN ( SELECT  codigo
                                    FROM    dbo.Tmp_p_eliminabaja )
            DELETE  dbo.p_avisos_imss
            WHERE   mov = 'B'
                    AND id_presup = @id_presup
                    AND codigo IN ( SELECT  codigo
                                    FROM    dbo.Tmp_p_eliminabaja )
            IF OBJECT_ID('dbo.Tmp_p_eliminabaja') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.Tmp_p_eliminabaja
                END
        END

    IF @Alta = 'S' 
        BEGIN
            PRINT 'Alta'
            IF OBJECT_ID('dbo.Tmp_p_eliminaAlta') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.Tmp_p_eliminaAlta
                END

            SELECT  a.empresa ,
                    a.codigo ,
                    a.fch_mov ,
                    a.sueldo ,
                    a.saldiaint
            INTO    dbo.Tmp_p_eliminaAlta
            FROM    dbo.p_avisos_imss AS a
                    INNER JOIN dbo.p_empleados_pres AS b ON a.empresa = b.empresa
                                                            AND a.codigo = b.codigo
                                                            AND ( b.origen = 'P' )
            WHERE   a.mov = 'A'
                    AND a.id_presup = @id_presup
            GROUP BY a.empresa ,
                    a.codigo ,
                    a.fch_mov ,
                    a.sueldo ,
                    a.saldiaint

            DELETE  dbo.p_avisos_imss
            WHERE   id_presup = @id_presup
                    AND codigo IN ( SELECT  codigo
                                    FROM    dbo.Tmp_p_eliminaAlta )
            DELETE  dbo.p_empleados_pres
            WHERE   id_presup = @id_presup
                    AND codigo IN ( SELECT  codigo
                                    FROM    dbo.Tmp_p_eliminaAlta )
	
            IF OBJECT_ID('dbo.Tmp_p_eliminaAlta') IS NOT NULL 
                BEGIN
                    DROP TABLE dbo.Tmp_p_eliminaAlta
                END
        END

    IF @Tablas = 'S' 
        BEGIN
            DELETE  dbo.p_tablas_int
            WHERE   id_presup = @id_presup
            DECLARE @emp INT ,
                @clase CHAR(2)
            DECLARE clases CURSOR FOR

            SELECT empresa,clase
            FROM dbo.clases 
            WHERE empresa IN(SELECT empresa FROM dbo.p_empresas WHERE id_presup=@id_presup)
            ORDER BY empresa,clase

            OPEN clases
            FETCH FROM clases INTO @Emp,@clase
	
            WHILE ( @@FETCH_STATUS <> -1 ) 
                BEGIN
                    PRINT @Emp
                    PRINT @clase
                    EXEC dbo.p_InsertaTablas @id_presup, @Emp, @clase
                    FETCH NEXT FROM clases INTO @Emp,@clase
                END
            DEALLOCATE clases
        END

    IF @Conceptos = 'S' 
        BEGIN 
            DELETE  dbo.p_pagos_Variables
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_percepciones
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_conc_pres_nomina
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_conc_pres
            WHERE   id_presup = @id_presup
        END

    IF @PlanTemp = 'S' 
        BEGIN

            DELETE  dbo.p_plantilla_propuestos
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_puestosTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillas_centrosTemp
            WHERE   id_presup = @id_presup
            DELETE  dbo.p_plantillasTemp
            WHERE   id_presup = @id_presup

            DELETE  b
            FROM    dbo.p_empleados_pres AS a
                    INNER JOIN dbo.p_avisos_imss AS b ON a.id_presup = b.id_presup
                                                         AND a.empresa = b.empresa
                                                         AND a.codigo = b.codigo
            WHERE   a.id_presup = @id_presup
                    AND a.origen = 'L'
	
            DELETE  a
            FROM    dbo.p_empleados_pres AS a
            WHERE   a.id_presup = @id_presup
                    AND a.origen = 'L'

            INSERT  INTO dbo.p_plantillasTemp
                    ( id_presup ,
                      empresa ,
                      plantilla_id ,
                      nombre ,
                      idtipo ,
                      fechainicio ,
                      fechafinal ,
                      staffing
                    )
                    SELECT  @id_presup ,
                            empresa ,
                            plantilla_id ,
                            nombre ,
                            idtipo ,
                            fechainicio ,
                            fechafinal ,
                            staffing
                    FROM    dbo.plantillas
                    WHERE   empresa IN ( SELECT empresa
                                         FROM   dbo.p_empresas
                                         WHERE  id_presup = @id_presup )
                            AND idtipo = 'T'
	
            INSERT  INTO dbo.p_plantillas_centrosTemp
                    ( id_presup ,
                      empresa ,
                      centro ,
                      plantilla_id
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.centro ,
                            b.plantilla_id
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.plantillas_centros AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.plantilla_id
                    WHERE   a.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND a.idtipo = 'T'
	
            INSERT  INTO dbo.p_plantillas_puestostemp
                    ( id_presup ,
                      empresa ,
                      plantilla_id ,
                      ocupacion ,
                      cantidad ,
                      disponibles ,
                      clase ,
                      horario ,
                      tiposal ,
                      sueldo ,
                      sindicato ,
                      varia_imss ,
                      centro ,
                      tiponom
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.plantilla_id ,
                            b.ocupacion ,
                            b.cantidad ,
                            b.disponibles ,
                            b.clase ,
                            b.horario ,
                            b.tiposal ,
                            b.sueldo ,
                            b.sindicato ,
                            b.varia_imss ,
                            b.centro ,
                            b.tiponom
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.plantillas_puestos AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.plantilla_id
                    WHERE   a.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND a.idtipo = 'T'
	
            INSERT  INTO dbo.p_plantilla_propuestos
                    ( id_presup ,
                      empresa ,
                      idplantilla ,
                      ocupacion ,
                      tipo ,
                      clave ,
                      tiponom ,
                      clase ,
                      horario ,
                      tiposal ,
                      sueldo ,
                      sindicato ,
                      varia_imss ,
                      centro ,
                      autorizado
                    )
                    SELECT  @id_presup ,
                            b.empresa ,
                            b.idplantilla ,
                            b.ocupacion ,
                            b.tipo ,
                            b.clave ,
                            b.tiponom ,
                            b.clase ,
                            b.horario ,
                            b.tiposal ,
                            b.sueldo ,
                            b.sindicato ,
                            b.varia_imss ,
                            b.centro ,
                            b.autorizado
                    FROM    dbo.plantillas AS a
                            INNER JOIN dbo.p_plantilla_propuestos AS b ON a.empresa = b.empresa
                                                              AND a.plantilla_id = b.idplantilla
                                                              AND b.autorizado = 'S'
                    WHERE   a.empresa IN ( SELECT   empresa
                                           FROM     dbo.p_empresas
                                           WHERE    id_presup = @id_presup )
                            AND a.idtipo = 'T'
        END


GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_BorraBajas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_BorraBajas
GO

CREATE PROCEDURE dbo.p_BorraBajas
    @id_presup INT ,
    @codigo NUMERIC(8, 0) ,
    @empresa INT
AS 
    BEGIN 

        IF OBJECT_ID('dbo.Tmp_p_eliminabaja') IS NOT NULL 
            BEGIN
                DROP TABLE dbo.Tmp_p_eliminabaja
            END
	
        SELECT  a.empresa ,
                a.codigo ,
                a.fch_mov ,
                a.sueldo ,
                a.saldiaint
        INTO    dbo.Tmp_p_eliminabaja
        FROM    dbo.p_avisos_imss AS a
                INNER JOIN dbo.p_empleados_pres AS b ON a.empresa = b.empresa
                                                        AND a.codigo = b.codigo
                                                        AND ( b.origen = 'P'
                                                              OR b.origen = 'N'
                                                            )
        WHERE   a.mov = 'B'
                AND a.id_presup = @id_presup
                AND a.codigo = @codigo
                AND a.empresa = @empresa
        GROUP BY a.empresa ,
                a.codigo ,
                a.fch_mov ,
                a.sueldo ,
                a.saldiaint
	

        DECLARE @nEmp INT ,
            @nCod NUMERIC(8, 0) ,
            @FchMov DATETIME ,
            @mes_ini INT ,
            @mes_fin INT ,
            @ayo_ini INT ,
            @ayo_fin INT ,
            @sueldo NUMERIC(12, 2) ,
            @saldiaint NUMERIC(12, 2) ,
            @ayo_mov INT ,
            @fecha DATETIME ,
            @mes_mov INT ,
            @mes1 INT
        SELECT  @mes_ini = mes_inicio ,
                @mes_fin = mes_final ,
                @ayo_ini = ini_ejercicio ,
                @ayo_fin = fin_ejercicio
        FROM    dbo.p_parametro
        WHERE   id_presup = @id_presup

        DECLARE Bajas CURSOR FOR

        SELECT empresa,codigo,fch_mov,sueldo,saldiaint
        FROM dbo.Tmp_p_eliminabaja

        OPEN Bajas
        FETCH FROM Bajas INTO @nEmp,@nCod,@FchMov,@sueldo,@saldiaint
        SET @ayo_mov = YEAR(@FchMov)	
        SET @mes_mov = MONTH(@FchMov)	
        WHILE ( @@FETCH_STATUS <> -1 ) 
            BEGIN
                IF @ayo_ini = @ayo_fin --and @ayo_mov=@ayo_ini
                    BEGIN
                        SET @mes1 = @mes_mov + 1
                        WHILE @mes1 <= @mes_fin 
                            BEGIN
                                SET @fecha = CAST(@ayo_mov AS CHAR(4))
                                    + ( CASE WHEN @mes1 <= 9
                                             THEN '0' + CAST(@mes1 AS CHAR(1))
                                             WHEN @mes1 >= 10
                                             THEN CAST(@mes1 AS CHAR(2))
                                        END ) + '01'
                                PRINT @Fecha
                                INSERT  INTO dbo.p_avisos_imss
                                        ( id_presup ,
                                          empresa ,
                                          serial ,
                                          codigo ,
                                          mov ,
                                          fch_mov ,
                                          sueldo ,
                                          saldiaint ,
                                          mes_operacion ,
                                          ayo_operacion
                                        )
                                VALUES  ( @id_presup ,
                                          @nEmp ,
                                          1 ,
                                          @nCod ,
                                          'IM' ,
                                          @fecha ,
                                          @sueldo ,
                                          @saldiaint ,
                                          @mes1 ,
                                          @ayo_mov
                                        )
                                SET @Mes1 = @Mes1 + 1
                                CONTINUE
                            END

                    END
			--Update p_parametro set fin_ejercicio=2009
                IF @ayo_ini < @ayo_fin --and @ayo_mov=@ayo_ini
                    BEGIN
                        SET @mes1 = @mes_mov + 1
                        WHILE @mes1 <= 12 
                            BEGIN
                                SET @fecha = CAST(@ayo_mov AS CHAR(4))
                                    + ( CASE WHEN @mes1 <= 9
                                             THEN '0' + CAST(@mes1 AS CHAR(1))
                                             WHEN @mes1 >= 10
                                             THEN CAST(@mes1 AS CHAR(2))
                                        END ) + '01'
                                PRINT @Fecha
                                INSERT  INTO dbo.p_avisos_imss
                                        ( id_presup ,
                                          empresa ,
                                          serial ,
                                          codigo ,
                                          mov ,
                                          fch_mov ,
                                          sueldo ,
                                          saldiaint ,
                                          mes_operacion ,
                                          ayo_operacion
                                        )
                                VALUES  ( @id_presup ,
                                          @nEmp ,
                                          1 ,
                                          @nCod ,
                                          'IM' ,
                                          @fecha ,
                                          @sueldo ,
                                          @saldiaint ,
                                          @mes1 ,
                                          @ayo_mov
                                        )
                                SET @Mes1 = @Mes1 + 1
                                CONTINUE
                            END
                        SET @Mes1 = 1
                        WHILE @mes1 <= @Mes_fin 
                            BEGIN
                                SET @fecha = CAST(@ayo_fin AS CHAR(4))
                                    + ( CASE WHEN @mes1 <= 9
                                             THEN '0' + CAST(@mes1 AS CHAR(1))
                                             WHEN @mes1 >= 10
                                             THEN CAST(@mes1 AS CHAR(2))
                                        END ) + '01'
                                PRINT @Fecha
                                INSERT  INTO dbo.p_avisos_imss
                                        ( id_presup ,
                                          empresa ,
                                          serial ,
                                          codigo ,
                                          mov ,
                                          fch_mov ,
                                          sueldo ,
                                          saldiaint ,
                                          mes_operacion ,
                                          ayo_operacion
                                        )
                                VALUES  ( @id_presup ,
                                          @nEmp ,
                                          1 ,
                                          @nCod ,
                                          'IM' ,
                                          @fecha ,
                                          @sueldo ,
                                          @saldiaint ,
                                          @mes1 ,
                                          @ayo_fin
                                        )
                                SET @Mes1 = @Mes1 + 1
                                CONTINUE
                            END

                    END
                PRINT @nCod
                FETCH NEXT FROM Bajas INTO @nEmp,@nCod,@FchMov,@sueldo,@saldiaint
            END
        DEALLOCATE Bajas 
	
        UPDATE  dbo.p_empleados_pres
        SET     baja = 'N'
        WHERE   id_presup = @id_presup
                AND empresa = @empresa
                AND codigo IN ( SELECT  codigo
                                FROM    dbo.Tmp_p_eliminabaja
                                WHERE   empresa = @empresa )
	
        DELETE  dbo.p_avisos_imss
        WHERE   mov = 'B'
                AND id_presup = @id_presup
                AND empresa = @empresa
                AND codigo IN ( SELECT  codigo
                                FROM    dbo.Tmp_p_eliminabaja
                                WHERE   empresa = @empresa )
        IF OBJECT_ID('dbo.Tmp_p_eliminabaja') IS NOT NULL 
            BEGIN
                DROP TABLE dbo.Tmp_p_eliminabaja
            END
    END


GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.p_Borra_Altas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.p_Borra_Altas
GO

--p_Borra_Altas 3,7,90000001

CREATE PROCEDURE dbo.p_Borra_Altas
--Declare 
    @id_presup INT ,
    @empresa INT ,
    @codigo INT
AS 
    DELETE  dbo.p_nomina_tot
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo
    DELETE  dbo.p_despensas
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo
    DELETE  dbo.p_kardex
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo
    DELETE  dbo.p_percepciones
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo

    DELETE  dbo.p_avisos_imss
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo
    
	DELETE  dbo.p_kardex_empleados
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo

	DELETE  dbo.P_Empleados_Pres
    WHERE   id_presup = @id_presup
            AND empresa = @empresa
            AND codigo = @codigo


GO

--//--REPORTES


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresTotaConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresTotaConcepts
GO

CREATE PROCEDURE dbo.GetPresTotaConcepts
    (
      @presupId udtInteger ,
      @payrollType udtInteger ,
      @history udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    DECLARE @debug udtInteger
    
    SET @debug = 0

    DECLARE @fromClause udtStringSize4096 ,
        @selectClause udtStringSize4096 ,
        @whereClause udtStringSize4096
    SET @selectClause = 'SELECT	b.nombre AS nombre_presup, '
        + ' case when a.mes_operacion = 1 then ''01 ENERO'' '
        + ' when a.mes_operacion = 2 then ''02 FEBRERO'' '
        + ' when a.mes_operacion = 3 then ''03 MARZO'' '
        + ' when a.mes_operacion = 4 then ''04 ABRIL'' '
        + ' when a.mes_operacion = 5 then ''05 MAYO'' '
        + ' when a.mes_operacion = 6 then ''06 JUNIO'' '
        + ' when a.mes_operacion = 7 then ''07 JULIO'' '
        + ' when a.mes_operacion = 8 then ''08 AGOSTO'' '
        + ' when a.mes_operacion = 9 then ''09 SEPTIEMBRE'' '
        + ' when a.mes_operacion = 10 then ''10 OCTUBRE'' '
        + ' when a.mes_operacion = 11 then ''11 NOVIEMBRE'' '
        + ' when a.mes_operacion = 12 then ''12 DICIEMBRE'' ELSE '' '' '
        + ' END  as mes, ' + ' a.ayo_operacion AS ao, '
        + ' REPLICATE(''0'', 4 - len(a.num_conc)) + convert(varchar(4),a.num_conc) +'' '' + rtrim(ltrim(a.concepto)) as concepto, '
        + ' a.importe, '
        + ' REPLICATE(''0'', 4 - len(c.concepto)) + convert(varchar(4),c.concepto) +'' '' + rtrim(ltrim(c.nombre)) as nombre_conceptos, '
        + ' REPLICATE(''0'', 4 - len(a.ocupacion)) + convert(varchar(4),a.ocupacion) +'' '' + rtrim(ltrim(a.actividad)) as actividad, '
        + ' rtrim(ltrim(a.centro)) +  '' '' + rtrim(ltrim(a.departamento)) as departamento, '
        + ' case when pr.mes_inicio = 1 then ''ENERO'' '
        + ' when pr.mes_inicio = 2 then ''FEBRERO'' '
        + ' when pr.mes_inicio = 3 then ''MARZO'' '
        + ' when pr.mes_inicio = 4 then ''ABRIL'' '
        + ' when pr.mes_inicio = 5 then ''MAYO'' '
        + ' when pr.mes_inicio = 6 then ''JUNIO'' '
        + ' when pr.mes_inicio = 7 then ''JULIO'' '
        + ' when pr.mes_inicio = 8 then ''AGOSTO'' '
        + ' when pr.mes_inicio = 9 then ''SEPTIEMBRE'' '
        + ' when pr.mes_inicio = 10 then ''OCTUBRE'' '
        + ' when pr.mes_inicio = 11 then ''NOVIEMBRE'' '
        + ' when pr.mes_inicio = 12 then ''DICIEMBRE'' ELSE '' '' END + rtrim(ltrim(str(pr.ini_ejercicio))) + ''-'' +   '
        + ' case when pr.mes_final = 1 then ''ENERO''   '
        + ' when pr.mes_final = 2 then ''FEBRERO'' '
        + ' when pr.mes_final = 3 then ''MARZO'' '
        + ' when pr.mes_final = 4 then ''ABRIL'' '
        + ' when pr.mes_final = 5 then ''MAYO'' '
        + ' when pr.mes_final = 6 then ''JUNIO'' '
        + ' when pr.mes_final = 7 then ''JULIO'' '
        + ' when pr.mes_final = 8 then ''AGOSTO'' '
        + ' when pr.mes_final = 9 then ''SEPTIEMBRE'' '
        + ' when pr.mes_final = 10 then ''OCTUBRE'' '
        + ' when pr.mes_final = 11 then ''NOVIEMBRE'' '
        + ' when pr.mes_final = 12 then ''DICIEMBRE'' ELSE '' '' END + rtrim(ltrim(str(pr.fin_ejercicio))) as title, '
        + ' 1 as counter,' 
        + ' a.clase,'
        + ' a.nombreClase '
    SET @fromClause = 'FROM dbo.p_kardex_resumen_detalle AS a '
        + 'INNER JOIN dbo.P_conc_pres AS c ON a.id_presup = c.id_presup AND a.grupo_concepto = c.concepto '
        + 'INNER JOIN P_catalogo_pres AS b ON a.id_presup = b.id_presup '
        + 'inner join dbo.p_parametro as pr on pr.id_presup=b.id_presup  '		
	
	
    SET @whereClause = 'where a.id_presup=' + RTRIM(LTRIM(STR(@presupId)))
        + CASE WHEN @payrollType > 0
               THEN ' and a.tiponom=' + RTRIM(LTRIM(STR(@payrollType)))
               ELSE ' and a.tiponom in(1,2,3,4,5,6) '
          END 
	
    IF @debug = 0 
        BEGIN 
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause )
        END

GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresTotalEmployee')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresTotalEmployee
GO

CREATE PROCEDURE dbo.GetPresTotalEmployee
    (
      @presupId udtInteger ,
      @payrollType udtInteger ,
      @typeReport udtInteger , --1 Departamentos --2 Departemento y puesto --3 Puesto
      @history udtName,
	  @ManoObra udtName=''
    )
    --WITH ENCRYPTION
AS 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName

    SELECT  @title = '''' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                 WHEN mes_inicio = 2 THEN 'FEBRERO'
                                 WHEN mes_inicio = 3 THEN 'MARZO'
                                 WHEN mes_inicio = 4 THEN 'ABRIL'
                                 WHEN mes_inicio = 5 THEN 'MAYO'
                                 WHEN mes_inicio = 6 THEN 'JUNIO'
                                 WHEN mes_inicio = 7 THEN 'JULIO'
                                 WHEN mes_inicio = 8 THEN 'AGOSTO'
                                 WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                 WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                 WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                 WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                 ELSE ' '
                            END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio))) + '-'
            + CASE WHEN mes_final = 1 THEN 'ENERO'
                   WHEN mes_final = 2 THEN 'FEBRERO'
                   WHEN mes_final = 3 THEN 'MARZO'
                   WHEN mes_final = 4 THEN 'ABRIL'
                   WHEN mes_final = 5 THEN 'MAYO'
                   WHEN mes_final = 6 THEN 'JUNIO'
                   WHEN mes_final = 7 THEN 'JULIO'
                   WHEN mes_final = 8 THEN 'AGOSTO'
                   WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN mes_final = 10 THEN 'OCTUBRE'
                   WHEN mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 


    SET @kardex = CASE WHEN @history = 'S' THEN 'dbo.p_kardex_historico'
                       ELSE 'dbo.p_kardex'
                  END

    SET @debug = 0

    SET @selectClause = CASE WHEN @typeReport = 1
                             THEN 'Select  p.id_presup, ' + 'p.nombre, '
                                  + 'k.ayo_operacion, ' + 'k.mes_operacion, '
                                  + '(case when k.mes_operacion =  1 then ''01 ENERO'' '
                                  + 'when k.mes_operacion =  2 then ''02 FEBRERO'' '
                                  + 'when k.mes_operacion =  3 then ''03 MARZO'' '
                                  + 'when k.mes_operacion =  4 then ''04 ABRIL'' '
                                  + 'when k.mes_operacion =  5 then ''05 MAYO'' '
                                  + 'when k.mes_operacion =  6 then ''06 JUNIO'' '
                                  + 'when k.mes_operacion =  7 then ''07 JULIO'' '
                                  + 'when k.mes_operacion =  8 then ''08 AGOSTO'' '
                                  + 'when k.mes_operacion =  9 then ''09 SEPTIEMBRE'' '
                                  + 'when k.mes_operacion = 10 then ''10 OCTUBRE'' '
                                  + 'when k.mes_operacion = 11 then ''11 NOVIEMBRE'' '
                                  + 'when k.mes_operacion = 12 then ''12 DICIEMBRE'' '
                                  + 'End)as Mes, '
                                  + 'rtrim(ltrim(k.centro)) + '' '' + rtrim(ltrim(k.departamento)) as Departameno, '
                                  + '''0''  + '' '' as Ocupacion,' + @title
                                  + ' as title,	 '
                                  + 'sum(k.empleados) as total '
                             WHEN @typeReport = 2
                             THEN 'Select  p.id_presup, ' + 'p.nombre, '
                                  + 'k.ayo_operacion, ' + 'k.mes_operacion, '
                                  + '(case when k.mes_operacion =  1 then ''01 ENERO'' '
                                  + 'when k.mes_operacion =  2 then ''02 FEBRERO'' '
                                  + 'when k.mes_operacion =  3 then ''03 MARZO'' '
                                  + 'when k.mes_operacion =  4 then ''04 ABRIL'' '
                                  + 'when k.mes_operacion =  5 then ''05 MAYO'' '
                                  + 'when k.mes_operacion =  6 then ''06 JUNIO'' '
                                  + 'when k.mes_operacion =  7 then ''07 JULIO''  '
                                  + 'when k.mes_operacion =  8 then ''08 AGOSTO'' '
                                  + 'when k.mes_operacion =  9 then ''09 SEPTIEMBRE'' '
                                  + 'when k.mes_operacion = 10 then ''10 OCTUBRE'' '
                                  + 'when k.mes_operacion = 11 then ''11 NOVIEMBRE'' '
                                  + 'when k.mes_operacion = 12 then ''12 DICIEMBRE'' '
                                  + 'End)as Mes, ' + ''' '' as Departameno, '
                                  + 'REPLICATE(''0'', 4 - len(k.ocupacion)) + convert(varchar(4),k.ocupacion) + '' '' + rtrim(ltrim(k.actividad)) as Ocupacion,'
                                  + @title + ' as title, '
                                  + 'sum(k.empleados) as total '
                             WHEN @typeReport = 3
                             THEN 'Select  k.id_presup, ' + 'p.nombre, '
                                  + 'k.ayo_operacion, ' + 'k.mes_operacion, '
                                  + '(case when k.mes_operacion =  1 then ''01 ENERO'' '
                                  + 'when k.mes_operacion =  2 then ''02 FEBRERO'' '
                                  + 'when k.mes_operacion =  3 then ''03 MARZO'' '
                                  + 'when k.mes_operacion =  4 then ''04 ABRIL'' '
                                  + 'when k.mes_operacion =  5 then ''05 MAYO'' '
                                  + 'when k.mes_operacion =  6 then ''06 JUNIO'' '
                                  + 'when k.mes_operacion =  7 then ''07 JULIO'' '
                                  + 'when k.mes_operacion =  8 then ''08 AGOSTO'' '
                                  + 'when k.mes_operacion =  9 then ''09 SEPTIEMBRE'' '
                                  + 'when k.mes_operacion = 10 then ''10 OCTUBRE'' '
                                  + 'when k.mes_operacion = 11 then ''11 NOVIEMBRE'' '
                                  + 'when k.mes_operacion = 12 then ''12 DICIEMBRE'' '
                                  + 'End)as Mes, '
                                  + 'rtrim(ltrim(k.centro)) + '' '' + rtrim(ltrim(k.departamento)) as Departameno, '
                                  + 'REPLICATE(''0'', 4 - len(k.ocupacion)) + convert(varchar(4),k.ocupacion) + '' '' + rtrim(ltrim(k.actividad)) as Ocupacion,'
                                  + @title + ' as title, '
                                  + 'k.empleados as total '
                             ELSE ''
                        END

    SET @fromClause = 'From dbo.p_catalogo_pres as p ' + 'inner join '
        + 'dbo.p_kardex_resumen_emps ' + ' as k on p.id_presup=k.id_presup '
                      
    SET @groupByClause = CASE WHEN @typeReport = 1
                              THEN 'Group by p.id_presup,p.nombre,k.ayo_operacion,k.mes_operacion,k.centro,k.departamento '
                              WHEN @typeReport = 2
                              THEN 'Group by p.id_presup,p.nombre,k.ayo_operacion,k.mes_operacion,k.ocupacion,k.actividad '
                              --WHEN @typeReport = 3
                              --THEN 'Group by k.id_presup,p.nombre,k.ayo_operacion,k.mes_operacion,c.centro,c.nomdepto,t.ocupacion,t.actividad '
                              ELSE ''
                         END	
	
    SET @orderByClause = CASE WHEN @typeReport = 1
                              THEN 'Order by k.ayo_operacion,k.mes_operacion,k.centro '
                              WHEN @typeReport = 2
                              THEN 'Order by k.ayo_operacion,k.mes_operacion,k.ocupacion '
                              WHEN @typeReport = 3
                              THEN 'Order by k.ayo_operacion,k.mes_operacion,k.centro,k.ocupacion '
                              ELSE ''
                         END	

    SET @whereClause = 'Where k.id_presup=' + RTRIM(LTRIM(STR(@presupId)))
        + CASE WHEN @payrollType = 0 THEN ' and k.tiponom>0 '
               ELSE ' and k.tiponom=' + RTRIM(LTRIM(STR(@payrollType)))
          END	
		+ case when @manoObra = '-' then '' else ' and isnull(k.ManoObra,'''')='''+@manoObra+'''' end



    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresComparativePayroll')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresComparativePayroll
GO

CREATE PROCEDURE dbo.GetPresComparativePayroll
    (
      @presupId udtInteger ,
      @payrollType udtInteger ,
      @detailReport udtInteger ,
      @history udtName,
	  @ManoObra udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName
    DECLARE @detailClause udtStringSize4096

    SELECT  @title = '''' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                 WHEN mes_inicio = 2 THEN 'FEBRERO'
                                 WHEN mes_inicio = 3 THEN 'MARZO'
                                 WHEN mes_inicio = 4 THEN 'ABRIL'
                                 WHEN mes_inicio = 5 THEN 'MAYO'
                                 WHEN mes_inicio = 6 THEN 'JUNIO'
                                 WHEN mes_inicio = 7 THEN 'JULIO'
                                 WHEN mes_inicio = 8 THEN 'AGOSTO'
                                 WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                 WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                 WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                 WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                 ELSE ' '
                            END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio))) + '-'
            + CASE WHEN mes_final = 1 THEN 'ENERO'
                   WHEN mes_final = 2 THEN 'FEBRERO'
                   WHEN mes_final = 3 THEN 'MARZO'
                   WHEN mes_final = 4 THEN 'ABRIL'
                   WHEN mes_final = 5 THEN 'MAYO'
                   WHEN mes_final = 6 THEN 'JUNIO'
                   WHEN mes_final = 7 THEN 'JULIO'
                   WHEN mes_final = 8 THEN 'AGOSTO'
                   WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN mes_final = 10 THEN 'OCTUBRE'
                   WHEN mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 


    SET @kardex = CASE WHEN @history = 'S' THEN 'p_kardex_historico'
                       ELSE 'p_kardex'
                  END

    SET @debug = 0
	
	

    SET @selectClause = 'Select k.id_presup, ' + 'p.nombre as nombrePresup, '
        + 'k.grupo_concepto numeroGrupo, ' + 'c.nombre nombreGrupo, '
        + 'k.num_conc, ' + 'k.concepto, '
        + 'isnull(sum(k.importe),0) as ImpoPres, '
        + 'isnull((select sum(k2.importe) from dbo.kardex_anual as k2 '
        + 'WHERE   k2.ayo_operacion = k.ayo_operacion '
        + 'AND k2.tiponom = k.tiponom '
        + 'AND k2.empresa in (select empresa from p_empresas where id_presup=k.id_presup ) '
        + 'AND k2.nomina = ''ORD'' '
        + 'AND MONTH(k2.fch_pago)=k.mes_operacion '
        --+ 'AND k2.num_conc IN(SELECT num_conc FROM dbo.P_conc_pres_nomina WHERE id_presup=k.id_presup AND concepto=k.grupo_concepto) '
        + 'AND k2.num_conc = k.num_conc '
        + 'AND tiponom = k.tiponom ' + 'AND ayo_operacion = k.ayo_operacion '
        + ' ' + '),0) as ImpoNomi, ' + 'k.mes_operacion, '
        + 'k.ayo_operacion '
    SET @fromClause = 'into #tmp_p_resumen_conceptos '
        + 'FROM dbo.p_kardex_resumen_detalle AS k '
        + 'INNER JOIN dbo.P_conc_pres AS c ON c.id_presup=k.id_presup AND c.concepto=k.grupo_concepto '
        + 'INNER JOIN dbo.P_catalogo_pres AS p ON k.id_presup=p.id_presup '

    SET @whereClause = 'where c.id_presup=' + RTRIM(LTRIM(STR(@presupID)))
        + CASE WHEN @payrollType > 0
               THEN ' AND k.tiponom=' + RTRIM(LTRIM(STR(@payrollType)))
               ELSE ''
          END 
		+ case when @manoObra = '-' then '' else ' and isnull(k.ManoObra,'''')='''+@manoObra+'''' end

    SET @groupByClause = 'Group by k.id_presup,p.nombre,k.concepto,c.concepto,c.nombre,k.num_conc,k.grupo_concepto,k.mes_operacion,k.ayo_operacion,k.tiponom '
    SET @orderByClause = 'Order By k.ayo_operacion,k.mes_operacion,k.grupo_concepto,k.num_conc '
    SET @detailClause = CASE WHEN @detailReport = 1
                             THEN 'SELECT id_presup,nombrePresup,ImpoPres,ImpoNomi,(ImpoPres-ImpoNomi) as diferencia,mes_operacion,ayo_operacion,'
                                  + @title + ' AS title, '
                                  + 'CASE WHEN mes_operacion=1 THEN ''01 ENE '' WHEN mes_operacion=2 THEN ''02 FEB '' WHEN mes_operacion=3 THEN ''03 MAR '' WHEN mes_operacion=4 THEN ''04 ABR '' WHEN mes_operacion=5 THEN ''05 MAY '' WHEN mes_operacion=6 THEN ''06 JUN '' WHEN mes_operacion=7 THEN ''07 JUL '' WHEN mes_operacion=8 THEN ''08 AGO '' WHEN mes_operacion=9 THEN ''09 SEP '' WHEN mes_operacion=10 THEN ''10 OCT '' WHEN mes_operacion=11 THEN ''11 NOV '' WHEN mes_operacion=12 THEN ''12 DIC '' END '
                                  + '  AS MES'
                                  + ',numeroGrupo,replicate(''0'',2-len(numeroGrupo))+  RTRIM(LTRIM(STR(numeroGrupo))) + '' '' +  nombreGrupo as nombreGrupo,num_conc,concepto FROM #tmp_p_resumen_conceptos '
                             WHEN @detailReport = 3
                             THEN 'SELECT id_presup,sum(impopres)as ImpoPres,sum(impoNomi) as ImpoNomi,(sum(impopres)-sum(impoNomi)) as diferencia,mes_operacion,ayo_operacion,'
                                  + 'CASE WHEN mes_operacion=1 THEN ''01 ENE '' WHEN mes_operacion=2 THEN ''02 FEB '' WHEN mes_operacion=3 THEN ''03 MAR '' WHEN mes_operacion=4 THEN ''04 ABR '' WHEN mes_operacion=5 THEN ''05 MAY '' WHEN mes_operacion=6 THEN ''06 JUN '' WHEN mes_operacion=7 THEN ''07 JUL '' WHEN mes_operacion=8 THEN ''08 AGO '' WHEN mes_operacion=9 THEN ''09 SEP '' WHEN mes_operacion=10 THEN ''10 OCT '' WHEN mes_operacion=11 THEN ''11 NOV '' WHEN mes_operacion=12 THEN ''12 DIC '' END '
                                  + '  AS MES'
                                  + ' FROM #tmp_p_resumen_conceptos group by id_presup,nombrePresup,mes_operacion,ayo_operacion '
                             ELSE 'SELECT id_presup,nombrePresup,sum(impopres)as ImpoPres,sum(impoNomi) as ImpoNomi,(sum(impopres)-sum(impoNomi)) as diferencia,mes_operacion,ayo_operacion,'
                                  + @title + ' AS title, '
                                  + 'CASE WHEN mes_operacion=1 THEN ''01 ENE '' WHEN mes_operacion=2 THEN ''02 FEB '' WHEN mes_operacion=3 THEN ''03 MAR '' WHEN mes_operacion=4 THEN ''04 ABR '' WHEN mes_operacion=5 THEN ''05 MAY '' WHEN mes_operacion=6 THEN ''06 JUN '' WHEN mes_operacion=7 THEN ''07 JUL '' WHEN mes_operacion=8 THEN ''08 AGO '' WHEN mes_operacion=9 THEN ''09 SEP '' WHEN mes_operacion=10 THEN ''10 OCT '' WHEN mes_operacion=11 THEN ''11 NOV '' WHEN mes_operacion=12 THEN ''12 DIC '' END '
                                  + '  AS MES'
                                  + ',numeroGrupo,replicate(''0'',2-len(numeroGrupo))+  RTRIM(LTRIM(STR(numeroGrupo))) + '' '' +  nombreGrupo AS nombreGrupo FROM #tmp_p_resumen_conceptos group by id_presup,nombrePresup,numeroGrupo,nombreGrupo,mes_operacion,ayo_operacion '
                        END


    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause +
            @detailClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause + @detailClause )
        END

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresInformation')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresInformation
GO

CREATE PROCEDURE dbo.GetPresInformation
    --WITH ENCRYPTION
AS 
    DECLARE @presupId udtInteger
    
    SET @presupId = ISNULL(( SELECT id_presup
                             FROM   dbo.P_catalogo_pres
                             WHERE  estatus = 'A'
                           ), 0)
    IF @presupId = 0 
        BEGIN
            SET @presupId = ISNULL(( SELECT MAX(id_presup)
                                     FROM   dbo.P_catalogo_pres
                                   ), 0) + 1
            SELECT  @presupId AS idPresup ,
                    '' ,
                    '' ,
                    '' ,
                    YEAR(GETDATE()) ,
                    YEAR(GETDATE()) + 1 ,
                    1 ,
                    12 ,
                    '' AS estatus,
                    '' Imss
        END
    ELSE 
        BEGIN
            SELECT  a.id_presup ,
                    a.referencia ,
                    a.nombre ,
                    a.realizo ,
                    b.ini_ejercicio ,
                    b.fin_ejercicio ,
                    ISNULL(b.mes_inicio,1) AS mes_inicio ,
                    ISNULL(b.mes_final,1) AS mes_final,
                    'A' AS estatus,
                    ISNULL(b.NaturalesImss,'F') AS Imss
            FROM    dbo.P_catalogo_pres AS a
                    LEFT JOIN dbo.p_parametro AS b ON b.id_presup = a.id_presup
            WHERE   a.id_presup = @presupId
        END


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresCompanys')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresCompanys
GO

CREATE PROCEDURE dbo.GetPresCompanys ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT  a.empresa ,
            CASE WHEN a.referencia IS NULL
                      OR a.referencia = '' THEN a.nombre_empresa
                 ELSE a.referencia
            END AS nombre
    FROM    dbo.empresas AS a
            LEFT JOIN dbo.p_empresas AS b ON b.empresa = a.empresa
                                             AND b.id_presup = @presupId
    WHERE   b.empresa IS NULL


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresCompanysOn')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresCompanysOn
GO

CREATE PROCEDURE dbo.GetPresCompanysOn ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT  b.empresa ,
            CASE WHEN a.referencia IS NULL
                      OR a.referencia = '' THEN a.nombre_empresa
                 ELSE a.referencia
            END AS nombre,
            '' AS sel,
            ISNULL(b.encabezados,'N') AS encabezados
    FROM    dbo.empresas AS a
            INNER JOIN dbo.p_empresas AS b ON b.empresa = a.empresa
                                              AND b.id_presup = @presupId


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresPayrollsType')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresPayrollsType
GO

CREATE PROCEDURE dbo.GetPresPayrollsType ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT DISTINCT
            ( a.Tiponom ) ,
            CASE WHEN a.Tiponom = 1 THEN 'Semanal'
                 WHEN a.Tiponom = 2 THEN 'Decenal'
                 WHEN a.Tiponom = 3 THEN 'Catorcenal'
                 WHEN a.Tiponom = 4 THEN 'Quincenal'
                 WHEN a.Tiponom = 5 THEN 'Mensual'
                 WHEN a.Tiponom = 6 THEN 'Especial'
            END AS nombre
    FROM    dbo.p_dias AS a
    WHERE   a.id_presup = @presupId
	


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresDaysMonths')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresDaysMonths
GO

CREATE PROCEDURE dbo.GetPresDaysMonths
    (
      @presupId udtInteger ,
      @payrollType udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SELECT  a.ini_ejercicio ,
            a.fin_ejercicio ,
            b.mes ,
            b.ejercicio ,
            b.dias ,
            a.mes_inicio ,
            a.mes_final
    FROM    dbo.p_parametro AS a
            INNER JOIN dbo.p_dias AS b ON b.id_presup = a.id_presup
    WHERE   b.id_presup = @presupId
            AND b.tiponom = @payrollType
    ORDER BY b.ejercicio ,
            b.mes
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresGroupConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresGroupConcepts
GO

CREATE PROCEDURE dbo.GetPresGroupConcepts ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT  concepto ,
            nombre
    FROM    dbo.p_conc_pres
    WHERE   id_presup = @presupId
    ORDER BY concepto
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresConceptsByGroupConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresConceptsByGroupConcepts
GO

CREATE PROCEDURE dbo.GetPresConceptsByGroupConcepts
    (
      @presupId udtInteger ,
      @concepGroup udtInteger
    )
    --WITH ENCRYPTION
AS 
    SELECT  a.num_conc ,
            ( SELECT    MAX(concepto)
              FROM      dbo.conceptos
              WHERE     num_conc = a.num_conc
            ) AS concepto
    FROM    dbo.p_conc_pres_nomina AS a
            INNER JOIN dbo.p_empresas AS c ON c.id_presup = a.id_presup
            INNER JOIN dbo.conceptos AS b ON b.empresa = c.empresa
                                             AND b.num_conc = a.num_conc
    WHERE   a.id_presup = @presupId
            AND a.concepto = @concepGroup
    GROUP BY a.num_conc
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresMinimumWage')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresMinimumWage
GO

CREATE PROCEDURE dbo.GetPresMinimumWage ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT  fecha ,
            regional ,
            UMA
    FROM    dbo.p_salmin
    WHERE   id_presup = @presupId
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresClassByCompany')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresClassByCompany
GO

CREATE PROCEDURE dbo.GetPresClassByCompany
    (
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SELECT  clase
    FROM    dbo.clases
    WHERE   empresa = @companyId
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresPayDays')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresPayDays
GO

CREATE PROCEDURE dbo.GetPresPayDays ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT  b.id_presup ,
            a.nombre ,
            REPLICATE('0', 2 - LEN(b.tiponom)) + CONVERT(VARCHAR(4), b.tiponom)
            + ' ' + CASE WHEN b.tiponom = 1 THEN 'SEMANAL'
                         WHEN b.tiponom = 2 THEN 'DECENAL'
                         WHEN b.tiponom = 3 THEN 'CATORCENAL'
                         WHEN b.tiponom = 4 THEN 'QUINCENAL'
                         WHEN b.tiponom = 5 THEN 'MENSUAL'
                         WHEN b.tiponom = 6 THEN 'ESPECIAL'
                    END AS tiponom ,
            b.mes ,
            REPLICATE('0', 2 - LEN(b.mes)) + CONVERT(VARCHAR(4), b.mes) + ' '
            + CASE WHEN b.mes = 1 THEN 'ENERO'
                   WHEN b.mes = 2 THEN 'FEBRERO'
                   WHEN b.mes = 3 THEN 'MARZO'
                   WHEN b.mes = 4 THEN 'ABRIL'
                   WHEN b.mes = 5 THEN 'MAYO'
                   WHEN b.mes = 6 THEN 'JUNIO'
                   WHEN b.mes = 7 THEN 'JULIO'
                   WHEN b.mes = 8 THEN 'AGOSTO'
                   WHEN b.mes = 9 THEN 'SEPTIEMBRE'
                   WHEN b.mes = 10 THEN 'OCTUBRE'
                   WHEN b.mes = 11 THEN 'NOVIEMBRE'
                   WHEN b.mes = 12 THEN 'DICIEMBRE'
              END AS mest_letra ,
            b.dias ,
            b.ejercicio ,
            CASE WHEN c.mes_inicio = 1 THEN 'ENERO'
                 WHEN c.mes_inicio = 2 THEN 'FEBRERO'
                 WHEN c.mes_inicio = 3 THEN 'MARZO'
                 WHEN c.mes_inicio = 4 THEN 'ABRIL'
                 WHEN c.mes_inicio = 5 THEN 'MAYO'
                 WHEN c.mes_inicio = 6 THEN 'JUNIO'
                 WHEN c.mes_inicio = 7 THEN 'JULIO'
                 WHEN c.mes_inicio = 8 THEN 'AGOSTO'
                 WHEN c.mes_inicio = 9 THEN 'SEPTIEMBRE'
                 WHEN c.mes_inicio = 10 THEN 'OCTUBRE'
                 WHEN c.mes_inicio = 11 THEN 'NOVIEMBRE'
                 WHEN c.mes_inicio = 12 THEN 'DICIEMBRE'
                 ELSE ' '
            END + ' ' + RTRIM(LTRIM(STR(c.ini_ejercicio))) + '-'
            + CASE WHEN c.mes_final = 1 THEN 'ENERO'
                   WHEN c.mes_final = 2 THEN 'FEBRERO'
                   WHEN c.mes_final = 3 THEN 'MARZO'
                   WHEN c.mes_final = 4 THEN 'ABRIL'
                   WHEN c.mes_final = 5 THEN 'MAYO'
                   WHEN c.mes_final = 6 THEN 'JUNIO'
                   WHEN c.mes_final = 7 THEN 'JULIO'
                   WHEN c.mes_final = 8 THEN 'AGOSTO'
                   WHEN c.mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN c.mes_final = 10 THEN 'OCTUBRE'
                   WHEN c.mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN c.mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(c.fin_ejercicio))) AS title
    FROM    dbo.P_catalogo_pres AS a
            INNER JOIN dbo.P_dias AS b ON a.id_presup = b.id_presup
            INNER JOIN dbo.P_parametro AS c ON a.id_presup = c.id_presup
    WHERE   b.id_presup = @presupId
    ORDER BY b.ejercicio DESC ,
            b.tiponom ASC
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresConceptsUsedByGroupConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresConceptsUsedByGroupConcepts
GO

CREATE PROCEDURE dbo.GetPresConceptsUsedByGroupConcepts
    (
      @presupId udtInteger ,
      @concepGroup udtInteger
    )
    --WITH ENCRYPTION
AS 
    SELECT  a.num_conc ,
            max(b.concepto) ,
            ISNULL(a.clase, '') AS clase ,
            ISNULL(a.centro, '') AS centro,
            '' AS Sel,
            'N' AS Sel2
    FROM    dbo.p_conc_pres_nomina AS a
            INNER JOIN dbo.p_empresas AS c ON c.id_presup = a.id_presup
            INNER JOIN dbo.conceptos AS b ON b.empresa = c.empresa
                                             AND b.num_conc = a.num_conc
                                             --AND a.clase = b.clase
                                             --AND a.centro = b.centro
    WHERE   a.id_presup = @presupId
            AND a.concepto = @concepGroup
    GROUP BY a.num_conc ,
            a.centro ,
            a.clase
    ORDER BY a.num_conc ,
            a.centro ,
            a.clase
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresGroupConceptsName')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresGroupConceptsName
GO

CREATE PROCEDURE dbo.GetPresGroupConceptsName
    (
      @presupId udtInteger ,
      @concepGroup udtInteger
    )
    --WITH ENCRYPTION
AS 
    SELECT  concepto ,
            nombre ,
            tipo
    FROM    dbo.p_conc_pres
    WHERE   id_presup = @presupId
            AND concepto = @concepGroup
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresAvailableConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresAvailableConcepts
GO


CREATE PROCEDURE dbo.GetPresAvailableConcepts
    (
      @presupId udtInteger ,
      @conceptType udtInteger
    )
    --WITH ENCRYPTION
AS 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = 'select b.num_conc,' 
        + '(select min(concepto) from dbo.conceptos where num_conc=b.num_conc and empresa in(select empresa from dbo.p_empresas where id_presup=a.id_presup)) as concepto,'
        + ''''' as uno,' + ''''' As dos,' 
        + ''''' as Sel, '
        + '''N'' as Sel2 '
    SET @fromClause = 'from dbo.p_empresas as a '
        + 'inner join dbo.conceptos as b on b.empresa=a.empresa and b.uso=''S'' and b.informativo=''N'' '
        + 'left join dbo.p_conc_pres_nomina as c on c.num_conc=b.num_conc and c.id_presup='
        + RTRIM(LTRIM(STR(@presupId))) + ' '
    SET @whereClause = 'where c.num_conc is null and c.centro is null and c.clase is null and '
        + CASE WHEN @conceptType = 1
               THEN ' ((b.num_conc>=1 and b.num_conc<=99) or (b.num_conc>=501 and b.num_conc<=600) or (b.num_conc>=1100 and b.num_conc<=1200)) '
               WHEN @conceptType = 2
               THEN ' ((b.num_conc>=101 and b.num_conc<=200) or (b.num_conc>=601 and b.num_conc<=700) or (b.num_conc>=1001 and b.num_conc<=1099)) '
               WHEN @conceptType = 3
               THEN ' ((b.num_conc>=201 and b.num_conc<=299)) '
          END
		  + ' and a.id_presup='+ RTRIM(LTRIM(STR(@presupId))) + ' '
    SET @groupByClause = 'group by a.id_presup,b.num_conc,c.num_conc '
	
    SET @orderByClause = 'order by b.num_conc,c.num_conc '
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresNextGroupConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresNextGroupConcepts
GO

CREATE PROCEDURE dbo.GetPresNextGroupConcepts ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SELECT  ISNULL(MAX(concepto), 0) + 1 AS nextGroup
    FROM    dbo.p_conc_pres
    WHERE   id_presup = @presupId
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddPresGroupConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddPresGroupConcepts
GO

CREATE PROCEDURE dbo.AddPresGroupConcepts
    (
      @presupId udtInteger ,
      @conceptId udtInteger ,
      @nameGroup udtName ,
      @typeGroup udtName 
    )
    --WITH ENCRYPTION
AS 
    INSERT  INTO dbo.p_conc_pres
            ( concepto ,
              id_presup ,
              nombre ,
              tipo
            )
    VALUES  ( @conceptId ,
              @presupId ,
              @nameGroup ,
              @typeGroup 
            )
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.DeletePresGroupConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.DeletePresGroupConcepts
GO

CREATE PROCEDURE dbo.DeletePresGroupConcepts
    (
      @presupId udtInteger ,
      @conceptId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @deletedRecords AS udtInteger
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        DELETE  FROM dbo.p_pagos_variables
        WHERE   id_presup = @presupId
                AND concepto = @conceptId
            
        DELETE  FROM dbo.p_conc_pres_nomina
        WHERE   id_presup = @presupId
                AND concepto = @conceptId
            
        DELETE  FROM dbo.p_conc_pres
        WHERE   id_presup = @presupId
                AND concepto = @conceptId
        
        SET @deletedRecords = @@ROWCOUNT

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0 
        BEGIN
            COMMIT TRANSACTION 
            SELECT  @deletedRecords AS 'deletedRecords'
            RETURN @deletedRecords
        END 
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresClassByIntegrationTables')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresClassByIntegrationTables
GO

CREATE PROCEDURE dbo.GetPresClassByIntegrationTables
    (
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SELECT  clase
    FROM    dbo.p_tablas_int
    WHERE   empresa = @companyId
            AND clase <> '0'
    GROUP BY clase
    ORDER BY clase
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresMonthsByIntegrationTables')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresMonthsByIntegrationTables
GO

CREATE PROCEDURE dbo.GetPresMonthsByIntegrationTables
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @classId AS udtName 
    )
    --WITH ENCRYPTION
AS 
    SELECT  LTRIM(( CASE WHEN mes_operacion = 1 THEN 'Ene'
                         WHEN mes_operacion = 2 THEN 'Feb'
                         WHEN mes_operacion = 3 THEN 'Mar'
                         WHEN mes_operacion = 4 THEN 'Abr'
                         WHEN mes_operacion = 5 THEN 'May'
                         WHEN mes_operacion = 6 THEN 'Jun'
                         WHEN mes_operacion = 7 THEN 'Jul'
                         WHEN mes_operacion = 8 THEN 'Ago'
                         WHEN mes_operacion = 9 THEN 'Sep'
                         WHEN mes_operacion = 10 THEN 'Oct'
                         WHEN mes_operacion = 11 THEN 'Nov'
                         WHEN mes_operacion = 12 THEN 'Dic'
                    END )) + ' ' + LTRIM(STR(ayo_operacion)) AS Periodo
    FROM    dbo.p_tablas_int
    WHERE   id_presup = @presupId
            AND empresa = @companyId
            AND clase = @classId
    GROUP BY clase ,
            mes_operacion ,
            ayo_operacion
    ORDER BY clase ,
            ayo_operacion ,
            mes_operacion
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresIntegrationTables')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresIntegrationTables
GO

CREATE PROCEDURE dbo.GetPresIntegrationTables
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @classId udtName ,
      @monthId udtInteger ,
      @yearId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    SELECT  empresa ,
            clase ,
            '' AS uno ,
            '' AS dos ,
            ayos ,
            mes_operacion ,
            ayo_operacion ,
            ISNULL(factor, 0) AS factor ,
            ISNULL(aguinaldo, 0) AS aguinaldo ,
            ISNULL(dias_vac, 0) AS dias_vac ,
            ISNULL(prima_vac, 0) AS prima_vac ,
            ISNULL(pmavacdias, 0) AS pmavacdias ,
            ISNULL(pmavacimpo, 0) AS pmavacimpo ,
            ISNULL(despensa, 0) AS despensa ,
            ISNULL(despensaim, 0) AS despensaim ,
            ISNULL(dias_ayo, 0) AS dias_ayo ,
            ISNULL(porc_ayo, 0) AS porc_ayo ,
            ISNULL(imp_ayo, 0) AS imp_ayo ,
            ISNULL(dias_mes, 0) AS dias_mes ,
            ISNULL(porc_mes, 0) AS porc_mes ,
            ISNULL(imp_mes, 0) AS imp_mes ,
            ISNULL(porc_dia, 0) AS porc_dia ,
            ISNULL(imp_dia, 0) AS imp_dia ,
            ISNULL(fdoahopatp, 0) AS fdoahopatp ,
            ISNULL(fdoahopati, 0) AS fdoahopati ,
            ISNULL(fdoahotrap, 0) AS fdoahotrap ,
            ISNULL(fdoahotrai, 0) AS fdoahotrai ,
            ISNULL(pmo1ayopor, 0) AS pmo1ayopor ,
            ISNULL(pmo1ayoimp, 0) AS pmo1ayoimp ,
            ISNULL(pmo2ayopor, 0) AS pmo2ayopor ,
            ISNULL(pmo2ayoimp, 0) AS pmo2ayoimp
    FROM    dbo.p_tablas_int
    WHERE   empresa = @companyId
            AND id_presup = @presupId
            AND ayo_operacion = @yearId
            AND mes_operacion = @monthId
            AND clase = @classId
    ORDER BY ayos

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresValueColumByIntegrationTables')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresValueColumByIntegrationTables
GO

CREATE PROCEDURE dbo.GetPresValueColumByIntegrationTables
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @classId udtName ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @yearsModify udtInteger ,
      @columModify udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = 'Select isnull(' + @columModify + ',0) as '
        + @columModify + ' ' 
    SET @fromClause = 'from dbo.p_tablas_int '
    SET @whereClause = 'where empresa=' + LTRIM(RTRIM(STR(@companyId)))
        + ' and ayo_operacion=' + LTRIM(RTRIM(STR(@yearId))) + ' '
        + 'and mes_operacion=' + LTRIM(RTRIM(STR(@monthId)))
        + ' and cast (ayos as int)=' + LTRIM(RTRIM(STR(@yearsModify)))
        + ' and ' + 'id_presup=' + LTRIM(RTRIM(STR(@presupId))) + ' and '
        + 'clase=''' + @classId + ''''
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause 
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause )
        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.UpdatePresValueColumByIntegrationTables')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.UpdatePresValueColumByIntegrationTables
GO

CREATE PROCEDURE dbo.UpdatePresValueColumByIntegrationTables
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @classId udtName ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @yearsBegin udtInteger ,
      @yearsEnd udtInteger ,
      @columModify udtName ,
      @valueColum udtDecimal10_4 ,
      @allMonths udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @updatedRecords AS udtInteger
    DECLARE @OSQL udtStringSize8000
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
	
        SET @OSQL = 'update dbo.p_tablas_int set ' + @columModify + '='
            + CONVERT(VARCHAR(30), @valueColum) + ' where empresa='
            + RTRIM(LTRIM(STR(@companyId))) + ' and ayo_operacion='
            + RTRIM(LTRIM(STR(@yearId))) + ' and (mes_operacion>='
            + RTRIM(LTRIM(STR(@monthId))) + ' and mes_operacion<='
            + CASE WHEN @allMonths = 'S' THEN '12'
                   ELSE RTRIM(LTRIM(STR(@monthId)))
              END + ')' + ' and (cast (ayos as int)>='
            + RTRIM(LTRIM(STR(@yearsBegin))) + ' and cast (ayos as int)<='
            + RTRIM(LTRIM(STR(@yearsEnd))) + ')' + ' and id_presup='
            + RTRIM(LTRIM(STR(@presupId))) + ' and clase=''' + @classId + ''''

        EXEC (@OSQL)
            
        SELECT  @updatedRecords = @@ROWCOUNT

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0 
        BEGIN
            COMMIT TRANSACTION 
            SELECT  @updatedRecords AS 'updatedRecords'
            RETURN @updatedRecords
        END 
        
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresNewEmployees')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresNewEmployees
GO

CREATE PROCEDURE dbo.GetPresNewEmployees
    (
      @presupId udtInteger ,
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
    SELECT  a.empresa ,
            a.Codigo ,
            a.nombre ,
            a.clase + ' ' + c.nombre AS clase ,
            STR(a.ocupacion) + ' ' + p.actividad AS Puesto ,
            RTRIM(a.centro) + ' ' + LTRIM(d.nomdepto) AS Centro ,
            a.sueldo ,
            a.saldiaint ,
            STR(a.horario) + ' ' + h.nombre AS horario ,
            ( CASE WHEN a.sindicato = 'S' THEN 'SINDICALIZADO'
                   WHEN a.sindicato = 'C' THEN 'CONFIANZA'
                   ELSE ''
              END ) AS Sind,
            a.campo01,
            a.campo03
    FROM    dbo.P_empleados_pres AS a
            INNER JOIN dbo.clases AS c ON a.empresa = c.empresa
                                          AND a.clase = c.clase
            INNER JOIN dbo.tabulador AS p ON a.empresa = p.empresa
                                             AND a.ocupacion = p.ocupacion
            INNER JOIN dbo.centros AS d ON a.empresa = d.empresa
                                           AND a.centro = d.centro
            INNER JOIN dbo.horarios_catalogo AS h ON a.empresa = h.empresa
                                                     AND a.horario = h.horario
    WHERE   a.id_presup = @presupId
            AND a.empresa = @companyId
            AND a.origen = 'P'

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresCostCenter')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresCostCenter
GO

CREATE PROCEDURE dbo.GetPresCostCenter
    (
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  centro ,
            nomdepto
    FROM    dbo.centros
    WHERE   empresa = @companyId
            AND centro <> ''
            AND centro <= '99999999999997 '
    ORDER BY centro

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresJobs')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresJobs
GO

CREATE PROCEDURE dbo.GetPresJobs
    (
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  ocupacion ,
            actividad
    FROM    dbo.tabulador
    WHERE   empresa = @companyId
    ORDER BY ocupacion

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresSchedules')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresSchedules
GO

CREATE PROCEDURE dbo.GetPresSchedules
    (
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  horario ,
            nombre
    FROM    dbo.horarios_catalogo
    WHERE   empresa = @companyId
    ORDER BY horario

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresClass')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresClass
GO

CREATE PROCEDURE dbo.GetPresClass
    (
      @companyId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  clase ,
            nombre
    FROM    dbo.clases
    WHERE   empresa = @companyId
            AND clase <> '0'
    ORDER BY clase

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresSalaryGuaranteeByJobs')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresSalaryGuaranteeByJobs
GO

CREATE PROCEDURE dbo.GetPresSalaryGuaranteeByJobs
    (
      @companyId udtInteger ,
      @jobId udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  ISNULL(garantia, 0) AS SalaryGuarantee
    FROM    dbo.tabulador
    WHERE   empresa = @companyId
            AND ocupacion = @jobId
    ORDER BY ocupacion

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddPresHighEmployees')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddPresHighEmployees
GO

CREATE PROCEDURE dbo.AddPresHighEmployees
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @numberHigh udtInteger ,
      @centerId udtName ,
      @classId udtName ,
      @jobId udtInteger ,
      @payrollId udtInteger ,
      @schedule udtInteger ,
      @hiringDate udtDateTime ,
      @unionized udtName ,
      @salary udtNumeric10_2 ,
      @baseSalaryQuote udtNumeric10_2 ,
      @salaryBegin udtNumeric10_2 ,
      @baseSalaryQuoteBegin udtNumeric10_2 ,
      @origin udtName ,
      @active udtName ,
      @typeSalary udtName ,
      @oldDate udtDateTime ,
      @imssVariable udtNumeric10_2 ,
      @birthDate udtDateTime
      
      
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
    DECLARE @lastEmployeeId udtInteger ,
        @Counter udtInteger ,
        @name udtName ,
        @month udtInteger ,
        @year udtInteger
    
    SELECT  @lastEmployeeId = ISNULL(MAX(codigo), 89999999) + 1
    FROM    dbo.p_empleados_pres
    WHERE   id_presup = @presupId
            AND empresa = @companyId
            AND SUBSTRING(origen, 1, 1) = 'P'
            
    SET @counter = 1
	
    WHILE @Counter <= @numberHigh 
        BEGIN
            --PRINT @lastEmployeeId
            --PRINT @Counter
            SET @name = 'Alta Presupuesto ' + LTRIM(STR(@lastEmployeeId))
            SET @month = MONTH(@hiringDate)
            SET @year = YEAR(@hiringDate)
		
            EXEC dbo.AddPresNewEmployee @presupId, @companyId, @lastEmployeeId,
                @name, @centerId, @classId, @jobId, @payrollId, @schedule,
                @hiringDate, @unionized, @salary, @baseSalaryQuote,
                @salaryBegin, @baseSalaryQuoteBegin, @origin, @active,
                @typeSalary, @oldDate, @imssVariable, @birthDate
                
            EXEC dbo.AddPresNewEmployeeIMSS @presupId, @companyId,
                @lastEmployeeId, 1, 'A', @month, @year, @hiringDate, @salary,
                @baseSalaryQuote
            
            EXEC dbo.p_InsertaIMAltas @presupId, @companyId, @lastEmployeeId,
                @hiringDate
            
		
		
            SET @lastEmployeeId = @lastEmployeeId + 1
            SET @Counter = @Counter + 1
        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddPresNewEmployee')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddPresNewEmployee
GO

CREATE PROCEDURE dbo.AddPresNewEmployee
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @employeeId udtInteger ,
      @name udtStringSize128 ,
      @centerId udtName ,
      @classId udtName ,
      @jobId udtInteger ,
      @payrollId udtInteger ,
      @schedule udtInteger ,
      @hiringDate udtDateTime ,
      @unionized udtName ,
      @salary udtNumeric10_2 ,
      @baseSalaryQuote udtNumeric10_2 ,
      @salaryBegin udtNumeric10_2 ,
      @baseSalaryQuoteBegin udtNumeric10_2 ,
      @origin udtName ,
      @active udtName ,
      @typeSalary udtName ,
      @oldDate udtDateTime ,
      @imssVariable udtNumeric10_2 ,
      @birthDate udtDateTime     
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        INSERT  INTO dbo.p_empleados_pres
                ( id_presup ,
                  empresa ,
                  codigo ,
                  nombre ,
                  centro ,
                  clase ,
                  ocupacion ,
                  tiponom ,
                  horario ,
                  fchalta ,
                  sindicato ,
                  sueldo ,
                  saldiaint ,
                  sueldo_i ,
                  saldiaint_i ,
                  origen ,
                  activo ,
                  tiposal ,
                  fchantigua ,
                  varia_imss ,
                  fchnac
                )
        VALUES  ( @presupId ,
                  @companyId ,
                  @employeeId ,
                  @name ,
                  @centerId ,
                  @classId ,
                  @jobId ,
                  @payrollId ,
                  @schedule ,
                  @hiringDate ,
                  @unionized ,
                  @salary ,
                  @baseSalaryQuote ,
                  @salaryBegin ,
                  @baseSalaryQuoteBegin ,
                  @origin ,
                  @active ,
                  @typeSalary ,
                  @oldDate ,
                  @imssVariable ,
                  @birthDate 
                )
        
        SET @recordId = @@IDENTITY
                
    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0 
        BEGIN
            COMMIT TRANSACTION 
            SELECT  @recordId AS 'recordId'
            RETURN @recordId 
        END 
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddPresNewEmployeeIMSS')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddPresNewEmployeeIMSS
GO
CREATE PROCEDURE dbo.AddPresNewEmployeeIMSS
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @employeeId udtInteger ,
      @serial udtInteger ,
      @mov udtName ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @dateMov udtDateTime ,
      @salary udtNumeric10_2 ,
      @baseSalaryQuote udtNumeric10_2
     
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        INSERT  INTO dbo.p_Avisos_Imss
                ( id_presup ,
                  empresa ,
                  codigo ,
                  serial ,
                  mov ,
                  mes_operacion ,
                  ayo_operacion ,
                  fch_mov ,
                  sueldo ,
                  saldiaint
                )
        VALUES  ( @presupId ,
                  @companyId ,
                  @employeeId ,
                  @serial ,
                  @mov ,
                  @monthId ,
                  @yearId ,
                  @dateMov ,
                  @salary ,
                  @baseSalaryQuote 
                )
        
        SET @recordId = @@IDENTITY
                
    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0 
        BEGIN
            COMMIT TRANSACTION 
            SELECT  @recordId AS 'recordId'
            RETURN @recordId 
        END 
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresMovsIMSS')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresMovsIMSS
GO

CREATE PROCEDURE dbo.GetPresMovsIMSS
    (
      @presupId udtInteger ,
      @typeMov udtName
    )
    --WITH ENCRYPTION
AS 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName

    SELECT  @title = CASE WHEN @typeMov = 'A' THEN '''ALTAS DEL PRESUPUESTO: '
                          WHEN @typeMov = 'B' THEN '''BAJAS DEL PRESUPUESTO: '
                          WHEN @typeMov = 'MS'
                          THEN '''MODIFICACIONES DE SALARIO DEL PRESUPUESTO: '
                          ELSE ''
                     END + '' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                     WHEN mes_inicio = 2 THEN 'FEBRERO'
                                     WHEN mes_inicio = 3 THEN 'MARZO'
                                     WHEN mes_inicio = 4 THEN 'ABRIL'
                                     WHEN mes_inicio = 5 THEN 'MAYO'
                                     WHEN mes_inicio = 6 THEN 'JUNIO'
                                     WHEN mes_inicio = 7 THEN 'JULIO'
                                     WHEN mes_inicio = 8 THEN 'AGOSTO'
                                     WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                     WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                     WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                     WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                     ELSE ' '
                                END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio)))
            + '-' + CASE WHEN mes_final = 1 THEN 'ENERO'
                         WHEN mes_final = 2 THEN 'FEBRERO'
                         WHEN mes_final = 3 THEN 'MARZO'
                         WHEN mes_final = 4 THEN 'ABRIL'
                         WHEN mes_final = 5 THEN 'MAYO'
                         WHEN mes_final = 6 THEN 'JUNIO'
                         WHEN mes_final = 7 THEN 'JULIO'
                         WHEN mes_final = 8 THEN 'AGOSTO'
                         WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                         WHEN mes_final = 10 THEN 'OCTUBRE'
                         WHEN mes_final = 11 THEN 'NOVIEMBRE'
                         WHEN mes_final = 12 THEN 'DICIEMBRE'
                         ELSE ' '
                    END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 


    SET @debug = 0

    SET @selectClause = 'SELECT  a.id_presup , ' + 'b.empresa, '
        + 'b.Codigo ,' + 'b.nombre ,' + 'a.Mov , ' + 'a.fch_mov ,'
        + 'a.Sueldo ,' + 'a.SalDiaInt ,' + 'b.Nombre ,' + 't.actividad ,'
        + @title + ' as title '

    SET @fromClause = 'FROM dbo.P_Avisos_IMSS AS a '
        + 'INNER JOIN dbo.P_Empleados_Pres AS b ON a.id_presup = b.id_presup '
        + 'AND a.empresa = b.empresa ' + 'AND a.Codigo = b.Codigo '
        + 'INNER JOIN dbo.tabulador AS t ON b.empresa = t.empresa '
        + 'AND b.ocupacion = t.ocupacion '


    SET @orderByClause = ' ORDER BY a.empresa,b.Codigo ASC ,
        a.fch_mov ASC'

    SET @whereClause = 'WHERE   a.id_presup = ' + LTRIM(RTRIM(STR(@presupId)))
        + ' AND a.Mov = ''' + @typeMov + ''''



    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @orderByClause )
        END

GO

IF NOT EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID(N'[dbo].[kardex_anual]')
                        AND name = N'pruesupIndex' ) 
    CREATE NONCLUSTERED INDEX [pruesupIndex] ON [dbo].[kardex_anual] 
    (
    [empresa] ASC,
    [tiponom] ASC,
    [ayo_operacion] ASC,
    [periodo] ASC,
    [num_conc] ASC
    )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]

GO

IF NOT EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID(N'[dbo].[p_kardex_historico]')
                        AND name = N'presupKh' ) 
    CREATE NONCLUSTERED INDEX presupKh ON [dbo].[p_kardex_historico] 
    (
    [id_presup] ASC,
    [mes_operacion] ASC,
    [ayo_operacion] ASC
    )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresEmployeesAvailableToLow')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresEmployeesAvailableToLow
GO

CREATE PROCEDURE dbo.GetPresEmployeesAvailableToLow
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @lowPresup udtName ,
      @classClause udtName ,
      @centerClause udtName ,
      @ocpationClause udtName
    )
    --WITH ENCRYPTION
AS 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName

    SET @debug = 0

    SET @selectClause = 'SELECT a.Codigo ,' + 'a.nombre ,' + 'a.FchAlta ,'
        + 'a.sueldo ,' + ' '' '' as  bmp, '
        + ' ISNULL(a.tempbaja, ''N'') as tmpbaja '

    SET @fromClause = 'FROM   dbo.P_empleados_pres AS a '


    SET @orderByClause = ' ORDER BY a.codigo '

    SET @whereClause = 'WHERE  a.id_presup = ' + LTRIM(STR(@presupId))
        + ' AND a.empresa = ' + LTRIM(STR(@companyId))
        + ' AND ISNULL(a.baja, ''N'') <> ''S'' '
        + CASE WHEN @lowPresup = 'T'
               THEN ' AND substring(a.origen,1,1)=''P'' '
               ELSE CASE WHEN @classClause <> '.'
                         THEN ' AND a.clase=' + '''' + @classClause + ''''
                         ELSE ''
                    END + CASE WHEN @centerClause <> '.'
                               THEN ' AND a.centro=' + '''' + @centerClause
                                    + ''''
                               ELSE ''
                          END
                    + CASE WHEN @ocpationClause <> '.'
                           THEN ' AND a.ocupacion=' + '' + @ocpationClause
                                + ''
                           ELSE ''
                      END
          END


    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @orderByClause )
        END

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresLows')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresLows
GO

CREATE PROCEDURE dbo.GetPresLows ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName

    SET @debug = 0

    SET @selectClause = 'SELECT  a.empresa ,' + 'a.Codigo ,' + 'a.nombre ,'
        + 'a.clase + '' '' + c.nombre AS clase ,'
        + 'STR(a.ocupacion) + '' '' + p.actividad AS Puesto ,'
        + 'a.centro + '' '' + d.nomdepto AS Centro ,' + 'a.sueldo ,'
        + 'a.saldiaint ,' + 'STR(a.horario) + '' '' + h.nombre AS horario ,'
        + '( CASE WHEN a.sindicato = ''S'' THEN ''SINDICALIZADO'' '
        + 'WHEN a.sindicato = ''C'' THEN ''CONFIANZA'' ' + 'ELSE '' '' '
        + 'END ) AS Sind '

    SET @fromClause = 'FROM    dbo.P_empleados_pres AS a '
        + 'INNER JOIN dbo.p_avisos_imss AS f ON a.empresa = f.empresa '
        + 'AND a.codigo = f.codigo ' + 'AND f.mov = ''B'' '
        + 'AND f.id_presup = a.id_presup '
        + 'INNER JOIN dbo.clases AS c ON a.empresa = c.empresa '
        + 'AND a.clase = c.clase '
        + 'INNER JOIN dbo.tabulador AS p ON a.empresa = p.empresa '
        + 'AND a.ocupacion = p.ocupacion '
        + 'INNER JOIN dbo.centros AS d ON a.empresa = d.empresa '
        + 'AND a.centro = d.centro '
        + 'INNER JOIN dbo.horarios_catalogo AS h ON a.empresa = h.empresa '
        + 'AND a.horario = h.horario '


    SET @orderByClause = ' ORDER BY a.codigo '

    SET @whereClause = 'WHERE  a.id_presup = ' + LTRIM(STR(@presupId))


    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @orderByClause )
        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresEmployeesMS')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresEmployeesMS
GO

CREATE PROCEDURE dbo.GetPresEmployeesMS
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @classClause udtName ,
      @centerClause udtName ,
      @ocpationClause udtName,
	  @Tiponom udtName
    )
    --WITH ENCRYPTION
AS 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName

    SET @debug = 0

    SET @selectClause = 'SELECT  a.Codigo ,' + 'a.nombre ,' + 'a.Sueldo ,'
        + 'a.saldiaint ,' + 'ISNULL(b.nvosal, 0) AS NvoSal ,'
        + 'ISNULL(b.nvosdi, 0) AS NvoSDI ,' + ' '' '' AS ms,'
        + '( CASE WHEN b.codigo IS NULL THEN ''N'' ' + 'ELSE ''S'' '
        + 'END ) AS marca '

    SET @fromClause = 'From dbo.P_empleados_pres as a '
        + 'LEFT JOIN dbo.p_tmp_modsal_pres AS b ON b.id_presup = a.id_presup '
        + 'AND b.empresa = a.empresa ' + 'AND b.codigo = a.codigo '


    SET @orderByClause = ' ORDER BY a.codigo '

    SET @whereClause = 'WHERE  a.id_presup = ' + LTRIM(STR(@presupId))
        + ' AND a.empresa = ' + LTRIM(STR(@companyId))
        + ' AND isnull(a.baja,''N'') <> ''S'' '
        + CASE WHEN @classClause <> '.'
               THEN ' AND a.clase=' + '''' + @classClause + ''''
               ELSE ''
          END + CASE WHEN @centerClause <> '.'
                     THEN ' AND a.centro=' + '''' + @centerClause + ''''
                     ELSE ''
                END
        + CASE WHEN @ocpationClause <> '.'
               THEN ' AND a.ocupacion=' + '' + @ocpationClause + ''
               ELSE ''
          END
		+ CASE WHEN @tiponom <> '.-'
               THEN ' AND a.tiponom=' + '' + @tiponom + ''
               ELSE ''
          END
          

    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @orderByClause )
        END

GO



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.DeletePresLowEmployess')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.DeletePresLowEmployess
GO

CREATE PROCEDURE dbo.DeletePresLowEmployess
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @lowDate udtDateTime
    )
    --WITH ENCRYPTION
AS --SET @presupId = 1 
--SET @companyId = 1
--SET @lowDate = '20110131'


    DECLARE @rowsCount udtInteger

    SET @rowsCount = ISNULL(( SELECT    COUNT(*)
                              FROM      dbo.p_empleados_pres
                              WHERE     empresa = @companyId
                                        AND id_presup = @presupId
                                        AND ISNULL(baja, 'N') <> 'S'
                                        AND tempbaja = 'S'
                            ), 0)
                        
--    PRINT @rowsCount

    INSERT  INTO dbo.P_Avisos_IMSS
            ( id_presup ,
              empresa ,
              serial ,
              Codigo ,
              Mov ,
              mes_operacion ,
              ayo_operacion ,
              fch_mov ,
              Sueldo ,
              SalDiaInt ,
              DiasTr ,
              SalDiaIV ,
              Incap ,
              Ausen ,
              Fch_Real
            )
            SELECT  a.id_presup ,
                    a.empresa ,
                    ISNULL(( SELECT MAX(serial)
                             FROM   dbo.p_Avisos_Imss
                             WHERE  id_presup = a.id_presup
                                    AND empresa = a.empresa
                                    AND codigo = a.codigo
                                    AND ayo_operacion = YEAR(@lowDate)
                                    AND mes_operacion = MONTH(@lowDate)
                           ), 0) + 1 AS serial ,
                    a.Codigo ,
                    'B' AS mov ,
                    MONTH(@lowDate) AS mes ,
                    YEAR(@lowDate) AS ao ,
                    @lowDate AS fch_mov ,
                    a.Sueldo ,
                    a.Saldiaint ,
                    0 AS dias ,
                    0 AS dias ,
                    0 AS incap ,
                    0 AS aus ,
                    @lowDate AS fch_real
            FROM    dbo.p_empleados_pres AS a
            WHERE   a.empresa = @companyId
                    AND a.id_presup = @presupId
                    AND ISNULL(a.baja, 'N') <> 'S'
                    AND a.tempbaja = 'S'
        
        

    UPDATE  a
    SET     baja = 'S'
    FROM    dbo.p_empleados_pres AS a
    WHERE   a.empresa = @companyId
            AND a.id_presup = @presupId
            AND ISNULL(a.baja, 'N') <> 'S'
            AND a.tempbaja = 'S'
        
    DELETE  a
    FROM    dbo.p_Avisos_Imss AS a
            INNER   JOIN dbo.p_empleados_pres AS b ON a.id_presup = b.id_presup
                                                      AND a.empresa = b.empresa
                                                      AND a.Codigo = b.Codigo
                                                      AND b.tempbaja = 'S'
    WHERE   a.empresa = @companyId
            AND a.id_presup = @presupId
            AND a.fch_mov > @lowDate

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddPresModifySalary')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddPresModifySalary
GO

CREATE PROCEDURE dbo.AddPresModifySalary
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @modifyDate udtDateTime
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    INSERT  INTO dbo.P_Avisos_IMSS
            ( id_presup ,
              empresa ,
              serial ,
              Codigo ,
              Mov ,
              mes_operacion ,
              ayo_operacion ,
              fch_mov ,
              Sueldo ,
              SalDiaInt ,
              Fch_Real
            )
            SELECT  a.id_presup ,
                    a.empresa ,
                    ISNULL(( SELECT MAX(serial)
                             FROM   dbo.p_Avisos_Imss
                             WHERE  id_presup = a.id_presup
                                    AND empresa = a.empresa
                                    AND codigo = a.codigo
                                    AND ayo_operacion = YEAR(@modifyDate)
                                    AND mes_operacion = MONTH(@modifyDate)
                           ), 0) + 1 AS serial ,
                    a.codigo ,
                    'MS' AS mov ,
                    MONTH(@modifyDate) AS mes ,
                    YEAR(@modifyDate) AS ayo ,
                    @modifyDate AS dateMS ,
                    a.nvosal ,
                    a.nvosdi ,
                    @modifyDate AS realDate
            FROM    dbo.p_tmp_modsal_pres AS a
            WHERE   a.id_presup = @presupId
                    AND a.empresa = @companyId
            
    UPDATE  a
    SET     sueldo = b.nvosal ,
            saldiaint = b.nvosdi
    FROM    dbo.p_empleados_pres AS a
            INNER JOIN dbo.p_tmp_modsal_pres AS b ON a.id_presup = b.id_presup
                                                     AND a.empresa = b.empresa
                                                     AND a.Codigo = b.Codigo
    WHERE   b.id_presup = @presupId
            AND b.empresa = @companyId
            
            
            
    UPDATE  b
    SET     Sueldo = a.nvosal ,
            SalDiaInt = a.nvosdi
    FROM    dbo.p_tmp_modsal_pres AS a
            INNER JOIN dbo.P_Avisos_IMSS AS b ON a.id_presup = b.id_presup
                                                 AND a.empresa = b.empresa
                                                 AND a.Codigo = b.Codigo
    WHERE   b.fch_mov > @modifyDate

   
    DELETE  dbo.p_tmp_modsal_pres
    WHERE   id_presup = @presupId
            AND empresa = @companyId
            
    EXEC dbo.Update_Salarys @presupId
	
    
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddUpdataTmpLow')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddUpdataTmpLow
GO


CREATE PROCEDURE dbo.AddUpdataTmpLow
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @employeeId udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    UPDATE  dbo.p_empleados_pres
    SET     tempbaja = CASE WHEN tempbaja = 'S' THEN 'N'
                            ELSE 'S'
                       END
    WHERE   id_presup = @presupId
            AND empresa = @companyId
            AND codigo = @employeeId    
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddIndexPresupuesto')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddIndexPresupuesto
GO

CREATE PROCEDURE dbo.AddIndexPresupuesto
AS 
    IF EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID(N'[dbo].[p_kardex]')
                        AND name = N'pKardexMensualCalculo' ) 
        DROP INDEX [pKardexMensualCalculo] ON [dbo].[p_kardex] WITH ( ONLINE = OFF )


		/*CREATE NONCLUSTERED INDEX [pKardexMensualCalculo] ON [dbo].[p_kardex] 
		(
			[id_presup] ASC,
			[num_conc] ASC,
			[mes_operacion] ASC,
			[ayo_operacion] ASC,
			[id_serial] ASC
		)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
		*/
    IF EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID(N'[dbo].[p_empleados_pres]')
                        AND name = N'pKardexCalculo' ) 
        DROP INDEX [pKardexCalculo] ON [dbo].[p_empleados_pres] WITH ( ONLINE = OFF )


    CREATE NONCLUSTERED INDEX [pKardexCalculo] ON [dbo].[p_empleados_pres] 
    (
    [id_presup] ASC,
    [empresa] ASC,
    [codigo] ASC
    )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]

    IF EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID(N'[dbo].[p_avisos_imss]')
                        AND name = N'pKardexCalculo' ) 
        DROP INDEX [pKardexCalculo] ON [dbo].[p_avisos_imss] WITH ( ONLINE = OFF )


    CREATE NONCLUSTERED INDEX [pKardexCalculo] ON [dbo].[p_avisos_imss] 
    (
    [id_presup] ASC,
    [empresa] ASC,
    [codigo] ASC,
    [mes_operacion] ASC,
    [ayo_operacion] ASC
    )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
		
    IF EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID(N'[dbo].[p_tablas_int]')
                        AND name = N'pKardexCalculo' ) 
        DROP INDEX [pKardexCalculo] ON [dbo].[p_tablas_int] WITH ( ONLINE = OFF )


    CREATE NONCLUSTERED INDEX [pKardexCalculo] ON [dbo].[p_tablas_int] 
    (
    id_presup ASC,
    empresa ASC,
    Mes_Operacion ASC,
    Ayo_Operacion ASC,
    ayos ASC 
    )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]

GO


EXEC dbo.AddIndexPresupuesto

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.UPDATE_presup_dias')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.UPDATE_presup_dias
GO

CREATE PROCEDURE dbo.UPDATE_presup_dias
    (
      @id_presup udtInteger
    )
AS 
    UPDATE  a
    SET     cierre = CASE WHEN cierre > CONVERT(DATETIME, LTRIM(RTRIM(STR(ejercicio)))
                               + '1231')
                          THEN CONVERT(DATETIME, LTRIM(RTRIM(STR(ejercicio)))
                               + '1231')
                          ELSE cierre
                     END ,
            pago = CASE WHEN pago > CONVERT(DATETIME, LTRIM(RTRIM(STR(ejercicio)))
                             + '1231')
                        THEN CONVERT(DATETIME, LTRIM(RTRIM(STR(ejercicio)))
                             + '1231')
                        ELSE pago
                   END
    FROM    P_dias AS a
    WHERE   a.id_presup = @id_presup
            AND a.mes = 12
		
		
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_resumen_forrecast')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_resumen_forrecast
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              grupo_concepto VARCHAR(15) NOT NULL ,
              num_conc INT NOT NULL ,
              concepto VARCHAR(50) NOT NULL ,
              tiponom INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              [id_serial] [BIGint]
                IDENTITY(1, 1)
                NOT NULL
                CONSTRAINT PK66959
                PRIMARY KEY NONCLUSTERED
                ( id_presup, tiponom, num_conc, mes_operacion, ayo_operacion, grupo_concepto, id_serial )
            )

        ALTER TABLE dbo.p_kardex_resumen_forrecast ADD CONSTRAINT RefP_Empleados_Pres39 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)

    END
go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_resumen_forrecast_Vacation')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_resumen_forrecast_Vacation
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              num_conc INT NOT NULL ,
              concepto VARCHAR(50) NOT NULL ,
              tiponom INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              [id_serial] [BIGint]
                IDENTITY(1, 1)
                NOT NULL
                CONSTRAINT PK66979
                PRIMARY KEY NONCLUSTERED
                ( id_presup, tiponom, num_conc, mes_operacion, ayo_operacion, id_serial )
            )

        ALTER TABLE dbo.p_kardex_resumen_forrecast_Vacation ADD CONSTRAINT RefP_Empleados_Pres49 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)

    END
go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.p_kardex_resumen_forrecast_class')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.p_kardex_resumen_forrecast_class
            (
              id_presup NUMERIC(8, 0) NOT NULL ,
              codigo NUMERIC(8, 0) NOT NULL ,
              num_conc INT NOT NULL ,
              concepto VARCHAR(50) NOT NULL ,
              tiponom INT NOT NULL ,
              mes_operacion INT NOT NULL ,
              ayo_operacion INT NOT NULL ,
              importe DECIMAL(12, 2) NOT NULL ,
              [id_serial] [BIGint]
                IDENTITY(1, 1)
                NOT NULL
                CONSTRAINT PK66989
                PRIMARY KEY NONCLUSTERED
                ( id_presup, codigo, tiponom, num_conc, mes_operacion, ayo_operacion, id_serial )
            )

        ALTER TABLE dbo.p_kardex_resumen_forrecast_class ADD CONSTRAINT RefP_Empleados_Pres79 
        FOREIGN KEY (id_presup)
        REFERENCES dbo.P_catalogo_pres(id_presup)

    END
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_Filterforecast')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_Filterforecast
GO

CREATE PROCEDURE dbo.Get_pres_Filterforecast
    --WITH ENCRYPTION
AS 
    SELECT  ISNULL(SUM(1), 0) AS coincidencia
    FROM    dbo.empresas
    WHERE   registro_patronal IN ( 'Y4011912104', 'D4213904102' )

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddRowsReportsForrecast')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddRowsReportsForrecast
GO

CREATE PROCEDURE dbo.AddRowsReportsForrecast
    (
      @presupId udtInteger ,
      @tiponom udtInteger ,
      @mes_operacion udtInteger ,
      @ayo_operacion udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    DECLARE @nomina udtName

    SET @nomina = CASE WHEN @TipoNom = 1 THEN 'SEM'
                       WHEN @TipoNom = 2 THEN 'DEC'
                       WHEN @TipoNom = 3 THEN 'CAT'
                       WHEN @TipoNom = 4 THEN 'QNA'
                       WHEN @TipoNom = 5 THEN 'MES'
                       ELSE 'ESP'
                  END

    DELETE  dbo.p_kardex_resumen_forrecast
    WHERE   id_presup = @presupId
            AND mes_operacion = @mes_operacion
            AND ayo_operacion = @ayo_operacion
    DELETE  dbo.p_kardex_resumen_forrecast_Vacation
    WHERE   id_presup = @presupId
            AND mes_operacion = @mes_operacion
            AND ayo_operacion = @ayo_operacion
    DELETE  dbo.p_kardex_resumen_forrecast_CLASS
    WHERE   id_presup = @presupId
            AND mes_operacion = @mes_operacion
            AND ayo_operacion = @ayo_operacion




    INSERT  INTO dbo.p_kardex_resumen_forrecast
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  k.id_presup ,
                    CASE WHEN e.campo01 = 'Teachers Salaries' THEN '01'
                         WHEN e.campo01 = 'Sch Admin Wages & Salaries'
                         THEN '02'
                         WHEN e.campo01 = 'Support Svc. Wages & Salaries' OR e.campo01 = 'Support Svc. Wages & Salari'
                         THEN '03'
                         WHEN e.campo01 = 'Maint. Wages & Salaries' THEN '04'
                         WHEN e.campo01 = 'Support Svc. Wages & SalariesTeachers Salaries'
                         THEN '05'
                         WHEN e.campo01 = 'Sub-Tearcher Wages' OR  e.campo01 = 'Sub-Teacher Wages'
                         THEN '06'
                         WHEN e.campo01 IS NULL THEN '07'
                    END + REPLICATE('0',
                                    2 - LEN(RTRIM(LTRIM(STR(k.num_conc)))))
                    + RTRIM(LTRIM(STR(k.num_conc))) AS grupo_concepto ,
                    k.num_conc ,
                    ISNULL(e.campo01, 'SIN CLASIFICAR') AS concepto ,
                    @tiponom AS tiponom ,
                    k.mes_operacion AS mes_operacion ,
                    k.ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
                    AND k.num_conc <= 6
                --AND f.campo_07 = 12
            GROUP BY k.id_presup ,
                    k.mes_operacion ,
                    k.ayo_operacion ,
                    k.num_conc ,
                    k.concepto ,
                    e.campo01
            ORDER BY CASE WHEN e.campo01 = 'Teachers Salaries' THEN '01'
                         WHEN e.campo01 = 'Sch Admin Wages & Salaries'
                         THEN '02'
                         WHEN e.campo01 = 'Support Svc. Wages & Salaries' OR e.campo01 = 'Support Svc. Wages & Salari'
                         THEN '03'
                         WHEN e.campo01 = 'Maint. Wages & Salaries' THEN '04'
                         WHEN e.campo01 = 'Support Svc. Wages & SalariesTeachers Salaries'
                         THEN '05'
                         WHEN e.campo01 = 'Sub-Tearcher Wages' OR  e.campo01 = 'Sub-Tearcher Wages'
                         THEN '06'
                         WHEN e.campo01 IS NULL THEN '07'
                    END + REPLICATE('0',
                                     2 - LEN(RTRIM(LTRIM(STR(k.num_conc)))))
                    + RTRIM(LTRIM(STR(k.num_conc))) 
        


    INSERT  INTO dbo.p_kardex_resumen_forrecast
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  k.id_presup ,
                    '0901' AS grupo_concepto ,
                    9 AS num_conc ,
                    'Vacation Accrual(PROVISION DE MAESTROS)' AS concepto ,
                    @tiponom AS tiponom ,
                    @mes_operacion AS mes_operacion ,
                    @ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
                    AND e.campo03 = 11
                    AND k.num_conc IN ( 4, 201, 202, 203, 204, 205, 206, 207,
                                        208, 209, 210, 211, 212, 206.210, 38,
                                        27, 31, 213, 215 )
            GROUP BY k.id_presup


    INSERT  INTO dbo.p_kardex_resumen_forrecast
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  k.id_presup ,
                    '10' + REPLICATE('0',
                                     2 - LEN(RTRIM(LTRIM(STR(c.concepto)))))
                    + RTRIM(LTRIM(STR(c.concepto))) AS grupo_concepto ,
                    c.concepto AS num_conc ,
                    d.nombre AS concepto ,
                    @tiponom AS tiponom ,
                    @mes_operacion AS mes_operacion ,
                    @ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_conc_pres_nomina AS c ON k.num_conc = c.num_conc
                                                              AND k.id_presup = c.id_presup
                    INNER JOIN dbo.P_conc_pres AS d ON c.concepto = d.concepto
                                                       AND c.id_presup = d.id_presup
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
            GROUP BY k.id_presup ,
                    c.concepto ,
                    d.nombre 
                
    INSERT  INTO dbo.p_kardex_resumen_forrecast_Vacation
            ( id_presup ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
            )
            SELECT  k.id_presup ,
                    k.num_conc ,
                    k.concepto ,
                    @tiponom AS tiponom ,
                    @mes_operacion AS mes_operacion ,
                    @ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
                    AND e.campo03 = 11
                    AND k.num_conc IN ( 4, 201, 202, 203, 204, 205, 206, 207,
                                        208, 209, 210, 211, 212, 206.210, 38,
                                        27, 31, 213, 215 )
            GROUP BY k.id_presup ,
                    k.num_conc ,
                    k.concepto
            ORDER BY k.num_conc

    INSERT  INTO dbo.p_kardex_resumen_forrecast_CLASS
            ( id_presup ,
              codigo ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
            )
            SELECT  k.id_presup ,
                    k.Codigo ,
                    k.num_conc ,
                    ISNULL(e.campo01, 'SIN CLASIFICAR') AS concepto ,
                    @tiponom AS tiponom ,
                    k.mes_operacion AS mes_operacion ,
                    k.ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
                    AND k.num_conc <= 6
                --AND f.campo_07 = 12
GROUP BY            k.id_presup ,
                    k.Codigo ,
                    k.mes_operacion ,
                    k.ayo_operacion ,
                    k.num_conc ,
                    k.concepto ,
                    e.campo01
            ORDER BY CASE WHEN e.campo01 = 'Teacher' THEN '01'
                          WHEN e.campo01 = 'Sch Admin Wages & Salaries'
                          THEN '02'
                          WHEN e.campo01 = 'Support Svc. Wages & Salari'
                          THEN '03'
                          WHEN e.campo01 = 'Maint. Wages & Salaries'
                          THEN '04'
                          WHEN e.campo01 = 'Corp Office Wages & Salarie'
                          THEN '05'
                          WHEN e.campo01 IS NULL THEN '06'
                     END + REPLICATE('0',
                                     2 - LEN(RTRIM(LTRIM(STR(k.num_conc)))))
                    + RTRIM(LTRIM(STR(k.num_conc)))
GO

ALTER TABLE dbo.p_kardex_empleados ALTER COLUMN departamento varchar(500) NULL	
ALTER TABLE dbo.p_kardex_empleados ALTER COLUMN actividad varchar(500) NULL
IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'ManoObra' and sysobjects.name='p_kardex_empleados')
begin
	Alter table dbo.p_kardex_empleados add ManoObra varchar(5)            
end

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AddRowsReports')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AddRowsReports
GO

CREATE PROCEDURE dbo.AddRowsReports
    (
      @presupId udtInteger ,
      @tiponom udtInteger ,
      @mes_operacion udtInteger ,
      @ayo_operacion udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    DBCC CHECKIDENT (p_kardex_empleados, RESEED,0)
	DBCC CHECKIDENT (p_kardex_resumen_detalle, RESEED,0)
    DBCC CHECKIDENT (p_kardex_resumen_emps, RESEED,0)
    DBCC CHECKIDENT (p_kardex_resumen_forrecast, RESEED,0)
    DBCC CHECKIDENT (p_kardex_resumen_forrecast_Vacation, RESEED,0)
    DBCC CHECKIDENT (p_kardex_resumen_forrecast_CLASS, RESEED,0)

    DECLARE @nomina udtName

    SET @nomina = CASE WHEN @TipoNom = 1 THEN 'SEM'
                       WHEN @TipoNom = 2 THEN 'DEC'
                       WHEN @TipoNom = 3 THEN 'CAT'
                       WHEN @TipoNom = 4 THEN 'QNA'
                       WHEN @TipoNom = 5 THEN 'MES'
                       ELSE 'ESP'
                  END

    DELETE  dbo.p_kardex_resumen_detalle
    WHERE   id_presup = @presupId
            AND tiponom = @tiponom
            AND mes_operacion = @mes_operacion
            AND ayo_operacion = @ayo_operacion
	
	DELETE  dbo.p_kardex_empleados
    WHERE   id_presup = @presupId
            AND tiponom = @tiponom
            AND mes_operacion = @mes_operacion
            AND ayo_operacion = @ayo_operacion

	INSERT  INTO dbo.p_kardex_resumen_detalle
            ( id_presup ,
              centro ,
              ocupacion ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              dias ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe ,
              actividad ,
              departamento,
              clase,
              nombreClase,
			  ManoObra
            )
            SELECT  k.id_presup ,
                    e.Centro ,
                    e.ocupacion ,
                    c.concepto AS grupo_concepto ,
                    k.num_conc ,
                    k.concepto ,
                    0 ,--SUM(k.dias) AS dias,
                    @tiponom AS tiponom ,
                    @mes_operacion AS mes_operacion ,
                    @ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe ,
                    t.actividad ,
                    d.nomdepto,
                    e.Clase,
                    (SELECT  MAX(nombre) FROM dbo.clases AS a WHERE a.empresa=MAX(e.empresa) AND a.clase=e.Clase),
					e.ManoObra
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_conc_pres_nomina AS c ON k.num_conc = c.num_conc
                                                              AND k.id_presup = c.id_presup
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
                    left JOIN dbo.centros AS d ON e.empresa = d.empresa
                                                   AND e.Centro = d.centro
                    INNER JOIN dbo.tabulador AS t ON e.empresa = t.empresa
                                                     AND e.ocupacion = t.ocupacion
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
            GROUP BY k.id_presup ,
                    e.Centro ,
                    e.ocupacion ,
                    c.concepto ,
                    k.num_conc ,
                    k.concepto ,
                    t.actividad ,
                    d.nomdepto,
                    e.Clase,
					e.ManoObra
			order by k.num_conc
		
	
    INSERT  INTO dbo.p_kardex_empleados
            ( id_presup ,
			  empresa,
			  codigo,
              centro ,
              ocupacion ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              dias ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe ,
              actividad ,
              departamento,
			  ManoObra
            )
            SELECT  k.id_presup ,
					k.empresa,
					k.codigo,
                    e.Centro ,
                    e.ocupacion ,
                    c.concepto AS grupo_concepto ,
                    k.num_conc ,
                    k.concepto ,
                    0 ,--SUM(k.dias) AS dias,
                    @tiponom AS tiponom ,
                    @mes_operacion AS mes_operacion ,
                    @ayo_operacion AS ayo_operacion ,
                    SUM(k.importe) AS importe ,
                    t.actividad ,
                    d.nomdepto,
					e.ManoObra
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_conc_pres_nomina AS c ON k.num_conc = c.num_conc
                                                              AND k.id_presup = c.id_presup
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
                    left JOIN dbo.centros AS d ON d.empresa = e.empresa
                                                   AND d.Centro = e.centro
                    INNER JOIN dbo.tabulador AS t ON e.empresa = t.empresa
                                                     AND e.ocupacion = t.ocupacion
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
            GROUP BY k.id_presup ,
					k.empresa,
					k.codigo,
                    e.Centro ,
                    e.ocupacion ,
                    c.concepto ,
                    k.num_conc ,
                    k.concepto ,
                    t.actividad ,
                    d.nomdepto,
                    e.Clase,
					e.ManoObra
			order by k.codigo,k.num_conc

	DELETE  dbo.p_kardex_resumen_emps
    WHERE   id_presup = @presupId
            AND tiponom = @tiponom
            AND mes_operacion = @mes_operacion
            AND ayo_operacion = @ayo_operacion	
	
	
	
    INSERT  INTO dbo.p_kardex_resumen_emps
            ( id_presup ,
              centro ,
              ocupacion ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              empleados ,
              actividad ,
              departamento,
			  ManoObra
            )
            SELECT  k.id_presup ,
                    e.Centro ,
                    e.ocupacion ,
                    @tiponom AS tiponom ,
                    @mes_operacion AS mes_operacion ,
                    @ayo_operacion AS ayo_operacion ,
                    COUNT(DISTINCT ( k.codigo )) AS empleados ,
                    t.actividad ,
                    c.nomdepto,
					e.ManoObra
            FROM    dbo.p_kardex AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.id_presup = e.id_presup
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
                    INNER JOIN dbo.centros AS c ON c.empresa = e.empresa
                                                   AND c.Centro = e.centro
                    INNER JOIN dbo.tabulador AS t ON e.empresa = t.empresa
                                                     AND e.ocupacion = t.ocupacion
            WHERE   k.id_presup = @presupId
                    AND k.nomina = @nomina
                    AND k.mes_operacion = @mes_operacion
                    AND k.ayo_operacion = @ayo_operacion
            GROUP BY k.id_presup ,
                    e.Centro ,
                    e.ocupacion ,
                    t.actividad ,
                    c.nomdepto,
					e.ManoObra

    DECLARE @forecast AS TABLE ( forecast udtInteger )

    INSERT  INTO @forecast
            ( forecast )
            EXEC dbo.Get_pres_Filterforecast

    IF EXISTS ( SELECT  1
                FROM    @forecast
                WHERE   forecast >= 1 ) 
        BEGIN
			--print''
            EXEC dbo.AddRowsReportsForrecast @presupId, @tiponom,
                @mes_operacion, @ayo_operacion
        END

    DELETE  dbo.p_kardex
    WHERE   id_presup = @presupId
            AND ayo_operacion = @ayo_operacion
            AND mes_operacion = @mes_operacion
            AND nomina = @nomina
    DELETE  dbo.p_despensas
    WHERE   id_presup = @presupId
            AND ayo_operacion = @ayo_operacion
            AND mes_operacion = @mes_operacion
            AND nomina = @nomina

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Update_Pres_NameEmployee')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Update_Pres_NameEmployee
GO

CREATE PROCEDURE dbo.Update_Pres_NameEmployee
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @employeeId udtInteger ,
      @name udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    UPDATE  P_Empleados_Pres
    SET     Nombre = @name
    WHERE   id_presup = @presupId
            AND empresa = @companyId
            AND Codigo = @employeeId
    
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_EmployeesForMonths')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_EmployeesForMonths
GO

CREATE PROCEDURE dbo.Get_EmployeesForMonths ( @presupId udtInteger,@ManoObra udtName='' ,@tiponom int = 0)
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 


    DECLARE @ini_ejercicio udtInteger
    DECLARE @fin_ejercicio udtInteger
    DECLARE @title udtStringSize4096
    DECLARE @nombre udtName
    SELECT  @ini_ejercicio = ini_ejercicio ,
            @fin_ejercicio = fin_ejercicio
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId

    SELECT  @nombre = nombre
    FROM    dbo.P_catalogo_pres
    WHERE   id_presup = @presupId


    SELECT  @title = 'EMPLEADOS ' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                         WHEN mes_inicio = 2 THEN 'FEBRERO'
                                         WHEN mes_inicio = 3 THEN 'MARZO'
                                         WHEN mes_inicio = 4 THEN 'ABRIL'
                                         WHEN mes_inicio = 5 THEN 'MAYO'
                                         WHEN mes_inicio = 6 THEN 'JUNIO'
                                         WHEN mes_inicio = 7 THEN 'JULIO'
                                         WHEN mes_inicio = 8 THEN 'AGOSTO'
                                         WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                         WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                         WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                         WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                         ELSE ' '
                                    END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio)))
            + '-' + CASE WHEN mes_final = 1 THEN 'ENERO'
                         WHEN mes_final = 2 THEN 'FEBRERO'
                         WHEN mes_final = 3 THEN 'MARZO'
                         WHEN mes_final = 4 THEN 'ABRIL'
                         WHEN mes_final = 5 THEN 'MAYO'
                         WHEN mes_final = 6 THEN 'JUNIO'
                         WHEN mes_final = 7 THEN 'JULIO'
                         WHEN mes_final = 8 THEN 'AGOSTO'
                         WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                         WHEN mes_final = 10 THEN 'OCTUBRE'
                         WHEN mes_final = 11 THEN 'NOVIEMBRE'
                         WHEN mes_final = 12 THEN 'DICIEMBRE'
                         ELSE ' '
                    END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 


    SELECT  a.empresa ,
            a.Codigo ,
            b.Nombre ,
            b.Centro ,
            RTRIM(b.Centro) + ' ' + c.nomdepto AS nomdepto ,
            b.ocupacion ,
            RTRIM(LTRIM(STR(b.ocupacion))) + ' ' + d.actividad AS actividad ,
            a.mes_operacion ,
            a.ayo_operacion ,
            CASE WHEN a.mes_operacion = 1 THEN 'ENERO'
                 WHEN a.mes_operacion = 2 THEN 'FEBRERO'
                 WHEN a.mes_operacion = 3 THEN 'MARZO'
                 WHEN a.mes_operacion = 4 THEN 'ABRIL'
                 WHEN a.mes_operacion = 5 THEN 'MAYO'
                 WHEN a.mes_operacion = 6 THEN 'JUNIO'
                 WHEN a.mes_operacion = 7 THEN 'JULIO'
                 WHEN a.mes_operacion = 8 THEN 'AGOSTO'
                 WHEN a.mes_operacion = 9 THEN 'SEPTIEMBRE'
                 WHEN a.mes_operacion = 10 THEN 'OCTUBRE'
                 WHEN a.mes_operacion = 11 THEN 'NOVIEMBRE'
                 WHEN a.mes_operacion = 12 THEN 'DICIEMBRE'
                 ELSE ' '
            END AS Mes ,
            a.Sueldo ,
            a.SalDiaInt ,
            @nombre AS nobrePresup ,
            @title AS title
    FROM    dbo.P_Avisos_IMSS AS a
            INNER JOIN P_Empleados_Pres AS b ON a.id_presup = b.id_presup
                                                AND a.empresa = b.empresa
                                                AND a.Codigo = b.Codigo
            INNER JOIN tabulador AS d ON b.empresa = d.empresa
                                         AND b.ocupacion = d.ocupacion
            INNER JOIN centros AS c ON b.empresa = c.empresa
                                       AND b.Centro = c.centro
    WHERE   a.id_presup = @presupId
            AND a.ayo_operacion >= @ini_ejercicio
			and case when @ManoObra='-' then '' else b.manoobra end=case when @ManoObra='-' then '' else @manoobra end
			and (b.tiponom=@tiponom or @tiponom=0)
    ORDER BY a.ayo_operacion ,
            a.mes_operacion ,
            a.Codigo ASC


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Add_PrimasRT')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Add_PrimasRT
GO

CREATE PROCEDURE dbo.Add_PrimasRT
    (
      @presupId udtInteger ,
      @companyId udtInteger
    )
AS 
    --DELETE  dbo.p_primas_rt
    --WHERE   id_presup = @presupId


    IF @companyId = 0 
        BEGIN
            INSERT  INTO dbo.p_primas_rt
                    SELECT  @presupId AS presup_id ,
                            empresa ,
                            prima_rt ,
                            0 ,
                            0 ,
                            0
                    FROM    dbo.primas_rt
                    WHERE   YEAR(fecha_final) = 2999
			--AND MONTH(fecha_inicial)=3
                            AND empresa IN ( SELECT empresa
                                             FROM   dbo.P_empresas
                                             WHERE  id_presup = @presupId )
	
        END
    ELSE 
        BEGIN
            INSERT  INTO dbo.p_primas_rt
                    SELECT  @presupId AS presup_id ,
                            empresa ,
                            prima_rt ,
                            0 ,
                            0 ,
                            0
                    FROM    dbo.primas_rt
                    WHERE   YEAR(fecha_final) = 2999
                            AND empresa = @companyId
        END
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_PrimasRT')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_PrimasRT
GO

CREATE PROCEDURE dbo.Get_PrimasRT ( @presupId udtInteger )
AS 
    SELECT  empresa ,
            prima_rt ,
            prima_modificada ,
            mes ,
            ayo
    FROM    dbo.p_primas_rt
    WHERE   id_presup = @presupId

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_Months')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_Months
GO

CREATE PROCEDURE dbo.Get_Months ( @presupId udtInteger )
AS 
    SELECT  REPLICATE('0', 2 - LEN(RTRIM(LTRIM(STR(mes)))))
            + RTRIM(LTRIM(STR(mes))) + ' ' + RTRIM(LTRIM(STR(ejercicio))) AS mes
    FROM    dbo.P_dias
    WHERE   id_presup = @presupId
    GROUP BY mes ,
            ejercicio
    ORDER BY ejercicio ASC ,
            mes ASC


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.update_p_PrimaRT')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.update_p_PrimaRT
GO

CREATE PROCEDURE dbo.update_p_PrimaRT
    (
      @presupId udtInteger ,
      @companyId udtInteger ,
      @prima DECIMAL(8, 5) ,
      @month udtInteger ,
      @year udtInteger
    )
AS 
    UPDATE  dbo.p_primas_rt
    SET     prima_modificada = @prima ,
            mes = @month ,
            ayo = @year
    WHERE   id_presup = @presupId
            AND empresa = @companyId

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.add_p_conceptsFDO')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.add_p_conceptsFDO
GO

CREATE PROCEDURE dbo.add_p_conceptsFDO
AS 
    IF ( SELECT COUNT(1)
         FROM   dbo.conceptos
         WHERE  num_conc = 27
       ) >= 1 
        BEGIN
            INSERT  INTO dbo.conceptos
                    ( empresa ,
                      num_conc ,
                      clase ,
                      centro ,
                      concepto ,
                      concepto15x11 ,
                      uso ,
                      ispt ,
                      imss ,
                      mca_agui ,
                      ptu ,
                      despensa ,
                      fdoahorro ,
                      captura ,
                      condicion1 ,
                      condicion2 ,
                      formula ,
                      mascara ,
                      formula2 ,
                      marca2 ,
                      ispt_ng ,
                      isptmask ,
                      imss_ni ,
                      imssmask ,
                      hrs_min1 ,
                      variable1 ,
                      variable2 ,
                      variable3 ,
                      variable4 ,
                      cuenta ,
                      nomcuenta ,
                      tipo ,
                      clasifica ,
                      clasifica2 ,
                      condicion ,
                      anexo07 ,
                      sys ,
                      Informativo
                    )
                    SELECT  a.empresa ,
                            27 AS num_conc ,
                            a.clase ,
                            '' AS centro ,
                            'FDO AHORRO PATRON' AS concepto ,
                            'FDO AHORRO' AS concepto15x11 ,
                            'N' AS uso ,
                            'S' AS ispt ,
                            'N' AS imss ,
                            'N' AS mca_agui ,
                            'N' AS ptu ,
                            'N' AS despensa ,
                            'N' AS fdoahorro ,
                            'A' AS captura ,
                            'T' AS condicion1 ,
                            'A' AS condicion2 ,
                            '((impor_base*nvar3)+nvar4)*(dias-aus-inc)' AS formula ,
                            '((A*K)+L)*(C-D-E)' AS mascara ,
                            '' AS formula2 ,
                            '' AS mascara2 ,
                            'salmin*10*0.13*(dias-aus-inc)' AS ispt_ng ,
                            'G*10*0.13*(C-E-D)' AS isptmask ,
                            'importe' AS imss_ni ,
                            'M' AS imssmask ,
                            0 AS hrs_min1 ,
                            '' AS variable1 ,
                            'FPST' AS variable2 ,
                            'PORCENTAJE' AS variable3 ,
                            'IMP DIARIO' AS variable4 ,
                            '' AS cuenta ,
                            '' AS nomcuenta ,
                            'D' AS tipo ,
                            'D' AS clasifica ,
                            'T' AS marca2 ,
                            '.T.' AS condicion ,
                            6 AS anexo07 ,
                            0 AS sys ,
                            'N' AS Informativo
                    FROM    dbo.clases AS a
                            INNER JOIN dbo.empresas AS b ON a.empresa = b.empresa
                    WHERE   NOT a.clase IN ( SELECT clase
                                             FROM   dbo.conceptos
                                             WHERE  num_conc = 27
                                                    AND empresa = a.empresa )
                            AND ( a.clase <> ''
                                  AND a.clase <> '0'
                                )
        END

GO

EXEC dbo.add_p_conceptsFDO

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_InitialTemplateCenters')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_InitialTemplateCenters
GO

CREATE PROCEDURE dbo.Get_pres_InitialTemplateCenters
    (
      @id_presup udtInteger ,
      @empresa udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 



    SELECT	DISTINCT
            ( a.Centro ) ,
            RTRIM(b.nomdepto) AS nomdepto
    FROM    dbo.P_Empleados_Pres AS a
            INNER JOIN dbo.centros AS b ON a.empresa = b.empresa
                                           AND a.Centro = b.centro
    WHERE   a.id_presup = @id_presup
            AND a.empresa = @empresa

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_InitialTemplateJobsByCenters')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_InitialTemplateJobsByCenters
GO

CREATE PROCEDURE dbo.Get_pres_InitialTemplateJobsByCenters
    (
      @id_presup udtInteger ,
      @empresa udtInteger ,
      @centro udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    DECLARE @resumen AS TABLE(ocupacion udtInteger,actividad udtStringSize128,trabs udtInteger)
    
    INSERT INTO @resumen
            ( ocupacion, actividad, trabs )
    SELECT  a.ocupacion ,
            b.actividad ,
            COUNT(1) AS trabs
    FROM    dbo.P_Empleados_Pres AS a
            INNER JOIN dbo.tabulador AS b ON a.empresa = b.empresa
                                             AND a.ocupacion = b.ocupacion
    WHERE   a.id_presup = @id_presup
            AND a.empresa = @empresa
            AND a.centro = @centro
    GROUP BY a.centro ,
            a.ocupacion ,
            b.actividad
    ORDER BY a.centro ,
            a.ocupacion
            
	INSERT INTO @resumen
            ( ocupacion, actividad, trabs )
	SELECT 999999999,'Total',SUM(trabs)
	FROM @resumen
	
	SELECT * FROM @resumen ORDER BY ocupacion
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_conceptList')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_conceptList
GO

CREATE PROCEDURE dbo.Get_pres_conceptList ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    DECLARE @title udtStringSize4096
    
    SELECT  @title = '''' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                 WHEN mes_inicio = 2 THEN 'FEBRERO'
                                 WHEN mes_inicio = 3 THEN 'MARZO'
                                 WHEN mes_inicio = 4 THEN 'ABRIL'
                                 WHEN mes_inicio = 5 THEN 'MAYO'
                                 WHEN mes_inicio = 6 THEN 'JUNIO'
                                 WHEN mes_inicio = 7 THEN 'JULIO'
                                 WHEN mes_inicio = 8 THEN 'AGOSTO'
                                 WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                 WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                 WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                 WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                 ELSE ' '
                            END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio))) + '-'
            + CASE WHEN mes_final = 1 THEN 'ENERO'
                   WHEN mes_final = 2 THEN 'FEBRERO'
                   WHEN mes_final = 3 THEN 'MARZO'
                   WHEN mes_final = 4 THEN 'ABRIL'
                   WHEN mes_final = 5 THEN 'MAYO'
                   WHEN mes_final = 6 THEN 'JUNIO'
                   WHEN mes_final = 7 THEN 'JULIO'
                   WHEN mes_final = 8 THEN 'AGOSTO'
                   WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN mes_final = 10 THEN 'OCTUBRE'
                   WHEN mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 

    SELECT  p.nombre AS nombrePresup ,
            @title AS title ,
            a.concepto AS grupoConcepto ,
            a.nombre AS nombreConcepto ,
            b.num_conc ,
            b.nombre AS concepto
    FROM    dbo.P_conc_pres AS a
            INNER JOIN dbo.P_conc_pres_nomina AS b ON a.concepto = b.concepto
                                                      AND a.id_presup = b.id_presup
            INNER JOIN dbo.P_catalogo_pres AS p ON b.id_presup = p.id_presup
    WHERE   a.id_presup = @presupId
    ORDER BY a.concepto ,
            b.num_conc

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_reportForecast')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_reportForecast
GO

CREATE PROCEDURE dbo.Get_pres_reportForecast ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    DECLARE @title udtStringSize4096
    
    SELECT  @title = '''' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                 WHEN mes_inicio = 2 THEN 'FEBRERO'
                                 WHEN mes_inicio = 3 THEN 'MARZO'
                                 WHEN mes_inicio = 4 THEN 'ABRIL'
                                 WHEN mes_inicio = 5 THEN 'MAYO'
                                 WHEN mes_inicio = 6 THEN 'JUNIO'
                                 WHEN mes_inicio = 7 THEN 'JULIO'
                                 WHEN mes_inicio = 8 THEN 'AGOSTO'
                                 WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                 WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                 WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                 WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                 ELSE ' '
                            END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio))) + '-'
            + CASE WHEN mes_final = 1 THEN 'ENERO'
                   WHEN mes_final = 2 THEN 'FEBRERO'
                   WHEN mes_final = 3 THEN 'MARZO'
                   WHEN mes_final = 4 THEN 'ABRIL'
                   WHEN mes_final = 5 THEN 'MAYO'
                   WHEN mes_final = 6 THEN 'JUNIO'
                   WHEN mes_final = 7 THEN 'JULIO'
                   WHEN mes_final = 8 THEN 'AGOSTO'
                   WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN mes_final = 10 THEN 'OCTUBRE'
                   WHEN mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 
    
    SELECT  CAST(a.grupo_concepto AS VARCHAR(5)) AS grupo_concepto ,
            a.num_conc ,
            SUBSTRING(a.grupo_concepto, 1, 2) + ' ' + a.concepto AS concepto ,
            a.tiponom ,
            RTRIM(LTRIM(STR(A.ayo_operacion))) + ' ' + REPLICATE('0', 2 - LEN(RTRIM(LTRIM(STR(A.mes_operacion)))))
            + RTRIM(LTRIM(STR(A.mes_operacion))) AS mes_operacion ,
            a.ayo_operacion ,
            a.importe ,
            a.id_serial ,
            @title AS titelReport ,
            b.nombre AS nombrePresup
    FROM    dbo.p_kardex_resumen_forrecast AS a
            INNER JOIN dbo.P_catalogo_pres AS b ON a.id_presup = b.id_presup
    WHERE   a.id_presup = @presupId


GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_reportForecastVacation')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_reportForecastVacation
GO

CREATE PROCEDURE dbo.Get_pres_reportForecastVacation ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    DECLARE @title udtStringSize4096
    
    SELECT  @title = '''' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                 WHEN mes_inicio = 2 THEN 'FEBRERO'
                                 WHEN mes_inicio = 3 THEN 'MARZO'
                                 WHEN mes_inicio = 4 THEN 'ABRIL'
                                 WHEN mes_inicio = 5 THEN 'MAYO'
                                 WHEN mes_inicio = 6 THEN 'JUNIO'
                                 WHEN mes_inicio = 7 THEN 'JULIO'
                                 WHEN mes_inicio = 8 THEN 'AGOSTO'
                                 WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                 WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                 WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                 WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                 ELSE ' '
                            END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio))) + '-'
            + CASE WHEN mes_final = 1 THEN 'ENERO'
                   WHEN mes_final = 2 THEN 'FEBRERO'
                   WHEN mes_final = 3 THEN 'MARZO'
                   WHEN mes_final = 4 THEN 'ABRIL'
                   WHEN mes_final = 5 THEN 'MAYO'
                   WHEN mes_final = 6 THEN 'JUNIO'
                   WHEN mes_final = 7 THEN 'JULIO'
                   WHEN mes_final = 8 THEN 'AGOSTO'
                   WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN mes_final = 10 THEN 'OCTUBRE'
                   WHEN mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 
    
    SELECT  a.id_presup ,
          a.num_conc ,
          a.concepto ,
          a.tiponom ,
          RTRIM(LTRIM(STR(A.ayo_operacion))) + ' ' + REPLICATE('0', 2 - LEN(RTRIM(LTRIM(STR(A.mes_operacion)))))
            + RTRIM(LTRIM(STR(A.mes_operacion))) AS mes_operacion ,
          a.ayo_operacion ,
          a.importe,
            @title AS titelReport ,
            b.nombre AS nombrePresup
    FROM    dbo.p_kardex_resumen_forrecast_Vacation AS a
            INNER JOIN dbo.P_catalogo_pres AS b ON a.id_presup = b.id_presup
    WHERE   a.id_presup = @presupId


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_reportForecastClass')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_reportForecastClass
GO

CREATE PROCEDURE dbo.Get_pres_reportForecastClass ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    DECLARE @title udtStringSize4096
    
    SELECT  @title = '''' + CASE WHEN mes_inicio = 1 THEN 'ENERO'
                                 WHEN mes_inicio = 2 THEN 'FEBRERO'
                                 WHEN mes_inicio = 3 THEN 'MARZO'
                                 WHEN mes_inicio = 4 THEN 'ABRIL'
                                 WHEN mes_inicio = 5 THEN 'MAYO'
                                 WHEN mes_inicio = 6 THEN 'JUNIO'
                                 WHEN mes_inicio = 7 THEN 'JULIO'
                                 WHEN mes_inicio = 8 THEN 'AGOSTO'
                                 WHEN mes_inicio = 9 THEN 'SEPTIEMBRE'
                                 WHEN mes_inicio = 10 THEN 'OCTUBRE'
                                 WHEN mes_inicio = 11 THEN 'NOVIEMBRE'
                                 WHEN mes_inicio = 12 THEN 'DICIEMBRE'
                                 ELSE ' '
                            END + ' ' + RTRIM(LTRIM(STR(ini_ejercicio))) + '-'
            + CASE WHEN mes_final = 1 THEN 'ENERO'
                   WHEN mes_final = 2 THEN 'FEBRERO'
                   WHEN mes_final = 3 THEN 'MARZO'
                   WHEN mes_final = 4 THEN 'ABRIL'
                   WHEN mes_final = 5 THEN 'MAYO'
                   WHEN mes_final = 6 THEN 'JUNIO'
                   WHEN mes_final = 7 THEN 'JULIO'
                   WHEN mes_final = 8 THEN 'AGOSTO'
                   WHEN mes_final = 9 THEN 'SEPTIEMBRE'
                   WHEN mes_final = 10 THEN 'OCTUBRE'
                   WHEN mes_final = 11 THEN 'NOVIEMBRE'
                   WHEN mes_final = 12 THEN 'DICIEMBRE'
                   ELSE ' '
              END + ' ' + RTRIM(LTRIM(STR(fin_ejercicio))) + ''''
    FROM    dbo.P_parametro
    WHERE   id_presup = @presupId 
    
			  
    
    SELECT  a.id_presup ,
            a.codigo ,
            c.Nombre,
            a.num_conc ,
            CASE WHEN a.concepto = 'Teacher' THEN '01'
                         WHEN a.concepto = 'Sch Admin Wages & Salaries'
                         THEN '02'
                         WHEN a.concepto = 'Support Svc. Wages & Salari'
                         THEN '03'
                         WHEN a.concepto = 'Maint. Wages & Salaries' THEN '04'
                         WHEN a.concepto = 'Corp Office Wages & Salarie'
                         THEN '05'
                         WHEN a.concepto = 'SIN CLASIFICAR' THEN '06'
                    END + ' ' + a.concepto AS concepto ,
            a.tiponom ,
            RTRIM(LTRIM(STR(A.ayo_operacion))) + ' ' + REPLICATE('0', 2 - LEN(RTRIM(LTRIM(STR(A.mes_operacion)))))
            + RTRIM(LTRIM(STR(A.mes_operacion))) AS mes_operacion ,
            a.ayo_operacion ,
            a.importe ,
            @title AS titelReport ,
            b.nombre AS nombrePresup
    FROM    dbo.p_kardex_resumen_forrecast_class AS a
            INNER JOIN dbo.P_Empleados_Pres AS c ON a.id_presup = c.id_presup
                                                    AND a.codigo = c.Codigo
                                                    AND a.tiponom = c.tiponom
            INNER JOIN dbo.P_catalogo_pres AS b ON a.id_presup = b.id_presup
    WHERE   a.id_presup = @presupId


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_reportForecastComp')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_reportForecastComp
GO

CREATE PROCEDURE dbo.Get_pres_reportForecastComp
    (
      @presupId udtInteger ,
      @tiponom udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    DECLARE @title AS udtName
    SELECT  @title = nombre
    FROM    dbo.P_catalogo_pres
    WHERE   id_presup = @presupId
    DECLARE @p_kardex_resumen_forrecastPresup AS TABLE
        (
          id_presup NUMERIC(8, 0) NOT NULL ,
          grupo_concepto VARCHAR(15) NOT NULL ,
          num_conc INT NOT NULL ,
          concepto VARCHAR(50) NOT NULL ,
          tiponom INT NOT NULL ,
          mes_operacion INT NOT NULL ,
          ayo_operacion INT NOT NULL ,
          importe DECIMAL(12, 2) NOT NULL
        )
    DECLARE @p_kardex_resumen_forrecast AS TABLE
        (
          id_presup NUMERIC(8, 0) NOT NULL ,
          grupo_concepto VARCHAR(15) NOT NULL ,
          num_conc INT NOT NULL ,
          concepto VARCHAR(50) NOT NULL ,
          tiponom INT NOT NULL ,
          mes_operacion INT NOT NULL ,
          ayo_operacion INT NOT NULL ,
          importe DECIMAL(12, 2) NOT NULL
        )
    INSERT  INTO @p_kardex_resumen_forrecast
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  @presupid AS id_presup ,
                    CASE WHEN e.campo01 = 'Teacher' THEN '01'
                         WHEN e.campo01 = 'Sch Admin Wages & Salaries'
                         THEN '02'
                         WHEN e.campo01 = 'Support Svc. Wages & Salari'
                         THEN '03'
                         WHEN e.campo01 = 'Maint. Wages & Salaries' THEN '04'
                         WHEN e.campo01 = 'Corp Office Wages & Salarie'
                         THEN '05'
                         WHEN e.campo01 IS NULL THEN '06'
                    END + REPLICATE('0',
                                    2 - LEN(RTRIM(LTRIM(STR(k.num_conc)))))
                    + RTRIM(LTRIM(STR(k.num_conc))) AS grupo_concepto ,
                    k.num_conc ,
                    ISNULL(e.campo01, 'SIN CLASIFICAR') AS concepto ,
                    @tiponom AS tiponom ,
                    CASE WHEN SUBSTRING(k.mes, 1, 3) = 'ENE' THEN 1
                         WHEN SUBSTRING(k.mes, 1, 3) = 'FEB' THEN 2
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAR' THEN 3
                         WHEN SUBSTRING(k.mes, 1, 3) = 'ABR' THEN 4
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAY' THEN 5
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUN' THEN 6
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUL' THEN 7
                         WHEN SUBSTRING(k.mes, 1, 3) = 'AGO' THEN 8
                         WHEN SUBSTRING(k.mes, 1, 3) = 'SEP' THEN 9
                         WHEN SUBSTRING(k.mes, 1, 3) = 'OCT' THEN 10
                         WHEN SUBSTRING(k.mes, 1, 3) = 'NOV' THEN 11
                         WHEN SUBSTRING(k.mes, 1, 3) = 'DIC' THEN 12
                    END AS mes_operacion ,
                    CAST('20' + SUBSTRING(k.mes, 4, 2) AS INT) AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.kardex_anual AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
                                                            AND e.id_presup = @presupId
            WHERE   k.nomina IN('ORD','FIN','VAC','VAL')
                    AND k.tiponom = @tiponom
                    AND k.mes IN (
                    SELECT  CASE WHEN mes_operacion = 1 THEN 'ENE'
                                 WHEN mes_operacion = 2 THEN 'FEB'
                                 WHEN mes_operacion = 3 THEN 'MAR'
                                 WHEN mes_operacion = 4 THEN 'ABR'
                                 WHEN mes_operacion = 5 THEN 'MAY'
                                 WHEN mes_operacion = 6 THEN 'JUN'
                                 WHEN mes_operacion = 7 THEN 'JUL'
                                 WHEN mes_operacion = 8 THEN 'AGO'
                                 WHEN mes_operacion = 9 THEN 'SEP'
                                 WHEN mes_operacion = 10 THEN 'OCT'
                                 WHEN mes_operacion = 11 THEN 'NOV'
                                 WHEN mes_operacion = 12 THEN 'DIC'
                            END + SUBSTRING(LTRIM(RTRIM(STR(ayo_operacion))),
                                            3, 2)
                    FROM    dbo.p_kardex_resumen_forrecast_Vacation
                    WHERE   id_presup = @presupId
                    GROUP BY mes_operacion ,
                            ayo_operacion )
                    AND k.num_conc <= 6
                --AND f.campo_07 = 12
            GROUP BY k.mes ,
                    k.ayo_operacion ,
                    k.num_conc ,
                    k.concepto ,
                    e.campo01
            ORDER BY CASE WHEN e.campo01 = 'Teacher' THEN '01'
                          WHEN e.campo01 = 'Sch Admin Wages & Salaries'
                          THEN '02'
                          WHEN e.campo01 = 'Support Svc. Wages & Salari'
                          THEN '03'
                          WHEN e.campo01 = 'Maint. Wages & Salaries'
                          THEN '04'
                          WHEN e.campo01 = 'Corp Office Wages & Salarie'
                          THEN '05'
                          WHEN e.campo01 IS NULL THEN '06'
                     END + REPLICATE('0',
                                     2 - LEN(RTRIM(LTRIM(STR(k.num_conc)))))
                    + RTRIM(LTRIM(STR(k.num_conc))) 
        


    INSERT  INTO @p_kardex_resumen_forrecast
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  @presupId AS id_presup ,
                    '0901' AS grupo_concepto ,
                    9 AS num_conc ,
                    'Vacation Accrual(PROVISION DE MAESTROS)' AS concepto ,
                    @tiponom AS tiponom ,
                    CASE WHEN SUBSTRING(k.mes, 1, 3) = 'ENE' THEN 1
                         WHEN SUBSTRING(k.mes, 1, 3) = 'FEB' THEN 2
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAR' THEN 3
                         WHEN SUBSTRING(k.mes, 1, 3) = 'ABR' THEN 4
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAY' THEN 5
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUN' THEN 6
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUL' THEN 7
                         WHEN SUBSTRING(k.mes, 1, 3) = 'AGO' THEN 8
                         WHEN SUBSTRING(k.mes, 1, 3) = 'SEP' THEN 9
                         WHEN SUBSTRING(k.mes, 1, 3) = 'OCT' THEN 10
                         WHEN SUBSTRING(k.mes, 1, 3) = 'NOV' THEN 11
                         WHEN SUBSTRING(k.mes, 1, 3) = 'DIC' THEN 12
                    END AS mes_operacion ,
                    CAST('20' + SUBSTRING(k.mes, 4, 2) AS INT) AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.kardex_anual AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON e.id_presup = @presupId
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.nomina IN('ORD','FIN','VAC','VAL')
                    AND k.tiponom = @tiponom
                    AND k.mes IN (
                    SELECT  CASE WHEN mes_operacion = 1 THEN 'ENE'
                                 WHEN mes_operacion = 2 THEN 'FEB'
                                 WHEN mes_operacion = 3 THEN 'MAR'
                                 WHEN mes_operacion = 4 THEN 'ABR'
                                 WHEN mes_operacion = 5 THEN 'MAY'
                                 WHEN mes_operacion = 6 THEN 'JUN'
                                 WHEN mes_operacion = 7 THEN 'JUL'
                                 WHEN mes_operacion = 8 THEN 'AGO'
                                 WHEN mes_operacion = 9 THEN 'SEP'
                                 WHEN mes_operacion = 10 THEN 'OCT'
                                 WHEN mes_operacion = 11 THEN 'NOV'
                                 WHEN mes_operacion = 12 THEN 'DIC'
                            END + SUBSTRING(LTRIM(RTRIM(STR(ayo_operacion))),
                                            3, 2)
                    FROM    dbo.p_kardex_resumen_forrecast_Vacation
                    WHERE   id_presup = @presupId
                    GROUP BY mes_operacion ,
                            ayo_operacion )
                    AND e.campo03 = 11
                    AND k.num_conc IN ( 4, 201, 202, 203, 204, 205, 206, 207,
                                        208, 209, 210, 211, 212, 206.210, 38,
                                        27, 31, 213, 215 )
            GROUP BY k.mes


    INSERT  INTO @p_kardex_resumen_forrecast
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  @presupId AS id_presup ,
                    '10' + REPLICATE('0',
                                     2 - LEN(RTRIM(LTRIM(STR(c.concepto)))))
                    + RTRIM(LTRIM(STR(c.concepto))) AS grupo_concepto ,
                    c.concepto AS num_conc ,
                    d.nombre AS concepto ,
                    @tiponom AS tiponom ,
                    CASE WHEN SUBSTRING(k.mes, 1, 3) = 'ENE' THEN 1
                         WHEN SUBSTRING(k.mes, 1, 3) = 'FEB' THEN 2
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAR' THEN 3
                         WHEN SUBSTRING(k.mes, 1, 3) = 'ABR' THEN 4
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAY' THEN 5
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUN' THEN 6
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUL' THEN 7
                         WHEN SUBSTRING(k.mes, 1, 3) = 'AGO' THEN 8
                         WHEN SUBSTRING(k.mes, 1, 3) = 'SEP' THEN 9
                         WHEN SUBSTRING(k.mes, 1, 3) = 'OCT' THEN 10
                         WHEN SUBSTRING(k.mes, 1, 3) = 'NOV' THEN 11
                         WHEN SUBSTRING(k.mes, 1, 3) = 'DIC' THEN 12
                    END AS mes_operacion ,
                    CAST('20' + SUBSTRING(k.mes, 4, 2) AS INT) AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.kardex_anual AS k
                    INNER JOIN dbo.P_conc_pres_nomina AS c ON k.num_conc = c.num_conc
                                                              AND c.id_presup = @presupId
                    INNER JOIN dbo.P_conc_pres AS d ON c.concepto = d.concepto
                                                       AND c.id_presup = d.id_presup
                    INNER JOIN dbo.P_Empleados_Pres AS e ON e.id_presup = @presupId
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.nomina IN('ORD','FIN','VAC','VAL')
                    AND k.tiponom = @tiponom
                    AND k.mes IN (
                    SELECT  CASE WHEN mes_operacion = 1 THEN 'ENE'
                                 WHEN mes_operacion = 2 THEN 'FEB'
                                 WHEN mes_operacion = 3 THEN 'MAR'
                                 WHEN mes_operacion = 4 THEN 'ABR'
                                 WHEN mes_operacion = 5 THEN 'MAY'
                                 WHEN mes_operacion = 6 THEN 'JUN'
                                 WHEN mes_operacion = 7 THEN 'JUL'
                                 WHEN mes_operacion = 8 THEN 'AGO'
                                 WHEN mes_operacion = 9 THEN 'SEP'
                                 WHEN mes_operacion = 10 THEN 'OCT'
                                 WHEN mes_operacion = 11 THEN 'NOV'
                                 WHEN mes_operacion = 12 THEN 'DIC'
                            END + SUBSTRING(LTRIM(RTRIM(STR(ayo_operacion))),
                                            3, 2)
                    FROM    dbo.p_kardex_resumen_forrecast_Vacation
                    WHERE   id_presup = @presupId
                    GROUP BY mes_operacion ,
                            ayo_operacion )
            GROUP BY k.mes ,
                    c.concepto ,
                    d.nombre 


    INSERT  INTO @p_kardex_resumen_forrecastPresup
            ( id_presup ,
              grupo_concepto ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
         
            )
            SELECT  id_presup ,
                    grupo_concepto ,
                    num_conc ,
                    concepto ,
                    tiponom ,
                    mes_operacion ,
                    ayo_operacion ,
                    importe
            FROM    dbo.p_kardex_resumen_forrecast
            WHERE   id_presup = @presupId

    SELECT  a.id_presup ,
            @title AS nombrePresup ,
            a.grupo_concepto ,
            a.concepto ,
            a.tiponom ,
            a.mes_operacion ,
            a.ayo_operacion ,
            ISNULL(a.importe, 0) AS importePresupuesto ,
            ISNULL(b.importe, 0) AS importeNomina ,
            ISNULL(a.importe, 0) - ISNULL(b.importe, 0) AS Diferencia
    FROM    @p_kardex_resumen_forrecastPresup AS a
            FULL MERGE JOIN @p_kardex_resumen_forrecast AS b ON a.id_presup = b.id_presup
                                                              AND a.grupo_concepto = b.grupo_concepto
                                                              AND a.mes_operacion = b.mes_operacion
                                                              AND a.ayo_operacion = b.ayo_operacion
                                                              AND a.num_conc = b.num_conc
                                                              AND a.tiponom = b.tiponom
    WHERE   a.id_presup = @presupId
    ORDER BY a.ayo_operacion ,
            a.mes_operacion ,
            a.grupo_concepto


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_pres_reportForecastCompDetail')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_pres_reportForecastCompDetail
GO

CREATE PROCEDURE dbo.Get_pres_reportForecastCompDetail
    (
      @presupId udtInteger ,
      @tiponom udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

    DECLARE @title AS udtName
    SELECT  @title = nombre
    FROM    dbo.P_catalogo_pres
    WHERE   id_presup = @presupId
    DECLARE @p_kardex_resumen_forrecast_Vacation AS TABLE
        (
          id_presup NUMERIC(8, 0) NOT NULL ,
          num_conc INT NOT NULL ,
          concepto VARCHAR(50) NOT NULL ,
          tiponom INT NOT NULL ,
          mes_operacion INT NOT NULL ,
          ayo_operacion INT NOT NULL ,
          importe DECIMAL(12, 2) NOT NULL
        )
    DECLARE @p_kardex_resumen_forrecast_Vacation_Presup AS TABLE
        (
          id_presup NUMERIC(8, 0) NOT NULL ,
          num_conc INT NOT NULL ,
          concepto VARCHAR(50) NOT NULL ,
          tiponom INT NOT NULL ,
          mes_operacion INT NOT NULL ,
          ayo_operacion INT NOT NULL ,
          importe DECIMAL(12, 2) NOT NULL
        )
			
    INSERT  INTO @p_kardex_resumen_forrecast_Vacation
            ( id_presup ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
            )
            SELECT  @presupId AS id_presup ,
                    k.num_conc ,
                    k.concepto ,
                    @tiponom AS tiponom ,
                    CASE WHEN SUBSTRING(k.mes, 1, 3) = 'ENE' THEN 1
                         WHEN SUBSTRING(k.mes, 1, 3) = 'FEB' THEN 2
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAR' THEN 3
                         WHEN SUBSTRING(k.mes, 1, 3) = 'ABR' THEN 4
                         WHEN SUBSTRING(k.mes, 1, 3) = 'MAY' THEN 5
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUN' THEN 6
                         WHEN SUBSTRING(k.mes, 1, 3) = 'JUL' THEN 7
                         WHEN SUBSTRING(k.mes, 1, 3) = 'AGO' THEN 8
                         WHEN SUBSTRING(k.mes, 1, 3) = 'SEP' THEN 9
                         WHEN SUBSTRING(k.mes, 1, 3) = 'OCT' THEN 10
                         WHEN SUBSTRING(k.mes, 1, 3) = 'NOV' THEN 11
                         WHEN SUBSTRING(k.mes, 1, 3) = 'DIC' THEN 12
                    END AS mes_operacion ,
                    CAST('20' + SUBSTRING(k.mes, 4, 2) AS INT) AS ayo_operacion ,
                    SUM(k.importe) AS importe
            FROM    dbo.kardex_anual AS k
                    INNER JOIN dbo.P_Empleados_Pres AS e ON e.id_presup = @presupId
                                                            AND k.empresa = e.empresa
                                                            AND k.Codigo = e.Codigo
            WHERE   k.tiponom = @tiponom
                    AND k.nomina IN('ORD','FIN','VAC','VAL')
                    AND k.mes IN (
                    SELECT  CASE WHEN mes_operacion = 1 THEN 'ENE'
                                 WHEN mes_operacion = 2 THEN 'FEB'
                                 WHEN mes_operacion = 3 THEN 'MAR'
                                 WHEN mes_operacion = 4 THEN 'ABR'
                                 WHEN mes_operacion = 5 THEN 'MAY'
                                 WHEN mes_operacion = 6 THEN 'JUN'
                                 WHEN mes_operacion = 7 THEN 'JUL'
                                 WHEN mes_operacion = 8 THEN 'AGO'
                                 WHEN mes_operacion = 9 THEN 'SEP'
                                 WHEN mes_operacion = 10 THEN 'OCT'
                                 WHEN mes_operacion = 11 THEN 'NOV'
                                 WHEN mes_operacion = 12 THEN 'DIC'
                            END + SUBSTRING(LTRIM(RTRIM(STR(ayo_operacion))),
                                            3, 2)
                    FROM    dbo.p_kardex_resumen_forrecast_Vacation
                    WHERE   id_presup = @presupId
                    GROUP BY mes_operacion ,
                            ayo_operacion )
                    AND e.campo03 = 11
                    AND k.num_conc IN ( 4, 201, 202, 203, 204, 205, 206, 207,
                                        208, 209, 210, 211, 212, 206.210, 38,
                                        27, 31, 213, 215 )
            GROUP BY k.mes ,
                    k.num_conc ,
                    k.concepto
            ORDER BY k.num_conc

    
    
    INSERT  INTO @p_kardex_resumen_forrecast_Vacation_presup
            ( id_presup ,
              num_conc ,
              concepto ,
              tiponom ,
              mes_operacion ,
              ayo_operacion ,
              importe
            )
            SELECT  id_presup ,
                    num_conc ,
                    concepto ,
                    tiponom ,
                    mes_operacion ,
                    ayo_operacion ,
                    importe
            FROM    dbo.p_kardex_resumen_forrecast_Vacation
            WHERE   id_presup = @presupId

    SELECT  ISNULL(a.id_presup, b.id_presup) AS id_presup ,
			@title AS nombrePresup ,
            ISNULL(a.num_conc, b.num_conc) AS num_conc ,
            ISNULL(a.concepto, b.concepto) AS concepto ,
            ISNULL(a.tiponom, b.tiponom) AS tiponom ,
            ISNULL(a.mes_operacion, b.mes_operacion) AS mes_operacion ,
            ISNULL(a.ayo_operacion, b.ayo_operacion) AS ayo_operacion ,
            ISNULL(a.importe, 0) AS importePresupuesto ,
            ISNULL(b.importe, 0) AS importeNomina ,
            ISNULL(a.importe, 0) - ISNULL(b.importe, 0) AS Diferencia
    FROM    @p_kardex_resumen_forrecast_Vacation_presup AS a
            FULL MERGE JOIN @p_kardex_resumen_forrecast_Vacation AS b ON a.id_presup = b.id_presup
                                                              AND a.mes_operacion = b.mes_operacion
                                                              AND a.ayo_operacion = b.ayo_operacion
                                                              AND a.num_conc = b.num_conc
                                                              AND a.tiponom = b.tiponom
    ORDER BY ISNULL(a.ayo_operacion, b.ayo_operacion) ,
			ISNULL(a.mes_operacion, b.mes_operacion) ,
            ISNULL(a.num_conc, b.num_conc)
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Add_Presup_ConcsVars')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Add_Presup_ConcsVars
GO

CREATE PROCEDURE dbo.Add_Presup_ConcsVars
    (
      @presupId udtInteger ,
      @num_conc udtInteger ,
      @centrosString udtStringSize4096
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 


    DECLARE @debugId udtInteger

    SET @debugId = 0

    DECLARE @fromClause udtStringSize4096 ,
        @selectClause udtStringSize4096 ,
        @whereClause udtStringSize4096 ,
        @orderByClause udtStringSize4096 ,
        @groupByClause udtStringSize4096

--insert into p_pagos_variables_tiponom(num_conc,id_presup,concepto,centro,clase,tiponom)
    SET @selectClause = 'select a.num_conc,' + LTRIM(RTRIM(STR(@presupId)))
        + ' AS id_presup,' + 'a.concepto,' + 'd.centro,' + ' '''' AS clase,'
        + 'g.tiponom '
    SET @fromClause = 'From dbo.p_conc_pres_nomina as a '
        + ' left join dbo.p_pagos_variables_tiponom as b on a.id_presup=b.id_presup and a.num_conc=b.num_conc '
        + ' inner join conceptos as c on a.num_conc=c.num_conc '
        + ' inner join dbo.p_empresas as f on a.id_presup=f.id_presup '
        + ' INNER JOIN dbo.P_Empleados_Pres AS g ON f.empresa = g.empresa AND f.id_presup = g.id_presup '
        + ' inner join dbo.centros as d on f.empresa=d.empresa and d.centro<>'''' '
                     
    SET @whereClause = ' where a.id_presup= ' + LTRIM(RTRIM(STR(@presupId)))
        + ' and b.num_conc is null ' + ' and a.num_conc='
        + LTRIM(RTRIM(STR(@num_conc))) + ' and d.centro in(' + @centrosString
        + ')' 
                     
    SET @groupByClause = ' group by a.num_conc,a.concepto,d.centro,g.tiponom '
                     
    SET @orderByClause = ' order by g.tiponom,d.centro,a.num_conc '


    IF @debugId = 0 
        BEGIN
            INSERT  INTO p_pagos_variables_tiponom
                    ( num_conc ,
                      id_presup ,
                      concepto ,
                      centro ,
                      clase ,
                      tiponom
                    )
                    EXEC
                        ( @selectClause + @fromClause + @whereClause
                          + @groupByClause + @orderByClause
                        )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_PresupCatalogClosed')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_PresupCatalogClosed
GO

CREATE PROCEDURE dbo.Get_PresupCatalogClosed

    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
SELECT	a.id_presup,
		a.nombre,
		a.referencia,
		RTRIM(LTRIM(STR(b.ini_ejercicio))) + '-' + RTRIM(LTRIM(STR(b.fin_ejercicio))) AS Aos,
		RTRIM(LTRIM(STR(b.mes_inicio))) + '-' + RTRIM(LTRIM(STR(b.mes_final))) AS Meses
FROM dbo.P_catalogo_pres AS a
INNER JOIN dbo.P_parametro AS b ON a.id_presup = b.id_presup
WHERE a.estatus='C'

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Update_PresupCatalogReOpen')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Update_PresupCatalogReOpen
GO

CREATE PROCEDURE dbo.Update_PresupCatalogReOpen ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
    UPDATE  dbo.P_catalogo_pres
    SET     estatus = 'C'
    WHERE   estatus = 'A'
    
    UPDATE  dbo.P_catalogo_pres
    SET     estatus = 'A'
    WHERE   id_presup = @presupId

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_PresupTotalsConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_PresupTotalsConcepts
GO

CREATE PROCEDURE dbo.Get_PresupTotalsConcepts
    (
      @presupId udtInteger ,
      @cCampos udtStringSize4096 ,
      @tiponom udtInteger ,
      @conceptId udtInteger 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
    DECLARE @debugId udtInteger
    DECLARE @fromClause udtStringSize4096 ,
        @selectClause udtStringSize4096 ,
        @whereClause udtStringSize4096 ,
        @orderByClause udtStringSize4096 ,
        @groupByClause udtStringSize4096
        
    SET @debugId = 0
    
    SET @selectClause = ' SELECT  ''Total==>'' ,' + @cCampos
    SET @fromClause = ' FROM    p_pagos_variables_tiponom AS a '
    SET @whereClause = ' WHERE   a.id_presup = ' + LTRIM(RTRIM(STR(@presupId)))
        + ' AND a.tiponom = ' + LTRIM(RTRIM(STR(@tiponom)))
        + ' AND a.num_conc = ' + LTRIM(RTRIM(STR(@conceptId)))
   
    IF @debugId = 0 
        BEGIN
            EXEC
            ( @selectClause + @fromClause + @whereClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause )
        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Get_PresupClosePresup')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Get_PresupClosePresup
GO

CREATE PROCEDURE dbo.Get_PresupClosePresup
    
    --WITH ENCRYPTION
AS
	set nocount on
	
SELECT a.id_presup,
		a.nombre,
		dbo.PadL(b.mes_final,'',2,'0') + RTRIM(LTRIM(STR(b.ini_ejercicio))) AS Inicio,
		dbo.PadL(b.mes_final,'',2,'0') + RTRIM(LTRIM(STR(b.fin_ejercicio))) AS Final,
		'' AS Sel,
		'N' AS Sel2
FROM dbo.P_catalogo_pres AS a
INNER JOIN dbo.P_parametro AS b ON a.id_presup = b.id_presup
WHERE a.estatus<>'A'

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'Presup_EliminaPresupuesto'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Presup_EliminaPresupuesto
GO

CREATE PROCEDURE dbo.Presup_EliminaPresupuesto ( @presupId udtLong )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        DELETE  p_poldisk
        WHERE   id_presup = @presupId

        DELETE  p_polizas
        WHERE   id_presup = @presupId
	
        DELETE  p_nomina_tot
        WHERE   id_presup = @presupId

        DELETE  p_despensas
        WHERE   id_presup = @presupId

        DELETE  p_kardex_historico
        WHERE   id_presup = @presupId

        DELETE  p_kardex
        WHERE   id_presup = @presupId

        DELETE  p_percepciones
        WHERE   id_presup = @presupId

        DELETE  p_plantilla_propuestos
        WHERE   id_presup = @presupId

        DELETE  p_plantillas_puestosTemp
        WHERE   id_presup = @presupId

        DELETE  p_plantillas_centrosTemp
        WHERE   id_presup = @presupId

        DELETE  p_plantillasTemp
        WHERE   id_presup = @presupId

        DELETE  p_plantillas_puestos
        WHERE   id_presup = @presupId

        DELETE  p_plantillas_centros
        WHERE   id_presup = @presupId

        DELETE  p_plantillas
        WHERE   id_presup = @presupId

        DELETE  p_percepciones
        WHERE   id_presup = @presupId

        DELETE  p_pagos_Variables
        WHERE   id_presup = @presupId

        DELETE  p_avisos_imss
        WHERE   id_presup = @presupId

        DELETE  p_tablas_int
        WHERE   id_presup = @presupId

        DELETE  p_dias
        WHERE   id_presup = @presupId

        DELETE  p_salmin
        WHERE   id_presup = @presupId

        DELETE  p_conc_pres_nomina
        WHERE   id_presup = @presupId

        DELETE  p_conc_pres
        WHERE   id_presup = @presupId

        DELETE  p_dias
        WHERE   id_presup = @presupId

        DELETE  p_SalMin
        WHERE   id_presup = @presupId

        DELETE  p_tablas_int
        WHERE   id_presup = @presupId
        
        DELETE  p_kardex_resumen_detalle
        WHERE   id_presup = @presupId
        
        DELETE  p_kardex_resumen_emps
        WHERE   id_presup = @presupId
        
        DELETE  p_kardex_historico
        WHERE   id_presup = @presupId
        
        DELETE  p_kardex_resumen_forrecast
        WHERE   id_presup = @presupId
        
        DELETE  p_kardex_resumen_forrecast_Vacation
        WHERE   id_presup = @presupId
        
        DELETE  p_kardex_resumen_forrecast_class
        WHERE   id_presup = @presupId
        
        DELETE  p_empleados_pres
        WHERE   id_presup = @presupId

        DELETE  p_empresas
        WHERE   id_presup = @presupId

        DELETE  p_parametro
        WHERE   id_presup = @presupId

        DELETE  p_catalogo_pres
        WHERE   id_presup = @presupId
        
        SELECT  'Presupuesto eliminado con exit.'

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  'Error' AS Error1,
				ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Presup_UpdateEmpresasEncabezados')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Presup_UpdateEmpresasEncabezados
GO

CREATE PROCEDURE dbo.Presup_UpdateEmpresasEncabezados(@presupId udtInteger, @empresa udtInteger)
    
    --WITH ENCRYPTION
AS

SET NOCOUNT ON 

DECLARE @actual udtName
SET @actual = (SELECT ISNULL(encabezados,'N')
FROM dbo.P_empresas
WHERE id_presup=@presupId AND empresa = @empresa )

IF @actual = 'N'
BEGIN
	UPDATE dbo.P_empresas SET encabezados = 'S'
	WHERE id_presup=@presupId AND empresa=@empresa
	
	UPDATE dbo.P_empresas SET encabezados = 'N'
	WHERE id_presup=@presupId AND empresa<>@empresa
END
ELSE BEGIN
	UPDATE dbo.P_empresas SET encabezados = 'N'
	WHERE id_presup=@presupId AND empresa=@empresa
END 

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Presup_EncabezadosReportes')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Presup_EncabezadosReportes
GO

CREATE PROCEDURE dbo.Presup_EncabezadosReportes ( @presupId udtInteger )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
    DECLARE @actual udtInteger
    DECLARE @Empresas udtInteger

    SET @actual = ISNULL(( SELECT   empresa
                           FROM     dbo.P_empresas
                           WHERE    id_presup = @presupId
                                    AND encabezados = 'S'
                         ), 0)

    SET @Empresas = ISNULL((SELECT COUNT(DISTINCT(empresa))
    FROM dbo.P_empresas
    WHERE id_presup = @presupId),0)
    
    SET @actual = CASE WHEN @Empresas>1 AND @actual=0 THEN 0 
						WHEN @Empresas = 1 THEN (SELECT MAX(empresa) FROM dbo.P_empresas WHERE id_presup = @presupId) 
						WHEN @Empresas = 0 THEN 0
						WHEN @Empresas>1 AND @actual>0 THEN @actual
				END  
    DECLARE @encabezados AS TABLE(nombreEmpresa udtStringSize128,rfc udtname,registroPatronal udtName)
    IF @actual = 0 
        BEGIN
			INSERT INTO @encabezados
			        ( nombreEmpresa ,
			          rfc ,
			          registroPatronal
			        )
			VALUES  ( '' , -- nombreEmpresa - udtStringSize128
			          '', -- rfc - udtName
			          ''  -- registroPatronal - udtName
			        )        
        END
    ELSE 
        BEGIN
            INSERT INTO @encabezados
			        ( nombreEmpresa ,
			          rfc ,
			          registroPatronal
			        )
			SELECT nombre_empresa,
					rfc_empresa,
					registro_patronal
			FROM dbo.empresas
			WHERE empresa=@actual
        END 
	
	SELECT * FROM @encabezados
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Presup_PresupuestoActivo')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Presup_PresupuestoActivo
GO

CREATE PROCEDURE dbo.Presup_PresupuestoActivo
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    
    DECLARE @actual udtInteger

    SET @actual = ISNULL(( SELECT  id_presup 
                           FROM     dbo.P_catalogo_pres
                           WHERE    estatus = 'A'
                         ), 0)
	SELECT @actual AS presupId
GO


If OBJECT_ID('dbo.asp_Fun_pres_Provisiona') Is NOT NULL
  Drop Procedure dbo.asp_Fun_pres_Provisiona
Go

CREATE  Procedure dbo.asp_Fun_pres_Provisiona
@id_presup      Int,
@nTipoNom      Int,
@nSalMin       Numeric(10,2),
@nSalDF        Numeric(10,2),
@dFF           DateTime,
@nPrimaGuard   Numeric(7,4),
@nPrimaInfo    Numeric(7,4),
@cReformas2014 Char(1),
@nUma         Numeric(12,2)

As

Declare @cMinimos     Char(1)
Declare @nTope        Int
Declare @dPago        DateTime
Declare @cTipoNom     Char(3)
Declare @nPeriodo     Int
Declare @dInicio      DateTime
Declare @dCierre      DateTime
Declare @dFechaTab    DateTime
Declare @cPatronPaga  Char(1)
Declare @nAnticipados Integer


Set @cTipoNom     = Case When @nTipoNom = 1 Then 'SEM'
                         When @nTipoNom = 2 Then 'DEC'
                         When @nTipoNom = 3 Then 'CAT'
                         When @nTipoNom = 4 Then 'QNA'
                         When @nTipoNom = 5 Then 'MES' Else 'ESP' End

declare @mes int
declare @ayo int

Declare @DiasDelAyo int
set @DiasDelAyo = isnull((select sum(dias) from dbo.p_dias where id_presup = @id_presup And TipoNom = @nTipoNom and ejercicio=@Ayo),0)

--select @DiasDelAyo as DiasDelAyo


Select @dInicio   = Periodos.Inicio, @dCierre = Periodos.Cierre, @dPago = Periodos.Pago, @nPeriodo = Periodos.mes,@mes=Periodos.mes,@ayo=Periodos.ejercicio From P_dias as Periodos Where Estatus = 'A' And id_presup = @id_presup --Empresa = @nEmpresa And TipoNom = @nTipoNom
Set @nTope        = Case When Year(@dPago) < 2009 Then 15 + Case When Year(@dPago) >= 1997 Then Year(@dPago)-1997 Else 0 End Else 25 End
Set @cMinimos     = Case When (Select Count(Num_Conc) From Conceptos Where Num_Conc = 101 And Marca1 = 'S' And Empresa in(select empresa from dbo.P_empresas where id_presup = @id_presup) ) > 0 Then 'S' Else 'N' End
Set @cPatronPaga  = (Select max(Patron_Paga_Cuotas_Imss) From Empresas Where Empresa in(select empresa from dbo.P_empresas where id_presup = @id_presup))
Set @nAnticipados = 0--(Select Top 1 Dias_Anticipados From Periodos Where TipoNom = @nTipoNom And Estatus = 'A' And Empresa = @nEmpresa)


If @nTope > 25
  Set @nTope = 25

-- Para las tablas de integracion, si la fecha de pago es del siguiente mes...tomar las tablas del mes actual
If @dPago > @dFF
  Set @dFechaTab = @dFF
Else
  Set @dFechaTab = @dPago
--




-- La prima de Infonavit se quedo con 2% como era para las reformas del 2014, regresarla al 5%
If Year(@dPago) = 2014
  Update Primas_Imss
  Set Infonavit = 5
  Where Year(Periodo) = 2014
-- 15 Ene 2014


If OBJECT_ID('dbo.Tmp_p_Provisiona') Is NOT NULL
  Drop Table dbo.Tmp_p_Provisiona

If OBJECT_ID('dbo.Tmp_p_Provisiones') Is NOT NULL
  Drop Table dbo.Tmp_p_Provisiones

If OBJECT_ID('dbo.Tmp_p_Kardex') Is NOT NULL
  Drop Table dbo.Tmp_p_Kardex

Select Kardex.Codigo, 
       Kardex.Dias,
       Kardex.Dias_Imss As Dias_Imss,
       IsNull(Kardex.Aus,0) As Aus,
       IsNull(Kardex.Inc,0) As Inc,
       Kardex.Impor_Base,
       Kardex.Fch_Inicio,
       Kardex.Fch_Cierre,
        Case When Kardex.SalDiaInt > IsNull(@nUma,@nSalDF) * 25
            Then IsNull(@nUma,@nSalDF) * 25 
            Else Kardex.SalDiaInt 
       End As SalDiaEyM,

       Case When Kardex.SalDiaInt > IsNull(@nUma,@nSalDF) * 25 
            Then IsNull(@nUma,@nSalDF) * 25 
            Else Kardex.SalDiaInt 
       End As SalDiaIV,

       Kardex.SalDiaInt As SalDiaReal,
       Case When Year(@dPago) < 2009 Then Case When Year(Kardex.Fch_Inicio) > 1997 And Month(Kardex.Fch_Inicio) < 7 Then @nTope - 1 Else @nTope End Else 25 End As Tope,
       Convert(Numeric(10,2),@nSalMin * Tablas_Int.Factor) As SalMinInt,
       Case When IsNull(RetieneImss.Excepcion1,' ') = 'NOIMSS' Then 'S' Else @cPatronPaga End As SoloPatron,
       '' as TipoSal,--Empleados.TipoSal,
       IsNull(CV.Excepcion1,' ') As CV,
       IsNull(IV.Excepcion1,' ') As IV,
       Kardex.Descuento,
       Kardex.Tabulador,
       Totales.Dias As Dias_Totales,
       Totales.Aus As Aus_Totales,
       Totales.Inc As Inc_Totales,
       Kardex.Num_Conc,
       'S' as Cotiza_Imss,--Empleados.Cotiza_Imss,
       kardex.empresa As Empresa,
       Tablas_Int.Factor,
       
       Identity(Int,0,1) As Folio,  -- Este campo se agrego para controlar el numero de registro y poder topar los ausentismos a 7 por mes
       
      @nSalDF As SalarioMinimo,
       @nUma As Uma,
	  @id_presup as id_presup
Into dbo.Tmp_p_Provisiona    
From p_Kardex as kardex
--Inner Join Empresas On Empresas.Empresa = Kardex.Empresa
--Inner Join Empleados On Kardex.Codigo = Empleados.Codigo And Kardex.Empresa = Empleados.Empresa
Inner Join P_Empleados_Pres as Llaves On Kardex.Codigo = Llaves.Codigo And Kardex.Empresa = Llaves.Empresa and llaves.id_presup=kardex.id_presup
Left Join p_tablas_int as tablas_int On tablas_int.id_presup = @id_presup and Llaves.Clase = Tablas_Int.Clase And Llaves.Empresa = Tablas_Int.Empresa And Convert(Int,Tablas_Int.Ayos) = Case When Round(DateDiff(Day,llaves.FchAntigua,@dFf)/365,0)+1 <= 45 Then Convert(Int,Round(DateDiff(Day,llaves.FchAntigua,@dFf)/365,0)+1) Else 45 End And Tablas_Int.Mes_Operacion = Month(@dFechaTab) And Tablas_Int.Ayo_Operacion = Year(@dFechaTab)
Left Join Excepciones As CV On CV.Codigo = Kardex.Codigo And CV.Empresa = Kardex.Empresa And CV.Excepcion1 = 'CV'
Left Join Excepciones As IV On IV.Codigo = Kardex.Codigo And IV.Empresa = Kardex.Empresa And IV.Excepcion1 = 'IV'
Left Join Excepciones As RetieneImss On RetieneImss.Codigo = Kardex.Codigo And RetieneImss.Empresa = Kardex.Empresa And RetieneImss.Excepcion1 = 'NOIMSS'
Left Join (Select Kardex.Codigo, Sum(Kardex.Dias) As Dias, Sum(Kardex.Aus*Kardex.Descuento/100) As Aus, Sum(Kardex.Inc) As Inc 
           From p_Kardex as kardex Where Kardex.Nomina = @cTipoNom and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo And Kardex.Num_Conc In (@nTipoNom,7,30,1107 ) And Kardex.Tipo_Mov <> 'FIN' And Kardex.id_presup = @id_presup Group By Kardex.Codigo) As Totales On Kardex.Codigo = Totales.Codigo
Inner Join Horarios_Catalogo On Horarios_Catalogo.Horario = Llaves.Horario And Horarios_Catalogo.Empresa = Llaves.Empresa
Where	kardex.id_presup = @id_presup and 
		Kardex.Nomina = @cTipoNom And
      Kardex.Num_Conc In (@nTipoNom,7,30,1107) And
      (Kardex.Dias > 0 Or (Horarios_Catalogo.Semana_Red = 'S' And Kardex.Dias_Imss > 0)) And
      Kardex.Tipo_Mov <> 'FIN' 
	  and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo

-- Rutina para topar los ausentismos a 7 por mes (para IMSS e INFONAVIT)
--Exec dbo.asp_Fun_R_Topa7Aus @nEmpresa, @nTipoNom, @dInicio, @dCierre
-- 7 de Agosto del 2012


If (Select max(Uso) From Conceptos Where Num_Conc = 107 And Empresa in(select empresa from dbo.P_empresas where id_presup = @id_presup) ) = 'S'
Begin
  UpDate Tmp_p_Provisiona
  Set Aus = Tmp_p_Provisiona.Aus + Case When IsNull(Deducciones.Justificar,'') In ('F','P','S','T') And Concepto108.Imss = 'S' Then IsNull(Deducciones.Dias,0) Else 0 End,
      Inc = Tmp_p_Provisiona.Inc + Case When IsNull(Deducciones.Justificar,'') In ('1','2','3','4') Then IsNull(Deducciones.Dias,0) Else 0 End --,
      --Dias_Imss = Tmp_p_Provisiona.Dias_Imss - Case When IsNull(Kardex.Dias,0) > Tmp_p_Provisiona.Dias Then Tmp_p_Provisiona.Dias Else IsNull(Kardex.Dias,0) End
  From Tmp_p_Provisiona
  Left Join Deducciones On Deducciones.Codigo = Tmp_p_Provisiona.Codigo And Deducciones.Num_Conc = 107 And Deducciones.FchInicio >= Tmp_p_Provisiona.Fch_Inicio And Deducciones.FchInicio <= Tmp_p_Provisiona.Fch_Cierre And Deducciones.Empresa = Tmp_p_Provisiona.Empresa And Deducciones.Periodo = @nPeriodo And Deducciones.Ayo_Operacion = Year(@dPago) And Deducciones.TipoNom = @nTipoNom
  Inner Join Conceptos As Concepto108 On Concepto108.Num_Conc = 108 And Concepto108.Empresa = Tmp_p_Provisiona.Empresa
  where Tmp_p_Provisiona.id_presup = @id_presup

  UpDate Tmp_p_Provisiona
  Set Aus = Tmp_p_Provisiona.Aus + Case When Concepto108.Imss = 'S' Then TotAus.Aus Else 0 End,
      Inc = Tmp_p_Provisiona.Inc + TotAus.Inc
  From Tmp_p_Provisiona
  Inner Join Conceptos As Concepto108 On Concepto108.Num_Conc = 108 And Concepto108.Empresa = Tmp_p_Provisiona.Empresa
  Inner Join (Select Kardex.empresa,Kardex.Codigo,
                     IsNull( Sum( Case When IsNull(Kardex.Justificar,'') In ('F','P','S','T')
                                       Then Dias
                                       Else 0
                                  End ),0) As Aus,
                     IsNull( Sum( Case When IsNull(Kardex.Justificar,'') In ('1','2','3','4')
                                       Then Dias
                                       Else 0 
                                  End ),0) As Inc
              From p_kardex as kardex
              Where Kardex.Num_Conc = 107 And
                    Kardex.Calculo = 'A' And
                    Kardex.Fch_Inicio >= @dInicio - @nAnticipados And
                    Kardex.Fch_Inicio <= @dInicio - 1 And
                    Kardex.Nomina = @cTipoNom And
                    Kardex.id_presup = @id_presup
					and kardex.mes_operacion =@mes and kardex.ayo_operacion=@ayo
              Group By Kardex.empresa,Kardex.Codigo) As TotAus On TotAus.empresa = Tmp_p_Provisiona.empresa and TotAus.Codigo = Tmp_p_Provisiona.Codigo
	where Tmp_p_Provisiona.id_presup = @id_presup

End



UpDate Tmp_p_Provisiona
Set SoloPatron = Case When (Case When @cMinimos = 'S' And Tmp_p_Provisiona.TipoSal <> 01 
                                           Then Tmp_p_Provisiona.Impor_Base 
                                           Else Tmp_p_Provisiona.SalDiaEyM 
                                      End)
                                     <=
                                     (Case When @cMinimos = 'S' And Tmp_p_Provisiona.TipoSal <> 01 
                                           Then Tmp_p_Provisiona.SalarioMinimo 
                                           Else Tmp_p_Provisiona.SalMinInt 
                                      End)
                                Then 'S'
                                Else SoloPatron --'N'
                           End
From Tmp_p_Provisiona
where Tmp_p_Provisiona.id_presup = @id_presup

--Inner Join Empleados On Empleados.Codigo = Tmp_p_Provisiona.Codigo And Empleados.Empresa = Tmp_p_Provisiona.Empresa
--Inner Join Empresas On Empresas.Empresa = @nEmpresa


-- Concepto 201 EyM Art. 25
Select Tmp_p_Provisiona.Codigo,
       201 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc)*Tmp_p_Provisiona.SalDiaEyM*(Case When Tmp_p_Provisiona.SoloPatron = 'S' Then Primas_Imss.EyMArt25 Else Primas_Imss.EyMPat25 End)/100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
Into dbo.Tmp_p_Provisiones
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.id_presup = @id_presup
	  and Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc > 0 And
      IsNull(Tmp_p_Provisiona.Cv,' ') <> 'CV' And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'


-- Concepto 202 EyM Art. 106-I
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       202 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),IsNull(@nUma,Tmp_p_Provisiona.SalarioMinimo) * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc) * Primas_Imss.EyMArt106I / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
Left Join primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)
Where Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
	  and Tmp_p_Provisiona.id_presup = @id_presup
)


-- Concepto 203 EyM Art. 106-II
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       203 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),(Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc)*(Tmp_p_Provisiona.SalDiaEyM-(IsNull(@nUma,Tmp_p_Provisiona.SalarioMinimo)*3))*(Case When Tmp_p_Provisiona.SoloPatron = 'S' Then Primas_Imss.EyMArt1062 Else Primas_Imss.EyMPat1062 End)/100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)
where Tmp_p_Provisiona.id_presup = @id_presup and
      Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc > 0 And
      Tmp_p_Provisiona.SalDiaEyM > IsNull(@nUma,Tmp_p_Provisiona.SalarioMinimo)*3 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
)


-- Concepto 204 EyM Art. 107
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       204 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),Tmp_p_Provisiona.SalDiaEyM * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc) * (Case When Tmp_p_Provisiona.SoloPatron = 'S' Then Primas_Imss.EyMArt107 Else Primas_Imss.EyMPat107 End) / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.id_presup = @id_presup 
	  and Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
)


-- Concepto 205 IV Art. 147
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       205 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),Tmp_p_Provisiona.SalDiaIV * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus) * (Case When Tmp_p_Provisiona.SoloPatron = 'S' Then Primas_Imss.IVArt147 Else Primas_Imss.IVPat147 End) / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.id_presup = @id_presup  and
	  Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus > 0 And
      IsNull(Tmp_p_Provisiona.IV,' ') <> 'IV' And
      IsNull(Tmp_p_Provisiona.CV,' ') <> 'CV' And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
)


-- Concepto 206 CV Art. 168-I
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       206 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),Tmp_p_Provisiona.SalDiaEyM * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Aus) * Primas_Imss.Retiro / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Aus > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
	  and Tmp_p_Provisiona.id_presup = @id_presup
)

--select * from Tmp_p_Provisiona

-- Concepto 207 CV Art. 168-II
--select * from Tmp_p_Provisiona
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)

Select Tmp_p_Provisiona.Codigo,
       207 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       --99 as importe,
	   Convert(Numeric(10,2),	
								Tmp_p_Provisiona.SalDiaIV * 
										(Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus) * 
										(Case When Tmp_p_Provisiona.SoloPatron = 'S' Then cv.CVArt168II Else cv.CVPat168II End) 
										/ 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
	   --, cv.rango
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)
--inner join dbo.P_Empleados_Pres as em on em.empresa=Tmp_p_Provisiona.empresa and em.Codigo=Tmp_p_Provisiona.Codigo and em.id_presup=Tmp_p_Provisiona.id_presup
OUTER APPLY (SELECT	rango--CASE WHEN Tmp_p_Provisiona.mov = 'B' THEN 0 ELSE rango END rango
			        , cvArt168II
                    , cvPat168II
                    , cvTra168II
			FROM dbo.NOM_FUN_ObtienePrimaCVPatron2023(Tmp_p_Provisiona.empresa, Tmp_p_Provisiona.fch_inicio, YEAR(Tmp_p_Provisiona.fch_inicio), Tmp_p_Provisiona.SalDiaEyM,Primas_Imss.cvArt168II, Primas_Imss.cvPat168II, Primas_Imss.cvTra168II)
			)as cv
	--WHERE aItc.mov <> 'B'
		--      AND (aItc.diastr - aItc.ausen - aItc.incap) > 0
						   ---) AS tblCV

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
	  and Tmp_p_Provisiona.id_presup = @id_presup
	  --and Tmp_p_Provisiona.codigo=9975

-- Concepto 208 RT Art. 71
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       208 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),Tmp_p_Provisiona.SalDiaEyM * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus) * Primas_RT.PrimaRT / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
outer apply (select	case when prima_modificada < 0 then prima_rt
					 when @ayo = ayo and @mes<mes and prima_modificada>0 then prima_rt
					 when @ayo = ayo and @mes>=mes and prima_modificada>0 then prima_modificada
					 when @ayo > ayo and prima_modificada>0 then prima_modificada
				else 0
				end as PrimaRT,
				id_presup
		   from p_Primas_RT where id_presup = @id_presup and empresa=Tmp_p_Provisiona.empresa) as Primas_RT
Where Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
	  and Tmp_p_Provisiona.id_presup = @id_presup
	  	  
)

-- Concepto 209 Guarderias Art. 211
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       209 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),Tmp_p_Provisiona.SalDiaEyM * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus) * IsNull(Primas_Imss.Art211,@nPrimaGuard) / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona

Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Inc - Tmp_p_Provisiona.Aus > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
)


-- Concepto 210 Infonavit
Insert Into Tmp_p_Provisiones (Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa)
(
Select Tmp_p_Provisiona.Codigo,
       210 As Num_Conc,
       Tmp_p_Provisiona.Dias,
       Tmp_p_Provisiona.Dias_Imss,
       Tmp_p_Provisiona.Aus,
       Tmp_p_Provisiona.Inc,
       Tmp_p_Provisiona.Impor_Base,
       Tmp_p_Provisiona.SalDiaEyM As SalDiaInt,
       Convert(Numeric(10,2),Tmp_p_Provisiona.SalDiaIV * (Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Aus) * IsNull(Primas_Imss.Infonavit,@nPrimaInfo) / 100) As Importe,
       Tmp_p_Provisiona.Fch_Inicio,
       Tmp_p_Provisiona.Fch_Cierre,
       0 As Folio,
       Tmp_p_Provisiona.Empresa As Empresa
From Tmp_p_Provisiona
Left Join Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dFechaTab)

--Left Join dbo.Fun_R_LeePrimasImss(Year(@dPago),@cReformas2014) As Primas_Imss On Year(Primas_Imss.Periodo) = Year(@dPago)

Where Tmp_p_Provisiona.Dias_Imss - Tmp_p_Provisiona.Aus > 0 And
      Tmp_p_Provisiona.Cotiza_Imss = 'S'
)


--La rutina que genera los Folios, requiere la tabla ordenada por codigo
Select Codigo,Num_Conc,Dias,Dias_Imss,Aus,Inc,Impor_Base,SalDiaInt,Importe,Fch_Inicio,Fch_Cierre,Folio,Empresa
Into dbo.Tmp_p_Kardex
From Tmp_p_Provisiones
Order by Codigo,Num_Conc


-- 5 de mayo
-- Crear indice para que ordene por codigo y num_conc
--CREATE  INDEX [IX_Tmp_p_Kardex] ON [dbo].[Tmp_p_Kardex]([Codigo], [num_conc]) ON [PRIMARY]


-- Determinar los folios para la insercion en el kardex
--Exec asp_genera_folio @nEmpresa,0,'Tmp_p_Kardex','Folio',0,0

Insert Into p_Kardex (Codigo, Empresa, Nomina, Centro, Num_Conc, Clase, Folio, Renglon, Fch_Inicio, Fch_Cierre, Fch_Pago, Dias, Inc, Aus,
                    DiasTr, Dias_Imss, TPago_Desc, Concepto, VariaImss, Variable, Imss, Ispt, Ptu, Despensa, Mca_Agui, FdoAhorro,
                    Calculo, Impor_Base, SalDiaInt, Tabulador, Unidades, Horas, Tipo_Mov, Secuencia, Importe, IGravable, IExento,
                    Credito, Descuento, Saldo, Referencia, Siempre, Justificar, Septimo, PrevSocial, Varia1, Varia2, Varia3, Varia4,
                    Variable1, Variable2, Variable3, Variable4, Masivo, Formula, Ispt_NG, Imss_NI, Marca, Serial, Informativo,mes_operacion,ayo_operacion,id_presup)

Select Tmp_p_Kardex.Codigo,
       Tmp_p_Kardex.Empresa As Empresa,
       @cTipoNom As Nomina,
       ' ' As Centro,
       Tmp_p_Kardex.Num_Conc,
       ' ' As Clase,
       Tmp_p_Kardex.Folio,
       0 As Renglon,
       Tmp_p_Kardex.Fch_Inicio,
       Tmp_p_Kardex.Fch_Cierre,
       @dPago As Fch_Pago,
       Tmp_p_Kardex.Dias As Dias,
       Tmp_p_Kardex.Inc,
       Tmp_p_Kardex.Aus,
       Tmp_p_Kardex.Dias_Imss As DiasTr,
       Tmp_p_Kardex.Dias_Imss,
       'I' As TPago_Desc,
       Conceptos.Concepto,
       0 As VariaImss,
       0 As Variable,
       Conceptos.Imss,
       Conceptos.Ispt,
       Conceptos.Ptu,
       Conceptos.Despensa,
       Conceptos.Mca_Agui,
       Conceptos.FdoAhorro,
       'A' As Calculo,
       Tmp_p_Kardex.Impor_Base,
       Tmp_p_Kardex.SalDiaInt,
       0 As Tabulador,
       0 As Unidades,
       0 As Horas,
       'PRO' As Tipo_Mov,
       0 As Secuencia,
       Tmp_p_Kardex.Importe,
       0 As IGravable,
       0 As IExento,
       0 As Credito,
       0 As Descuento,
       0 As Saldo,
       ' ' As Referencia,
       'N' As Siempre,
       ' ' As Justificar,
       ' ' As Septimo,
       'F' As PrevSocial,
       0 As Varia1,
       0 As Varia2,
       0 As Varia3,
       0 As Varia4,
       ' ' As Variable1,
       ' ' As Variable2,
       ' ' As Variable3,
       ' ' As Variable4,
       'F' As Masivo,
       ' ' As Formula,
       ' ' As Ispt_NG,
       ' ' As Imss_NI,
       ' ' As Marca,
       0 As Serial,
       'F' As Informativo,
	   @mes,
	   @ayo,
	   @id_presup
From Tmp_p_Kardex
Left Join Conceptos On Tmp_p_Kardex.Num_Conc = Conceptos.Num_Conc And Conceptos.Empresa = Tmp_p_Kardex.Empresa And Conceptos.Clase = ' '
Where Tmp_p_Kardex.Importe > 0 And
      Conceptos.Uso = 'S'


Drop Table dbo.Tmp_p_Provisiones
Drop Table dbo.Tmp_p_Kardex


GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresTiposNom')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresTiposNom
GO

CREATE PROCEDURE dbo.GetPresTiposNom ( @presupId udtInteger, @empresa int )
    --WITH ENCRYPTION
AS 
    SELECT  dbo.padl(a.tiponom,'',2,'0') + ' ' + rtrim(b.nomina) as Nomina
    FROM    dbo.p_empleados_pres as a
	inner join nominas as b on b.empresa=a.empresa and b.tiponom=a.tiponom
	where a.id_presup=@presupId and a.empresa=@empresa
	group by a.tiponom, b.nomina
	order by a.tiponom

GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresTotaConcepts')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresTotaConcepts
GO

CREATE PROCEDURE dbo.GetPresTotaConcepts
    (
      @presupId udtInteger ,
      @payrollType udtInteger ,
      @history udtName,
	  @manoObra udtName = ''
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    DECLARE @debug udtInteger
    
    SET @debug = 0

    DECLARE @fromClause udtStringSize4096 ,
        @selectClause udtStringSize4096 ,
        @whereClause udtStringSize4096
    SET @selectClause = 'SELECT	b.nombre AS nombre_presup, '
        + ' case when a.mes_operacion = 1 then ''01 ENERO'' '
        + ' when a.mes_operacion = 2 then ''02 FEBRERO'' '
        + ' when a.mes_operacion = 3 then ''03 MARZO'' '
        + ' when a.mes_operacion = 4 then ''04 ABRIL'' '
        + ' when a.mes_operacion = 5 then ''05 MAYO'' '
        + ' when a.mes_operacion = 6 then ''06 JUNIO'' '
        + ' when a.mes_operacion = 7 then ''07 JULIO'' '
        + ' when a.mes_operacion = 8 then ''08 AGOSTO'' '
        + ' when a.mes_operacion = 9 then ''09 SEPTIEMBRE'' '
        + ' when a.mes_operacion = 10 then ''10 OCTUBRE'' '
        + ' when a.mes_operacion = 11 then ''11 NOVIEMBRE'' '
        + ' when a.mes_operacion = 12 then ''12 DICIEMBRE'' ELSE '' '' '
        + ' END  as mes, ' + ' a.ayo_operacion AS ao, '
        + ' REPLICATE(''0'', 4 - len(a.num_conc)) + convert(varchar(4),a.num_conc) +'' '' + rtrim(ltrim(a.concepto)) as concepto, '
        + ' a.importe, '
        + ' REPLICATE(''0'', 4 - len(c.concepto)) + convert(varchar(4),c.concepto) +'' '' + rtrim(ltrim(c.nombre)) as nombre_conceptos, '
        + ' REPLICATE(''0'', 4 - len(a.ocupacion)) + convert(varchar(4),a.ocupacion) +'' '' + rtrim(ltrim(a.actividad)) as actividad, '
        + ' rtrim(ltrim(a.centro)) +  '' '' + rtrim(ltrim(a.departamento)) as departamento, '
        + ' case when pr.mes_inicio = 1 then ''ENERO'' '
        + ' when pr.mes_inicio = 2 then ''FEBRERO'' '
        + ' when pr.mes_inicio = 3 then ''MARZO'' '
        + ' when pr.mes_inicio = 4 then ''ABRIL'' '
        + ' when pr.mes_inicio = 5 then ''MAYO'' '
        + ' when pr.mes_inicio = 6 then ''JUNIO'' '
        + ' when pr.mes_inicio = 7 then ''JULIO'' '
        + ' when pr.mes_inicio = 8 then ''AGOSTO'' '
        + ' when pr.mes_inicio = 9 then ''SEPTIEMBRE'' '
        + ' when pr.mes_inicio = 10 then ''OCTUBRE'' '
        + ' when pr.mes_inicio = 11 then ''NOVIEMBRE'' '
        + ' when pr.mes_inicio = 12 then ''DICIEMBRE'' ELSE '' '' END + rtrim(ltrim(str(pr.ini_ejercicio))) + ''-'' +   '
        + ' case when pr.mes_final = 1 then ''ENERO''   '
        + ' when pr.mes_final = 2 then ''FEBRERO'' '
        + ' when pr.mes_final = 3 then ''MARZO'' '
        + ' when pr.mes_final = 4 then ''ABRIL'' '
        + ' when pr.mes_final = 5 then ''MAYO'' '
        + ' when pr.mes_final = 6 then ''JUNIO'' '
        + ' when pr.mes_final = 7 then ''JULIO'' '
        + ' when pr.mes_final = 8 then ''AGOSTO'' '
        + ' when pr.mes_final = 9 then ''SEPTIEMBRE'' '
        + ' when pr.mes_final = 10 then ''OCTUBRE'' '
        + ' when pr.mes_final = 11 then ''NOVIEMBRE'' '
        + ' when pr.mes_final = 12 then ''DICIEMBRE'' ELSE '' '' END + rtrim(ltrim(str(pr.fin_ejercicio))) as title, '
        + ' 1 as counter,' 
        + ' a.clase,'
        + ' a.nombreClase '
    SET @fromClause = 'FROM dbo.p_kardex_resumen_detalle AS a '
        + 'INNER JOIN dbo.P_conc_pres AS c ON a.id_presup = c.id_presup AND a.grupo_concepto = c.concepto '
        + 'INNER JOIN P_catalogo_pres AS b ON a.id_presup = b.id_presup '
        + 'inner join dbo.p_parametro as pr on pr.id_presup=b.id_presup  '		
	
	
    SET @whereClause = 'where a.id_presup=' + RTRIM(LTRIM(STR(@presupId)))
        + CASE WHEN @payrollType > 0
               THEN ' and a.tiponom=' + RTRIM(LTRIM(STR(@payrollType)))
               ELSE ' and a.tiponom in(1,2,3,4,5,6) '
          END 

		+ case when @manoObra = '-' then '' else ' and isnull(a.ManoObra,'''')='''+@manoObra+'''' end
	
    IF @debug = 0 
        BEGIN 
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause )
        END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresTotaConceptsEmployee')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresTotaConceptsEmployee
GO

CREATE PROCEDURE dbo.GetPresTotaConceptsEmployee
    (
      @presupId udtInteger ,
      @payrollType udtInteger ,
      @history udtName,
	  @ManoObra udtName
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    DECLARE @debug udtInteger
    
    SET @debug = 0

    DECLARE @fromClause udtStringSize4096 ,
        @selectClause udtStringSize4096 ,
        @whereClause udtStringSize4096
    SET @selectClause = 'SELECT	b.nombre AS nombre_presup, '
        + ' case when a.mes_operacion = 1 then ''01 ENERO'' '
        + ' when a.mes_operacion = 2 then ''02 FEBRERO'' '
        + ' when a.mes_operacion = 3 then ''03 MARZO'' '
        + ' when a.mes_operacion = 4 then ''04 ABRIL'' '
        + ' when a.mes_operacion = 5 then ''05 MAYO'' '
        + ' when a.mes_operacion = 6 then ''06 JUNIO'' '
        + ' when a.mes_operacion = 7 then ''07 JULIO'' '
        + ' when a.mes_operacion = 8 then ''08 AGOSTO'' '
        + ' when a.mes_operacion = 9 then ''09 SEPTIEMBRE'' '
        + ' when a.mes_operacion = 10 then ''10 OCTUBRE'' '
        + ' when a.mes_operacion = 11 then ''11 NOVIEMBRE'' '
        + ' when a.mes_operacion = 12 then ''12 DICIEMBRE'' ELSE '' '' '
        + ' END  as mes, ' + ' a.ayo_operacion AS ao, '
        + ' REPLICATE(''0'', 4 - len(a.num_conc)) + convert(varchar(4),a.num_conc) +'' '' + rtrim(ltrim(a.concepto)) as concepto, '
        + ' a.importe, '
        + ' REPLICATE(''0'', 4 - len(c.concepto)) + convert(varchar(4),c.concepto) +'' '' + rtrim(ltrim(c.nombre)) as nombre_conceptos, '
        + ' REPLICATE(''0'', 4 - len(a.ocupacion)) + convert(varchar(4),a.ocupacion) +'' '' + rtrim(ltrim(a.actividad)) as actividad, '
        + ' rtrim(ltrim(a.centro)) +  '' '' + rtrim(ltrim(a.departamento)) as departamento, '
        + ' case when pr.mes_inicio = 1 then ''ENERO'' '
        + ' when pr.mes_inicio = 2 then ''FEBRERO'' '
        + ' when pr.mes_inicio = 3 then ''MARZO'' '
        + ' when pr.mes_inicio = 4 then ''ABRIL'' '
        + ' when pr.mes_inicio = 5 then ''MAYO'' '
        + ' when pr.mes_inicio = 6 then ''JUNIO'' '
        + ' when pr.mes_inicio = 7 then ''JULIO'' '
        + ' when pr.mes_inicio = 8 then ''AGOSTO'' '
        + ' when pr.mes_inicio = 9 then ''SEPTIEMBRE'' '
        + ' when pr.mes_inicio = 10 then ''OCTUBRE'' '
        + ' when pr.mes_inicio = 11 then ''NOVIEMBRE'' '
        + ' when pr.mes_inicio = 12 then ''DICIEMBRE'' ELSE '' '' END + rtrim(ltrim(str(pr.ini_ejercicio))) + ''-'' +   '
        + ' case when pr.mes_final = 1 then ''ENERO''   '
        + ' when pr.mes_final = 2 then ''FEBRERO'' '
        + ' when pr.mes_final = 3 then ''MARZO'' '
        + ' when pr.mes_final = 4 then ''ABRIL'' '
        + ' when pr.mes_final = 5 then ''MAYO'' '
        + ' when pr.mes_final = 6 then ''JUNIO'' '
        + ' when pr.mes_final = 7 then ''JULIO'' '
        + ' when pr.mes_final = 8 then ''AGOSTO'' '
        + ' when pr.mes_final = 9 then ''SEPTIEMBRE'' '
        + ' when pr.mes_final = 10 then ''OCTUBRE'' '
        + ' when pr.mes_final = 11 then ''NOVIEMBRE'' '
        + ' when pr.mes_final = 12 then ''DICIEMBRE'' ELSE '' '' END + rtrim(ltrim(str(pr.fin_ejercicio))) as title, '
        + ' 1 as counter,' 
		+ ' e.codigo, '
		+ ' e.nombre '
    SET @fromClause = 'FROM dbo.p_kardex_empleados AS a '
        + 'INNER JOIN dbo.P_empleados_pres AS e ON e.id_presup = a.id_presup AND e.empresa = a.empresa AND e.codigo = a.codigo '
		+ 'INNER JOIN dbo.P_conc_pres AS c ON a.id_presup = c.id_presup AND a.grupo_concepto = c.concepto '
        + 'INNER JOIN P_catalogo_pres AS b ON a.id_presup = b.id_presup '
        + 'inner join dbo.p_parametro as pr on pr.id_presup=b.id_presup  '		
	
	
    SET @whereClause = 'where a.id_presup=' + RTRIM(LTRIM(STR(@presupId)))
		+ + case when @manoObra = '-' then '' else ' and isnull(e.ManoObra,'''')='''+@manoObra+'''' end
        + CASE WHEN @payrollType > 0
               THEN ' and a.tiponom=' + RTRIM(LTRIM(STR(@payrollType)))
               ELSE ' and a.tiponom in(1,2,3,4,5,6) '
          END 
	
    IF @debug = 0 
        BEGIN 
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause )
        END

GO


update conceptos set Arreglo1='' where Arreglo1='{{0,0,0,0}}'
update conceptos set Arreglo2='' where Arreglo2='{{0,0,0,0}}'


GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.GetPresImportConcept')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.GetPresImportConcept
GO

CREATE PROCEDURE dbo.GetPresImportConcept
(
    @idPresup bigint,
	@num_conc int,
	@centro varchar(30),
	@ejercicio int,
	@tiponom int,
	@mes varchar(15),
	@importe decimal(12,2)
)
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON


	Declare @concepto int
	select @concepto=a.concepto
	from dbo.P_conc_pres_nomina as a
	inner join dbo.P_conc_pres as b on b.id_presup=a.id_presup and b.concepto=a.concepto
	where a.id_presup=@idPresup and a.num_conc=@num_conc

	--select @concepto
	if isnull(@concepto,0)>0
	begin
		Declare @NumeroMes varchar(1)
		set @NumeroMes = case when @ejercicio=(select top 1 ini_ejercicio from dbo.p_parametro where id_presup=@idPresup) then '1' else '2' end
		--select @NumeroMes=iif(@ejercicio=ini_ejercicio,'1','2') from dbo.p_parametro where id_presup=@idPresup
		--select @NumeroMes
		Declare @sql varchar(max)
	
		if isnull((select top 1 1 from dbo.p_pagos_variables_tiponom where id_presup=@idPresup and num_conc=@num_conc and centro=@centro),0)>0
		begin
			set @sql = 'update dbo.p_pagos_variables_tiponom set '+ @mes+@NumeroMes+ '='+convert(varchar,@importe)+' where id_presup='+convert(varchar,@idPresup)+ ' and num_conc='+convert(varchar,@num_conc)+' and centro='''+@centro+''' and tiponom=' + convert(varchar,@tiponom)
			exec(@sql)
		end
		else begin
			set @sql =	'insert into dbo.p_pagos_variables_tiponom (id_presup,num_conc,concepto,centro,clase,tiponom,'+ @mes+@NumeroMes+ ')values(' +
						convert(varchar,@idPresup) + ','+ convert(varchar,@num_conc) + ',' + convert(varchar,@concepto) + ','''+@centro+''','''','+convert(varchar,@tiponom)+','+convert(varchar,@importe)+')'
						--+convert(varchar,@importe)+' where id_presup='++ ' and num_conc='+convert(varchar,@num_conc)+' and centro='''+@centro+''''
			exec(@sql)
		end
		--select * from dbo.p_pagos_variables_tiponom where id_presup=@idPresup
	end

GO


